
/* action.c for VPC++ to reduce the size of y++.tab.c         */
/* Created by Jenq-Kuen Lee March 16, 1990                    */
     	
#include "vparse.h"
#include "tag"
#include "vpc.h"
#include "db.h"
#include "vextern.h"

PTR_BLOB follow_blob();
PTR_TYPE follow_type() ;
PTR_LLND follow_record_id(),follow_llnd();
PTR_BFND chain_up();
PTR_LLND find_suit_declarator();	
PTR_SYMB find_type_symbol_global();
PTR_SYMB match_name(),find_type_symbol(),install_entry_2();
PTR_TYPE fetch_type_for_constructor();
PTR_HASH find_entry_from_type();
extern  PTR_SYMB count_first();
extern  int      count_fields_num(),count_record_size();
PTR_TYPE follow_type_1();
PTR_SYMB check_extern_second_part();
PTR_BFND not_until_classnode();
PTR_SYMB install_duplicate_entry();
PTR_SYMB find_parameter_name();
PTR_SYMB find_object_symbol();
PTR_BFND find_class_bfnd();
PTR_SYMB check_field_decl_3();
PTR_TYPE adjust_array_type();
PTR_HASH look_up_type();
PTR_SYMB find_proc_name();
PTR_LLND lazy_install(),func_declarator_appear();
PTR_LLND chain_type_declarator();
PTR_SYMB fts_by_inherited_class();
PTR_HASH look_up_expanded_string();
extern     struct data_type second_part ;
PTR_TYPE   combine_2();
PTR_TYPE   get_type();
PTR_SYMB   find_parameter_name();
/*****************************************************************/
/*                                                               */
/*  Grammar :typed_declspecs "(" parmlist ')'                    */
/*                                                               */
/* flag ==0: for CONSTRUCTOR                                     */
/* flag ==1: for DESTRUCTOR                                      */
/*****************************************************************/
component_constructor_action(type,parmlist,flag,body_appear)
PTR_TYPE type;
PTR_LLND parmlist;
{
   PTR_LLND ll,lptr2;
   PTR_SYMB symb;
   PTR_TYPE ptr1;
   PTR_SYMB dummy_symb;
   PTR_TYPE new_type;
   PTR_HASH entry;
   PTR_BLOB blob;

   if ((type->variant!= T_DESCRIPT)&&(type->variant!=T_DERIVED_TYPE))
     err("illegal syntax");
   entry = find_entry_from_type(type);
   if (flag==DESTRUCTOR)entry = look_up_expanded_string(entry);
   new_type = fetch_type_for_constructor(type);
   main_type_flag = TYPE_TWO;
   ll = lazy_install(entry,VARIABLE_NAME,NO);
   symb = find_proc_name();
   if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
       (ll->variant == FUNCTION_REF))                 
     transform_symb_node(symb);
   ll = func_declarator_appear(ll,parmlist,symb) ;
   /* notype_initdecls returns expr_list ll_node */
   lptr2 = chain_type_declarator(new_type,OFF,ll,&dummy_symb,body_appear);
   if (body_appear){
     fill_type_for_param(symb);
     blob = follow_blob(pred_bfnd);
     blob->ref->entry.template.symbol= symb ;
   }

 }



/*****************************************************************/
/*                                                               */
/*  Grammar :primary:                                            */
/*                                                               */
/*****************************************************************/

/* Primary: IDENTIFIER:                                          */
PTR_LLND
primary_identifier_action(entry)
PTR_HASH entry;
{
  PTR_SYMB symbptr;
  PTR_LLND return_llnd;

	  symbptr = find_type_symbol(entry,VARIABLE_NAME,area());
	  if (! symbptr)symbptr=fts_by_inherited_class(entry,VARIABLE_NAME,area());
	  if (! symbptr){  /* default function expected */
	    exception_flag = ON ;
	    cur_id_entry = entry ;
	    return_llnd= LLNULL;
	  }
	  else {
	    switch (symbptr->variant) {
	    case MEMBER_FUNC :
	    case FUNCTION_NAME:
	      /* primary_flag = EXCEPTION_ON ;  */
	      /* above one incorrect while nested */
	      return_llnd = make_llnd(fi,FUNCTION_REF,LLNULL,LLNULL,symbptr);
	      break;
	    case FIELD_NAME :
	    case VARIABLE_NAME:
	      return_llnd = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
	      break;
	    }
	    return_llnd->type = adjust_array_type(symbptr);
	  }
  return(return_llnd);
}


/*****************************************************************/
/*                                                               */
/*  Grammar :typed_declspecs                                     */
/*                                                               */
/*  flag == 0 : normal case                                      */
/*          1 : need to eliminate unnecessary links              */
/*****************************************************************/
PTR_TYPE
typed_declspecs_without_declmods(main_type1,type2,flag)
PTR_TYPE main_type1,type2;
{ PTR_TYPE type_ptr1,type_ptr2 ;
  PTR_BFND bf2;
  PTR_SYMB gsym;
  PTR_BLOB blob2;
  PTR_TYPE return_type;


  switch (main_type_flag) {
  case TYPE_ONE :
    type_ptr1=main_type1 ;
    return_type = type_ptr1 ;
    break ;
  case TYPE_TWO :
    type_ptr2 = get_type(fi,T_DERIVED_TYPE);
    type_ptr2->entry.derived_type = (PTR_SYMB) main_type1;
    type_ptr1 = type_ptr2;
    return_type = type_ptr1 ;
    break ;
  case TYPE_THREE :
    blob2 = follow_blob(pred_bfnd);
    bf2 = blob2->ref;
    if ((gsym= bf2->entry.template.symbol))
      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
	type_ptr2->entry.derived_type = gsym ;
	type_ptr1 = type_ptr2;
	return_type = type_ptr1;
      }
    else {
      return_type= main_type1 ;
    }
    passed_bfnd=new_cur_bfnd = bf2 ;                
    if (flag) {
      if (this_is_class(bf2->variant))
	{   
	  eliminate_lastlink();
	}
    }
    break;
    default :      err("System Crash ");
   }
  return(return_type);
}







PTR_TYPE
typed_declspecs_with_declmods(main_type1,type2,flag)
PTR_TYPE main_type1,type2;
{ PTR_TYPE type_ptr1,type_ptr2 ;
  PTR_SYMB gsym;
  PTR_BFND bf2;
  PTR_BLOB blob2 ;
  PTR_TYPE return_type;

  
  switch (main_type_flag) {
  case TYPE_ONE : type_ptr1 = combine_2(type2, &second_part);
    type_ptr1 = type2 ;
    type_ptr1->entry.descriptive.base_type=main_type1;
    return_type = type_ptr1 ;
    break ;
  case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
    type_ptr2->entry.derived_type = (PTR_SYMB) main_type1 ;
    type_ptr1 = type2 ;
    type_ptr1 = combine_2(type2,&second_part);
    type_ptr1->entry.descriptive.base_type= type_ptr2 ;
    return_type = type_ptr1 ;
    break ;
  case TYPE_THREE :
    type_ptr1 = type2;
    blob2 = follow_blob(pred_bfnd);
    bf2 = blob2->ref;
    if (gsym= bf2->entry.template.symbol)
      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
	type_ptr2->entry.derived_type = gsym ;
	type_ptr1->entry.descriptive.base_type = type_ptr2;
	return_type = type_ptr1 ;
      }
    else {
      type_ptr2 = main_type1;
      /* new_cur_type must be set inside structsp */
      type_ptr1->entry.descriptive.base_type = type_ptr2;
      return_type=type_ptr1;
    }
    passed_bfnd=new_cur_bfnd = bf2 ;                    
    if (flag) {
      if (this_is_class(bf2->variant))
	{   
	  eliminate_lastlink();
	}
    }
    break;
    default :      err("System Crash ");
   }
  return(return_type);
}



expr_primary_action(pllnd)
PTR_LLND pllnd;
{
  PTR_TYPE type;
  if (exception_flag == ON)  { err("undefined symbol");
			       exception_flag =OFF;
			     }
  if (pllnd->variant== FUNCTION_REF) {
    /* pllnd->variant = VAR_REF;*/
    type=get_type(fi,T_POINTER);
    type->entry.descriptive.base_type = pllnd->entry.template.symbol->type;
    pllnd->type = type;
   }
}

/*
PTR_LLND
pointer_declarator_action(variant,type_mod,declarator_llnd)
int variant;
PTR_TYPE type_mod;
PTR_LLND declarator_llnd;
{  PTR_TYPE type,type_1;
   PTR_SYMB symbptr1 ;
   int level_num,empty_sw ;
   PTR_LLND return_llnd;
   
   return_llnd= make_llnd(fi,DEREF_OP,declarator_llnd,LLNULL,SMNULL);
   symbptr1 = find_proc_name();
   if (! symbptr1->type) 
     type = symbptr1->type = get_type(fi,T_POINTER);
   else
     { type = follow_type(symbptr1, &level_num,&empty_sw);
       switch (type->variant) {
       case T_ARRAY :
	 type_1= type->entry.ar_decl.base_type=get_type(fi,T_POINTER);
	 break ;
       case T_FUNCTION:
       case T_POINTER :
       case T_REFERENCE:
	 type_1= type->entry.template.base_type=get_type(fi,T_POINTER);
	 break;
	 default : err("System Trouble");
       }
     }
 }


*/

/* Not completed yet 
PTR_LLND 
install_conversion_operator(maintype,star_type)
PTR_TYPE maintype;
PTR_TYPE star_type;
{

 PTR_TYPE type_ptr1,type_ptr2 ;
 PTR_BFND bf2;
 PTR_SYMB gsym;
 PTR_BLOB blob2 ;
 PTR_LLND ll;
 

 if (TRACEON) printf("122 ") ; 
 switch (main_type_flag) {
 case TYPE_ONE :
     type_ptr1 = maintype;
 case TYPE_TWO :
     type_ptr2 = get_type(fi,T_DERIVED_TYPE);
     type_ptr2->entry.derived_type = (PTR_SYMB) maintype;
     type_ptr1 = type_ptr2;
     break ;
 case TYPE_THREE :
     blob2 = follow_blob(pred_bfnd);
     bf2 = blob2->ref ;
     eliminate_lastlink();
     if ((gsym= bf2->entry.template.symbol))
     { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
       type_ptr2->entry.derived_type = gsym ;
       type_ptr1 = type_ptr2;
     }
     else type_ptr1= maintype ;
 }
 
 if (star_type) {
     star_type->entry.template.base_type = type_ptr1;
     type_ptr1 = star_type;
 }
 sprintf(buffer,"$ConversionOp");

 ll = lazy_install(entry,FUNCTION_NAME,NO);
 ll->entry.template.symbol->type = type_ptr1;
 return(ll);
 
 
}

*/
 


PTR_TYPE    
map_rid_to_type(i)
int i;
{

  switch (i) {
  case (int) RID_CHAR : 
    return(global_char);
  case (int) RID_INT  :
    return(global_int);
  case (int) RID_FLOAT :
    return(global_float);
  case (int) RID_DOUBLE : 
    return(global_double);
  case (int) RID_VOID :
    return(global_void);
  }
  return(global_int);
}
  

PTR_LLND
handle_complicated_paramters(p1,p2)
PTR_LLND p1,p2;
{
  PTR_LLND p;
  PTR_SYMB  symbptr1;
  PTR_TYPE type;
  int level,sw;

  p = make_llnd(fi,FUNCTION_OP,p1,p2,SMNULL);
  symbptr1 = find_parameter_name(p1);
  if (! symbptr1->type) 
    type = symbptr1->type = get_type(fi,T_FUNCTION);
  else  /* no type checking here */
    { type = follow_type(symbptr1, &level,&sw);
      switch (type->variant) {
      case T_FUNCTION:
      case T_POINTER :
      case T_REFERENCE:
	 type->entry.template.base_type=get_type(fi,T_FUNCTION);
	break;
      default : err("too complicated paramter expressions");
      }
    }
  return(p);
}
