/* transform for PC++                            */
/* Created by Jenq-Kuen Lee Dec 16, 1989         */


#include "vparse.h"
#include "tag"
#include "vpc.h"
#include "db.h"
#include "vextern.h"
#include "distribution.h"

extern PTR_FILE fi;
extern PTR_TYPE global_elementtype;            
extern int growing_flag;
/* define some local usage constants */
#define MAX_OBJECT_NUM 500
#define SCAN_ONLY 1
#define SCAN_AND_RECORD 2
#define SCAN_FOR_SUBSTITUTE 3
#define SCAN_DOSUBSET_INDEX 4
#define SCAN_OBJECT         5


#define MAX_TEMP_SPACE      500
#define DOALL_TRANSFORM     1
#define DOSUBSET_TRANSFORM  2

/* Define Names of Method in the kernel */
#define LocalCollectionString "LocalCollection"
#define HeadInfoString        "head_info"
#define ProcSetFieldString    "Pset"
#define ElementSchedulingString "scheduling"
#define AllocatorString         "para_calloc"
#define VectorConstantName      "vconstant"
#define InitFunctionString      "Z_VconstantInit"
#define SIZEOF_VCONSTANT        8
#define VconstantDimName        "dimension"       /*field of vconstant*/
#define VconstantArrayName      "body"            /*field of vconstant*/ 
#define DOALLStringName         "DOALL"


typedef struct collection_table  *PTR_ENTRY;
typedef struct use_set           *PTR_USESET;
typedef struct chain_set         *PTR_CHAIN;
struct chain_set {
  PTR_ENTRY  entry;
  PTR_CHAIN  next;
};

struct collection_table  {
    int         expanded_flag;
    int         id;
    PTR_TYPE    base;
    PTR_SYMB    name;
    PTR_ENTRY   next;  /* for next entry with the different collection_name*/
    PTR_ENTRY   prev;  /* for prev entry with the different collection_name*/
    PTR_ENTRY   outer; /* for next entry with the same collection_name*/
    PTR_ENTRY   thread;
    PTR_SYMB    new_name;
    PTR_CHAIN   subclass;
};
struct use_set {
	PTR_BFND    appearance;
	PTR_USESET  next;
       } ;

PTR_ENTRY  head_col_entry = NULL;
PTR_ENTRY  cur_col_entry  = NULL;
extern PTR_FILE cur_file;
int        collection_counter = 0;

PTR_SYMB   *symb_storage_pool;
PTR_BFND   *bif_storage_pool;
PTR_TYPE   *type_storage_pool;
PTR_LLND   *llnd_storage_pool;
PTR_LLND   *field_storage_pool;
PTR_LLND   *extra_space = NULL;
PTR_BFND  *expired_bif_storage_pool;

int        symb_storage_pool_top=0;
int        llnd_storage_pool_top=0;
int        field_storage_pool_top = 0;
int        bif_storage_pool_top=0;
int        type_storage_pool_top = 0;
int        expired_bif_storage_pool_size;

PTR_TYPE   this_element_type;
PTR_SYMB   this_collection_name;
PTR_BFND   this_collection_node;

/* expression transformation */
int          all_elements_flag;
int        expression_space_size=0;
int        expression_counter=0;
int        dosubset_node=0;
typedef struct collection_expr_nodes *PTR_EXPRNODE;
struct collection_expr_nodes {
  int  index;
  PTR_SYMB s;
};
PTR_EXPRNODE expression_space = NULL;
PTR_SYMB     subcollection_name[MAX_TEMP_SPACE];
PTR_SYMB     subfield_name[MAX_TEMP_SPACE];


/* transformation of the vector constant */
int          global_counter;
PTR_LLND     vconstant_llnd[MAX_TEMP_SPACE];
PTR_SYMB     vconstant_symb[MAX_TEMP_SPACE];


PTR_SYMB put_new_symb();
PTR_BFND put_new_bif();
PTR_TYPE put_new_type();
PTR_LLND put_new_llnd();
PTR_TYPE follow_type_1();
PTR_TYPE follow_type_2();
PTR_TYPE chain_up_type();
PTR_TYPE copy_new_type();
PTR_BFND duplicate_bif_node();
PTR_LLND duplicate_ll_node();
PTR_LLND find_suit_declarator();
PTR_LLND follow_llnd();
char *creat_new_collection_name();
char *copys();
PTR_HASH look_up_type();
PTR_LLND set_local_collection_llnd();
PTR_BFND set_up_expr_body();
PTR_SYMB make_symb();
PTR_SYMB find_out_collection_object();
PTR_BFND trans_exprnode_dosubset();
PTR_SYMB check_field_decl_3_varied();
PTR_LLND scan_expr_for_dosubset();
PTR_BFND find_class_bfnd();
PTR_SYMB find_object_symbol();
PTR_SYMB find_to_symb();
PTR_SYMB find_functor();
PTR_LLND make_new_collection_expr();
PTR_LLND substitute_expr_for_dosubset();
PTR_BLOB make_blob();
PTR_ENTRY install_collection_entry();
PTR_SYMB  follow_class_field();
extern int is_old_DOALL;
PTR_SYMB find_to_left_symb();
PTR_SYMB find_to_functor();
PTR_ENTRY
alloc_entry()
{  PTR_ENTRY s;

   if (!head_col_entry)
       head_col_entry=
       cur_col_entry =(PTR_ENTRY) calloc(1,sizeof(struct collection_table));
   else  {
     cur_col_entry->thread =(PTR_ENTRY) calloc(1,sizeof(struct collection_table));
     cur_col_entry= cur_col_entry->thread;
   }
   cur_col_entry->id = collection_counter++;
   return(cur_col_entry);
}


PTR_USESET
alloc_useset()
{  PTR_USESET s;
	
   s= (PTR_USESET) calloc(1,sizeof(struct use_set));
   return(s);
}


scan_collection_entry()
{  PTR_BLOB blob;
   PTR_SYMB name;
   PTR_LLND p1;
   PTR_TYPE type,ttype,next_type;
   

   type = cur_file->head_type;
   for ( next_type = type; next_type; next_type= next_type->thread)
    {
      if (next_type->variant==T_DERIVED_COLLECTION) {
            name = next_type->entry.col_decl.collection_name;
            ttype = next_type->entry.col_decl.base_type;
	    if ((ttype->variant==T_DERIVED_TYPE)&&
		(!strcmp(ttype->entry.derived_type->ident,"ElementType")))
	      continue;
            else install_collection_entry(name,ttype);
	  }
              
    }
 }


/*
   return  1:  entry is installed
           0:  entry is not installed because it was there already

*/
PTR_ENTRY
install_collection_entry(name,type)
PTR_TYPE type;
PTR_SYMB name;
{
  PTR_TYPE base,derived_type;
  PTR_SYMB collection_name;
  PTR_ENTRY entry,p,q,oldp,oldq,parent;
  PTR_LLND p1,p2;
  PTR_BFND bf1;
  int depth,sw;  

  base = type;
  collection_name = name;
       
  for (oldp= p = head_col_entry; p; p= p->next)
  {	
    if ((p->name==collection_name)&&is_same_entry(p->base,base)) return(p);
    if (p->name==collection_name)
      {
	for (oldq= q = p; q; q= q->outer) 
	  {
	    if (is_same_entry(q->base,base)) return(q);
	    oldq = q;
	  }	    
	entry=alloc_entry();
	entry->base = base;	
	entry->name = collection_name;
	oldq->outer = entry;
        /* install the superclass too */
        derived_type=follow_type_2(collection_name->type,&depth,&sw);
        bf1=derived_type->entry.derived_class.original_class;
        for (p1=bf1->entry.template.ll_ptr2;p1;p1=p1->entry.template.ll_ptr2)
	  {
	    p2=follow_llnd(p1,1);
	    parent=install_collection_entry(p2->entry.template.symbol,base);
	    setup_inheritance_chain(parent,entry);
	  }
        return(entry);
      }
    oldp = p;
    
  }
  entry=alloc_entry();
  entry->base = base;
  entry->name = collection_name;
  if (oldp) oldp->next = entry;
  entry->prev = oldp;
  /* install the superclass too */
  derived_type=follow_type_2(collection_name->type,&depth,&sw);
  bf1=derived_type->entry.derived_class.original_class;
  for (p1=bf1->entry.template.ll_ptr2;p1;p1=p1->entry.template.ll_ptr2)
   {
     p2=follow_llnd(p1,1);
     parent=install_collection_entry(p2->entry.template.symbol,base);
     setup_inheritance_chain(parent,entry);
    }
  return(entry);
}	  

int
is_same_entry(base,new_base)
PTR_TYPE  base,new_base;
{

    if (base==new_base) return(1);
    if ((!base)||(!new_base)) return(0);
    if ((base->variant==T_DERIVED_TYPE)&&(new_base->variant==T_DERIVED_TYPE))
      {
	if (base->entry.derived_type==new_base->entry.derived_type) return(1);
      }
    return(0);
  }

  



setup_inheritance_chain(super_entry,child_entry)
PTR_ENTRY super_entry,child_entry;
{
  PTR_CHAIN q,oldq;

  for (oldq=q=super_entry->subclass;q; q=q->next)
    {
      if (q->entry==child_entry) return;
    }
  q = (PTR_CHAIN) calloc(1, sizeof(struct chain_set));
  q->entry = child_entry;
  if (oldq) oldq->next = q;
  else  super_entry->subclass = q;
}



printout_chain()
{
  PTR_ENTRY p,q;
  PTR_CHAIN q1;

  for ( p = head_col_entry; p; p= p->next)
  {	
    for ( q = p; q; q= q->outer) 
      {
	printf("The superclass is %s\n",q->name->ident);
	for (q1= q->subclass; q1; q1= q1->next)
	  printf("The subclass is %s\n",q1->entry->name->ident);
	printf("\n\n");
      }	    

  }

}


adjust_order_entry()
{
  PTR_ENTRY p,q;
  PTR_CHAIN q1;

  for ( p = head_col_entry; p; p= p->next)
  {	
    for ( q1 = p->subclass; q1; q1= q1->next)
      {
	q = q1->entry;
	if (q->id < p->id )
	  {
	    if (q==head_col_entry) {
	      head_col_entry = q->next;
	      q->next->prev = NULL;
	      if (p->next) p->next->prev = q;
	      q->next = p->next;
	      q->prev = p;
	      p->next = q;
	    }
	   else {
	     q->prev->next = q->next;
	     q->next->prev = q->prev;
	     if (p->next) p->next->prev = q;
	     q->next = p->next;
	     q->prev = p;
	     p->next = q;	     
	   }
	  }
      }
  }
}




/*************************************************************************/
/* duplicate Bif structure                                               */
/*************************************************************************/
PTR_BFND
transform_collection_structure(q,pbf,sw)
PTR_BFND pbf;
PTR_ENTRY q;
{
  PTR_BFND root;


    duplicate_bif_node(pbf,1);
    root =duplicate_bif_node(pbf,2);
    chain_up_new_node(pbf,root);
    if (!sw) {
       expand_all_member_func_boody(q,this_collection_name);
     }
  return(root);

}




PTR_LLND
duplicate_ll_node(pllnd,sw)
PTR_LLND pllnd;
{
 PTR_LLND p1,p2,root;
 PTR_SYMB symb;


 if (!pllnd) return(NULL);
 if (sw==1) {
   root=make_llnd(fi,pllnd->variant,NULL,NULL,NULL);
   push_new_llnd(pllnd);
   extra_space[pllnd->id] = root;
   switch (pllnd->variant)  {
   case INT_VAL:
   case CHAR_VAL:
   case DOUBLE_VAL:
   case FLOAT_VAL:
   case STRING_VAL:
     break;
   case ARITH_ASSGN_OP:	/* New added for VPC++ */
     duplicate_ll_node(pllnd->entry.template.ll_ptr1,sw) ; 
     duplicate_ll_node(pllnd->entry.template.ll_ptr2,sw) ;
     break;

   case CAST_OP:	/* New added for VPC++ */
     duplicate_ll_node(pllnd->entry.template.ll_ptr1,sw) ; 
     duplicate_ll_node(pllnd->entry.template.ll_ptr2,sw) ;
     adjust_cast_op_new_type(pllnd->type,sw);
     break;
   default:
     duplicate_ll_node(pllnd->entry.template.ll_ptr1,sw) ; 
     duplicate_ll_node(pllnd->entry.template.ll_ptr2,sw) ;
   }
   return(root);
 }
 else  root = put_new_llnd(pllnd);
 switch (pllnd->variant)  {
   case INT_VAL:
     root->entry.ival = pllnd->entry.ival;
     root->type       = pllnd->type;
     break;
   case CHAR_VAL:
     root->entry.cval = pllnd->entry.cval;
     root->type       = pllnd->type;
     break;
   case DOUBLE_VAL:
   case FLOAT_VAL:
   case STRING_VAL:
     root->entry.string_val = pllnd->entry.string_val;
     root->type       = pllnd->type;
     break;
   case ARITH_ASSGN_OP:	/* New added for VPC++ */
     root->entry.template.symbol =root->entry.template.symbol;
     root->entry.template.ll_ptr1=duplicate_ll_node(pllnd->entry.template.ll_ptr1,sw) ; 
     root->entry.template.ll_ptr2=duplicate_ll_node(pllnd->entry.template.ll_ptr2,sw) ;
     root->type       = pllnd->type;
     break;
   case CAST_OP:
     adjust_cast_op_new_type(pllnd->type,sw);
     root->entry.template.ll_ptr1=duplicate_ll_node(pllnd->entry.template.ll_ptr1,sw) ; 
     root->entry.template.ll_ptr2=duplicate_ll_node(pllnd->entry.template.ll_ptr2,sw) ;
     root->entry.template.symbol = put_new_symb(pllnd->entry.template.symbol);
     root->type       = put_new_type(pllnd->type);
     break;
   default:
     root->entry.template.ll_ptr1=duplicate_ll_node(pllnd->entry.template.ll_ptr1,sw) ; 
     root->entry.template.ll_ptr2=duplicate_ll_node(pllnd->entry.template.ll_ptr2,sw) ;
     root->entry.template.symbol = put_new_symb(pllnd->entry.template.symbol);
     root->type       = put_new_type(pllnd->type);
   }
 return(root);
  
}




PTR_LLND
copy_ll_node(pllnd)
PTR_LLND pllnd;
{
 PTR_LLND p1,p2,root;

 if (!pllnd) return(NULL);
 p1= copy_ll_node(pllnd->entry.template.ll_ptr1);
 p2= copy_ll_node(pllnd->entry.template.ll_ptr2);
 root=make_llnd(fi,pllnd->variant,p1,p2,pllnd->entry.template.symbol);
 root->type =pllnd->type;
 return(root);
  
}
 


chain_up_new_node(pbf,root)
PTR_BFND pbf,root;
{
  PTR_BLOB blob,old_blob;
  int sw;
  PTR_BFND parent;


  parent = pbf->control_parent;
  for(sw=1,old_blob=NULL,blob=parent->entry.template.bl_ptr1;blob;blob=blob->next)
    { 
      if (blob->ref==pbf) break;
      old_blob = blob;
    }
  if (!blob) {
    sw=2;
    for(old_blob=NULL,blob=parent->entry.template.bl_ptr2;blob;blob=blob->next)
    { 
      if (blob->ref==pbf) break;
      old_blob = blob;
    }
  }
 if (!blob) err("cant not found the original bif node while restructuring");
 if (sw==1) {
   if (!old_blob) 
     parent->entry.template.bl_ptr1=make_blob(fi,root,blob);
   else
     old_blob->next = make_blob(fi,root,blob);
 }
 else      {
   if (!old_blob) 
     parent->entry.template.bl_ptr2=make_blob(fi,root,blob);
   else
     old_blob->next = make_blob(fi,root,blob);
 }


}


/*************************************************************************/
/* duplicate Bif structure                                               */
/* If (sw==1)  Create symbol only (first pass)                           */
/* if (sw==2)  create the whole structure (second pass)                  */
/*************************************************************************/
PTR_BFND
duplicate_bif_node(pbf,sw) 
PTR_BFND  pbf;
int sw;
{
  PTR_SYMB  symb,s;
  PTR_LLND  p1,p2,expr_list;
  PTR_BLOB  blob,blob1;
  PTR_BFND  root,child_bfnd;

  if (!pbf) return(NULL);  
  switch (pbf->variant) {
	case FUNC_HEDR  :
	    symb= pbf->entry.template.symbol;
	    for (s=symb->entry.member_func.in_list;s;
		 s=s->entry.var_decl.next_in)
	      {
		gen_duplicate_symbol(s,sw);
	      }
	    gen_duplicate_symbol(symb,sw);
	  break;
        case ENUM_DECL :                /* New added for VPC */
        case CLASS_DECL:                /* New added for VPC */
        case UNION_DECL:                /* New added for VPC */
        case STRUCT_DECL:               /* New added for VPC */
        case DERIVED_CLASS_DECL:        /* Need More for VPC */
	case COLLECTION_DECL:
	    if (pbf->entry.template.symbol)
	      gen_duplicate_type(pbf->entry.template.symbol->type,sw);
	    gen_duplicate_symbol(pbf->entry.template.symbol,sw);
	    expr_list = pbf->entry.template.ll_ptr1;
	    for( p1=expr_list; p1; p1=p1->entry.template.ll_ptr2)
	      {
		p2=find_suit_declarator(p1);
		gen_duplicate_symbol(p2->entry.template.symbol,sw);
	      }
	    break;
        case VAR_DECL:
	    expr_list = pbf->entry.template.ll_ptr1;
	    for( p1=expr_list; p1; p1=p1->entry.template.ll_ptr2)
	      {
		p2=find_suit_declarator(p1);
		if (p2->entry.template.symbol->variant==TYPE_NAME)
		  {
		    gen_duplicate_type(p2->entry.template.symbol->type,sw);
		  }
		gen_duplicate_symbol(p2->entry.template.symbol,sw);
	      }
	  break;
       default:
	  break;
	}
  if (sw==1)   {
    gen_duplicate_bif(pbf,sw);
    for(blob = pbf->entry.template.bl_ptr1;blob; blob=blob->next)
      duplicate_bif_node(blob->ref,1);
    for(blob = pbf->entry.template.bl_ptr2;blob; blob=blob->next)
      duplicate_bif_node(blob->ref,1);
    duplicate_ll_node(pbf->entry.template.ll_ptr1,sw);
    duplicate_ll_node(pbf->entry.template.ll_ptr2,sw);
    duplicate_ll_node(pbf->entry.template.ll_ptr3,sw);
    return(NULL);
  }
  /* second phase */
  root=put_new_bif(pbf);
  for(blob1=NULL,blob = pbf->entry.template.bl_ptr1;blob; blob=blob->next)
    {
      child_bfnd = duplicate_bif_node(blob->ref,2);
      if (!blob1) 
        root->entry.template.bl_ptr1= blob1 = make_blob(fi,child_bfnd,BLNULL);
      else {
        blob1->next  = make_blob(fi,child_bfnd,BLNULL);
        blob1 = blob1->next;
      }
    }
  for(blob1=NULL,blob = pbf->entry.template.bl_ptr2;blob; blob=blob->next)
    {
      child_bfnd = duplicate_bif_node(blob->ref,2);
      if (!blob1)
        root->entry.template.bl_ptr2= blob1 = make_blob(fi,child_bfnd,BLNULL);
      else {
        blob1->next  = make_blob(fi,child_bfnd,BLNULL);
        blob1 = blob1->next;
      }
    }
 root->entry.template.ll_ptr1=duplicate_ll_node(pbf->entry.template.ll_ptr1,sw);
 root->entry.template.ll_ptr2=duplicate_ll_node(pbf->entry.template.ll_ptr2,sw);
 root->entry.template.ll_ptr3=duplicate_ll_node(pbf->entry.template.ll_ptr3,sw);
 symb=root->entry.template.symbol=put_new_symb(pbf->entry.template.symbol);
 if (symb) symb->type=put_new_type(pbf->entry.template.symbol->type);
 root->control_parent       =put_new_bif(pbf->control_parent);
 return(root);
  
}










/*************************************************************************/
/*                                                                       */
/* store new symbol and bif_node information                             */
/*                                                                       */
/*************************************************************************/
push_new_symbol(symb)
PTR_SYMB symb;
{
  symb_storage_pool[ symb_storage_pool_top ] = symb;
  symb_storage_pool_top++;
}

PTR_SYMB
put_new_symb(symb)
PTR_SYMB symb;
{
   if (!symb) return(NULL);
   if (symb->id_list) return(symb->id_list);
   return(symb);
}

clean_push_symbol()
{
  int i;
  for (i=0; i<symb_storage_pool_top;i++)
    symb_storage_pool[i]->id_list = NULL;

}


clean_partial_push_symbol(from)
int from;
{
  int i;
  for (i=from; i<symb_storage_pool_top;i++)
    symb_storage_pool[i]->id_list = NULL;

}



push_new_llnd(pllnd)
PTR_LLND pllnd;
{
  llnd_storage_pool[ llnd_storage_pool_top ] = pllnd;
  llnd_storage_pool_top++;
}


PTR_LLND
put_new_llnd(pllnd)
PTR_LLND pllnd;
{
   if (!pllnd) return(NULL);
   if (extra_space[pllnd->id]) return(extra_space[pllnd->id]);
   return(pllnd);
}


clean_push_llnd()
{
  int i;
  for (i=0; i<llnd_storage_pool_top;i++)
    extra_space[llnd_storage_pool[i]->id] = NULL;
}


clean_partial_push_llnd(from)
int from;
{
  int i;
  for (i=from; i<llnd_storage_pool_top;i++)
    extra_space[llnd_storage_pool[i]->id] = NULL;
}


push_new_bif(pbf)
PTR_BFND pbf;
{
  bif_storage_pool[ bif_storage_pool_top ] = pbf;
  bif_storage_pool_top++;

}


push_expired_bif(pbf)
PTR_BFND pbf;
{
  expired_bif_storage_pool[ pbf->id]= pbf;
}




PTR_BFND
put_new_bif(pbf)
PTR_BFND pbf;
{
   if (!pbf) return(NULL);
   if (pbf->index) return((PTR_BFND) pbf->index);
   return(pbf);
}


clean_push_bif()
{
  int i;
  for (i=0; i<bif_storage_pool_top;i++)
    bif_storage_pool[i]->index = NULL;

}

clean_partial_push_bif(from)
int from;
{
  int i;
  for (i=from; i<bif_storage_pool_top;i++)
    bif_storage_pool[i]->index = NULL;

}



gen_duplicate_bif(pbf,sw)
PTR_BFND pbf;
int sw;
{
  PTR_BFND root;
  int i;

  if (sw==1) {
    i = (pbf->variant==COLLECTION_DECL)? CLASS_DECL : pbf->variant;
    root=make_bfnd(fi,i, SMNULL,NULL,NULL,NULL);
    root->filename = pbf->filename;
    pbf->index = (int)root;
    push_new_bif(pbf);

  }
   
}


push_new_type(type)
PTR_TYPE type;
{
  type_storage_pool[ type_storage_pool_top ] = type;
  type_storage_pool_top++;
}



PTR_TYPE
put_new_type(type)
PTR_TYPE type;
{
  PTR_TYPE final_type,new_type,base_type,one_type;
  int sw,flag;

   if (!type) return(NULL);
   if (type->length) return((PTR_TYPE) type->length);
   final_type = follow_type_2(type,&sw,&flag);
   if ((final_type->variant==T_DERIVED_TYPE)&&
       (!strcmp(final_type->entry.derived_type->ident,"ElementType")))
     {
       if (!final_type->length)  {
	 final_type->length= (int) this_element_type;
	 push_new_type(final_type);
       }
     }
   else if (final_type->variant==T_DERIVED_COLLECTION)
     {

       base_type =final_type->entry.col_decl.base_type;
       if ((base_type->variant==T_DERIVED_TYPE)&&
	   (!strcmp(base_type->entry.derived_type->ident,"ElementType")))
	 {
           one_type = get_type(fi,T_DERIVED_COLLECTION);
	   one_type->entry.col_decl.base_type = this_element_type;
	   one_type->entry.col_decl.collection_name=final_type->entry.col_decl.collection_name;
           final_type->length= (int) one_type;
           push_new_type(final_type);      
	   /*printf("We come here\n"); */
	 }

     }
   if (!final_type->length) return(type);
   else  new_type=copy_new_type(type);
   return(new_type);
}


clean_push_type()
{
  int i;
  for (i=0; i<type_storage_pool_top;i++)
    type_storage_pool[i]->length = NULL;

}


clean_partial_push_type(from)
int from;
{
  int i;
  for (i=from; i<type_storage_pool_top;i++)
    type_storage_pool[i]->length = NULL;

}



gen_duplicate_type(type,sw)
PTR_TYPE type;
int sw;
{
  PTR_TYPE q;
  int i;

  if (sw==1) {
    i = type->variant;
    q= get_type(fi,i);
    type ->length = (int) q;
    push_new_type(type);
  }
  else  links_new_type(type);

}



/*************************************************************************/
/* replace_collection_field_llnd                                         */
/*                                                                       */
/*************************************************************************/
replace_collection_bfnd(pbf)
PTR_BFND pbf;
{
  PTR_BLOB blob;
  if (!pbf) return;
  for(blob=pbf->entry.template.bl_ptr1;blob;blob=blob->next)
      replace_collection_bfnd(blob->ref);
  for(blob=pbf->entry.template.bl_ptr2;blob;blob=blob->next)
      replace_collection_bfnd(blob->ref);
  replace_collection_llnd(pbf->entry.template.ll_ptr1);
  replace_collection_llnd(pbf->entry.template.ll_ptr2);
  replace_collection_llnd(pbf->entry.template.ll_ptr3);
}

replace_collection_llnd(pllnd)
PTR_LLND pllnd;
{
  if (!pllnd) return;
  replace_collection_llnd(pllnd->entry.template.ll_ptr1);
  replace_collection_llnd(pllnd->entry.template.ll_ptr2);
  if ((pllnd->variant==RECORD_REF)||(pllnd->variant==POINTST_OP))
    replace_collection_field_llnd(pllnd);
}


replace_collection_field_llnd(p1)
PTR_LLND p1;
{
  PTR_LLND target_llnd;
  PTR_SYMB target_symb;
  int sw,level,sw2;
  PTR_ENTRY q,entry;
  PTR_TYPE type,type2;
  PTR_TYPE base;
  PTR_SYMB name,first,subcollection;
  

  sw=ON;
  type=follow_type_2(p1->entry.template.ll_ptr1->type,&level,&sw2);
  if (type&&(type->variant== T_DERIVED_COLLECTION))
    {
      target_llnd=p1->entry.template.ll_ptr2;
      target_symb=target_llnd->entry.template.symbol;
      name = type->entry.col_decl.collection_name;
      base = type->entry.col_decl.base_type;
      for (entry = head_col_entry; (sw==ON)&&entry; entry =entry->next)
	for ( q= entry; (sw==ON)&&q; q= q->outer)
	  {
	    if (is_same_entry(q->base,base)&& (q->name==name))
	      {
		first=follow_class_field(q->name,q->new_name,target_symb);
		if (first) target_llnd->entry.template.symbol = first;
		sw= OFF;
	      }
	  }
    }
  else  {
    subcollection = find_to_left_symb(p1);
    if (subcollection&&(subcollection->attr & SUBCOLLECTION)) {
      target_llnd=p1->entry.template.ll_ptr2;
      target_symb=target_llnd->entry.template.symbol;
      name = (PTR_SYMB) subcollection->entry.var_decl.offset;
      base = (PTR_TYPE) subcollection->entry.var_decl.dovar;
      for (entry = head_col_entry; (sw==ON)&&entry; entry =entry->next)
	for ( q= entry; (sw==ON)&&q; q= q->outer)
	  {
	    if (is_same_entry(q->base,base)&& (q->name==name))
	      {
		first=follow_class_field(q->name,q->new_name,target_symb);
		if (first) target_llnd->entry.template.symbol = first;
		sw= OFF;
	      }      
	  }
    }
  }
}
  
/*************************************************************************/
/* gen_duplicate_symbol                                                  */
/* Phase 1: (sw==1) create the duplicate and give its scope as global    */
/* Phase 2: (sw==2) give the proper links and scope                      */
/*                                                                       */
/*************************************************************************/
gen_duplicate_symbol(symb,sw)
PTR_SYMB symb;
{
  PTR_SYMB new_symb;
  char *s;
  int status;
  PTR_HASH entry;

  if (sw==1) {
    if (symb->variant==COLLECTION_NAME){
      /* do nothing */
    }
    else{
      if (symb->id_list) return;
      new_symb  = make_symb(fi,symb->variant,symb->ident);
      symb->id_list= new_symb;
      push_new_symbol(symb);
    }
  }
  else {
    links_new_symb(symb);
  }

    
}



links_new_symb(symb)
PTR_SYMB symb;
{
  PTR_SYMB new_symb;
  char *s,*id,*id1;
  char buf1[200];
  PTR_TYPE dtype;
  PTR_SYMB tagname;
  PTR_BFND bf;
  int sw2,level;

   if (!symb) return(NULL);
   new_symb= symb->id_list;
   if (!new_symb) return(NULL);
   if (symb->variant==MEMBER_FUNC){
     if ((symb->entry.member_func.base_name)&&
	 (symb->entry.member_func.base_name->variant==COLLECTION_NAME))
       {
	 tagname= symb->entry.member_func.base_name;
	 s= tagname->ident;
	 id = symb->ident;
	 id1 = id+1;
	 if (!strcmp(s,id)) {
	   new_symb->ident = (tagname->id_list)? tagname->id_list->ident:s;
	   }
	 else if ((!strcmp(s,id1))&&( *id =='~')){
	   s = (tagname->id_list)? tagname->id_list->ident : s;
	   sprintf(buf1,"~%s",s);
	   s= copys(buf1);	  
	   new_symb->ident = s;
	 }	  
       }
   }


   new_symb->type = put_new_type(symb->type);
   new_symb->attr = symb->attr;
   new_symb->scope = put_new_bif(symb->scope);
   switch (symb->variant) {
   case CONST_NAME:
     break;
   case ENUM_NAME:
   case FIELD_NAME:
     new_symb->entry.field.tag= symb->entry.field.tag;
     new_symb->entry.field.restricted_bit=symb->entry.field.restricted_bit;
     new_symb->entry.field.next = put_new_symb(symb->entry.field.next);
     new_symb->entry.field.base_name=put_new_symb(symb->entry.field.base_name);
     new_symb->entry.field.declared_name=put_new_symb(symb->entry.field.declared_name);
     break;
   case VARIABLE_NAME:
     new_symb->entry.var_decl.local= symb->entry.var_decl.local;
     new_symb->entry.var_decl.next_in=put_new_symb(symb->entry.var_decl.next_in);
     new_symb->entry.var_decl.next_out=put_new_symb(symb->entry.var_decl.next_out);
     break;
   case PROGRAM_NAME:
     break;
   case PROCEDURE_NAME:
   case FUNCTION_NAME:
     new_symb->entry.proc_decl.num_input=symb->entry.proc_decl.num_input;
     new_symb->entry.proc_decl.num_output=symb->entry.proc_decl.num_output;
     new_symb->entry.proc_decl.num_io=symb->entry.proc_decl.num_io;
     new_symb->entry.proc_decl.in_list=put_new_symb(symb->entry.proc_decl.in_list);
     new_symb->entry.proc_decl.out_list=put_new_symb(symb->entry.proc_decl.out_list);
     new_symb->entry.proc_decl.symb_list=put_new_symb(symb->entry.proc_decl.symb_list);
     new_symb->entry.proc_decl.proc_hedr=put_new_bif(symb->entry.proc_decl.proc_hedr);
       break;
     case MEMBER_FUNC:    /*  NEW ADDED FOR VPC */
       new_symb->entry.member_func.num_input=symb->entry.member_func.num_input;
       new_symb->entry.member_func.num_output=symb->entry.member_func.num_output;
       new_symb->entry.member_func.num_io=symb->entry.member_func.num_io;
       new_symb->entry.member_func.in_list=put_new_symb(symb->entry.member_func.in_list);
       new_symb->entry.member_func.out_list=put_new_symb(symb->entry.member_func.out_list);
       new_symb->entry.member_func.symb_list=put_new_symb(symb->entry.member_func.symb_list);
       new_symb->entry.member_func.func_hedr=put_new_bif(symb->entry.member_func.func_hedr);
       new_symb->entry.member_func.next = put_new_symb(symb->entry.member_func.next);
       new_symb->entry.member_func.base_name=put_new_symb(symb->entry.member_func.base_name);
       new_symb->entry.member_func.declared_name=put_new_symb(symb->entry.member_func.declared_name);
       break;
     default:
       break;
     }
 }


 links_new_type(type)
 PTR_TYPE type;
 {

   PTR_TYPE q;

   if (!type) return(NULL);
   q = (PTR_TYPE) type->length;
   if (!q) return(NULL);

   switch (type->variant) {
   case T_DERIVED_TYPE :   /*  NEW ADDED FOR VPC */
     q->entry.derived_type = put_new_symb(type->entry.derived_type);
     break;
   case T_DERIVED_COLLECTION :   /*  NEW ADDED FOR PC++ */
     q->variant = T_DERIVED_TYPE;
     q->entry.derived_type = put_new_symb(type->entry.col_decl.collection_name);
     break;
   case T_ENUM:
   case T_UNION:   /*  NEW ADDED FOR VPC */
   case T_STRUCT:  /*  NEW ADDED FOR VPC */
   case T_CLASS :  /*  NEW ADDED FOR VPC */
   case T_DERIVED_CLASS :   /*  NEW ADDED FOR VPC */
   case T_COLLECTION:       /*  NEW ADDED FOR PC++ */
     q->variant= (type->variant==T_COLLECTION) ? T_CLASS : type->variant;
     q->entry.derived_class.num_fields=type->entry.derived_class.num_fields;
     q->entry.derived_class.first=put_new_symb(type->entry.derived_class.first);
     q->entry.derived_class.original_class=put_new_bif(type->entry.derived_class.original_class);
     q->entry.derived_class.base_type= NULL;
     break;
   default:
     break;
   }

 }  



 /*
    copy_new_type will stop in the type node whose length field is not
		   nil 

 */
 PTR_TYPE
 copy_new_type(passing_type)
 PTR_TYPE passing_type;
 { 
  PTR_TYPE new_type,old_type,next_type,one_type;

   new_type = NULL;
   for (next_type= passing_type; next_type;  )
    {  
      if (next_type->length) 
	return(chain_up_type((PTR_TYPE)next_type->length,new_type));
      switch(next_type->variant) {
      case T_ARRAY :
	old_type = next_type;
	one_type = get_type(fi,T_ARRAY);
	push_new_type(next_type);
	next_type->length =(int) one_type;
	new_type=chain_up_type(one_type,new_type);
	one_type->entry.ar_decl.ranges = next_type->entry.ar_decl.ranges;
	one_type->entry.ar_decl.num_dimensions = next_type->entry.ar_decl.num_dimensions;
	next_type = next_type->entry.template.base_type ;
	break;
      case T_FUNCTION :
      case T_POINTER  :
      case T_DESCRIPT : 
	old_type = next_type;
	one_type = get_type(fi,next_type->variant);
	push_new_type(next_type);
	next_type->length =(int) one_type;
	new_type =chain_up_type(one_type,new_type);
	one_type->entry.template.ranges = next_type->entry.template.ranges;
	one_type->entry.template.dummy1 = next_type->entry.template.dummy1;
	one_type->entry.template.dummy2 = next_type->entry.template.dummy2;
	one_type->entry.template.dummy3 = next_type->entry.template.dummy3;
	one_type->entry.template.dummy4 = next_type->entry.template.dummy4;
	one_type->entry.template.dummy5 = next_type->entry.template.dummy5;
	next_type = next_type->entry.template.base_type ;
	break;
      case T_DERIVED_TYPE :
	old_type = next_type;
	next_type = next_type->entry.derived_type->type;
	break;
     case T_DERIVED_COLLECTION:
     case T_COLLECTION:
     case T_CLASS:
     case T_UNION:
     case T_ENUM:
     default:
	old_type = next_type;
	new_type =chain_up_type(next_type,new_type);
	next_type= NULL;
      }
    }
  return(new_type);
 }



adjust_cast_op_new_type(type,sw)
PTR_TYPE type;
{
   PTR_TYPE q,next_type;

   if (!type) return(NULL);
   q = (PTR_TYPE) type->length;
   if (q) return;
   for (next_type= type; next_type;  )
    {  
      switch(next_type->variant) {
      case T_ARRAY :
        if (sw==1)  duplicate_ll_node(next_type->entry.ar_decl.ranges,sw) ; 
	else {
	  duplicate_ll_node(next_type->entry.ar_decl.ranges,sw) ; 
	  next_type->entry.ar_decl.ranges =
	    put_new_llnd(next_type->entry.ar_decl.ranges);
	}
	next_type = next_type->entry.template.base_type ;
	break;
      case T_FUNCTION :
      case T_POINTER  :
      case T_DESCRIPT : 
	next_type = next_type->entry.template.base_type ;
	break;
      case T_DERIVED_TYPE :
	next_type = NULL;
	break;
     case T_DERIVED_COLLECTION:
     case T_COLLECTION:
     case T_CLASS:
     case T_UNION:
     case T_ENUM:
     default:
	next_type= NULL;
      }
    }
 }









 transform_collection()
 {
   PTR_TYPE type,base;
   PTR_ENTRY entry,q;
   int sw,depth;
   PTR_BFND root;
   PTR_BLOB old,blob,blob1;
   char *s;
   PTR_SYMB name;
   int status;
   PTR_CHAIN c;
   PTR_HASH h;


  transform_vconstant_structure();
  transform_all_dosubset(global_bfnd,NULL,DOSUBSET_TRANSFORM);
   if (!is_old_DOALL)
     transform_all_dosubset(global_bfnd,NULL,DOALL_TRANSFORM);
  scan_collection_entry();
  adjust_order_entry();
  extra_space = (PTR_LLND *) calloc(1,sizeof(char *)*(fi->num_llnds+4));
  expired_bif_storage_pool=(PTR_BFND *)calloc(1,sizeof(char *)*(fi->num_bfnds+4));
  expired_bif_storage_pool_size = fi->num_bfnds;
  symb_storage_pool=(PTR_SYMB *) calloc(1,sizeof(char *)*(fi->num_symbs+4));
  bif_storage_pool=(PTR_BFND *) calloc(1,sizeof(char *)*(fi->num_bfnds+4));
  type_storage_pool=(PTR_TYPE *) calloc(1,sizeof(char *)*(fi->num_types+4));
  llnd_storage_pool=(PTR_LLND *) calloc(1,sizeof(char *)*(fi->num_llnds+4));


  for (entry = head_col_entry; entry; entry =entry->next)
    {
      for ( q= entry; q; q= q->outer)
	{
	  base=q->base;
	  name = q->name;
	  s=creat_new_collection_name(name, base);
          q->new_name  = make_symb(fi,CLASS_NAME,s);
	}
    }

  for (entry = head_col_entry; entry; entry =entry->next)
      for ( q= entry; q; q= q->outer)
	{
	  if (q->expanded_flag) continue;
	  symb_storage_pool_top = 0;
	  llnd_storage_pool_top = 0;
	  bif_storage_pool_top = 0;
	  type_storage_pool_top = 0;

	  expand_collection_entry(q);

	  clean_push_symbol();
	  clean_push_bif();
	  clean_push_type();
	  clean_push_llnd();
	  symb_storage_pool_top = 0;
	  llnd_storage_pool_top = 0;
	  bif_storage_pool_top = 0;
	  type_storage_pool_top = 0;

	}
  remove_expired_bif();
  replace_collection_bfnd(global_bfnd);

  /* export the element object to the proper places */
  for (entry = head_col_entry; entry; entry =entry->next)
      for ( q= entry; q; q= q->outer)
        q->expanded_flag=0;
  /* printout_chain(); */
  for (entry = head_col_entry; entry; entry =entry->next)
      for ( q= entry; q; q= q->outer)
	{
	  if (q->expanded_flag) continue;
	  export_object(q);
	  q->expanded_flag=1;
	  for (c = q->subclass; c; c = c->next)	  
	    if (!c->entry->expanded_flag)
	      {
		export_object(c->entry);
		c->entry->expanded_flag=1;
	      }
	}
  replace_all_nullified_method_bfnd(global_bfnd);
  update_derived_collection_type();
  free(extra_space);
  free(expired_bif_storage_pool);
  free(symb_storage_pool);
  free(bif_storage_pool);
  free(type_storage_pool);
  free(llnd_storage_pool);

}


expand_collection_entry(q)
PTR_ENTRY q;
{
  int depth,sw;
  PTR_TYPE type;
  PTR_BFND root;
  PTR_CHAIN c;
  PTR_ENTRY q1;
  int   old_symb_storage_pool_top,old_bif_storage_pool_top;
  int   old_llnd_storage_pool_top,old_type_storage_pool_top;


  if (q->expanded_flag) return;

  this_element_type = q->base;
  push_all_new_collection_name(this_element_type);
  type =follow_type_1(q->name->type,&depth,&sw);
  this_collection_node = type->entry.derived_class.original_class;
  this_collection_name = q->name;
  push_expired_bif(this_collection_node);
  root=transform_collection_structure(q,this_collection_node,0);
  transform_element_imported_method(q,this_element_type,this_collection_name);
  q->expanded_flag =1;
  for (c = q->subclass; c; c = c->next)
    {
      q1 = c->entry;
      if (q1->expanded_flag) continue;

      old_symb_storage_pool_top = symb_storage_pool_top;
      old_bif_storage_pool_top  = bif_storage_pool_top;
      old_type_storage_pool_top = type_storage_pool_top;
      old_llnd_storage_pool_top = llnd_storage_pool_top;
      expand_collection_entry(q1);
      q1->expanded_flag =1;
      clean_partial_push_symbol(old_symb_storage_pool_top);
      clean_partial_push_bif(old_bif_storage_pool_top);
      clean_partial_push_type(old_type_storage_pool_top);
      clean_partial_push_llnd(old_llnd_storage_pool_top);

      symb_storage_pool_top = old_symb_storage_pool_top;
      bif_storage_pool_top  = old_bif_storage_pool_top;
      type_storage_pool_top = old_type_storage_pool_top;
      llnd_storage_pool_top = old_llnd_storage_pool_top;
    }

}




push_all_new_collection_name(base)
PTR_TYPE base;
{
  PTR_ENTRY entry,q;


  for (entry = head_col_entry; entry; entry =entry->next)
    {
      for ( q= entry; q; q= q->outer)
	{
	  if (is_same_entry(q->base,base)) {
	    q->name->id_list = q->new_name;
	    push_new_symbol(q->name);
	  }
	}
    }

}




expand_all_member_func_boody(q,object)
PTR_SYMB object;
PTR_ENTRY q;
{
  PTR_BLOB blob,old;
  PTR_BFND pbf;
  PTR_SYMB functor;
  PTR_BFND root;

  for (old=blob = global_bfnd->entry.template.bl_ptr1; blob; blob=blob->next) 
    {
      if (blob->ref->variant==FUNC_HEDR) {
	pbf = blob->ref;
	functor= blob->ref->entry.template.symbol;
	if ((functor->variant==MEMBER_FUNC)&&
	    (functor->entry.member_func.base_name==object))
	  {
	    push_expired_bif(pbf);
	    root=transform_collection_structure(q,pbf,1);
	  }
      }
    }
}

remove_expired_bif()
{
  int size,i;
  PTR_BFND pbf;

  size= expired_bif_storage_pool_size;
  for (i=0;i<size;i++)
    {
      pbf=expired_bif_storage_pool[i];
      if (pbf) {
	remove_one_bif(pbf);
	expired_bif_storage_pool[i]= NULL;
      }
    }
}


remove_one_bif(pbf)
PTR_BFND pbf;
{
  PTR_BLOB blob,old;
  PTR_BFND parent;

  parent = pbf->control_parent;
  for (old =blob = parent->entry.template.bl_ptr1; blob;blob=blob->next)
    {
      if (blob->ref==pbf) {
	if (blob== parent->entry.template.bl_ptr1)
	  parent->entry.template.bl_ptr1=blob->next;
	else old->next=blob->next;
      }
      old=blob;
    }

  for (old=blob = parent->entry.template.bl_ptr2; blob;blob=blob->next)
    {
      if (blob->ref==pbf) {
	if (blob== parent->entry.template.bl_ptr2)
	  parent->entry.template.bl_ptr2=blob->next;
	else old->next=blob->next;
      }
      old=blob;
    }
}


update_derived_collection_type()
{
  PTR_TYPE type;
  PTR_TYPE base;
  PTR_SYMB name;
  PTR_ENTRY q,entry;

 for ( type = fi->head_type; type; type =type->thread)
       if (type->variant==T_DERIVED_COLLECTION)
	 {
            base = type->entry.col_decl.base_type;
            name = type->entry.col_decl.collection_name;
            for (entry = head_col_entry; entry; entry =entry->next)
               for ( q= entry; q; q= q->outer)
         	{
	           if ((is_same_entry(q->base,base))&& (q->name==name))
                     {
                        type->variant = T_DERIVED_TYPE;
                        type->entry.derived_type = q->new_name;
		      }
		 }
	  }
}


/*************************************************************************/
/* replace_element's imported methos with new symbol                     */
/*                                                                       */
/*************************************************************************/
transform_element_imported_method(q,base,collection_name)
PTR_ENTRY q;
PTR_TYPE  base;
PTR_SYMB  collection_name;
{
  PTR_SYMB object,parent_symb,symb;
  PTR_TYPE type;
  PTR_BFND pbf;
  PTR_BLOB blob;
  PTR_LLND p3;
  int depth,sw;

  if (base->variant!=T_DERIVED_TYPE) return;
  object = base->entry.derived_type;
  type=follow_type_2(object->type,&depth,&sw);
  if ((type->variant!=T_CLASS)&&(type->variant!=T_STRUCT)&&
      (type->variant!=T_UNION)&&(type->variant!=T_COLLECTION))
    return;
  else pbf= type->entry.derived_class.original_class;
  p3=pbf->entry.template.ll_ptr3;
  if (!p3) return;
  p3 = follow_llnd(p3,1);
  parent_symb = p3->entry.template.symbol;
  if (parent_symb !=collection_name) return;
  for(symb = type->entry.derived_class.first; symb; )
    {
     if ((symb->variant==MEMBER_FUNC)&&(symb->entry.member_func.func_hedr))
       replace_element_imported_method_bfnd(symb->entry.member_func.func_hedr);
      if (symb->variant==FIELD_NAME)
	symb=symb->entry.field.next;
      else
	symb=symb->entry.member_func.next;
    }
}




replace_element_imported_method_bfnd(pbf)
PTR_BFND pbf;
{
  PTR_BLOB blob;

  if (!pbf) return;
  for(blob=pbf->entry.template.bl_ptr1;blob;blob=blob->next)
    replace_element_imported_method_bfnd(blob->ref);
  for(blob=pbf->entry.template.bl_ptr2;blob;blob=blob->next)
    replace_element_imported_method_bfnd(blob->ref);
  replace_element_imported_method_llnd(pbf->entry.template.ll_ptr1);
  replace_element_imported_method_llnd(pbf->entry.template.ll_ptr2);
  replace_element_imported_method_llnd(pbf->entry.template.ll_ptr3);
}  


replace_element_imported_method_llnd(pllnd)
PTR_LLND pllnd;
{
  if (!pllnd) return;
  replace_element_imported_method_llnd(pllnd->entry.template.ll_ptr1);
  replace_element_imported_method_llnd(pllnd->entry.template.ll_ptr2);
  switch (pllnd->variant) {
   case VAR_REF:
   case ARRAY_REF:
   case FUNC_CALL:
   case FUNCTION_REF:
    if (pllnd->entry.template.symbol)
      pllnd->entry.template.symbol=put_new_symb(pllnd->entry.template.symbol);
  }
}




/*************************************************************************/
/* Create the new name for collection_name                               */
/*************************************************************************/
char *
creat_new_collection_name(collection_name, base)
PTR_SYMB collection_name;
PTR_TYPE base;
{
 
   char tbuff[1000],*cp,*s;
   int level,i,sw;
   PTR_BFND pbf;
   PTR_TYPE type;
   PTR_SYMB tag_name;
   
   cp = tbuff;
   *cp++ = '_';
   type = follow_type_2(base,&level,&sw);
   for ( ; level >0 ; level--) *cp++ = 'E';
   switch (type->variant) {
   case T_CHAR    :
     *cp++ = 'C';
     break;
   case T_VOID    :
     *cp++ = 'V';
     break;
   case T_DOUBLE  :
     *cp++ = 'D';
     break;
   case T_FLOAT   :
     *cp++ = 'F';
     break;
   case T_DERIVED_TYPE:
     tag_name =type->entry.derived_type;
     if (tag_name) {
       *cp++ = 'E';
       for (s= tag_name->ident; *s !='\0'; )
	 *cp++ = *s++;
     }
     break;
   case T_UNION   :
   case T_STRUCT  :
   case T_CLASS   :
   case T_COLLECTION:
     pbf = type->entry.derived_class.original_class;
     tag_name = pbf->entry.template.symbol;
     *cp++ = 'E';
     if (tag_name) {
       for (s= tag_name->ident; *s !='\0'; )
	 *cp++ = *s++;
     }
     break;
   case DEFAULT : 
   case T_INT     :
   case T_ENUM    :
   default:
     *cp++ = 'I';
   }
 *cp++ = '_';
 s = collection_name->ident;
 for ( ; *s!='\0' ; )
   *cp++ = *s++;
  *cp = '\0';
 return(copys(tbuff));
 }




/**************************************************************************/
/* Programs transformation of DoSubset and the invocation of methods      */
/* of elements by  the collection                                         */
/*                                                                        */
/* (1) Invocations of all elements:                                       */
/*                                                                        */
/*      original form:  G->update()                                       */
/*      original form:  DoSubset([...],G->update,arg1,...)                */
/*      original form:  G->DoSubSet([...],G->update,arg1,arg2,...)        */
/*                                                                        */
/*      Transformed form:                                                 */
/*                                                                        */
/*      DOALL  Pid   in G    {                                            */
/*      int BEGIN[MAX_NESTED_DIM],END[MAX_NESTED_DIM],STRIDE[MAX_NESTED_DIM]*/
/*      int begin[MAX_NESTED_DIM],end[MAX_NESTED_DIM],stride[MAX_NESTED_DIM]*/
/*      int I1,I2,I3,I4,I5,I6,I7;                                         */
/*                                                                        */
/*      begin[]=....; end[]=..., stride=...;                              */
/*      scheduling(info_unit,variant,pid,begin,end,stride,BEGIN,END,STRIDE)*/
/*      switch (dimension) {                                              */
/*        case ONE_DIMENSION:                                             */
/*            W = G.SubCollection(pid);                                   */
/*            for (I1 =BEGIN[0]; I1 <END[0]; I1+=STRIDE[0])               */
/*                 W[I1].update();                                        */
/*            break;                                                      */
/*        case TWO_DIMENSION:                                             */
/*            W = G.SubCollection(pid);                                   */
/*            for (I1 =BEGIN[0]; I1 <END[0]; I1+=STRIDE[0])               */
/*             for (I2 =BEGIN[1]; I2 <END[1]; I2 +=STRIDE[1])             */
/*                 W[I1][I2].update();                                    */
/*            break;                                                      */
/*      case THREE_DIMENSION:                                             */
/*            W = G.SubCollection(pid);                                   */
/*            for (I1 =BEGIN[0]; I1 <END[0]; I1+=STRIDE[0])               */
/*             for (I2 =BEGIN[1]; I2 <END[1]; I2+=STRIDE[1])              */
/*              for (I3 =BEGIN[2]; I3 <END[2]; I3+=STRIDE[2])             */
/*               W[I1][I2][I3].update();                                  */
/*            break;                                                      */
/*        case FOUR_DIMENSION:                                            */
/*            W = G.SubCollection(pid);                                   */
/*            for (I1 =BEGIN[0]; I1 <END[0]; I1+=STRIDE[0])               */
/*             for (I2 =BEGIN[1]; I2 <END[1]; I2+=STRIDE[1])              */
/*              for (I3 =BEGIN[2]; I3 <END[2]; I3+=STRIDE[2])             */
/*               for (I4 =BEGIN[3]; I4 <END[3]; I4+=STRIDE[3])            */
/*                 W[I1][I2][I3][I4].update();                            */
/*            break;                                                      */
/*        case FIVE_DIMENSION:                                            */
/*            W = G.SubCollection(pid);                                   */
/*            for (I1 =BEGIN[0]; I1 <END[0]; I1+=STRIDE[0])               */
/*             for (I2 =BEGIN[1]; I2 <END[1]; I2+=STRIDE[1])              */
/*              for (I3 =BEGIN[2]; I3 <END[2]; I3+=STRIDE[2])             */
/*               for (I4 =BEGIN[3]; I4 <END[3]; I4+=STRIDE[3])            */
/*                for (I5 =BEGIN[4]; I5 <END[4]; I5+=STRIDE[4])           */
/*                 W[I1][I2][I3][I4][I5].update();                        */
/*            break;                                                      */
/*        case SIX_DIMENSION:                                             */
/*            W = G.SubCollection(pid);                                   */
/*            for (I1 =BEGIN[0]; I1 <END[0]; I1+=STRIDE[0])               */
/*             for (I2 =BEGIN[1]; I2 <END[1]; I2+=STRIDE[1])              */
/*              for (I3 =BEGIN[2]; I3 <END[2]; I3+=STRIDE[2])             */
/*               for (I4 =BEGIN[3]; I4 <END[3]; I4+=STRIDE[3])            */
/*                for (I5 =BEGIN[4]; I5 <END[4]; I5+=STRIDE[4])           */
/*                 for (I6 =BEGIN[5]; I6 <END[5]; I6+=STRIDE[5])          */
/*                 W[I1][I2][I3][I4][I5][I6].update();                    */
/*            break;                                                      */
/*        case SEVEN_DIMENSION:                                           */
/*            W = G.SubCollection(pid);                                   */
/*            for (I1 =BEGIN[0]; I1 <END[0]; I1+=STRIDE[0])               */
/*             for (I2 =BEGIN[1]; I2 <END[1]; I2+=STRIDE[1])              */
/*              for (I3 =BEGIN[2]; I3 <END[2]; I3+=STRIDE[2])             */
/*               for (I4 =BEGIN[3]; I4 <END[3]; I4+=STRIDE[3])            */
/*                for (I5 =BEGIN[4]; I5 <END[4]; I5+=STRIDE[4])           */
/*                 for (I6 =BEGIN[5]; I6 <END[5]; I6+=STRIDE[5])          */
/*                  for (I7 =BEGIN[6]; I7 <END[6]; I7+=STRIDE[6])         */
/*                    W[I1][I2][I3][I4][I5][I6][I7].update();             */
/*             break;                                                     */
/*        default: err("not implemented yet")                             */
/*    }                                                                   */
/*  }                                                                     */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
PTR_BFND
trans_all_elements(pbf,collection_llnd)
PTR_BFND pbf;
PTR_LLND collection_llnd;
{
  PTR_SYMB symb[20],name[20],name2[20],object,symbol;
  PTR_LLND list,expr_list,pllnd,p1,p2,head_list;
  PTR_BFND var_bf1,root,switch_node,for_node,new_for_node,bf;
  int i,j,level,sw,dummy;
  PTR_TYPE type;
  PTR_SYMB s1,s2,dim_symb,collection_name,head_info_symb,pset_symb;
  char *s;
  char buf1[200];
  PTR_SYMB base,temp_symb;

  root=make_bfnd(fi,COLOOP_NODE,SMNULL,NULL,NULL,NULL);
  root->filename = pbf->filename;
  create_expression_space();
  scan_expr_for_dosubset(collection_llnd,SCAN_AND_RECORD);
  for (i=0; i<expression_counter;i++)
    {
       sprintf(buf1,"W%d",i);
       s= copys(buf1);
       subcollection_name[i] = make_symb(fi,VARIABLE_NAME,s);
       subcollection_name[i]->scope = root;
     }

  for(i=0;i< symb_storage_pool_top; i++)
    {
      temp_symb=  symb_storage_pool[ i ];
      j   = ((int)symb_storage_pool[ i ]->id_list)-1;
      type =follow_type_2(temp_symb->type, &level,&dummy);
      if (type->variant== T_DERIVED_COLLECTION) {
	subcollection_name[j]->attr=subcollection_name[j]->attr|SUBCOLLECTION;
	subcollection_name[j]->entry.var_decl.offset=
	  (int) type->entry.col_decl.collection_name;
	subcollection_name[j]->entry.var_decl.dovar =
	  (int) type->entry.col_decl.base_type;
      }
    }


  for (i=0; i<MAX_NESTED_DIM;i++)
    {
       sprintf(buf1,"X%d",i);
       s= copys(buf1);
       subfield_name[i]=  make_symb(fi,FIELD_NAME,s);
    }
  var_bf1=make_bfnd(fi,VAR_DECL,SMNULL,NULL,NULL,NULL);
  var_bf1->filename = pbf->filename;
  chain_up(root,var_bf1);
  name[0] =make_symb(fi,VARIABLE_NAME,"START");
  name[1] =make_symb(fi,VARIABLE_NAME,"END");
  name[2] =make_symb(fi,VARIABLE_NAME,"STRIDE");
  for (i=0; i<3; i++)
    name[i]->scope = root;
  s1=make_symb(fi,FUNCTION_NAME,ElementSchedulingString);
  s1->scope=global_bfnd;
  s2=make_symb(fi,VARIABLE_NAME,"Z_i");
  s2->scope = pbf->control_parent;
  collection_name = find_out_collection_object(collection_llnd);
  if (collection_name) {
    type = follow_type_2(collection_name->type,&level,&sw);
    base =type->entry.col_decl.collection_name;
    pset_symb =check_field_decl_3_varied(base,ProcSetFieldString,0,0);   
    p1=make_llnd(fi,VAR_REF,NULL,LLNULL,collection_name);
    p1->type = collection_name->type;
    p2=make_llnd(fi,VAR_REF,NULL,LLNULL,pset_symb);
    if (level) 
      pllnd =make_llnd(fi,POINTST_OP,p1,p2,NULL);
    else
      pllnd =make_llnd(fi,RECORD_REF,p1,p2,NULL);
    pllnd->type =pset_symb->type;
    p2=pllnd;
    p1=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
    pllnd =make_llnd(fi,ASSGN_OP,p1,pllnd,NULL);
    pllnd =make_llnd(fi,EXPR_LIST,pllnd,NULL,NULL);
  }
  else {
	for (bf=pbf; bf->variant !=FUNC_HEDR; bf=bf->control_parent);
	symbol=bf->entry.template.symbol;
	object =symbol->entry.member_func.base_name;
	pset_symb =check_field_decl_3_varied(object,ProcSetFieldString,0,0);
	if (!pset_symb) err("proc set field is not found in the kernel");
	p1=make_llnd(fi,VAR_REF,NULL,NULL,pset_symb);
	p1->type = pset_symb->type;
        p2=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
        pllnd =make_llnd(fi,ASSGN_OP,p2,p1,NULL);
        pllnd =make_llnd(fi,EXPR_LIST,pllnd,NULL,NULL);
  }
  root->entry.template.ll_ptr2 = pllnd;
  root->entry.template.symbol =make_symb(fi,VARIABLE_NAME,"$COLOOP");
  root->entry.template.symbol->scope = global_bfnd;
  root->entry.template.symbol->attr = PCPLUSPLUS_DOSUBSET;

  for (list=NULL,i=0;i<3;i++) 
    {
      name[i]->scope = root;
      /* we also needthings for  type */
      p1 = make_llnd(fi,INT_VAL,LLNULL,LLNULL,MAX_NESTED_DIM);	
      expr_list=make_llnd(fi,EXPR_LIST,p1,LLNULL,SMNULL);
      type =name[i]->type  = get_type(fi,T_ARRAY);
      type->entry.ar_decl.ranges =  expr_list;
      type->entry.ar_decl.base_type = global_int;
      pllnd =make_llnd(fi,ARRAY_REF,expr_list,LLNULL,name[i]);
      expr_list = make_llnd(fi,EXPR_LIST,pllnd,LLNULL,SMNULL);
      if (list) list->entry.template.ll_ptr2=expr_list;
      else head_list = expr_list;
      list = expr_list;
    }
  var_bf1->entry.template.ll_ptr1= head_list;

  var_bf1=make_bfnd(fi,VAR_DECL,SMNULL,NULL,NULL,NULL);
  var_bf1->filename = pbf->filename;
  chain_up(root,var_bf1);
  name2[0] =make_symb(fi,VARIABLE_NAME,"Z_begin");
  name2[1] =make_symb(fi,VARIABLE_NAME,"Z_end");
  name2[2] =make_symb(fi,VARIABLE_NAME,"Z_stride");
  for (list=NULL,i=0;i<3;i++) 
    {
      name2[i]->scope = root;
      /* we also needthings for  type */
      p1 = make_llnd(fi,INT_VAL,LLNULL,LLNULL,MAX_NESTED_DIM);	
      expr_list=make_llnd(fi,EXPR_LIST,p1,LLNULL,SMNULL);
      type =name2[i]->type  = get_type(fi,T_ARRAY);
      type->entry.ar_decl.ranges =  expr_list;
      type->entry.ar_decl.base_type = global_int;
      pllnd =make_llnd(fi,ARRAY_REF,expr_list,LLNULL,name2[i]);
      expr_list = make_llnd(fi,EXPR_LIST,pllnd,LLNULL,SMNULL);
      if (list) list->entry.template.ll_ptr2=expr_list;
      else head_list = expr_list;
      list = expr_list;
    }
  var_bf1->entry.template.ll_ptr1= head_list;


  var_bf1=make_bfnd(fi,VAR_DECL,SMNULL,NULL,NULL,NULL);
  var_bf1->filename = pbf->filename;
  chain_up(root,var_bf1);

  for (i=0; i<MAX_NESTED_DIM; i++)
    {
      char buff2[20];
      char *s3;

      sprintf(buff2,"I%d",i);
      s3 = copys(buff2);
      symb[i] =make_symb(fi,VARIABLE_NAME,s3);
      symb[i]->scope = root;
    }
  dim_symb=make_symb(fi,VARIABLE_NAME, "dimension");
  dim_symb->scope = root;
  for (list=NULL,i=0;i<(MAX_NESTED_DIM+1);i++) 
    {
      if (i  <MAX_NESTED_DIM) {
        symb[i]->scope = root;
        symb[i]->type  = global_int;
        /* we also needthings for  type */
        pllnd =make_llnd(fi,VAR_REF,NULL,LLNULL,symb[i]);
      }
      else {
        dim_symb->scope = root;
        dim_symb->type  = global_int;
        /* we also needthings for  type */
        pllnd =make_llnd(fi,VAR_REF,NULL,LLNULL,dim_symb);
      }
      expr_list = make_llnd(fi,EXPR_LIST,pllnd,LLNULL,SMNULL);
      if (list) list->entry.template.ll_ptr2=expr_list;
      else head_list = expr_list;
      list = expr_list;
    }
  var_bf1->entry.template.ll_ptr1= head_list;

  /* setup union temptag { ....} W...; */
  set_localcollection_var(root);

  index_processing(root, collection_llnd,&name2[0]);  
  /* setup sechedule(....) */
  var_bf1=make_bfnd(fi,EXPR_STMT_NODE,NULL,NULL,NULL,NULL);
  var_bf1->filename = pbf->filename;
  chain_up(root,var_bf1);

  for (list=NULL,i=8; i>=0; i--) {
    if (i<3) pllnd =make_llnd(fi,VAR_REF,NULL,NULL,name[2-i]);
    if ((i<6)&&(i>2)) pllnd =make_llnd(fi,VAR_REF,NULL,NULL,name2[2-(i-3)]);
    if (i==6) pllnd =make_llnd(fi,VAR_REF,NULL,NULL,s2);
    if (i==7) pllnd =make_llnd(fi,INT_VAL,NULL,NULL,all_elements_flag);
    if (i==8) {
      if (collection_name) {
	type = follow_type_2(collection_name->type,&level,&sw);
	base =type->entry.col_decl.collection_name;
	head_info_symb =check_field_decl_3_varied(base,HeadInfoString,0,0);   
	if (!head_info_symb)
	  err("head_info field is not found in the kernel");
	p1=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
	p1=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
	p1=make_llnd(fi,ARRAY_REF,p1,NULL,head_info_symb);
	pllnd =make_llnd(fi,VAR_REF,NULL,LLNULL,collection_name);
	pllnd->type = collection_name->type;
	if (level) 
	  pllnd =make_llnd(fi,POINTST_OP,pllnd,p1,NULL);
	else
	  pllnd =make_llnd(fi,RECORD_REF,pllnd,p1,NULL);
      }
      else {
	for (bf=pbf; bf->variant !=FUNC_HEDR; bf=bf->control_parent);
	symbol=bf->entry.template.symbol;
	object =symbol->entry.member_func.base_name;
	head_info_symb =check_field_decl_3_varied(object,HeadInfoString,0,0);
	if (!head_info_symb)
	  err("head_info field is not found in the kernel");
	p1=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
	p1=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
	pllnd=make_llnd(fi,ARRAY_REF,p1,NULL,head_info_symb);
      }
    }
    expr_list = make_llnd(fi,EXPR_LIST,pllnd,LLNULL,SMNULL);
    if (list) list->entry.template.ll_ptr2=expr_list;
    else head_list = expr_list;
    list = expr_list;
  }

  p2     = make_llnd(fi,FUNC_CALL,head_list,LLNULL,s1);
  p1     = make_llnd(fi,VAR_REF,LLNULL,LLNULL,dim_symb);
  pllnd  = make_llnd(fi,ASSGN_OP,p1,p2,SMNULL);
  expr_list = make_llnd(fi,EXPR_LIST,pllnd,LLNULL,SMNULL);
  var_bf1->entry.template.ll_ptr1 = expr_list;

  /* now the body of switch */
  p1     = make_llnd(fi,VAR_REF,LLNULL,LLNULL,dim_symb);
  expr_list = make_llnd(fi,EXPR_LIST,p1,LLNULL,SMNULL);
  switch_node =var_bf1=make_bfnd(fi,SWITCH_NODE,SMNULL,expr_list,NULL,NULL);
  var_bf1->filename = pbf->filename;
  chain_up(root,var_bf1);
  for (i=0 ; i < MAX_NESTED_DIM; i++) 
  {
    p1 = make_llnd(fi,INT_VAL,LLNULL,LLNULL,i+1);
    expr_list=make_llnd(fi,EXPR_LIST,p1,LLNULL,SMNULL);
    var_bf1=make_bfnd(fi,CASE_NODE,SMNULL,expr_list,NULL,NULL);
    var_bf1->filename = pbf->filename;
    chain_up(switch_node,var_bf1);  
    set_local_collection_llnd(pbf,switch_node,s2,i);
    /* now nested for loops */
    for (for_node = switch_node,j=0; j <=i ;j++)
    {
       new_for_node=make_bfnd(fi,FOR_NODE,SMNULL,NULL,NULL,NULL);
       new_for_node->filename = pbf->filename;
       chain_up(for_node,new_for_node);  
       p1  =make_llnd(fi,VAR_REF,NULL,LLNULL,symb[j]);
       expr_list =make_llnd(fi,INT_VAL,LLNULL,LLNULL,j);
       expr_list =make_llnd(fi,EXPR_LIST,expr_list,LLNULL,NULL);
       p2  =make_llnd(fi,ARRAY_REF,expr_list,LLNULL,name[0]);
       p2->type = global_int;
       p1 = make_llnd(fi,ASSGN_OP,p1,p2,SMNULL);
       expr_list=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
       new_for_node->entry.template.ll_ptr1 = expr_list;
       
       p1  =make_llnd(fi,VAR_REF,NULL,LLNULL,symb[j]);
       expr_list =make_llnd(fi,INT_VAL,LLNULL,LLNULL,j);
       expr_list =make_llnd(fi,EXPR_LIST,expr_list,LLNULL,NULL);
       p2  =make_llnd(fi,ARRAY_REF,expr_list,LLNULL,name[1]);
       p1 = make_llnd(fi,LE_OP,p1,p2,SMNULL);
       expr_list=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
       new_for_node->entry.template.ll_ptr2 = expr_list;

       expr_list =make_llnd(fi,INT_VAL,LLNULL,LLNULL,j);
       expr_list =make_llnd(fi,EXPR_LIST,expr_list,LLNULL,NULL);
       p2  =make_llnd(fi,ARRAY_REF,expr_list,LLNULL,name[2]);
       p1  =make_llnd(fi,VAR_REF,NULL,LLNULL,symb[j]);
       p2  =make_llnd(fi,ADD_OP,p1,p2,SMNULL);
       p1  =make_llnd(fi,VAR_REF,NULL,LLNULL,symb[j]);
       p1 = make_llnd(fi,ASSGN_OP,p1,p2,SMNULL);
       expr_list=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
       new_for_node->entry.template.ll_ptr3 = expr_list;

       if (j >= i) {
	 var_bf1=make_bfnd(fi,CONTROL_END,SMNULL,NULL,NULL,NULL);	 
	 var_bf1->filename = pbf->filename;
	 chain_up(for_node,var_bf1);
	 for_node = new_for_node;

	 var_bf1 = set_up_expr_body(pbf,symb,j);
	 chain_up(for_node,var_bf1);

	 var_bf1=make_bfnd(fi,CONTROL_END,SMNULL,NULL,NULL,NULL);	 
	 var_bf1->filename = pbf->filename;
	 chain_up(for_node,var_bf1);
       }
       else {
	 var_bf1=make_bfnd(fi,CONTROL_END,SMNULL,NULL,NULL,NULL);	 
	 var_bf1->filename = pbf->filename;
	 chain_up(for_node,var_bf1);
	 for_node = new_for_node;
       }
   }
   var_bf1=make_bfnd(fi,BREAK_NODE,SMNULL,NULL,NULL,NULL);
   var_bf1->filename = pbf->filename;
   chain_up(switch_node,var_bf1);  
}
  
  /* end of  the body of switch */
  var_bf1=make_bfnd(fi,CONTROL_END,SMNULL,NULL,NULL,NULL);
  var_bf1->filename = pbf->filename;
  chain_up(switch_node,var_bf1);
  var_bf1=make_bfnd(fi,CONTROL_END,SMNULL,NULL,NULL,NULL);
  var_bf1->filename = pbf->filename;
  chain_up(root,var_bf1);
  clean_collection_expression();
  return(root);
}



PTR_SYMB
find_out_collection_object(pllnd)
PTR_LLND pllnd;
{
  PTR_LLND p;
  PTR_SYMB s;
  p=scan_expr_for_dosubset(pllnd,SCAN_OBJECT);
  if (p->variant==FUNC_CALL) return(NULL);
  if (p->entry.template.ll_ptr1->variant==THIS_NODE) return(NULL);
  s = find_to_symb(p);
  return(s);
}


PTR_LLND
set_local_collection_llnd(pbf,switch_node,pid,index)
PTR_BFND pbf,switch_node;
PTR_SYMB pid;
int index;
{
  int i,j;
  PTR_SYMB name,symb,functor;
  PTR_BFND var_bf1;
  PTR_LLND p1,p2,p3,expr_list;
  PTR_TYPE type;
  int level,dummy;
  PTR_BFND bf;
  PTR_SYMB symbol,object;

  for(i=0;i< symb_storage_pool_top; i++)
    {
      symb=  symb_storage_pool[ i ];
      j   = (int ) symb->id_list;
      type =follow_type_2(symb->type, &level,&dummy);
      if (type->variant== T_DERIVED_COLLECTION) {
	var_bf1=make_bfnd(fi,EXPR_STMT_NODE,NULL,NULL,NULL,NULL);
	var_bf1->filename = pbf->filename;
	chain_up(switch_node,var_bf1);
	name = type->entry.col_decl.collection_name;
	functor =check_field_decl_3_varied(name,LocalCollectionString,0,0);   
	if (!functor) err("wrong kernel descriptions");
	p1  =make_llnd(fi,VAR_REF,NULL,LLNULL,pid);
	expr_list =make_llnd(fi,EXPR_LIST,p1,LLNULL,NULL);
	p2     = make_llnd(fi,FUNC_CALL,expr_list,LLNULL,functor);
	p1     = make_llnd(fi,VAR_REF,NULL,NULL,symb);
	p1->type = symb->type;
	if (level)  p1  = make_llnd(fi,POINTST_OP,p1,p2,NULL);
	else        p1  = make_llnd(fi,RECORD_REF,p1,p2,NULL);
	p1  = make_llnd(fi,CAST_OP,p1,NULL,NULL);
        p1->type = subfield_name[index]->type;
	p2 = make_llnd(fi,VAR_REF,NULL,NULL, subcollection_name[j-1]);
	p3 = make_llnd(fi,VAR_REF,NULL,NULL, subfield_name[index]);
	p2 = make_llnd(fi,RECORD_REF,p2,p3,NULL);
	p1 = make_llnd(fi,ASSGN_OP,p2,p1,NULL);
	expr_list= make_llnd(fi,EXPR_LIST,p1,NULL,NULL);
	var_bf1->entry.template.ll_ptr1 = expr_list;
      }
    }
  if (dosubset_node) {
      var_bf1=make_bfnd(fi,EXPR_STMT_NODE,NULL,NULL,NULL,NULL);
      var_bf1->filename = pbf->filename;
      chain_up(switch_node,var_bf1);
      for (bf=pbf; bf->variant !=FUNC_HEDR; bf=bf->control_parent);
      symbol=bf->entry.template.symbol;
      object =symbol->entry.member_func.base_name;
      functor =check_field_decl_3_varied(object,LocalCollectionString,0,0);
      if (!functor) err("wrong kernel descriptions");
      p1  =make_llnd(fi,VAR_REF,NULL,LLNULL,pid);
      expr_list =make_llnd(fi,EXPR_LIST,p1,LLNULL,NULL);
      p2     = make_llnd(fi,FUNC_CALL,expr_list,LLNULL,functor);
      p2->type = functor->type;
      p1  = make_llnd(fi,CAST_OP,p2,NULL,NULL);
      p1->type = subfield_name[index]->type;
      p2=make_llnd(fi,VAR_REF,NULL,NULL,subcollection_name[dosubset_node-1]);
      p3 = make_llnd(fi,VAR_REF,NULL,NULL, subfield_name[index]);
      p2 = make_llnd(fi,RECORD_REF,p2,p3,NULL);
      p1 = make_llnd(fi,ASSGN_OP,p2,p1,NULL);
      expr_list= make_llnd(fi,EXPR_LIST,p1,NULL,NULL);
      var_bf1->entry.template.ll_ptr1 = expr_list;
    }


}



PTR_BFND
set_up_expr_body(pbf,index_array,nested_index)
PTR_BFND pbf;
PTR_SYMB *index_array;
{
  PTR_LLND p;
  PTR_BFND bf;
  p=substitute_expr_for_dosubset(pbf->entry.template.ll_ptr1,SCAN_FOR_SUBSTITUTE,index_array,nested_index);
  bf=make_bfnd(fi,pbf->variant,pbf->entry.template.symbol,p,NULL,NULL);
  bf->filename = pbf->filename;
  return(bf);
}



/*
   union  Z_local_var {
      float *X1;       
      float **X2;       
      float ***x3;
      float ****x4;
      ....
   } W0, W1, W2,....;
*/
set_localcollection_var(root)
PTR_BFND root;
{
  PTR_TYPE     base_type[MAX_TEMP_SPACE];
  int          base_type_bit[MAX_TEMP_SPACE];
  int i,j,k;
  PTR_LLND p,p1,list,head_list,list1,expr_list;
  PTR_SYMB field,old_field,w,symb,name;
  PTR_TYPE type,union_type,one_type;
  PTR_BFND var_decl,bf1;
  int dummy,level;
  PTR_SYMB tag_name;

  for(i=0;i< MAX_TEMP_SPACE; i++) {
    base_type[i]=0;
    base_type_bit[i]=0;
  }
  for(i=0;i<= symb_storage_pool_top; i++)
    {
      if (i< symb_storage_pool_top) {
	symb=  symb_storage_pool[ i ];
	type =follow_type_2(symb->type, &level,&dummy);
	if (type->variant== T_DERIVED_COLLECTION) {
	  name = type->entry.col_decl.collection_name;
	  if (i <MAX_TEMP_SPACE) {
	    base_type[i] = type->entry.col_decl.base_type;
	    base_type_bit[i] = 0;
	  }
	  else err("extra buffer space needed");
	}
      }
      else {
        if (dosubset_node) {
	  if (i <MAX_TEMP_SPACE) {
	    base_type[i] = global_elementtype;
	    base_type_bit[i] = 0;
	  }
	  else err("extra buffer space needed");
	}
	else {
	    base_type[i] = 0;
	    base_type_bit[i] = 1;
	  }
      }
    }

  for(i=0;i<= symb_storage_pool_top; i++ )
    {
      char buf1[200];
      char *s;

      if (base_type_bit[i])  continue;
      bf1=make_bfnd(fi,UNION_DECL,SMNULL,NULL,NULL,NULL);
      bf1->filename = root->filename;
      chain_up(root,bf1);
      sprintf(buf1,"TempTag%d",i);
      s= copys(buf1);
      tag_name=  make_symb(fi,UNION_NAME,s);      
      tag_name->scope = root;
      tag_name->type =union_type= get_type(fi,T_UNION);
      union_type->entry.derived_class.original_class = bf1;
      bf1->entry.template.symbol = tag_name;    
      for (list=NULL,k=i; k <=symb_storage_pool_top; k++)
        {
	  if (!base_type[k]) continue;
          if ((base_type[k]==base_type[i])||
	      is_same_entry(base_type[k],base_type[i]))
	    {
	      base_type_bit[k] = 1;
	      if (k<symb_storage_pool_top)
		w=subcollection_name[((int)symb_storage_pool[ k ]->id_list)-1];
	      else if (dosubset_node)
		w=subcollection_name[dosubset_node-1];
	      else  continue;

	      w->type = union_type;
	      p1 =make_llnd(fi,VAR_REF,LLNULL,LLNULL,w);
	      expr_list=make_llnd(fi,EXPR_LIST,p1,LLNULL,SMNULL);
	      if (list) list->entry.template.ll_ptr2=expr_list;
	      else head_list = expr_list;
	      list = expr_list;
	  }
	}
      bf1->entry.template.ll_ptr1 = head_list;      
      for (old_field=NULL,j=0; j <MAX_NESTED_DIM; j++)
	{
          field =subfield_name[j];
	  field->scope = bf1;
          if (!old_field) union_type->entry.derived_class.first=field;
          else old_field->entry.field.next = field;
	  if (growing_flag) {
	    for (type = base_type[i],k=0;k<=(j+1) ; k++)
	      {  one_type= get_type(fi,T_POINTER);
		 one_type->entry.template.base_type=type;
		 type = one_type;
	       }
	  }
	  else {
	    for (type = base_type[i],k=0;k<=j ; k++)
	      {  one_type= get_type(fi,T_POINTER);
		 one_type->entry.template.base_type=type;
		 type = one_type;
	       }
	  }
          field->type= type;
          p=make_llnd(fi,VAR_REF,NULL,LLNULL,field);
	  if (growing_flag) {
	    for (k=0;k<=(j+1) ; k++)
	      p=make_llnd(fi,DEREF_OP,p,LLNULL,NULL);
	  }
	  else {
	    for (k=0;k<=j ; k++)
	      p=make_llnd(fi,DEREF_OP,p,LLNULL,NULL);
	  }
          p->type = field->type;
          expr_list=make_llnd(fi,EXPR_LIST,p,LLNULL,SMNULL);
          var_decl=make_bfnd(fi,VAR_DECL,SMNULL,expr_list,NULL,NULL);
	  var_decl->filename = root->filename;
          chain_up(bf1,var_decl);
          old_field= field;
       }
    }

}





/*************************************************************************/
/* Scan and transform all DoSubset operators and ForAllElements          */
/* expressions                                                           */
/*************************************************************************/
transform_all_dosubset(pbf,pblob,sw)
PTR_BFND pbf;     
PTR_BLOB pblob;
{
  PTR_BLOB blob;
  PTR_BFND fbf;

  if (!pbf) return;
  if (pbf->variant == CONTROL_END) return;
  for(blob = pbf->entry.template.bl_ptr1;blob; blob=blob->next)
    transform_all_dosubset(blob->ref,blob,sw);
  for(blob = pbf->entry.template.bl_ptr2;blob; blob=blob->next)
    transform_all_dosubset(blob->ref,blob,sw);
  switch (pbf->variant) {
  case IF_NODE    :
    transform_if_header(pbf,sw);
    break;
  case FOR_NODE   :
    transform_for_header(pbf,sw);
    break;
  case WHILE_NODE :
    transform_while_header(pbf,sw);
    break;
  case RETURN_STAT:
  case RETURN_NODE  :             /* New added for VPC */
    transform_return_header(pbf,sw);
    break;
  case DO_WHILE_NODE:             /* New added for VPC */
    transform_do_while_header(pbf,sw);
    break;
  case SWITCH_NODE :              /* New added for VPC */
    transform_switch_header(pbf,sw);
    break ;
  case COLOOP_NODE  :             /* New added for VPC */
    break;
  case COEXEC_NODE  :             /* New added for VPC */
    break;
  case EXPR_STMT_NODE:
    if (sw==DOSUBSET_TRANSFORM) {
      if (scan_expr_for_dosubset(pbf->entry.template.ll_ptr1,SCAN_ONLY))  {
	fbf=pblob->ref =trans_exprnode_dosubset(pbf,pbf->entry.template.ll_ptr1);
	fbf->control_parent = pbf->control_parent;
      }
    }
    else {
      if (scan_expr_for_doall(pbf->entry.template.ll_ptr1,SCAN_ONLY))
	trans_exprnode_doall(pbf,pbf->entry.template.ll_ptr1);
      }
    break;
  default:
    break;
  }
}










transform_if_header(pbf,sw)
PTR_BFND pbf;
{}

transform_for_header(pbf,sw)
PTR_BFND pbf;
{}


transform_while_header(pbf,sw)
PTR_BFND pbf;
{}

transform_return_header(pbf,sw)
PTR_BFND pbf;
{}

transform_do_while_header(pbf,sw)
PTR_BFND pbf;
{}

transform_switch_header(pbf,sw)
PTR_BFND pbf;
{}




PTR_BFND
trans_exprnode_dosubset(pbf,pllnd)
PTR_BFND pbf;
PTR_LLND pllnd;
{
  PTR_BFND p;

  p =trans_all_elements(pbf,pllnd);
  return(p);


}



/**************************************************************************/
/* Programs transformation of low level node of Collection-Oriented       */
/* operation                                                              */
/*                                                                        */
/* IF (sw ==SCAN_ONLY)  {                                                 */
/*   Scan the expression only to see if the expression is                 */
/*   colllection-parallel expression.  With the assumption that           */
/*   if any sub-expression of an expression  is collection-parallelism    */
/*   operation, then the whole expression is  collection-parallelism      */
/*   operation.                                                           */
/*                                                                        */
/*   return NULL if it is not                                             */
/*   Otherwise return the left-most expressions of the whole expression   */
/*             which is explicitly collection-parallel expression         */
/*                                                                        */
/*                                                                        */
/*     (1) Given a Collection-expression                                  */
/*     (2) The number of different collection expressions are stored      */
/*         in                                                             */
/*     (3) Each collection-expression is associated with an index         */
/* IF (sw== SCAN_AND_RECORD) {                                            */
/*                                                                        */
/*     (1) Given a Collection-expression                                  */
/*     (2) The number of different collection expressions are stored      */
/*         in                                                             */
/*     (3) Each collection-expression is associated with an index         */
/* }                                                                      */
/* IF sw== SCAN_FOR_SUBSTITUTE {                                          */
/*   Assume that the all the transformationsare done, so we can transform */
/*   the old expression by destructing it and modified it. The information*/
/*   is already recorded in the previous time                             */
/* }                                                                      */
/* IF sw== SCAN_DOSUBSET_INDEX {                                          */
/*   Only for DoSubset[this_index_set]                                    */
/*   Return  [this_index_set] llnd                                        */
/*   (return NULL if it is not dosubset node                              */
/* }                                                                      */
/* IF sw== SCAN_OBJECT {                                                  */
/*    4 cases: (G->update, G->DoSubSet(), DOsubSet, or this->DoSubSet()   */
/*    Return  G in case 1,2                                               */
/*    return NULL in case 3,4                                             */
/* }                                                                      */
/**************************************************************************/
PTR_LLND
scan_expr_for_dosubset(pllnd,sw)
PTR_LLND pllnd;
{
  PTR_SYMB symbol,symb,name;
  PTR_TYPE type;
  PTR_LLND p;
  int level,dummy;
  int flag;

  flag =0;
  if (!pllnd) return(NULL);
  switch (pllnd->variant) {
  case VAR_REF:
  case ARRAY_REF:
    break;
  case RECORD_REF:
  case POINTST_OP:
    symbol = pllnd->entry.template.ll_ptr2->entry.template.symbol;
    if (!symbol) break;
    type =follow_type_2(pllnd->entry.template.ll_ptr1->type, &level,&dummy);
    if (type&&(type->variant== T_DERIVED_COLLECTION)) {
      name = type->entry.col_decl.collection_name;
      symb =check_field_decl_3_varied(name,symbol->ident,0,0);
      p=pllnd->entry.template.ll_ptr2;
      if ((p->variant==FUNC_CALL)&&	  
	  ((!strcmp(p->entry.template.symbol->ident,"DoSubSet"))||
	   (!strcmp(p->entry.template.symbol->ident,"DOSUBSET"))))
	flag =1;
      else flag =0;
      if ((!symb)||flag)
	{
	  switch (sw) {
	  case SCAN_ONLY:
	    return(pllnd->entry.template.ll_ptr1);
	  case SCAN_DOSUBSET_INDEX:
	    if (flag==1) 
	      return(p->entry.template.ll_ptr1->entry.template.ll_ptr1);
	    return(NULL);
	  case SCAN_OBJECT:
	    return(pllnd);
	    break;
	  case SCAN_AND_RECORD:
	    symb= find_to_symb(pllnd);
	    if (flag==0) {
	      all_elements_flag= ALL_ELEMENTS;
	      push_collection_expression(symb,flag);
	      scan_expr_for_dosubset(pllnd->entry.template.ll_ptr2,sw);
              register_elementwise_collect(pllnd->entry.template.ll_ptr2,1);
	      return(pllnd);
	    }
	    else {
	      all_elements_flag= SUBSETS;
	      push_collection_expression(symb,flag);
              register_elementwise_collect(p,2);
	      return(pllnd);
	    }

	  }
	}
    }
    else {
      if (p=scan_expr_for_dosubset(pllnd->entry.template.ll_ptr1,sw))
	return(p);
    }
    break;
  case FUNCTION_OP:
    break;
  case FUNC_CALL:
    if ((!strcmp(pllnd->entry.template.symbol->ident,"DoSubSet"))||
	(!strcmp(pllnd->entry.template.symbol->ident,"DOSUBSET")))
      {
	  switch (sw) {
	  case SCAN_ONLY:
           return(pllnd);
	  case SCAN_DOSUBSET_INDEX:
	   return(pllnd->entry.template.ll_ptr1->entry.template.ll_ptr1);
	 case SCAN_OBJECT:
	   return(pllnd);
	  case SCAN_AND_RECORD:
	   all_elements_flag= SUBSETS;
	   push_collection_expression(symb,2);
	   scan_expr_for_dosubset(pllnd->entry.template.ll_ptr1,sw);
	   register_elementwise_collect(pllnd,2);
	   return(pllnd);
	 }
      }
    else {
      if (p=scan_expr_for_dosubset(pllnd->entry.template.ll_ptr1,sw))
	return(p);
    }
    break;
    default:
      if ((sw== SCAN_ONLY)||(sw==SCAN_DOSUBSET_INDEX)||(sw==SCAN_OBJECT)) {
	if (pllnd->variant== ASSGN_OP) {
	  if (p=scan_expr_for_dosubset(pllnd->entry.template.ll_ptr2,sw))
	    return(p);
	  if (p=scan_expr_for_dosubset(pllnd->entry.template.ll_ptr1,sw))
	    return(p);
	}
	else {
	  if (p=scan_expr_for_dosubset(pllnd->entry.template.ll_ptr1,sw))
	    return(p);
	  if (p=scan_expr_for_dosubset(pllnd->entry.template.ll_ptr2,sw))
	    return(p);
	}
      }
    else {
      scan_expr_for_dosubset(pllnd->entry.template.ll_ptr1,sw);
      scan_expr_for_dosubset(pllnd->entry.template.ll_ptr2,sw);
      return(pllnd);
    }
  }
  return(NULL);
}


PTR_LLND
substitute_expr_for_dosubset(pllnd,sw,index_array,nested_index)
PTR_LLND pllnd;
PTR_SYMB *index_array;
{
  PTR_SYMB symbol,symb,name,functor;
  PTR_TYPE type;
  PTR_LLND p,p1,p2,list,list1,q1;
  int level,dummy;
  int flag;

  flag =0;
  if (!pllnd) return(NULL);
  switch (pllnd->variant) {
  case RECORD_REF:
  case POINTST_OP:
    symbol = pllnd->entry.template.ll_ptr2->entry.template.symbol;
    if (!symbol) break;
    type =follow_type_2(pllnd->entry.template.ll_ptr1->type, &level,&dummy);
    if (type->variant== T_DERIVED_COLLECTION) {
      name = type->entry.col_decl.collection_name;
      symb =check_field_decl_3_varied(name,symbol->ident,0,0);
      p=pllnd->entry.template.ll_ptr2;
      if ((p->variant==FUNC_CALL)&&	  
	  ((!strcmp(p->entry.template.symbol->ident,"DoSubSet"))||
	   (!strcmp(p->entry.template.symbol->ident,"DOSUBSET"))))
	flag =1;
      else flag =0;
      if ((!symb)|| flag)
	{
	  symb= find_to_symb(pllnd);
	  if (flag ==0) {
	    p1=make_new_collection_expr(symb,NULL,flag,index_array,nested_index);
	    p2=substitute_expr_for_dosubset(pllnd->entry.template.ll_ptr2,sw,index_array,nested_index);
	    q1=make_llnd(fi,RECORD_REF,p1,p2,NULL);
	    substitute_registered_collect(q1->entry.template.ll_ptr2,index_array,nested_index);
	    return(q1);
	  }
	  else {
	    p1=make_new_collection_expr(symb,NULL,flag,index_array,nested_index);
	    list=p->entry.template.ll_ptr1;
	    list1= list->entry.template.ll_ptr2;
	    functor= find_to_functor(list1->entry.template.ll_ptr1);
	    list= copy_ll_node(list1->entry.template.ll_ptr2);
	    p2=make_llnd(fi,FUNC_CALL,list,NULL,functor);
	    substitute_registered_collect(p2,index_array,nested_index);
	    return(make_llnd(fi,RECORD_REF,p1,p2,NULL));
	  }
	  break;
	}
    }
    break;
  case FUNCTION_OP:
    break;
  case FUNC_CALL:
    if ((!strcmp(pllnd->entry.template.symbol->ident,"DoSubSet"))||
	(!strcmp(pllnd->entry.template.symbol->ident,"DOSUBSET")))
      {
	p1=make_new_collection_expr(NULL,pllnd->entry.template.ll_ptr1,2,index_array,nested_index);
	list=pllnd->entry.template.ll_ptr1;
	list1= list->entry.template.ll_ptr2;
	functor= list1->entry.template.ll_ptr1->entry.template.symbol;
	list= copy_ll_node(list1->entry.template.ll_ptr2);
	p2=make_llnd(fi,FUNC_CALL,list,NULL,functor);
	substitute_registered_collect(p2,index_array,nested_index);
	return(make_llnd(fi,RECORD_REF,p1,p2,NULL));
      } 
    break;
  }

  p1=substitute_expr_for_dosubset(pllnd->entry.template.ll_ptr1,sw,index_array,nested_index);
  p2=substitute_expr_for_dosubset(pllnd->entry.template.ll_ptr2,sw,index_array,nested_index);
  return(make_llnd(fi,pllnd->variant,p1,p2,pllnd->entry.template.symbol));

}



/*
 Handle the cases of 
          G.foo(a, &B); or G.foo(a, B)
  We need to transform it for every element e of G and e' of B

         e.foo(a,e');   or G.foo(a,e);
  (1) register_elementwise_collect(pllnd) will only record it 
  (2) substitute_registered_collect(pllnd)   will substitute the expression
  (3) sw==1 then    G.foo(a, &B);  (pllnd == foo(a,&B))
      sw==2 then    G.DoSubSet([1:20:2],G.foo,a,&B); (pllnd==Dosubset(....))
*/
register_elementwise_collect(pllnd,sw)
PTR_LLND pllnd;
{
  PTR_SYMB functor,symbol,s;
  PTR_TYPE type,type1;
  PTR_LLND arglist,p,expr_list;
  int      level,sw2;
  PTR_LLND e_list,functor_llnd;

  if (!pllnd) return;
  if (pllnd->variant!=FUNC_CALL) return;
  switch (sw) {
  case 1:
    functor = pllnd->entry.template.symbol;
    arglist = pllnd->entry.template.ll_ptr1;
    s=functor->entry.member_func.in_list;
    break;
  case 2:
    e_list = pllnd->entry.template.ll_ptr1->entry.template.ll_ptr2;
    arglist= e_list->entry.template.ll_ptr2;
    functor_llnd = e_list->entry.template.ll_ptr1;
    functor = find_to_functor(functor_llnd);
    if (!functor) return;
    s=functor->entry.member_func.in_list;    
  }

  for (expr_list=arglist;expr_list;expr_list=expr_list->entry.template.ll_ptr2)
    {
      p =expr_list->entry.template.ll_ptr1;
      if (p->variant==ADDRESS_OP) {
	p = p->entry.template.ll_ptr1;
	if (p->variant==VAR_REF) {
	  symbol = p->entry.template.symbol;
	  type=follow_type_2(symbol->type,&level,&sw2);
	  if (type&&(type->variant== T_DERIVED_COLLECTION))
	    {
	      type1=follow_type_2(s->type,&level,&sw2);
	      if (!(type1&&(type1->variant== T_DERIVED_COLLECTION)))
		push_collection_expression(symbol,1);
	    }
	}
      }
      else     {
	/* if we have call-by-reference or call-by-value 
	   then &Address_op is not necessary, we only need G not &G  */
	if (p->variant==VAR_REF) {
	  symbol = p->entry.template.symbol;
	  type=follow_type_2(symbol->type,&level,&sw2);
	  if (type&&(type->variant== T_DERIVED_COLLECTION))
	    {
	      type1=follow_type_2(s->type,&level,&sw2);
	      if (!(type1&&(type1->variant== T_DERIVED_COLLECTION)))
		push_collection_expression(symbol,1);
	    }
	}
      }
    
      if (s) s=s->entry.var_decl.next_in;
      if (!s) break;
    }

}


substitute_registered_collect(pllnd,index_array,nested_index)
PTR_LLND pllnd;
PTR_SYMB *index_array;
int      nested_index;
{
  PTR_SYMB functor,symbol,s;
  PTR_TYPE type,type1, new_type;
  PTR_LLND arglist,p,expr_list,p1,address_llnd;
  int      level,sw2,level1;
  
  if (!pllnd) return;
  if (pllnd->variant!=FUNC_CALL) return;
  functor = pllnd->entry.template.symbol;
  arglist = pllnd->entry.template.ll_ptr1;
  s=functor->entry.member_func.in_list;
  for (expr_list=arglist;expr_list;expr_list=expr_list->entry.template.ll_ptr2)
    {
      p =expr_list->entry.template.ll_ptr1;
      if (p->variant==ADDRESS_OP) {
	address_llnd=p;
	p= p->entry.template.ll_ptr1;
	if (p->variant==VAR_REF) {
	  symbol = p->entry.template.symbol;
	  type=follow_type_2(symbol->type,&level,&sw2);
	  if (type&&(type->variant== T_DERIVED_COLLECTION))
	    {
	      type1=follow_type_2(s->type,&level,&sw2);
	      if (!(type1&&(type1->variant== T_DERIVED_COLLECTION))){
	        p1=make_new_collection_expr(symbol,NULL,0,index_array,nested_index);
	        address_llnd->entry.template.ll_ptr1= p1; 
	      }
	    }
	}
      }
      else {
	/* if we have call-by-reference then &Address_op is not necessary */
	address_llnd=expr_list;
	if (p->variant==VAR_REF) {
	  symbol = p->entry.template.symbol;
	  type=follow_type_2(symbol->type,&level,&sw2);
	  if (type&&(type->variant== T_DERIVED_COLLECTION))
	    {
	      type1=follow_type_2(s->type,&level1,&sw2);
	      if (!(type1&&(type1->variant== T_DERIVED_COLLECTION))){
	        p1=make_new_collection_expr(symbol,NULL,0,index_array,nested_index);
		if (level ==1) {
		  new_type = get_type(fi,T_POINTER);
		  if (p1->type) new_type->entry.template.base_type=p1->type;
		  p1=make_llnd(fi,ADDRESS_OP,p1,NULL,NULL);		
		  p1->type = new_type;
		}
		address_llnd->entry.template.ll_ptr1= p1; 
	      }
	    }
	}
      }
      if (s) s=s->entry.var_decl.next_in;
      if (!s) break;
    }

}


/*
  Argument_list:
  symb:  G in G->update();
  pllnd: argument_list in DoSubset(argument_list....);
  flag:  0, 1, 2
     flag==0: 
       symb == G in G->method  ===>
                    W[...]->update();
                    ^^^^^^ only this part
     flag==1:
       symb == G in G.DOSUBSET([index],foo, arg1,..)==>
                    W[..].foo(arg1,arg2....);
                    ^^^^^^ only this part
     flag==2:
       symb == NULL in  DOSUBSET(...), Please refer to dosubset_node
                    W[..].foo(arg1,arg2....);
                    ^^^^^^ only this part 

  index_array: refers to the array of symb[] of nested loop index
  nested_index: number of loops nested
*/
PTR_LLND
make_new_collection_expr(symb,pllnd,flag,index_array,nested_index)
PTR_SYMB symb;
PTR_SYMB *index_array;
PTR_LLND pllnd;
int      flag,nested_index;
{
  PTR_LLND list,head_list,p1,expr_list,new_node;
  PTR_SYMB w;
  int i;   
  PTR_LLND new_node1,new_node2;
  PTR_TYPE type;

  switch (flag ) {
  case 0:
  case 1:
     if (symb) w = subcollection_name[((int) symb->id_list)-1];
     else      w = subcollection_name[((int) dosubset_node) -1];
    break;
  case 2:
    w = subcollection_name[((int) dosubset_node) -1];
    break;
  }
    new_node1 =make_llnd(fi,VAR_REF,NULL,NULL,w);
    new_node2=make_llnd(fi,ARRAY_REF,NULL,LLNULL,subfield_name[nested_index]);
    for (list=NULL,i=0;i<=nested_index;i++) 
    {
      p1 =make_llnd(fi,VAR_REF,LLNULL,LLNULL,*(index_array+i));
      expr_list=make_llnd(fi,EXPR_LIST,p1,LLNULL,SMNULL);
      if (list) list->entry.template.ll_ptr2=expr_list;
      else head_list = expr_list;
      list = expr_list;
    }
    new_node2->entry.template.ll_ptr1 = head_list;
    new_node =make_llnd(fi,RECORD_REF,new_node1,new_node2,NULL);
    type =subfield_name[0]->type;
    if (growing_flag) {
      new_node->type =  type;      
      new_node =make_llnd(fi,DEREF_OP,new_node,NULL,NULL);
      if (type->variant==T_POINTER) type=type->entry.template.base_type;
      new_node->type =  type;      
    }
    else  {
      if (type->variant==T_POINTER) type=type->entry.template.base_type;
      new_node->type =  type;
    }
    return(new_node);
}



/* Used Place :
 *      Primary :- Object  :: identifier
 *
 * <1> given two nodes
 *  object:  class object {...} of  the current LHS object-type is declared
 *  entry: stands for the new field hash_entry
 *
 * <3> sw :   dummy flags
 * <4> range: dummy flag
 *   
 */
PTR_SYMB
check_field_decl_3_varied(object,ident,sw,range)
PTR_SYMB object;
char *ident;
int sw ;
int range;
{
  
   PTR_SYMB first,object2,typesymb,base_name;
   PTR_BLOB blob;
   PTR_LLND ll,expr_list,list,list1;   
   PTR_BFND pbf;
   int status;

   pbf  = find_class_bfnd(object);
   blob = pbf->entry.template.bl_ptr1;
   ll=(PTR_LLND) NULL;
   for(blob = pbf->entry.template.bl_ptr1;blob; blob=blob->next)
     {
       ll=(PTR_LLND)find_suit_declarator(blob->ref->entry.template.ll_ptr1); 
       if (ll) break;
     }
   if (!ll) return(SMNULL);
   first = ll->entry.template.symbol;
   for (; first  ;  )
     { 
       if ((!strcmp(first->ident,ident)) &&
	   (!(first->attr & ELEMENT_FIELD)))
	 return(first);
       else
	 {
	   if (first->variant == FIELD_NAME)
	     first = first->entry.field.next;
	   else
	     first = first->entry.member_func.next;
	 }
     }
     if (expr_list =pbf->entry.template.ll_ptr2) {
       for ( list = expr_list; list; list =list->entry.template.ll_ptr2)
	 {
	   list1 = follow_llnd(list,1);
	   object2= list1->entry.template.symbol;
/*	   object2 = find_object_symbol(typesymb->parent); */
	   if (first =check_field_decl_3_varied(object2,ident,0,range))
	     return(first);
	 }
     }
  return(SMNULL);
 }


PTR_SYMB
find_to_symb(pllnd)
PTR_LLND pllnd;
{
  PTR_LLND p;

   p=follow_llnd(pllnd,1);
   return(p->entry.template.symbol);

}



PTR_SYMB
find_to_left_symb(pllnd)
PTR_LLND pllnd;
{
  PTR_LLND p;

   for (p=pllnd; p; p=p->entry.template.ll_ptr1)
     { 
      if ((p->variant==VAR_REF)||(p->variant==FUNC_CALL) ||
          (p->variant==ARRAY_REF)||(p->variant==FUNCTION_REF))
        return(p->entry.template.symbol);
    }
   return(NULL);

}




/*
   Gvien a expression :  G.foo() or G.foo or foo
   return   foo

*/

PTR_SYMB
find_to_functor(p)
PTR_LLND p;
{
PTR_LLND pllnd;

  for (pllnd=p; pllnd; )
    {
      if (pllnd->variant==VAR_REF) return(pllnd->entry.template.symbol);
      if (pllnd->variant==FUNCTION_REF)  return(pllnd->entry.template.symbol);
      if (pllnd->variant==FUNC_CALL)     return(pllnd->entry.template.symbol);
      if ((pllnd->variant==RECORD_REF)||(pllnd->variant==POINTST_OP))
	pllnd = pllnd->entry.template.ll_ptr2;
      else
	pllnd= pllnd->entry.template.ll_ptr1;
    }

return(NULL);
}







PTR_SYMB
follow_class_field(old_object,new_object,old_field)
PTR_SYMB old_object,new_object,old_field;
{
  
   PTR_SYMB old_first,new_first,first;
   PTR_BLOB blob;
   PTR_LLND list,list1;
   PTR_LLND old_list,old_list1;
   PTR_LLND new_list,new_list1;
   PTR_BFND old_pbf,new_pbf,pbf;
   PTR_LLND ll;
   PTR_SYMB old_object2,new_object2;


   pbf=old_pbf  = find_class_bfnd(old_object);
   blob = pbf->entry.template.bl_ptr1;
   ll=(PTR_LLND) NULL;
   for(blob = pbf->entry.template.bl_ptr1;blob; blob=blob->next)
     {
       ll=(PTR_LLND)find_suit_declarator(blob->ref->entry.template.ll_ptr1); 
       if (ll) break;
     }
   if (!ll) return(SMNULL);
   old_first = ll->entry.template.symbol;

   new_pbf=pbf  = find_class_bfnd(new_object);
   blob = pbf->entry.template.bl_ptr1;
   ll=(PTR_LLND) NULL;
   for(blob = pbf->entry.template.bl_ptr1;blob; blob=blob->next)
     {
       ll=(PTR_LLND)find_suit_declarator(blob->ref->entry.template.ll_ptr1); 
       if (ll) break;
     }
   if (!ll) return(SMNULL);
   new_first = ll->entry.template.symbol;


   for (; old_first&&new_first  ;  )
     { 
       if (old_first==old_field) return(new_first);
       else
	 {
	   if (old_first->variant == FIELD_NAME)
	     old_first = old_first->entry.field.next;
	   else
	     old_first = old_first->entry.member_func.next;

	   if (new_first->variant == FIELD_NAME)
	     new_first = new_first->entry.field.next;
	   else
	     new_first = new_first->entry.member_func.next;
	 }
     }

   if (old_pbf->entry.template.ll_ptr2) {
     old_list =old_pbf->entry.template.ll_ptr2;
     new_list =new_pbf->entry.template.ll_ptr2;
     for ( ;old_list;  )
       {
	 old_list1 = follow_llnd(old_list,1);
	 new_list1 = follow_llnd(new_list,1);
	 old_object2= old_list1->entry.template.symbol;
	 new_object2= new_list1->entry.template.symbol;
	 if (first =follow_class_field(old_object2,new_object2,old_field))
	     return(first);
	 old_list=old_list->entry.template.ll_ptr2;
	 new_list=new_list->entry.template.ll_ptr2;
       }
   }
  return(SMNULL);
 }



/**************************************************************************/
/* push_collection_expression()                                           */
/* (1) Store all object instances of the Collection-Oriented expression   */
/* (2) Store all pointers of object instances in the Collection-Oriented  */
/*     expression                                                         */
/**************************************************************************/
push_collection_expression(symb,flag)
PTR_SYMB symb;
{
  if ((!symb) ||(flag==2)) {
    if (dosubset_node) return;
    else dosubset_node = expression_counter++;
    return;
  }
  if (symb->id_list) return;
  push_new_symbol(symb);
  symb->id_list = (PTR_SYMB) expression_counter;
  expression_counter++;
}


create_expression_space()
{
  symb_storage_pool_top=0;
  dosubset_node =0;
  expression_counter=1;
  symb_storage_pool=(PTR_SYMB *) calloc(1,sizeof(char *)*fi->num_symbs);
}  


clean_collection_expression()
{

  expression_counter=0;
  dosubset_node =0;
  clean_push_symbol();
  symb_storage_pool_top=0;
  free(symb_storage_pool);
  symb_storage_pool= NULL;
}


/*************************************************************************/
/* Init the index set of DoSubSet into three subarrays                   */
/* begin[MAX_NESTED_DIM],end[MAX_NESTED_DIM],stride[MAX_NESTED_DIM]      */
/*************************************************************************/
index_processing(pbf,pllnd,name2)
PTR_BFND pbf;
PTR_LLND pllnd;
PTR_SYMB name2[];
{
  PTR_LLND p;
  int      i,j;
  PTR_LLND index_list,expr_list,p1,p2;
  PTR_LLND begin_list,end_list,stride_list;
  PTR_LLND list1,list;
  PTR_BFND bf1;
  PTR_LLND vector_list;

  vector_list = scan_expr_for_dosubset(pllnd,SCAN_DOSUBSET_INDEX);
  if (!vector_list) return;
  for (i=0,p=vector_list->entry.template.ll_ptr1;p;p=p->entry.template.ll_ptr2,i++)
    {
      if (p->variant==EXPR_LIST) list= p->entry.template.ll_ptr1;
      else                       err("wrong indexes in DoSubSet");
      switch (list->variant) {
      case DDOT:
	list1=list->entry.template.ll_ptr1;
	if ((list1)&&(list1->variant==DDOT)){
	  stride_list=list->entry.template.ll_ptr2;
	  end_list=list1->entry.template.ll_ptr2;
	  begin_list=list1->entry.template.ll_ptr1;
	}
	else {
	  begin_list=list->entry.template.ll_ptr1;
	  end_list=list->entry.template.ll_ptr2;
	  stride_list= make_llnd(fi,INT_VAL,NULL,LLNULL,1);
	}
	break;
      case EXPR_LIST:
      case INT_VAL:
      default:
	if (list->variant==DDOT) {
	  begin_list = list->entry.template.ll_ptr1;
	  end_list   = list->entry.template.ll_ptr2;
	}
	else {
	  begin_list = list;
	  end_list   = list;
	}
	stride_list=make_llnd(fi,INT_VAL,NULL,LLNULL,1);
      }

    for (j=0; j<3;j++)
      {
	if (j==0) index_list=begin_list;
	if (j==1) index_list=end_list;
	if (j==2) index_list=stride_list;
	bf1=make_bfnd(fi,EXPR_STMT_NODE,SMNULL,NULL,NULL,NULL);
	bf1->filename = pbf->filename;
	chain_up(pbf,bf1);
	expr_list =make_llnd(fi,INT_VAL,LLNULL,LLNULL,i);
	expr_list =make_llnd(fi,EXPR_LIST,expr_list,LLNULL,NULL);
	p2  =make_llnd(fi,ARRAY_REF,expr_list,LLNULL,name2[j]);
	p1 = make_llnd(fi,ASSGN_OP,p2,index_list,SMNULL);
	expr_list=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
	bf1->entry.template.ll_ptr1 = expr_list;
      }
    }
}


/*************************************************************************/
/*                                                                       */
/* Export MethodofElement in the collection to the element object        */
/*                                                                       */
/*************************************************************************/
export_object(q)
PTR_ENTRY q;
{
PTR_SYMB col_name,symb,symb2,parent_first,child_first;
PTR_SYMB prev_moving_first,moving_first,old_symb;
PTR_BLOB blob,blob2,old_blob,moving_blob,prev_moving_blob,next;
PTR_BLOB next_moving_blob;
PTR_BFND parent_bfnd,child_bfnd;
PTR_TYPE type1,type2,base;
int level,sw,i,counter;
PTR_LLND p1,expr_list;

/*printf("we enter export_object \n"); */
base = q->base;
col_name = q->new_name;
type1 = follow_type_2(base,&level,&sw);
if (level ) return;
if ((type1->variant !=T_CLASS)&&
      (type1->variant !=T_STRUCT)&&
      (type1->variant !=T_UNION)&&
      (type1->variant !=T_COLLECTION)) return;
 child_bfnd = type1->entry.derived_class.original_class;
 child_first =  type1->entry.derived_class.first;

 type2 = follow_type_2(col_name->type,&level,&sw);  
 parent_bfnd = type2->entry.derived_class.original_class;
 parent_first =  type2->entry.derived_class.first;
 prev_moving_blob=NULL;
 for (moving_blob=parent_bfnd->entry.template.bl_ptr1;
      moving_blob;
      moving_blob=next_moving_blob)
  {
    next_moving_blob = moving_blob->next;
    expr_list = moving_blob->ref->entry.template.ll_ptr1;
    p1=find_suit_declarator(expr_list);
    moving_first = p1->entry.template.symbol;
    if (moving_first->attr & ELEMENT_FIELD) {
      /* printf("we come to export object field\n"); */
      blob2=old_blob=child_bfnd->entry.template.bl_ptr1; 
      for (  ; blob2;blob2 = blob2->next)  
        old_blob = blob2;
      if (old_blob) old_blob->next = moving_blob;
      else  child_bfnd->entry.template.bl_ptr1 = moving_blob;
      moving_blob->ref->control_parent = child_bfnd ;
      next =moving_blob->next;
      if (prev_moving_blob) prev_moving_blob->next = next;
      else  { 
	parent_bfnd->entry.template.bl_ptr1    = next;
      }
      moving_blob->next= NULL;
      if (!child_first) type1->entry.derived_class.first = moving_first;
      else    chain_field_symb(child_first,moving_first);
      for (counter=0,p1=expr_list;p1;p1=p1->entry.template.ll_ptr2)
	counter++;
      for (old_symb=symb=moving_first,i=0; i< counter; i++)
	{
	  nullify_symbol(child_first,symb); /* important late binding */
          old_symb=symb;
	  if (symb->variant==MEMBER_FUNC)  {
	    symb->entry.member_func.base_name=child_bfnd->entry.template.symbol;
	    symb=symb->entry.member_func.next;
	  }
	  else   {
	    symb->entry.field.base_name=child_bfnd->entry.template.symbol;
	    symb=symb->entry.field.next;
	  }
	}  
      if (old_symb->variant==MEMBER_FUNC) 
             old_symb->entry.member_func.next=NULL; 
      else   old_symb->entry.field.next=NULL;

      prev_moving_first=NULL;
      for (symb2=parent_first;symb2; )
	{
	  if (symb2==moving_first) break;
	  prev_moving_first=symb2;
	  if (symb2->variant==MEMBER_FUNC)
	    symb2=symb2->entry.member_func.next;
	  else   
	    symb2=symb2->entry.field.next;
	}  
      if (!prev_moving_first) type2->entry.derived_class.first=symb;
      else  {
        if (prev_moving_first->variant==MEMBER_FUNC)
	  prev_moving_first->entry.member_func.next=symb;
        else   prev_moving_first->entry.field.next=symb;
      }
    }
    else       prev_moving_blob = moving_blob;	
  }
}


/****************************************************************************/
/* A routine to  mark a new symbol as invalid and find out the real binding */
/* of the old symbol and stored it.                                         */
/* (1) The new binding is stored in the entry.member_func.declared_name     */
/* (2) The mark of invalid is put in the attr as INVALID                    */
/*                                                                          */
/****************************************************************************/
nullify_symbol(child_first,moving_symbol)
PTR_SYMB child_first,moving_symbol;
{
  PTR_SYMB arg_list,new_arg_list;
  PTR_SYMB first;
  int      n,n1;


  if (moving_symbol->variant!=MEMBER_FUNC) return;
  if (moving_symbol->entry.member_func.func_hedr) return;
  new_arg_list = moving_symbol->entry.member_func.in_list;
  n= num_of_args(new_arg_list);
  for (first=child_first; first; )
    {
      if (first->variant==FIELD_NAME)
	first=first->entry.field.next;
      else {
       arg_list =     first->entry.member_func.in_list;
       n1 = num_of_args(arg_list);
       if ((!strcmp(moving_symbol->ident,first->ident))&&
	   ((is_type_matched_in_arglist(new_arg_list,arg_list,4)&&
	    (n1==n)&&
	    is_same_type_conversion(moving_symbol->type,first->type))||
	   (is_same_type_conversion(moving_symbol->type,first->type)&&
	    is_void_in_arglist(n,arg_list))))
	  { 
	    moving_symbol->entry.member_func.declared_name = first;
	    if (first) moving_symbol->attr = moving_symbol->attr | INVALID; 
	    return;
	  }    
	first=first->entry.member_func.next;
      }
    }
  warning("inherited function mismatched");
}


replace_all_nullified_method_bfnd(pbf)
PTR_BFND pbf;
{
  PTR_BLOB blob;

  if (!pbf) return;
  for(blob=pbf->entry.template.bl_ptr1;blob;blob=blob->next)
    replace_all_nullified_method_bfnd(blob->ref);
  for(blob=pbf->entry.template.bl_ptr2;blob;blob=blob->next)
    replace_all_nullified_method_bfnd(blob->ref);
  replace_all_nullified_method_llnd(pbf->entry.template.ll_ptr1);
  replace_all_nullified_method_llnd(pbf->entry.template.ll_ptr2);
  replace_all_nullified_method_llnd(pbf->entry.template.ll_ptr3);
}  


replace_all_nullified_method_llnd(pllnd)
PTR_LLND pllnd;
{
  PTR_SYMB symb;
  
  if (!pllnd) return;
  replace_all_nullified_method_llnd(pllnd->entry.template.ll_ptr1);
  replace_all_nullified_method_llnd(pllnd->entry.template.ll_ptr2);

  switch (pllnd->variant) {
   case VAR_REF:
   case ARRAY_REF:
   case FUNC_CALL:
   case FUNCTION_REF:
    symb=pllnd->entry.template.symbol;
    if (symb &&(symb->variant==MEMBER_FUNC)&&(symb->attr & INVALID))
     {
       pllnd->entry.template.symbol= symb->entry.member_func.declared_name;
     }
  }
}







/*************************************************************************/
/*                                                                       */
/* Program Transformation  for vector constant                           */   
/*                                                                       */
/*************************************************************************/
transform_vconstant_structure()
{
  PTR_BFND root;
  PTR_LLND p;
  PTR_SYMB functor;

  transform_all_vconstant(global_bfnd);
  if (global_counter) {
    gen_vconstant_string();
    install_vconstant_vars();
  }
  else {
    /* generates a empty vconstant_init() */
    functor=make_symb(fi,FUNCTION_NAME,InitFunctionString);
    functor->type=global_int;
    functor->scope =global_bfnd;
    p     = make_llnd(fi,FUNCTION_REF,NULL,NULL,functor);
    root=make_bfnd(fi,FUNC_HEDR,functor,p,NULL,NULL);
    root->filename = global_bfnd->filename;
    functor->entry.func_decl.func_hedr=root;
    chain_up(global_bfnd,root);
  }

}

transform_all_vconstant(pbf)
PTR_BFND pbf;     
{
  PTR_BLOB blob;

  if (!pbf) return;
  if (pbf->variant == CONTROL_END) return;
  switch (pbf->variant) {
  case IF_NODE    :
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);
      break;
  case FOR_NODE   :
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);	
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr2);	
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr3);	
      break;
  case WHILE_NODE :
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);	
      break;
  case RETURN_STAT:
  case RETURN_NODE  :             /* New added for VPC */
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);	
      break;
  case DO_WHILE_NODE:             /* New added for VPC */
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);	
      break;
  case SWITCH_NODE :              /* New added for VPC */
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);	
      break ;
  case COLOOP_NODE  :             /* New added for VPC */
      break;
  case COEXEC_NODE  :             /* New added for VPC */
      break;
  case EXPR_STMT_NODE:
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);	
      break;
  case VAR_DECL:
  case CLASS_DECL:
  case STRUCT_DECL:
  case COLLECTION_DECL:
  case UNION_DECL:
  case ENUM_DECL:
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);     
      break;
  case FUNC_HEDR:
      transform_expr_vconstant(NULL,1,pbf->entry.template.ll_ptr1);     
      break;
  default:
      break;
  }	
  for(blob = pbf->entry.template.bl_ptr1;blob; blob=blob->next)
      transform_all_vconstant(blob->ref);
  for(blob = pbf->entry.template.bl_ptr2;blob; blob=blob->next)
      transform_all_vconstant(blob->ref);

}



transform_expr_vconstant(control_llnd,which_llnd,pllnd)
PTR_LLND pllnd;
PTR_LLND control_llnd;    
int which_llnd;

{
  char buf1[200];
  char *s;  
  PTR_LLND p,arg_list;

  
  if (!pllnd) return;
  switch (pllnd->variant) {
  case VECTOR_CONST:
      if (global_counter <MAX_TEMP_SPACE) {
          vconstant_llnd[global_counter] = pllnd;
	  sprintf(buf1,"Z_VO%d",global_counter);
	  s= copys(buf1);
          vconstant_symb[global_counter] = make_symb(fi,VARIABLE_NAME,s);
          vconstant_symb[global_counter]->scope = global_bfnd;
	  p =make_llnd(fi,VAR_REF,NULL,LLNULL,vconstant_symb[global_counter]);
	  if (which_llnd==1)
	      control_llnd->entry.template.ll_ptr1 = p;
	  else
	      control_llnd->entry.template.ll_ptr2 = p;
          global_counter++;
	  error_checking_for_vconstant(pllnd);
      }
      else err("vector constant table is full");
      break;
  case ARRAY_REF:
  case VAR_REF:
      break;
  default:
      break;
      
  }

  if ((pllnd->variant==FUNC_CALL)&&
      ((!strcmp(pllnd->entry.template.symbol->ident,"DoSubSet"))||
       (!strcmp(pllnd->entry.template.symbol->ident,"DOSUBSET"))))
      return;
  if ((pllnd->variant==FUNC_CALL)&&
      (!strcmp(pllnd->entry.template.symbol->ident,"DOALL")))
    {
      arg_list =pllnd->entry.template.ll_ptr1->entry.template.ll_ptr2;
      if(arg_list) {
	transform_expr_vconstant(arg_list,1,arg_list->entry.template.ll_ptr1);
	transform_expr_vconstant(arg_list,2,arg_list->entry.template.ll_ptr2);
      }
      return;
    }
  transform_expr_vconstant(pllnd,1,pllnd->entry.template.ll_ptr1);
  transform_expr_vconstant(pllnd,2,pllnd->entry.template.ll_ptr2);

}





gen_vconstant_string()
{
    
    PTR_SYMB symb,symb1,vsymb,allocator;
    PTR_SYMB functor;
    PTR_BFND root,bf1;
    PTR_LLND p1,p2,new_node,p,pllnd;
    int i,j,k,dim,dim_plus;
    PTR_TYPE type,pointer_to_int;
    PTR_LLND p3,p4;
    PTR_SYMB dim_field,body_field;    

    functor=make_symb(fi,FUNCTION_NAME,InitFunctionString);
    functor->type=global_int;
    functor->scope =global_bfnd;
    p     = make_llnd(fi,FUNCTION_REF,NULL,NULL,functor);
    root=make_bfnd(fi,FUNC_HEDR,functor,p,NULL,NULL);
    root->filename = global_bfnd->filename;
    functor->entry.func_decl.func_hedr=root;
    chain_up(global_bfnd,root);
    allocator=make_symb(fi,FUNCTION_NAME,AllocatorString);
    allocator->scope = global_bfnd;
    vsymb =NULL;
    for ( symb1=fi->head_symb; symb1; symb1=symb1->thread)
	if ((!strcmp(symb1->ident,VectorConstantName))&&
	    ((symb1->variant==STRUCT_NAME)||
	     (symb1->variant==CLASS_NAME)||
	     (symb1->variant==COLLECTION_NAME)||
	     (symb1->variant==TYPE_NAME)))
	    { 
		vsymb = symb1;
		break;
             }		

    if (global_counter&&(!vsymb)) err("vconstant object is not included");    
    body_field =check_field_decl_3_varied(vsymb,VconstantArrayName,0,0);
    dim_field =check_field_decl_3_varied(vsymb,VconstantDimName,0,0);

    pointer_to_int = get_type(fi,T_POINTER);
    pointer_to_int->entry.template.base_type = global_int;
    for (i=0; i<global_counter ; i++)
    {
	pllnd = vconstant_llnd[i];
	symb  = vconstant_symb[i];

        /* Var = para_calloc(1, sizeof(vconstant)) */
	bf1=make_bfnd(fi,EXPR_STMT_NODE,SMNULL,NULL,NULL,NULL);
	bf1->filename = global_bfnd->filename;
	chain_up(root,bf1);
	p     = make_llnd(fi,INT_VAL,NULL,NULL,SIZEOF_VCONSTANT);
	p2    = make_llnd(fi,EXPR_LIST,p,NULL,NULL);        
	p     = make_llnd(fi,INT_VAL,NULL,NULL,1);        
	p1    = make_llnd(fi,EXPR_LIST,p,p2,NULL);        
	p2    = make_llnd(fi,FUNC_CALL,p1,NULL,allocator);        
	p2    = make_llnd(fi,CAST_OP,p2,NULL,NULL);
        type = get_type(fi,T_DERIVED_TYPE);
	type->entry.derived_type = vsymb;
        p2->type = get_type(fi,T_POINTER);
	p2->type->entry.template.base_type =type;
	p1    = make_llnd(fi,VAR_REF,NULL,NULL,symb);        	
	p1    = make_llnd(fi,ASSGN_OP,p1,p2,NULL);
	new_node =make_llnd(fi,EXPR_LIST,p1,NULL,NULL);
	bf1->entry.template.ll_ptr1 = new_node;
	
        /* allocate the stroage for the body of the vconstant */
        dim = length_of(pllnd);
        dim_plus = (dim+1)*sizeof(int);

        /* Var->body = para_calloc(1,sizeof(int)*(dim+1)) */
	bf1=make_bfnd(fi,EXPR_STMT_NODE,SMNULL,NULL,NULL,NULL);
	bf1->filename = global_bfnd->filename;
	chain_up(root,bf1);
	p     = make_llnd(fi,INT_VAL,NULL,NULL,dim_plus);
	p2    = make_llnd(fi,EXPR_LIST,p,NULL,NULL);        
	p     = make_llnd(fi,INT_VAL,NULL,NULL,1);        
	p1    = make_llnd(fi,EXPR_LIST,p,p2,NULL);        
	p2    = make_llnd(fi,FUNC_CALL,p1,NULL,allocator);        
	p2    = make_llnd(fi,CAST_OP,p2,NULL,NULL);
	p2->type = pointer_to_int;
	p1    = make_llnd(fi,VAR_REF,NULL,NULL,symb);        	
	p3    = make_llnd(fi,VAR_REF,NULL,NULL,body_field);        	
	p1    = make_llnd(fi,POINTST_OP,p1,p3,NULL);
	p1    = make_llnd(fi,ASSGN_OP,p1,p2,NULL);
	new_node =make_llnd(fi,EXPR_LIST,p1,NULL,NULL);
	bf1->entry.template.ll_ptr1 = new_node;

        /* Var->dim = dim  */
	bf1=make_bfnd(fi,EXPR_STMT_NODE,SMNULL,NULL,NULL,NULL);
	bf1->filename = global_bfnd->filename;
	chain_up(root,bf1);
	p2    = make_llnd(fi,INT_VAL,NULL,NULL,dim);
	p1    = make_llnd(fi,VAR_REF,NULL,NULL,symb);        	
	p3    = make_llnd(fi,VAR_REF,NULL,NULL,dim_field);        	
	p1    = make_llnd(fi,POINTST_OP,p1,p3,NULL);
	p1    = make_llnd(fi,ASSGN_OP,p1,p2,NULL);
	new_node =make_llnd(fi,EXPR_LIST,p1,NULL,NULL);
	bf1->entry.template.ll_ptr1 = new_node;

	p4 = pllnd;
	
        /* initialization : Var->body[i] = field_i;  */
 	if (p4) p4=p4->entry.template.ll_ptr1;
	for (j=0 ; j <dim; j++)
	{	    
	    bf1=make_bfnd(fi,EXPR_STMT_NODE,SMNULL,NULL,NULL,NULL);
	    bf1->filename = global_bfnd->filename;
	    chain_up(root,bf1);
	    p2= copy_ll_node(p4->entry.template.ll_ptr1);
	    p     = make_llnd(fi,INT_VAL,NULL,NULL,j);        
	    p1    = make_llnd(fi,EXPR_LIST,p,NULL,NULL);        
	    p3    = make_llnd(fi,ARRAY_REF,p1,NULL,body_field);        
	    p1    = make_llnd(fi,VAR_REF,NULL,NULL,symb);        	
	    p1    = make_llnd(fi,POINTST_OP,p1,p3,NULL);
	    p1    = make_llnd(fi,ASSGN_OP,p1,p2,NULL);
	    new_node =make_llnd(fi,EXPR_LIST,p1,NULL,NULL);
	    bf1->entry.template.ll_ptr1 = new_node;
	    p4=p4->entry.template.ll_ptr2;
	    
	}
    }

}






install_vconstant_vars()
{
  PTR_SYMB symb1,vsymb;
  PTR_LLND head_list,expr_list,p1,list;
  PTR_TYPE type,new_type;
  PTR_BLOB blob,blob1,next_blob;
  PTR_BFND child_bfnd,bf;
  int i,level,dummy;

  

  for ( symb1=fi->head_symb; symb1; symb1=symb1->thread)
      if ((!strcmp(symb1->ident,VectorConstantName))&&
	  ((symb1->variant==STRUCT_NAME)||
	   (symb1->variant==CLASS_NAME)||
	   (symb1->variant==COLLECTION_NAME)||
	   (symb1->variant==TYPE_NAME)))
      { 
	  vsymb = symb1;
	  break;
      }		
  type =follow_type_2(vsymb->type, &level,&dummy);
  bf = type->entry.derived_class.original_class;
  for (blob= bf->control_parent->entry.template.bl_ptr1;(blob->ref!=bf);
       blob=blob->next) ;
  next_blob = blob->next;
  child_bfnd=make_bfnd(fi,VAR_DECL,SMNULL,NULL,NULL,NULL);
  child_bfnd->filename = global_bfnd->filename;
  blob1 = make_blob(fi,child_bfnd,BLNULL);
  
  blob->next=      blob1;
  blob1->next=next_blob;
  child_bfnd->control_parent = bf->control_parent;
  
  /* vconstant *V1,*V,...*Vn; */
  type = get_type(fi,T_DERIVED_TYPE);
  type->entry.derived_type = vsymb;
  new_type = get_type(fi,T_POINTER);
  new_type->entry.template.base_type =type;
  for (list=NULL,expr_list=NULL,i=0; i<global_counter;i++)
  {	  
      vconstant_symb[i]->type = new_type;
      p1    = make_llnd(fi,VAR_REF,NULL,NULL,vconstant_symb[i]);
      p1    = make_llnd(fi,DEREF_OP,p1,NULL,NULL);
      expr_list = make_llnd(fi,EXPR_LIST,p1,LLNULL,SMNULL);
      if (list) list->entry.template.ll_ptr2=expr_list;
      else head_list = expr_list;
      list = expr_list;      
  }
  child_bfnd->entry.template.ll_ptr1=head_list;
  

}




length_of(pllnd)
PTR_LLND pllnd;
{
  int i;
  PTR_LLND p;
    
  if (!pllnd) return(0);
  p = pllnd->entry.template.ll_ptr1;
  if (!p) return(0);
  for (i=0; p; p=p->entry.template.ll_ptr2) i++;
  return(i);
  
}



error_checking_for_vconstant(pllnd)
PTR_LLND pllnd;
{

  if (!pllnd) return;
  if ((pllnd->variant==VAR_REF)||(pllnd->variant==FUNCTION_REF))
   err_symb("variable used in vector constant",pllnd->entry.template.symbol->ident);
  else {
    error_checking_for_vconstant(pllnd->entry.template.ll_ptr1);
    error_checking_for_vconstant(pllnd->entry.template.ll_ptr2);
  }

}



/**************************************************************************/
/* Programs transformation of DOALL node of Collection-Oriented operation */
/*                                                                        */
/* IF (sw ==SCAN_ONLY)  {                                                 */
/*   Scan the expression only to see if the expression is                 */
/*       DOALL                                                            */
/*   Otherwise return the left-most expressions of the whole expression   */
/* }                                                                      */
/**************************************************************************/
scan_expr_for_doall(pllnd,sw)
PTR_LLND pllnd;
{
  PTR_SYMB symbol;


  if (!pllnd) return(0);
  switch (pllnd->variant) {
  case VAR_REF:
  case ARRAY_REF:
    break;
  case RECORD_REF:
  case POINTST_OP:
    symbol = pllnd->entry.template.ll_ptr2->entry.template.symbol;
    if (!symbol) break;
    if  (!strcmp(symbol->ident,DOALLStringName))
	return(1);
    break;
  case FUNCTION_OP:
    break;
  case FUNC_CALL:
    if (!strcmp(pllnd->entry.template.symbol->ident,DOALLStringName))
	return(1);	
    }
  if (scan_expr_for_doall(pllnd->entry.template.ll_ptr1,sw)) return(1);
  if (scan_expr_for_doall(pllnd->entry.template.ll_ptr2,sw)) return(1);

return(0);
}

/*

trans_exprnode_doall(pbf,pllnd)
PTR_BFND pbf;
PTR_LLND pllnd;
{

  PTR_LLND p,p1,p2,expr_list;
  PTR_SYMB symbol,base,object,pset_symb;
  PTR_TYPE type1,type;
  PTR_BFND bf;
  int      level,sw;

  if (!pllnd) return;
  switch (pllnd->variant) {
  case VAR_REF:
  case ARRAY_REF:
    break;
  case RECORD_REF:
  case POINTST_OP:
    symbol = pllnd->entry.template.ll_ptr2->entry.template.symbol;
    if (!symbol) break;
    if  (!strcmp(symbol->ident,DOALLStringName))
      {
	type = pllnd->entry.template.ll_ptr1->type;
	type1 = follow_type_2(type,&level,&sw);
	if (type1&&(type1->variant==T_DERIVED_COLLECTION))
	  base =type1->entry.col_decl.collection_name;
	else if (type1->variant==T_COLLECTION)
	  base=type1->entry.derived_class.original_class->entry.template.symbol;
	pset_symb =check_field_decl_3_varied(base,ProcSetFieldString,0,0);   
	if (!pset_symb) err("proc set field is not found in the kernel");
	p1=copy_ll_node(pllnd->entry.template.ll_ptr1);
	p2=make_llnd(fi,VAR_REF,NULL,NULL,pset_symb);
	p2->type = pset_symb->type;
	p1=make_llnd(fi,pllnd->variant,p1,p2,SMNULL);
	p1->type = pset_symb->type;
	p=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
	p1=pllnd->entry.template.ll_ptr2;
	expr_list=p1->entry.template.ll_ptr1;
	p->entry.template.ll_ptr2 =expr_list;
	p1->entry.template.ll_ptr1=p;
	return;
      }
    break;
  case FUNCTION_OP:
    break;
  case FUNC_CALL:
    if (!strcmp(pllnd->entry.template.symbol->ident,DOALLStringName))
      {
	for (bf=pbf; bf->variant !=FUNC_HEDR; bf=bf->control_parent);
	symbol=bf->entry.template.symbol;
	object =symbol->entry.member_func.base_name;
	pset_symb =check_field_decl_3_varied(object,ProcSetFieldString,0,0);
	if (!pset_symb) err("proc set field is not found in the kernel");
	p1=make_llnd(fi,VAR_REF,NULL,NULL,pset_symb);
	p1->type = pset_symb->type;
	p=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
	expr_list=pllnd->entry.template.ll_ptr1;
	p->entry.template.ll_ptr2 =expr_list;
	pllnd->entry.template.ll_ptr1=p;
	return;
      }
  }
trans_exprnode_doall(pbf,pllnd->entry.template.ll_ptr1);
trans_exprnode_doall(pbf,pllnd->entry.template.ll_ptr2);



}
*/


trans_exprnode_doall(pbf,pllnd)
PTR_BFND pbf;
PTR_LLND pllnd;
{

  PTR_LLND p,p1,p2,expr_list,arg_list,arg_list1;
  PTR_SYMB symbol,base,object,pset_symb;
  PTR_TYPE type1,type;
  PTR_BFND bf;
  int      level,sw;

  if (!pllnd) return;
  switch (pllnd->variant) {
  case VAR_REF:
  case ARRAY_REF:
    break;
  case RECORD_REF:
  case POINTST_OP:
    symbol = pllnd->entry.template.ll_ptr2->entry.template.symbol;
    if (!symbol) break;
    if  (!strcmp(symbol->ident,DOALLStringName))
      {
	arg_list = pllnd->entry.template.ll_ptr2->entry.template.ll_ptr1;
	arg_list1 =arg_list->entry.template.ll_ptr1;
	if (arg_list1->variant==VECTOR_CONST)
	  {
	    gen_general_doall_to_coloop(pbf,pllnd);
	    return;
	  }
	type = pllnd->entry.template.ll_ptr1->type;
	type1 = follow_type_2(type,&level,&sw);
	if (type1->variant==T_DERIVED_COLLECTION)
	  base =type1->entry.col_decl.collection_name;
	else if (type1->variant==T_COLLECTION)
	  base=type1->entry.derived_class.original_class->entry.template.symbol;
	pset_symb =check_field_decl_3_varied(base,ProcSetFieldString,0,0);   
	if (!pset_symb) err("proc set field is not found in the kernel");
	p1=copy_ll_node(pllnd->entry.template.ll_ptr1);
	p2=make_llnd(fi,VAR_REF,NULL,NULL,pset_symb);
	p2->type = pset_symb->type;
	p1=make_llnd(fi,pllnd->variant,p1,p2,SMNULL);
	p1->type = pset_symb->type;
	p=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
	p1=pllnd->entry.template.ll_ptr2;
	expr_list=p1->entry.template.ll_ptr1;
	p->entry.template.ll_ptr2 =expr_list;
	p1->entry.template.ll_ptr1=p;
	return;
      }
    break;
  case FUNCTION_OP:
    break;
  case FUNC_CALL:
    if (!strcmp(pllnd->entry.template.symbol->ident,DOALLStringName))
      {
	arg_list = pllnd->entry.template.ll_ptr1;
	arg_list1 =arg_list->entry.template.ll_ptr1;
	if (arg_list1->variant==VECTOR_CONST)
	  {
	    gen_general_doall_to_coloop(pbf,pllnd);
	    return;
	  }
	for (bf=pbf; bf->variant !=FUNC_HEDR; bf=bf->control_parent);
	symbol=bf->entry.template.symbol;
	object =symbol->entry.member_func.base_name;
	pset_symb =check_field_decl_3_varied(object,ProcSetFieldString,0,0);
	if (!pset_symb) err("proc set field is not found in the kernel");
	p1=make_llnd(fi,VAR_REF,NULL,NULL,pset_symb);
	p1->type = pset_symb->type;
	p=make_llnd(fi,EXPR_LIST,p1,NULL,SMNULL);
	expr_list=pllnd->entry.template.ll_ptr1;
	p->entry.template.ll_ptr2 =expr_list;
	pllnd->entry.template.ll_ptr1=p;
	return;
      }
  }
trans_exprnode_doall(pbf,pllnd->entry.template.ll_ptr1);
trans_exprnode_doall(pbf,pllnd->entry.template.ll_ptr2);



}

/************************************************************************/
/* change                                                               */
/*      G.DOALL([1:end:stride],functor,arglist..)                       */
/* to                                                                   */
/*      coloop ( [1:end:stride] ; Z_i= G.Pset)                          */
/*             functor(Z_i,arglist);                                    */

/************************************************************************/
gen_general_doall_to_coloop(pbf,pllnd)
PTR_BFND pbf;
PTR_LLND pllnd;
{
  PTR_SYMB s2,base,pset_symb,object,symbol;
  PTR_LLND p1,p2,p3,arg1,arg_list,expr_list;
  PTR_TYPE type,type1;
  PTR_BFND bf1,bf;
  int level,sw;

  s2=make_symb(fi,VARIABLE_NAME,"Z_i");
  s2->scope = pbf->control_parent;
  pbf->variant = COLOOP_NODE;
  pbf->entry.template.symbol =make_symb(fi,VARIABLE_NAME,"$COLOOP");
  pbf->entry.template.symbol->scope = global_bfnd;
  pbf->entry.template.symbol->attr = PCPLUSPLUS_DOSUBSET;
  switch (pllnd->variant) {
    case RECORD_REF:
    case POINTST_OP:
       type = pllnd->entry.template.ll_ptr1->type;
       type1 = follow_type_2(type,&level,&sw);
       if (type1->variant==T_DERIVED_COLLECTION)
	 base =type1->entry.col_decl.collection_name;
       else if (type1->variant==T_COLLECTION)
	 base=type1->entry.derived_class.original_class->entry.template.symbol;
       pset_symb =check_field_decl_3_varied(base,ProcSetFieldString,0,0);   
       if (!pset_symb) err("proc set field is not found in the kernel");
       /*Now we generate coloop([1:end:stride],Z_i=G.Pset) */
       p1=copy_ll_node(pllnd->entry.template.ll_ptr1);
       p2=make_llnd(fi,VAR_REF,NULL,NULL,pset_symb);
       p2->type = pset_symb->type;
       p2=make_llnd(fi,pllnd->variant,p1,p2,SMNULL);
       p2->type =  pset_symb->type;
       p1=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
       p1 =make_llnd(fi,ASSGN_OP,p1,p2,NULL);
       expr_list =make_llnd(fi,EXPR_LIST,p1,NULL,NULL);    
       pbf->entry.template.ll_ptr2= expr_list;
       arg_list= pllnd->entry.template.ll_ptr2->entry.template.ll_ptr1;
       pbf->entry.template.ll_ptr1=arg_list->entry.template.ll_ptr1;
       
       /* now Let's generate "functor(Z_i,arglist...)" */
       bf1=make_bfnd(fi,EXPR_STMT_NODE,SMNULL,NULL,NULL,NULL);   
       bf1->filename = pbf->filename;
       chain_up(pbf,bf1);
       arg_list= arg_list->entry.template.ll_ptr2;
       arg1 = arg_list->entry.template.ll_ptr1;
       if (arg1->variant==FUNCTION_REF)    p3 = arg1;
       else                 p3 = follow_llnd(arg1,2);
       p3->variant= FUNC_CALL;
       p1=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
       expr_list=make_llnd(fi,EXPR_LIST,p1,arg_list->entry.template.ll_ptr2,NULL);
       p3->entry.template.ll_ptr1 = expr_list;
       expr_list=make_llnd(fi,EXPR_LIST,arg1,NULL,NULL);
       bf1->entry.template.ll_ptr1 =expr_list;
       break;
     case FUNC_CALL:
       for (bf=pbf; bf->variant !=FUNC_HEDR; bf=bf->control_parent);
       symbol=bf->entry.template.symbol;
       object =symbol->entry.member_func.base_name;
       pset_symb =check_field_decl_3_varied(object,ProcSetFieldString,0,0);
       if (!pset_symb) err("proc set field is not found in the kernel");
       p2=make_llnd(fi,VAR_REF,NULL,NULL,pset_symb);
       p2->type = pset_symb->type;
       p1=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
       p1 =make_llnd(fi,ASSGN_OP,p1,p2,NULL);
       expr_list =make_llnd(fi,EXPR_LIST,p1,NULL,NULL);    
       pbf->entry.template.ll_ptr2= expr_list;
       arg_list= pllnd->entry.template.ll_ptr1;
       pbf->entry.template.ll_ptr1=arg_list->entry.template.ll_ptr1;
       
       /* now Let's generate "functor(Z_i,arglist...)" */
       bf1=make_bfnd(fi,EXPR_STMT_NODE,SMNULL,NULL,NULL,NULL);   
       bf1->filename = pbf->filename;
       chain_up(pbf,bf1);
       arg_list= arg_list->entry.template.ll_ptr2;
       arg1 = arg_list->entry.template.ll_ptr1;
       if (arg1->variant==FUNCTION_REF)    p3 = arg1;
       else                 p3 = follow_llnd(arg1,2);
       p3->variant= FUNC_CALL;
       p1=make_llnd(fi,VAR_REF,NULL,LLNULL,s2);
       expr_list=make_llnd(fi,EXPR_LIST,p1,arg_list->entry.template.ll_ptr2,NULL);
       p3->entry.template.ll_ptr1 = expr_list;
       expr_list=make_llnd(fi,EXPR_LIST,arg1,NULL,NULL);
       bf1->entry.template.ll_ptr1 =expr_list;
     }
}


