
/* Modified by Jenq-Kuen Lee Feb 24,1988          */
/* The simple un-parser for VPC++                 */
# include <stdio.h>
# include "defs.h"
# include "bif.h"
# include "ll.h"
# include "symb.h"
# include "sets.h"
# include "vparse.h"

# define  NULLTEST(VAR) (VAR == NULL? -1 : VAR->id)
# define type_index(X) (X-T_INT)

void     gen_func_hedr();
PTR_SYMB find_declarator();
extern 	PTR_CMNT cmnt;     /* point to chain of comment list */
extern  char temp_buf[];   /* For switching buffer           */
extern  char temp1_buf[];  /* For switching buffer           */
extern  int old_buff_base1;
int     tm_put_string();
int     global_wid  ;
int     global_tab  ;
int     global_curh = 0 ;
int     global_maxh = 80 ;
int     global_token ;
char *cop_name[] = {
        "->",       /* 0  */
        "!",        /* 1  */
        "~",        /* 2  */
        "++",       /* 3  */
        "--",       /* 4  */
        "-",        /* 5  */
        "*",        /* 6  */
        "&",        /* 7  */
        "sizeof ",  /* 8  */
        "*",        /* 9  */
        "/",        /* 10 */
        "%",        /* 11 */
        "+",        /* 12 */
        "-",        /* 13 */
        ">>",       /* 14 */
        "<<",       /* 15 */
        "<",        /* 16 */
        ">",        /* 17 */
        "<=",       /* 18 */
        ">=",       /* 19 */
        "==",       /* 20 */
        "!=",       /* 21 */
        "&",        /* 22 */
        "^",        /* 23 */
        "|",        /* 24 */
        "&&",       /* 25 */
        "||",       /* 26 */
        "=",        /* 27 */
        "+=",       /* 28 */
        "-=",       /* 29 */
};


/* Added for VPC */

char *ridpointers[ (int) RID_MAX ] ;

/* Added for VPC */
extern char buffer[],cpybuf[];
extern char buffera[];
extern int buff_base;
extern int linecnt;
extern int fout_buff();
/* extern int (*unp_bfnd) ();  */
extern PTR_BFND current_proc, global_bfnd;


/*
 * This code depends on the ordering of the tag for the binary operators
 * It returns true (1) if the given tag is within the range of the binary
 * operators.  It returns 0 otherwise
 */
static
int
binop(n)
int n;
{
        return (n >= EQ_OP && n <= NEQV_OP);
}


static
put_tabs(n)
int n;
{
        register int i;

        for(i = 0; i < n; i++) {
                buffer[buff_base++] = ' ';
                buffer[buff_base++] = ' ';
        }
}


cunp_bfnd(Wid,token,tabs,pbf)
int Wid;
int token;
int tabs;
PTR_BFND     pbf;
{
        PTR_BFND        pbfnd, pnext;
        PTR_SYMB        s;
        int             i;
        int             lines;

        if (!pbf) return(0);
	
        if (cmnt = pbf->entry.template.cmnt_ptr)
                while (cmnt != NULL && cmnt->type == FULL) {
                        tm_put_string(Wid,cmnt->string,token);
                        tm_put_string(Wid,"\n",token);
                        cmnt = cmnt->next;
                }    
/* 
        if (pbf->label) {
                char   b[10];

                sprintf(b ,"%-5d ", pbf->label->stateno);
                addstr(b); }
        else
                addstr("");
*/

        put_tabs(tabs);

        switch (pbf->variant) {
        case GLOBAL     :
                addstr("Top Level Program and Function List\n");
                break;
        case PROG_HEDR  :
        case PROC_HEDR  :  break ;
        case FUNC_HEDR  :
                gen_simple_type(pbf->entry.template.symbol->type,pbf,Wid,token,tabs);
                gen_func_hedr(pbf->entry.template.symbol,pbf,Wid,token,tabs);
                break;
        case IF_NODE    :
                gen_branch(IF_NODE,"if ",pbf);
                break;
        case LOGIF_NODE :
        case ARITHIF_NODE:
        case WHERE_NODE :
                break;
        case FOR_NODE   :
                addstr("for (");
                cunp_llnd(pbf->entry.template.ll_ptr1);
                addchar(';');
                cunp_llnd(pbf->entry.template.ll_ptr2);
                addchar(';');
                cunp_llnd(pbf->entry.template.ll_ptr3);
                addstr(") ") ;
                break;
        case FORALL_NODE        :
        case WHILE_NODE :
                addstr("while (");
                cunp_llnd(pbf->entry.template.ll_ptr1);
                addstr(") ") ;
                break;
        case ASSIGN_STAT:
        case IDENTIFY:
        case PROC_STAT  :
        case SAVE_DECL:
        case CONT_STAT:
        case FORMAT_STAT:
                break;
        case LABEL_STAT:
                addstr(pbf->entry.template.lbl_ptr->label_name->ident);
                addstr(" : ");
                break;
        case GOTO_NODE:
                addstr("goto ");
                /* cunp_llnd(pbf->entry.template.ll_ptr3); Fortran Version */
                addstr(pbf->entry.template.lbl_ptr->label_name->ident);
                addstr(" ;");
                break;
        case ASSGOTO_NODE:
        case COMGOTO_NODE:
        case STOP_STAT:
                break;
        case RETURN_STAT:
                addstr("return");
                if (pbf->entry.template.ll_ptr1)
                  { addstr("(");
                    cunp_llnd(pbf->entry.template.ll_ptr1);
                    addstr(")");
                  }
               addstr(" ;");
                break;
        case PARAM_DECL :
        case DIM_STAT:
        case EQUI_STAT:
        case DATA_DECL:
        case READ_STAT:
        case WRITE_STAT:
        case OTHERIO_STAT:
        case COMM_STAT:
        case CONTROL_END:
                break;
        case ENUM_DECL :                /* New added for VPC */
        case CLASS_DECL:                /* New added for VPC */
        case UNION_DECL:                /* New added for VPC */
        case STRUCT_DECL:               /* New added for VPC */
	      {  PTR_BLOB blob ;
                 PTR_SYMB symb,symb1 ;
                 PTR_LLND llptr;

                      llptr = pbf->entry.template.ll_ptr1;
                      symb1 = find_declarator(llptr);
                      if (symb1) gen_descriptive_type(symb1);
                      switch (pbf->variant) {
                      case UNION_DECL: addstr("union ") ;
                                       break;
                      case STRUCT_DECL:addstr("struct ") ;
                                       break;
                      case ENUM_DECL  : addstr("enum ") ;
                                       break;
                      case CLASS_DECL : addstr("class ") ;
                                       break;
                      }
                      if (symb=pbf->entry.template.symbol)
                          {  addstr(symb->ident);
                             addchar(' ');
			   }
                      if (blob=pbf->entry.template.bl_ptr1)
                        {   addstr(" {\n") ;
                            for ( ; blob ; blob = blob->next)
                             { cdrtext(blob->ref,Wid,token,tabs+2,global_curh+1,global_maxh);
                               out_buff(Wid,token);
                             }
                            put_tabs(tabs);  addstr("} ");
                          }
                       cunp_llnd(llptr);
                       addchar(';');
                       break;
	       }
        case DERIVED_CLASS_DECL:        /* Need More for VPC */
        case VAR_DECL:
                {  PTR_SYMB symb1 ;
                   PTR_LLND llptr;

                   llptr = pbf->entry.template.ll_ptr1;
                   symb1 = find_declarator(llptr);
                   if (symb1) gen_simple_type(symb1->type,pbf,Wid,token,tabs) ;
                   cunp_llnd(llptr);
                   if (pbf->control_parent->variant != ENUM_DECL) addstr(" ;");
                   break;
                }

        case EXPR_STMT_NODE:            /* New added for VPC */
                   cunp_llnd(pbf->entry.template.ll_ptr1);
                   addstr(" ;");
                   break ;
        case DO_WHILE_NODE:             /* New added for VPC */
                                        /* Need study        */
        case SWITCH_NODE :              /* New added for VPC */
                   addstr("switch (");
                   cunp_llnd(pbf->entry.template.ll_ptr1);
                   addchar(')');
                   break ;
        case CASE_NODE :                /* New added for VPC */
                   addstr("case ");
                   cunp_llnd(pbf->entry.template.ll_ptr1);
                   addstr(" : ") ;
                   break ;
        case DEFAULT_NODE:              /* New added for VPC */
                   addstr("default :") ;
                   break;
        case BASIC_BLOCK :
                   break ;
        case BREAK_NODE  :              /* New added for VPC */
                   addstr("break;");
                   break;
        case CONTINUE_NODE:             /* New added for VPC */
                   addstr("continue ;");
		   break;
        case RETURN_NODE  :             /* New added for VPC */
                addstr("return");
                if (pbf->entry.template.ll_ptr1)
                  { addstr("(");
                    cunp_llnd(pbf->entry.template.ll_ptr1);
                    addstr(")");
                  }
                addstr(" ;");
                 break;
        case ASM_NODE     :             /* New added for VPC */
               break;                   /* Need More         */
        case COBREAK_NODE :             /* New added for VPC */
               addstr("cobreak;");
               break;
        case COLOOP_NODE  :             /* New added for VPC */
               addstr("coloop(") ;
               cunp_llnd(pbf->entry.template.ll_ptr1);
               addstr(" ; ");
               cunp_llnd(pbf->entry.template.ll_ptr2);
               addchar(')');
               break;
        case COEXEC_NODE  :             /* New added for VPC */
               addstr("coexec (") ;
               cunp_llnd(pbf->entry.template.ll_ptr1);
               addchar(')');
               break;
        default:
                sprintf(buffera, "bad bfnd case");
                unperror(buffera);
                break;                  /* don't know what to do at this point */
        }
/* The following code need check
        if (pbf->variant != CONTROL_END) {
                if (cmnt && cmnt->type != FULL)
                        addstr(cmnt->string);
                if (pbf->variant != LOGIF_NODE)
                        addchar('\n');
        }
                                                                */
        /* end of biff node.  now write string and reset buffer */
        /*     addchar('\n');  */
        lines = out_buff(Wid,token);
        if (cmnt && cmnt->type == HALF)
            while  (cmnt && cmnt->type == HALF)
                     {  tm_put_string(Wid,cmnt->string,token);
                        cmnt =cmnt->next ;
		      }
        if (cmnt && cmnt->type == NEXT_FULL)
	  { 
            while  (cmnt && cmnt->type == NEXT_FULL)
                     {  
                        tm_put_string(Wid,"\n",token);
                        tm_put_string(Wid,cmnt->string,token);
                        cmnt =cmnt->next ;
		      }
	  }
        tm_put_string(Wid,"\n",token);


        return(lines);
}


static
gen_loop_header(nodetag, looptype, pbf)
int       nodetag;
char    * looptype;
PTR_BFND        pbf;
{       char    label[7];

        addstr(looptype);
        if (pbf->entry.for_node.doend) {
                sprintf(label,"%d ",pbf->entry.for_node.doend->stateno);
                addstr(label);
        }
        addstr(pbf->entry.for_node.control_var->ident);
        addstr(" = ");
        cunp_llnd(pbf->entry.for_node.range->entry.binary_op.l_operand);
        addstr(", ");
        cunp_llnd(pbf->entry.for_node.range->entry.binary_op.r_operand);
        if (pbf->entry.for_node.increment) {
                addstr(" , ");
                cunp_llnd(pbf->entry.for_node.increment);
        }
}


/*
 * gen_if_node(pbf) --- generate the if statement pointed to by pbf.
 */
static
gen_branch(branch_tag, branch_type, pbf)
        int             branch_tag;
        char           *branch_type;
        PTR_BFND        pbf;
{
        PTR_BFND        pnext;  /* next statement pointer       */
        PTR_BFND        gen_stmt_list();
        addstr(branch_type);
        addchar('(');
        cunp_llnd(pbf->entry.template.ll_ptr1);
        addchar(')');
}


cunp_llnd(pllnd)
PTR_LLND        pllnd;
{
        if (pllnd == NULL) return;

        switch (pllnd->variant) {
        case INT_VAL    :
                { char sb[64];

                sprintf(sb, "%d", pllnd->entry.ival);
                addstr(sb);
                break;
                }
        case STMT_STR   : break ;
        case FLOAT_VAL  :
        case DOUBLE_VAL :
                addstr(pllnd->entry.string_val);
                break;
        case STRING_VAL :
                addchar('"');
                sprintf(buffera, "%s", pllnd->entry.string_val);
                addstr(buffera);
                addchar('"');
                break;
        case BOOL_VAL   :
                break;
        case CHAR_VAL   :
                sprintf(buffera, "\'%c\'",pllnd->entry.cval);
                addstr(buffera);
                break;
        case CONST_REF  :
        case VAR_REF    :
        case ENUM_REF   :
                addstr(pllnd->entry.template.symbol->ident);
                break;
        case RECORD_REF:		    
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addchar('.');
                cunp_llnd(pllnd->entry.template.ll_ptr2);
                break ;
	case ARRAY_OP :
                addchar('(');
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addchar(')');
                cunp_llnd(pllnd->entry.template.ll_ptr2);
		break;
        case ARRAY_REF  :
                addstr(pllnd->entry.array_ref.symbol->ident);
                if (pllnd->entry.template.ll_ptr1) {
                        cunp_llnd(pllnd->entry.template.ll_ptr1);
                }
                break;
        case CONSTRUCTOR_REF    :
                break;
        case ACCESS_REF :
                break;
        case CONS       :
                break;
        case ACCESS     :
                break;
        case IOACCESS   :
                break;
        case PROC_CALL  :
        case FUNC_CALL  :
                addstr(pllnd->entry.template.symbol->ident);
                addchar('(');
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addchar(')');
                break;
        case EXPR_LIST  :
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                if (pllnd->entry.template.ll_ptr2) {
                        addstr(",");
                        cunp_llnd(pllnd->entry.template.ll_ptr2);
                }
                break;
        case EQUI_LIST  :
                break;
        case COMM_LIST  :
                break;
        case VAR_LIST   :
        case CONTROL_LIST       :
                break;
        case RANGE_LIST :
                addchar('[');
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addchar(']');
                cunp_llnd(pllnd->entry.template.ll_ptr2);
                break;
        case DDOT       :
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addstr(":");
                cunp_llnd(pllnd->entry.template.ll_ptr2);
                break;
        case COPY_NODE :
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addstr("#");
                cunp_llnd(pllnd->entry.template.ll_ptr2);
                break;
        case VECTOR_CONST : /* NEW ADDED FOR VPC++  */
                addstr("[ ");
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addstr(" ]"); 
                break ;
        case INIT_LIST:
                addstr("{ ");
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addstr(" }"); 
                break ;
        case BIT_NUMBER:
		cunp_llnd(pllnd->entry.template.ll_ptr1);
                addstr(" : ");
 		cunp_llnd(pllnd->entry.template.ll_ptr2);
                break ;
        case DEF_CHOICE :
        case SEQ        :
                break;
        case SPEC_PAIR  :
                break;

        case MOD_OP     :
                break;
        case EQ_OP      :
        case LT_OP      :
        case GT_OP      :
        case NOTEQL_OP  :
        case LTEQL_OP   :
        case GTEQL_OP   :
        case ADD_OP     :
        case SUBT_OP    :
        case OR_OP      :
        case MULT_OP    :
        case DIV_OP     :
        case AND_OP     :
        case EXP_OP     :
        case POINTST_OP :                /* New added for VPC */
        case LE_OP      :                /* New added for VPC *//*Duplicated*/
        case GE_OP      :                /* New added for VPC *//*Duplicated*/
        case NE_OP      :                /* New added for VPC *//*Duplicated*/
        case ARITH_ASSGN_OP:             /* New added for VPC */
        case ASSGN_OP   :                /* New added for VPC */
        case BITAND_OP    :              /* New added for VPC */
        case BITOR_OP     :              /* New added for VPC */
        case LSHIFT_OP         :         /* New added for VPC */
        case RSHIFT_OP         :         /* New added for VPC */
        case INTEGER_DIV_OP :             /* New added for VPC */
                {
                 int i, j ;
                 PTR_LLND p;

                 i = pllnd->variant ;
                 p = pllnd->entry.template.ll_ptr1 ;
                 j = p->variant;
                 if ( cprecedence(i) < cprecedence(j) ) {
                        addchar('(');
                        cunp_llnd(p);
                        addchar(')');
                        if (pllnd->variant != ARITH_ASSGN_OP)
			     addstr(cop_name[mapping(i)] );
                        else
                             gen_op(pllnd->entry.template.symbol); 
                     }
                 else {
                        cunp_llnd(p);
                        if (pllnd->variant != ARITH_ASSGN_OP)
			     addstr(cop_name[mapping(i)] );
                        else
                             gen_op(pllnd->entry.template.symbol); 
                    
                      }
                 p = pllnd->entry.template.ll_ptr2;
                 j = p->variant;
                 if ( cprecedence(i) <= cprecedence(j)) {
                        addchar('(');
                        cunp_llnd(p);
                        addchar(')');
                    }
                 else {
                        cunp_llnd(p);
                      }
                break ;
                }




        case SUB_OP   :                  /* duplicated unary minus  */
        case MINUS_OP   :                /* unary operations */
        case UNARY_ADD_OP      :         /* New added for VPC */
        case BIT_COMPLEMENT_OP :         /* New added for VPC */
        case NOT_OP     :
        case DEREF_OP :
        case SIZE_OP      :               /* New added for VPC */
        case ADDRESS_OP   :               /* New added for VPC */

                {
                  int i, j;
                  PTR_LLND p;
                        i = pllnd->variant ;
                        p = pllnd->entry.template.ll_ptr1 ;
                        j = p->variant;
                        addstr(cop_name[mapping(i)] );
                        if ( cprecedence(i) < cprecedence(j) ) {
                                addchar('(');
                                cunp_llnd(p);
                                addchar(')');
                        }
                        else {
                                cunp_llnd(p);
                              }
		} 
                break;
        case MINUSMINUS_OP:              /* New added for VPC */
        case PLUSPLUS_OP  :              /* New added for VPC */
                {
                  int i ,j ;
                  PTR_LLND p;

                   i = pllnd->variant;
                   if   (p = pllnd->entry.template.ll_ptr1)
		     {
                           j = p->variant;
                           addstr(cop_name[mapping(i)] );
                           if ( cprecedence(i) < cprecedence(j) ) {
                                addchar('(');
                                cunp_llnd(p);
                                addchar(')');
                           }
                           else {
                                cunp_llnd(p);
                           }
	             }
                  else
		     {     p = pllnd->entry.template.ll_ptr2 ;
                            j = p->variant;
                           if ( cprecedence(i) < cprecedence(j) ) {
                                addchar('(');
                                cunp_llnd(p);
                                addchar(')');
                           }
                           else {
                                cunp_llnd(p);
                           }
                           addstr(cop_name[mapping(i)] );
	             }
		} 
                break;

        case STAR_RANGE :
                addstr(" : ");
                break;
        case CLASSINIT_OP :               /* New added for VPC */
	  {   PTR_LLND p;
                addstr(pllnd->entry.template.symbol->ident);
                addchar('(');
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addchar(')');
	   }
                break ;
        case CAST_OP :             /* New added for VPC */
                 addchar('(');
                 gen_simple_type_2(pllnd->type,BFNULL,global_wid,global_token,global_tab);
                 addchar(')');
                 addchar(' ');
                 cunp_llnd(pllnd->entry.template.ll_ptr1);
	         break;

        case EXPR_IF      :               /* New added for VPC */
                 cunp_llnd(pllnd->entry.template.ll_ptr1);
                 addstr(" ? ");
                 cunp_llnd(pllnd->entry.template.ll_ptr2);
                 break;
        case EXPR_IF_BODY :               /* New added for VPC */
                 cunp_llnd(pllnd->entry.template.ll_ptr1);
                 addstr(" : ");
                 cunp_llnd(pllnd->entry.template.ll_ptr2);
                 break;
        case FUNCTION_REF :               /* New added for VPC */
                addstr(pllnd->entry.template.symbol->ident);
                addchar('(');
/*              cunp_llnd(pllnd->entry.template.ll_ptr1);   */
                addchar(')');
                break ;
        case FUNCTION_OP :               /* New added for VPC */
                addchar('(');
                cunp_llnd(pllnd->entry.template.ll_ptr1);
                addchar(')');                
                addchar('(');
                cunp_llnd(pllnd->entry.template.ll_ptr2);   
                addchar(')');                
                break ;
        case LABEL_REF: /* Fortran Version, For VPC we need more */
                { char sb[64];

                  sprintf(sb, "%d", pllnd->entry.label_list.lab_ptr->stateno);
                  addstr(sb);
                  break;
                }
        default                 :
                sprintf(buffer, "bad llnd ptr!");
                unperror(buffer);
                break;
        }
}


/*********************************************************************/


PTR_SYMB        cur_symb_head;  /* point to the head of the list of symbols */
                                /* used to search type that LIKE the current*/
struct  tpair {
          PTR_SYMB link;
        };

typedef struct tpair *PTR_PAIR;






/*  Temporary as a Comment */

int cdrtext(bfptr,Wid,token,tab,curh,maxh)
PTR_BFND bfptr;
int Wid, token,tab;
int curh,maxh;
{
        int lev;
        register PTR_BLOB b, p;
        int      left_param ;

        left_param = NULL ;
        lev = maxh-curh;
  mk_bf_grnode(token,bfptr); 

/*       if (cmnt = bfptr->entry.template.cmnt_ptr)
                while (cmnt != NULL && cmnt->type == FULL) {
                        tm_put_string(Wid,cmnt->string,token);
                        tm_put_string(Wid,"\n",token);
                        cmnt = cmnt->next;
                }                               */
        global_wid = Wid ;
        global_tab = tab ;
        global_curh= curh ;
        global_maxh= maxh ;
        cunp_bfnd(Wid,token++,tab, bfptr);
        global_wid = Wid ;
        global_tab = tab ;
        global_curh= curh ;
        global_maxh= maxh ;

        if ((current_proc == global_bfnd) && (bfptr->control_parent == global_bfnd))
                return(token);


        if ((basket_needed(bfptr,1) > 1)&&(not_class(bfptr)))
           {   put_tabs(tab); addstr("{ \n");
               out_buff(Wid,token);
	   }
	  
        for (b = bfptr->entry.template.bl_ptr1; b; b = b->next)
	  {
/*               PTR_CMNT cmnt = b->ref->entry.template.cmnt_ptr;
                 if (cmnt)
                       while (cmnt != NULL && cmnt->type == FULL) {
                                        tm_put_string(Wid,cmnt->string,token);
                                        tm_put_string(Wid,"\n",token);
                                        cmnt = cmnt->next;
                                }
*/
                  switch(bfptr->variant){
	          case CLASS_DECL :
                  case UNION_DECL :
                  case ENUM_DECL:
                  case STRUCT_DECL :
                  case DERIVED_CLASS_DECL : break ;
                  case FUNC_HEDR :
                      if (left_param==NULL)
                            {
                             if (!is_param_decl(b->ref,bfptr->entry.template.symbol))
			       {   put_tabs(tab); addstr("{ \n");
                                   out_buff(Wid,token);
                                   left_param= 1 ;
				 }

                           }
                       token = cdrtext(b->ref,Wid,token,tab+1,curh+1,maxh);
                       break ; 
                  default :
                          token = cdrtext(b->ref,Wid,token,tab+1,curh+1,maxh);
	          }
/*                 if (cmnt && cmnt->type != FULL)
                     {  tm_put_string(Wid,cmnt->string,token);
                        tm_put_string(Wid,"\n",token);
		      }
*/
	     } 
       if (bfptr->variant == FUNC_HEDR)
         {
                if (left_param == NULL)  {
                         put_tabs(tab); addstr("{ \n");
                         out_buff(Wid,token);
		       }
                put_tabs(tab); addstr("} \n");
               out_buff(Wid,token);
	    }

        if ((basket_needed(bfptr, 1) > 1)&&(not_class(bfptr)))
           {   put_tabs(tab); addstr("} \n");
               out_buff(Wid,token);
	   }

        if (basket_needed(bfptr,2) > 0)
	  {    put_tabs(tab); addstr("else \n");
               out_buff(Wid,token);
	     }
        if (basket_needed(bfptr,2) > 1)
           {   put_tabs(tab); addstr("{ \n");
               out_buff(Wid,token);
	   }


        for (b = bfptr->entry.template.bl_ptr2; b; b = b->next)
          {                  
              PTR_CMNT cmnt = b->ref->entry.template.cmnt_ptr;
                       token = cdrtext(b->ref,Wid,token,tab+1,curh+1,maxh);
   
          }

        if (basket_needed(bfptr,2) > 1)
           {   put_tabs(tab); addstr("} \n");
               out_buff(Wid,token);
	   }
/*        if (cmnt && cmnt->type != FULL)
            while  (cmnt && cmnt->type != FULL)
                     {  tm_put_string(Wid,cmnt->string,token);
                        cmnt =cmnt->next ;
		      }
         tm_put_string(Wid,"\n",token);
*/
        return (token);


 }



int 
basket_needed(bf, index)
PTR_BFND  bf ;
int index ;
{   PTR_BLOB blob1 ,blob ;

    switch (index) {
    case 1 :
          if (bf->variant == FUNC_HEDR) return(2);
          if (bf->variant == BASIC_BLOCK) return(2);
          blob = bf->entry.template.bl_ptr1 ;
          if (!blob)  return(0) ;
          if (!(blob1= blob->next)) return(1);
          return(2) ;
    case 2 :
          blob = bf->entry.template.bl_ptr2 ;
          if (!blob)  return(0) ;
          if (!(blob1= blob->next)) return(1);
          return(2) ;
	}
  }



void
init_token()
{ char *copys();

/*ridpointers[(int) RID_CHAR] = copys("char");
  ridpointers[(int) RID_VOID] = copys("void");
  ridpointers[(int) RID_FLOAT] = copys("float");
  ridpointers[(int) RID_DOUBLE] = copys("double");   */
  ridpointers[(int) RID_SHORT] = copys("short");
  ridpointers[(int) RID_LONG] = copys("long");
  ridpointers[(int) RID_UNSIGNED] = copys("unsigned");
  ridpointers[(int) RID_SIGNED] = copys("signed");
  ridpointers[(int) RID_CONST] = copys("const");
  ridpointers[(int) RID_VOLATILE] = copys("volatile");
  ridpointers[(int) RID_AUTO] = copys("auto");
  ridpointers[(int) RID_STATIC] = copys("static");
  ridpointers[(int) RID_EXTERN] = copys("extern");
  ridpointers[(int) RID_TYPEDEF] = copys("typedef");
  ridpointers[(int) RID_REGISTER] = copys("register");
  ridpointers[(int) RID_SYN] = copys("syn");
  ridpointers[(int) RID_SHARED] = copys("shared");
  ridpointers[(int) RID_PRIVATE] = copys("private");
  
}

addstr1(index)
int index ;
{
  if (index){ addstr(ridpointers[index]) ;
              addchar(' ');
            }
}



/***************************************************************************/
/*                                                                         */
/*                   generate simple declaration                           */
/*                                                                         */
/***************************************************************************/
gen_simple_type(q_type,dum_pbf,Wid,token,tabs)
PTR_TYPE q_type ;
PTR_BFND dum_pbf ;
int Wid,token,tabs;
{
   PTR_TYPE q ;
   PTR_SYMB s ,symb;
   PTR_BLOB blob ;

    for (q = q_type ; q ; )
    {
     switch (q->variant) {
     case T_POINTER  :
     case T_FUNCTION :
     case T_ARRAY    :
                      q = q->entry.template.base_type ;
                      break ;
     case T_DESCRIPT :
                      addstr1(q->entry.descriptive.access_flag);
                      addstr1(q->entry.descriptive.storage_flag);
                      addstr1(q->entry.descriptive.mod_flag);
                      addstr1(q->entry.descriptive.signed_flag);
                      addstr1(q->entry.descriptive.long_short_flag);
                      q = q->entry.descriptive.base_type ;
                      break ;
      case DEFAULT :  q = (PTR_TYPE ) NULL ;
                      break ;
      case T_DERIVED_TYPE :
                      s = q->entry.derived_type ;
                      switch (s->variant) {
                      case STRUCT_NAME: addstr("struct "); break;
		      case ENUM_NAME:   addstr("enum ");   break;
		      case UNION_NAME:  addstr("union ");  break;
		      case CLASS_NAME:  addstr("class ");  break;
		      case TYPE_NAME:
                      default:
			break ;
		      }
                      addstr(s->ident);
                      addchar(' ');
                      q = (PTR_TYPE) NULL ;
                      break ;

       case T_INT     :
                      addstr("int ");
                      q= (PTR_TYPE) NULL ;
                      break;
       case T_CHAR    :
                      addstr("char ");
                      q= (PTR_TYPE) NULL ;
                      break;
       case T_VOID    :
                      addstr("void ");
                      q= (PTR_TYPE) NULL ;
                      break;
       case T_DOUBLE  :
                      addstr("double ");
                      q= (PTR_TYPE) NULL ;
                      break;
       case T_FLOAT   :
                      addstr("float ");
                      q= (PTR_TYPE) NULL ;
                      break;

       case T_UNION   :
       case T_STRUCT  :
       case T_ENUM    :
       case T_CLASS   :
                      switch (q->variant) {
                      case T_UNION   : addstr("union ") ;
                                       break;
                      case T_STRUCT  : addstr("struct ") ;
                                       break;
                      case T_ENUM    : addstr("enum ") ;
                                       break;
                      case T_CLASS   : addstr("class ") ;
                                       break;
                      }

                      if (symb=q->entry.derived_class.original_class->entry.template.symbol)
                        {   addstr(symb->ident);
                            addchar(' ');
			  }         

                      if (blob= q->entry.derived_class.original_class->entry.template.bl_ptr1)
                        {   addstr(" {\n") ;
                            for ( ; blob ; blob = blob->next)
                             { cdrtext(blob->ref,Wid,token,tabs,0,100);
                               out_buff(Wid,token);
                             }
                            put_tabs(tabs);  addstr("} ");
                          }
                       q = (PTR_TYPE) NULL ;
                       break;
       case T_DERIVED_CLASS:
                    {  PTR_BFND pbf ;
                      pbf = q->entry.derived_class.original_class ;
                      addstr("class");
                      if (symb=pbf->entry.template.symbol) addstr(symb->ident);
                      addstr(" : ");
                      cunp_llnd(pbf->entry.template.ll_ptr2);
                      if (blob=pbf->entry.template.bl_ptr1)
                        {   addstr(" {") ; out_buff(Wid,token);
                            for ( ; blob ; blob = blob->next)
                             cunp_bfnd(Wid,token,tabs,blob->ref);
                            put_tabs(tabs);  addchar("}");
                          }
                      break ;
		    }
       default :      sprintf(buffera,"unexpected type");
       }
   }
 }


/* find_declarator :
 * <1> Given a ll_node <expr_list> to follow ll_ptr1 to find declarator
 * <2> return the symb pointer
 */
PTR_SYMB
find_declarator(expr_list)
PTR_LLND expr_list ;
{
  PTR_SYMB symb;
  PTR_LLND p ;

  if (! expr_list)  return(SMNULL);
  symb = SMNULL ;
  for ( p = expr_list->entry.template.ll_ptr1 ; p ;   )
    {
      switch (p->variant) {
      case BIT_NUMBER:
      case ASSGN_OP :
      case FUNCTION_OP :
      case DEREF_OP : p = p->entry.template.ll_ptr1 ;
                      break ;
      case FUNCTION_REF:
      case ARRAY_REF:
      case VAR_REF:
                      symb = p->entry.template.symbol ;
                      p = LLNULL ;
                      break ;
      }
    }
   return(symb);

}

 


int
cprecedence(op)
int op ;
{   
    switch (op)  {

        case EQ_OP      :   return(7);
        case LT_OP      :   return(6);
        case GT_OP      :   return(6);
        case NOTEQL_OP  :   return(7);
        case LTEQL_OP   :   return(6);
        case GTEQL_OP   :   return(6);
        case ADD_OP     :   return(4);
        case OR_OP      :   return(12);
        case MULT_OP    :   return(3);
        case DIV_OP     :   return(3);
        case MOD_OP     :   return(NULL); /* No such operator */
        case AND_OP     :   return(11);
        case EXP_OP     :   return(9);

        case LE_OP      :   return(6);  /* duplicated */
        case GE_OP      :   return(6);  /* duplicated */
        case NE_OP      :   return(7);  /* duplicated */
        case UNARY_ADD_OP:  return(2);  /* unary operation */
        case SUB_OP     :   return(2);  /* unary operation */
        case SUBT_OP    :   return(11); /* binary operator */
        case MINUS_OP   :   return(2);  /* unary operator */
        case NOT_OP     :   return(2);
	case ARITH_ASSGN_OP:
        case ASSGN_OP   :   return(14);
        case DEREF_OP   :   return(2);
        case POINTST_OP :   return(1);
        case BITAND_OP  :   return(10);
        case BITOR_OP   :   return(10);
        case LSHIFT_OP  :   return(5);
        case RSHIFT_OP  :   return(5);
        case INTEGER_DIV_OP :   return(3);        /* New added for VPC */
        case ADDRESS_OP:    return(2);
        case SIZE_OP   :    return(2);
        case PLUSPLUS_OP:
        case MINUSMINUS_OP: return(2);
        case EXPR_LIST  :    return(15);
        default         :   return(0);
        }

  }





int
mapping(op)
int op ;
{
    switch (op)  {

        case EQ_OP      :   return(20);
        case LT_OP      :   return(16);
        case GT_OP      :   return(17);
        case NOTEQL_OP  :   return(21);
        case LTEQL_OP   :   return(18);
        case GTEQL_OP   :   return(19);
        case ADD_OP     :   return(12);
        case OR_OP      :   return(26);
        case MULT_OP    :   return(9);
        case DIV_OP     :   return(10);
        case MOD_OP     :   return(NULL); /* No such operator */
        case AND_OP     :   return(25);
        case EXP_OP     :   return(23);

        case LE_OP      :   return(18); /* duplicated */
        case GE_OP      :   return(19); /* duplicated */
        case NE_OP      :   return(21); /* duplicated */
        case SUB_OP     :   return(5); /* unary operator */
        case MINUS_OP   :   return(5); /* unary operator */
        case SUBT_OP   :   return(5); /* binary operator */
        case NOT_OP     :   return(1);
        case ASSGN_OP   :   return(27);
        case DEREF_OP   :   return(6);
        case POINTST_OP :   return(0);
        case BITAND_OP  :   return(22);
        case BITOR_OP   :   return(24);
        case LSHIFT_OP  :   return(15);
        case RSHIFT_OP  :   return(14);
        case MINUSMINUS_OP: return(4);             /* New added for VPC */
        case PLUSPLUS_OP  : return(3);             /* New added for VPC */
        case UNARY_ADD_OP : return(12);            /* New added for VPC */
        case BIT_COMPLEMENT_OP :return(2);         /* New added for VPC */
        case INTEGER_DIV_OP :   return(11);        /* New added for VPC */
        case SIZE_OP :       return(8);            /* New added for VPC */
        case ADDRESS_OP:     return(7);
        default         :   sprintf(buffera, "bad case 1");
                            return(0);
	}

  }






int
not_class(pbf)
PTR_BFND pbf;
{
  switch(pbf->variant) {
  case GLOBAL :
  case CLASS_DECL :
  case UNION_DECL :
  case STRUCT_DECL :
  case ENUM_DECL :
  case FUNC_HEDR :
  case DERIVED_CLASS_DECL:  return(0);
    default :               return(1);
  }

}





void
gen_func_hedr(functor,pbf,Wid,token,tabs)
PTR_SYMB functor ;
PTR_BFND pbf ;
int      Wid ,token,tabs ;
{ PTR_SYMB s ;
  PTR_TYPE q ;
  int i;

  for (q = functor->type; q ;   )
    { 
       switch ( q->variant) {
       case T_POINTER : 
                       addchar('*');
                       q = q->entry.template.base_type ;
                       break;
        default:   /* It might need more for complicated case */
                       q = (PTR_TYPE) NULL ;
	}
     }

  addstr(functor->ident);
  addchar('(') ;
  for ( i=0, s = functor->entry.member_func.in_list ; s ; i++ )
    { if (i)  addchar(',');  
      if (not_explicit(s, pbf))
       {  gen_simple_type(s->type,BFNULL , Wid,token,tabs);
          for (q = s->type; q ;   )
           { 
              switch ( q->variant) {
              case T_POINTER : 
                       addchar('*');
                       q = q->entry.template.base_type ;
                       break;
              default:   /* It might need more for complicated case */
                       q = (PTR_TYPE) NULL ;
        	}
            }
          
        }
      addstr(s->ident);
      s = s->entry.var_decl.next_in ;
    }
  addchar(')') ;


} 



is_param_decl(var_bf, functor)
PTR_BFND var_bf ;
PTR_SYMB functor ;
{
  PTR_LLND flow_ptr,lpr ;
  int i ;
  PTR_SYMB s ;

   switch (var_bf->variant) {
   case VAR_DECL :
   case ENUM_DECL:
   case CLASS_DECL:
   case UNION_DECL:
   case STRUCT_DECL:
   case DERIVED_CLASS_DECL :
      lpr = var_bf->entry.template.ll_ptr1 ;
      for ( flow_ptr = lpr;flow_ptr ;flow_ptr = flow_ptr->entry.template.ll_ptr1)
       {  if ((flow_ptr->variant == VAR_REF) ||
              (flow_ptr->variant == ARRAY_REF) ||
              (flow_ptr->variant == FUNCTION_REF) ) break ;
        }
      if (!flow_ptr) { /* err("system crash");  */
                        return(NULL) ;
                     }

      for ( i=0, s = functor->entry.member_func.in_list ; s ; i++ )
      { 
            if (flow_ptr->entry.template.symbol == s) return(1);
            s = s->entry.var_decl.next_in ;
       }
      return(0);

      default :   return(0) ;
    }

}





gen_descriptive_type(symb1)
PTR_SYMB symb1 ;
{
  PTR_TYPE q ;

  for (q = symb1->type; q ;   )
    { 
       switch ( q->variant) {
       case T_POINTER : 
       case T_FUNCTION :
                       q = q->entry.template.base_type ;
                       break;
       case T_DESCRIPT :
                      addstr1(q->entry.descriptive.access_flag);
                      addstr1(q->entry.descriptive.storage_flag);
                      addstr1(q->entry.descriptive.mod_flag);
                      addstr1(q->entry.descriptive.signed_flag);
                      addstr1(q->entry.descriptive.long_short_flag);
                      q = q->entry.descriptive.base_type ;
                      break ;
        default:   /* It might need more for complicated case */
                       q = (PTR_TYPE) NULL ;
		     }
     }


} 




not_explicit(s, pbf)
PTR_SYMB  s ;
PTR_BFND pbf ;

{
PTR_BLOB blob ;
PTR_LLND lptr1,lptr2 ;
PTR_SYMB symbptr;
PTR_SYMB find_declarator();	


   for (blob = pbf->entry.template.bl_ptr1 ; blob ; blob = blob->next )
     {
        if (!this_is_decl(blob->ref->variant )) return(1);
        for ( lptr1=blob->ref->entry.template.ll_ptr1 ; lptr1  ; lptr1 = lptr1->entry.template.ll_ptr2)
          { symbptr = find_declarator(lptr1);
            if ( s == symbptr) return(0);
	  }
      }
    return(1);
    	
}




this_is_decl(variant)
int variant ;
{
  switch(variant) {

  case CLASS_DECL :
  case UNION_DECL :
  case STRUCT_DECL :
  case ENUM_DECL :
  case VAR_DECL :
  case DERIVED_CLASS_DECL:  return(1);
    default :               return(0);
  }

}








/* <1> Given a ll_node which is supposed to be a ll_ptr1 of expr_list node
 * <2> Intelligent routine will try to find declarator in this branch
 * <3> The following node is possible delarator
 *     ARRAY_REF  VAR_REF  FUNCTION_REF
 */
PTR_LLND 
find_suit_declarator_at_unp(low_node)
PTR_LLND  low_node ;

{  PTR_LLND flow_ptr;
   for ( flow_ptr = low_node;flow_ptr ;flow_ptr = flow_ptr->entry.template.ll_ptr1)
     {  if ((flow_ptr->variant == VAR_REF) ||
            (flow_ptr->variant == ARRAY_REF) ||
            (flow_ptr->variant == FUNCTION_REF) ) return(flow_ptr);
      }
    if (!flow_ptr) { err("system crash");
                     return(LLNULL) ;
                   }
 }



gen_op( value)
int value;
{
  switch (value) {
  case ((int) PLUS_EXPR) : addstr("+= ");
                           break;
  case ((int) MINUS_EXPR): addstr("-= ");
                           break;
  case ((int) BIT_AND_EXPR):addstr("&= ");
                           break;
  case ((int) BIT_IOR_EXPR):addstr("|= ");
                           break;
  case ((int) MULT_EXPR):  addstr("*= ");
                           break;
  case ((int) TRUNC_DIV_EXPR): addstr("/= ");
                           break;
  case ((int) TRUNC_MOD_EXPR): addstr("%= ");
                           break;
  case ((int) BIT_XOR_EXPR): addstr("^= ");
                           break;
  case ((int) LSHIFT_EXPR): addstr("<<= ");
                           break;
  case ((int) RSHIFT_EXPR): addstr(">>= ");
                           break;
  default : addstr("= ");
 
  }

}




/****************************************************************************/
/* subroutine to generate the type of cast_op                               */
/* It will fit the future of vector type                                    */
/****************************************************************************/
put_right(s, temp_buf)
char *s ;
char *temp_buf;
{
    int len,i ;
    char *p;
      
    i=0;
    len = strlen(temp_buf) ;
    p = s ;
    for ( p ; *p ; p++,i++)
        *(temp_buf + len+ i) = *p ;
    *(temp_buf+len+i+1) = '\0';

}


put_left(s, temp_buf)
char *s ;
char *temp_buf;
{
    int i ;
    char *p;
    int len1 ,len2;      

    len1 = strlen(s);
    len2 = strlen(temp_buf) ;
    *(temp_buf+len2+len1) = '\0';
    for ( i=len2 ; i ; i--)
        *(temp_buf + len1+ i-1) = *(temp_buf + i -1 );
    for ( i=0,p = s ; *s ; i++,s++)
        *(temp_buf + i ) = *s ;

}
/* similar to gen_simple_type, but stronger */
gen_simple_type_2(q_type,dum_pbf,Wid,token,tabs)
PTR_TYPE q_type ;
PTR_BFND dum_pbf ;
int Wid,token,tabs;
{
   PTR_TYPE q ;
   PTR_SYMB s ,symb;
   PTR_BLOB blob ;
   char *old_bp;
   int level ;
   PTR_BFND pbf;

   level= 0 ;
   clean(temp_buf);
    for (q = q_type ; q ; )
    {
     switch (q->variant) {
     case T_POINTER  :
        put_left("*",temp_buf);
	level = 1;
	q = q->entry.template.base_type ;
	break;
     case T_FUNCTION :
        put_left("(",temp_buf);
	put_right(")",temp_buf);
	put_right("()",temp_buf);
	q = q->entry.template.base_type ;
	break;
     case T_ARRAY    :
        if (level >0) {
	    put_left("(",temp_buf);
	    put_right(")",temp_buf);
	  }
	clean(temp1_buf);
	old_buff_base1 = buff_base;  /* Backup before switching buffer */
	put_left(buffer,temp1_buf);  /* Backup before switching buffer */
	clean(buffer);
	buff_base = 0;
	cunp_llnd(q->entry.ar_decl.ranges);
	put_right(buffer,temp_buf);
	clean(buffer);
	buff_base = old_buff_base1;
	put_left(temp1_buf,buffer);
	q = q->entry.template.base_type ;
	break ;
     case T_DESCRIPT :
	clean(temp1_buf);
	old_buff_base1 = buff_base;  /* Backup before switching buffer */
	put_left(buffer,temp1_buf);  /* Backup before switching buffer */
	clean(buffer);
	buff_base = 0;
        addstr1(q->entry.descriptive.access_flag);
        addstr1(q->entry.descriptive.storage_flag);
        addstr1(q->entry.descriptive.mod_flag);
        addstr1(q->entry.descriptive.signed_flag);
        addstr1(q->entry.descriptive.long_short_flag);
	put_left(buffer,temp_buf);
	clean(buffer);
	buff_base = old_buff_base1;
	put_left(temp1_buf,buffer);
        q = q->entry.descriptive.base_type ;
        break ;
    case DEFAULT : 
	put_left("int ",temp_buf);
        q = (PTR_TYPE ) NULL ;
        break ;
    case T_DERIVED_TYPE :
	clean(temp1_buf);
	old_buff_base1 = buff_base;  /* Backup before switching buffer */
	put_left(buffer,temp1_buf);  /* Backup before switching buffer */
	clean(buffer);
	buff_base = 0;
        s = q->entry.derived_type ;
        switch (s->variant) {
	case STRUCT_NAME: addstr("struct "); break;
	case ENUM_NAME:   addstr("enum ");   break;
	case UNION_NAME:  addstr("union ");  break;
	case CLASS_NAME:  addstr("class ");  break;
	case TYPE_NAME:
	default:
	  break ;
	}
	addstr(s->ident);
	addstr(" ");
	put_left(buffer,temp_buf);
	clean(buffer);
	buff_base = old_buff_base1;
	put_left(temp1_buf,buffer);
	q = (PTR_TYPE) NULL ;
	break ;
   case T_INT     :
       put_left("int ",temp_buf);
       q= (PTR_TYPE) NULL ;
       break;
   case T_CHAR    :
       put_left("char ",temp_buf);
       q= (PTR_TYPE) NULL ;
       break;
   case T_VOID    :
        put_left("void ",temp_buf);
        q= (PTR_TYPE) NULL ;
        break;
   case T_DOUBLE  :
        put_left("double ",temp_buf);
        q= (PTR_TYPE) NULL ;
        break;
   case T_FLOAT   :
        put_left("float ",temp_buf);
        q= (PTR_TYPE) NULL ;
        break;
     
   case T_UNION   :
   case T_STRUCT  :
   case T_ENUM    :
   case T_CLASS   :
     clean(temp1_buf);
     old_buff_base1 = buff_base;  /* Backup before switching buffer */
     put_left(buffer,temp1_buf);  /* Backup before switching buffer */
     clean(buffer);
     buff_base = 0;
     switch (q->variant) {
     case T_UNION   : addstr("union ") ;
       break;
     case T_STRUCT  : addstr("struct ") ;
       break;
     case T_ENUM    : addstr("enum ") ;
       break;
     case T_CLASS   : addstr("class ") ;
       break;
     }
     if (symb=q->entry.derived_class.original_class->entry.template.symbol)
       {   addstr(symb->ident);
	   addstr(" ");
	 }         
     if (blob= q->entry.derived_class.original_class->entry.template.bl_ptr1)
       {   addstr(" {\n") ;
	   for ( ; blob ; blob = blob->next)
	     { cdrtext(blob->ref,Wid,token,tabs,0,100);
	       addstr("\n");
	     }
	   put_tabs(tabs);  addstr("} ");
	 }
     put_left(buffer,temp_buf);
     clean(buffer);
     buff_base = old_buff_base1;
     put_left(temp1_buf,buffer);
     q = (PTR_TYPE) NULL ;
     break;
   case T_DERIVED_CLASS:
     {  PTR_BFND pbf ;
	clean(temp1_buf);
	old_buff_base1 = buff_base;  /* Backup before switching buffer */
	put_left(buffer,temp1_buf);  /* Backup before switching buffer */
	clean(buffer);
	buff_base = 0;
	pbf = q->entry.derived_class.original_class ;
	addstr("class");
	if (symb=pbf->entry.template.symbol) addstr(symb->ident);
	addstr(" : ");
	cunp_llnd(pbf->entry.template.ll_ptr2);
	if (blob=pbf->entry.template.bl_ptr1)
	  {   addstr(" {") ; 
	      for ( ; blob ; blob = blob->next)
		cunp_bfnd(tabs,blob->ref);
	      put_tabs(tabs);  
	      addstr("}");
	    }
	put_left(buffer,temp_buf);
	clean(buffer);
	buff_base = old_buff_base1;
	put_left(temp1_buf,buffer);
	q = (PTR_TYPE) NULL ;
	break ;
      }
     default :      sprintf(buffera,"unexpected type");
      
      }
   }   
   addstr(temp_buf);
 }

