
/* utility.c for PC++                            */
/* Created by Jenq-Kuen Lee Dec 16, 1989         */


#include "vparse.h"
#include "tag"
#include "vpc.h"
#include "db.h"
#include "vextern.h"
#include "y++.tab.h"

extern int    store_overloaded_flag;
PTR_BLOB follow_blob();
PTR_TYPE follow_type() ;
PTR_LLND follow_record_id(),follow_llnd();
PTR_BFND chain_up();
PTR_LLND find_suit_declarator();			
PTR_SYMB find_type_symbol_global();
PTR_SYMB match_name(),find_type_symbol(),install_entry_2();
PTR_TYPE fetch_type_for_constructor();
PTR_HASH find_entry_from_type();
extern  PTR_SYMB count_first();
extern  int      count_fields_num(),count_record_size();
PTR_TYPE follow_type_1();
PTR_TYPE follow_type_2();
PTR_SYMB check_extern_second_part();
PTR_BFND not_until_classnode();
PTR_SYMB install_duplicate_entry();
PTR_SYMB find_parameter_name();
PTR_SYMB find_object_symbol();
PTR_BFND find_class_bfnd();
PTR_SYMB check_field_decl_3();
PTR_SYMB check_field_decl_4();
PTR_TYPE adjust_array_type();
PTR_HASH look_up_type();
PTR_SYMB find_proc_name();
PTR_LLND lazy_install(),func_declarator_appear();
PTR_LLND chain_type_declarator();
PTR_TYPE copy_type_list();
PTR_TYPE chain_up_type();
PTR_TYPE type_conversion();
PTR_SYMB find_element();
PTR_SYMB find_current_superobject();
name_of_struct(i)
int i;
{

 switch(i) {
 case  STRUCT:
   return(STRUCT_NAME);
 case CLASS:
   return(CLASS_NAME);
 case COLLECTION:
   return(COLLECTION_NAME);
 default:
   err("wrong struct names");
 }

}


node_of_struct(i)
int i;
{

 switch(i) {
 case  STRUCT:
   return(STRUCT_DECL);
 case CLASS:
   return(CLASS_DECL);
  case COLLECTION:
   return(COLLECTION_DECL);
 default:
   err("wrong struct names");
 }

}



type_of_struct(i)
int i;
{

 switch(i) {
 case  STRUCT:
   return(T_STRUCT);
 case CLASS:
   return(T_CLASS);
 case COLLECTION:
   return(T_COLLECTION);
 default:
   err("wrong struct names");
 }

}


/*
  This routine set up the new flag for the class_decl bif node
*/
change_public_flag(i)
{
  int k;

  k = (int) pred_bfnd->prop_list;
  switch (i) {
  case  PUBLIC_FIELD:
  case  PROTECTED_FIELD:
  case  PRIVATE_FIELD:
     pred_bfnd->prop_list = (pred_bfnd->variant==COLLECTION_DECL)?
                           (PTR_PLNK)( i| COLLECTION_FIELD) : (PTR_PLNK) i ;
     break;
  case ELEMENT_FIELD:
     pred_bfnd->prop_list = (PTR_PLNK) (i | PUBLIC_FIELD);
   }


}


area()
{
 PTR_BFND p;

  for (p =pred_bfnd;((p->variant != FUNC_HEDR)&&(p->variant != GLOBAL)) ;
       p = p->control_parent) ;

  if (p->variant==GLOBAL) return(ALL_FIELDS);
  if (p->entry.template.symbol->attr & ELEMENT_FIELD)
      return(ELEMENT_ONLY);
  return(ALL_FIELDS);
}


/**************************************************************************/
/*                                                                        */
/* The followings are the routines to handle parameterized type-checking  */
/*                                                                        */
/**************************************************************************/
/*
 This routine substitute the elementtype with real/correct type
*/
PTR_TYPE
substitute_element_type(passing_type, element_type)
PTR_TYPE passing_type;
PTR_TYPE element_type;
{ PTR_TYPE type,old_type ;
  PTR_SYMB symb;

   for (old_type=type=passing_type ;type ; )
   {  
       switch(type->variant) {
       case T_ARRAY :
       case T_FUNCTION :
       case T_POINTER  :
       case T_REFERENCE:
       case T_DESCRIPT :
	 old_type = type ;
	 type = type->entry.template.base_type ;
	 break;
       case T_DERIVED_TYPE :
	 symb = type->entry.derived_type;
	 if (symb== elementtype_symb) {
	   if (type==passing_type) type = element_type;
	   else  {
	      type = copy_type_list(passing_type,old_type);
	      if (type) type->entry.template.base_type= element_type;
	      else      type = element_type;
	    }
	   return(type);
	 }
	 else {
	   old_type = type ;
	   if (!(type = symb->type)) return(passing_type);
	 }
	 break;
       case T_DERIVED_COLLECTION:
       default :
            type = (PTR_TYPE) NULL ;
      }
     }

return(passing_type);
}

/* Utility routine for substitute_element_type
   copy_type_list: Given a type and return a copy of the type which
                   is structurally equivalent to the old one.

   duplicated node: T_POINTER, T_FUNCTION, T_DESCRIPT, T_POINTER
   same node      : T_CHAR, T_FLOAT ... T_STRUCT, T_DERIVED_COLLECTION
   eliminated/reduce node: T_DERIVED_TYPE
   

   copy_type_list will stop in the type stop_node and it will copy the
                  whole type list if stop_node is NULL
		  (The stop_node is included in the copy process.)

*/

PTR_TYPE
copy_type_list(passing_type,stop_node)
PTR_TYPE passing_type;
PTR_TYPE stop_node;
{ 
 PTR_TYPE new_type,old_type,next_type,one_type;
  
  new_type = NULL;
  for (next_type= passing_type; next_type;  )
   {  
     
     switch(next_type->variant) {
     case T_ARRAY :
       old_type = next_type;
       one_type = get_type(fi,T_ARRAY);
       new_type=chain_up_type(one_type,new_type);
       one_type->entry.ar_decl.ranges = next_type->entry.ar_decl.ranges;
       one_type->entry.ar_decl.num_dimensions = next_type->entry.ar_decl.num_dimensions;
       next_type = next_type->entry.template.base_type ;
       break;
     case T_FUNCTION :
     case T_POINTER  :
     case T_REFERENCE:
     case T_DESCRIPT : 
       old_type = next_type;
       one_type = get_type(fi,next_type->variant);
       new_type =chain_up_type(one_type,new_type);
       one_type->entry.template.ranges = next_type->entry.template.ranges;
       one_type->entry.template.dummy1 = next_type->entry.template.dummy1;
       one_type->entry.template.dummy2 = next_type->entry.template.dummy2;
       one_type->entry.template.dummy3 = next_type->entry.template.dummy3;
       one_type->entry.template.dummy4 = next_type->entry.template.dummy4;
       one_type->entry.template.dummy5 = next_type->entry.template.dummy5;
       next_type = next_type->entry.template.base_type ;
       break;
     case T_DERIVED_TYPE :
       old_type = next_type;
       next_type = next_type->entry.derived_type->type;
       break;
    case T_DERIVED_COLLECTION:
    case T_COLLECTION:
    case T_CLASS:
    case T_UNION:
    case T_ENUM:
    default:
       old_type = next_type;
       new_type =chain_up_type(next_type,new_type);
       next_type= NULL;
     }
     if (old_type==stop_node) break;
   }
 return(new_type);
}


/*
  adjust_element_type
  return the new_type after the substitution or the old type when 
  no substitution occurs.
*/

PTR_TYPE
adjust_element_type(pllnd,field_type)
PTR_LLND pllnd;
PTR_TYPE field_type;
{
  PTR_TYPE type,element_type,new_type;
  int level,sw;

  if (pllnd->variant==THIS_NODE) return(field_type);
  type = field_type;
  type = follow_type_2(type, &level,&sw);
  if (!((type->variant==T_DERIVED_TYPE)&&
      (type->entry.derived_type==elementtype_symb))) return(field_type);

  /* now check if the LHS's type  is T_DERIVED_COLLECTION */
  type = pllnd->type;
  type = follow_type_1(type,&level,&sw);
  if (type->variant==T_DERIVED_COLLECTION) {
    element_type= type->entry.col_decl.base_type;
    new_type = substitute_element_type(field_type, element_type);
    return(new_type);
  }
  return(field_type);
}



/**************************************************************************/
/* Routines to Handle Operator Overloading                                */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/**************************************************************************/



/**************************************************************************/
/*  Find_overloaded_operator()                                            */
/*  expr1: the object expression                                          */
/*  expr2: the argument expression                                        */
/*  operator: the variant of the C operator                               */
/*  flag : Unary                                                          */
/*         Binary                                                         */
/*         Multiple (in this case, expr2 is expr_list)                    */
/**************************************************************************/
PTR_SYMB
find_overloaded_operator(expr1,expr2, operator_ident)
PTR_LLND expr1,expr2;
char *operator_ident;
{
  PTR_SYMB object,symb,element,object_base;
  PTR_TYPE type,elementtype,type1;
  int level ,sw;
  PTR_BFND pbf;   
  
  element =symb=  object= SMNULL;
  elementtype =NULL;
  type = follow_type_2(expr1->type,&level,&sw);
  if (!type) return(NULL);
  if (level==0){
    switch (type->variant) {
    case T_DERIVED_COLLECTION:
      object = type->entry.col_decl.collection_name;
      elementtype = type->entry.col_decl.base_type;
      break;
    case T_COLLECTION:
    case T_CLASS:
    case T_STRUCT:
      pbf=type->entry.derived_class.original_class;
      if (pbf) object= pbf->entry.template.symbol;
      break;
    default:
      type1= follow_type_1(type, &level,&sw);
      if (sw==YES){
	type1= follow_type_2(type, &level,&sw);
	if ((!strcmp(type1->entry.derived_type->ident,"ElementType")) &&
	    (level==0))
	  {
	    object_base= find_current_superobject();
	    if (object_base)
	      symb=check_field_decl_4(object_base,operator_ident,expr2,ELEMENT_ONLY,0);
	    else   symb =NULL;
	    return(symb);
	  }
      }
    }

    if (object) {
      symb = check_field_decl_4(object,operator_ident,expr2,ALL_FIELDS,0);
    }
    if (!symb) {
      if (elementtype) element = find_element(elementtype);
      if (element) {
	symb=check_field_decl_4(element,operator_ident,expr2,CLASS_ONLY,0);
	/* we are looking at a collection and elementwise parameter */
	if (!symb) 
	  symb=check_field_decl_4(element,operator_ident,expr2,CLASS_ONLY,1);
      }
    }
  }
return(symb);
}
  

  
/*
  Do the conventional type_conversion 
  or 
  processing the overloaded operator
  Limitation: Only used for binary or unary overloaded operator.
              [], SIZEOF,CAST_OP, (), NEW, and Delete, are excluded

  flag: if (flag) then type_conversion is needed
*/
typeconversion_or_oo_handling(expr1,expr2, op,expr3,flag)
PTR_LLND expr1,expr2;
PTR_LLND expr3;
char *op;
{
  PTR_SYMB symb;

  symb=find_overloaded_operator(expr1,expr2, op);
  if (!symb) {
    if (flag) expr3->type = type_conversion(expr1->type,expr2->type);
    return(0);
  }
  else {
    expr3->type = adjust_element_type(expr1,symb->type);
    if (store_overloaded_flag) {
      if ((expr3->variant==FUNC_CALL)||(expr3->variant==ARRAY_REF))
	expr3->entry.template.ll_ptr2=make_llnd(fi,VAR_REF,NULL,NULL,symb);
      else
	expr3->entry.template.symbol = symb;
    }
    return(1);
  }


}





char *
map_op( value)
int value;
{

  switch (value) {
  case ((int) PLUS_EXPR) : return("+=");
                           
  case ((int) MINUS_EXPR): return("-=");
                           
  case ((int) BIT_AND_EXPR):return("&=");
                           
  case ((int) BIT_IOR_EXPR):return("|=");
                           
  case ((int) MULT_EXPR):  return("*=");
                           
  case ((int) TRUNC_DIV_EXPR): return("/=");
                           
  case ((int) TRUNC_MOD_EXPR): return("%=");
                           
  case ((int) BIT_XOR_EXPR): return("^=");
                           
  case ((int) LSHIFT_EXPR): return("<<=");
                           
  case ((int) RSHIFT_EXPR): return(">>=");
                                
  case LE_EXPR:
           return("<=");
  case GE_EXPR:
          return(">=");
  case EQ_EXPR:
          return("==");
  case NE_EXPR:
          return("!=");
  default : return("=");
 
  }
  
}



char *
map_unop(i)
int i;
{


   switch(i) {
    case ADDRESS_OP: return("&");
    case MINUS_OP:  return("-");
    case UNARY_ADD_OP: return("+");
    case PLUSPLUS_OP:  return("++");
    case MINUSMINUS_OP:return("--");
    case BIT_COMPLEMENT_OP: return("~");
    case NOT_OP: return("!");
    default:
       return("+");
    }

}
