
/* vclass.c for VPC++                            */
/* Created by Jenq-Kuen Lee Dec 16, 1989         */
     	
#include "vparse.h"
#include "tag"
#include "vpc.h"
#include "db.h"
#include "vextern.h"

PTR_BLOB follow_blob();
PTR_TYPE follow_type() ;
PTR_LLND follow_record_id(),follow_llnd();
PTR_BFND chain_up();
PTR_LLND find_suit_declarator();			
PTR_SYMB find_type_symbol_global();
PTR_SYMB match_name(),find_type_symbol(),install_entry_2();
PTR_TYPE fetch_type_for_constructor();
PTR_HASH find_entry_from_type();
extern  PTR_SYMB count_first();
extern  int      count_fields_num(),count_record_size();
PTR_TYPE follow_type_1();
PTR_TYPE follow_type_2();
PTR_SYMB check_extern_second_part();
PTR_BFND not_until_classnode();
PTR_SYMB install_duplicate_entry();
PTR_SYMB find_parameter_name();
PTR_SYMB find_object_symbol();
PTR_BFND find_class_bfnd();
PTR_SYMB check_field_decl_3();
PTR_TYPE adjust_array_type();
PTR_HASH look_up_type();
PTR_SYMB find_proc_name();
PTR_LLND lazy_install(),func_declarator_appear();
PTR_LLND chain_type_declarator();
extern PTR_TYPE global_elementtype;            /* new added for PC++*/
/*
  The routine to actually install object::field
  (1) check if the object is legally derived with the current object
  (2) if yes, then use the object to find the proper field
  (3) do some preparing work for the coming [] or () just like
      "primary . identifier" generated
  (4) generate proper low level nodes just like  
      "primary . identifier" generated
*/


PTR_LLND
install_scope_operator(object_type_entry,field_entry,current_pred_bfnd)
PTR_HASH object_type_entry,field_entry;
PTR_BFND current_pred_bfnd;
{
  PTR_SYMB object,symbol;
  PTR_BFND class_bfnd;
  PTR_LLND ll,l_ptr1,l_ptr2;
  int sw,tag;
  

  object = find_object_symbol(object_type_entry);                 
  if (is_object_legal(object,current_pred_bfnd)) {
    symbol=check_field_decl_3(object,field_entry,0,CLASS_ONLY);
    if (!symbol){ err("error member"); return(LLNULL);}
    else {
      tag  = map2( symbol->variant)  ;
      l_ptr2 = make_llnd(fi,tag,LLNULL,LLNULL,symbol);
      l_ptr1 = make_llnd(fi,VAR_REF,LLNULL,LLNULL,object);
      ll = make_llnd(fi,SCOPE_OP,l_ptr1,l_ptr2,SMNULL);
      ll->type = adjust_array_type(symbol);
      return(ll);
    }
  }
 else err("improper derived class");
 return(LLNULL);
  

}


is_object_legal(object,pbf)
PTR_SYMB object;
PTR_BFND pbf;
{
  /* temporarily */
  return(1);
}




PTR_BFND
find_class_bfnd(object)
PTR_SYMB object;
{ int level,temp_sw;
  PTR_TYPE type;

/*  if (!(object->type) ) return((PTR_BFND)object->id_list); */
  type = follow_type_1(object->type,&level,&temp_sw);
  if ((type->variant== T_CLASS)||(type->variant==T_STRUCT)||
      (type->variant==T_UNION)||
      (type->variant==T_ENUM)||(type->variant==T_COLLECTION))
      return(type->entry.derived_class.original_class);
  else err("unexpected class/struct constructs");
  return((PTR_BFND)NULL);
}


PTR_HASH
look_up_expanded_string(entry)
PTR_HASH  entry;
{
  char tmp[256],*s1;
  int  status;
  PTR_SYMB symb;

  s1 = tmp;
  *s1++ = '~';
  strcpy(s1,entry->ident);
  s1 = copys(tmp);
  return(look_up_type(s1,&status));
}





set_func_hedr2_with_typename(type,pllnd,flag)
PTR_TYPE type;
PTR_LLND pllnd;
{
  PTR_LLND ll,lptr2;
  PTR_BLOB blob;
  PTR_BFND bf1;
  PTR_TYPE ptr1;
  PTR_SYMB symb;
  PTR_SYMB dummy_symb;
  PTR_HASH entry;
  PTR_TYPE new_type;

  if ((type->variant!= T_DESCRIPT)&&(type->variant!=T_DERIVED_TYPE))
    err("illegal syntax");
  entry = find_entry_from_type(type);
  if (flag)   entry = look_up_expanded_string(entry);
  new_type = fetch_type_for_constructor(type);
  main_type_flag = TYPE_TWO;
  ll = lazy_install(entry,VARIABLE_NAME,NO);
  symb = find_proc_name();
  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
      (ll->variant == FUNCTION_REF))                 
    transform_symb_node(symb);
  ll = func_declarator_appear(ll,pllnd,symb) ;
  lptr2 = chain_type_declarator(new_type,OFF,ll,&dummy_symb,YES);
  blob = follow_blob(pred_bfnd);
  bf1 = blob->ref ;
  bf1->variant = FUNC_HEDR ;
  bf1->entry.template.symbol = symb;
  /*
    if (symb->entry.member_func.seen == FUNCTION_BODY_APPEAR)
    { 
    err(" redeclaration function module "); 
    }
    else   symb->entry.member_func.seen = FUNCTION_BODY_APPEAR;
  */
  symb->entry.member_func.seen = FUNCTION_BODY_APPEAR;
  change_param_scope(symb,bf1);
  pred_bfnd = bf1 ;
  main_type_flag = TYPE_FOUR ;
  fill_type_for_param(pred_bfnd->entry.template.symbol);
  
}





set_func_hedr3_with_typename()
{
  PTR_LLND ll,lptr2;
  PTR_BLOB blob;
  PTR_BFND bf1;
  PTR_TYPE ptr1;
  PTR_SYMB symb;

/* Since it will be set at base_list:set_func_hedr, so we don't do it again */
/*
  blob = follow_blob(pred_bfnd);
  bf1 = blob->ref ;
  bf1->variant = FUNC_HEDR ;
  symb = bf1->entry.template.symbol;
  symb->entry.member_func.seen = FUNCTION_BODY_APPEAR;
  change_param_scope(symb,bf1);
  pred_bfnd = bf1 ;
*/
  main_type_flag = TYPE_FOUR ;

 
  
}

/*****************************************************************/
/* find the right function symbol for overloaded function        */
/*****************************************************************/
PTR_SYMB
find_overloading_function(functor)
PTR_SYMB  functor;
{

PTR_SYMB  new_arg_list,arg_list,symb;
int       n,n1;
PTR_TYPE new_return_type;

 if (functor->variant != MEMBER_FUNC) return(NULL);
 if (!functor->entry.member_func.symb_list)  return(NULL);
 /* Put everything back to normal setup */
 new_arg_list = functor->entry.member_func.in_list;
 functor->entry.member_func.in_list=functor->entry.member_func.out_list;
 functor->entry.member_func.symb_list =(PTR_SYMB) NULL;
 functor->entry.member_func.out_list = (PTR_SYMB) NULL;
 new_return_type = functor->type;
 if (functor->ud_chain) functor->type= (PTR_TYPE) functor->ud_chain;

 n= num_of_args(new_arg_list);
 for ( symb = functor; symb;   )
   {
     if (symb->variant == FIELD_NAME)
       symb = symb->entry.field.next;
     else  {
       arg_list = symb->entry.member_func.in_list;
       n1 = num_of_args(arg_list);
       if ((!strcmp(functor->ident,symb->ident))&&
	   is_type_matched_in_arglist(new_arg_list,arg_list,1)&&
	   ((n1==n)&&is_same_type_conversion(new_return_type,symb->type))||
	   (is_void_in_arglist(n,arg_list)))
            break;
       else   symb=symb->entry.member_func.next;

     }
   }
 if (!symb) warning("function type mismatched");
 else  symb->entry.member_func.in_list = new_arg_list;
 return(symb);
  
}

int
num_of_args(list)
PTR_SYMB list;
{
  int i;
  PTR_SYMB first;

  for (i=0,first = list;first ;i++ )
    {
      first = first->entry.var_decl.next_in;
    }
  return(i);
}

/* flag ==1 then both are arg_list
   flag ==2 then the first one is expr_list and the second one is arg_list
   flag ==3 then the first one is expr_list and the second one is arg_list
            but the type of the arguements can be a collection of 
	    the original  argument type
   flag ==4 then both of them are arg_lists but one of them might with
            element_type
	    
*/
int
is_type_matched_in_arglist(new_arg_list,arg_list,flag)
PTR_SYMB new_arg_list;
PTR_SYMB arg_list;
{
  PTR_SYMB old,new;
  PTR_TYPE type;
  PTR_LLND expr_list,p1;

  switch (flag) {
  case 1:
    for (new =new_arg_list,old=arg_list;new ; )
      {
	if ((!new)&&(!old)) return(1);
	if ((!new)||(!old)) return(1);
	if (!is_same_type_conversion(new->type,old->type)) return(0);
	old = old->entry.var_decl.next_in;
	new = new->entry.var_decl.next_in;
      }
    if (old) return(0);
    return(1);
  case 4:
    for (new =new_arg_list,old=arg_list;new ; )
      {
	if ((!new)&&(!old)) return(1);
	if ((!new)||(!old)) return(1);
	if (!is_same_type_with_elementtype(new->type,old->type)) return(0);
	old = old->entry.var_decl.next_in;
	new = new->entry.var_decl.next_in;
      }
    if (old) return(0);
    return(1);
  case 2:
    if ((!new_arg_list)||(!arg_list)) return(1);
    expr_list = (PTR_LLND) new_arg_list;
    if (expr_list->variant != EXPR_LIST) {
        /* sigle expression without expr_list */
	type = expr_list->type;
	if ((!is_same_type_conversion(type,arg_list->type))&&
            (!is_in_the_exception(type,arg_list->type,expr_list)))
	  return(0);
        else    return(1);
   }
   else {
    for (p1 =expr_list ,old=arg_list;p1 ;p1=p1->entry.template.ll_ptr2 )
      {
	if (!(type =p1->entry.template.ll_ptr1->type)) type = global_int;
	if ((!is_same_type_conversion(type,old->type))&&(!is_in_the_exception(type,old->type,p1->entry.template.ll_ptr1)))
	  return(0);
	old = old->entry.var_decl.next_in;
      }
    if (old) return(0);
    return(1);
  }
  case 3:
    if ((!new_arg_list)||(!arg_list)) return(1);
    expr_list = (PTR_LLND) new_arg_list;
    if (expr_list->variant != EXPR_LIST) {
        /* sigle expression without expr_list */
	type = expr_list->type;
	if ((!is_about_same_type_conversion(type,arg_list->type))&&
            (!is_in_the_exception(type,arg_list->type,expr_list)))
	  return(0);
        else    return(1);
   }
   else {
    for (p1 =expr_list ,old=arg_list;p1 ;p1=p1->entry.template.ll_ptr2 )
      {
	if (!(type =p1->entry.template.ll_ptr1->type)) type = global_int;
	if ((!is_about_same_type_conversion(type,old->type))&&(!is_in_the_exception(type,old->type,p1->entry.template.ll_ptr1)))
	  return(0);
	old = old->entry.var_decl.next_in;
      }
    if (old) return(0);
    return(1);
  }
 }
}


/**************************************************************************/
/* We need to match the function invocation with proper overloaded        */
/* function name                                                          */
/* For any compound-object argument of (T_CLASS, T_COLLECTION,            */
/* T_DERIVED_COLLECTION,T_STRUCT) we think it is a pointer to the object  */
/**************************************************************************/
/*
  the first one is expr_list and the second one is arg_list
*/
is_compound_type_matched_in_arglist(new_arg_list,arg_list)
PTR_SYMB new_arg_list;
PTR_SYMB arg_list;
{
  PTR_SYMB old,new;
  PTR_TYPE type;
  PTR_LLND expr_list,p1;

    if ((!new_arg_list)||(!arg_list)) return(1);
    expr_list = (PTR_LLND) new_arg_list;
    if (expr_list->variant != EXPR_LIST) {
        /* sigle expression without expr_list */
	type = expr_list->type;
	if ((!is_same_type_conversion2(type,arg_list->type))&&
            (!is_in_the_exception(type,arg_list->type,expr_list)))
	  return(0);
        else    return(1);
   }
   else {
    for (p1 =expr_list ,old=arg_list;p1 ;p1=p1->entry.template.ll_ptr2 )
      {
	if (!(type =p1->entry.template.ll_ptr1->type)) type = global_int;
	if ((!is_same_type_conversion2(type,old->type))&&(!is_in_the_exception(type,old->type,p1->entry.template.ll_ptr1)))
	  return(0);
	old = old->entry.var_decl.next_in;
      }
    if (old) return(0);
    return(1);
  }

}


/********************************************************************/
/* type1 : new type                                                 */
/* type2 : old-declared type                                        */
/* type1==type2 if new type type1 is a subclass of type2            */
/* The type of a compound obect is considered to be a pointer to    */
/* the compound object                                              */
/********************************************************************/
int
is_same_type_conversion2(type1,type2)
PTR_TYPE type1,type2;
{  PTR_TYPE type_a,type_b ;
   int level1, level2 ;
   int temp_var1,temp_var2;
   PTR_SYMB c1,c2,symb1,symb2;
   PTR_TYPE b1,b2;

   if ((!type1)&&(!type2)) return(1);
   if ((!type1)||(!type2)) return(0);
   type_a = follow_type_1(type1, &level1,&temp_var1);
   type_b = follow_type_1(type2, &level2,&temp_var2);
   if ((type_a == type_b) && (level1 == level2)) return(1);
   if (level1 == level2) {
     if (((type_a->variant== T_CHAR)||(type_a->variant ==T_INT)||
	 (type_a->variant ==DEFAULT))&&
	 ((type_b->variant== T_CHAR)||(type_b->variant ==T_INT)||
	 (type_b->variant ==DEFAULT)))
       return(1);
     if ((((type_a->variant == T_DOUBLE)||(type_a->variant==T_FLOAT))&&
	  ((type_b->variant == T_DOUBLE)||(type_b->variant==T_FLOAT))))
       return(1);
     if (is_sub_class_of(type_a,type_b)) return(1);
     if ((type_a->variant==T_DERIVED_COLLECTION)&&
         (type_b->variant==T_DERIVED_COLLECTION))
       {
          c1 = type_a->entry.col_decl.collection_name;
          c2 = type_b->entry.col_decl.collection_name;
          b1 = type_a->entry.col_decl.base_type;
          b2 = type_b->entry.col_decl.base_type;
          if ((c1==c2) && is_same_entry(b1,b2)) return(1);
          if ((c1==c2)&&(b1->variant==T_DERIVED_TYPE)&&
              (b2->variant==T_DERIVED_TYPE))
	    {
              symb1 =b1->entry.derived_type;
              symb2 =b2->entry.derived_type;
              if ((symb1==elementtype_symb)||(symb2==elementtype_symb))
                      return(1);
	    }
	}
   }
   if ((level1==0)&&(level2==1)) {
     if (is_sub_class_of(type_a,type_b)) return(1);
     if ((type_a->variant==T_DERIVED_COLLECTION)&&
         (type_b->variant==T_DERIVED_COLLECTION))
       {
          c1 = type_a->entry.col_decl.collection_name;
          c2 = type_b->entry.col_decl.collection_name;
          b1 = type_a->entry.col_decl.base_type;
          b2 = type_b->entry.col_decl.base_type;
          if ((c1==c2) && is_same_entry(b1,b2)) return(1);
          if ((c1==c2)&&(b1->variant==T_DERIVED_TYPE)&&
              (b2->variant==T_DERIVED_TYPE))
	    {
              symb1 =b1->entry.derived_type;
              symb2 =b2->entry.derived_type;
              if ((symb1==elementtype_symb)||(symb2==elementtype_symb))
                      return(1);

	    }
	}
   }

   return(0);

 }


PTR_SYMB
find_overloading_function2(functor,expr_list)
PTR_SYMB  functor;
PTR_LLND expr_list;
{

PTR_SYMB  arg_list,symb;
int       n,n1;
PTR_TYPE new_return_type;
PTR_LLND p1;

 if (functor->variant != MEMBER_FUNC) return(NULL);
 for ( n=0, p1=expr_list;p1;p1=p1->entry.template.ll_ptr2) n++;
 for ( symb = functor; symb;   )
   {
     if (symb->variant == FIELD_NAME)
       symb = symb->entry.field.next;
     else  {
       arg_list = symb->entry.member_func.in_list;
       n1 = num_of_args(arg_list);
       if ((!strcmp(functor->ident,symb->ident))&&
	   (((n1==n)&&(is_type_matched_in_arglist(expr_list,arg_list,2) ||
	    is_compound_type_matched_in_arglist(expr_list,arg_list))) ||
	    is_void_in_arglist(n,arg_list)))
            break;
        else   symb=symb->entry.member_func.next;
     }
   }
 if (!symb) {
   if ((!strcmp(functor->ident,"DoSubSet"))||
       (!strcmp(functor->ident,"DOSUBSET")))
     {
       info("DoSubSet operator is used");
     }
   else if ((!strcmp(functor->ident,"Doall"))||
	    (!strcmp(functor->ident,"DOALL")))
     {
       info("Doall operator is used");
     }
   else {
     warning("function type mismatched",functor->ident);
   }
   return(functor);
 }
 return(symb);
  
}



confirm_overloaded_function(f_llnd,exprlist)
PTR_LLND f_llnd,exprlist;
{
  PTR_SYMB functor,symb;
  functor = f_llnd->entry.template.symbol;
  if (functor->variant== MEMBER_FUNC){
    symb=find_overloading_function2(functor,exprlist);
    if (symb) f_llnd->entry.template.symbol = symb;
  }


}
/********************************************************************/
/*                                                                  */
/* C++ use strong type-checking, but there are some execptions:     */
/* (1) NULL and POINTER are of the same type                        */
/* (2) More can be added                                            */
/*                                                                  */
/********************************************************************/
int
is_in_the_exception(type,old_type,pllnd)
PTR_TYPE type;
PTR_TYPE old_type;
PTR_LLND pllnd;
{
  int level,sw;
  PTR_TYPE temp_type;

  if (((pllnd->variant==INT_VAL)||(pllnd->variant==CHAR_VAL))&&
      (!pllnd->entry.ival)) 
    {
      temp_type = follow_type_1(old_type,&level,&sw);      
      if (level >0) return(1);
    }
   if ((type&&(type->variant==T_VOID))||(old_type&&(old_type->variant==T_VOID)))
     return(1);
  return(0);
}

int
is_void_in_arglist(n,arg_list)
int n;
PTR_SYMB arg_list;
{ PTR_TYPE type;
  int level,sw;

 if (n==0) {
   if (!arg_list) return(1);
   type = follow_type_1(arg_list->type,&level,&sw);
   if ((type->variant== T_VOID)&&(level == 0)) return(1);
 }
 return(0);
}

/********************************************************************/
/* routine find_entry_from_type:                                    */
/* Used in parser for the constructor function header               */
/*                                                                  */
/********************************************************************/
PTR_HASH 
find_entry_from_type(type)
PTR_TYPE type;
{
  PTR_TYPE type1;
  PTR_SYMB s;

  if (type->variant== T_DESCRIPT)
    type1=type->entry.descriptive.base_type;
  else type1= type;
  if (type->variant==T_DERIVED_TYPE) {
    s=type->entry.derived_type;
    return(s->parent);
  }
  else err("illegal syntax");
  return((PTR_HASH) NULL);
}

PTR_TYPE
fetch_type_for_constructor(type)
PTR_TYPE type;
{

  if (type->variant== T_DESCRIPT){
    type->entry.descriptive.base_type = global_default;
    return(type);
  }
  return(global_default);
}


/********************************************************************/
/* type1 : new type                                                 */
/* type2 : old-declared type                                        */
/* type1==type2 if new type type1 is a subclass of type2            */
/********************************************************************/


int
is_same_type_conversion(type1,type2)
PTR_TYPE type1,type2;
{  PTR_TYPE type_a,type_b ;
   int level1, level2 ;
   int temp_var1,temp_var2;
   PTR_SYMB c1,c2,symb1,symb2;
   PTR_TYPE b1,b2;

   if ((!type1)&&(!type2)) return(1);
   if ((!type1)||(!type2)) return(0);
   type_a = follow_type_1(type1, &level1,&temp_var1);
   type_b = follow_type_1(type2, &level2,&temp_var2);
   if ((type_a == type_b) && (level1 == level2)) return(1);
   if (level1 == level2) {
     if (((type_a->variant== T_CHAR)||(type_a->variant ==T_INT)||
	 (type_a->variant ==DEFAULT))&&
	 ((type_b->variant== T_CHAR)||(type_b->variant ==T_INT)||
	 (type_b->variant ==DEFAULT)))
       return(1);
     if ((((type_a->variant == T_DOUBLE)||(type_a->variant==T_FLOAT))&&
	  ((type_b->variant == T_DOUBLE)||(type_b->variant==T_FLOAT))))
       return(1);
     if (is_sub_class_of(type_a,type_b)) return(1);
     if ((type_a->variant==T_DERIVED_COLLECTION)&&
         (type_b->variant==T_DERIVED_COLLECTION))
       {
          c1 = type_a->entry.col_decl.collection_name;
          c2 = type_b->entry.col_decl.collection_name;
          b1 = type_a->entry.col_decl.base_type;
          b2 = type_b->entry.col_decl.base_type;
          if ((c1==c2) && is_same_entry(b1,b2)) return(1);
          if ((c1==c2)&&(b1->variant==T_DERIVED_TYPE)&&
              (b2->variant==T_DERIVED_TYPE))
	    {
              symb1 =b1->entry.derived_type;
              symb2 =b2->entry.derived_type;
              if ((symb1==elementtype_symb)||(symb2==elementtype_symb))
                      return(1);
	    }
	}
   }

   return(0);

 }


is_sub_class_of(subclass,superclass)
PTR_TYPE subclass,superclass;
{
  PTR_SYMB subclass_symb,superclass_symb,object;
  PTR_BFND subclass_bfnd,superclass_bfnd;
  PTR_LLND expr_list,list,list1;
  
  if (((subclass->variant==T_STRUCT)||
       (subclass->variant==T_CLASS)||
       (subclass->variant==T_COLLECTION))&&
      ((superclass->variant==T_STRUCT)||
       (superclass->variant==T_COLLECTION)||
       (superclass->variant==T_CLASS)))
    {
      subclass_bfnd=subclass->entry.derived_class.original_class;
      subclass_symb = subclass_bfnd->entry.template.symbol;
      superclass_symb =superclass->entry.derived_class.original_class->entry.template.symbol;
      if ((!subclass_symb)||(!superclass_symb)) return(0);
      
      if (expr_list =(subclass_bfnd->entry.template.ll_ptr2)) {
	for ( list = expr_list; list; list =list->entry.template.ll_ptr2)
	  { list1  = follow_llnd(list,1);
	    object = list1->entry.template.symbol;
	    if (object==superclass_symb) return(1);
	    else if (is_sub_class_of(object->type,superclass)) return(1);
	  }
	
      }
    }
  return(0);
 }


late_adjust_functor(pbf)
PTR_BFND pbf;
{

  PTR_SYMB symbptr,symb3;
  PTR_LLND lptr2;
  if (pbf->variant != FUNC_HEDR) return;
  lptr2= find_suit_declarator(pbf->entry.template.ll_ptr1);
  symbptr=pbf->entry.template.symbol;
  if (symb3=find_overloading_function(symbptr)) {
    pbf->entry.template.symbol = lptr2->entry.template.symbol= symb3;
  }
  pbf->entry.template.symbol->entry.member_func.func_hedr = pbf;
  symbptr->ud_chain = (PTR_BLOB) NULL;
  symbptr->decl     = NULL;
}


/*
 *   used for find_overloaded_operator()
 */
int
is_function_type_matched(functor,expr2)
PTR_SYMB functor;
PTR_LLND;
{
   PTR_SYMB arglist;
   int n1,n2;
   
   if (functor->variant != MEMBER_FUNC) return(0);
   arglist = functor->entry.member_func.in_list;
   n1 = num_of_args(arglist);
   n2 = num_of_exprlist(expr2);
   if (((n1==n2)&&is_type_matched_in_arglist(expr2,arglist,2)) ||
       is_void_in_arglist(n2,arglist))  return(1);
 }

num_of_exprlist(expr)
PTR_LLND expr;
{
  PTR_LLND q;
  int i;

  if (!expr)  return(0);
  if (expr->variant != EXPR_LIST) return(1);
  for (i=0 ,q = expr; q;  q=q->entry.template.ll_ptr2) i++;
  return(i);
}

/****************************************************************************/
/* The following routines are used to find the overloaded operator          */
/*  A/ B and both are collections                                           */
/*  Let operator '/'(element x) be a method of A,                           */
/*  We need to find the operator '/' is the overloaded one                  */
/****************************************************************************/
int
is_function_type_about_matched(functor,expr2)
PTR_SYMB functor;
PTR_LLND;
{
   PTR_SYMB arglist;
   int n1,n2;
   
   if (functor->variant != MEMBER_FUNC) return(0);
   arglist = functor->entry.member_func.in_list;
   n1 = num_of_args(arglist);
   n2 = num_of_exprlist(expr2);
   if (((n1==n2)&&is_type_matched_in_arglist(expr2,arglist,3)) ||
       is_void_in_arglist(n2,arglist))  return(1);
 }




/********************************************************************/
/* type1 : new type                                                 */
/* type2 : old-declared type                                        */
/* type1==type2 if new type type1 is a subclass of type2            */
/********************************************************************/
int
is_about_same_type_conversion(type1,type2)
PTR_TYPE type1,type2;
{  PTR_TYPE type_a,type_b ;
   int level1, level2 ;
   int temp_var1,temp_var2;
   PTR_SYMB c1,c2,symb1,symb2;
   PTR_TYPE b1,b2;

   if ((!type1)&&(!type2)) return(1);
   if ((!type1)||(!type2)) return(0);
   type_a = follow_type_1(type1, &level1,&temp_var1);
   type_b = follow_type_1(type2, &level2,&temp_var2);
   if ((type_a == type_b) && (level1 == level2)) return(1);
   if (level1 == level2) {
     if (((type_a->variant== T_CHAR)||(type_a->variant ==T_INT)||
	 (type_a->variant ==DEFAULT))&&
	 ((type_b->variant== T_CHAR)||(type_b->variant ==T_INT)||
	 (type_b->variant ==DEFAULT)))
       return(1);
     if ((((type_a->variant == T_DOUBLE)||(type_a->variant==T_FLOAT))&&
	  ((type_b->variant == T_DOUBLE)||(type_b->variant==T_FLOAT))))
       return(1);
     if (is_sub_class_of(type_a,type_b)) return(1);
     if ((type_a->variant==T_DERIVED_COLLECTION)&&
         (type_b->variant==T_DERIVED_COLLECTION))
       {
          c1 = type_a->entry.col_decl.collection_name;
          c2 = type_b->entry.col_decl.collection_name;
          b1 = type_a->entry.col_decl.base_type;
          b2 = type_b->entry.col_decl.base_type;
          if ((c1==c2) && is_same_entry(b1,b2)) return(1);
          if ((c1==c2)&&(b1->variant==T_DERIVED_TYPE)&&
              (b2->variant==T_DERIVED_TYPE))
	    {
              symb1 =b1->entry.derived_type;
              symb2 =b2->entry.derived_type;
              if ((symb1==elementtype_symb)||(symb2==elementtype_symb))
                      return(1);
	    }
	}
   }
   if (is_collective_type(type1,type2)) return(1);
   return(0);
}

/*
  The first one is the actual argument and the second one is formal param.
*/

int
is_collective_type(type1,type2)
PTR_TYPE type1,type2;
{
  PTR_TYPE type_a;
  PTR_TYPE type_b;
  PTR_TYPE basetype,finaltype;
  int sw,extra_level,finallevel;
  int level1,level2;

  type_a=follow_type_2(type1,&level1,&sw);
  type_b=follow_type_2(type2,&level2,&sw);
  if (type_a->variant !=T_DERIVED_COLLECTION) return(0);
  basetype = type_a->entry.col_decl.base_type;
  finaltype = follow_type_2(basetype,&extra_level,&sw);
  if (!is_same_type_conversion(finaltype,type_b)) return(0);
  finallevel = level1 + extra_level;
  if (level2== finallevel) return(1);
  return(0);

 }






/********************************************************************/
/* type1 : new type                                                 */
/* type2 : old-declared type                                        */
/* type1==type2 if new type type1 is a subclass of type2            */
/* we also check if element_type is in type1, if so we will match   */
/* it with the element object type                                  */
/********************************************************************/
int
is_same_type_with_elementtype(type1,type2)
PTR_TYPE type1,type2;
{  PTR_TYPE type_a,type_b ;
   int level1, level2 ;
   int temp_var1,temp_var2;
   PTR_SYMB c1,c2,symb1,symb2;
   PTR_TYPE b1,b2;

   if ((!type1)&&(!type2)) return(1);
   if ((!type1)||(!type2)) return(0);
   type_a = follow_type_2(type1, &level1,&temp_var1);
   type_b = follow_type_2(type2, &level2,&temp_var2);
   if ((type_a == type_b) && (level1 == level2)) return(1);
   if (level1 == level2) {
     if (((type_a->variant== T_CHAR)||(type_a->variant ==T_INT)||
	 (type_a->variant ==DEFAULT))&&
	 ((type_b->variant== T_CHAR)||(type_b->variant ==T_INT)||
	 (type_b->variant ==DEFAULT)))
       return(1);
     if ((((type_a->variant == T_DOUBLE)||(type_a->variant==T_FLOAT))&&
	  ((type_b->variant == T_DOUBLE)||(type_b->variant==T_FLOAT))))
       return(1);
     if (is_sub_class_of(type_a,type_b)) return(1);
     if ((type_a->variant==T_DERIVED_COLLECTION)&&
         (type_b->variant==T_DERIVED_COLLECTION))
       {
          c1 = type_a->entry.col_decl.collection_name;
          c2 = type_b->entry.col_decl.collection_name;
          b1 = type_a->entry.col_decl.base_type;
          b2 = type_b->entry.col_decl.base_type;
          if ((c1==c2) && is_same_entry(b1,b2)) return(1);
          if ((c1==c2)&&(b1->variant==T_DERIVED_TYPE)&&
              (b2->variant==T_DERIVED_TYPE))
	    {
              symb1 =b1->entry.derived_type;
              symb2 =b2->entry.derived_type;
              if ((symb1==elementtype_symb)||(symb2==elementtype_symb))
                      return(1);
	    }
	}
     if ((type_a->variant==T_DERIVED_TYPE)&&
	 (!strcmp(type_a->entry.derived_type->ident,"ElementType")))
       return(1);
   }
   return(0);
 }
