

/* This is VPC version */
/* Latest Modified date is Oct 7, 1987 */ /* Date Nov 15,1987 */
/* Feb 3, 1988 /
/* BISON parser for VPC++  Modified by Jenq-kuen Lee  Sep 28, 1987    */
/* YACC parser for C syntax.         */
/*   Copyright (C) 1987 Free Software Foundation, Inc. */


%{
#include "vparse.h"
#include "vpc.h"
#include "db.h"
#include "vextern.h"
%}

%start program
%union { 
         int       token ;
         char      charv ;
         char      *charp;
         PTR_BFND   bfnode ;
         PTR_LLND   ll_node ;
         PTR_SYMB   symbol  ;
         PTR_TYPE   data_type ;
         PTR_HASH   hash_entry ;
         PTR_LABEL  label ;        
         PTR_BLOB   blob_ptr ;
       }
/* all identifiers   that are not reserved words
   and are not declared typedefs in the current block */
%token IDENTIFIER
/* all identifiers   that are declared typedefs in the current block.
   In some contexts, they are treated just like IDENTIFIER,
   but they can also serve as typespecs in declarations.  */
%token TYPENAME

/* reserved words that specify storage class.
   yylval contains an IDENTIFIER_NODE which indicates which one.  */
%token SCSPEC

/* reserved words that specify type.
   yylval contains an IDENTIFIER_NODE which indicates which one.  */
%token TYPESPEC

/* reserved words that modify type: "const" or "volatile".
   yylval contains an IDENTIFIER_NODE which indicates which one.  */
%token TYPEMOD
%token FUTURE INLINE VIRTUAL
/*character or numeric constants.
   yylval is the node for the constant.  */
%token CONSTANT

/* String constants in raw form.
   yylval is a STRING_CST node.  */
%token STRING

/* "...", used for functions with variable arglists.  */
%token ELLIPSIS

/* the reserved words */
%token SIZEOF ENUM STRUCT UNION IF ELSE WHILE DO FOR SWITCH CASE DEFAULT_TOKEN
%token BREAK CONTINUE RETURN GOTO ASM
%token CLASS PUBLIC  ACCESSWORD OVERLOAD THIS PROTECTED 
%token OPERATOR COBREAK COLOOP COEXEC LOADEDOPR NEW DELETE 
%token MULTIPLEID EXTERN_LANG_STRI

%token COLLECTION ELEMENTTYPE ELEMENTTYPEOF METHODOFELEMENT  const_expr_no_commas const_primary 

/* Define the operator tokens and their precedences.
   The value is an integer because, if used, it is the tree code
   to use in the expression made from the operator.  */
%left  <charv> ';'
%left IDENTIFIER TYPENAME  SCSPEC TYPESPEC TYPEMOD
%left  <charv> SUPER_OP
%left  <charv> ','
%right <charv> '='
%right <token> ASSIGN 
%right <charv> '?' ':'
%left <charv> OROR
%left <charv> ANDAND
%left <charv> '|'
%left <charv> '^'
%left <charv> '&'
%left <token> EQCOMPARE
%left <token> ARITHCOMPARE  '>' '<' 
%left <charv> LSHIFT RSHIFT
%left <charv> '+' '-'
%left <token> '*' '/' '%'
%right <token> UNARY PLUSPLUS MINUSMINUS 
%left HYPERUNARY 
%left <token> POINTSAT '.'
%right <token> DOUBLEMARK

%type <token> new_TYPEMOD 
%type <token> unop  general_classname
%type <hash_entry> IDENTIFIER TYPENAME  LOADEDOPR
%type <ll_node> CONSTANT STRING  primary expr_no_commas  expr nonnull_exprlist
%type <ll_node>  base_init member_init_list member_init  exprlist
%type <ll_node> string
%type <data_type> typed_declspecs  maintype typed_declspecs_2  
%type <token> typespecfinal typed_declfinal
%type <token>  typespec_reserved  component_decl
%type <token>  SCSPEC TYPESPEC TYPEMOD public_group
%type <ll_node> initdecls   initdcl notype_initdecls
%type <ll_node> init initlist vector_constant triplet  compound_constant vector_list

%type <ll_node> declarator inside components notype_components component_declarator
%type  <ll_node> notype_component_declarator  future_declarator
%type <ll_node> notype_declarator  after_type_declarator notype_initdcl
%type <ll_node> single_v_expr array_expr_a array_expr_b expr_vector multiple_id
%type <ll_node> xexpr  declarator1 notype_declarator1 scoped_identifier
%type <hash_entry> identifier    
%type <token>  component_decl_list  nonempty_component_decl_list ref_pointer
%type <ll_node> enumlist enumerator
%type <data_type> typename absdcl absdcl1 typemods typed_typespecs nonempty_typemods  structsp
%type <ll_node>  parmlist parms parm  identifiers  notype_declarator_parm  
%type <ll_node> lexpr assign_stmt TYPENAME_list parm_init
%type <token> declarator_list    decl
%type <token> ACCESSWORD 
%type <token> COLOOP COEXEC COBREAK CLASS UNION STRUCT
%type <token> setspecs
%type <bfnode> datadef
%type <data_type> declmods
%type <ll_node> passing_identifiers passing_identifier_list
%type <ll_node> optionlist


/* the declaration found for the last IDENTIFIER token read in.
   yylex must look this up to detect typedefs, which get token type TYPENAME,
   so it is left around in case the identifier is not a typedef but is
   used in a context which makes it a reference to a variable.  */


/* list of types and structure classes of the current declaration */
/* tree current_declspecs;  */
%{ char      *input_filename;	
   int       enum_id = 0;
   extern    int lastdecl_id;
   extern    PTR_SYMB first_symbol;
   PTR_FNAME find_file_entry();
   extern     struct data_type second_part ;
   PTR_LLND   chain_type_declarator();
   PTR_LLND   follow_llnd();
   PTR_SYMB   find_type_symbol();
   PTR_SYMB   find_field_symb_by_type();
   PTR_LLND   check_format_function();
   PTR_LLND   check_array_id_format();
   PTR_LLND   func_declarator_appear();
   PTR_LLND   lazy_install();
   PTR_LLND   install_parameter();
   PTR_TYPE   combine_2();
   PTR_TYPE   follow_type(), follow_type_1();
   PTR_TYPE   install_declmod();
   PTR_TYPE   install_struct(),set_struct_typename();
   PTR_BLOB   follow_blob(), follow_blob_2();      
   PTR_HASH   look_up_type(),look_up() ;
   PTR_SYMB   install_entry();
   PTR_SYMB   find_proc_name();
   PTR_SYMB   count_first();
   PTR_SYMB   next_member();
   PTR_TYPE   type_conversion();
   PTR_TYPE   adjust_deref_type();
   PTR_TYPE   adjust_array_type();
   PTR_SYMB   install_entry_2(),find_first_field_2();
   double     build_real_from_string();
   PTR_TYPE   chain_type_declarator_2();
   PTR_LABEL  find_label();
   PTR_LABEL  make_label();
   PTR_LABEL  get_label();
   PTR_CMNT   make_comment(),follow_comment();
   PTR_TYPE   chain_up_type();
   PTR_TYPE   chain_type_with_array_range();
   PTR_SYMB   find_field_for_this();
   int        fill_type_for_param();
   extern     int cur_counter ;    
   PTR_LLND chain_parameter_list();
   PTR_SYMB find_parameter_name();   
   PTR_SYMB find_global_symbol();
   PTR_LLND install_scope_operator();
   PTR_SYMB fts_by_inherited_class();
   PTR_LLND find_suit_declarator();
   PTR_LLND find_suit_declarator2();
   PTR_LLND derived_lazy_install();
   PTR_HASH look_up_expanded_string();
   PTR_SYMB find_object_symbol();
   PTR_SYMB check_field_decl_2(),check_field_decl_3();
   PTR_HASH find_entry_from_type();
   PTR_TYPE fetch_type_for_constructor();
   PTR_LLND primary_identifier_action();
   PTR_TYPE typed_declspecs_without_declmods();
   PTR_TYPE typed_declspecs_with_declmods();
   PTR_LLND chain_array_op_range();
   PTR_TYPE find_constant_type();
   PTR_BFND find_current_class_bfnd();
   PTR_TYPE map_rid_to_type();
   PTR_TYPE adjust_element_type();
   char *map_op();
   char *map_unop();
   PTR_LLND  handle_complicated_paramters();
%}     


%%

 program: /* empty */
          { if (TRACEON) printf("1\n ");}
	| extdefs
          { if (TRACEON) printf("2\n ");}
	;

/* the reason for the strange actions in this rule
 is so that notype_initdecls when reached via datadef
 can find a valid list of type and sc specs in $0. */

extdefs:
          extdef
          { if (TRACEON) printf("3\n ");}
	| extdefs  extdef
          { if (TRACEON) printf("4\n ");}
	;

extdef:
	fndef
          { if (TRACEON) printf("5  ");
            main_type_flag = TYPE_FOUR ;
          }
	| datadef
          { if (TRACEON) printf("6  ");
	    fill_comment();
            main_type_flag = TYPE_FOUR ;
          }
	| ASM '(' STRING ')' ';'
		{ if (TRACEON) printf("7  ");  }
        | extern_lang_string '{' extdefs '}'
		{ main_type_flag = TYPE_FOUR ;}
	| extern_lang_string '{' '}'
		{ main_type_flag = TYPE_FOUR ;}
	| extern_lang_string fndef
		{ main_type_flag = TYPE_FOUR ;}
	| extern_lang_string datadef
		{ 
		  main_type_flag = TYPE_FOUR ;
		  fill_comment();
		}

        ;


extern_lang_string:
        EXTERN_LANG_STRI
            {}
         ;

/* modified */
datadef:
	  ACCESSWORD  notype_initdecls ';'
         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;
           PTR_SYMB dummy_symb;

           if (TRACEON) printf("8  ");
           ptr1 = global_int ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,$1,$2,&dummy_symb,NO);
	 }
        | notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;
           PTR_SYMB dummy_symb;

           if (TRACEON) printf("9  ");
           ptr1 = global_int ;
           /* notype_initdecls returns expr_list ll_node */  
           lptr2 = chain_type_declarator(ptr1,OFF,$1,&dummy_symb,NO);


	 }
        | ACCESSWORD declmods  notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1 ;
           PTR_SYMB dummy_symb;

           if (TRACEON) printf("10  ");

           ptr1 = $2 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,$1,$3,&dummy_symb,NO);

	 }
        | declmods notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;
           PTR_SYMB dummy_symb;

           if (TRACEON) printf("11  ");
           ptr1 = $1 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,OFF,$2,&dummy_symb,NO);


	 }
	| ACCESSWORD typed_declspecs  initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND  bf1 ;
	    PTR_SYMB dummy_symb;

            if (TRACEON) printf("12 ");
            chain_type_declarator($2,$1,$3,&dummy_symb,NO);
	  }
          
	| typed_declspecs initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND  bf1 ;
	    PTR_SYMB dummy_symb;

            if (TRACEON) printf("13 ");
            chain_type_declarator($1,OFF,$2,&dummy_symb,NO);
	  }


        | ACCESSWORD  declmods ';'
	  { if (TRACEON) printf("empty declaration"); }
        | declmods ';'
          { if (TRACEON) printf("empty declaration"); }
	| ACCESSWORD  typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;

            if (TRACEON) printf("15  "); 
            blob = follow_blob(pred_bfnd);
          if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))
	   { 
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name))
	      {  symb2=find_type_symbol(name->parent,VARIABLE_NAME,area());
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err_symb(" redeclaration symbol ",symb2->ident);
                 else   name->scope = pred_bfnd;
	       }
	  }
	 }

	| typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;

            if (TRACEON) printf("16  "); 
            blob = follow_blob(pred_bfnd);
         if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))

	   { 
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name))
	      {  symb2=find_type_symbol(name->parent,VARIABLE_NAME,area());
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err_symb(" redeclaration symbol ",symb2->ident);
                 else   name->scope = pred_bfnd;
	       }
	  }
	  }
        | OVERLOAD declarator_list ';'
          { if (TRACEON) printf("17  ");
            /* Needs future work  */
          }
	| error ';'
           { if (TRACEON) printf("17.2  "); }              
	| error '}'
           { if (TRACEON) printf("17.3  "); }
	| ';'
          { if (TRACEON) printf("18  "); }
	;


fndef:	  typed_declspecs  
          declarator1
                {
		  enter_func_body($1,$2);
		 }
	  xdecls
		{ if (TRACEON) printf("20  "); 
		  pred_bfnd->entry.template.symbol->dovar -= XDECL ;
		  fill_type_for_param(pred_bfnd->entry.template.symbol);
		  late_adjust_functor(pred_bfnd);
                }
	  compstmt
		{ if (TRACEON) printf("21 ");
                  function_flag = OFF ;
                  pred_bfnd = pred_bfnd->control_parent ;
		}
	| typed_declspecs  declarator1 error
		{ if (TRACEON) printf("22 "); }
	| declmods   notype_declarator1
                { PTR_BFND bf1;
		  PTR_LLND expr_llnd;
		  PTR_SYMB dummy_symb;

		  $1->entry.descriptive.base_type = global_default ;
		  enter_func_body($1,$2);
		 }
	  xdecls
		{ if (TRACEON) printf("24 "); 
		  pred_bfnd->entry.template.symbol->dovar -= XDECL ;
		  fill_type_for_param(pred_bfnd->entry.template.symbol); 
		  late_adjust_functor(pred_bfnd);
                }
	  compstmt
		{ if (TRACEON) printf("25 ");
                  function_flag = OFF ;
                  pred_bfnd = pred_bfnd->control_parent ;
		}

	| declmods  notype_declarator1 error
		{ if (TRACEON) printf("26 "); }
	| notype_declarator1
                {
		  enter_func_body(global_default,$1);
		 }
	  xdecls
		{ if (TRACEON) printf("28 "); 
                  pred_bfnd->entry.template.symbol->dovar -= XDECL ;
		  fill_type_for_param(pred_bfnd->entry.template.symbol);
		  late_adjust_functor(pred_bfnd);
                }
	  compstmt
		{ if (TRACEON) printf("29 ");
                  function_flag = OFF ;
                  pred_bfnd = pred_bfnd->control_parent ;
		}

	|  notype_declarator1 error
		{ if (TRACEON) printf("30 "); }
	;


declarator1:
           declarator
            { $$ = $1;
	      set_function_hedr();
	    }
        |  declarator base_init
            {
	      $$ = make_llnd(fi,BIT_NUMBER,$1,$2,SMNULL);
            }
        ;


notype_declarator1:
           notype_declarator
            { $$ = $1;
	      set_function_hedr();
	    }
        |  notype_declarator base_init
            {
	      $$ = make_llnd(fi,BIT_NUMBER,$1,$2,SMNULL);
            }
        ;




base_init: ':'  
              { set_function_hedr(); }
           member_init_list  /*%prec SUPER_OP */
             { $$= $3;}
         ;


member_init_list:
	  /* empty */
              { $$ = LLNULL;}
	| member_init
              { $$ = make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);}
	| member_init_list ',' member_init
              { PTR_LLND ll_node1;
		ll_node1 = follow_llnd($1,2);
		ll_node1->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
		$$=$1;
	      }
	| member_init_list error
              {}

	;


/* Non-virtual baseclass initializers can live on the temporary_obstack,
   since they are used only for the compilation of this function.  Virtual
   baseclass initializers, however, must be built on the permanent_obstack.  */

member_init:
	  '(' exprlist ')'
		{
		  $$= make_llnd(fi,CLASSINIT_OP,LLNULL,$2,SMNULL);
		}

	| identifier
	  '(' exprlist ')'
             { PTR_SYMB symbptr;
	       PTR_LLND pllnd;

	       symbptr=fts_by_inherited_class($1,VARIABLE_NAME,area());
	       if (!symbptr) err_symb("no proper member/class",$1->ident);
	       else {
		 pllnd = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
		 $$= make_llnd(fi,CLASSINIT_OP,pllnd,$3,SMNULL);
	       }
	     }
	| scoped_identifier identifier
	  '(' exprlist ')'
 		{}

	;




scoped_identifier:
	  DOUBLEMARK 
             {}
	| identifier DOUBLEMARK
             {}
	| scoped_identifier DOUBLEMARK
              {}
	;



/* Must appear precede expr for resolve precedence problem */
/* A nonempty list of identifiers.  */
identifiers:	
	IDENTIFIER
		{ PTR_LLND ll;
		  if (TRACEON) printf("306 ") ;
                  ll= install_parameter($1,VARIABLE_NAME) ;
                  $$= make_llnd(fi,EXPR_LIST,ll,LLNULL,SMNULL);
                }
	| identifiers ',' IDENTIFIER
		{ PTR_LLND ll;
		  if (TRACEON) printf("307 ") ;
                  ll = install_parameter($3,VARIABLE_NAME) ;
                  $$=chain_parameter_list($1,ll);
		}
	;


/* modified */
declarator_list :
          declarator
           { if (TRACEON) printf("31  ");}
        | declarator_list ',' declarator 
           { if (TRACEON) printf("32 ");}
        ;



identifier:
	IDENTIFIER
           { if (TRACEON) printf("33 ");}
	| TYPENAME
           { if (TRACEON) printf("34 ");}
	;

unop:     '&'
               { if (TRACEON) printf("35 ");
                 $$ = ADDRESS_OP ;
	       }

	| '-'
		{ if (TRACEON) printf("36 ");  
                 $$ = MINUS_OP ;
	       }
	| '+'
		{ if (TRACEON) printf("37 "); 
                 $$ = UNARY_ADD_OP ;
	       }
	| PLUSPLUS
		{ if (TRACEON) printf("38 "); 
                 $$ = PLUSPLUS_OP ;
	       }
	| MINUSMINUS
		{ if (TRACEON) printf("39 "); 
                 $$ = MINUSMINUS_OP ;
	       }
	| '~'
		{ if (TRACEON) printf("40 "); 
                 $$ = BIT_COMPLEMENT_OP ;
	       }

	| '!'
		{ if (TRACEON) printf("41 "); 
                 $$ = NOT_OP ;
	       }
/*        | DOUBLEMARK
                 {$$ = SCOPE_OP;}
*/
	;

expr:	nonnull_exprlist
		{ if (TRACEON) printf("42 ");
                  $$ = $1 ;
                }
	;

exprlist:
	  /* empty */
		{ if (TRACEON) printf("43 ");
                  $$ = LLNULL ;
                }
	| nonnull_exprlist
		{ if (TRACEON) printf("44 "); 
                  $$ = $1 ; 
                }
	;

/* modified */
nonnull_exprlist:
          expr_no_commas
		{ if (TRACEON) printf("45 ");
                  $$ = make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
		  $$->type = $1->type ;
                }
	| nonnull_exprlist ',' expr_no_commas
		{ PTR_LLND ll_ptr ;

                  if (TRACEON) printf("46 ");
                  ll_ptr = follow_llnd($1,2);
                  ll_ptr->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
                  $$=$1;
                  $$->type = $3->type ;
                }
	;

/* modified */


/* modified */
vector_constant : '['  ']'   %prec ','
            {     PTR_SYMB symb;
                  PTR_HASH entry;  
		  int status;
		  if (TRACEON) printf("70.5 ");
                  $$ = make_llnd(fi,VECTOR_CONST,LLNULL,LLNULL,SMNULL);
                  primary_flag = VECTOR_CONST_APPEAR ;
		  /* Temporarily setting */
                  entry=look_up_type("vconstant",&status);
		  symb = find_object_symbol(entry);
		  if (!symb) {
                    symb=install_entry_2(entry,CLASS_NAME,OTHER);
		  }
		  $$->type = get_type(fi,T_DERIVED_TYPE);
		  $$->type->entry.derived_type = symb;
		}
        | '['  vector_list  ']'  %prec ','
            {    PTR_SYMB symb;
                 PTR_HASH entry;  
		 int status;
		 if (TRACEON) printf("70.6 ");
                 $$ = make_llnd(fi,VECTOR_CONST,$2,LLNULL,SMNULL);
		 primary_flag = VECTOR_CONST_APPEAR ;
		 entry=look_up_type("vconstant",&status);
		 symb = find_object_symbol(entry);
		 if (!symb) {
		   symb=install_entry_2(entry,CLASS_NAME,OTHER);
		 }
		 $$->type = get_type(fi,T_DERIVED_TYPE);
		 $$->type->entry.derived_type = symb;

	       }
        ;


vector_list :
          single_v_expr
          { $$ = make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL); }
        | vector_list ',' single_v_expr

             {
               PTR_LLND ll_node1 ;
               if (TRACEON) printf("48 ") ;
               ll_node1 = follow_llnd($1,2);
               ll_node1->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
              $$=$1;
	    }

        ;

/* modified */
single_v_expr :
          expr_no_commas
             { if (TRACEON) printf("47 ");
               $$ = $1;
             }
        | triplet
             { if (TRACEON) printf("50 ");
               $$ = $1;
             }
        | compound_constant
             { if (TRACEON) printf("51 "); 
               $$ = $1;
             }        

        ;


triplet :
          expr_no_commas ':' expr_no_commas ':' expr_no_commas   %prec '.'

            { PTR_LLND p1,p2 ;
              if (TRACEON) printf("52 ") ;
              p1 = make_llnd(fi,DDOT,$1,$3,SMNULL);
              p2 = make_llnd(fi,DDOT,p1,$5,SMNULL);
              $$ = p2 ;
	    }
         | expr_no_commas ':' expr_no_commas               %prec '.'
            { if (TRACEON) printf("53 ") ; 
              $$= make_llnd(fi,DDOT,$1,$3,SMNULL);
	    }
        ;


compound_constant :
          expr_no_commas '#' expr_no_commas
           { if (TRACEON) printf("54 ") ; 
             $$= make_llnd(fi,COPY_NODE,$1,$3,SMNULL);
	   }

        ;


/* modified */
array_expr_a :        /* empty */
                  {}
        | expr_no_commas ':' expr_no_commas ':' expr_no_commas  %prec ','
            { PTR_LLND p1,p2 ;
              if (TRACEON) printf("55 ") ;
              p1 = make_llnd(fi,DDOT,$1,$3,SMNULL);
              p2 = make_llnd(fi,DDOT,p1,$5,SMNULL);
              $$ = p2 ;
	    }
        | expr_no_commas ':' expr_no_commas                     %prec ','
            {
              if (TRACEON) printf("56 ") ; 
              $$= make_llnd(fi,DDOT,$1,$3,SMNULL);
	    }
        ;


/* modified */
array_expr_b :  expr_no_commas '#' expr_no_commas  
            { if (TRACEON) printf("59 ") ; }
        ;


/* modified */
expr_vector : expr_no_commas   /* original is expr  */
              { if (TRACEON) printf("60 ") ; }
        |  array_expr_a
              { if (TRACEON) printf("61 ") ; }
        ;
 
expr_no_commas:
	primary
           { if (TRACEON) printf("62 ") ; 
            /* Need Another way to check this one */
            /*  if (primary_flag & EXCEPTION_ON) err("syntax error 6"); */
	     expr_primary_action($1);
             $$=$1 ;
	   }
	| '*' expr_no_commas   %prec UNARY
		{ PTR_TYPE type ;
        
                  if (TRACEON) printf("63 ") ;
		  $$ = make_llnd(fi,DEREF_OP,$2,LLNULL,SMNULL);
		  if (!typeconversion_or_oo_handling($2,NULL,"*",$$,0))
		    $$->type = adjust_deref_type($2->type,DEREF_OP);

                }
	| unop expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("64 ") ; 
		  $$=make_llnd(fi,$1,$2,LLNULL,SMNULL);
		  if (!typeconversion_or_oo_handling($2,NULL,map_unop($1),$$,0))
		    {
		      if (($1 == ADDRESS_OP)&&(is_variable($2)))
			$$->type = adjust_deref_type($2->type,ADDRESS_OP);
		      else $$ ->type = $2->type ;
		    }
                }
	| '(' typename ')' expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("65 ") ; 
		  $$=make_llnd(fi,CAST_OP,$4,LLNULL,SMNULL);
                  $$->type = $2 ;

                }

	| SIZEOF expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("66 ") ; 
		  $$=make_llnd(fi,SIZE_OP,$2,LLNULL,SMNULL);
                  $$->type = global_int ;
                }
	| SIZEOF '(' typename ')'  %prec HYPERUNARY
		{ PTR_LLND ll_1 ;
		  
                  if (TRACEON) printf("67 ") ;  
                  ll_1 = make_llnd(fi,CAST_OP,LLNULL,LLNULL,SMNULL);
                  ll_1->type = $3 ;
		  $$=make_llnd(fi,SIZE_OP,ll_1,LLNULL,SMNULL);
		  $$->type = global_int ;
                }


	| DELETE  expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("66 ") ; 
		  $$=make_llnd(fi,DELETE_OP,$2,LLNULL,SMNULL);
                  $$->type = global_int ;
                }


	| DELETE vector_constant  expr_no_commas  %prec UNARY
                {
		  $$=make_llnd(fi,DELETE_OP,$3,$2->entry.template.ll_ptr1,SMNULL);
                  $$->type = global_int ;
		}


	| expr_no_commas '+' expr_no_commas
		{ if (TRACEON) printf("68 ") ;  
		  $$=make_llnd(fi,ADD_OP,$1,$3,SMNULL);
                  typeconversion_or_oo_handling($1,$3,"+",$$,1);
                }
	| expr_no_commas '-' expr_no_commas
		{ if (TRACEON) printf("69 ") ;  
		  $$=make_llnd(fi,SUBT_OP,$1,$3,SMNULL);
                  typeconversion_or_oo_handling($1,$3,"-",$$,1);
                }
	| expr_no_commas '*' expr_no_commas
		{ if (TRACEON) printf("70 ") ;
		  $$=make_llnd(fi,MULT_OP,$1,$3,SMNULL);
                  typeconversion_or_oo_handling($1,$3,"*",$$,1);
                }
	| expr_no_commas '/' expr_no_commas
		{ if (TRACEON) printf("71 ") ;
		  $$=make_llnd(fi,DIV_OP,$1,$3,SMNULL);
                  typeconversion_or_oo_handling($1,$3,"/",$$,1);
                }
	| expr_no_commas '%' expr_no_commas
		{ if (TRACEON) printf("72 ") ;
		  $$=make_llnd(fi,MOD_OP,$1,$3,SMNULL);
                  typeconversion_or_oo_handling($1,$3,"%",$$,1);
                }
	| expr_no_commas LSHIFT expr_no_commas
		{ if (TRACEON) printf("73 ") ;  
		  $$=make_llnd(fi,LSHIFT_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,"<<",$$,0))
		    $$->type = $1->type ;
                }
	| expr_no_commas RSHIFT expr_no_commas
		{ if (TRACEON) printf("74 ") ;  
		  $$=make_llnd(fi,RSHIFT_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,">>",$$,0))
		    $$->type = $1->type ;
                }
	| expr_no_commas ARITHCOMPARE expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("75 ") ;  
                  op1 = ($2 == ((int) LE_EXPR)) ? LE_OP : GE_OP ;
		  $$=make_llnd(fi,op1,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,map_op($2),$$,0))
		    $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas '<'  expr_no_commas  
                { if (TRACEON) printf("76 ") ; 
		  $$=make_llnd(fi,LT_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,"<",$$,0))
		    $$->type = global_int ;
                }
	| expr_no_commas '>'  expr_no_commas   
                { if (TRACEON) printf("77 ") ; 
		  $$=make_llnd(fi,GT_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,">",$$,0))
		    $$->type = global_int ;
                }
	| expr_no_commas EQCOMPARE expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("78 ") ;  
                  op1 = ($2 == ((int) NE_EXPR)) ? NE_OP : EQ_OP  ;
     		  $$=make_llnd(fi,op1,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,map_op($2),$$,0))
		    $$->type = global_int ;
                }
	| expr_no_commas '&' expr_no_commas
		{ if (TRACEON) printf("79 ") ;  
		  $$=make_llnd(fi,BITAND_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,"&",$$,0))
                  $$->type = global_int ;
                }
	| expr_no_commas '|' expr_no_commas
		{ if (TRACEON) printf("80 ") ;  
		  $$=make_llnd(fi,BITOR_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,"|",$$,0))
                  $$->type = global_int ;
                }
	| expr_no_commas '^' expr_no_commas
		{ if (TRACEON) printf("81 ") ;  
		  $$=make_llnd(fi,XOR_OP,$1,$3,SMNULL);
                  typeconversion_or_oo_handling($1,$3,"^",$$,1);
                }
	| expr_no_commas ANDAND expr_no_commas
		{ if (TRACEON) printf("82 ") ;  
		  $$=make_llnd(fi,AND_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,"&&",$$,0))
		    $$->type = global_int ;
                }
	| expr_no_commas OROR expr_no_commas
		{ if (TRACEON) printf("83 ") ; 
		  $$=make_llnd(fi,OR_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,"||",$$,0))
                  $$->type = global_int ;
                }
	| expr_no_commas '?' expr_no_commas ':' expr_no_commas  /* expr */
		{ PTR_LLND ll_node1;

                  if (TRACEON) printf("84 ") ; 
		  ll_node1=make_llnd(fi,EXPR_IF_BODY,$3,$5,SMNULL);
		  $$=make_llnd(fi,EXPR_IF,$1,ll_node1,SMNULL);
                  $$->type = type_conversion($3->type, $5->type);
		}
	| expr_no_commas '=' expr_no_commas
		{ if (TRACEON) printf("85 ") ; 
		  $$=make_llnd(fi,ASSGN_OP,$1,$3,SMNULL);
		  if (!typeconversion_or_oo_handling($1,$3,"=",$$,1))
		    $$->type  =$1->type;
                }
	| expr_no_commas ASSIGN expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("86 ") ;  
                  op1 = map_assgn_op($2);
		  $$=make_llnd(fi,op1,$1,$3,NULL);
		  if (!typeconversion_or_oo_handling($1,$3,map_op($2),$$,1))
		    $$->type  =$1->type;
                }

	;






/* modified */
primary:
        IDENTIFIER
  	{ 	  
	  if (TRACEON) printf("87 ") ; 
	  $$=primary_identifier_action($1);
	}
        | THIS
           { PTR_TYPE type,type1,type2;
	     PTR_BFND bf;
	     PTR_SYMB symb;
	     int status;

	     if (TRACEON) printf("87.5 ") ; 
	     $$ = make_llnd(fi,THIS_NODE,LLNULL,LLNULL,SMNULL);
	     bf= find_current_class_bfnd(pred_bfnd,&status);
	     if (!bf) err("not proper usage for this");
	     symb = bf->entry.template.symbol;
	     if (!symb) err("not proper usage for this");
	     if (symb->variant==COLLECTION_NAME) {
	        type1 =  get_type(fi,T_DERIVED_COLLECTION);
		type1->entry.col_decl.collection_name = symb;
		type2= get_type(fi,T_DERIVED_TYPE);
		type2->entry.derived_type =  elementtype_symb;
		type1->entry.col_decl.base_type = type2;
		type = get_type(fi,T_POINTER);
		type->entry.descriptive.base_type= type1;
		$$->type = type;
	     }
	     else {
	       type = get_type(fi,T_POINTER);
	       type->entry.descriptive.base_type= symb->type;
	       $$->type = type;
	     }

           }

        | NEW typename %prec '='
		{ PTR_LLND ll_1 ;
		  PTR_TYPE type;

                  if (TRACEON) printf("68.2 ") ;  
                  ll_1 = make_llnd(fi,CAST_OP,LLNULL,LLNULL,SMNULL);
                  ll_1->type = $2 ;
		  $$=make_llnd(fi,NEW_OP,ll_1,LLNULL,SMNULL);
                  if (ll_1->type->variant == T_ARRAY)
		      $$->type = ll_1->type;
		  else {
                    type = get_type(fi,T_POINTER);
                    type->entry.template.base_type = ll_1->type;
		    $$->type = type;
		  }
		}

        | NEW '(' typename ')'
            {	  PTR_LLND ll_1 ;
		  PTR_TYPE type;

                  if (TRACEON) printf("67.2 ") ;  
                  ll_1 = make_llnd(fi,CAST_OP,LLNULL,LLNULL,SMNULL);
                  ll_1->type = $3 ;
		  $$=make_llnd(fi,NEW_OP,ll_1,LLNULL,SMNULL);
                  if (ll_1->type->variant == T_ARRAY)
		      $$->type = ll_1->type;
		  else {
                    type = get_type(fi,T_POINTER);
                    type->entry.template.base_type = ll_1->type;
		    $$->type = type;
		  }
		}

	| NEW  maintype '(' nonnull_exprlist ')'  %prec HYPERUNARY
            {  PTR_TYPE type;
	       PTR_LLND ll_1 ;	

	       if (TRACEON) printf("69.2 ") ;  
               if (($2->variant == TYPE_NAME)||is_symbol_an_object($2->variant))
		 {
		   type = get_type(fi,T_DERIVED_TYPE);
		   type->entry.derived_type = (PTR_SYMB) $2;
		 }
	       else type = $2;
	       ll_1 = make_llnd(fi,CAST_OP,LLNULL,LLNULL,SMNULL);
	       ll_1->type = type;
	       $$=make_llnd(fi,NEW_OP,ll_1,$4,SMNULL);
	       if (ll_1->type->variant == T_ARRAY)
		 $$->type = ll_1->type;
	       else {
		 type = get_type(fi,T_POINTER);
		 type->entry.template.base_type = ll_1->type;
		 $$->type = type;
	       }
	     }

	| CONSTANT
                { if (TRACEON) printf("88 ") ;
                  $$ = $1 ;
		  /* Temporarily setting */
                  $$->type = find_constant_type($1);
                }
	| string
		{ PTR_TYPE type;
		  if (TRACEON) printf("89 ") ;
                  $$ = $1 ;    
		  /* Temporarily setting */
		  type = get_type(fi,T_POINTER);
		  type->entry.template.base_type = global_char;
                  $$->type = type;
                }
	| '(' expr ')'
		{ if (TRACEON) printf("90 ") ;
                  primary_flag =EXPR_LR ;
                  $$ = $2 ;
                }

	| '(' error ')'
		{ if (TRACEON) printf("91 ") ;   }
	| '(' compstmt ')'
		{ if (TRACEON) printf("92 ");

                }
        |   vector_constant       %prec '.'
                { if (TRACEON) printf("93 ") ;
                }

	| primary '('  
                {  PTR_SYMB symb;

                   if (TRACEON) printf("94.0 ") ;
                   if (exception_flag == ON)
		    {
                      /* strange behavior for default function */
                      symb= install_entry_2(cur_id_entry,FUNCTION_NAME,OTHER);
		      symb->type = global_int ;
                      exception_flag = OFF ;
                      if ($1) {
			$1->entry.template.ll_ptr2 =  make_llnd(fi,FUNCTION_REF,LLNULL,LLNULL,symb);
			$<ll_node>$ = $1 ;
		      }
		      else  $<ll_node>$ =  make_llnd(fi,FUNCTION_REF,LLNULL,LLNULL,symb);
		      $<ll_node>$->type = symb->type ;
		      }
                   else
                      $<ll_node>$ = $1 ;
		 }

          exprlist ')'   %prec '.'
		{ PTR_LLND lnode_ptr ,llp ;
                  int      status;
                  PTR_SYMB symb;

                  if (TRACEON) printf("94 ") ;  
/*                if (primary_flag & EXCEPTION_ON) primary_flag -= EXCEPTION_ON ; */
                  llp = $<ll_node>3 ;
                  status = OFF ;
                  if ((llp->variant == FUNC_CALL) && (!llp->entry.template.ll_ptr1))
                      { 
                         lnode_ptr = llp;
                         status = FUNC_CALL ;
		       }
                  if ((!status) &&((llp->variant == RECORD_REF)||
				   (llp->variant == POINTST_OP)||
				   (llp->variant == SCOPE_OP)))
		    {
                       lnode_ptr = llp->entry.template.ll_ptr2;
		       if ((lnode_ptr)&&(lnode_ptr->variant== FUNCTION_REF))
			 {
                           lnode_ptr->variant = FUNC_CALL;
			 }
                       status = FUNC_CALL ;
		     }
                  if ((!status) &&(llp->variant== FUNCTION_REF))
		    {  llp->variant = FUNC_CALL ;
                       status = FUNC_CALL ;
		       lnode_ptr = llp;
		     }
		  if (!status) {
                       status = FUNCTION_OP;
		       lnode_ptr = llp;
		     }
                  switch (status) {
                  case FUNCTION_OP : $$ =make_llnd(fi,FUNCTION_OP,$<ll_node>3,$4,SMNULL);
                                     $$->type = $<ll_node>3->type ;
                                     break;
                  case FUNC_CALL :   lnode_ptr->entry.template.ll_ptr1=$4;
		                     confirm_overloaded_function(lnode_ptr,$4);
                                     $$ = $<ll_node>3 ;
                                     break;
		    default :        err("system error 10");
		  }
		  typeconversion_or_oo_handling(llp,$4,"()",$$,0);
		}

	| primary '[' expr_vector ']'   %prec '.'
	   { int status ;
             PTR_LLND ll_ptr,lp1;

             if (TRACEON) printf("95 ") ;
             ll_ptr = check_array_id_format($1,&status);
             switch (status) {
             case NO : err("syntax error ");
                       break ;
	     case ARRAY_OP_NEED:
                       lp1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);/*mod*/
                       $$ = make_llnd(fi,ARRAY_OP,$1,lp1,SMNULL);
                       break;
             case ID_ONLY :
                       ll_ptr->variant = ARRAY_REF ;
                       ll_ptr->entry.template.ll_ptr1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
                       $$ = $1 ;
                       break;
             case RANGE_APPEAR :
	               ll_ptr->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
 	               $$ = $1 ; 
                       break;
             }
	     
	     if (!typeconversion_or_oo_handling($1,$3,"[]",$$,0))
	       $$->type = adjust_deref_type($1->type,DEREF_OP);	       
           }


	| primary '.' identifier
		{ PTR_LLND l_ptr1,l_ptr2,p1 ;
                  int sw,tag ;
		  PTR_SYMB object;

                  if (TRACEON) printf("96 ") ;  
                  sw = check_field_decl($1,$3,0);
                  if (sw ==NO){ err("error member"); $$ = LLNULL;}
                  else {
                        tag  = map2( right_symbol->variant)  ;
                        l_ptr2 = make_llnd(fi,tag,LLNULL,LLNULL,right_symbol);
			$$ = make_llnd(fi,RECORD_REF,$1,l_ptr2,SMNULL);
                        $$->type = adjust_array_type(right_symbol);
                        $$->type = adjust_element_type($1,$$->type);
			l_ptr2->type = $$->type;
			
                       }
                 }
        | TYPENAME DOUBLEMARK identifier
                { PTR_SYMB symbptr, object;
                    
                  $$= install_scope_operator($1,$3,pred_bfnd);
                }

	| DOUBLEMARK identifier
		{ PTR_SYMB symbptr;
		  PTR_LLND ll;
 
                  if (TRACEON) printf("96 ") ;  
                  symbptr = find_global_symbol($2,VARIABLE_NAME);
                  if (! symbptr){  /* default function expected */
                                   exception_flag = ON ;
                                   cur_id_entry = $2 ;
                                   ll= LLNULL;
				 }
                  else {
                      switch (symbptr->variant) {
                      case MEMBER_FUNC :
                      case FUNCTION_NAME:
                           /* primary_flag = EXCEPTION_ON ;  */
                           /* above one incorrect while nested */
                           ll = make_llnd(fi,FUNCTION_REF,LLNULL,LLNULL,symbptr);
                           break;
                      case FIELD_NAME :
                      case VARIABLE_NAME:
                           ll = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
                           break;
			 }
                       $$->type = adjust_array_type(symbptr);
		    }
                  $$= make_llnd(fi,SCOPE_OP,LLNULL,ll,SMNULL);
                  if (symbptr) $$->type = symbptr->type;
                  else         $$->type = global_int;
		}

	| primary POINTSAT identifier
		{ PTR_LLND l_ptr,l_ptr2;
		  PTR_SYMB symb_ptr1;
		  int      tag ;
 
                  if (TRACEON) printf("97 ") ; 
                  if ($1->variant == THIS_NODE) {
                      symb_ptr1 = find_field_for_this($3);
                  }
		  else {                     
		    if (!$1) err("undefined symbol");
		    symb_ptr1= find_field_symb_by_type($1->type, $3); 
		  }
		  tag  = map2( symb_ptr1->variant)  ;
		  l_ptr = make_llnd(fi,tag,LLNULL,LLNULL,symb_ptr1);
                  $$ = make_llnd(fi,POINTST_OP,$1,l_ptr,SMNULL);
                  $$->type = adjust_array_type(symb_ptr1);
                  $$->type = adjust_element_type($1,$$->type);
		  l_ptr->type = $$->type;
		  

		}
                              
	| primary PLUSPLUS
		{ if (TRACEON) printf("98 ") ;
                  $$ = make_llnd(fi,PLUSPLUS_OP,LLNULL,$1,SMNULL);
		  $$->type = $1->type ;
                }
	| primary MINUSMINUS
		{ if (TRACEON) printf("99 ") ; 
                  $$ = make_llnd(fi,MINUSMINUS_OP,LLNULL,$1,SMNULL);
		  $$->type = $1->type ;
		}
	;




/* Produces a STRING_CST with perhaps more STRING_CSTs chained onto it.  */
string:
	  STRING
            { if (TRACEON) printf("100 ") ;
              $$ = $1 ;
            }
	| string STRING
		{ if (TRACEON) printf("101 ") ; }
	;

xdecls:
	/* empty */
           { if (TRACEON) printf("102 ") ; }
	| decls
           { if (TRACEON) printf("103 ") ; }
	;

decls:
	decl
           { if (TRACEON) printf("104 ") ;
              main_type_flag = TYPE_FOUR ;  
           }
	| errstmt
           { if (TRACEON) printf("105 ") ; }
	| decls decl
           { if (TRACEON) printf("106 ") ;
              main_type_flag = TYPE_FOUR ; 
           }
	| decl errstmt
           { if (TRACEON) printf("107 ") ; }
	;


/* records the type and storage class specs to use for processing
   the declarators that follow */
setspecs: /* empty */
           { if (TRACEON) printf("108 ") ;  }

	;

decl:
	typed_declspecs  initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND bf1 ;
            PTR_SYMB dummy_symb;

            if (TRACEON) printf("109 ");
            chain_type_declarator($1,OFF,$2,&dummy_symb,NO);
	    fill_comment();
	  }

	| declmods    notype_initdecls ';'
         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;
            PTR_SYMB dummy_symb;


           if (TRACEON) printf("110 ");
           ptr1 = $1 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,OFF,$2,&dummy_symb,NO);
           fill_comment();
	 }

	| typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;
            PTR_SYMB dummy_symb;

            if (TRACEON) printf("111  "); 
            blob = follow_blob(pred_bfnd);
    	    fill_comment();
         if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))

	   {
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name))
	      {  symb2= find_type_symbol(name->parent,VARIABLE_NAME,area());
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err(" redeclaration symbol ");
                 else   name->scope = pred_bfnd;
	       }
	  }
	  }

	| declmods ';'
		{ if (TRACEON) printf("112 ") ; 
	          fill_comment();
                }
	| ACCESSWORD  typed_declspecs    initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND bf1;
            PTR_SYMB dummy_symb;

            if (TRACEON) printf("109.2 ");
            chain_type_declarator($2,$1,$3,&dummy_symb,NO);
	    fill_comment();
	  }

	| ACCESSWORD  declmods    notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;
	   PTR_SYMB dummy_symb;

           if (TRACEON) printf("110.2 ");

           ptr1 = $2 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,$1,$3,&dummy_symb,NO);
	    fill_comment();
	 }

	| ACCESSWORD  typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;

            if (TRACEON) printf("111.2 "); 
            blob = follow_blob(pred_bfnd);
    	    fill_comment();
         if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))
	   {
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name) )
	      {  symb2= find_type_symbol(name->parent,VARIABLE_NAME,area());
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err_symb(" redeclaration symbol ",symb2->ident);
                 else   name->scope = pred_bfnd;
	       }
	  }
	  }
	| ACCESSWORD  declmods ';'
		{ if (TRACEON) printf("112.2 ") ; 
	          fill_comment();
		}
	;

/* declspecs which contain at least one type specifier or typedef name.
   (Just `const' or `short' is not enough.)
   A typedef'd name following these is taken as a name to be declared.  */

typed_declspecs:
	  maintype typed_declfinal
         {
            if (TRACEON) printf("113 ") ; 
	    $$= typed_declspecs_without_declmods($1,$2,0);
	  }
	| declmods maintype typed_declfinal
          {
	    if (TRACEON) printf("114 ") ; 
	    $$=typed_declspecs_with_declmods($2,$1,0);
          }
         ;


typed_declspecs_2:
	  maintype typed_declfinal
           {
             if (TRACEON) printf("113 ") ; 
	     $$= typed_declspecs_without_declmods($1,$2,1);
	   }

	| declmods maintype typed_declfinal
           {
             if (TRACEON) printf("114 ") ; 
	     $$=typed_declspecs_with_declmods($2,$1,1);
	   }

        ;





typed_declfinal:  /* empty */
		{ if (TRACEON) printf("115 ") ;  }
	| typed_declfinal typespec_reserved
		{ if (TRACEON) printf("116 ") ;
                  install_declmod(&second_part,$2);
                }
	| typed_declfinal SCSPEC
		{ if (TRACEON) printf("117 ") ;
                  install_declmod(&second_part,$2);
                }
	;

/* List of just storage classes and type modifiers.
   A declaration can start with this, but then it cannot be used
   to redeclare a typedef-name (unless you use parentheses).  */

declmods:
	  new_TYPEMOD
		{ PTR_TYPE ptr;
                  if (TRACEON) printf("118 ") ;
                  ptr = get_type(fi,T_DESCRIPT);
                  $$ = install_declmod(ptr, $1);
                }


	| SCSPEC
		{ PTR_TYPE ptr;
                  if (TRACEON) printf("119 ") ;  
                  ptr = get_type(fi,T_DESCRIPT);
                  $$ = install_declmod(ptr, $1);
                }
	| declmods new_TYPEMOD
		{
                  if (TRACEON) printf("120 ") ;  
                  $$ = install_declmod($1,$2);
                }
	| declmods SCSPEC
		{ if (TRACEON) printf("121 ") ; 
                  $$ = install_declmod($1,$2);
                }
	;

new_TYPEMOD:    TYPEMOD
            {}
        |  FUTURE
            {}
        |  VIRTUAL
            {}
        |  INLINE
            {}
        ;


/* Used instead of declspecs where storage classes are not allowed
   (typenames and structure components)
   Don't accept a typedef-name if anything but a modifier precedes it.  */

typed_typespecs:
	  maintype typespecfinal

           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_BFND bf2;
             PTR_SYMB gsym;
	     PTR_BLOB blob2 ;

             if (TRACEON) printf("122 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1=$1 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $1;
                             type_ptr1 = type_ptr2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
	                     blob2 = follow_blob(pred_bfnd);
                             bf2 = blob2->ref ;
                             eliminate_lastlink();
                             if ((gsym= bf2->entry.template.symbol))
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1 = type_ptr2;
                                $$ = type_ptr1;
                              }
                             else {
                                $$= $1 ;
			      }
                            /* passed_bfnd=new_cur_bfnd = bf2 ;     */
                            break;
	     default :      err("System Crash ");   }
	   }

	| nonempty_typemods maintype typespecfinal

           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_SYMB gsym;
             PTR_BFND bf2;
	     PTR_BLOB blob2 ;

             if (TRACEON) printf("123 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1 = combine_2($1, &second_part);
                             type_ptr1 = $1 ;
                             type_ptr1->entry.descriptive.base_type=$2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $2 ;
                             type_ptr1 = $1 ;
                             type_ptr1 = combine_2($1,&second_part);
                             type_ptr1->entry.descriptive.base_type= type_ptr2 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
                             type_ptr1 = $1;
	                     blob2 = follow_blob(pred_bfnd);
	                     bf2 = blob2->ref ;
                             eliminate_lastlink();
                             if (gsym= bf2->entry.template.symbol)
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$ = type_ptr1 ;
                              }
                             else {
                                type_ptr2 = $2;
                                /* new_cur_type must be set inside structsp */
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$=type_ptr1;
			      }
                            /* passed_bfnd=new_cur_bfnd = bf2 ;  */
                            break;
	     default :      err("System Crash ");   }
	   }

	;

typespecfinal:  /* empty */
		{ if (TRACEON) printf("124 ") ;  }
	| typespecfinal typespec_reserved
		{ if (TRACEON) printf("125 ") ;  }
	;

/* Any kind of typespec.  

typespec: TYPESPEC
            { if (TRACEON) printf("126 ") ; }
	| new_TYPEMOD
            { if (TRACEON) printf("127 ") ; }
	| structsp
            { if (TRACEON) printf("128 ") ; }
	| TYPENAME
            { if (TRACEON) printf("129 ") ; }
	;
*/
/* A typespec that is not a modifier.
   It is never correct to use two of these in one declaration.
   But we try to parse it and report a "semantic" error message later.  */

maintype: TYPESPEC
            { if (TRACEON) printf("130 ") ;
              $$= map_rid_to_type($1);
              main_type_flag = TYPE_ONE ;
	    }

	| structsp
            { if (TRACEON) printf("131 ") ;
              $$ = (PTR_TYPE) $1 ;
              main_type_flag = TYPE_THREE ;

            }
	| TYPENAME
            { PTR_SYMB s;

              if (TRACEON) printf("132 ") ;
              s= find_type_symbol($1,TYPE_NAME,area());
              $$= (PTR_TYPE) s;
              main_type_flag = TYPE_TWO ;
            }
	| TYPENAME '<'  TYPESPEC '>'
            { PTR_SYMB symb1,symb2;
              PTR_TYPE type1,type2;

              symb1= find_object_symbol($1);
	      if (!symb1) err("undefined collection symbol");
              $$ = type1 =  get_type(fi,T_DERIVED_COLLECTION);
              type1->entry.col_decl.collection_name = symb1;
	      if (symb1->type->variant!=T_COLLECTION) 
		err("collection name expected");
	      else type1->entry.col_decl.base_type = map_rid_to_type($3);
              main_type_flag = TYPE_ONE ;
	    }
	| TYPENAME '<'  TYPENAME '>'
            { PTR_SYMB symb1,symb2;
              PTR_TYPE type1,type2;

              symb1= find_object_symbol($1);
	      if (!symb1) err("undefined collection symbol");
              $$ = type1 =  get_type(fi,T_DERIVED_COLLECTION);
              type1->entry.col_decl.collection_name = symb1;
	      if (symb1->type->variant!=T_COLLECTION) 
		err("collection name expected");
              symb2= find_type_symbol($3,TYPE_NAME,area()) ;
              type2= get_type(fi,T_DERIVED_TYPE);
              type2->entry.derived_type = (PTR_SYMB) symb2;
	      type1->entry.col_decl.base_type = type2;
              main_type_flag = TYPE_ONE ;
	    }
	;

/* A typespec that is a reserved word.
typespec_reserved: TYPESPEC
            { if (TRACEON) printf("133 ") ; }
	| new_TYPEMOD
            { if (TRACEON) printf("134 ") ; }
	| structsp
            { if (TRACEON) printf("135 ") ; }
	;
*/

typespec_reserved: new_TYPEMOD  
            { if (TRACEON) printf("134 ") ;
              $$ = $1 ;
            }
        ;


initdecls:
	initdcl
            {  PTR_BLOB blob ;
               PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("136 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              exprlist_llnd->entry.template.ll_ptr1 = $1 ;
              $$ = exprlist_llnd ;
	    }
	| initdecls ',' initdcl
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("137 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$ = exprlist_llnd ;
	    }
	;



notype_initdecls:
	notype_initdcl
            {  PTR_BLOB blob ;
               PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("138 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              exprlist_llnd->entry.template.ll_ptr1 = $1 ;
              $$ = exprlist_llnd ;
	    }

	| notype_initdecls ',' initdcl
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("139 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$ = exprlist_llnd ;
	    }

	;



initdcl:
	  declarator  '='
	
	  init
/* Note how the declaration of the variable is in effect while its init is parsed! */
		{ if (TRACEON) printf("141 ") ; 
                   $$ = make_llnd(fi,ASSGN_OP,$1,$3,SMNULL);
		}
	| declarator '='
	
	  error
		{ if (TRACEON) printf("143 ") ;  }
	| declarator
		{ if (TRACEON) printf("144 ") ;  
                  $$=$1;
                }
	;




notype_initdcl:
	  notype_declarator '='
	
	  init

		{ if (TRACEON) printf("146 ") ;  
                   $$ = make_llnd(fi,ASSGN_OP,$1,$3,SMNULL);
		}

	| notype_declarator '='
	
	  error
		{ if (TRACEON) printf("148 ") ;  }
	| notype_declarator
		{ if (TRACEON) printf("149 ") ; 
                  $$=$1 ;
                }
	;



/* modified */
init:
          expr_no_commas
                { if (TRACEON) printf("150 ") ;
                  $$=$1 ;
                }

        | '{' initlist '}'
                { if (TRACEON) printf("151 ") ; 
                  $$= make_llnd(fi,INIT_LIST,$2,LLNULL,SMNULL);
		}
        | '{' initlist ',' '}'
                { if (TRACEON) printf("152 ") ; 
                  $$= make_llnd(fi,INIT_LIST,$2,LLNULL,SMNULL); 
		}
	;

/* This chain is built in reverse order,
   and put in forward order where initlist is used.  */
/* modified */
initlist:
	inside
		{ if (TRACEON) printf("153 ") ;
                  $$ = make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
		}
	| initlist ',' inside
            { PTR_LLND ll_node1;

              if (TRACEON) printf("154 ") ; 
              ll_node1 = follow_llnd($1,2);
              ll_node1->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
              $$=$1;
	    }

	;


/* modified */
inside: 
         init
           { if (TRACEON) printf("155 ") ;
             $$=$1;
	   }
       | array_expr_a
           { if (TRACEON) printf("156 ") ;
             $$=$1 ;
	   }
       | array_expr_b
           { if (TRACEON) printf("157 ") ;
             $$=$1;
	   }

       ;


/* Any kind of declarator (thus, all declarators allowed
   after an explicit typespec).  */

declarator:
	  notype_declarator
             { PTR_LLND ll;
	       PTR_SYMB symb;
               if (TRACEON) printf("159 ") ;
	       $$= $1 ;     
	       symb = find_proc_name();
	       if (symb->decl)  {
		 check_extern_first_part(symb);
	       }
	     }
        | after_type_declarator
             { PTR_LLND ll;
	       PTR_SYMB symb;
               if (TRACEON) printf("159.2 ") ;
	       $$= $1 ;     
	       symb = find_proc_name();
	       if (symb->decl)  {
		 check_extern_first_part(symb);
	       }
	     }

          ;


after_type_declarator:
	  after_type_declarator '(' parmlist ')'  %prec '.'
		{ PTR_LLND ll; 
                  PTR_SYMB symb;

                  if (TRACEON) printf("161 ") ;
                  symb = find_proc_name();
                  ll = $1 ;
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                  
                }

	| after_type_declarator '(' identifiers ')'  %prec '.'
		{ PTR_LLND ll;
                  PTR_SYMB symb;

                  if (TRACEON) printf("162 ") ;
                  ll = $1 ;
                  symb = find_proc_name();
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                }

	| after_type_declarator '(' error ')'  %prec '.'
		{ if (TRACEON) printf("163 ") ; }
/*
	| '(' after_type_declarator ')'
		{ PTR_LLND ll;

                  if (TRACEON) printf("164 ") ;
                  cur_flag = CLEAN ;
                  cur_flag = RULE_LR ;
                  $$ = $2 ;
                }
       
*/
	| '*' typemods after_type_declarator  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                 if (TRACEON) printf("165 ") ;
                 ll=$3;
                 $$ = make_llnd(fi,DEREF_OP,ll,LLNULL,SMNULL);
                 symbptr1 = find_proc_name();
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_POINTER);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_POINTER);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                    case T_REFERENCE:
                          type_1= type->entry.template.base_type=get_type(fi,T_POINTER);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }
	| '&' typemods after_type_declarator  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                if (TRACEON) printf("165 ") ;
                ll=$3;
                $$ = make_llnd(fi,ADDRESS_OP,ll,LLNULL,SMNULL);
		symbptr1 = find_proc_name();
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_REFERENCE);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_REFERENCE);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                    case T_REFERENCE:
                          type_1= type->entry.template.base_type=get_type(fi,T_REFERENCE);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }
	| after_type_declarator '[' expr ']'  %prec '.'
		{ 
 		  $$= chain_array_op_range($1,$3);
		  cur_flag = cur_flag | RULE_ARRAY ;
		}

	| after_type_declarator '[' ']'  %prec '.'
		{ PTR_LLND ll;
 		  $$= chain_array_op_range($1,NULL);
		  cur_flag = cur_flag | RULE_ARRAY ;
		}

        | after_type_declarator '(' expr ')'      %prec '.'
                 {  PTR_LLND ll ;

                    if (TRACEON) printf("168 ") ;
                    ll = $1 ;
                    if ((cur_flag - RULE_ID) &&(cur_flag - RULE_ID - RULE_ARRAY))
                        err("syntax error 3");
                    else {
                        $$ = make_llnd(fi,CLASSINIT_OP,ll,$3,SMNULL);
                        cur_flag = cur_flag | RULE_CLASSINIT ;
                    }
                 }
	| TYPENAME 
            { if (TRACEON) printf("169 ") ;
                   $$=lazy_install($1,VARIABLE_NAME,NO);
	    } 
        | '~' TYPENAME 
             {  char tmp[256],*s1;
                int  status;
                PTR_HASH entry;

                s1 = tmp;
                *s1++ = '~';
                strcpy(s1,$2->ident);
                s1 = copys(tmp);
                entry = look_up_type(s1,&status);
                $$=lazy_install(entry,VARIABLE_NAME,NO);

             }


/*        | multiple_typename
            { if (TRACEON) printf("168 ") ;}
*/
	;

/* A declarator allowed whether or not there has been
   an explicit typespec.  These cannot redeclare a typedef-name.  */
 
/* modified */
notype_declarator:
	  notype_declarator '(' parmlist ')'  %prec '.'
		{ PTR_LLND ll; 
                  PTR_SYMB symb;

                  if (TRACEON) printf("169 ") ;
                  symb = find_proc_name();
                  ll = $1 ;
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                  
                }
	| notype_declarator '(' identifiers ')'  %prec '.'
		{ PTR_LLND ll;
                  PTR_SYMB symb;

                  if (TRACEON) printf("170 ") ;
                  ll = $1 ;
                  symb = find_proc_name();
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                }

	| notype_declarator '(' error ')'  %prec '.'
		{ if (TRACEON) printf("171 ") ; }
	| '(' notype_declarator ')'
		{ PTR_LLND ll;

                  if (TRACEON) printf("172 ") ;
                  cur_flag = CLEAN ;
                  cur_flag = RULE_LR ;
                  $$ = $2 ;
                }
	| '*'  typemods notype_declarator  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                 if (TRACEON) printf("173 ") ;
                 ll=$3;
                 $$ = make_llnd(fi,DEREF_OP,ll,LLNULL,SMNULL);
                 symbptr1 = find_proc_name();
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_POINTER);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_POINTER);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                    case T_REFERENCE:
                          type_1= type->entry.template.base_type=get_type(fi,T_POINTER);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }
	| '&'  typemods notype_declarator  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                 if (TRACEON) printf("173 ") ;
                 ll=$3;
                 $$ = make_llnd(fi,ADDRESS_OP,ll,LLNULL,SMNULL);
                 symbptr1 = find_proc_name();
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_REFERENCE);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_REFERENCE);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                    case T_REFERENCE:
                          type_1= type->entry.template.base_type=get_type(fi,T_REFERENCE);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }
	| notype_declarator '[' expr_no_commas ']'  %prec '.'
		{ PTR_LLND ll ;

                  if (TRACEON) printf("174 ") ;
		  $$=chain_array_op_range($1,$3);
		  cur_flag = cur_flag | RULE_ARRAY ;
                }
	| notype_declarator '[' ']'  %prec '.'
		{ PTR_LLND ll;

                  if (TRACEON) printf("175 ") ; 
		  $$=chain_array_op_range($1,NULL);
		  cur_flag = cur_flag | RULE_ARRAY ;
                }

       
	| notype_declarator '(' expr ')'      %prec '.'
                 {  PTR_LLND ll ;

                    if (TRACEON) printf("176 ") ;
                    ll = $1 ;
                    if ((cur_flag - RULE_ID) &&(cur_flag - RULE_ID - RULE_ARRAY))
                        err("syntax error 3");
                    else {
                        $$ = make_llnd(fi,CLASSINIT_OP,ll,$3,SMNULL);
                        cur_flag = cur_flag | RULE_CLASSINIT ;
                    }
                 }
        | IDENTIFIER
             {
                   $$=lazy_install($1,VARIABLE_NAME,NO);

             }
        | '~' IDENTIFIER
             {  char tmp[256],*s1;
                int  status;
                PTR_HASH entry;

                s1 = tmp;
                *s1++ = '~';
                strcpy(s1,$2->ident);
                s1 = copys(tmp);
                entry = look_up_type(s1,&status);
                $$=lazy_install(entry,VARIABLE_NAME,NO);

             }
        | OPERATOR LOADEDOPR  
             {  PTR_HASH entry; 
                if (TRACEON) printf("190 ") ;
                $$ = lazy_install($2,FUNCTION_NAME,NO);
	      }
        | multiple_id
             { if (TRACEON) printf("178 ") ;
               $$=$1 ; 
             }
        | NEW
             {int status;
	      PTR_HASH entry;
	      entry = look_up_type("new",&status);
	      $$=lazy_install(entry,FUNCTION_NAME,NO);
	      }
        | DELETE
             {int status;
	      PTR_HASH entry;
	      entry = look_up_type("delete",&status);
	      $$=lazy_install(entry,FUNCTION_NAME,NO);
	    }
	;

/*
multiple_typename :
          TYPENAME  DOUBLEMARK multiple_id2
        { if (TRACEON) printf("179 ") ;}
        ;

*/
/* '::'  DOUBLEMARK */
multiple_id : identifier DOUBLEMARK  identifier
            { int sw ;
	      PTR_SYMB symb,object;

              if (TRACEON)  printf("180 ") ;
	      object = find_object_symbol($1);
	      if (!object) err("unknown class/struct name");
              symb= check_field_decl_2(object,$3,FUNCTION_ONLY);
	      symb->ud_chain = (PTR_BLOB) symb->type;
	      symb->type     = (PTR_TYPE) NULL;
	      symb->decl     =  symb->variant;
	      $$ = derived_lazy_install(symb);
	    }
        | identifier DOUBLEMARK  OPERATOR LOADEDOPR  
            { int sw ;
	      PTR_SYMB symb,object;

              if (TRACEON)  printf("180 ") ;
	      object = find_object_symbol($1);
	      if (!object) err("unknown class/struct name");
              symb= check_field_decl_2(object,$4,FUNCTION_ONLY);
	      symb->ud_chain = (PTR_BLOB) symb->type;
	      symb->type     = (PTR_TYPE) NULL;
	      symb->decl     =  symb->variant;
	      $$ = derived_lazy_install(symb);
	    }
        | identifier DOUBLEMARK  NEW
             {int status;
	      PTR_HASH entry;
	      PTR_SYMB symb,object;

	      entry = look_up_type("new",&status);
	      object = find_object_symbol($1);
	      if (!object) err("unknown class/struct name");
              symb= check_field_decl_2(object,entry,FUNCTION_ONLY);
	      symb->ud_chain = (PTR_BLOB) symb->type;
	      symb->type     = (PTR_TYPE) NULL;
	      symb->decl     =  symb->variant;
	      $$ = derived_lazy_install(symb);
	    }
        | identifier DOUBLEMARK  DELETE
             {int status;
	      PTR_HASH entry;
	      PTR_SYMB symb,object;

	      entry = look_up_type("delete",&status);
	      object = find_object_symbol($1);
	      if (!object) err("unknown class/struct name");
              symb= check_field_decl_2(object,entry,FUNCTION_ONLY);
	      symb->ud_chain = (PTR_BLOB) symb->type;
	      symb->type     = (PTR_TYPE) NULL;
	      symb->decl     =  symb->variant;
	      $$ = derived_lazy_install(symb);
	    }

         |  identifier DOUBLEMARK '~' identifier
            { int sw ;
	      char tmp[256],*s1;
	      int  status;
	      PTR_HASH entry;
	      PTR_SYMB symb,object;

              if (TRACEON)  printf("180 ") ;
	      s1 = tmp;
	      *s1++ = '~';
	      strcpy(s1,$4->ident);
	      s1 = copys(tmp);
	      entry = look_up_type(s1,&status);
	      object = find_object_symbol($1);
	      if (!object) err("unknown class/struct name");
              symb= check_field_decl_2(object,entry,FUNCTION_ONLY);
	      symb->ud_chain = (PTR_BLOB) symb->type;
	      symb->type     = (PTR_TYPE) NULL;
	      symb->decl     =  symb->variant;
	      $$ = derived_lazy_install(symb);
	    }
        ;




/* modified */
structsp: UNION identifier
               { PTR_SYMB symb1 ;
                 symb1 = find_type_symbol($2,UNION_NAME,area()) ;
                 if ((!symb1) ||(!same_scope(symb1->scope,pred_bfnd)))
		   {
		     symb1 = install_entry_2($2,UNION_NAME,UP_TO_NODECL) ;
		   }
		 
                 else 
		   { if (same_scope(symb1->scope,pred_bfnd)&& (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(UNION_DECL,symb1,LLNULL);


               }
           '{' component_decl_list '}'
		{ PTR_TYPE type;
		  PTR_SYMB symb;

		  if (TRACEON) printf("196 ") ;
		  type = $$ = install_struct(T_UNION,SMNULL);
                }
	| UNION 
               { char buffer[200];
		 PTR_HASH entry;
		 PTR_SYMB symb1;
		 int status;
		 
		 sprintf(buffer,"Z%d_Dummy",enum_id++);
		 entry = look_up_type(buffer,&status);
		 symb1 = install_entry_2(entry,UNION_NAME,UP_TO_NODECL);
		 symb1->entry.template.seen = BEEN_SEEN;
		 enter_inner_level(UNION_DECL,symb1,LLNULL); 
		}

            '{' component_decl_list '}'
		{  if (TRACEON) printf("197 ") ;
                   $$=install_struct(T_UNION,SMNULL);
		 }
	| UNION identifier
		{ PTR_SYMB symb1 ;

                 if (TRACEON) printf("198 ") ;  
                 symb1 = find_type_symbol($2,UNION_NAME,area()) ;
                 if (!symb1){  symb1 = install_entry_2($2,UNION_NAME,UP_TO_NODECL);
			       symb1->type = (PTR_TYPE)NULL;
                               symb1->entry.template.seen = NOT_SEEN ;
			     }
                 type_checking(symb1,T_UNION);
                 $$ = set_struct_typename(UNION_DECL,symb1);
                }
	| general_classname identifier optionlist ':' TYPENAME_list
             {   PTR_SYMB symb1 ;

                 symb1 = find_type_symbol($2,name_of_struct($1),area()) ;
                 if ((!symb1) ||( !same_scope(symb1->scope,pred_bfnd)))
		   {
		     symb1 = install_entry_2($2,name_of_struct($1),UP_TO_NODECL);
		   }
                 else 
		   { if (same_scope(symb1->scope,pred_bfnd)&&(symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(node_of_struct($1),symb1,$5);           
		 pred_bfnd->entry.template.ll_ptr2 = $5;
		 pred_bfnd->entry.template.ll_ptr3 = $3;

                }
          '{' component_decl_list  '}'
                { PTR_BLOB blob;
		  PTR_BFND bf1;
		  PTR_SYMB symb;
		  PTR_TYPE type;

                  if (TRACEON) printf("199 ") ;
                  type = install_struct(type_of_struct($1),$5);
		  $$ = type;
                  blob = follow_blob(pred_bfnd);
		  bf1 = blob->ref;
		  bf1->prop_list =(PTR_PLNK) NULL;
              }

	| general_classname identifier   optionlist
              {  PTR_SYMB symb1;
                 symb1 = find_type_symbol($2,name_of_struct($1),area()) ;
                 if ((!symb1) ||(!same_scope(symb1->scope,pred_bfnd)))
		   {
		     symb1 = install_entry_2($2,name_of_struct($1),UP_TO_NODECL);
		   }
                else 
		   { if (same_scope(symb1->scope,pred_bfnd)&& (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(node_of_struct($1),symb1,LLNULL);
		 pred_bfnd->entry.template.ll_ptr3 = $3;
                }
          '{' component_decl_list '}'
                { PTR_SYMB symb;
		  PTR_TYPE type;
		  PTR_BLOB blob;
                  PTR_BFND bf1;

		  if (TRACEON) printf("200 ");
                  type = install_struct(type_of_struct($1),SMNULL);
		  $$=type;
                  blob = follow_blob(pred_bfnd);
		  bf1 = blob->ref;
		  bf1->prop_list =(PTR_PLNK) NULL;
                }

	| general_classname optionlist
               { char buffer[200];
		 PTR_SYMB symb1;
		 PTR_HASH entry;
		 int status;
		 
		 sprintf(buffer,"Z%d_Dummy",enum_id++);
		 entry = look_up_type(buffer,&status);
		 symb1 = install_entry_2(entry,name_of_struct($1),UP_TO_NODECL);
		 symb1->entry.template.seen = BEEN_SEEN;
		 enter_inner_level(node_of_struct($1),symb1,LLNULL); 
		}
         '{' component_decl_list  '}'
                { PTR_BLOB blob;
                  PTR_BFND bf1;

		  if (TRACEON) printf("201 ") ; 
                  $$ = install_struct(type_of_struct($1),SMNULL);
                  blob = follow_blob(pred_bfnd);
		  bf1 = blob->ref;
		  bf1->prop_list =(PTR_PLNK) NULL;
                }

	| general_classname identifier optionlist
                {     PTR_SYMB symb1;
                     
                      if (TRACEON) printf("202 ") ;
                      symb1 = find_type_symbol($2,name_of_struct($1),area()) ;
                      if (!symb1){  symb1 = install_entry_2($2,name_of_struct($1),UP_TO_NODECL) ;
				    symb1->type = (PTR_TYPE)NULL;
                                    symb1->entry.template.seen = NOT_SEEN ;
		  	     }
                      type_checking(symb1,type_of_struct($1));
                      $$ = set_struct_typename(node_of_struct($1),symb1);
                }
	| ENUM identifier
              {  PTR_SYMB symb1;
                 symb1 = find_type_symbol($2,ENUM_NAME,area()) ;
                 if ((!symb1) ||(!same_scope(symb1->scope,pred_bfnd)))
		   {
		     symb1 = install_entry_2($2,ENUM_NAME,UP_TO_NODECL);
		   }
		 else 
		   { if (same_scope(symb1->scope,pred_bfnd)&& (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(ENUM_DECL,symb1,LLNULL); 
                }
               '{' enumlist '}'
		{  if (TRACEON) printf("203 ") ; 
                  $$ = install_struct(T_ENUM,SMNULL);
                }
	| ENUM 
               { char buffer[200];
		 PTR_SYMB symb1;
		 int status;
		 PTR_HASH entry;
		 
		 sprintf(buffer,"Z%d_Dummy",enum_id++);
		 entry = look_up_type(buffer,&status);
		 symb1 = install_entry_2(entry,ENUM_NAME,UP_TO_NODECL);
		 symb1->entry.template.seen = BEEN_SEEN;
		 enter_inner_level(ENUM_DECL,symb1,LLNULL); 
		}
              '{'  enumlist '}'
		{ if (TRACEON) printf("205 ") ;
                  $$ = install_struct(T_ENUM,SMNULL);
                }
	| ENUM identifier
		{ PTR_SYMB symb1 ;
                 
                  if (TRACEON) printf("206 ") ;
                  symb1 = find_type_symbol($2,ENUM_NAME,area()) ;
                  if (!symb1){  symb1 = install_entry_2($2,ENUM_NAME,UP_TO_NODECL);
				symb1->type = (PTR_TYPE)NULL;
				symb1->entry.template.seen = NOT_SEEN ;
			     }
                  type_checking(symb1,T_ENUM);
                  $$ = set_struct_typename(ENUM_DECL,symb1);
                }
	;



general_classname:
          CLASS
            {  $$ = CLASS; }
       |  COLLECTION
            {  $$ = COLLECTION;}
       |  STRUCT
            {  $$ = STRUCT; }
       ;

optionlist:
            { $$=LLNULL;}
       |  ELEMENTTYPEOF TYPENAME
            { PTR_SYMB symb;
	      symb = find_object_symbol($2);
	      $$= make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
	    }

        ;

TYPENAME_list:
          TYPENAME
           { PTR_SYMB  symb;
	     PTR_LLND  llnd,expr_list;

	     symb = find_object_symbol($1);
	     llnd = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
	     llnd->type = (PTR_TYPE) NULL;
	     $$ = make_llnd(fi,EXPR_LIST,llnd,LLNULL,SMNULL);
	   }
       |  public_group TYPENAME
           { PTR_SYMB  symb;
	     PTR_LLND  llnd,expr_list;

	     symb = find_object_symbol($2);
	     llnd = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
             /* We use type field as RID_PUBLIC, RID_PRIVATE,RID_PROTECTED*/
	     $$ = make_llnd(fi,EXPR_LIST,llnd,LLNULL,SMNULL);
	   }

       |   TYPENAME_list ',' TYPENAME
           { PTR_SYMB  symb;
	     PTR_LLND  llnd,expr_list,ll_ptr;

	     symb = find_object_symbol($3);
	     llnd = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
	     expr_list = make_llnd(fi,EXPR_LIST,llnd,LLNULL,SMNULL);
	     ll_ptr = follow_llnd($1,2);
             ll_ptr->entry.template.ll_ptr2 = expr_list;
	   }
       |  TYPENAME_list ',' public_group TYPENAME
           { PTR_SYMB  symb;
	     PTR_LLND  llnd,expr_list,ll_ptr;

	     symb = find_object_symbol($4);
	     llnd = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
	     expr_list = make_llnd(fi,EXPR_LIST,llnd,LLNULL,SMNULL);
	     ll_ptr = follow_llnd($1,2);
             ll_ptr->entry.template.ll_ptr2 = expr_list;
	   }
       ;




component_decl_list:   /* empty */
		{ if (TRACEON) printf("207 ") ;  }
        | ';'
                {}
	| nonempty_component_decl_list
                {}
        ;

/* modified */
nonempty_component_decl_list:
	 component_decl
                { if (TRACEON) printf("208 ") ;
                  main_type_flag = TYPE_FOUR ;
		  first_symbol   = SMNULL;
                }
	| nonempty_component_decl_list  component_decl
		{ if (TRACEON) printf("209 ") ;
                  main_type_flag = TYPE_FOUR ;
		  first_symbol   = SMNULL;
                }
	| nonempty_component_decl_list ';'
                { if (TRACEON) printf("210 ") ;
                  main_type_flag = TYPE_FOUR ;
		  first_symbol   = SMNULL;
                }   
	;

/* modified */
component_decl:
	typed_declspecs 
        components  ';'
	  { PTR_BFND bf1;
            PTR_SYMB dummy_symb;

            if (TRACEON) printf("211 ") ;
            chain_type_declarator($1,OFF,$2,&dummy_symb,NO);
	    fill_comment();
           }
           
	|   notype_component_declarator  ';'
              { PTR_BLOB blob ;
                PTR_LLND exprlist_llnd ;
		PTR_SYMB dummy_symb;

                if (TRACEON) printf("212.2 ") ; 
                blob = follow_blob(pred_bfnd);
                exprlist_llnd = blob->ref->entry.template.ll_ptr1;
                exprlist_llnd->entry.template.ll_ptr1 = $1 ;
		chain_type_declarator(global_default,OFF,exprlist_llnd,&dummy_symb,NO);
		fill_comment();	
              }

	| declmods   notype_components  ';'
	   { PTR_BFND bf1 ;
	     PTR_SYMB dummy_symb;

              if (TRACEON) printf("213 ") ;
              $1->entry.descriptive.base_type = global_default;
	      chain_type_declarator($1,OFF,$2,&dummy_symb,NO);
              fill_comment();
           }

        | typed_declspecs '('  parmlist ')' ';'
          {
            component_constructor_action($1,$3,CONSTRUCTOR,NO);
	  }
        | '~'   typed_declspecs  '('   parmlist ')' ';'
             {
	       component_constructor_action($2,$4,DESTRUCTOR,NO);
	     }

        | '~'     typed_declspecs '('  parmlist ')'
            { 
	       set_func_hedr2_with_typename($2,$4,1);
	       late_adjust_functor(pred_bfnd);
	     }

           compstmt
              {
		function_flag = OFF;
		pred_bfnd = pred_bfnd->control_parent;
	       }
        |    typed_declspecs  '('    parmlist ')'

          {
            component_constructor_action($1,$3,CONSTRUCTOR,YES);
	  } 
          base_init
             {
               set_func_hedr3_with_typename();
	       late_adjust_functor(pred_bfnd);
	     }

           compstmt
              {
		function_flag = OFF;
		pred_bfnd = pred_bfnd->control_parent;
              }                     
        |     typed_declspecs  '('    parmlist ')'
             { 
               set_func_hedr2_with_typename($1,$3,0);
	       late_adjust_functor(pred_bfnd);
	     }

           compstmt
              {
		function_flag = OFF;
		pred_bfnd = pred_bfnd->control_parent;
              }                     

        | fndef
          { if (TRACEON) printf("216 ") ;   } 
	| error
		{ if (TRACEON) printf("217 ") ;  }
        | public_group ':'
           { change_public_flag($1);}

	;


public_group:
          PUBLIC
            { $$ = PUBLIC_FIELD;}
        | PROTECTED
            { $$ = PROTECTED_FIELD;}
        | ACCESSWORD
            { $$ = PRIVATE_FIELD; }
        | METHODOFELEMENT
            { $$ = ELEMENT_FIELD; }
        ;


setfunctor:
            {}
           ;




components:
	  /* empty */
              { if (TRACEON) printf("218 ") ;
                $$ = LLNULL ;
              }
	| component_declarator
              { PTR_BLOB blob ;
                PTR_LLND exprlist_llnd ;

                if (TRACEON) printf("219 ") ; 
                blob = follow_blob(pred_bfnd);
                exprlist_llnd = blob->ref->entry.template.ll_ptr1;
                exprlist_llnd->entry.template.ll_ptr1 = $1 ;
                $$ = exprlist_llnd ;
              }
	| components ',' component_declarator
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("220 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$= exprlist_llnd ;
	    }

	;


notype_components:
	  /* empty */
              { if (TRACEON) printf("218 ") ;
                $$ = LLNULL ;
              }
	| notype_component_declarator
              { PTR_BLOB blob ;
                PTR_LLND exprlist_llnd ;

                if (TRACEON) printf("219 ") ; 
                blob = follow_blob(pred_bfnd);
                exprlist_llnd = blob->ref->entry.template.ll_ptr1;
                exprlist_llnd->entry.template.ll_ptr1 = $1 ;
                $$ = exprlist_llnd ;
              }
	| notype_components ',' component_declarator
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("220 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$= exprlist_llnd ;
	    }

	;





component_declarator:
	declarator
		{ if (TRACEON) printf("221 ") ;
                  $$ = $1 ;
                }
	| declarator ':' CONSTANT
		{ PTR_SYMB symb ;

                  if (TRACEON) printf("222 ") ; 
                  symb = find_proc_name();
                  if (symb->variant == FIELD_NAME)
		    symb->entry.field.restricted_bit = $3;
		  
                  $$ = make_llnd(fi,BIT_NUMBER,$1,$3,SMNULL);
                 
                }

	| ':' CONSTANT 
		{ char buffer[40];
		  int status,i;
		  PTR_HASH pseudo_hash_entry;
		  PTR_SYMB symb;
		  PTR_LLND lp1;

		  if (TRACEON) printf("223 ") ;  
		  for (i=0; i<30 ; i++) buffer[i]= '\0';
		  sprintf(buffer,"%s%d","ZZZ_",num_symbs);
		  pseudo_hash_entry = look_up_type(buffer,&status);
		  lp1=lazy_install( pseudo_hash_entry,VARIABLE_NAME,NO);
		  symb = find_proc_name();
                  if (symb->variant == FIELD_NAME)
                         symb->entry.field.restricted_bit = $2;
                  $$ = make_llnd(fi,BIT_NUMBER,lp1,$2,SMNULL);
                }
	;



notype_component_declarator:
	notype_declarator
		{ if (TRACEON) printf("221 ") ;
                  $$ = $1 ;
                }
	| notype_declarator ':' CONSTANT 
		{ PTR_SYMB symb ;

                  if (TRACEON) printf("222 ") ; 
                  symb = find_proc_name();
                  if (symb->variant == FIELD_NAME)
                         symb->entry.field.restricted_bit = $3 ;
                  $$ = make_llnd(fi,BIT_NUMBER,$1,$3,SMNULL);
                 
                }

	| ':' CONSTANT 
		{ char buffer[40];
		  int status,i;
		  PTR_HASH pseudo_hash_entry;
		  PTR_SYMB symb;
		  PTR_LLND lp1;

		 if (TRACEON) printf("223.5 ") ;  

		  for (i=0; i<30 ; i++) buffer[i]= '\0';
		  sprintf(buffer,"%s%d","ZZZ_",num_symbs);
		  pseudo_hash_entry = look_up_type(buffer,&status);
		  lp1=lazy_install( pseudo_hash_entry,VARIABLE_NAME,NO);
		  symb = find_proc_name();
                  if (symb->variant == FIELD_NAME)
                         symb->entry.field.restricted_bit = $2;
                  $$ = make_llnd(fi,BIT_NUMBER,lp1,$2,SMNULL);
                }

	;



/* We chain the enumerators in reverse order.
   They are put in forward order where enumlist is used.
   (The order used to be significant, but no longer is so.
   However, we still maintain the order, just to be clean.)  */

enumlist:
	  enumerator
            {  PTR_BLOB blob ;
               PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("224 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              exprlist_llnd->entry.template.ll_ptr1 = $1 ;
              $$ = exprlist_llnd ;
	    }

	| enumlist ',' enumerator
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("225 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$ = exprlist_llnd ;
	    }
	| enumlist ','
             { if (TRACEON) printf("226 ") ; }
	;


enumerator:
	  identifier
		{ PTR_TYPE ptr1;
                  PTR_LLND llnd ;
		  PTR_SYMB dummy_symb;

		  if (TRACEON) printf("227 ") ; 
                  llnd = $$ = lazy_install($1,VARIABLE_NAME,YES);
                  ptr1 = global_default;
                  /* notype_initdecls returns expr_list ll_node */
                  chain_type_declarator(ptr1,OFF,llnd,&dummy_symb,NO);

		}
	| identifier '=' expr_no_commas
 		{ PTR_LLND llnd ;
		  PTR_TYPE ptr1;
		  PTR_SYMB dummy_symb;

                  if (TRACEON) printf("228 ") ;  
                  llnd = lazy_install($1,VARIABLE_NAME,YES);
                  ptr1 = global_default ;
                  /* notype_initdecls returns expr_list ll_node */
                  chain_type_declarator(ptr1,OFF,llnd,&dummy_symb,NO);
                  $$= make_llnd(fi,ASSGN_OP,llnd,$3,SMNULL);
		}
	;

typename:
	typed_typespecs absdcl
                {
                  if (TRACEON) printf("229 ") ;  
		  $$=chain_up_type($1,$2);
                }
	| nonempty_typemods absdcl
		{ PTR_TYPE new_type;
                  if (TRACEON) printf("230 ") ;
		  new_type=chain_up_type($1,$2);
		  $$=chain_up_type(global_default,new_type);
		}
	;
	
absdcl:   /* an absolute declarator */
	/* empty */
		{ if (TRACEON) printf("231 ") ; 
                  $$ = (PTR_TYPE) NULL ;
		}
	| absdcl1
              { if (TRACEON) printf("232 ") ;
	        $$ = $1 ;
	      }
	;

nonempty_typemods:
	  new_TYPEMOD
		{ PTR_TYPE ptr;
                  if (TRACEON) printf("233 ") ;
                  ptr = get_type(fi,T_DESCRIPT);
                  $$ = install_declmod(ptr, $1);
                }

	| nonempty_typemods new_TYPEMOD
		{ if (TRACEON) printf("234 ") ;  

                  $$ = install_declmod($1,$2);
                }
	;

typemods:
	  /* empty */
		{ if (TRACEON) printf("235 ") ;
		  $$ = (PTR_TYPE) NULL;
		}
	| typemods new_TYPEMOD
		{ PTR_TYPE ptr;
		  if (TRACEON) printf("236 ") ;  
                  if (!$1) ptr = get_type(fi,T_DESCRIPT);
		  else     ptr = $1;
                  $$ = install_declmod(ptr, $2);
                }
	;

absdcl1:  /* a nonempty absolute declarator */
	  '(' absdcl1 ')'
		{ if (TRACEON) printf("237 ") ;  
		   $$ = $2;
		}
	|  '*'  typemods absdcl1  %prec SUPER_OP
		{ PTR_TYPE type;
		  if (TRACEON) printf("238 ") ; 
                  type = get_type(fi,T_POINTER);
		  $$ = chain_up_type(type,$3);
                }
	|  '&'  typemods absdcl1  %prec SUPER_OP
		{ PTR_TYPE type;
		  if (TRACEON) printf("238 ") ; 
                  type = get_type(fi,T_REFERENCE);
		  $$ = chain_up_type(type,$3);
                }
	| '*' typemods  %prec SUPER_OP
		{ if (TRACEON) printf("239 ") ; 
                  $$ = get_type(fi,T_POINTER);
                 }
	| '&' typemods  %prec SUPER_OP
		{ if (TRACEON) printf("239 ") ; 
                  $$ = get_type(fi,T_REFERENCE);
                 }
	| absdcl1 '(' parmlist ')'  %prec '.'
		{ PTR_TYPE oldptr,temptr,type1;
		  if (TRACEON) printf("240 ") ;
		  for (oldptr=temptr=$1;temptr;temptr=temptr->entry.template.base_type)
		    oldptr = temptr;
		  if (oldptr->variant != T_POINTER) err("invalid typename");
		  else {
		    type1 = get_type(fi,T_FUNCTION);
		    oldptr->entry.template.base_type = type1;
		  }
                  $$ = $1;
                }
	| absdcl1 '[' expr ']'  %prec '.'
		{ PTR_LLND p1;
		  if (TRACEON) printf("241 ") ; 
		  p1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
                  $$ = chain_type_with_array_range($1,p1);
                }
	| absdcl1 '[' ']'  %prec '.'
		{ PTR_LLND p1;
		  if (TRACEON) printf("242 ") ;
		  p1 = make_llnd(fi,EXPR_LIST,LLNULL,LLNULL,SMNULL);
                  $$ = chain_type_with_array_range($1,p1);
                }
	| '(' parmlist ')'  %prec '.'
		{ if (TRACEON) printf("243 ") ;
                  $$ = (PTR_TYPE) NULL ;
                }
	| '[' expr ']'  %prec '.'
		{ PTR_TYPE type;
		  PTR_LLND p1;
		  if (TRACEON) printf("244 ") ;
		  type = get_type(fi,T_ARRAY);
		  p1 = make_llnd(fi,EXPR_LIST,$2,LLNULL,SMNULL);
		  type->entry.ar_decl.ranges= p1;
		  $$ =type;
                 }
/* new operand needed
        |  
                {}
*/

	| '[' ']'  %prec '.'
		{ PTR_TYPE type;
		  PTR_LLND p1;
		  if (TRACEON) printf("245 ") ; 
		  type = get_type(fi,T_ARRAY);
		  p1 = make_llnd(fi,EXPR_LIST,LLNULL,LLNULL,SMNULL);
		  type->entry.ar_decl.ranges= p1;
		  $$ =type;
                }
	;

/* at least one statement, the first of which parses without error.  */
/* stmts is used only after decls, so an invalid first statement
   is actually regarded as an invalid decl and part of the decls.  */

stmts:
	stmt
           { if (TRACEON) printf("246 ") ; }
	| stmts stmt
           { if (TRACEON) printf("247 ") ; }
	| stmts errstmt
           { if (TRACEON) printf("248 ") ; }
	;

errstmt:  error ';'
           { if (TRACEON) printf("249 ") ; }
	;

pushlevel:  /* empty */
           { PTR_BLOB blob ;
             PTR_BFND bf1 ;

             if (TRACEON) printf("250 ") ;
             blob = pred_bfnd->entry.template.bl_ptr1 ;
             if ( is_basic_block() )
               { bf1 = get_bfnd(fi,BASIC_BLOCK,SMNULL,LLNULL,LLNULL,LLNULL);
                 chain_up(pred_bfnd,bf1);
                 pred_bfnd = bf1 ;

	       }
	   }
	;

do_decls:   /* empty */
		{ if (TRACEON) printf("251 ") ;  }
	;

compstmt: '{' '}'
		{ if (TRACEON) printf("252 ") ;  }
	| '{' pushlevel decls  stmts '}'
		{ PTR_BFND bf1;
		  if (TRACEON) printf("253 ") ;
                  if (pred_bfnd->variant == BASIC_BLOCK)
		    { 
		      bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
		      chain_up(pred_bfnd,bf1); 
		      pred_bfnd = pred_bfnd->control_parent ;
		    }
		}
	| '{' pushlevel decls  '}'
		{ PTR_BFND bf1;
		  if (TRACEON) printf("254 ") ;
                  if (pred_bfnd->variant == BASIC_BLOCK)
		    { 
		      bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
		      chain_up(pred_bfnd,bf1); 
		      pred_bfnd = pred_bfnd->control_parent ;
		    }
		}
	| '{' pushlevel error '}'
		{ if (TRACEON) printf("255 ") ; 
                  if (pred_bfnd->variant == BASIC_BLOCK)
                        pred_bfnd = pred_bfnd->control_parent ;
                }
	| '{' pushlevel stmts '}'
		{ PTR_BFND bf1;
		  if (TRACEON) printf("256 ") ;
                  if (pred_bfnd->variant == BASIC_BLOCK)
		    { 
		      bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
		      chain_up(pred_bfnd,bf1); 
		      pred_bfnd = pred_bfnd->control_parent ;
		    }
                }
	;

simple_if:
	  IF '(' expr ')'
	   { PTR_BFND bf1 ;
      
                bf1 = get_bfnd(fi,IF_NODE,SMNULL,$3,LLNULL,LLNULL);
                chain_up(pred_bfnd,bf1);
                pred_bfnd = bf1 ;
           }	
	  stmt
           {   PTR_BFND bf1;
               if (TRACEON) printf("257 ") ;
	       bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
	       chain_up(pred_bfnd,bf1);
	       new_cur_bfnd = pred_bfnd ;   /* for else using */
	       pred_bfnd = pred_bfnd->control_parent;
	     }

	;



/* modified */
stmt:
	  compstmt
            { if (TRACEON) printf("258 ") ; }
	| expr ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("259 ") ;  
                  bf1 = get_bfnd(fi,EXPR_STMT_NODE,SMNULL,$1,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| simple_if ELSE 
		{   PTR_BLOB blob ;
                    if (TRACEON) printf("260 ") ;
		    if ( pred_bfnd->index == BRANCH_OFF)
                          blob = follow_blob(pred_bfnd);
                    else
                          blob = follow_blob_2(pred_bfnd);
                    pred_bfnd = blob->ref ;
                    pred_bfnd->index = BRANCH_ON;
		  }
	  stmt
		{ PTR_BFND bf1;

		  if (TRACEON) printf("261 ") ;  
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd->index = BRANCH_OFF ;
                  pred_bfnd = pred_bfnd->control_parent ;
                }
	| simple_if
		{ if (TRACEON) printf("262 ") ;  }
	| WHILE

	  '(' expr ')'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("264 ") ;  
                  bf1 = get_bfnd(fi,WHILE_NODE,SMNULL,$3,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}
	  stmt
	       {  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("265 ") ;  
		}
	| DO
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("266 ") ;  
                  bf1 = get_bfnd(fi,DO_WHILE_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}

	  stmt WHILE '(' expr ')' ';'
	       {  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd->entry.template.ll_ptr1 = $6 ;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("267 ") ;  
		}

	| FOR 
	  '(' xexpr ';'

	  xexpr ';'

	  xexpr ')'
		/* Don't let the tree nodes for $9 be discarded
		   by clear_momentary during the parsing of the next stmt.  */
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("270 ") ;  
                  bf1 = get_bfnd(fi,FOR_NODE,SMNULL,$3,$5,$7);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}

	  stmt
              {   PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("271 ") ;  
		}

	| SWITCH '(' expr ')'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("272 ") ;  
                  bf1 = get_bfnd(fi,SWITCH_NODE,SMNULL,$3,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}

	  stmt
	       {
		  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("273 ") ;  
		}

	| CASE expr ':'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("274 ") ;  
                  bf1 = get_bfnd(fi,CASE_NODE,SMNULL,$2,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	  stmt
                { if (TRACEON) printf("275 ") ; }
	| DEFAULT_TOKEN ':'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("276 ") ;  
                  bf1 = get_bfnd(fi,DEFAULT_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

		
	  stmt
                { if (TRACEON) printf("277 ") ; }
	| BREAK ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("278 ") ;  
                  bf1 = get_bfnd(fi,BREAK_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| CONTINUE ';'	
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("279 ") ;  
                  bf1 = get_bfnd(fi,CONTINUE_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| RETURN ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("280 ") ;  
                  bf1 = get_bfnd(fi,RETURN_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| RETURN expr ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("281 ") ;  
                  bf1 = get_bfnd(fi,RETURN_NODE,SMNULL,$2,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| ASM '(' STRING ')' ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("282 ") ;  
                  bf1 = get_bfnd(fi,ASM_NODE,SMNULL,$3,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| GOTO identifier ';'
		{  PTR_LABEL temp_label ;
		   PTR_SYMB  temp_symb ;
                   PTR_BFND  bf1 ;
		   if (TRACEON) printf("283 ") ; 
                   
                   bf1 = get_bfnd(fi,GOTO_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                   chain_up(pred_bfnd,bf1);
		   temp_symb = find_type_symbol($2,LABEL_NAME,area());
                   if (!temp_symb)
		     { temp_label = get_label(fi,$2);
                       temp_label->labused  = YES ;
		     }
                   else
                     { temp_label = find_label(temp_symb );
                       if (! temp_label) err("unexpected label ");
                       else      temp_label->labused  = YES ;
                     }
                   bf1->entry.template.lbl_ptr = temp_label ;
                }    
	| identifier ':'
		{  PTR_LABEL temp_label ;
		   PTR_SYMB  temp_symb ;
                   PTR_BFND  bf1 ;
		   
		   if (TRACEON) printf("284 ") ;
                   bf1 = get_bfnd(fi,LABEL_STAT,SMNULL,LLNULL,LLNULL,LLNULL);
                   chain_up(pred_bfnd,bf1);
                   temp_symb = find_type_symbol($1, LABEL_NAME,area());
                   if (!temp_symb) 
		     {   temp_label = get_label(fi,$1);
                         temp_label->labdefined = YES ;
		       }
                   else
                     { temp_label = find_label(temp_symb );
                       if (temp_label)
			 {  if ((temp_label->labdefined) == YES)
                              err("label redeclaration ");
                            else   temp_label->labdefined = YES;
			 }
                     }
                   bf1->entry.template.lbl_ptr = temp_label ;
                   temp_label->statbody = bf1 ;
		 } 
	  stmt
             { if (TRACEON) printf("285 ") ; }
        | COBREAK ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("286 ") ;  
                  bf1 = get_bfnd(fi,COBREAK_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

        | COLOOP '(' expr_no_commas ';' lexpr ')' 
		{ PTR_BFND bf1 ;
		  PTR_HASH entry;
		  int status;
		  PTR_SYMB symb;

                  if (TRACEON) printf("287.1 ") ;  
                  bf1 = get_bfnd(fi,COLOOP_NODE,SMNULL,$3,$5,LLNULL);
		  entry = look_up_type("$COLOOP",&status);
                  symb  = install_entry_2(entry,VARIABLE_NAME,OTHER);
		  bf1->entry.template.symbol = symb;
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
        	}

          stmt 
	       {  
		  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("287 ") ;  
		}
        | FUTURE future_declarator '(' passing_identifier_list ')' 
		{ PTR_BFND bf1 ;
		  PTR_HASH entry;
		  int status;
		  PTR_SYMB symb;

                  if (TRACEON) printf("287.3 ") ;  
                  bf1 = get_bfnd(fi,FUTURE_STMT,SMNULL,$2,$4,LLNULL);
		  entry = look_up_type("$FUTURE",&status);
                  symb  = install_entry_2(entry,VARIABLE_NAME,OTHER);
		  bf1->entry.template.symbol = symb;
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
        	}

          stmt 
	       {  
		  PTR_BFND bf1;
		  if (TRACEON) printf("288.3 ") ;  
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;

		}

        | COEXEC '(' xexpr  ')'
		{ PTR_BFND bf1 ;
		  PTR_HASH entry;
		  int status;
		  PTR_SYMB symb;

                  if (TRACEON) printf("287.1 ") ;  
                  bf1 = get_bfnd(fi,COEXEC_NODE,SMNULL,$3,LLNULL,LLNULL);
		  entry = look_up_type("$COEXEC",&status);
                  symb  = install_entry_2(entry,VARIABLE_NAME,OTHER);
		  bf1->entry.template.symbol = symb;
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
        	}
          stmt
	       {
		  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("288 ") ;  
		}

	| ';'
            { if (TRACEON) printf("289 ") ; }
	;



passing_identifier_list:
            { $$ = LLNULL;}     
         | passing_identifiers
            { $$ = $1;}     
         ;
 

passing_identifiers:
         IDENTIFIER
           { PTR_SYMB symbptr;
             PTR_LLND lptr;
	     if (TRACEON) printf("300 ") ; 
	     symbptr = find_type_symbol($1,VARIABLE_NAME,area());
	     if (! symbptr) symbptr=fts_by_inherited_class($1,VARIABLE_NAME,area());
	     if (! symbptr)     err("undefined symbol");
	     else {
		 lptr = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
		 $$ = make_llnd(fi,EXPR_LIST,lptr,LLNULL,SMNULL);
	       }
	   }
	| passing_identifiers ',' IDENTIFIER
           { PTR_SYMB symbptr;
             PTR_LLND lptr;
	     PTR_LLND ll_node1;

	     if (TRACEON) printf("300 ") ; 
	     symbptr = find_type_symbol($3,VARIABLE_NAME,area());
	     if (! symbptr) symbptr=fts_by_inherited_class($3,VARIABLE_NAME,area());
	     if (! symbptr)     err("undefined symbol");
	     else {
		 lptr = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
		 lptr = make_llnd(fi,EXPR_LIST,lptr,LLNULL,SMNULL);
		 ll_node1 = follow_llnd($1,2);
		 ll_node1->entry.template.ll_ptr2 = lptr;

	       }
	   }

	;


/* modified */
lexpr :   assign_stmt
           { if (TRACEON) printf("290 ") ; }
        | lexpr ',' assign_stmt
           { if (TRACEON) printf("291 ") ;
             $$ = make_llnd(fi,EXPR_LIST,$1,$3,SMNULL);
	   }
        ;

/* modified */
assign_stmt: IDENTIFIER  '='  vector_constant

                {  PTR_SYMB symb ;
		   PTR_LLND ll_ptr1 ;
		 
		   if (TRACEON) printf("292 ") ;    
		   symb = find_type_symbol($1,VARIABLE_NAME,area()); 
                  if (! symb) symb=fts_by_inherited_class($1,VARIABLE_NAME,area());
                   if (!symb) {  err("undefined symbol");
                                 $$ = LLNULL;
                              } 

                   else {
                          ll_ptr1 = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
                          $$ = make_llnd(fi,ASSGN_OP, ll_ptr1,$3,SMNULL);
                        }
                 }

        ;

/* modifed  */
array_expression:
          array_expr_a
            { if (TRACEON) printf("293 ") ;  } 
        | array_expr_b
            { if (TRACEON) printf("294 ") ;  } 
        ;


xexpr:
	/* empty */
           { if (TRACEON) printf("295 ") ;
             $$ = (PTR_LLND) LLNULL ;
           }
	| expr
           { if (TRACEON) printf("296 ") ; 
             $$ = $1 ;
           }
	;

/* This is what appears inside the parens in a function declarator.
   Is value is represented in the format that grokdeclarator expects.  */
parmlist:  /* empty */
               { if (TRACEON) printf("297 ") ;
                  $$ = LLNULL;
		}
		
	| parms
  		{ if (TRACEON) printf("298 ") ;  }
		
	| parms ',' ELLIPSIS
                { if (TRACEON) printf("299 ") ; }
        | parms  ELLIPSIS
                {}
        | ELLIPSIS
                { $$ = LLNULL; }
	;

/* A nonempty list of parameter declarations or type names.  */
parms:	
	parm
		{ if (TRACEON) printf("300 ");
		  $$= make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
                }
	| parms ',' parm
		{ if (TRACEON) printf("301 ") ;
                  $$=chain_parameter_list($1,$3);
                }
	;


parm:
	  typed_declspecs_2 notype_declarator_parm parm_init
             { PTR_LLND ll;
	       if (TRACEON) printf("302 ") ;  
	       ll = find_suit_declarator($2);
	       ll->type=chain_type_declarator_2($1,ll->entry.template.symbol);
	       if ($3) $$=  make_llnd(fi,ASSGN_OP,$2,$3,SMNULL);
	       else    $$=  $2;
	     }
	|  typed_declspecs_2 absdcl parm_init
             { PTR_LLND ll;
	       int status;
	       PTR_HASH entry;
	       PTR_SYMB symb;
	       
	       if (TRACEON) printf("303 ") ; 
	       entry = look_up_type("$Dummy",&status);
	       symb  = install_entry_2(entry,VARIABLE_NAME,OTHER);
	       ll = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
	       symb->type = ll->type = chain_up_type($1,$2);
	       if ($3) $$=  make_llnd(fi,ASSGN_OP,ll,$3,SMNULL);
	       else    $$=  ll;
	     }

	| declmods notype_declarator_parm parm_init
                { PTR_LLND ll;
		  
                  if (TRACEON) printf("304 ") ;  
		  ll = find_suit_declarator($2);
		  ll->type =chain_type_declarator_2($1,ll->entry.template.symbol);
		  if ($3) $$=  make_llnd(fi,ASSGN_OP,$2,$3,SMNULL);
		  else    $$=  $2;
                }
	| declmods absdcl parm_init
		{ PTR_TYPE  new_type;
		  PTR_LLND ll; 
		  int status;
		  PTR_HASH entry;
		  PTR_SYMB symb;

		  if (TRACEON) printf("305 ") ; 
		  entry = look_up_type("$Dummy",&status);
		  symb  = install_entry_2(entry,VARIABLE_NAME,OTHER);
		  ll = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
		  new_type=chain_up_type($1,$2);
		  symb->type=ll->type=chain_up_type(global_default,new_type);
		  if ($3) $$=  make_llnd(fi,ASSGN_OP,ll,$3,SMNULL);
		  else    $$=  ll;
		}

	;

parm_init:
          {  $$= LLNULL; }
        |
         '=' init
          { $$ = $2;}
        ;


/* modified */
notype_declarator_parm:
	  notype_declarator_parm '(' parmlist ')'  %prec '.'
		{ PTR_LLND ll; 
 
                if (TRACEON) printf("169 ") ;
		  $$ = handle_complicated_paramters($1,$3);
                }
	| notype_declarator_parm '(' identifiers ')'  %prec '.'
		{ PTR_LLND ll;

                  if (TRACEON) printf("170 ") ;
		  $$ = handle_complicated_paramters($1,$3);
                }
	| notype_declarator_parm '(' error ')'  %prec '.'
		{ if (TRACEON) printf("171 ") ; }
	| '(' notype_declarator_parm ')'
		{ PTR_LLND ll;

                  if (TRACEON) printf("305.4 ") ;
                  cur_flag = CLEAN ;
                  cur_flag = RULE_LR ;
                  $$ = $2 ;
                }
	| '*' typemods notype_declarator_parm  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                 if (TRACEON) printf("173 ") ;
                 ll=$3;
                 $$ = make_llnd(fi,DEREF_OP,ll,LLNULL,SMNULL);
		symbptr1 = find_parameter_name(ll);
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_POINTER);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_POINTER);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                    case T_REFERENCE:
                          type_1= type->entry.template.base_type=get_type(fi,T_POINTER);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }

	| '&' typemods notype_declarator_parm  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                 if (TRACEON) printf("173 ") ;
                 ll=$3;
                 $$ = make_llnd(fi,ADDRESS_OP,ll,LLNULL,SMNULL);
		symbptr1 = find_parameter_name(ll);
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_REFERENCE);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_REFERENCE);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                    case T_REFERENCE:
                          type_1= type->entry.template.base_type=get_type(fi,T_REFERENCE);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }

	| notype_declarator_parm '[' expr_no_commas ']'  %prec '.'
		{ 
                  if (TRACEON) printf("174 ") ;
		  $$=chain_array_op_range($1,$3);
		  cur_flag = cur_flag | RULE_ARRAY ;
                }
	| notype_declarator_parm '[' ']'  %prec '.'
		{ 
                  if (TRACEON) printf("175.5 ") ; 
		  $$=chain_array_op_range($1,NULL);
		  cur_flag = cur_flag | RULE_ARRAY ;
		}

	| notype_declarator_parm '(' expr ')'      %prec '.'
                 {  PTR_LLND ll ;

                    if (TRACEON) printf("176 ") ;
                    ll = $1 ;
                    if ((cur_flag - RULE_ID) &&(cur_flag - RULE_ID - RULE_ARRAY))
                        err("syntax error 3");
                    else {
                        $$ = make_llnd(fi,CLASSINIT_OP,ll,$3,SMNULL);
                        cur_flag = cur_flag | RULE_CLASSINIT ;
                    }
                 }

        | IDENTIFIER
             {
                if (TRACEON) printf("305.9 ");
                $$ = install_parameter($1, VARIABLE_NAME);
             }

	;



future_declarator:
	 future_declarator '[' expr_no_commas ']'  %prec '.'
	   { int status ;
             PTR_LLND ll_ptr,lp1;

             if (TRACEON) printf("301 ") ;
             ll_ptr = check_array_id_format($1,&status);
             switch (status) {
             case NO : err("syntax error ");
                       break ;
             case RANGE_APPEAR :
	               ll_ptr->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
 	               $$ = $1 ; 
                       break;
	     case ARRAY_OP_NEED:
	       lp1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);/*mod*/
	       $$ = make_llnd(fi,ARRAY_OP,$1,lp1,SMNULL);
	       break;
             case ID_ONLY :
	     default:
	       ll_ptr->variant = ARRAY_REF ;
	       ll_ptr->entry.template.ll_ptr1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
	       $$ = $1 ;
	       break;
           
             }
             $$->type = adjust_deref_type($1->type,DEREF_OP);
	   }

	| future_declarator  '.' IDENTIFIER
	{ PTR_LLND l_ptr1,l_ptr2,p1 ;
	  int sw,tag ;
	  PTR_SYMB object;

	  if (TRACEON) printf("302 ") ;  
          sw= check_field_decl($1,$3,0);
          if (sw==NO){ err("error member"); $$ = LLNULL;}
          else {
               tag  = map2( right_symbol->variant)  ;
               l_ptr2 = make_llnd(fi,tag,LLNULL,LLNULL,right_symbol);
	       $$ = make_llnd(fi,RECORD_REF,$1,l_ptr2,SMNULL);
	       $$->type = adjust_array_type(right_symbol);
               $$->type = adjust_element_type($1,$$->type);
	       }
	 }
	| future_declarator  POINTSAT  IDENTIFIER
                {
		  PTR_LLND l_ptr;
		  PTR_SYMB symb_ptr1;
		  int      tag ;
 
                  if (TRACEON) printf("97 ") ; 
                  if ($1->variant == THIS_NODE) {
                      symb_ptr1 = find_field_for_this($3);
                  }
		  else {                     
		    symb_ptr1= find_field_symb_by_type($1->type, $3); 
		  }
		  tag  = map2( symb_ptr1->variant)  ;
		  l_ptr = make_llnd(fi,tag,LLNULL,LLNULL,symb_ptr1);
                  $$ = make_llnd(fi,POINTST_OP,$1,l_ptr,SMNULL);
                  $$->type = adjust_array_type(symb_ptr1);
                  $$->type = adjust_element_type($1,$$->type);

		}

        | IDENTIFIER
           { PTR_SYMB symbptr;
	     if (TRACEON) printf("300 ") ; 
	     symbptr = find_type_symbol($1,VARIABLE_NAME,area());
	     if (! symbptr) symbptr=fts_by_inherited_class($1,VARIABLE_NAME,area());
	     if (! symbptr){  /* default function expected */
	       err("undefined symbol");
	     }
	     else {
	       switch (symbptr->variant) {
	       case FIELD_NAME :
	       case VARIABLE_NAME:
	       default:
		 $$ = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
		 break;
	       }
	       $$->type = adjust_array_type(symbptr);
	     }
	   }
        ;



/*
declarator_parm:
       notype_declarator_parm 
        {}
     | after_type_declarator_parm
        {}
     ;
*/

ref_pointer:
       '*'
        { $$ = POINTST_OP; }
     | '&'
        { $$ = ADDRESS_OP; }
     ;

