
#include <stdio.h>
#include "SiEList.h"
#include "SiFuns.h"
#include "tag"

int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */

int event_id = 0;
FILE *outfile;
#define ENTRY_EVENT 0
#define EXIT_EVENT 1
#define LOOP_ENTRY 2
#define LOOP_EXIT 3
int eventid = 0;
     
main(argc, argv)
int argc;
char **argv;
{

	ELIST e, enames, subname,procs;
	char *proj_name;
	int i, j;
	char *filename;

	if(argc == 1) {
		printf("usage: instr project_name.proj\n");
		exit(0);
		}
	proj_name = argv[1];	
	printf("opening project: %s\n",proj_name);
	if( SiOpenProject(proj_name,proj_name) < 0){
		printf("*** could not open project ***\n");
		exit(0);
		}
	
	if((outfile = fopen("test.f","w")) == NULL){
		printf("could not open file for output\n");
		exit(0);
	      }
	if(SiDoGlobalAnalysis() == 0)
		printf("global analysis done\n");
	else{
	    printf("global analysis failed\n");
	    exit(0);
	    }
	procs = SiGetProcIdList(proj_name);
	printf("\n proc list:\n");
	enames =  SiGetProcList(proj_name);
	SiUnparseEList (enames); 
	printf("start analysis\n");
	for(e = procs; e; e = SiECdr(e)){
		filename = SiECadar(enames);
		printf("\nIn source file %s  and doing analysis for-\n",filename);
		subname = SiECddar(enames);
		printf("subroutine =%s=\n",SiECar(subname));
		SiSelectFile(filename);
		count(e);

		enames = SiECdr(enames);
		}
	/* SiCrossReference(); */
	fclose(outfile);
}

count(e)
ELIST e;
{
      ELIST x;
      if(SiDoFlowAnalysis() == 0)
	       printf("flow analysis also done\n");
	else{
	     printf("flow analysis failed\n");
	     exit(0);
	   }
      SiGenerateDeps ((int) SiECar(e));
      list_use_mod((int) SiECar(e),0);
      x = SiUnparseBlock((int) SiECar(e));
      /* SiUnparseEList (x); */
     fprintf(outfile, (char *) SiECar(x));
    }

int executable_stmt(stmt_id)
int stmt_id;
{
  
  if( SiStmtVariant (stmt_id) <= 168 && SiStmtVariant (stmt_id) >=152)
   return 0;
  else return 1;
}

char *depstrs[] = {"flow", "anti", "outp", "accd", "input"};
char *dirstrs[] = {"  ", "= ", "- ", "0-", "+ ", "0+", ". ", "+-"};
print_deps(stmt,e,depth)
int stmt;
ELIST e;
int depth;
{
  ELIST e1, from, to, vector;
  int i, s, t;
  char *t1, *t2;

  if(SiStmtVariant (stmt) == FOR_NODE)
    printf("dependences carried by this loop:\n");
  else
    printf("dependences sourced at this statement:\n");
  if(e == NULL) printf(" none\n");
  while(e){
    e1 = (ELIST) SiECar(e); e = SiECdr(e);
    s = (int) SiECar(e1); e1 = SiECdr(e1);
    t = (int) SiECar(e1); e1 = SiECdr(e1);
    from = (ELIST) SiECar(e1); e1 = SiECdr(e1);
    to	 = (ELIST) SiECar(e1); e1 = SiECdr(e1);
    t1 = SiECar(SiUnparseExpr((int) SiECadr(from)));
    t2 = SiECar(SiUnparseExpr((int) SiECadr(to)));
    vector = (ELIST) SiECar(e1);
    printf("symb:%d type:%s from:(%d) to:(%d)",
		  s, depstrs[t], (int)SiECar(from), (int)SiECar(to));
    if(depth)
      printf(" vector:(");
       for(i = 0; i < depth; i++){ 
	  if(i < depth-1) printf("%s,",dirstrs[(int)SiECar(vector)]);
	  else printf("%s)",dirstrs[(int)SiECar(vector)]);
	  vector= SiECdr(vector);
	}
      printf(" terms: %s, %s\n", t1, t2);
  }
}
list_expansion_candidates(stmt,e,depth)
int stmt;
ELIST e;
int depth;
{
  ELIST deps, e1, from, to, vector, dfrom, dto;
  int i, s, t, from_stmt, to_stmt, ss, tt;
  char *t1, *t2;
  ELIST SiGetCarriedDeps();
  while(e){
    e1 = (ELIST) SiECar(e); e = SiECdr(e);
    s = (int) SiECar(e1); e1 = SiECdr(e1); /* symbol */
    t = (int) SiECar(e1); e1 = SiECdr(e1); /* type of dependence */
    from = (ELIST) SiECar(e1); e1 = SiECdr(e1); /* (stmt term) */
    to	 = (ELIST) SiECar(e1); e1 = SiECdr(e1); /* (stmt term) */
    from_stmt = (int) SiECar(from);
    t1 = SiECar(SiUnparseExpr((int) SiECadr(from)));
    printf("expansion candidate: %s\n-- other occurrences:",t1);
    vector = (ELIST) SiECar(e1);
    deps = SiGetCarriedDeps(from_stmt);
    while(deps){
      e1 = (ELIST) SiECar(deps); deps = SiECdr(deps);
      ss = (int) SiECar(e1); e1 = SiECdr(e1); /* symbol */
      tt = (int) SiECar(e1); e1 = SiECdr(e1); /* type */
      if(tt == 0){ /* a flow dep. */
	dfrom = (ELIST) SiECar(e1); e1 = SiECdr(e1); /* (stmt term) */
	dto   = (ELIST) SiECar(e1); e1 = SiECdr(e1); /* (stmt term) */
	vector = (ELIST) SiECar(e1);
	for(i = 0; i < depth; i++) vector = SiECdr(vector);
	t2 = SiECar(SiUnparseExpr((int) SiECadr(dto)));
	printf("[%d] %s:%d(%s) ", (int) SiECar(dto),t2, (int)SiECar(vector),
	       dirstrs[(int)SiECar(vector)]);
      }
    }
    printf("\n");
  }
}

print_uses(e)
ELIST e;
{
  ELIST a;
  int stmt, expr;

   while(e){
      a = (ELIST) SiECar(e); e = SiECdr(e);
      stmt = (int) SiECar(a);
      expr = (int) SiECadr(a);
      printf(" s: %d  e: %s\n", stmt, SiECar(SiUnparseExpr(expr)));
      }
}



list_use_mod( stmt_id, depth)
int depth;
int stmt_id;
{
  ELIST q, branch;
  int child_stmt, var, var_ref;
  ELIST SiVarsUsedInStmt(), SiVarsModInStmt(), SiReachingUses(),
	SiReachingDefs(), SiWhereDefined(), SiGetCarriedDeps();
  ELIST SiGetOutputCarriedDeps();
  ELIST e;

       
  q = SiControlChildren(stmt_id);
  if(q != NULL) branch = (ELIST) SiECar(q); else branch = NULL;		     
  while(q != NULL){
    child_stmt = -1;
    branch = (ELIST) SiECar(q);
    /* loop through each child statement on the branch */
    while(branch != NULL ){
      child_stmt = (int) SiECar(branch);
      switch(SiStmtVariant (child_stmt )){
	  case FOR_NODE:     /* basic loop node: "do" in Fortran */
	  case WHILE_NODE:   /* C while 			 */
	  case CDOALL_NODE:  /* Cedar DoALL node		 */
		  printf("loop:[%d]",child_stmt);
		  SiUnparseEList (SiUnparseStmt(child_stmt));
		  e = SiGetOutputCarriedDeps(child_stmt);
		  list_expansion_candidates(child_stmt,e,depth+1);
		  /*
		  e = SiReachingUses(child_stmt);
		  printf("reaching uses are:\n");
		  print_uses(e);
		  */
		  printf("body of loop:[%d]\n",child_stmt);
		  list_use_mod(child_stmt,depth+1);
		  printf("end body of loop:[%d]\n", child_stmt);
		  break;
	  case IF_NODE:      /* a if node with a "then" 	 */
	  case ELSEIF_NODE:  /* a matching "else if ... "then"	 */
	  case	LOGIF_NODE:  /* an if without a then		 */
		  printf("conditional:[%d]",child_stmt);
		  SiUnparseEList (SiUnparseStmt(child_stmt));
		  list_use_mod(child_stmt,depth);
		  printf("end of conditional:[%d]\n",child_stmt);
		  break;
	  case CONTINUE_NODE:
	  case CONTROL_END:
	  case RETURN_STAT:
	  case GOTO_NODE:
		  break;
	  default:
	     if(  executable_stmt(child_stmt)){
		  printf("statment:[%d] %s",child_stmt,
			  SiECar(SiUnparseStmt(child_stmt)));
      	          e = SiGetCarriedDeps(child_stmt);
		  print_deps(child_stmt,e,depth);
		  /*
       		  e = SiVarsModInStmt(child_stmt);
		  while(e){
		    SiUnparseEList (SiUnparseExpr((int) SiECar(e)));
		    var_ref = (int) SiECar(e);
		    var = SiVarId(var_ref);
		    printf("the uses are:\n");
		    SiUnparseEList (SiWhereUsed(var));
		    e = SiECdr(e);
		  }
		  e = SiReachingDefs(child_stmt);
		  printf("reaching defs are:");
		  SiUnparseEList (e);
		  */
		}
		break;
	    } 
     branch = SiECdr(branch);
     } /* go to next stmt on branch  */
  q = SiECdr(q); /*is there another branch? */
  } /* end outer while. switch to new branch */
}
