
#include <stdio.h>
#include "SiEList.h"
#include "SiFuns.h"
#include "tag"

int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */

int event_id = 0;
FILE *outfile;
#define ENTRY_EVENT 0
#define EXIT_EVENT 1
#define LOOP_ENTRY 2
#define LOOP_EXIT 3
int eventid = 0;
     
main(argc, argv)
int argc;
char **argv;
{

	ELIST e, enames, subname,procs;
	char *proj_name;
	int i, j;
	char *filename;

	if(argc == 1) {
		printf("usage: %s project_name.proj\n", argv[0] );
		exit(0);
		}
	proj_name = argv[1];	
	printf("opening project: %s\n",proj_name);
	if( SiOpenProject(proj_name,proj_name) < 0){
		printf("*** could not open project ***\n");
		exit(0);
		}
	
	if((outfile = fopen("test.f","w")) == NULL){
		printf("could not open file for output\n");
		exit(0);
	      }
	if(SiDoGlobalAnalysis() == 0)
		printf("global analysis done\n");
	else{
	    printf("global analysis failed\n");
	    exit(0);
	    }
	procs = SiGetProcIdList(proj_name);
	printf("\n proc list:\n");
	enames =  SiGetProcList(proj_name);
	SiUnparseEList (enames); 
	printf("start analysis\n");
	for(e = procs; e; e = SiECdr(e)){
		filename = SiECadar(enames);
		printf("\nIn source file %s  and doing analysis for-\n",filename);
		subname = SiECddar(enames);
		printf("subroutine =%s=\n",SiECar(subname));
		SiSelectFile(filename);
		count(e);

		enames = SiECdr(enames);
		}
	fclose(outfile);
}

count(e)
ELIST e;
{
      ELIST x;
      add_counters((int) SiECar(e),-1);
      x = SiUnparseBlock((int) SiECar(e));
      /* SiUnparseEList (x); */
     fprintf(outfile, (char *) SiECar(x));
    }

int executable_stmt(stmt_id)
int stmt_id;
{
  
  if( SiStmtVariant (stmt_id) <= 168 && SiStmtVariant (stmt_id) >=152)
   return 0;
  else return 1;
}

int labels[20];
int loops[20];
int events[20];

int count_flops(stmt_id)
int stmt_id;
{
   ELIST e;
   int x,y, tp1, tp2;
   e = SiGetBothSides(stmt_id);
   x = count_exp_flops(SiECar(e), &tp1);
   y = count_exp_flops(SiECadr(e), &tp2);
   SiEFree(e);
   return x+y;
}

int count_exp_flops(exp_id, res_type)
int *res_type;
int exp_id;
{
   ELIST e;
   int lhs, rhs, op, t, total, lt, rt, tp1, tp2;
   *res_type = 0;
   if(exp_id == -1) return 0;
   e = SiGetLRChild(exp_id);
   op = SiExprVariant (exp_id);
   lhs = (int) SiECar(e); 
   rhs = (int) SiECadr(e);
   SiEFree(e);
   total = 0;
   switch(op){
      case VAR_REF:
	if(((t = SiVarType (SiVarId(exp_id))) == TYPE_FLOAT) || t == TYPE_DOUBLE)
	     *res_type = 1; 
	     return(0);
      case ARRAY_REF: 
	     *res_type = 1;
	     return 0;
      case CONST_REF:
	     *res_type = 1;
	return 0;
      case ADD_OP:
      case SUBT_OP:
      case MULT_OP:
      case DIV_OP:
      case MOD_OP:
	total = 1;
	break;
     default:
	*res_type = 0;
	total = 0;
     }
   lt = count_exp_flops(lhs, &tp1);
   rt = count_exp_flops(rhs, &tp2);
   if((total > 0) && (tp1 || tp2) ){ 
	  *res_type = 1; 
	  return total +lt+rt; 
	 }
   else { 
	  *res_type = 0; 
	   return lt+rt; 
	}
}

update_last_stmt(symb,stmt, current_total)
int symb, stmt,current_total;
{
   ELIST e;
   int cnst, expr, newstat;
   if(stmt == -1 || current_total <= 0) return current_total;
   cnst = SiNewConstant(SiEAppend(SiENumber(TYPE_INT), SiENumber(current_total)));
   expr = SiNewExpr(ADD_OP, SiNewSymbolRef(VAR_REF,symb,-1), cnst);
   newstat = SiNewStmtInt(ASSIGN_STAT, -1, SiNewSymbolRef(VAR_REF,symb,-1), expr, -1);
   SiInsertStmt (SiEAppend(SiENumber(stmt), SiEAppend( SiENumber(1), SiENumber(newstat))));
   if(SiStmtVariant (SiControlParent (stmt)) == LOGIF_NODE){
	  SiChangeStmtVariant(SiControlParent (stmt), IF_NODE);
	  stmt = SiNewStmtInt(CONTROL_END, -1, -1, -1, -1);
	  SiInsertStmt (SiEAppend(SiENumber(newstat),SiEAppend( SiENumber(1), SiENumber(stmt))));
	}
   return 0;
}
   
add_parameter(stmt, expr)
int stmt, expr;
{
  ELIST e;
  int parm_list;
  e = SiGetBothSides(stmt);
  parm_list = (int) SiECar(e);
  parm_list = SiAppendExprList(parm_list, expr);
  SiReplaceLeftSide(stmt,parm_list);
}

    
add_counters( stmt_id, new_sym_id)
int stmt_id, new_sym_id;
{
  ELIST q, branch;
  int child_stmt;
  int new_symb;
  int stmt_tp, last_stmt, current_total;

  stmt_tp = SiStmtVariant (stmt_id);
  if(stmt_tp == PROG_HEDR)
	 new_sym_id = SiNewVarInt (TYPE_INT,stmt_id,"flops");
  if(stmt_tp == PROC_HEDR || stmt_tp == FUNC_HEDR)
	 new_sym_id = SiNewScalarParameterInt(TYPE_INT,stmt_id,"flops");
       
  q = SiControlChildren(stmt_id);
  if(q != NULL) branch = (ELIST) SiECar(q); else branch = NULL;		     
  current_total = 0;
  while(q != NULL){
    child_stmt = -1;
    branch = (ELIST) SiECar(q);
    /* loop through each child statement on the branch */
    while(branch != NULL ){
      last_stmt = child_stmt;
      child_stmt = (int) SiECar(branch);
      current_total += count_flops(child_stmt);
      switch(SiStmtVariant (child_stmt )){
	  case FOR_NODE:     /* basic loop node: "do" in Fortran */
	  case WHILE_NODE:   /* C while 			 */
	  case CDOALL_NODE:  /* Cedar DoALL node		 */
	  case IF_NODE:      /* a if node with a "then" 	 */
	  case ELSEIF_NODE:  /* a matching "else if ... "then"	 */
	  case	LOGIF_NODE:  /* an if without a then		 */
		  current_total = update_last_stmt(new_sym_id, last_stmt, current_total);
		  add_counters(child_stmt, new_sym_id);
		  break;
	  case CONTINUE_NODE:
	  case RETURN_STAT:
	  case GOTO_NODE:
		  current_total = update_last_stmt(new_sym_id,last_stmt, current_total);
		  break;
	  case PROC_STAT:    /* a subroutine call */
		  if(SiIsRoutineDefined(SiGetStmtSymbol(child_stmt))) 
		       add_parameter(child_stmt, SiNewSymbolRef(VAR_REF,new_sym_id,-1));
		  break;
	  default: 
		  break;
	    } 
     branch = SiECdr(branch);
     if(branch == NULL )
	  if(last_stmt != -1)
	    current_total = update_last_stmt(new_sym_id, last_stmt, current_total);
	  else
	    current_total = update_last_stmt(new_sym_id, child_stmt, current_total);
     } /* go to next stmt on branch  */
  q = SiECdr(q); /*is there another branch? */
  } /* end outer while. switch to new branch */
}
