

#include <stdio.h>
#include "SiEList.h"
#include "SiFuns.h"
#include "tag"

int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */

int event_id = 0;
FILE *outfile;
#define ENTRY_EVENT 0
#define EXIT_EVENT 1
#define LOOP_ENTRY 2
#define LOOP_EXIT 3
int eventid = 0;
     
main(argc, argv)
int argc;
char **argv;
{

	ELIST e, enames, subname,procs;
	char *proj_name;
	int i, j;
	char *filename;

	if(argc == 1) {
		printf("usage: %s project_name.proj\n", argv[0]);
		exit(0);
		}
	proj_name = argv[1];	
	printf("opening project: %s\n",proj_name);
	if( SiOpenProject(proj_name,proj_name) < 0){
		printf("*** could not open project ***\n");
		exit(0);
		}
	
	if((outfile = fopen("test.f","w")) == NULL){
		printf("could not open file for output\n");
		exit(0);
	      }
	if (SiDoGlobalAnalysis() == 0)
      	   printf("global analysis done\n");
	else
        {
	    printf("global analysis failed\n");
	    exit(0);
	}
        if (SiDoFlowAnalysis() == 0)
           printf("flow analysis done\n");
        else 
        {
           printf("flow analysis fails\n");
	   exit(0);
        }
	procs = SiGetProcIdList(proj_name);
        printf("unparsing output of SiGetProcIdList\n");
        SiUnparseEList(procs);
        printf("finished unparsing output of SiGetProcIdList\n");
	enames =  SiGetProcList(proj_name);
        printf("unparsing output of SiGetProcList\n");
	SiUnparseEList(enames); 
        printf("finished unparsing output of SiGetProcList\n");
      
	printf("start analysis\n");
	for (e = procs; e; e = SiECdr(e))
        {
           filename = SiECadar(enames);
           printf("In source file %s  and doing analysis for-\n",filename);
           printf("Goto statements and their targets in %s\n", 
                  SiECar(SiECddar(enames)));
           SiSelectFile(filename);
           find_gotos(SiECar(e), SiECar(e));
           enames = SiECdr(enames);
	}
	fclose(outfile);
}

find_gotos(routine_id,scope_id)
int routine_id;
int scope_id;
{
   ELIST e, branch, lab_refs;
   int child_stmt,tgt_stmt_id,sid,label_id;
   int stype;

   e = SiControlChildren(scope_id);
   if (e != NULL)
      branch = (ELIST)SiECar(e);
   else
      branch = NULL;
 
   while (e)  /* this loop will happen only twice */
   {
     branch = (ELIST)SiECar(e);
     while (branch)
     {
        child_stmt = (int)SiECar(branch);
        switch (stype = SiStmtVariant((int)child_stmt))
        {
           case GOTO_NODE:
                label_id = SiGetGotoLabel((int)child_stmt);
                if (label_id == -1)
                {
                   printf("find_gotos: The goto at line %d has no target\n",
		          SiLineNumber((int)child_stmt));
                 }
                 else
                 {
                   tgt_stmt_id = SiFindLabelledStmt((int)routine_id, label_id);
                   printf("GOTO from stmtid:%d at line:%d to stmtid:%d at line:%d\n", 
		          child_stmt, SiLineNumber((int)child_stmt),
                          tgt_stmt_id, SiLineNumber(tgt_stmt_id));
                  }
                  break;
             default:
                  label_id = SiStmtLabel((int)child_stmt);
                  if (label_id != -1) /* it is a labelled statement */
                  {
                     printf("LABEL statement id %d at line %d reached from:\n",
                            child_stmt, SiLineNumber(child_stmt));
                     lab_refs = SiFindLabelRefs((int)scope_id, label_id);
                     printf("lab_refs = %d\n", lab_refs);
                     for (; lab_refs; lab_refs = SiECdr(lab_refs))
                     {
                        sid = (int)SiECaar(lab_refs);
                        printf("stmtid:%d at line:%d\n",sid, SiLineNumber((int)sid));
                     }
                   }
                   if (stype == FOR_NODE || stype == WHILE_NODE || 
                       stype == CDOALL_NODE)
                   {
                      find_gotos(routine_id, child_stmt);
                   }
         } /* switch */
         branch = SiECdr(branch);
     }
     e = SiECdr(e);
   }
} /* find_gotos */
                
