/****************************************************************
 *								*
 *   This files contains dependence related routines for the	*
 *   the server 						*
 *   The functions in this file are not currently supported!!!  *
 *								*
 ****************************************************************/

#if FALSE
#include "db.h"
#include "elist.h"

#define HasBit(n, x)	(0x01 & (x >> n))

/*
 * external references
 */
extern PTR_FILE currentFile;

extern PTR_BFND FindCurrBifNode();
extern PTR_LLND FindLLNode();
extern PTR_DEP	FindDepNode();

/*
 * Forward references
 */

ELIST get_dep_info(), get_blck_dep_info();
int   move_dep(), delete_from_dep(), add_to_dep(), bad_cycles(),
      bad_interchange(), ereplace_dep();

/*
 * (static) print_one_dep
 */
static ELIST print_one_dep(b)
PTR_BFND b;
{
   int i;
   register PTR_DEP d;
   ELIST e,e1,e2,e3,e4;

   e = NULL;
   for (d = b->entry.template.dep_ptr1; d; d = d->from_fwd) 
   {
      e1 = ECons(ENumber(d->from.stmt->id), ENumber(d->from.refer->id));
      e2 = ECons(ENumber(d->to.stmt->id),   ENumber(d->to.refer->id));
      e3 = NULL;
      for (i = 1; i < MAX_DEP; i++)
	 e3 = EAppend(e3,ENumber(d->direct[i]));
      e4 = EAppend(e1,EAppend(e2, EAppend(ENumber(d->symbol->id),
				ENumber(d->type))));
      e4 = EAppend(e4,ECons(e3,NULL));
      e = EAppend(e,ECons(e4,NULL));
   }
   return e;
} /* print_one_dep */


static ELIST print_dep_rec(b)
PTR_BFND b;
{
   register PTR_BLOB bl1 = b->entry.template.bl_ptr1,
		     bl2 = b->entry.template.bl_ptr2;
   ELIST e = NULL;
   ELIST t;
   t = print_one_dep(b);
   if (t) 
      e = t;
   /* e = ECons(print_one_dep(b),NULL); */
   if (bl1 || bl2) 
   {
      for (; bl1; bl1 = bl1->next)
      {
	 t = print_dep_rec(bl1->ref);
	 if (t) 
            e = EAppend(e,t);
      }
      for (; bl2; bl2 = bl2->next)
      {
	 t = print_dep_rec(bl2->ref);
	 if (t) 
            e = EAppend(e,t);
      }
   }
   return e;
} /* print_dep_rec */


/****************************************************************
 *								*
 *  nest_lev -- computes the current for-loop nest level of a	*
 *		stmt						*
 *								*
 *  Input:							*
 *	stmt - the bif node pointer of the given statement	*
 *								*
 *  Output:							*
 *	an integer -> the nesting level of the statement	*
 *								*
 ****************************************************************/
static int nest_lev(stmt)
PTR_BFND stmt;
{
   int i = 0;
   PTR_BFND p;

   for (p = stmt; p != NULL && p->variant != GLOBAL; p = p->control_parent)
      switch (p->variant) 
      {
	 case FOR_NODE:
	 case FORALL_NODE:
	 case WHILE_NODE:
	 case CDOALL_NODE:
	 case SDOALL_NODE:
	 case DOACROSS_NODE:
	 case CDOACROSS_NODE:
	      i++;
      }
   return i;
} /* nest_lev */


/****************************************************************
 *								*
 * SiBadCycles -- checks the dependence loop that would prohibit*
 *		 vectorization					*
 *								*
 * Input:							*
 *	id - the bif node id 					*
 *								*
 * Output:							*
 *      0 - success, -1 - failure				*
 *								*
 ****************************************************************/
int SiBadCycles(id)
int id;
{
    PTR_BFND stmt;
    PTR_DEP dep;
	
    if (stmt = FindCurrBifNode(id)) 
    {
       for (dep = stmt->entry.template.dep_ptr1; dep; dep = dep->from_fwd)
	  if ((dep->to.stmt == stmt) && (dep->type == DEP_FLOW))
	     if (HasBit(2, dep->direct[nest_lev(stmt)])) 
             {
		 return 0;
	     }
	  return -1;
    }
    return -1;
} /* SiBadCycles */


/****************************************************************
 * (static)							*
 * bad_interch -- checks if a loop can legally be interchanged	*
 *		  with the loop above it.			*
 *								*
 *	The basic rule is as follows:				*
 *	   check each dep. on statements scoped by loop.	*
 *	   let n = nestlevel of the interior loop.  We must	*
 *	   have either a leading non-zero			*
 *		or direct[n] must be 1 4 or 5			*
 *								*
 * Input:							*
 *	n    - the nesting level of the loop statement		*
 *	loop - the pointer to the loop statement		*
 *								*
 * Output:							*
 *	 returns 1 if this loop can not legally be interchanged *
 *	 with the loop above it.				*
 ****************************************************************/
static int bad_interch(n, loop)
   PTR_BFND loop;
   int n;
{
   PTR_BFND stmt;
   PTR_BLOB b;
   PTR_DEP dep;
   int i, ok;
	
   for (b = loop->entry.for_node.control; b; b = b->next) 
   {
      stmt = b->ref;
      if (stmt->variant == FOR_NODE)
	 if (bad_interch(n,stmt) == 1) 
            return(1);
      for (dep = stmt->entry.template.dep_ptr1; dep;dep = dep->from_fwd)
	 if (dep->type == DEP_FLOW || dep->type == DEP_ANTI ||
	    dep->type == DEP_OUTPUT)
         {
	    ok = 0;
            for (i = 1; i < n; i++)
            if (dep->direct[n] != 1) 
               ok = 1;
	    if (ok == 0 && HasBit(1,dep->direct[n+1]))
               return 1;
        }
   }
   return 0;
} /* bad_interch */


/****************************************************************
 *								*
 * SiBadInterchange -- checks if a loop can legally be          *
 *		  interchanged with the loop above it.		*
 *								*
 * Input -							*
 *     id -  Id of the loop					*
 *								*
 * Output -							*
 *      1 if cannot be interchanged				*
 *      0 if can be interchanged				*
 *      -1 error						*
 *								*
 ****************************************************************/
int SiBadInterchange(id)
int id;
{
   int      i;
   PTR_BFND b;

   if (b = FindCurrBifNode(id)) 
   {
      i = bad_interch(nest_lev(b), b);
      return  i ? 1 : 0;
   } 
   else
      return -1;
} /* SiBadInterchange */

	
/****************************************************************
 * (static)							*
 * shift_dep -- shifts the dependence vector one position down	*
 *		the list.  It can be used after a loop has been *
 *		split.	The idea is that the new vector value	*
 *		should be the same as the old one.		*
 *								*
 * Inputs:							*
 *	n - the nest level of the outer loop			*
 *								*
 ****************************************************************/
static void shift_dep(b,n)
PTR_BLOB b;
int n;
{
   PTR_DEP d;
   int k;

    for (; b != NULL; b = b->next)
    {
       if (b->ref->variant == FOR_NODE || b->ref->variant == FORALL_NODE 
	   || b->ref->variant == WHILE_NODE) 
	  shift_dep(b->ref->entry.for_node.control,n); 
       if (b->ref->variant == IF_NODE)
       {
	  shift_dep(b->ref->entry.if_node.control_true,n);
	  shift_dep(b->ref->entry.if_node.control_false,n);
       }
       for (d =b->ref->entry.template.dep_ptr1; d; d = d->from_fwd)
/* now shift all value to the right repeating value at n in position n+1 */
	  for (k = MAX_DEP-1; k > n; k--)
	     d->direct[k] = d->direct[k-1];
    }
} /* shift_dep */


/****************************************************************
 *  (static)							*
 *  rev_direct -- reverses the direction vector terms at	*
 *		   position n with position n-1 for all 	*
 *		   decendents of on the blob list.		*
 *								*
 *  Inputs:							*
 *								*
 *  Output:							*
 *								*
 *  Side Effect:						*
 *	It also updates control parent info for each element on *
 *	the list.						*
 *								*
 ****************************************************************/
static int rev_direct(loop, n, b)
PTR_BFND loop;
int n;
PTR_BLOB b;
{
   PTR_DEP d;
   int k;
	
   if (n < 2)
      return -1;

   for (;b != NULL; b = b->next)
   {
      /* now loop over all deps "from" on this blob lists */
      if (b->ref->variant == FOR_NODE || b->ref->variant == FORALL_NODE ||
	  b->ref->variant == WHILE_NODE) 
	 rev_direct(b->ref,n,b->ref->entry.for_node.control); 

      if (b->ref->variant == IF_NODE)
      {
	 rev_direct(b->ref,n,b->ref->entry.if_node.control_true);
	 rev_direct(b->ref,n,b->ref->entry.if_node.control_false);
      }

      b->ref->control_parent = loop;
      for (d =b->ref->entry.template.dep_ptr1; d; d = d->from_fwd)
      {
	 /* interchange indicies n and n-1 in direct vector */
	 k = d->direct[n];
	 d->direct[n] = d->direct[n-1];
	 d->direct[n-1] = k;
      }
   }
   return 0;
} /* rev_direct */


/****************************************************************
 *								*
 * SiReplaceDep -- replace all deps to oldb with ones to newb	*
 *								*
 *								*
 * Input -							*
 *								* 
 *								*
 * Output -							*
 *								*
 *								*
 ****************************************************************/
int SiReplaceDep(e)
ELIST e;
{
   int i1, i2, i3;
   PTR_BFND b1, b2;
   PTR_LLND ll;
   PTR_DEP d;

   i1 = (int) e->car; e = e->cdr;
   i2 = (int) e->car; e = e->cdr;
   i3 = (int) e->car; e = e->cdr;
   if ((b1 = FindCurrBifNode(i1)) && (b2 = FindCurrBifNode(i2)))
      if (i3)
	 if (ll = FindLLNode(i3)) 
         {
	    for (d = cur_file->head_dep; d; d = d->thread)
	       if (d->to.stmt == b1) 
               {
                  d->to.stmt = b2;
		  d->to.refer = ll;
               }
	       return 0;
	 }
	 else 
         {
	    for (d = cur_file->head_dep; d; d = d->thread)
	       if (d->to.stmt == b1)
		  d->to.stmt = b2;
	    return 0;
	}
    return -1;
} /* SiReplaceDep */


/****************************************************************
 *								*
 *  SiGetDepInfo -- gets list of dependences of a given bif	*
 *		    node					*
 *								*
 ****************************************************************/
ELIST SiGetDepInfo(stmt_id)
int stmt_id;
{
   int i;
   PTR_BFND b;
   PTR_DEP d;

   if (b = FindCurrBifNode(stmt_id)) 
   {
      return print_one_dep(b);
   }
   return NULL;
} /* SiGetDepInfo */


/****************************************************************
 *								*
 *  SiMoveDep -- 						*
 *								*
 ****************************************************************/
int SiMoveDep(e)
ELIST e;
{
   int i1, i2;
   PTR_BFND b1, b2;

   i1 = (int) e->car; e = e->cdr;
   i2 = (int) e->car; e = e->cdr;
   if ((b1 = FindCurrBifNode(i1)) && (b2 = FindCurrBifNode(i2))) 
   {
      b2->entry.template.dep_ptr1 = b1->entry.template.dep_ptr1;
      b2->entry.template.dep_ptr2 = b1->entry.template.dep_ptr2;
      return 0;
   } 
   else
      return 1;
} /* SiMoveDep */


/****************************************************************
 *								*
 *  SiDeleteFromDep -- 						*
 *								*
 ****************************************************************/
int SiDeleteFromDep(e)
ELIST e;
{
   int i1, i2;
   PTR_BFND b1, b2;
   PTR_DEP d1, d2;

   i1 = (int) e->car; e = e->cdr;
   i2 = (int) e->car; e = e->cdr;
   if ((b1 = FindCurrBifNode(i1)) && (b2 = FindCurrBifNode(i2))) 
   {
      for (d1 = d2 = b1->entry.template.dep_ptr1; d1; d1 = d1->from_fwd) 
      {
	 if (d1->from.stmt == b2)  /* find one - remove from list */
	    d2->from_fwd = d1->from_fwd;
	 d2 = d1;
      }
      return 0;
   } else
	return -1;
} /* SiDeleteFromDep */


/****************************************************************
 *								*
 *  SiAddToDep  -- 						*
 *								*
 ****************************************************************/
int SiAddToDep(e)
ELIST e;
{
   int i1, i2, i3;
   PTR_BFND b1, b2;
   PTR_LLND ll;
   PTR_DEP d1, d2;

   i1 = (int) e->car; e = e->cdr;
   i2 = (int) e->car; e = e->cdr;
   i3 = (int) e->car; e = e->cdr;
   if ((b1 = FindCurrBifNode(i1)) && (b2 = FindCurrBifNode(i2)) &&
	(ll = FindLLNode(i3))) 
   {
      return 0;
   } 
   else
      return -1;
} /* SiAddToDep */


/****************************************************************
 *								*
 *  SiGetBlockDepInfo -- gets list of dependences of a given	*
 *			 head of a (basic) block such as loop	*
 *								*
 ****************************************************************/
ELIST SiGetBlockDepInfo(stmt)
int stmt;
{
   PTR_BFND b;

   if (b = FindCurrBifNode(stmt)) 
   {
      return print_dep_rec(b);
   }
   return NULL;
} /* SiGetBlockDepInfo */

#endif
