#include <strings.h>
#include "db.h"
#include "elist.h"


/*
 * functions used from libdb.a 
 */
extern PTR_TYPE make_type();
extern PTR_BLOB make_blob();
extern PTR_SYMB make_symb();
extern PTR_BFND FindBifNode();

/*
 * externs from libdb.a
 */
extern PCF UnparseType[];

/*
 * External references
 */
extern PTR_FILE currentFile;	/* point to the current active file */


/*
 * external functions from elsewhere in the cbaselib
 */
extern PTR_BFND FindCurrBifNode();
extern PTR_LLND FindLLNode();

/****************************************************************
 *								*
 *  SiUniqueId   -- Not done yet...                             *
 *								*
 *  Input:							*
 *       ...                                                    *
 *  Output:							*
 *								*
 ****************************************************************/
int SiUniqueId()
{
  return -1; /* not done yet. */
} /* SiUniqueId */

/* (static)
 * new_variable_int: help function for SiNewVarInt, SiNewVar
 *    SiNewArrayParameterInt, SiNewScalarParameterInt
 */

static int new_variable_int (type,scope,str)
int type, scope;
char *str;
{
    char vname[200];
    PTR_SYMB s, vlist, p;
    PTR_BFND b, b1;
    PTR_BLOB bl;

    strcpy(vname, str);
    if (b = FindCurrBifNode(scope)) 
    {
       if (b->variant == PROG_HEDR)
	  vlist = p = b->entry.program.prog_symb->entry.prog_decl.symb_list;
       else 
          if (b->variant == PROC_HEDR)
	    vlist = p = b->entry.procedure.proc_symb->entry.proc_decl.symb_list;
	  else 
             if (b->variant == FUNC_HEDR)
	        vlist = p = b->entry.function.func_symb->entry.func_decl.symb_list;
	     else 
                if (b->variant == CDOALL_NODE || b->variant == FOR_NODE)
	           vlist = NULL;
	        else 
                   return -1;
       p = NULL; 
       for (; vlist; vlist = vlist->next_symb)
	  p = vlist;
       if (s = make_symb(currentFile, VARIABLE_NAME, vname)) 
       {
	  s->type = FindTypeNode(type);
	  s->scope = b;
	  if (p) 
             p->next_symb = s;
	  else 
             if (b->variant == PROG_HEDR)
	        b->entry.program.prog_symb->entry.prog_decl.symb_list = s;
	     else 
                if (b->variant == PROC_HEDR)
	           b->entry.procedure.proc_symb->entry.proc_decl.symb_list = s;
	        else 
                   if (b->variant == FUNC_HEDR)
	              b->entry.function.func_symb->entry.func_decl.symb_list = s;
	  s->next_symb = NULL;
     	  b1 = MakeDeclStmt(s);
	  b1->control_parent = b;
	  bl = b->entry.template.bl_ptr1;
	  b->entry.template.bl_ptr1 = make_blob(currentFile, b1, bl);
	  b1->filename = b->filename;
	  b1->thread = b->thread;
	  b->thread = b1;
	 /* 
	    connt_lines
	    ReNumAfterInsertion
	 */
	 return s->id;
      }
      else 
         return -1;
    }
    return -1;
} /* new_variable_int */
	
/****************************************************************
 *  LocalVarList takes the symbol id of a function and returns  *
 *  the list of local variables in that function.  this includes*
 *  the implicitly declared and typed vars in fortran 77        *
 ****************************************************************/

ELIST SiLocalVarList(function)
int function;
{
	PTR_SYMB f, s;
	ELIST e;
	if((f = FindSymbolNode(function)) == NULL) return NULL;
	e = NULL;
	s = f->entry.proc_decl.symb_list;
	while(s){
		e = EAppend(e, ENumber(s->id));
		s = s->next_symb;
		}
	return e;
}
		


/****************************************************************
 *								*
 *  SiNewVar --- 						*
 *     creates a new symbol and declares it in scope		*
 *     which is defined as the scope of the statment	        *
 *     with id "scope".						*
 *     most work is done through new_variable_int function	*
 *								*
 * Input: (type scope_node_id, "name")				*
 *    where type is one of TYPE_INT, TYPE_FLOAT, TYPE_DOUBLE,   *
 *    TYPE_CHAR, TYPE_STRING, TYPE_BOOL, TYPE_COMPLEX.          *
 *    scope_node_id is a control node that can have valid local *
 *    declaration in a block.					*
 *								*
 * Output: id of the newly created variable			*
 *								*
 ****************************************************************/
int SiNewVar (e)
ELIST e;
{
    int type, scope;
    char vname[200];

    type = (int) e->car; e = e->cdr;
    scope = (int) e->car; e = e->cdr;
    return new_variable_int(type,scope,(char *) e->car);
} /* SiNewVar */

/****************************************************************
 *								*
 *  SiNewVarInt --- 						*
 *     creates a new symbol and declares it in scope		*
 *     which is defined as the scope of the statment	        *
 *     with id "scope".						*
 *     All the work is done through the help function           *
 *     new_variable_int						*
 *								*
 * Input: (type scope_node_id, "name")				*
 *    type -  one of TYPE_INT, TYPE_FLOAT, TYPE_DOUBLE,   	*
 *       TYPE_CHAR, TYPE_STRING, TYPE_BOOL, TYPE_COMPLEX.       *
 *    scope_node_id - control node that can have valid local 	*
 *    declaration in a block.					*
 *    name - name of the variable				*
 *								*
 * Output: id of the newly created variable			*
 *								*
 ****************************************************************/
int SiNewVarInt (type,scope,str)
int type, scope;
char *str;
{
   return new_variable_int(type, scope, str);
} /* SiNewVarInt */

/* (static)
 * make_array_type: help function used by SiMakeArrayType
 */
static int make_array_type(basetype, dimension, sizes)
int basetype, dimension, sizes;
{
   PTR_TYPE bt, t;
   PTR_LLND expr_list;
  
   if ((bt = FindTypeNode(basetype)) && (expr_list = FindLLNode(sizes)))
   {
      t = make_type(currentFile, T_ARRAY);
      t->entry.ar_decl.base_type = bt;
      t->entry.ar_decl.num_dimensions = dimension;
      t->entry.ar_decl.ranges = expr_list;
      return t->id;
   }
   return -1;
} /* make_array_type */
    
/****************************************************************
 *								*
 * SiMakeArrayType  - Creates an entry  in the type table for   *
 *   an array of some given basic type. 			*
 *   All the work is done through the help function 		*
 *   make_array_type						*
 *								*
 * Input -							*
 *   basetype - element  type of the array			*
 *   dimension  -       dimension of the array 			*
 *   sizes -  the id of the expression list that describes the  *
 *	size in each dimension 				        *
 *								*
 * Output -							*
 *    id of the newly created node, -1 for error.		*
 *								*
 *								*
 ****************************************************************/
int SiMakeArrayType(basetype, dimension, sizes)
int basetype, dimension, sizes;
{
   return make_array_type(basetype, dimension, sizes);
} /* SiMakeArrayType */

/****************************************************************
 *								*
 * SiBasicMakeSymbol - Creates a symbol of the given type with  *
 *  the given name and type. It has no scope and is not declared*
 *  anywhere.							*
 *  REMARKS :  used by daya  					*
 *								*
 * Input -							*
 *    type - type of the new symbol				*
 *    name - name of the new symbol				*
 *								*
 * Output -							*
 *   id of the newly created id. -1 indicates error 		*
 *								*
 ****************************************************************/
int SiBasicMakeSymbol(type, name)
int type;
char * name;
{
  PTR_SYMB s;
  s = make_symb(currentFile, VARIABLE_NAME, name);
  if (s == NULL) 
     return -1;
  s->type = FindTypeNode(type);
  return s->id;
} /* SiBasicMakeSymbol */


/****************************************************************
 *								*
 * SiNewScalarParameterInt - Creates a new parameter for the    *
 *    function (with id 'function') with given name and       	*
 *    type.  The parameter is added to the end of the    	*
 *    parameterlist for the function and a declaration stmt     *
 *    is added to the function.					*
 *								*
 * Input -							*
 *   type - type of the parameter      				*
 *   function - id of the function node.			*
 *   name - name of the parameter				*
 *								*
 * Output -							*
 *   id of the newly created node, -1 indicates error.		*
 *								*
 ****************************************************************/
int SiNewScalarParameterInt(type, function, name)
int type, function;
char *name;
{
    int symb_id;
    PTR_SYMB s,t;
    PTR_BFND b;
    

    if ((b = FindCurrBifNode(function))== NULL)
    {
      return -1;
    }
    symb_id = new_variable_int(type, function, name);
    if ((s = FindSymbolNode(symb_id))!= NULL)
    {
       t = b->entry.procedure.proc_symb->entry.proc_decl.in_list;
       while (t && t->entry.var_decl.next_in)
       {
	   t = t->entry.var_decl.next_in;
       }
       if (t == NULL)
	  b->entry.procedure.proc_symb->entry.proc_decl.in_list = s;
       else
	  t->entry.var_decl.next_in = s;
       s->entry.var_decl.next_in = NULL;
       return symb_id;
    }
    else
    { 
       printf("couldn't find new symbol node\n"); 
       return -1;
    }
} /* SiNewScalarParameterInt */

/****************************************************************
 *								*
 * SiNewScalarParameterInt -                                    *
 * same as new_scalar_parameter but dimension  is the dimension *
 * of the array and sizes is the id of an EXPR_LIST for the size*
 * type is the base type.					*
 *								*
 * Input -							*
 *   type - return type of the function				*
 *   dimension - dimension of the array				*
 *   sizes - id of an EXPR_LIST for size			*
 *   function - id of the function node.			*
 *   name - name of the parameter				*
 *								*
 * Output -							*
 *   id of the newly created node, -1 indicates error.		*
 *								*
 ****************************************************************/
int SiNewArrayParameterInt(type, dimension, sizes, function, name)
int type, dimension, sizes, function ;
char *name;
{
    int symb_id;
    PTR_SYMB s,t;
    PTR_BFND b;

    if ((b = FindCurrBifNode(function))== NULL)
    {
       return -1;
    }
    type = make_array_type(type, dimension, sizes);
    symb_id = new_variable_int(type, function, name);
    if ((s = FindSymbolNode(symb_id))!= NULL)
    {
       t = b->entry.procedure.proc_symb->entry.proc_decl.in_list;
       while (t && t->entry.var_decl.next_in)
       {
	   t = t->entry.var_decl.next_in;
       }
       if (t == NULL)
	  b->entry.procedure.proc_symb->entry.proc_decl.in_list = s;
       else
	  t->entry.var_decl.next_in = s;
       s->entry.var_decl.next_in = NULL;
       return symb_id;
    }
    else
    { 
       return -1;
    }
} /* SiNewArrayParameterInt */
      

/****************************************************************
 *								*
 *  SiCopyVar --- creates a new symbol and declares it in       *	 
 *      scope  defined as the scope of the statment with id     *
 *      "scope".					        *
 *								*
 * Input -							*
 *    e - ELIST of the form (symb_id type scope). The new       *
 *        variable has the same string identifier as the        *
 *        original identified by symb_id.			*
 *        type can be any of TYPE_INT , TYPE_FLOAT etc.		*
 * Output -							*
 *   the id of the newly created node				*
 *								*
 ****************************************************************/
int SiCopyVar(e)
ELIST e;
{
    int id, type, scope;
    PTR_SYMB s1, s2, vlist, p;
    PTR_BFND b;

    id = (int) e->car; e = e->cdr;
    type = (int) e->car; e = e->cdr;
    scope = (int) e->car;
    if ((s1 = FindSymbolNode(id)) && (b = FindCurrBifNode(scope))) 
    {
       if (b->variant == PROG_HEDR)
	  vlist = p = b->entry.program.prog_symb->entry.prog_decl.symb_list;
       else 
          if (b->variant == PROC_HEDR)
	    vlist = p = b->entry.procedure.proc_symb->entry.proc_decl.symb_list;
	  else 
             if (b->variant == FUNC_HEDR)
	        vlist = p = b->entry.function.func_symb->entry.func_decl.symb_list;
	  else 
             if (b->variant ==	CDOALL_NODE || b->variant == SDOALL_NODE)
	        vlist = p = b->entry.template.symbol;
       for (; vlist; vlist = vlist->next_symb)
	  p = vlist;
       if (s2 = make_symb(currentFile, type, s1->ident)) 
       {
	  return s2->id;
       }
    }
    return -1;
} /* SiCopyVar */

/****************************************************************
 *								*
 *  SiVarType -- returns variable type given the symbol id	*
 *   Note: This is the type id, not the variant of the type.    *
 *								*
 * Input -							*
 *   symbol id of the node					*
 *								*
 * Output -							*
 *   the type id, -1 indicates error			 	*
 *								*
 ****************************************************************/
int SiVarType (id)
int id;
{
    PTR_SYMB sym;

    for (sym = currentFile->head_symb; sym; sym = sym->thread)
       if (sym->id == id) 
       {
	  return sym->type->id;
       }
    return -1;
} /* SiVarType */

/*
 * search_sym_ref: help function for SiVarTypeString
 */

static PTR_SYMB search_sym_ref(ll, name)
PTR_LLND ll;
char *name;
{
   PTR_SYMB sym;

   if (!ll)
      return SMNULL;

   if ((ll->variant == VAR_REF || ll->variant == ARRAY_REF) &&
	(! strcmp(ll->entry.template.symbol->ident, name)))
      return ll->entry.template.symbol;

   if ((sym = search_sym_ref(ll->entry.template.ll_ptr1, name)))
      return sym;
   if ((sym = search_sym_ref(ll->entry.template.ll_ptr2, name)))
      return sym;
   return SMNULL;
} /* search_sym_ref */
 


/****************************************************************
 *								*
 *  SiVarTypeString -- returns variable type given line number	*
 *		       and variable name			*
 *								*
 * Input -							*
 *   no - line number						*
 *   name - variable name 					*
 *								*
 * Output -							*
 *   ELIST with the variable type as a string, NULL if error    *
 *								*
 ****************************************************************/
ELIST SiVarTypeString(no, name)
int  no;
char *name;
{
    PTR_BFND bf;
    PTR_SYMB sy;

    if (bf = FindBifNode(currentFile->filename, no)) 
    {
       if ((sy =search_sym_ref(bf->entry.template.ll_ptr1, name)) ||
	    (sy =search_sym_ref(bf->entry.template.ll_ptr2, name)) ||
	    (sy =search_sym_ref(bf->entry.template.ll_ptr3, name))) 
       {
	    return EString((UnparseType[currentFile->lang])(sy->type));
	}
    }
    return NULL;
} /* SiVarTypeString */

/* returns  the text string name of a variable given its id */
/****************************************************************
 *								*
 *  SiVarIdent -- returns the text string name of a variable    *
 *                   given its id                               *
 *								*
 * Input -							*
 *   id - symbol table id of the name                           *
 *								*
 * Output -							*
 *   the name of the variable as a string.                      *
 *   NULL is returned if the id is not found.			*
 *								*
 ****************************************************************/

char *SiVarIdent (id)
int id;
{
    PTR_SYMB sym;

    for (sym = currentFile->head_symb; sym; sym = sym->thread)
       if (sym->id == id)
       {
          return sym->ident;
       }
    return NULL;
} /* SiVarIdent */

/* for a fortran 90 varabile this returns the id */
/* of the size expression as in:                 */
/*    real(size = 16):: x                        */

/****************************************************************
 *								*
 *  SiVarFortSize -- 						*
 *  For a fortran 90 variable this returns the id of the size   *
 *  expression as in real(size=16)::x				*
 *								*
 *  Input -							*
 *    id - symbol id of the variable                            *
 *								*
 * Output -							*
 *    returns the size id. -1 is returns in case of error.      *
 *								*
 ****************************************************************/
int SiVarFortSize(id)
int id;
{
   PTR_SYMB s;
   if (s = FindSymbolNode(id))
   {
      if (s->type && s->type->entry.template.ranges)
         return s->type->entry.template.ranges->id;
      else return -1;
   }
   else return -1;
} /* SiVarFortSize */


/****************************************************************
 *								*
 *  SiVarCModifiers -- C vars have modifiers as in:             *
 *                         unsigned  short int x                *
 *  this returns the modifiers as bits in the order		*
 *  BIT_name where name can be					*
 *      SYN , SHARED, PRIVATE, FUTURE, VIRTUAL			*
 *	INLINE, UNSIGNED, SIGNED, LONG				*
 *	SHORT, VOLATILE, CONST, TYPEDEF				*
 *      EXTERN, AUTO, STATIC, REGISTER, FRIEND			*
 *								*
 * Output -							*
 *      returns the modifier					*
 *      0 is returned if there is no modifier or		*
 *      -1 if id is not found (?)				*
 *								*
 ****************************************************************/
int SiVarCModifiers(id)
int id;
{
   PTR_SYMB s;
   PTR_TYPE t;
   if (s = FindSymbolNode(id))
   {
      t = s->type;
      while (t->variant == T_ARRAY    || 
             t->variant == T_FUNCTION ||
	     t->variant == T_POINTER  ||
	     t->variant == T_LIST)
	 t = t->entry.template.base_type;
      if (t->variant == T_DESCRIPT)
         return t->entry.descriptive.long_short_flag;
      else return 0; 
   }
   else return 0; /* -1 ? */
} /* SiVarCModifiers */

/* returns the statement id of the node that */
/* defines the scope of this variable        */
/****************************************************************
 *								*
 *  SiVarScope -- returns the statement id of the node that     *
 *    that defines the scope of this variable 			*
 *								*
 * Input -							*
 *    id - symbol table id of the variable			*
 *								*
 * Output -							*
 *    id of the statement. -1 is returned if there is no such   *
 *    variable.							*
 *								*
 ****************************************************************/
int SiVarScope(id)
int id;
{
   PTR_SYMB s;
   if (s = FindSymbolNode(id))
   {
      return s->scope->id;
   }
   else return -1;
} /* SiVarScope */

/* returns the base type  of a variable */
/****************************************************************
 *								*
 *  SiVarBaseType -- returns the base type of the variable	*
 *								*
 * Input -							*
 *    id - symbol table id of the variable			*
 *								*
 * Output -							*
 *    variant  of the base type. 				*
 *    -1 if id is not found.					*
 *								*
 ****************************************************************/
int SiVarBaseType(id)
int id;
{
   PTR_SYMB s;
   PTR_TYPE t;
   if (s = FindSymbolNode(id))
   {
      t = s->type;
      while (t->variant == T_ARRAY    || 
             t->variant == T_FUNCTION ||
	     t->variant == T_POINTER  ||
	     t->variant == T_LIST     ||
	     t->variant == T_DESCRIPT)
	 t = t->entry.template.base_type;
      return t->variant;
   }
   return -1;
} /* SiVarBaseType */

/* array sizes returns an ELIST of expression ids for the sizes
   in each dimension of an array.
*/

/****************************************************************
 *								*
 *  SiVarArraySizes -- returns an ELIST of expression ids for   *
 *    the sizes of each dimension of an array.			*
 *								*
 * Input -							*
 *    symbol table id of the array variable.			*
 *								*
 * Output -							*
 *    ELIST of the sizes in each dimension. NULL is returned    *
 *    if the variable is not found or if it is not an array.	*
 *								*
 ****************************************************************/
ELIST SiVarArraySizes(id)
int id;
{
   PTR_SYMB s;
   PTR_TYPE t;
   PTR_LLND p;
   ELIST e;
   if (s = FindSymbolNode(id))
   {
      t = s->type;
      if (t->variant == T_ARRAY)
      {
       	 e = NULL;
	 p = t->entry.ar_decl.ranges;
	 if(p == NULL) return e;
	 if (p->variant != EXPR_LIST) 
            e = EAppend(e, ENumber(p->id));
	 while (p!= NULL && p->variant == EXPR_LIST)
         {
	    if (p->entry.template.ll_ptr1)
	       e = EAppend(e, ENumber(p->entry.template.ll_ptr1->id));
	    p = p->entry.template.ll_ptr2;
	 }
	 return e;
      }
  }
  return NULL;
} /* SIVarArraySizes */


/*  returns 1 for a 1-d array, 2 for a 2-d array, etc. */

/****************************************************************
 *								*
 *  SiVarArrayDimensions -- returns number of dimensions in the *
 *    array. 1 for 1 - d array, 2 for 2-d array etc.		*
 *								*
 * Input -							*
 *    symbol table id of the array variable.			*
 *								*
 * Output -							*
 *    number of dimensions. If the variable is not an array     *
 *    it returns 0; if the variable is not found returns -1.    * 
 *								*
 ****************************************************************/
int SiVarArrayDimensions(id)
int id;
{
   PTR_SYMB s;
   PTR_TYPE t;
   PTR_LLND p;
   int c;
   if (s = FindSymbolNode(id))
   {
      t = s->type;
      if (t->variant == T_ARRAY)
      {
       	 c = 0;
	 p = t->entry.ar_decl.ranges;
	 if(p == NULL) return 0;
	 if (p->variant != EXPR_LIST) 
            c = 1;
	 while (p!= NULL && p->variant == EXPR_LIST)
         {
	    if (p->entry.template.ll_ptr1) 
               c++;
	    p = p->entry.template.ll_ptr2;
	 }
	 return c;
      }
      return 0;
   }
   return -1;
} /* SiVarArrayDimensions */

/****************************************************************
 *								*
 *  SiTypeVariant -- returns the variant of the type node 	*
 *	identified by id					*
 *								*
 * Input -							*
 *	type table id of the type.				*
 *								*
 * Output -							*
 *     variant of the id. -1 if the id is not found.		*
 *								*
 ****************************************************************/
int SiTypeVariant(id)
int id;
{
    PTR_TYPE t;
    if (t = FindTypeNode(id))
       return t->variant;
    else 
       return -1;
} /* SiTypeVariant */


/* returns the base type node id of the given type node    */
/* applies only to T_SUBRANGE, T_ARRAY, T_FUNCTION,        */
/* T_POINTER, T_DESCRIPT                                   */

/****************************************************************
 *								*
 *  SiTypeBaseType -- returns the id of the base type of a  	*
 *    complex type like subrange, array, function, pointer,     *
 *    descript etc.						*
 *								*
 * Input -							*
 *	type table id of the type.				*
 *      note that this applies only to T_SUBRANGE, T_ARRAY,     *
 *      T_FUNCTION, T_POINTER, T_DESCRIPT			*
 *								*
 * Output -							*
 *      id of the basetype. -1 if the input id is not found or  *
 *	is not one of the above types				*
 *								*
 ****************************************************************/
int SiTypeBaseType(id)
int id;
{
    PTR_TYPE t;
    if( t = FindTypeNode(id) )
    	if( (t->variant == T_SUBRANGE ||
	     t->variant == T_ARRAY    ||
	     t->variant == T_FUNCTION ||
	     t->variant == T_POINTER  ||
	     t->variant == T_DESCRIPT) &&
	    t->entry.template.base_type) 
    	   return t->entry.template.base_type->id;
    return -1;
}

/* given the type id of a structure or a class or collection */
/* returns the number of fields. */

int SiStructTypeNumFields(id)
int id;
{
  printf("SiStructTypeNumFields: NOT YET IMPLEMENTED\n");
}

/* given a structure type and the integer i */
/* this returns the symbol id of the field at*/
/* the i-th position. */

int SiStructTypeFindField(id, i)
int id, i;
{
  printf("SiStructTypeFindField: NOT YET IMPLEMENTED\n");
}

/* given a structure type returns an ELIST of */
/* symbol table ids defined in the stucture   */

ELIST SiStructTypeFields(id)
int id;
{
  printf("SiStructTypeFields: NOT YET IMPLEMENTED\n");
}


