#include "db.h"


/*
 * External references
 */
void rm_dep();			/* in "list.c" */
void append_dep();		/* in "list.c" */


/****************************************************************
 * (static)							*
 * chk_for_par -- check if "par" is an ancestor of "nd"         *
 *								*
 * Inputs:							*
 *	par - the bif node to be used as control parent  	*
 *	nd  - the node to be checked against			*
 *                                                              *
 * Output:							*
 *	1 if "par" is an ancestor of "nd"			*
 *	0 otherwise						*
 *								*
 ****************************************************************/
static int chk_for_par (par, nd)
PTR_BFND par, nd;
{
   for (; nd && nd->control_parent != NULL; nd = nd->control_parent)
      if (nd->control_parent == par)
	 return 1;
   return 0;
} /* chk_for_par */

/*** lift_dep_info needs to be fixed - Neel ***/

/*
 * for each dep coming from a node on the blob list p
 * check to see if both the destination and origin of the
 * dep have same parent
 */
void LiftDepInfo(p)
PTR_BLOB p;
{
   PTR_BFND bif, par;
   PTR_DEP dep, nxtdep;

   for (; p != NULL; p = p->next) 
   {
      bif = p->ref;
      par = bif->control_parent;
      for (dep = bif->entry.template.dep_ptr1; dep; dep = nxtdep) 
      {
	 nxtdep = dep->from_fwd;
	 if (chk_for_par (par, dep->to.stmt) != 1) 
         {
	    rm_dep(bif, dep);
	    append_dep(par, dep);
	 }
      }
    }
} /* LiftDepInfo */

