
#include <stdio.h>
#include "SiEList.h"
#include "SiFuns.h"
#include "tag"

int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */

int event_id = 0;
FILE *outfile;
#define ENTRY_EVENT 0
#define EXIT_EVENT 1
#define LOOP_ENTRY 2
#define LOOP_EXIT 3
int eventid = 0;
     
main(argc, argv)
int argc;
char **argv;
{

	ELIST e, enames, subname,procs;
	char *proj_name;
	int i, j;
	char *filename;

	if(argc == 1) {
		printf("usage: instr project_name.proj\n");
		exit(0);
		}
	proj_name = argv[1];	
	printf("opening project: %s\n",proj_name);
	if( SiOpenProject(proj_name,proj_name) < 0){
		printf("*** could not open project ***\n");
		exit(0);
		}
	
	if((outfile = fopen("test.f","w")) == NULL){
		printf("could not open file for output\n");
		exit(0);
	      }
	if(SiDoGlobalAnalysis() == 0)
		printf("global analysis done\n");
	else{
	    printf("global analysis failed\n");
	    exit(0);
	    }
	procs = SiGetProcIdList(proj_name);
	printf("\n proc list:\n");
	enames =  SiGetProcList(proj_name);
	SiUnparseEList (enames); 
	printf("start analysis\n");
	for(e = procs; e; e = SiECdr(e)){
		filename = SiECadar(enames);
		printf("\nIn source file %s  and doing analysis for-\n",filename);
		subname = SiECddar(enames);
		printf("subroutine =%s=\n",SiECar(subname));
		SiSelectFile(filename);
		count(e);

		enames = SiECdr(enames);
		}
        SiWriteDepFile("saj.dep");
	fclose(outfile);
}

count(e)
ELIST e;
{
      if(SiDoFlowAnalysis() == 0)
	       printf("flow analysis also done\n");
	else{
	     printf("flow analysis failed\n");
	     exit(0);
	   }
      SiGenerateDeps ((int) SiECar(e));
      list_use_mod((int) SiECar(e),0);
    }

int executable_stmt(stmt_id)
int stmt_id;
{
  
  if( SiStmtVariant (stmt_id) <= 168 && SiStmtVariant (stmt_id) >=152)
   return 0;
  else return 1;
}




list_use_mod( stmt_id, depth)
int depth;
int stmt_id;
{
  ELIST q, branch;
  int child_stmt, var, var_ref;
  ELIST SiGetOutputCarriedDeps();
  ELIST e;

       
  q = SiControlChildren(stmt_id);
  if(q != NULL) branch = (ELIST) SiECar(q); else branch = NULL;		     
  while(q != NULL){
    child_stmt = -1;
    branch = (ELIST) SiECar(q);
    /* loop through each child statement on the branch */
    while(branch != NULL ){
      child_stmt = (int) SiECar(branch);
      switch(SiStmtVariant (child_stmt )){
	  case FOR_NODE:     /* basic loop node: "do" in Fortran */
	  case WHILE_NODE:   /* C while 			 */
	  case CDOALL_NODE:  /* Cedar DoALL node		 */
		  printf("loop:[%d]",child_stmt);
		  SiUnparseEList (SiUnparseStmt(child_stmt));
		  e = SiGetOutputCarriedDeps(child_stmt);
		  printf("body of loop:[%d]\n",child_stmt);
		  list_use_mod(child_stmt,depth+1);
		  printf("end body of loop:[%d]\n", child_stmt);
		  break;
	  case IF_NODE:      /* a if node with a "then" 	 */
	  case ELSEIF_NODE:  /* a matching "else if ... "then"	 */
	  case	LOGIF_NODE:  /* an if without a then		 */
		  printf("conditional:[%d]",child_stmt);
		  SiUnparseEList (SiUnparseStmt(child_stmt));
		  list_use_mod(child_stmt,depth);
		  printf("end of conditional:[%d]\n",child_stmt);
		  break;
	  case CONTINUE_NODE:
	  case CONTROL_END:
	  case RETURN_STAT:
	  case GOTO_NODE:
		  break;
	  default:
	     if(  executable_stmt(child_stmt)){
		  printf("statment:[%d] %s",child_stmt,
			  SiECar(SiUnparseStmt(child_stmt)));
      	          e = SiGetCarriedDeps(child_stmt);
		}
		break;
	    } 
     branch = SiECdr(branch);
     } /* go to next stmt on branch  */
  q = SiECdr(q); /*is there another branch? */
  } /* end outer while. switch to new branch */
}
