#include <stdio.h>
#include "SiEList.h"
#include "tag"
#include "db.h"
#include "SiFuns.h"

int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */
void printf_refl();
main(argc, argv)
int argc;
char **argv;
{

        ELIST e, enames, subname,procs;
        char *proj_name;
        int i, j;
        char *filename;

        if(argc == 1) {
                printf("usage: instr project_name.proj\n");
                exit(0);
                printf("usage: instr project_name.proj\n");
                exit(0);
                }
        proj_name = argv[1];
        printf("opening project: %s\n",proj_name);
        if( SiOpenProject(proj_name,proj_name) < 0){
                printf("*** could not open project ***\n");
                exit(0);
                }

        if(SiDoGlobalAnalysis() == 0)
                printf("global analysis done\n");
        else{
            printf("global analysis failed\n");
            exit(0);
            }
        procs = SiGetProcIdList(proj_name);
        printf("\n proc list:\n");
        enames =  SiGetProcList(proj_name);
        SiUnparseEList (enames);
        printf("start analysis\n");
        for(e = procs; e; e = SiECdr(e)){
                filename = SiECadar(enames);
                printf("\nIn source file %s  and doing analysis for-\n",filename
);
                subname = SiECddar(enames);
                printf("subroutine =%s=\n",SiECar(subname));
                SiSelectFile(filename);
                count(e);

                enames = SiECdr(enames);
                }

}

count(e)
ELIST e;
{
      if(SiDoFlowAnalysis() == 0)
               printf("flow analysis also done\n");
        else{
             printf("flow analysis failed\n");
             exit(0);
           }
      list_use_mod((int) SiECar(e),0);
}

int executable_stmt(stmt_id)
int stmt_id;
{

  if( SiStmtVariant (stmt_id) <= 168 && SiStmtVariant (stmt_id) >=152)
   return 0;
  else return 1;
}



void printf_refl(r)
PTR_REFL r;
{
  PTR_REFL rr;

  for (rr=r;rr;rr=rr->next)
   {
    if (rr->id!=NULL)
    printf("symb_id=%d ",rr->id->id);
    if (rr->node!=NULL)
    printf("stmt_id=%d llnd_id=%d   %s \n",rr->node->stmt->id,rr->node->refer->id ,SiECar(SiUnparseExpr(rr->node->refer->id)));
   }
}

PTR_REFL mycopy_refl(p)
PTR_REFL p;
{
  PTR_REFL q;
  extern PTR_REFL free_refl; 
  if (p == NULL)
    return (NULL);
  q = NULL;
 
  if (free_refl == NULL)
      q = (PTR_REFL) malloc(sizeof(struct refl));
  else {
      q = free_refl;
      free_refl = free_refl->next;
    }
  if (q == NULL){
      fprintf(stderr, "!! out of space for reference lists !\n");
      return NULL;
    }
  q->node = p->node;
  q->id = p->id;
  q->next = NULL;
  return q;
}
PTR_REFL mymerge(refl1,refl2)
PTR_REFL refl1,refl2;
{
  PTR_REFL t;
  t=refl1;
  if ( t==NULL )
   {
    return ( refl2);
   }
  while (t->next)
  {
   t=t->next;
  }
  t->next=refl2;
  return (refl1);
}
static PTR_REFL  myvars_mod_in_stmt(id)
int id;
{
   PTR_BFND bf;
   PTR_REFL defs, used, tmp, tmp2, tmp3;
   PTR_REFL gather_refl(), union_refl();
   PTR_LLND lp1, lp2, lp3;

   defs = used = tmp = tmp2 = tmp3 = (PTR_REFL) NULL;
   if (bf = FindCurrBifNode(id))
   {
      lp1 = bf->entry.template.ll_ptr1;
      lp2 = bf->entry.template.ll_ptr2;
      lp3 = bf->entry.template.ll_ptr3;
      switch (bf->variant)
      {
         case PROC_HEDR:
         case PROG_HEDR:
         case FUNC_HEDR:
              return NULL;
         case ASSIGN_STAT: /* must be fortran */
              defs = gather_refl(1, &tmp, bf, lp1);
              if (defs)
              {
                 tmp2 = defs->next;
                 defs->next = (PTR_REFL) NULL;
              }
              used = union_refl(defs,tmp);
              disp_refl(defs); disp_refl(tmp); disp_refl(tmp2);
              defs = gather_refl(1, &tmp, bf, lp2);
              tmp = union_refl(tmp, used);
              disp_refl(defs);
              disp_refl(used);
              used = tmp;
              break;
         case IF_NODE:
         case ELSEIF_NODE:
         case LOGIF_NODE:
              used = gather_refl(1, &tmp, bf, lp1);
              disp_refl(used);
              used = tmp;
              break;
         case PROC_STAT:
              used = gather_refl(1, &defs,bf, (PTR_LLND) 1);
              disp_refl(used);
              used = defs;
              break;
         case DECOMPOSITION_STMT:
         case ALIGN_STMT:
	 case DISTRIBUTE_STMT:
              return (PTR_REFL)NULL;
         default:
              defs = gather_refl(1, &tmp, bf, lp1);
              used = gather_refl(1, &tmp2, bf, lp2);
              disp_refl(defs); disp_refl(used);
              used = union_refl(tmp, tmp2);
              disp_refl(tmp); disp_refl(tmp2);
              break;
       } /* switch */
       tmp = used;
       return(tmp);
   }
   return NULL;
} /* myvars_mod_in_stmt */

static PTR_REFL myvars_used_in_stmt(id)
int id;
{
   PTR_BFND bf;
   PTR_REFL defs, used, tmp, tmp2, tmp3;
   PTR_REFL gather_refl(), union_refl();
   PTR_LLND lp1, lp2, lp3;

   defs = used = tmp = tmp2 = tmp3  = (PTR_REFL) NULL;
   if ((bf = FindCurrBifNode(id)))
   {
      lp1 = bf->entry.template.ll_ptr1;
      lp2 = bf->entry.template.ll_ptr2;
      lp3 = bf->entry.template.ll_ptr3;
      switch (bf->variant)
      {
         case PROC_HEDR:
         case PROG_HEDR:
         case FUNC_HEDR:
              return NULL;
         case ASSIGN_STAT: /* must be fortran */
              defs = gather_refl(1, &tmp, bf, lp1);
              if (defs)
                 used = defs->next;
              defs = gather_refl(1, &tmp, bf, lp2);
              tmp = union_refl(defs, used);
              disp_refl(defs);
              disp_refl(used);
              used = tmp;
              break;
         case PROC_STAT:
              used = gather_refl(1, &defs,bf, (PTR_LLND) 1);
              break;
         case DECOMPOSITION_STMT:
         case ALIGN_STMT:
         case DISTRIBUTE_STMT:
              return (PTR_REFL)NULL;
         default:
              defs = gather_refl(1, &tmp, bf, lp1);
              used = gather_refl(1, &tmp, bf, lp2);
              if (bf->variant == FOR_NODE)
              {
                 tmp2 = gather_refl(1, &tmp, bf, lp3);
                 tmp3 = union_refl(used,tmp2);

                 disp_refl(used, tmp2);
                 used = tmp3;

              }
              tmp = union_refl(defs, used);
              disp_refl(defs);
              disp_refl(used);
              used = tmp;
              break;
      } /* switch */
      tmp = used;
      return (tmp);
   }
   return NULL;
} /* myvars_used_in_stmt */

  struct dru{
             PTR_REFL ud;
             struct dru *next;
             } ;
 typedef struct dru * PTR_DRU;

static PTR_DRU mydissreachinguses(stmt)
int stmt;

{
  PTR_REFL al, dis, use, ddis, aal;
  PTR_REFL uuse,uuad,mod,u=NULL;
  PTR_LLND llp1, llp2=NULL;
  PTR_BFND bf,bf1;
  PTR_SYMB s;
  PTR_SETS sets;
  PTR_DRU uad,t;
  if ((bf=FindCurrBifNode(stmt)))
   {
     sets=bf->entry.template.sets;
     al=remove_locals(bf,sets->in_al);
     dis=remove_locals(bf,sets->in_dis);
     use= myvars_used_in_stmt(stmt);
     mod= myvars_mod_in_stmt(stmt);
     use= mymerge(use,mod);
     use= remove_locals(bf,use); 
     t=uad=(PTR_DRU)NULL;

     for (uuse=use; uuse; uuse=uuse->next)
       { 
       for (aal=al;aal;aal=aal->next)
         {
           if (uuse->id==aal->id)
             {
              bf1=aal->node->stmt;
              llp2=bf1->entry.template.ll_ptr2;
              llp1=llp2->entry.template.ll_ptr1;
              s=llp1->entry.template.symbol;
              for(ddis=dis;ddis;ddis=ddis->next)
                {
                  if(s==ddis->id)
                    {
                      uuad=mycopy_refl(ddis);
                      uuad->next=u;
                      u=uuad;
                    }
                }
              }
         }
         uuad=mycopy_refl(uuse);
         uuad->next=u; 
         u=uuad;
         uad=(PTR_DRU)malloc(sizeof (struct dru));
         uad->ud=u;
         uad->next=t;
         t=uad;
      }
     }
 return(t);
 }

void printf_disru(t)
PTR_DRU t;
{
  PTR_REFL use,dislist;
while (t)
 {
   if (t->ud)
    {
      use=t->ud;
      dislist= t->ud->next;
      use=mycopy_refl(use);
      printf("use is :");
      printf_refl(use);
      printf("\n");
      printf("distributes is :");
      printf_refl(dislist);
      printf("\n");
    }  	
  t=t->next;
 }
}
list_use_mod( stmt_id, depth)
int depth;
int stmt_id;
{
  PTR_BFND bf;
  ELIST q, branch;
  int child_stmt;
  ELIST e;
  PTR_DRU t;
  q = SiControlChildren(stmt_id);
  if(q != NULL) branch = (ELIST) SiECar(q); else branch = NULL;
  while(q != NULL){
    child_stmt = -1;
    branch = (ELIST) SiECar(q);
    /* loop through each child statement on the branch */
    while(branch != NULL ){
      child_stmt = (int) SiECar(branch);
      bf = FindCurrBifNode(child_stmt);
      switch(SiStmtVariant (child_stmt )){
          case FOR_NODE:     /* basic loop node: "do" in Fortran */
          case WHILE_NODE:   /* C while                          */
          case CDOALL_NODE:  /* Cedar DoALL node                 */
                  printf("loop:[%d]",child_stmt);
                  SiUnparseEList (SiUnparseStmt(child_stmt));
		  t=mydissreachinguses(child_stmt);
                  printf_disru(t); 
                  printf("body of loop:[%d]\n",child_stmt);
                  list_use_mod(child_stmt,depth+1);
                  printf("end body of loop:[%d]\n", child_stmt);
                  break;
          case IF_NODE:      /* a if node with a "then"          */
          case ELSEIF_NODE:  /* a matching "else if ... "then"   */
          case  LOGIF_NODE:  /* an if without a then             */
                  printf("conditional:[%d]",child_stmt);
                  SiUnparseEList (SiUnparseStmt(child_stmt));
                  t=mydissreachinguses(child_stmt);
                  printf_disru(t);
                  list_use_mod(child_stmt,depth);
                  printf("end of conditional:[%d]\n",child_stmt);
                  break;
          case CONTINUE_NODE:
          case CONTROL_END:
          case RETURN_STAT:
          case GOTO_NODE:
                  printf("stmt:[%d]",child_stmt);
     		  SiUnparseEList (SiUnparseStmt(child_stmt));
                  t=mydissreachinguses(child_stmt);
                  printf_disru(t);
                  break;
          default:
             if(  executable_stmt(child_stmt)){
                  printf("statment:[%d] %s",child_stmt,
                          SiECar(SiUnparseStmt(child_stmt)));
                  t=mydissreachinguses(child_stmt);
                  printf_disru(t);

                }
                break;
            }
     branch = SiECdr(branch);
     } /* go to next stmt on branch  */
  q = SiECdr(q); /*is there another branch? */
  } /* end outer while. switch to new branch */
}
