#include <stdio.h>
#include "SiEList.h"
#include "SiFuns.h"
#include "tag"
#include <strings.h>
#include "db.h"
#include "elist.h"

int debug = 0;
int show_deps = 1;  

main(argc, argv)
int argc;
char **argv;
{

	ELIST e, enames, subname,procs;
	char *proj_name;
        int i, j;
	char *filename;

	if(argc == 1) {
		printf("usage: instr project_name.proj\n");
		exit(0);
		}
	proj_name = argv[1];	
	printf("opening project: %s\n",proj_name);
	if( SiOpenProject(proj_name,proj_name) < 0){
		printf("*** could not open project ***\n");
		exit(0);
		}
	
       if(SiDoGlobalAnalysis() == 0)
		printf("global analysis done\n");
	else{
	    printf("global analysis failed\n");
	    exit(0);
	    }
	procs = SiGetProcIdList(proj_name);
	printf("\n proc list:\n");
	enames =  SiGetProcList(proj_name);
	SiUnparseEList (enames); 
	printf("start analysis\n");
	for(e = procs; e; e = SiECdr(e)){
		filename = SiECadar(enames);
		printf("\nIn source file %s  and doing analysis for-\n",filename);
		subname = SiECddar(enames);
		printf("subroutine =%s=\n",SiECar(subname));
		SiSelectFile(filename);
		count(e);

		enames = SiECdr(enames);
		}
}
PTR_REFL myremove_locals(b, in)
PTR_BFND b;
PTR_REFL in;
{
  PTR_SYMB i;
  PTR_REFL t, rk, tmp;
  PTR_BFND loop;
  int notfound;

  /* prune out all killed nodes from t */
  rk = NULL;
  t = in;
  while (t != NULL) {
    tmp = t;
    t = t->next;
    i = tmp->id;
    tmp->next = NULL;
    loop = b;
    notfound = 1;
    while (loop != NULL &&
           (loop->variant != FOR_NODE &&
            loop->variant != WHILE_NODE &&
            loop->variant != LOOP_NODE &&
            loop->variant != CDOALL_NODE &&
            loop->variant != COLOOP_NODE &&
            loop->variant != IF_NODE &&
            loop->variant != LOGIF_NODE &&
            loop->variant != COEXEC_NODE)) {
      loop = loop->control_parent;
    }
    if (loop != NULL)
      notfound = search_local(loop, i);
    if (notfound == 0)
      mydisp_refl(tmp);
    else {
      tmp->next = rk;
      rk = tmp;
    }
  }
  return (rk);
}

/****************************************************************************
 * the rountines search_local and remove_local are used to surpress carried *
 * deps for forall loops.  search the reference list looking for references *
 * to locals                                                                *
 ****************************************************************************/
int search_local(b, s)
PTR_BFND b;
PTR_SYMB s;
{
  PTR_SYMB locs;
  PTR_BLOB blob;

  if (b->variant == FORALL_NODE) {
    locs = b->entry.forall_nd.control_var;
    while (locs != NULL && s != locs)
      locs = locs->next_symb;
    if (locs == s)
      return (0);
    else
      return (1);
  }
  else if (language != ForSrc) {
    blob = b->entry.template.bl_ptr1;
    return (search_decl(blob, s));
  }
  else
    return (1);
}

int search_decl(blob, s)
PTR_BLOB blob;
PTR_SYMB s;
{
  PTR_BFND b;
  PTR_LLND ll, v;

  while (blob != NULL && blob->ref->variant != CONTROL_END) {
    b = blob->ref;
    if (b->variant == VAR_DECL) {
      ll = b->entry.template.ll_ptr1;
      /* ll should be an expression list */
      while (ll != NULL) {
        if (ll->entry.template.ll_ptr1 != NULL) {
          v = ll->entry.template.ll_ptr1;

          if ((v->variant == VAR_REF ||
               v->variant == ARRAY_REF) &&
              v->entry.template.symbol == s)
            return (0);
        }
        ll = ll->entry.template.ll_ptr2;
      }
    }
    blob = blob->next;
  }
  return (1);
}

mydisp_refl(p)
PTR_REFL p;
{
  PTR_REFL q;

  while (p != NULL) {
    q = p->next;
    p->node = NULL;
    p->id = NULL;
    p->next = free_refl;
    free_refl = p;
    p = q;
  }
}

PTR_REFL mycopy_refl(p)
PTR_REFL p;
{
  PTR_REFL q;
  PTR_REFL tail, neo_q;

  if (p == NULL)
    return (NULL);
  q = NULL;
  tail = q;

  if (free_refl == NULL)
      q = (PTR_REFL) malloc(sizeof(struct refl));
  else {
      q = free_refl;
      free_refl = free_refl->next;
    }
  if (q == NULL){
      fprintf(stderr, "!! out of space for reference lists !\n");
      return NULL;
    }
  q->node = p->node;
  q->id = p->id;
  q->next = NULL;
  /* now copy the rest of p */
  tail = q;
  p = p->next;
  while (p){
      if(free_refl == NULL)
          neo_q = (PTR_REFL) malloc(sizeof(struct refl));
       else{
          neo_q = free_refl;
          free_refl = free_refl->next;
          }
      if (neo_q == NULL){
          fprintf(stderr, "!! out of space for reference lists !\n");
          return NULL;
          }
      neo_q->node = p->node;
      neo_q->id = p->id;
      neo_q->next = NULL;
      tail->next = neo_q;
      tail = neo_q;
      p = p->next;
      }
  return q;
}
/* create a new reference list that is the interesction of two others */
/* the intersection is based on names and the actual reference comes  */
/* from the second argument of the pair.                              */
/* in the case of a pair  p   p->a  we include p->a in the intersection */
PTR_REFL myintersect_refl(p, q)
PTR_REFL p, q;
{
  PTR_REFL s, t, inter;
  PTR_SYMB id;
  PTR_LLND z;
  int match_found;

  inter = NULL;
  s = q;
  while (p != NULL) {
    id = p->id;
    if (id == NULL) {           /* this is a ref to a p->a sub struct */
      z = p->node->refer;
      while (z != NULL && z->variant != VAR_REF)
        z = z->entry.template.ll_ptr1;
      if (z == NULL)
        id = NULL;
      else
        id = z->entry.template.symbol;
    }
    match_found = 0;
    while (s != NULL && (match_found == 0)) {

      if (s->id == NULL) {      /* a ref to a p->a sub struct */
        z = s->node->refer;
        while (z != NULL && z->variant != VAR_REF)
          z = z->entry.template.ll_ptr1;
        if (z == NULL)
          s = s->next;
        else if (z->entry.template.symbol == id)
          match_found = 1;
        else
          s = s->next;
      }
      else {
        if (s->id == id)
          match_found = 1;
        else
          s = s->next;
      }
    }

    if (match_found && id != NULL) {
      if (free_refl == NULL)
        t = (PTR_REFL) malloc(sizeof(struct refl));
      else {
        t = free_refl;
        free_refl = free_refl->next;
      }
      if (t == NULL)
        fprintf(stderr, "!!! out of space for reference lists\n");
      if (p->node != NULL &&
          (p->node->refer->variant == POINTST_OP ||
           p->node->refer->variant == RECORD_REF)) {
        t->node = p->node;
        t->id = NULL;
      }
      else {
        t->node = s->node;
        t->id = s->id;
      }
      t->next = inter;
      inter = t;
      s = s->next;
    }
    else {
      p = p->next;
      s = q;
    }
  }
  return (inter);
}


/*************************************************************/
/* find_bounds(b,q,qnew) takes a bifnode-llnd pair (b,q) and */
/*  creates a low level expression that describes the range  */
/* of values that are touched by the reference in the current*/
/* context.  the index expressions are all scalars and ranges*/
/* interms of parameters or constants.  if the index exp is  */
/* undecidable, then the whole range of the index is assumed */
/*  the parameter qnew is a low level list upon which this   */
/*  expression is appended.                                  */
/*************************************************************/
PTR_LLND find_bounds(b, q, qnew)
PTR_BFND b;
PTR_LLND q, qnew;
{
  PTR_SYMB ind_list[MAX_NEST_DEPTH];
  PTR_LLND ind_terms[MAX_NEST_DEPTH];
  struct subscript il_lo[MAX_NEST_DEPTH];
  struct subscript il_hi[MAX_NEST_DEPTH];
  struct subscript source[AR_DIM_MAX];  /* a source reference or def. */
  int i, j, count, dumb,sign;
  struct ref sor;
  PTR_LLND qind_list, new_list, q_index, make_llnd(), tmp;
  PTR_LLND exp1, exp2, exp3, append_ll_elist(), build_exp_from_bound();
  PTR_BFND fun;
  PTR_REFL parms;
  PTR_LLND copy_llnd();

  for (i = 0; i < MAX_NEST_DEPTH; i++) {
    ind_list[i] = NULL;
    ind_terms[i] = NULL;
    for (j = 0; j < MAX_NEST_DEPTH; j++) {
      il_lo[i].coefs_symb[j] = NULL;
      il_hi[i].coefs_symb[j] = NULL;
    }
  }

  make_induct_list(b, ind_list, il_lo, il_hi);
  sor.stmt = b;
  sor.refer = q;
  make_subscr(&sor, source);    /* source is an array of */
                                /* subscript records that */
                                /* shared by all routines */
                                /* find the parameter list */
  fun = b;
  while ((fun->variant != PROG_HEDR) &&
         (fun->variant != FUNC_HEDR) &&

         (fun->variant != PROC_HEDR))
    fun = fun->control_parent;
  parms = fun->entry.template.sets->in_def;

  qind_list = q->entry.template.ll_ptr1;
  new_list = NULL;
  i = 0;
  while (qind_list != NULL) {
    q_index = qind_list->entry.template.ll_ptr1;
    if (source[i].decidable == 2) {     /* ddot case */
      PTR_LLND low, hi, ar1, ar2, rl1, rl2, ltmp, htmp;
      /* skip stride for now */
      if (q_index->variant == DDOT && q_index->entry.template.ll_ptr1 != NULL
          && q_index->entry.template.ll_ptr1->variant == DDOT)
        q_index = q_index->entry.template.ll_ptr1;
      if (q_index->variant == STAR_RANGE) {
        rl1 = make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
      }
      else {
        low = copy_llnd(q_index->entry.template.ll_ptr1);
        hi = copy_llnd(q_index->entry.template.ll_ptr2);

        rl1 = make_llnd(cur_file, EXPR_LIST, low, NULL, NULL);
        rl2 = make_llnd(cur_file, EXPR_LIST, hi, NULL, NULL);
        ar1 = make_llnd(cur_file,ARRAY_REF,rl1,NULL, q->entry.template.symbol);
        ar2 = make_llnd(cur_file,ARRAY_REF,rl2,NULL, q->entry.template.symbol);
        ltmp = find_bounds(b, ar1, NULL);
        htmp = find_bounds(b, ar2, NULL);
        ltmp = ltmp->entry.template.ll_ptr1;
        htmp = htmp->entry.template.ll_ptr1;

        if (ltmp!= NULL && (ltmp->variant == EXPR_LIST || ltmp->variant == EXPR_LIST))
          ltmp = ltmp->entry.template.ll_ptr1;
        if (htmp!= NULL && (htmp->variant == EXPR_LIST || htmp->variant == EXPR_LIST))
          htmp = htmp->entry.template.ll_ptr1;
        if(ltmp == NULL) low =  make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
        else if (ltmp->variant == DDOT)
          low = ltmp->entry.template.ll_ptr1;
        else
          low = ltmp;
        if(htmp == NULL) hi =  make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
        else if (htmp->variant == DDOT) {
          hi = htmp->entry.template.ll_ptr2;
          if (hi->variant == DDOT)

            hi = hi->entry.template.ll_ptr1;
        }
        else
          hi = htmp;
        if (low->variant == STAR_RANGE)
          rl1 = low;
        else if (hi->variant == STAR_RANGE)
          rl1 = hi;
        else {
          rl1->variant = DDOT;
          rl1->entry.template.ll_ptr1 = low;
          rl1->entry.template.ll_ptr2 = hi;
        }
      }
      new_list = append_ll_elist(new_list, rl1);
    }
    else if (source[i].decidable == 0) {        /* parm */
      if (q_index == NULL || q_index->variant == STAR_RANGE) {
        exp3 = make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
        new_list = append_ll_elist(new_list, exp3);
      }
      else if (reduce_ll_exp(b, parms, ind_list, q_index, &exp2, &dumb) == 0) {
        /* was not able to resolve */
        if (simple_algebraic(q_index)) {
          sign = 1;
          exp1 = build_exp_from_bound(il_lo, &(source[i]),&sign);
          if (exp1 == NULL) {
            /* this should only happen if the subscript */
            /* is very strange.                     */
          }
          if (reduce_ll_exp(b, parms, ind_list, exp1, &exp2, &dumb) == 0) {
            /* was not able to resolve ! */
            exp3 = make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
          }
          else {
            exp1 = exp2;
            count = 0;
            for (j = 0; j < MAX_NEST_DEPTH; j++)
              if (source[i].coefs[j] != 0)
                count++;
            if (count == 0)
              exp3 = exp1;
            else {
              sign = 1;

              exp2 = build_exp_from_bound(il_hi, &(source[i]),&sign);
               if (reduce_ll_exp(b, parms, ind_list, exp2, &exp3, &dumb) == 0) {
                exp3 = make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
              }
              else {
                exp2 = exp3;
                if(sign > 0)
                   exp3 = make_llnd(cur_file, DDOT, exp1, exp2, NULL);
                else
                   exp3 = make_llnd(cur_file, DDOT, exp2, exp1, NULL);
              }
            }
          }
          new_list = append_ll_elist(new_list, exp3);
        }
        else {
          tmp = make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
          new_list = append_ll_elist(new_list, tmp);
        }
      }
      else
        new_list = append_ll_elist(new_list, exp2);
    }
    else if (source[i].decidable == 1) {        /* standard linear */
      sign = 1;
      exp1 = build_exp_from_bound(il_lo, &(source[i]),&sign);
       if (exp1 == NULL) {
        /* fprintf(stderr, "OOPS null!\n"); */
        /* this should only happen if the subscript */
        /* is very strange.  or the low bound is strange   */
      }
      if (reduce_ll_exp(b, parms, ind_list, exp1, &exp2, &dumb) == 0) {
        /* was not able to resolve ! */
        exp3 = make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
      }
      else {
        exp1 = exp2;
        count = 0;
        for (j = 0; j < MAX_NEST_DEPTH; j++)
          if (source[i].coefs[j] != 0
              || source[i].coefs_symb[j] != NULL)
            count++;
        if (count == 0)
          exp3 = exp1;

        else {
          sign = 1;
          exp2 = build_exp_from_bound(il_hi, &(source[i]),&sign);
           if (reduce_ll_exp(b, parms, ind_list, exp2, &exp3, &dumb) == 0) {
            exp3 = make_llnd(cur_file, STAR_RANGE, NULL, NULL, NULL);
          }
          else {
            exp2 = exp3;
            if(sign> 0)
              exp3 = make_llnd(cur_file, DDOT, exp1, exp2, NULL);
            else
              exp3 = make_llnd(cur_file, DDOT, exp2, exp1, NULL);
          }
        }
      }
      new_list = append_ll_elist(new_list, exp3);
    }
    else {
      fprintf(stderr, "source[i].decidable = %d\n", source[i].decidable);
      fprintf(stderr, "strange brew in find_bounds %s\n",
              (UnparseLlnd[cur_file->lang])(q_index));
      new_list = append_ll_elist(new_list, q_index);
    }
    qind_list = qind_list->entry.template.ll_ptr2;
    i++;
  }
  if (qnew != NULL)
    qnew->entry.template.ll_ptr1 = new_list;
  else
    qnew = new_list;
  return (qnew);
}

/***************************************************************/
/* link_set_list() builds a expr list of low level expressions */
/* that describe the use of variable in the list.  it will list*/
/* each scalar only once and for each array reference it will  */
/* build an expression that describes the use of the variable  */
/* using ddot form. lots of common subexpressions are used.    */
/* find_bounds() is found in anal_ind.c                        */
/***************************************************************/

PTR_LLND mylink_set_list(s)
PTR_REFL s;
{
  PTR_LLND p, q, newq, mymake_llnd(), myfind_bounds();
  PTR_BFND b;
  PTR_REFL myremove_scalar_dups();
  PTR_LLND myremove_array_dups(), mymerge_ll_array_list();

  s = myremove_scalar_dups(s);
  p = NULL;
  while (s != NULL) {
    switch (s->node->refer->variant) {
     case VAR_REF:
     case POINTST_OP:
     case RECORD_REF:
      p = mymake_llnd(cur_file, EXPR_LIST, s->node->refer, p, NULL);
      break;
     case ARRAY_REF:
      q = s->node->refer;
      b = s->node->stmt;
      newq = mymake_llnd(cur_file, ARRAY_REF,NULL,NULL,q->entry.template.symbol);
      newq = myfind_bounds(b, q, newq);
      /* now put q into normal form */
      normal_form(&(newq->entry.template.ll_ptr1));
      q = newq->entry.template.ll_ptr1;
      /* now link into expr list chain p */
      p = mymake_llnd(cur_file, EXPR_LIST, newq, p, NULL);
      break;
     default:
      fprintf(stderr, "something wrong here ");
      break;
    }
    s = s->next;
  }
  return (mymerge_ll_array_list(mymerge_ll_array_list(p))); /* two passes */
}


PTR_LLND myremove_array_dups(elist)
PTR_LLND elist;
{
  PTR_LLND star_range_list;
  PTR_LLND tmp_list;
  PTR_LLND final_list, cons, item, p, q;
  PTR_SYMB var;
  int not_found;

  /* first pull off all star range arrays from elist and put them */
  /* on the star_range_list.  Others go to tmp_list.  Then tmp_list */
  /* compared to star_range list.  If not there it is added to final */
  /* list and star_range_list is appended to tmp_list.            */
  star_range_list = NULL;
  tmp_list = NULL;
  final_list = NULL;
  while (elist != NULL) {
    cons = elist;
    elist = elist->entry.template.ll_ptr2;
    cons->entry.template.ll_ptr2 = NULL;
    item = cons->entry.template.ll_ptr1;
    var = item->entry.template.symbol;
    p = star_range_list;
    q = tmp_list;
    if (item->variant == ARRAY_REF && is_star_range(item)) {
      not_found = 1;
      while (p != NULL) {
        if (var == p->entry.template.ll_ptr1->entry.template.symbol) {
          not_found = 0;
          break;
        }
        p = p->entry.template.ll_ptr2;
      }
      if (not_found) {
        cons->entry.template.ll_ptr2 = star_range_list;
        star_range_list = cons;
      }
    }
    else {
      not_found = 1;
      while (q != NULL) {
        if (identical(q->entry.template.ll_ptr1, item)) {

          not_found = 0;
          break;
        }
        q = q->entry.template.ll_ptr2;
      }
      if (not_found) {
        cons->entry.template.ll_ptr2 = tmp_list;
        tmp_list = cons;
      }
    }
  }
  while (tmp_list != NULL) {
    cons = tmp_list;
    tmp_list = tmp_list->entry.template.ll_ptr2;
    cons->entry.template.ll_ptr2 = NULL;
    item = cons->entry.template.ll_ptr1;
    var = item->entry.template.symbol;
    p = star_range_list;
    if (item->variant == ARRAY_REF) {
      not_found = 1;
      while (p != NULL) {
        if (var == p->entry.template.ll_ptr1->entry.template.symbol) {
          not_found = 0;
          break;
        }
        p = p->entry.template.ll_ptr2;
      }
      if (not_found) {
        cons->entry.template.ll_ptr2 = final_list;
        final_list = cons;
      }
    }
    else {
      cons->entry.template.ll_ptr2 = final_list;
      final_list = cons;
    }
  }
  q = final_list;
  while (q != NULL && q->entry.template.ll_ptr2 != NULL)
    q = q->entry.template.ll_ptr2;
  if (q == NULL)
    final_list = star_range_list;
  else
    q->entry.template.ll_ptr2 = star_range_list;

  return (final_list);
}
/* buid_recur_expr will try to reduce simple recurrences like */
/* i = i+1 in loop into expressions involving an induction var*/
PTR_LLND build_recur_expr(stmt, s,lls, lld)
PTR_BFND stmt;
PTR_SYMB s;
PTR_LLND lld;
{
   PTR_BFND parent;
   PTR_LLND init_val, index_ref, rhs, new_expr, coef, lb, one;
   PTR_LLND copy_llnd();

   parent = stmt->control_parent;
   if(parent->variant == FOR_NODE || parent->variant == CDOALL_NODE){
          if(stmt->variant == ASSIGN_STAT){
            init_val = lld->entry.template.ll_ptr1;
            lb = copy_llnd(parent->entry.template.ll_ptr1->entry.template.ll_ptr1);
            index_ref = mymake_llnd(cur_file,VAR_REF,NULL,NULL,
                                  parent->entry.template.symbol);
            one = mymake_llnd(cur_file,INT_VAL,NULL,NULL,NULL);
            one->entry.ival = 0;
            lb = mymake_llnd(cur_file,SUBT_OP,one,lb,NULL);
            index_ref = mymake_llnd(cur_file,ADD_OP,index_ref,lb,NULL);
            rhs = stmt->entry.template.ll_ptr2;
            /*
            printf("index:%s init_val:%s rhs:%s",
                   (UnparseLlnd[cur_file->lang])(index_ref),
                   (UnparseLlnd[cur_file->lang])(init_val),
                   (UnparseLlnd[cur_file->lang])(rhs));
            */
            if(rhs->variant == ADD_OP){
                 if(rhs->entry.template.ll_ptr1 == lld)
                      coef = rhs->entry.template.ll_ptr2;
                 else if(rhs->entry.template.ll_ptr2 == lld)
                      coef = rhs->entry.template.ll_ptr1;
                 else return NULL;
                 new_expr = mymake_llnd(cur_file,MULT_OP,
                                       copy_llnd(coef),index_ref,NULL);
                 new_expr = mymake_llnd(cur_file,ADD_OP,new_expr,init_val,NULL);
                /*printf("new expr:%s",(UnparseLlnd[cur_file->lang])(new_expr));*/
                 return new_expr;
               }
            else if(rhs->variant == SUBT_OP){

                 if(rhs->entry.template.ll_ptr1 == lld)
                      coef = rhs->entry.template.ll_ptr2;
                 else return NULL;
                 if(coef == NULL) return NULL;
                 new_expr = mymake_llnd(cur_file,MULT_OP,
                                       copy_llnd(coef),index_ref,NULL);
                 new_expr = mymake_llnd(cur_file,SUBT_OP,init_val,new_expr,NULL);
                /*printf("new expr:%s",(UnparseLlnd[cur_file->lang])(new_expr));*/
                 return new_expr;
            }
            else return NULL;
          }
          else return NULL;
        }
   else return NULL;
}
/* propogate will do the scalar propogation.  (test version). */
void propogate(def, use)
PTR_REFL def, use;
{
  PTR_REFL g;                   /* temporary reference list              */
  PTR_SYMB s;                   /* symbol for varialble name             */
  PTR_LLND lls, lld;            /* term source and destination           */
  PTR_BFND bns;                 /* biff nd source and destination        */
  PTR_LLND p;

  /* search through each of the definitions */
  while (def != NULL) {
    s = def->id;                /* s is the symbol table entry */
    g = use;
    if ((s != NULL) && (s->type != NULL) &&
        (s->type->variant == T_INT))
      while (g != NULL) {
        if (g->id == s) {
          lld = g->node->refer;
          if (def->node->stmt == g->node->stmt) {
            /* definition is reaching itself where it is used */
            /* printf("recurrence\n"); */
            lld = g->node->refer;
            lls = def->node->refer;
            if(lld->entry.template.ll_ptr1 != NULL)
              lld->entry.template.ll_ptr1 = build_recur_expr(g->node->stmt,s,lls,lld);
            else lld->entry.template.ll_ptr1 = NULL;
            }

          else{
            /* a definition is reaching a different use */
            bns = def->node->stmt;
            lld = g->node->refer;
            lls = def->node->refer;
            if (bns->variant == FOR_NODE) {
              lld->entry.template.ll_ptr1 = NULL;
            }
            else if (bns->variant != EXPR_STMT_NODE) {
              /* a Fortran  assignment, p <- rhs of source */
              p = bns->entry.template.ll_ptr2;
              if (lld->entry.template.ll_ptr1 == NULL)
                lld->entry.template.ll_ptr1 = p;
              else if (lld->entry.template.ll_ptr1 != p)
                lld->entry.template.ll_ptr1 = NULL;
            }
            else {
              /* a C EXPR_STMT_NODE */
              p = bns->entry.template.ll_ptr1;
              /* assume it is expr list then asign op */
              p = p->entry.template.ll_ptr1;
              while (p != NULL &&
                     p->entry.template.ll_ptr1 != lls)
                p = p->entry.template.ll_ptr2;
              if (p != NULL)
                p = p->entry.template.ll_ptr2;
              if (lld->entry.template.ll_ptr1 == NULL)
                lld->entry.template.ll_ptr1 = p;
              else if (lld->entry.template.ll_ptr1 != p)
                lld->entry.template.ll_ptr1 = NULL;
            }
          }
        }
        else {
          /* symbols do not agree */
        }
        g = g->next;
      }
    def = def->next;
  }
}

/*  make name list makes a reference list based on a list of symbol */
/*  table names.  The node field is null.  This is used for making  */
/*  a dummy list for arguments to procedures.                       */
PTR_REFL make_name_list(p)
PTR_SYMB p;
{
  PTR_REFL list, t;

  list = NULL;
  while (p != NULL) {
    if (free_refl == NULL)
      t = (PTR_REFL) malloc(sizeof(struct refl));
    else {
      t = free_refl;
      free_refl = free_refl->next;
    }
    if (t == NULL)
      fprintf(stderr, "!!! out of space for reference lists\n");
    t->node = NULL;
    t->id = p;
    t->next = list;
    list = t;
    p = p->entry.var_decl.next_in;
  }
  return (list);
}


void myappend_refl(s, p)          /* and remove dups */
PTR_REFL *s, p;
{
  PTR_REFL t;
  struct ref *n;

  while (p != NULL) {
    n = p->node;
    t = *s;
    while ((t != NULL) && (t->node != n))
      t = t->next;
    if (t == NULL) {
      if (free_refl == NULL)
        t = (PTR_REFL) malloc(sizeof(struct refl));
      else {
        t = free_refl;
        free_refl = free_refl->next;
      }
      if (t == NULL)
        fprintf(stderr, "!!! out of space for reference lists\n");
      t->node = p->node;
      t->id = p->id;
      t->next = *s;
      *s = t;
    }
    p = p->next;
  }
}

PTR_REFL myunion_refl(p, q)
PTR_REFL p, q;
{
  PTR_REFL s, t;
  struct ref *n;

  s = copy_refl(q);
  while (p != NULL) {
    n = p->node;
    t = q;
    while ((t != NULL) && (t->node != n))
      t = t->next;
    if (t == NULL) {
      if (free_refl == NULL)
        t = (PTR_REFL) malloc(sizeof(struct refl));

      else {
        t = free_refl;
        free_refl = free_refl->next;
      }
      if (t == NULL){
        fprintf(stderr, "!!! out of space for reference lists\n");
         exit( 0);
      }
      t->node = p->node;
      t->id = p->id;
      t->next = s;
      s = t;
    }
    p = p->next;
  }
  return (s);
}

myassign(to, from)
PTR_REFL *to;
PTR_REFL from;
{
  mydisp_refl(*to);
  *to = from;
}




PTR_SETS mybuild_sets(rnd, b, in_use, in_def, pass)
int rnd;                        /* rnd = 0 first time and rnd = 1 after
                                 * global analysis */
PTR_BFND b;
PTR_REFL in_use, in_def;
int pass;
{
  PTR_BLOB bl;
  PTR_SETS s;
  PTR_REFL out_useT, out_useF, out_defT, out_defF;
  PTR_REFL gen, use, out_use, out_def, detmp;
  PTR_REFL myremove_locals();
  PTR_REFL tmp1, tmp2, tmp3;
  PTR_LLND mylink_set_list();

  if (b == NULL)
    fprintf(stderr, "null bfnd!!\n");

  if (b != NULL)
    switch (b->variant) {

     case GLOBAL:
      node_count = 0;
      bl = b->entry.template.bl_ptr1;
      b->id = node_count++;
      while ((bl != NULL) && (bl->ref != b)) {
        if ((bl->ref->variant == PROG_HEDR) ||
            (bl->ref->variant == FUNC_HEDR) ||
            (bl->ref->variant == PROC_HEDR))
          s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
        bl = bl->next;
      }
      break;

     case PROG_HEDR:
      /* PASS 1 ---------------------- */
      /* visit each child                */
      if (pass == 1) {
        b->id = node_count++;
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        b->entry.template.sets->out_use = NULL;
        b->entry.template.sets->in_use = NULL;
        b->entry.template.sets->out_def = NULL;
        b->entry.template.sets->in_def = NULL;
        b->entry.template.sets->gen = NULL;
        b->entry.template.sets->use = NULL;
        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
          bl = bl->next;
        }
        return (b->entry.template.sets);
      }
      else {
        PTR_REFL t1, t2;
        /* PASS 2 ---------------------- */
        in_use = NULL;
        out_def = NULL;
        out_use = NULL;
        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, out_use, out_def, pass);
          out_use = s->out_use;
          out_def = s->out_def;
          bl = bl->next;
        }
        /* at this point intersect out_use and */
        /* out_def with the global and commons */
        /* and set to out_use and out_def      */
        t1 = myintersect_refl(b->entry.template.sets->in_def, out_def);
        t2 = myremove_locals_from_list(out_def);
        b->entry.template.sets->out_def = myunion_refl(t1, t2);
        mydisp_refl(t1);
        mydisp_refl(t2);
        t1 = myintersect_refl(b->entry.template.sets->in_def, out_use);
        t2 = myremove_locals_from_list(out_use);
        b->entry.template.sets->out_use = myunion_refl(t1, t2);
        mydisp_refl(t1);
        mydisp_refl(t2);
        if (rnd == 0) {
          fprintf(stderr, "%%program %s --\n",
                 b->entry.procedure.proc_symb->ident);
          fprintf(stderr, "%s\n",
                 b->entry.procedure.proc_symb->ident);
          fprintf(stderr, ">>L %d \n", b->g_line);
          fprintf(stderr, "%%defines variables\n");
          b->entry.template.ll_ptr2 =
            mymake_llnd(cur_file, EXPR_LIST, NULL, NULL, NULL);
          b->entry.template.ll_ptr2->entry.template.ll_ptr1 =
            mylink_set_list(b->entry.template.sets->out_def);
          b->entry.template.ll_ptr3 =
            mymake_llnd(cur_file, EXPR_LIST, NULL, NULL, NULL);
          b->entry.template.ll_ptr3->entry.template.ll_ptr1 =
            mylink_set_list(b->entry.template.sets->out_use);
          fprintf(stderr, "%s",
                  (UnparseLlnd[cur_file->lang])(b->entry.template.ll_ptr2));
          fprintf(stderr, "%% and uses\n");
          fprintf(stderr, "%s\n",
                  (UnparseLlnd[cur_file->lang])(b->entry.template.ll_ptr3));
          fprintf(stderr, "\n");
        }
        return (b->entry.template.sets);
      }

     case PROC_HEDR:
     case FUNC_HEDR:
      /* PASS 1 ---------------------- */
      if (pass == 1) {
        b->id = node_count++;
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        b->entry.template.sets->out_use = NULL;
        b->entry.template.sets->in_use = NULL;
        b->entry.template.sets->out_def = NULL;
        b->entry.template.sets->in_def = NULL;
        b->entry.template.sets->gen = NULL;
        b->entry.template.sets->use = NULL;
        /* set in_def  to be a ref list of all */
        /* parameters to this proc.  this is     */
        /* appended with commons and then it is */
        /* interesected with the real ref and  */
        /* use list in pass 2.           */
        b->entry.template.sets->in_def =
          mymake_name_list(b->entry.template.symbol->entry.proc_decl.in_list);
        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
          bl = bl->next;
        }
        return (b->entry.template.sets);
      }
      else {
        PTR_REFL t1, t2;

        /* PASS 2 ---------------------- */
        /* visit each child              */
        /* in_def = in_params; in_use = {}; out_def = in_def; out_use = {};
         * for each child do pass out_use and out_def; visit child; out_use =
         * child.out_use; out_def = child.out_def; end; */
        in_use = NULL;
        out_def = NULL;
        out_use = NULL;
        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, out_use, out_def, pass);
          out_use = s->out_use;
          out_def = s->out_def;
          bl = bl->next;
        }
        /* interest out_use and out_def with the */
        /* parameters and common statements         */
        t1 = myintersect_refl(b->entry.template.sets->in_def, out_def);
        t2 = myremove_locals_from_list(out_def);
        b->entry.template.sets->out_def = myunion_refl(t1, t2);
        mydisp_refl(t1);
        mydisp_refl(t2);
        t1 = myintersect_refl(b->entry.template.sets->in_def, out_use);
        t2 = myremove_locals_from_list(out_use);
        b->entry.template.sets->out_use = myunion_refl(t1, t2);
        mydisp_refl(t1);
        mydisp_refl(t2);
        t1 = b->entry.template.sets->out_def;
        t2 = b->entry.template.sets->out_use;
        if (rnd == 0) {
          b->entry.template.ll_ptr2 =
            mymake_llnd(cur_file, EXPR_LIST, NULL, NULL, NULL);
          b->entry.template.ll_ptr2->entry.template.ll_ptr1 =
            mylink_set_list(t1);
          b->entry.template.ll_ptr3 =
            mymake_llnd(cur_file, EXPR_LIST, NULL, NULL, NULL);
          b->entry.template.ll_ptr3->entry.template.ll_ptr1 =
            mylink_set_list(t2);
          fprintf(stderr, "%%procedure %s-\n",
                 b->entry.procedure.proc_symb->ident);
          fprintf(stderr, "%s", (UnparseBfnd[cur_file->lang])(b));
          fprintf(stderr, ">>L %d \n", b->g_line);
          fprintf(stderr, "%%which defines values for-\n");
          fprintf(stderr, "%s",
                  (UnparseLlnd[cur_file->lang])(b->entry.template.ll_ptr2));
          fprintf(stderr, "\n%%and uses values-\n");
          fprintf(stderr, "%s\n",
                  (UnparseLlnd[cur_file->lang])(b->entry.template.ll_ptr3));
        }
        return (b->entry.template.sets);
      }
     case COMM_STAT:
      if (pass == 1) {
        b->id = node_count++;
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        b->entry.template.sets->gen = NULL;
        b->entry.template.sets->use = NULL;
        /* now gather up all the varaibles and */
        /* link them in to the parent node.       */
        /* not done yet.                          */
        detmp = NULL;
        tmp1 = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr1);
        tmp2 = b->control_parent->entry.template.sets->in_def;
        while ((tmp2 != NULL) && (tmp2->next != NULL))
          tmp2 = tmp2->next;
        if (tmp2 == NULL)
          b->control_parent->entry.template.sets->in_def = tmp1;
        else
          tmp2->next = tmp1;
        return (b->entry.template.sets);
      }
      else {
        /* PASS 2 ----------------------- */
        /* just pass everything through! */
        b->entry.template.sets->out_def = in_def;
        b->entry.template.sets->out_use = in_use;
        return (b->entry.template.sets);
      }
     case EXPR_STMT_NODE:
      /* PASS 1 ----------------------- */
      /* make synth. attribs gen, use */
      if (pass == 1) {
        b->id = node_count++;
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        if (b->entry.template.sets->gen == NULL) {
          detmp = NULL;
          tmp1 = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr1);
          /* we only want the first.  the others are uses */
          b->entry.template.sets->gen = detmp;
          b->entry.template.sets->use = tmp1;
        }
        return (b->entry.template.sets);
      }
      else {
        /* PASS 2 ----------------------- */
        b->entry.template.sets->in_use = mycopy_refl(in_use);
        b->entry.template.sets->in_def = mycopy_refl(in_def);

        /* set local kill = { X in in_def | ref(X) in gen } */
        out_def = rem_kill(in_def, b->entry.template.sets->gen);

        myassign(&out_def,myunion_refl(out_def, b->entry.template.sets->gen));
        b->entry.template.sets->out_def = out_def;

        /* out_use = in_use + use */
        b->entry.template.sets->out_use =
          myunion_refl(in_use, b->entry.template.sets->use);
        propogate(in_def, b->entry.template.sets->use);
        return (b->entry.template.sets);
      }
     case ASSIGN_STAT:
     case M_ASSIGN_STAT:
     case SUM_ACC:
     case MULT_ACC:
     case MAX_ACC:
     case MIN_ACC:
     case CAT_ACC:
     case OR_ACC:
     case AND_ACC:
     case READ_STAT:
     case WRITE_STAT:
     case PROC_STAT:

      /* PASS 1 ----------------------- */
      /* make synth. attribs gen, use */
      if (pass == 1) {
        b->id = node_count++;
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        if (b->entry.template.sets->gen == NULL) {
          detmp = NULL;
          tmp1 = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr1);
          if (b->variant == PROC_STAT) {
            b->entry.template.sets->gen = detmp;
            b->entry.template.sets->use = tmp1;
            return (b->entry.template.sets);
          }
          /* we only want the first.  the others are uses */
          if (tmp1 == NULL) {
            tmp2 = NULL;
            b->entry.template.sets->gen = NULL;
          }
          else {
            tmp2 = tmp1->next;
            tmp1->next = NULL;
            b->entry.template.sets->gen = tmp1;
          }
        }
        else
          tmp2 = NULL;
        if (b->entry.template.sets->use == NULL) {
          detmp = NULL;
          tmp1 = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr2);
          if (tmp2 != NULL) {
            tmp3 = myunion_refl(tmp1, tmp2);
            mydisp_refl(tmp1);
            mydisp_refl(tmp2);
          }
          else
            tmp3 = tmp1;
          b->entry.template.sets->use = tmp3;
        }
        return (b->entry.template.sets);
      }
      else {
        /* PASS 2 ----------------------- */
        b->entry.template.sets->in_use = mycopy_refl(in_use);
        b->entry.template.sets->in_def = mycopy_refl(in_def);


        /* set local kill = { X in in_def | ref(X) in gen } */
        out_def = rem_kill(in_def, b->entry.template.sets->gen);

        /* create synth. attrib. out_def = in_def - kill + gen */
        myassign(&out_def,
               myunion_refl(out_def, b->entry.template.sets->gen)
          );
        b->entry.template.sets->out_def = out_def;

        /* out_use = in_use + use */
        b->entry.template.sets->out_use =
          myunion_refl(in_use, b->entry.template.sets->use);

        propogate(in_def, b->entry.template.sets->use);
        return (b->entry.template.sets);
      }

     case LOOP_NODE:
     case FOR_NODE:
     case WHILE_NODE:
      /* PASS 1 ---------------------- */
      /* for each child collect gen and use */
      if (pass == 1) {
        b->id = node_count++;
        use = NULL;
        gen = NULL;
        detmp = NULL;
        if (b->entry.template.symbol == NULL) { /* this is  a C loop */
          use = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr1);
          gen = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr2);
          myassign(&use, myunion_refl(use, gen));
          gen = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr3);
          myassign(&use, myunion_refl(use, gen));
          myassign(&gen, detmp);
        }
        else
          use = gather_refl(rnd, &detmp, b, b->entry.for_node.range);
        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
          myassign(&use, myunion_refl(use, s->use));
          gen = rem_kill(gen, s->gen);  /* try to fix propogation prob */
          myassign(&gen, myunion_refl(gen, s->gen));
          bl = bl->next;

        }
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        b->entry.template.sets->out_use = NULL;
        b->entry.template.sets->in_use = NULL;
        b->entry.template.sets->out_def = NULL;
        b->entry.template.sets->in_def = NULL;
        b->entry.template.sets->gen = myremove_locals(b, gen);
        b->entry.template.sets->use = myremove_locals(b, use);
        return (b->entry.template.sets);
      }
      else {
        /* PASS 2 ---------------------- */
        s = b->entry.template.sets;
        b->entry.template.sets->in_use = mycopy_refl(in_use);
        b->entry.template.sets->out_def = mycopy_refl(in_def);
        /* first take care of range varible propogation. */
        detmp = NULL;
        if (b->entry.template.symbol == NULL) { /* this is  a C loop */
          use = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr1);
          gen = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr2);
          myassign(&use, myunion_refl(use, gen));
          gen = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr3);
          myassign(&use, myunion_refl(use, gen));
          gen = detmp;
        }
        else
          use = gather_refl(rnd, &detmp, b, b->entry.for_node.range);
        propogate(in_def, use);
        /* now  take care of children */
        out_use = myunion_refl(in_use, s->use);
        out_def = myunion_refl(in_def, s->gen);
        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, out_use, out_def, pass);
          myassign(&out_use, mycopy_refl(s->out_use));
          myassign(&out_def, mycopy_refl(s->out_def));
          bl = bl->next;
        }
        b->entry.template.sets->out_use = out_use;
        b->entry.template.sets->out_def = out_def;
        return (b->entry.template.sets);
      }
     case COLOOP_NODE:
     case CDOALL_NODE:

      /* PASS 1 ----------------------           */
      /* for each child collect gen and use              */
      if (pass == 1) {
        b->id = node_count++;
        use = NULL;
        gen = NULL;
        detmp = NULL;
        if (b->variant == COLOOP_NODE) {
          use = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr2);
          bl = b->entry.template.bl_ptr1;
        }
        else {
          use = gather_refl(rnd, &detmp, b, b->entry.for_node.range);
          bl = b->entry.template.bl_ptr2;
        }
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
          myassign(&use, myunion_refl(use, s->use));
          myassign(&gen, myunion_refl(gen, s->gen));
          bl = bl->next;
        }
        if (b->variant == CDOALL_NODE &&
            b->entry.template.bl_ptr1 != NULL) {
          bl = b->entry.template.bl_ptr1;
          while ((bl != NULL) && (bl->ref != b)) {
            s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
            myassign(&use, myunion_refl(use, s->use));
            myassign(&gen, myunion_refl(gen, s->gen));
            bl = bl->next;
          }
        }
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        b->entry.template.sets->out_use = NULL;
        b->entry.template.sets->in_use = NULL;
        b->entry.template.sets->out_def = NULL;
        b->entry.template.sets->in_def = NULL;
        /* here is difference with other loops   */
        /* locals must be deleted from gen and use       */
        b->entry.template.sets->gen = myremove_locals(b, gen);
        b->entry.template.sets->use = myremove_locals(b, use);
        return (b->entry.template.sets);
      }
      else {
        /* PASS 2 ---------------------- */

        s = b->entry.template.sets;
        b->entry.template.sets->in_use = mycopy_refl(in_use);
        b->entry.template.sets->in_def = mycopy_refl(in_def);
        detmp = NULL;
        if (b->variant == COLOOP_NODE) {
          use = gather_refl(rnd, &detmp, b, b->entry.template.ll_ptr2);
          bl = b->entry.template.bl_ptr1;
        }
        else {
          use = gather_refl(rnd, &detmp, b, b->entry.for_node.range);
          bl = b->entry.template.bl_ptr2;
        }
        out_use = myunion_refl(in_use, s->use);
        out_def = myunion_refl(in_def, s->gen);
        propogate(in_def, use);
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, out_use, out_def, pass);
          myassign(&out_use, mycopy_refl(s->out_use));
          myassign(&out_def, mycopy_refl(s->out_def));
          bl = bl->next;
        }
        if (b->variant == CDOALL_NODE &&
            b->entry.template.bl_ptr1 != NULL) {
          bl = b->entry.template.bl_ptr1;
          while ((bl != NULL) && (bl->ref != b)) {
            s = mybuild_sets(rnd, bl->ref, out_use, out_def, pass);
            myassign(&out_use, mycopy_refl(s->out_use));
            myassign(&out_def, mycopy_refl(s->out_def));
            bl = bl->next;
          }
        }
        b->entry.template.sets->out_use = out_use;
        b->entry.template.sets->out_def = out_def;
        return (b->entry.template.sets);
      }
     case LOGIF_NODE:
     case ELSEIF_NODE:
     case IF_NODE:
      /* PASS 1 ---------------------- */
      /* for each child collect gen and use */
      if (pass == 1) {
        b->id = node_count++;
        use = NULL;
        gen = NULL;
        use = gather_refl(rnd, &gen, b, b->entry.template.ll_ptr1);

        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
          myassign(&use, myunion_refl(use, s->use));
          myassign(&gen, myunion_refl(gen, s->gen));
          bl = bl->next;
        }
        if (b->variant != LOGIF_NODE) {
          bl = b->entry.template.bl_ptr2;
          while ((bl != NULL) && (bl->ref != b)) {
            s = mybuild_sets(rnd, bl->ref, NULL, NULL, pass);
            myassign(&use, myunion_refl(use, s->use));
            myassign(&gen, myunion_refl(gen, s->gen));
            bl = bl->next;
          }
        }
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        b->entry.template.sets->out_use = NULL;
        b->entry.template.sets->in_use = NULL;
        b->entry.template.sets->out_def = NULL;
        b->entry.template.sets->in_def = NULL;
        b->entry.template.sets->gen = gen;
        b->entry.template.sets->use = use;
        return (b->entry.template.sets);
      }
      else {
        /* PASS 2 ------------------------------------------------ */
        /* for each branch do                                     */
        /* out_use = in_use; out_def_branch = in_def;     */
        /* for each child do                      */
        /* pass out_use and out_def_branch;  */
        /* visit child                    */
        /* out_use = child.out_use;       */
        /* out_def_branch = child.out_def;   */
        /* end;                                   */
        /* out_def = out_def_lbranch+out_def_rbranch */
        /* ________________________________________________________ */
        out_defT = in_def;
        out_useT = in_use;
        /* visit True children */
        b->entry.template.sets->in_use =
          mycopy_refl(in_use);
        b->entry.template.sets->in_def =
          mycopy_refl(in_def);

        bl = b->entry.template.bl_ptr1;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, out_useT, out_defT, pass);
          out_useT = s->out_use;
          out_defT = s->out_def;
          bl = bl->next;
        }
        out_defF = in_def;
        out_useF = in_use;
        /* visit False children */
        bl = b->entry.template.bl_ptr2;
        while ((bl != NULL) && (bl->ref != b)) {
          s = mybuild_sets(rnd, bl->ref, out_useF, out_defF, pass);
          out_useF = s->out_use;
          out_defF = s->out_def;
          bl = bl->next;
        }
        gen = NULL;
        use = gather_refl(rnd, &gen, b, b->entry.template.ll_ptr1);
        myassign(&use, myunion_refl(out_useF, use));
        myassign(&gen, myunion_refl(out_defF, gen));
        b->entry.template.sets->out_use =
          myunion_refl(use, out_useT);
        b->entry.template.sets->out_def =
          myunion_refl(gen, out_defT);

        return (b->entry.template.sets);
      }
     case EXIT_NODE:
      fprintf(stderr, "exit node found! no dep ananysis!\n");

     default:                   /* assume a no op */
      if (pass == 1) {
        b->id = node_count++;
        if (b->entry.template.sets == NULL)
          b->entry.template.sets = alloc_sets();
        b->entry.template.sets->gen = NULL;
        b->entry.template.sets->use = NULL;
        return (b->entry.template.sets);
      }
      else {
        /* PASS 2 ----------------------- */
        /* just pass everything through! */
        b->entry.template.sets->out_def = in_def;
        b->entry.template.sets->out_use = in_use;

        return (b->entry.template.sets);
      }
    }
  return (NULL);
}
void myreset_llnd(p)
PTR_LLND p;
{
  if (p == NULL)
    return;
  if (p->variant == VAR_REF) {
    p->entry.template.ll_ptr1 = NULL;
  }
 myreset_llnd(p->entry.template.ll_ptr1);
 myreset_llnd(p->entry.template.ll_ptr2);
}


void myreset_scalar_propogation(b)
PTR_BFND b;
{
  PTR_BLOB bl;

  if (b == NULL)
    return;
  if ((b->variant != FUNC_HEDR) && (b->variant != PROC_HEDR)) {
    reset_llnd(b->entry.template.ll_ptr1);
    reset_llnd(b->entry.template.ll_ptr2);
    reset_llnd(b->entry.template.ll_ptr3);
  }
  for (bl = b->entry.template.bl_ptr1; bl; bl = bl->next)
    myreset_scalar_propogation(bl->ref);

  for (bl = b->entry.template.bl_ptr2; bl; bl = bl->next)
    myreset_scalar_propogation(bl->ref);
}

void myrelink(fi)
PTR_FILE fi;
{
  PTR_BFND bf_ptr;
  int count = 1;

  for (bf_ptr = fi->head_bfnd; bf_ptr != NULL; bf_ptr = bf_ptr->thread)
    bf_ptr->id = count++;
}

count(e)
ELIST e;
{  extern PTR_FILE currentFile;
   extern PTR_PROJ currentProject; 
   void myreset_scalar_propogation();
   void myrelink();
   PTR_BFND p;
   if (currentProject && currentFile) 
  {
      p = currentFile->global_bfnd;
       myreset_scalar_propogation(p);
       (void) mybuild_sets(1, p, (PTR_REFL)NULL, (PTR_REFL)NULL, 1);
       (void) mybuild_sets(1, p, (PTR_REFL)NULL, (PTR_REFL)NULL, 2);
       myrelink(currentFile);
       return 0;
   } 
  else 
        return -1;  
}
