      SUBROUTINE BJT
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     THIS ROUTINE PROCESSES BJTS FOR DC AND TRANSIENT ANALYSES.
C
C SPICE VERSION 2G.6  SCCSID=TABINF 3/15/83
      COMMON /TABINF/ IELMNT,ISBCKT,NSBCKT,IUNSAT,NUNSAT,ITEMPS,NUMTEM,
     1   ISENS,NSENS,IFOUR,NFOUR,IFIELD,ICODE,IDELIM,ICOLUM,INSIZE,
     2   JUNODE,LSBKPT,NUMBKP,IORDER,JMNODE,IUR,IUC,ILC,ILR,NUMOFF,ISR,
     3   NMOFFC,ISEQ,ISEQ1,NEQN,NODEVS,NDIAG,ISWAP,IEQUA,MACINS,LVNIM1,
     4   LX0,LVN,LYNL,LYU,LYL,LX1,LX2,LX3,LX4,LX5,LX6,LX7,LD0,LD1,LTD,
     5   IMYNL,IMVN,LCVN,NSNOD,NSMAT,NSVAL,ICNOD,ICMAT,ICVAL,
     6   LOUTPT,LPOL,LZER,IRSWPF,IRSWPR,ICSWPF,ICSWPR,IRPT,JCPT,
     7   IROWNO,JCOLNO,NTTBR,NTTAR,LVNTMP
C SPICE VERSION 2G.6  SCCSID=CIRDAT 3/15/83
      COMMON /CIRDAT/ LOCATE(50),JELCNT(50),NUNODS,NCNODS,NUMNOD,NSTOP,
     1   NUT,NLT,NXTRM,NDIST,NTLIN,IBR,NUMVS,NUMALT,NUMCYC
C SPICE VERSION 2G.6  SCCSID=STATUS 3/15/83
      COMMON /STATUS/ OMEGA,TIME,DELTA,DELOLD(7),AG(7),VT,XNI,EGFET,
     1   XMU,SFACTR,MODE,MODEDC,ICALC,INITF,METHOD,IORD,MAXORD,NONCON,
     2   ITERNO,ITEMNO,NOSOLV,MODAC,IPIV,IVMFLG,IPOSTP,ISCRCH,IOFILE
C SPICE VERSION 2G.6  SCCSID=KNSTNT 3/15/83
      COMMON /KNSTNT/ TWOPI,XLOG2,XLOG10,ROOT2,RAD,BOLTZ,CHARGE,CTOK,
     1   GMIN,RELTOL,ABSTOL,VNTOL,TRTOL,CHGTOL,EPS0,EPSSIL,EPSOX,
     2   PIVTOL,PIVREL
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
C
C
      DIMENSION VBEO(1),VBCO(1),CCO(1),CBO(1),GPIO(1),GMUO(1),GMO(1),
     1   GOO(1),QBE(1),CQBE(1),QBC(1),CQBC(1),QCS(1),CQCS(1),QBX(1),
     2   CQBX(1),GXO(1),CEXBC(1),GEQCBO(1)
      EQUIVALENCE (VBEO(1),VALUE(1)),(VBCO(1),VALUE(2)),
     1   (CCO(1),VALUE(3)),(CBO(1),VALUE(4)),(GPIO(1),VALUE(5)),
     2   (GMUO(1),VALUE(6)),(GMO(1),VALUE(7)),(GOO(1),VALUE(8)),
     3   (QBE(1),VALUE(9)),(CQBE(1),VALUE(10)),(QBC(1),VALUE(11)),
     4   (CQBC(1),VALUE(12)),(QCS(1),VALUE(13)),(CQCS(1),VALUE(14)),
     5   (QBX(1),VALUE(15)),(CQBX(1),VALUE(16)),(GXO(1),VALUE(17)),
     6   (CEXBC(1),VALUE(18)),(GEQCBO(1),VALUE(19))
C
C
      LOC=LOCATE(12)
   10 IF ((LOC.EQ.0).OR.(NODPLC(LOC+36).NE.0)) RETURN
      LOCV=NODPLC(LOC+1)
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODE4=NODPLC(LOC+5)
      NODE5=NODPLC(LOC+6)
      NODE6=NODPLC(LOC+7)
      NODE7=NODPLC(LOC+30)
      LOCM=NODPLC(LOC+8)
      IOFF=NODPLC(LOC+9)
      TYPE=NODPLC(LOCM+2)
      LOCM=NODPLC(LOCM+1)
      LOCT=NODPLC(LOC+22)
      GCCS=0.0D0
      CEQCS=0.0D0
      GEQBX=0.0D0
      CEQBX=0.0D0
      GEQCB=0.0D0
C
C  DC MODEL PARAMTERS
C
      AREA=VALUE(LOCV+1)
      BFM=VALUE(LOCM+2)
      BRM=VALUE(LOCM+8)
      CSAT=VALUE(LOCM+1)*AREA
      RBPR=VALUE(LOCM+18)/AREA
      RBPI=VALUE(LOCM+16)/AREA-RBPR
      GCPR=VALUE(LOCM+20)*AREA
      GEPR=VALUE(LOCM+19)*AREA
      OVA=VALUE(LOCM+4)
      OVB=VALUE(LOCM+10)
      OIK=VALUE(LOCM+5)/AREA
      C2=VALUE(LOCM+6)*AREA
      VTE=VALUE(LOCM+7)*VT
      OIKR=VALUE(LOCM+11)/AREA
      C4=VALUE(LOCM+12)*AREA
      VTC=VALUE(LOCM+13)*VT
      VCRIT=VALUE(LOCM+54)
      TD=VALUE(LOCM+28)
      XJRB=VALUE(LOCM+17)*AREA
C
C  INITIALIZATION
C
      ICHECK=1
      GO TO (100,20,30,50,60,70),INITF
   20 IF(MODE.NE.1.OR.MODEDC.NE.2.OR.NOSOLV.EQ.0) GO TO 25
      VBE=TYPE*VALUE(LOCV+2)
      VCE=TYPE*VALUE(LOCV+3)
      VBC=VBE-VCE
      VBX=VBC
      VCS=0.0D0
      GO TO 300
   25 IF(IOFF.NE.0) GO TO 40
      VBE=VCRIT
      VBC=0.0D0
      GO TO 300
   30 IF (IOFF.EQ.0) GO TO 100
   40 VBE=0.0D0
      VBC=0.0D0
      GO TO 300
   50 VBE=VBEO(LX0+LOCT)
      VBC=VBCO(LX0+LOCT)
      VBX=TYPE*(VALUE(LVNIM1+NODE2)-VALUE(LVNIM1+NODE4))
      VCS=TYPE*(VALUE(LVNIM1+NODE7)-VALUE(LVNIM1+NODE4))
      GO TO 300
   60 VBE=VBEO(LX1+LOCT)
      VBC=VBCO(LX1+LOCT)
      VBX=TYPE*(VALUE(LVNIM1+NODE2)-VALUE(LVNIM1+NODE4))
      VCS=TYPE*(VALUE(LVNIM1+NODE7)-VALUE(LVNIM1+NODE4))
      IF(MODE.NE.2.OR.NOSOLV.EQ.0) GO TO 300
      VBX=TYPE*(VALUE(LOCV+2)-VALUE(LOCV+3))
      VCS=0.0D0
      GO TO 300
   70 XFACT=DELTA/DELOLD(2)
      VBEO(LX0+LOCT)=VBEO(LX1+LOCT)
      VBE=(1.0D0+XFACT)*VBEO(LX1+LOCT)-XFACT*VBEO(LX2+LOCT)
      VBCO(LX0+LOCT)=VBCO(LX1+LOCT)
      VBC=(1.0D0+XFACT)*VBCO(LX1+LOCT)-XFACT*VBCO(LX2+LOCT)
      CCO(LX0+LOCT)=CCO(LX1+LOCT)
      CBO(LX0+LOCT)=CBO(LX1+LOCT)
      GPIO(LX0+LOCT)=GPIO(LX1+LOCT)
      GMUO(LX0+LOCT)=GMUO(LX1+LOCT)
      GMO(LX0+LOCT)=GMO(LX1+LOCT)
      GOO(LX0+LOCT)=GOO(LX1+LOCT)
      GXO(LX0+LOCT)=GXO(LX1+LOCT)
      GO TO 110
C
C  COMPUTE NEW NONLINEAR BRANCH VOLTAGES
C
  100 VBE=TYPE*(VALUE(LVNIM1+NODE5)-VALUE(LVNIM1+NODE6))
      VBC=TYPE*(VALUE(LVNIM1+NODE5)-VALUE(LVNIM1+NODE4))
  110 DELVBE=VBE-VBEO(LX0+LOCT)
      DELVBC=VBC-VBCO(LX0+LOCT)
      VBX=TYPE*(VALUE(LVNIM1+NODE2)-VALUE(LVNIM1+NODE4))
      VCS=TYPE*(VALUE(LVNIM1+NODE7)-VALUE(LVNIM1+NODE4))
      CCHAT=CCO(LX0+LOCT)+(GMO(LX0+LOCT)+GOO(LX0+LOCT))*DELVBE
     1   -(GOO(LX0+LOCT)+GMUO(LX0+LOCT))*DELVBC
      CBHAT=CBO(LX0+LOCT)+GPIO(LX0+LOCT)*DELVBE+GMUO(LX0+LOCT)*DELVBC
C
C   BYPASS IF SOLUTION HAS NOT CHANGED
C
      IF (INITF.EQ.6) GO TO 200
      TOL=RELTOL*MAX(ABS(VBE),ABS(VBEO(LX0+LOCT)))+VNTOL
      IF (ABS(DELVBE).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(VBC),ABS(VBCO(LX0+LOCT)))+VNTOL
      IF (ABS(DELVBC).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(CCHAT),ABS(CCO(LX0+LOCT)))+ABSTOL
      IF (ABS(CCHAT-CCO(LX0+LOCT)).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(CBHAT),ABS(CBO(LX0+LOCT)))+ABSTOL
      IF (ABS(CBHAT-CBO(LX0+LOCT)).GE.TOL) GO TO 200
      VBE=VBEO(LX0+LOCT)
      VBC=VBCO(LX0+LOCT)
      CC=CCO(LX0+LOCT)
      CB=CBO(LX0+LOCT)
      GPI=GPIO(LX0+LOCT)
      GMU=GMUO(LX0+LOCT)
      GM=GMO(LX0+LOCT)
      GO=GOO(LX0+LOCT)
      GX=GXO(LX0+LOCT)
      GEQCB=GEQCBO(LX0+LOCT)
      IF (MODE.NE.1) GO TO 800
      GO TO 900
C
C  LIMIT NONLINEAR BRANCH VOLTAGES
C
  200 ICHK1=1
      CALL PNJLIM(VBE,VBEO(LX0+LOCT),VT,VCRIT,ICHECK)
      CALL PNJLIM(VBC,VBCO(LX0+LOCT),VT,VCRIT,ICHK1)
      IF (ICHK1.EQ.1) ICHECK=1
C
C  DETERMINE DC CURRENT AND DERIVITIVES
C
  300 VTN=VT*VALUE(LOCM+3)
      IF(VBE.LE.-5.0D0*VTN) GO TO 320
      EVBE=EXP(VBE/VTN)
      CBE=CSAT*(EVBE-1.0D0)+GMIN*VBE
      GBE=CSAT*EVBE/VTN+GMIN
      IF (C2.NE.0.0D0) GO TO 310
      CBEN=0.0D0
      GBEN=0.0D0
      GO TO 350
  310 EVBEN=EXP(VBE/VTE)
      CBEN=C2*(EVBEN-1.0D0)
      GBEN=C2*EVBEN/VTE
      GO TO 350
  320 GBE=-CSAT/VBE+GMIN
      CBE=GBE*VBE
      GBEN=-C2/VBE
      CBEN=GBEN*VBE
  350 VTN=VT*VALUE(LOCM+9)
      IF(VBC.LE.-5.0D0*VTN) GO TO 370
      EVBC=EXP(VBC/VTN)
      CBC=CSAT*(EVBC-1.0D0)+GMIN*VBC
      GBC=CSAT*EVBC/VTN+GMIN
      IF (C4.NE.0.0D0) GO TO 360
      CBCN=0.0D0
      GBCN=0.0D0
      GO TO 400
  360 EVBCN=EXP(VBC/VTC)
      CBCN=C4*(EVBCN-1.0D0)
      GBCN=C4*EVBCN/VTC
      GO TO 400
  370 GBC=-CSAT/VBC+GMIN
      CBC=GBC*VBC
      GBCN=-C4/VBC
      CBCN=GBCN*VBC
C
C  DETERMINE BASE CHARGE TERMS
C
  400 Q1=1.0D0/(1.0D0-OVA*VBC-OVB*VBE)
      IF (OIK.NE.0.0D0) GO TO 405
      IF (OIKR.NE.0.0D0) GO TO 405
      QB=Q1
      DQBDVE=Q1*QB*OVB
      DQBDVC=Q1*QB*OVA
      GO TO 410
  405 Q2=OIK*CBE+OIKR*CBC
      ARG=MAX(0.0D0,1.0D0+4.0D0*Q2)
      SQARG=1.0D0
      IF(ARG.NE.0.0D0) SQARG=SQRT(ARG)
      QB=Q1*(1.0D0+SQARG)/2.0D0
      DQBDVE=Q1*(QB*OVB+OIK*GBE/SQARG)
      DQBDVC=Q1*(QB*OVA+OIKR*GBC/SQARG)
C
C  WEIL'S APPROX. FOR EXCESS PHASE APPLIED WITH BACKWARD-
C  EULER INTEGRATION
C
  410 CC=0.0D0
      CEX=CBE
      GEX=GBE
      IF(MODE.EQ.1) GO TO 420
      IF(TD.EQ.0.0D0) GO TO 420
      ARG1=DELTA/TD
      ARG2=3.0D0*ARG1
      ARG1=ARG2*ARG1
      DENOM=1.0D0+ARG1+ARG2
      ARG3=ARG1/DENOM
      IF(INITF.NE.5) GO TO 411
      CEXBC(LX1+LOCT)=CBE/QB
      CEXBC(LX2+LOCT)=CEXBC(LX1+LOCT)
  411 CC=(CEXBC(LX1+LOCT)*(1.0D0+DELTA/DELOLD(2)+ARG2)
     1  -CEXBC(LX2+LOCT)*DELTA/DELOLD(2))/DENOM
      CEX=CBE*ARG3
      GEX=GBE*ARG3
      CEXBC(LX0+LOCT)=CC+CEX/QB
C
C  DETERMINE DC INCREMENTAL CONDUCTANCES
C
  420 CC=CC+(CEX-CBC)/QB-CBC/BRM-CBCN
      CB=CBE/BFM+CBEN+CBC/BRM+CBCN
      GX=RBPR+RBPI/QB
      IF(XJRB.EQ.0.0D0) GO TO 430
      ARG1=MAX(CB/XJRB,1.0D-9)
      ARG2=(-1.0D0+SQRT(1.0D0+14.59025D0*ARG1))/2.4317D0/SQRT(ARG1)
      ARG1=TAN(ARG2)
      GX=RBPR+3.0D0*RBPI*(ARG1-ARG2)/ARG2/ARG1/ARG1
  430 IF(GX.NE.0.0D0) GX=1.0D0/GX
      GPI=GBE/BFM+GBEN
      GMU=GBC/BRM+GBCN
      GO=(GBC+(CEX-CBC)*DQBDVC/QB)/QB
      GM=(GEX-(CEX-CBC)*DQBDVE/QB)/QB-GO
      IF (MODE.NE.1) GO TO 500
      IF ((MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 500
      IF (INITF.EQ.4) GO TO 500
      GO TO 700
C
C  CHARGE STORAGE ELEMENTS
C
  500 TF=VALUE(LOCM+24)
      TR=VALUE(LOCM+33)
      CZBE=VALUE(LOCM+21)*AREA
      PE=VALUE(LOCM+22)
      XME=VALUE(LOCM+23)
      CDIS=VALUE(LOCM+32)
      CTOT=VALUE(LOCM+29)*AREA
      CZBC=CTOT*CDIS
      CZBX=CTOT-CZBC
      PC=VALUE(LOCM+30)
      XMC=VALUE(LOCM+31)
      FCPE=VALUE(LOCM+46)
      CZCS=VALUE(LOCM+38)*AREA
      PS=VALUE(LOCM+39)
      XMS=VALUE(LOCM+40)
      XTF=VALUE(LOCM+25)
      OVTF=VALUE(LOCM+26)
      XJTF=VALUE(LOCM+27)*AREA
      IF(TF.EQ.0.0D0) GO TO 505
      IF(VBE.LE.0.0D0) GO TO 505
      ARGTF=0.0D0
      ARG2=0.0D0
      ARG3=0.0D0
      IF(XTF.EQ.0.0D0) GO TO 504
      ARGTF=XTF
      IF(OVTF.NE.0.0D0) ARGTF=ARGTF*EXP(VBC*OVTF)
      ARG2=ARGTF
      IF(XJTF.EQ.0.0D0) GO TO 503
      TEMP=CBE/(CBE+XJTF)
      ARGTF=ARGTF*TEMP*TEMP
      ARG2=ARGTF*(3.0D0-TEMP-TEMP)
  503 ARG3=CBE*ARGTF*OVTF
  504 CBE=CBE*(1.0D0+ARGTF)/QB
      GBE=(GBE*(1.0D0+ARG2)-CBE*DQBDVE)/QB
      GEQCB=TF*(ARG3-CBE*DQBDVC)/QB
  505 IF (VBE.GE.FCPE) GO TO 510
      ARG=1.0D0-VBE/PE
      SARG=EXP(-XME*LOG(ARG))
      QBE(LX0+LOCT)=TF*CBE+PE*CZBE*(1.0D0-ARG*SARG)/(1.0D0-XME)
      CAPBE=TF*GBE+CZBE*SARG
      GO TO 520
  510 F1=VALUE(LOCM+47)
      F2=VALUE(LOCM+48)
      F3=VALUE(LOCM+49)
      CZBEF2=CZBE/F2
      QBE(LX0+LOCT)=TF*CBE+CZBE*F1+CZBEF2*(F3*(VBE-FCPE)
     1   +(XME/(PE+PE))*(VBE*VBE-FCPE*FCPE))
      CAPBE=TF*GBE+CZBEF2*(F3+XME*VBE/PE)
  520 FCPC=VALUE(LOCM+50)
      F1=VALUE(LOCM+51)
      F2=VALUE(LOCM+52)
      F3=VALUE(LOCM+53)
      IF (VBC.GE.FCPC) GO TO 530
      ARG=1.0D0-VBC/PC
      SARG=EXP(-XMC*LOG(ARG))
      QBC(LX0+LOCT)=TR*CBC+PC*CZBC*(1.0D0-ARG*SARG)/(1.0D0-XMC)
      CAPBC=TR*GBC+CZBC*SARG
      GO TO 540
  530 CZBCF2=CZBC/F2
      QBC(LX0+LOCT)=TR*CBC+CZBC*F1+CZBCF2*(F3*(VBC-FCPC)
     1   +(XMC/(PC+PC))*(VBC*VBC-FCPC*FCPC))
      CAPBC=TR*GBC+CZBCF2*(F3+XMC*VBC/PC)
  540 IF(VBX.GE.FCPC) GO TO 550
      ARG=1.0D0-VBX/PC
      SARG=EXP(-XMC*LOG(ARG))
      QBX(LX0+LOCT)=PC*CZBX*(1.0D0-ARG*SARG)/(1.0D0-XMC)
      CAPBX=CZBX*SARG
      GO TO 560
  550 CZBXF2=CZBX/F2
      QBX(LX0+LOCT)=CZBX*F1+CZBXF2*(F3*(VBX-FCPC)+(XMC/(PC+PC))*
     1   (VBX*VBX-FCPC*FCPC))
      CAPBX=CZBXF2*(F3+XMC*VBX/PC)
  560 IF(VCS.GE.0.0D0) GO TO 570
      ARG=1.0D0-VCS/PS
      SARG=EXP(-XMS*LOG(ARG))
      QCS(LX0+LOCT)=PS*CZCS*(1.0D0-ARG*SARG)/(1.0D0-XMS)
      CAPCS=CZCS*SARG
      GO TO 580
  570 QCS(LX0+LOCT)=VCS*CZCS*(1.0D0+XMS*VCS/(2.0D0*PS))
      CAPCS=CZCS*(1.0D0+XMS*VCS/PS)
C
C  STORE SMALL-SIGNAL PARAMETERS
C
  580 IF ((MODE.EQ.1).AND.(MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 700
      IF (INITF.NE.4) GO TO 600
      VALUE(LX0+LOCT+9)=CAPBE
      VALUE(LX0+LOCT+11)=CAPBC
      VALUE(LX0+LOCT+13)=CAPCS
      VALUE(LX0+LOCT+15)=CAPBX
      VALUE(LX0+LOCT+17)=GEQCB
      GO TO 1000
C
C  TRANSIENT ANALYSIS
C
  600 IF (INITF.NE.5) GO TO 610
      QBE(LX1+LOCT)=QBE(LX0+LOCT)
      QBC(LX1+LOCT)=QBC(LX0+LOCT)
      QBX(LX1+LOCT)=QBX(LX0+LOCT)
      QCS(LX1+LOCT)=QCS(LX0+LOCT)
  610 CALL INTGR8(GEQ,CEQ,CAPBE,LOCT+8)
      GEQCB=GEQCB*AG(1)
      GPI=GPI+GEQ
      CB=CB+CQBE(LX0+LOCT)
      CALL INTGR8(GEQ,CEQ,CAPBC,LOCT+10)
      GMU=GMU+GEQ
      CB=CB+CQBC(LX0+LOCT)
      CC=CC-CQBC(LX0+LOCT)
      IF (INITF.NE.5) GO TO 700
      CQBE(LX1+LOCT)=CQBE(LX0+LOCT)
      CQBC(LX1+LOCT)=CQBC(LX0+LOCT)
C
C  CHECK CONVERGENCE
C
  700 IF (INITF.NE.3) GO TO 710
      IF (IOFF.EQ.0) GO TO 710
      GO TO 750
  710 IF (ICHECK.EQ.1) GO TO 720
      TOL=RELTOL*MAX(ABS(CCHAT),ABS(CC))+ABSTOL
      IF (ABS(CCHAT-CC).GT.TOL) GO TO 720
      TOL=RELTOL*MAX(ABS(CBHAT),ABS(CB))+ABSTOL
      IF (ABS(CBHAT-CB).LE.TOL) GO TO 750
  720 NONCON=NONCON+1
  750 VBEO(LX0+LOCT)=VBE
      VBCO(LX0+LOCT)=VBC
      CCO(LX0+LOCT)=CC
      CBO(LX0+LOCT)=CB
      GPIO(LX0+LOCT)=GPI
      GMUO(LX0+LOCT)=GMU
      GMO(LX0+LOCT)=GM
      GOO(LX0+LOCT)=GO
      GXO(LX0+LOCT)=GX
      GEQCBO(LX0+LOCT)=GEQCB
      IF (MODE.EQ.1) GO TO 900
C
C     CHARGE STORAGE FOR C-S AND B-X JUNCTIONS
C
  800 CALL INTGR8(GCCS,CEQ,CAPCS,LOCT+12)
      CEQCS=TYPE*(CQCS(LX0+LOCT)-VCS*GCCS)
      CALL INTGR8(GEQBX,CEQ,CAPBX,LOCT+14)
      CEQBX=TYPE*(CQBX(LX0+LOCT)-VBX*GEQBX)
      IF (INITF.NE.5) GO TO 900
      CQBX(LX1+LOCT)=CQBX(LX0+LOCT)
      CQCS(LX1+LOCT)=CQCS(LX0+LOCT)
C
C  LOAD CURRENT EXCITATION VECTOR
C
  900 CEQBE=TYPE*(CC+CB-VBE*(GM+GO+GPI)+VBC*(GO-GEQCB))
      CEQBC=TYPE*(-CC+VBE*(GM+GO)-VBC*(GMU+GO))
      VALUE(LVN+NODE2)=VALUE(LVN+NODE2)-CEQBX
      VALUE(LVN+NODE4)=VALUE(LVN+NODE4)+CEQCS+CEQBX+CEQBC
      VALUE(LVN+NODE5)=VALUE(LVN+NODE5)-CEQBE-CEQBC
      VALUE(LVN+NODE6)=VALUE(LVN+NODE6)+CEQBE
      VALUE(LVN+NODE7)=VALUE(LVN+NODE7)-CEQCS
C
C  LOAD Y MATRIX
C
      LOCY=LVN+NODPLC(LOC+24)
      VALUE(LOCY)=VALUE(LOCY)+GCPR
      LOCY=LVN+NODPLC(LOC+25)
      VALUE(LOCY)=VALUE(LOCY)+GX+GEQBX
      LOCY=LVN+NODPLC(LOC+26)
      VALUE(LOCY)=VALUE(LOCY)+GEPR
      LOCY=LVN+NODPLC(LOC+27)
      VALUE(LOCY)=VALUE(LOCY)+GMU+GO+GCPR+GCCS+GEQBX
      LOCY=LVN+NODPLC(LOC+28)
      VALUE(LOCY)=VALUE(LOCY)+GX  +GPI+GMU+GEQCB
      LOCY=LVN+NODPLC(LOC+29)
      VALUE(LOCY)=VALUE(LOCY)+GPI+GEPR+GM+GO
      LOCY=LVN+NODPLC(LOC+10)
      VALUE(LOCY)=VALUE(LOCY)-GCPR
      LOCY=LVN+NODPLC(LOC+11)
      VALUE(LOCY)=VALUE(LOCY)-GX
      LOCY=LVN+NODPLC(LOC+12)
      VALUE(LOCY)=VALUE(LOCY)-GEPR
      LOCY=LVN+NODPLC(LOC+13)
      VALUE(LOCY)=VALUE(LOCY)-GCPR
      LOCY=LVN+NODPLC(LOC+14)
      VALUE(LOCY)=VALUE(LOCY)-GMU+GM
      LOCY=LVN+NODPLC(LOC+15)
      VALUE(LOCY)=VALUE(LOCY)-GM-GO
      LOCY=LVN+NODPLC(LOC+16)
      VALUE(LOCY)=VALUE(LOCY)-GX
      LOCY=LVN+NODPLC(LOC+17)
      VALUE(LOCY)=VALUE(LOCY)-GMU-GEQCB
      LOCY=LVN+NODPLC(LOC+18)
      VALUE(LOCY)=VALUE(LOCY)-GPI
      LOCY=LVN+NODPLC(LOC+19)
      VALUE(LOCY)=VALUE(LOCY)-GEPR
      LOCY=LVN+NODPLC(LOC+20)
      VALUE(LOCY)=VALUE(LOCY)-GO+GEQCB
      LOCY=LVN+NODPLC(LOC+21)
      VALUE(LOCY)=VALUE(LOCY)-GPI-GM-GEQCB
      LOCY=LVN+NODPLC(LOC+31)
      VALUE(LOCY)=VALUE(LOCY)+GCCS
      LOCY=LVN+NODPLC(LOC+32)
      VALUE(LOCY)=VALUE(LOCY)-GCCS
      LOCY=LVN+NODPLC(LOC+33)
      VALUE(LOCY)=VALUE(LOCY)-GCCS
      LOCY=LVN+NODPLC(LOC+34)
      VALUE(LOCY)=VALUE(LOCY)-GEQBX
      LOCY=LVN+NODPLC(LOC+35)
      VALUE(LOCY)=VALUE(LOCY)-GEQBX
 1000 LOC=NODPLC(LOC)
      GO TO 10
      END
