C SPICE VERSION 2G.6  SCCSID=DCTRAN.MA 3/15/83
      SUBROUTINE DCTRAN
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C
C     THIS ROUTINE CONTROLS THE DC TRANSFER CURVE, DC OPERATING POINT,
C AND TRANSIENT ANALYSES.  THE VARIABLES MODE AND MODEDC (DEFINED BELOW)
C DETERMINE EXACTLY WHICH ANALYSIS IS PERFORMED.
C
C SPICE VERSION 2G.6  SCCSID=TABINF 3/15/83
      COMMON /TABINF/ IELMNT,ISBCKT,NSBCKT,IUNSAT,NUNSAT,ITEMPS,NUMTEM,
     1   ISENS,NSENS,IFOUR,NFOUR,IFIELD,ICODE,IDELIM,ICOLUM,INSIZE,
     2   JUNODE,LSBKPT,NUMBKP,IORDER,JMNODE,IUR,IUC,ILC,ILR,NUMOFF,ISR,
     3   NMOFFC,ISEQ,ISEQ1,NEQN,NODEVS,NDIAG,ISWAP,IEQUA,MACINS,LVNIM1,
     4   LX0,LVN,LYNL,LYU,LYL,LX1,LX2,LX3,LX4,LX5,LX6,LX7,LD0,LD1,LTD,
     5   IMYNL,IMVN,LCVN,NSNOD,NSMAT,NSVAL,ICNOD,ICMAT,ICVAL,
     6   LOUTPT,LPOL,LZER,IRSWPF,IRSWPR,ICSWPF,ICSWPR,IRPT,JCPT,
     7   IROWNO,JCOLNO,NTTBR,NTTAR,LVNTMP
C SPICE VERSION 2G.6  SCCSID=MISCEL 3/15/83
      COMMON /MISCEL/ ATIME,APROG(3),ADATE,ATITLE(10),DEFL,DEFW,DEFAD,
     1  DEFAS,RSTATS(50),IWIDTH,LWIDTH,NOPAGE
C SPICE VERSION 2G.6  SCCSID=CIRDAT 3/15/83
      COMMON /CIRDAT/ LOCATE(50),JELCNT(50),NUNODS,NCNODS,NUMNOD,NSTOP,
     1   NUT,NLT,NXTRM,NDIST,NTLIN,IBR,NUMVS,NUMALT,NUMCYC
C SPICE VERSION 2G.6  SCCSID=STATUS 3/15/83
      COMMON /STATUS/ OMEGA,TIME,DELTA,DELOLD(7),AG(7),VT,XNI,EGFET,
     1   XMU,SFACTR,MODE,MODEDC,ICALC,INITF,METHOD,IORD,MAXORD,NONCON,
     2   ITERNO,ITEMNO,NOSOLV,MODAC,IPIV,IVMFLG,IPOSTP,ISCRCH,IOFILE
C SPICE VERSION 2G.6  SCCSID=FLAGS 3/15/83
      COMMON /FLAGS/ IPRNTA,IPRNTL,IPRNTM,IPRNTN,IPRNTO,LIMTIM,LIMPTS,
     1   LVLCOD,LVLTIM,ITL1,ITL2,ITL3,ITL4,ITL5,ITL6,IGOOF,NOGO,KEOF
C SPICE VERSION 2G.6  SCCSID=DC 3/15/83
      COMMON /DC/ TCSTAR(2),TCSTOP(2),TCINCR(2),ICVFLG,ITCELM(2),KSSOP,
     1   KINEL,KIDIN,KOVAR,KIDOUT
C SPICE VERSION 2G.6  SCCSID=TRAN 3/15/83
      COMMON /TRAN/ TSTEP,TSTOP,TSTART,DELMAX,TDMAX,FORFRE,JTRFLG
C SPICE VERSION 2G.6  SCCSID=CJE 3/15/83
      COMMON /CJE/ MAXTIM,ITIME,ICOST
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
      LOGICAL MEMPTR
C
C
      DIMENSION SUBTIT(4,2)
      DIMENSION AVHDR(3),AVFRM(4)
      DATA AVHDR / 8H( (2X,A4, 8H,3X,A7,3, 5HX)//) /
      DATA AVFRM / 8H( (1H ,A, 8H1,I3,1H), 8H,F10.4,3, 4HX)/) /
      DATA ANODE, AVLTG / 4HNODE, 7HVOLTAGE /
      DATA SUBTIT / 8HSMALL SI, 8HGNAL BIA, 8HS SOLUTI, 8HON      ,
     1              8HINITIAL , 8HTRANSIEN, 8HT SOLUTI, 8HON      /
      DATA LPRN /1H(/
      DATA ABLNK, ALETR, ALETT /1H , 1HR, 1HT /
C
C      THE VARIABLES *MODE*, *MODEDC*, AND *INITF* ARE USED BY SPICE TO
C KEEP TRACK OF THE STATE OF THE ANALYSIS.  THE VALUES OF THESE FLAGS
C (AND THE CORRESPONDING MEANINGS) ARE AS FOLLOWS:
C
C        FLAG    VALUE    MEANING
C        ----    -----    -------
C
C        MODE      1      DC ANALYSIS (SUBTYPE DEFINED BY *MODEDC*)
C                  2      TRANSIENT ANALYSIS
C                  3      AC ANALYSIS (SMALL SIGNAL)
C
C        MODEDC    1      DC OPERATING POINT
C                  2      INITIAL OPERATING POINT FOR TRANSIENT ANALYSIS
C                  3      DC TRANSFER CURVE COMPUTATION
C
C        INITF     1      CONVERGE WITH 'OFF' DEVICES ALLOWED TO FLOAT
C                  2      INITIALIZE JUNCTION VOLTAGES
C                  3      CONVERGE WITH 'OFF' DEVICES HELD 'OFF'
C                  4      STORE SMALL-SIGNAL PARAMETERS AWAY
C                  5      FIRST TIMEPOINT IN TRANSIENT ANALYSIS
C                  6      PREDICTION STEP
C
C NOTE:  *MODEDC* IS ONLY SIGNIFICANT IF *MODE* = 1.
C
C
C  INITIALIZE
C
      CALL TSEC(T1)
      SFACTR=1.0D0
C.. DON'T TAKE ANY CHANCES WITH LX3, SET TO LARGE NUMBER
      LX3=20000000
      LX2=20000000
C.. SEE IF LX3 AND LX2 TABLES ARE NEEDED
      NOLX2=0
      NOLX3=0
   20 LOCTIM=5
      IF(IPOSTP.EQ.0) GO TO 25
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C
C.. POST-PROCESSING INITIALIZATION
C
C     NUMCUR=JELCNT(9)
C     NUMPOS=NUNODS+NUMCUR
C     CALL GETM8(IBUFF,NUMPOS)
C     NUMPOS=NUMPOS*4
C     IF(NUMCUR.EQ.0) GO TO 25
C     LOC=LOCATE(9)
C     LOCCUR=NODPLC(LOC+6)-1
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C
C...  SET UP FORMAT
C
   25 NVPRLN=4+(LWIDTH-72)/19
      NVPRLN=MIN(NVPRLN,NCNODS-1)
      IPOS=2
      CALL ALFNUM(NVPRLN,AVFRM,IPOS)
      IPOS=2
      CALL ALFNUM(NVPRLN,AVHDR,IPOS)
C...  ALLOCATE STORAGE
      IF (MODE.EQ.2) GO TO 35
      NEED=4*NSTOP+NTTBR+NXTRM
      CALL AVLM8(NAVL)
      IF(NEED.LE.NAVL) GO TO 30
C...  NOT ENOUGH MEMORY FOR DC OPERATING POINT ANALYSIS
      WRITE(IOFILE,26) NEED,NAVL
   26 FORMAT('0INSUFFICIENT MEMORY AVAILABLE FOR DC ANALYSIS.',/
     1' MEMORY REQUIRED ',I6,', MEMORY AVAILABLE ',I6,'.')
      NOGO=1
      GO TO 1100
   30 CALL GETM8(LVNIM1,NSTOP)
      CALL GETM8(LVN,NSTOP+NTTBR)
      CALL SLPMEM(LVN,NSTOP)
      CALL GETM8(LX0,NXTRM)
      CALL GETM8(LVNTMP,NSTOP)
      IF (MODEDC.NE.3) GO TO 45
   35 CALL GETM8(LX1,NXTRM)
      IF(NOLX2.EQ.0) CALL GETM8(LX2,NXTRM)
      IF (MODE.NE.2) GO TO 40
      IF(NOLX3.EQ.0) CALL GETM8(LX3,NXTRM)
      CALL GETM8(LTD,0)
   40 CALL GETM8(LOUTPT,0)
   45 CALL CRUNCH
   50 IF (MODE.EQ.2) GO TO 500
      TIME=0.0D0
      AG(1)=0.0D0
      CALL SORUPD
      IF (MODEDC.EQ.3) GO TO 300
C
C
C  ....  SINGLE POINT DC ANALYSIS
C
C
C  COMPUTE DC OPERATING POINT
C
  100 IF (ITL6.GT.0) GO TO 105
      INITF=2
      CALL ITER8(ITL1)
      RSTATS(6)=RSTATS(6)+ITERNO
      IF (IGOOF.NE.0) GO TO 150
      GO TO 110
  105 CALL SORSTP(ITL6)
      RSTATS(6)=RSTATS(6)+ITERNO
      IF (IGOOF.NE.0) GO TO 150
  110 IF (MODEDC.NE.1) GO TO 120
      INITF=4
      CALL DIODE
      CALL BJT
      CALL JFET
      CALL MOSFET
C
C  PRINT OPERATING POINT
C
  120 IF ((MODE.EQ.1).AND.(MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 1000
      CALL TITLE(-1,LWIDTH,1,SUBTIT(1,MODEDC))
      WRITE (IOFILE,AVHDR) (ANODE,AVLTG,I=1,NVPRLN)
      WRITE (IOFILE,AVFRM) (LPRN,NODPLC(JUNODE+I),VALUE(LVNIM1+I),
     1  I=2,NCNODS)
      GO TO 1000
C
C  NO CONVERGENCE
C
  150 NOGO=1
      WRITE (IOFILE,151)
  151 FORMAT('1*ERROR*:  NO CONVERGENCE IN DC ANALYSIS'/'0LAST NODE VOL'
     1   ,'TAGES:'/)
      WRITE (IOFILE,AVHDR) (ANODE,AVLTG,I=1,NVPRLN)
      WRITE (IOFILE,AVFRM) (LPRN,NODPLC(JUNODE+I),VALUE(LVNIM1+I),
     1  I=2,NCNODS)
      GO TO 1000
C
C  ....  DC TRANSFER CURVES
C
  300 NUMOUT=JELCNT(41)+1
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C     IF(IPOSTP.NE.0) CALL PHEADR(ATITLE)
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
      ITEMP=ITCELM(1)
      LOCS=NODPLC(ITEMP+1)
      ANAM=VALUE(LOCS)
      CALL MOVE(ANAM,2,ABLNK,1,7)
      IRDCTC=0
      IRDCT2=0
      ITDCTC=0
      ITDCT2=0
      IF (ANAM.EQ.ALETR) IRDCTC=1
      IF (ANAM.EQ.ALETT) ITDCTC=1
      TEMVAL=VALUE(LOCS+1)
      ICVFL2=1
      IF(ITCELM(2).EQ.0) GO TO 310
      ITEMP=ITCELM(2)
      LOCS2=NODPLC(ITEMP+1)
      ANAM=VALUE(LOCS2)
      CALL MOVE(ANAM,2,ABLNK,1,7)
      IF (ANAM.EQ.ALETR) IRDCT2=1
      IF (ANAM.EQ.ALETT) ITDCT2=1
      TEMV2=VALUE(LOCS2+1)
      VALUE(LOCS2+1)=TCSTAR(2)
      TEMP=ABS((TCSTOP(2)-TCSTAR(2))/TCINCR(2))+0.5D0
      ICVFL2=INT(TEMP)+1
      ICVFL2=MAX(ICVFL2,1)
  310 DELTA=TCINCR(1)
      DO 320 I=1,7
      DELOLD(I)=DELTA
  320 CONTINUE
      ICVFL1=ICVFLG/ICVFL2
      VALUE(LOCS+1)=TCSTAR(1)
      IF ((ITDCTC.NE.1).AND.(ITDCT2.NE.1)) GO TO 325
      ITEMNO=3
      IF (ITDCTC.EQ.1) VALUE(ITEMPS+ITEMNO)=VALUE(LOCS+1)
      IF (ITDCT2.EQ.1) VALUE(ITEMPS+ITEMNO)=VALUE(LOCS2+1)
      CALL TMPUPD
  325 IF (IRDCTC.EQ.1) VALUE(LOCS+1)=1.0D0/VALUE(LOCS+1)
      IF (IRDCT2.EQ.1) VALUE(LOCS2+1)=1.0D0/VALUE(LOCS2+1)
      ICALC=0
      ICAL2=0
      LOCTIM=3
  340 INITF=2
      CALL ITER8(ITL1)
      RSTATS(4)=RSTATS(4)+ITERNO
      CALL COPY8(VALUE(LX0+1),VALUE(LX1+1),NXTRM)
      IF(NOLX2.EQ.0) CALL COPY8(VALUE(LX0+1),VALUE(LX2+1),NXTRM)
      IF (IGOOF.NE.0) GO TO 450
      GO TO 360
  350 CALL GETCJE
      IF ((MAXTIM-ITIME).LE.LIMTIM) GO TO 460
      INITF=6
      CALL ITER8(ITL2)
      RSTATS(4)=RSTATS(4)+ITERNO
      IF (IGOOF.NE.0) GO TO 340
C
C  STORE OUTPUTS
C
  360 CALL EXTMEM(LOUTPT,NUMOUT)
      LOCO=LOUTPT+ICALC*NUMOUT
      ICALC=ICALC+1
      ICAL2=ICAL2+1
      VALUE(LOCO+1)=VALUE(LOCS+1)
      IF (IRDCTC.EQ.1) VALUE(LOCO+1)=1.0D0/VALUE(LOCO+1)
      LOC=LOCATE(41)
  370 IF (LOC.EQ.0) GO TO 400
      IF (NODPLC(LOC+5).NE.0) GO TO 380
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      ISEQ=NODPLC(LOC+4)
      VALUE(LOCO+ISEQ)=VALUE(LVNIM1+NODE1)-VALUE(LVNIM1+NODE2)
      LOC=NODPLC(LOC)
      GO TO 370
  380 IPTR=NODPLC(LOC+2)
      IPTR=NODPLC(IPTR+6)
      ISEQ=NODPLC(LOC+4)
      VALUE(LOCO+ISEQ)=VALUE(LVNIM1+IPTR)
      LOC=NODPLC(LOC)
      GO TO 370
C
C  INCREMENT SOURCE VALUE
C
  400 IF(IPOSTP.EQ.0) GO TO 410
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C     VALUE(IBUFF+1)=VALUE(LOCS+1)
C     CALL COPY8(VALUE(LVNIM1+2),VALUE(IBUFF+2),NUNODS-1)
C     IF(NUMCUR.NE.0) CALL COPY8(VALUE(LVNIM1+LOCCUR+1),
C    1  VALUE(IBUFF+NUNODS+1),NUMCUR)
C     CALL FWRITE(VALUE(IBUFF+1),NUMPOS)
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
  410 IF (ICALC.GE.ICVFLG) GO TO 490
      IF(ICAL2.GE.ICVFL1) GO TO 480
      IF(NOLX2.NE.0) GO TO 420
      CALL PTRMEM(LX2,ITEMP)
      CALL PTRMEM(LX1,LX2)
      GO TO 430
  420 CALL PTRMEM(LX1,ITEMP)
  430 CALL PTRMEM(LX0,LX1)
      CALL PTRMEM(ITEMP,LX0)
      VALUE(LOCS+1)=TCSTAR(1)+DBLE(ICAL2)*DELTA
      IF (ITDCTC.NE.1) GO TO 440
      VALUE(ITEMPS+ITEMNO-1)=VALUE(ITEMPS+ITEMNO)
      VALUE(ITEMPS+ITEMNO)=VALUE(LOCS+1)
      CALL TMPUPD
  440 IF (IRDCTC.EQ.1) VALUE(LOCS+1)=1.0D0/VALUE(LOCS+1)
      GO TO 350
C
C  NO CONVERGENCE
C
  450 ITEMP=ITCELM(1)
      LOCE=NODPLC(ITEMP+1)
      WRITE (IOFILE,451) VALUE(LOCE),VALUE(LOCS+1)
  451 FORMAT('1*ERROR*:  NO CONVERGENCE IN DC TRANSFER CURVES AT ',A8,
     1   ' = ',1PD10.3/'0LAST NODE VOLTAGES:'/)
      WRITE (IOFILE,AVHDR) (ANODE,AVLTG,I=1,NVPRLN)
      WRITE (IOFILE,AVFRM) (LPRN,NODPLC(JUNODE+I),VALUE(LVNIM1+I),
     1  I=2,NCNODS)
      GO TO 470
  460 WRITE (IOFILE,461)
  461 FORMAT('0*ERROR*:  CPU TIME LIMIT EXCEEDED ... ANALYSIS STOPPED'/)
      GO TO 470
  462 WRITE(IOFILE,463)
  463 FORMAT('0*ERROR*:   TEMPERATURE SWEEP SHOULD BE THE SECOND SWEEP
     1SOURCE, CHANGE THE ORDER AND RE-EXECUTE'/)
  470 NOGO=1
      GO TO 490
C... RESET FIRST SWEEP VARIABLE ... STEP SECOND
  480 ICAL2=0
      VALUE(LOCS+1)=TCSTAR(1)
      IF (IRDCTC.EQ.1) VALUE(LOCS+1)=1.0D0/VALUE(LOCS+1)
      IF (ITDCTC.EQ.1) GO TO 462
      VALUE(LOCS2+1)=VALUE(LOCS2+1)+TCINCR(2)
      IF (IRDCT2.EQ.1) VALUE(LOCS2+1)=1.0D0/VALUE(LOCS2+1)
      IF (ITDCT2.NE.1) GO TO 340
      VALUE(ITEMPS+ITEMNO-1)=VALUE(ITEMPS+ITEMNO)
      VALUE(ITEMPS+ITEMNO)=VALUE(LOCS2+1)
      CALL TMPUPD
      GO TO 340
C
C  FINISHED WITH DC TRANSFER CURVES
C
  490 VALUE(LOCS+1)=TEMVAL
      IF(ITCELM(2).NE.0) VALUE(LOCS2+1)=TEMV2
      IF ((ITDCTC.EQ.0).AND.(ITDCT2.EQ.0)) GO TO 1000
      VALUE(ITEMPS+ITEMNO-1)=VALUE(ITEMPS+ITEMNO)
      IF (ITDCTC.EQ.1) VALUE(ITEMPS+ITEMNO)=TEMVAL
      IF (ITDCT2.EQ.1) VALUE(ITEMPS+ITEMNO)=TEMV2
      WRITE (IOFILE,492)
  492 FORMAT (/,'0*****0 RETURN TO ORIGINAL TEMPERATURE 0*****0',/)
      CALL TMPUPD
      ITEMNO=1
      CALL RELMEM(ITEMPS,2)
      IF(IPOSTP.EQ.0) GO TO 1000
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C     CALL FWRITE(VALUE(IBUFF+1),NUMPOS)
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
      GO TO 1000
C
C  ....  TRANSIENT ANALYSIS
C
  500 NUMOUT=JELCNT(42)+1
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C     IF(IPOSTP.NE.0) CALL PHEADR(ATITLE)
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C...  LIMIT DELMAX IF NO ENERGY-STORAGE ELEMENTS
      NUMESE=JELCNT(2)+JELCNT(3)+JELCNT(11)+JELCNT(12)+JELCNT(13)
     1   +JELCNT(14)
      IF (NUMESE.EQ.0) DELMAX=MIN(DELMAX,TSTEP)
      INITF=5
      IORD=1
      LOCTIM=9
      ICALC=0
      NUMTP=0
      NUMRTP=0
      NUMNIT=0
      TIME=0.0D0
      IBKFLG=1
      DELBKP=DELMAX
      NBKPT=1
      DELTA=DELMAX
      DO 510 I=1,7
      DELOLD(I)=DELTA
  510 CONTINUE
      DELNEW=DELTA
      DELMIN=1.0D-9*DELMAX
      GO TO 650
C
C  INCREMENT TIME, UPDATE SOURCES, AND SOLVE NEXT TIMEPOINT
C
  600 TIME=TIME+DELTA
      CALL SORUPD
      IF (NOGO.NE.0) GO TO 950
      CALL GETCJE
      IF ((MAXTIM-ITIME).LE.LIMTIM) GO TO 920
      IF ((ITL5.NE.0).AND.(NUMNIT.GE.ITL5)) GO TO 905
      CALL COMCOF
      IF (INITF.NE.5) INITF=6
      ITRLIM=ITL4
      IF ((NUMTP.EQ.0).AND.(NOSOLV.NE.0)) ITRLIM=ITL1
      CALL ITER8(ITRLIM)
      NUMNIT=NUMNIT+ITERNO
      NUMTP=NUMTP+1
      IF (NUMTP.NE.1) GO TO 605
      IF(NOLX2.EQ.0) CALL COPY8(VALUE(LX1+1),VALUE(LX2+1),NXTRM)
      IF(NOLX3.EQ.0) CALL COPY8(VALUE(LX1+1),VALUE(LX3+1),NXTRM)
C.. NOTE THAT TIME-POINT IS CUT WHEN ITRLIM EXCEEDED REGARDLESS
C.. OF WHICH TIME-STEP CONTOL IS SPECIFIED THRU 'LVLTIM'.
  605 IF (IGOOF.EQ.0) GO TO 610
      JORD=IORD
      IORD=1
      IF (JORD.GE.5) CALL CLRMEM(LX7)
      IF (JORD.GE.4) CALL CLRMEM(LX6)
      IF (JORD.GE.3) CALL CLRMEM(LX5)
      IF ((JORD.GE.2).AND.(METHOD.NE.1)) CALL CLRMEM(LX4)
      IGOOF=0
      TIME=TIME-DELTA
      DELTA=DELTA/8.0D0
      GO TO 620
  610 DELNEW=DELTA
      IF (NUMTP.EQ.1) GO TO 630
      CALL TRUNC(DELNEW)
      IF (DELNEW.GE.(0.9D0*DELTA)) GO TO 630
      TIME=TIME-DELTA
      DELTA=DELNEW
  620 NUMRTP=NUMRTP+1
      IBKFLG=0
      DELOLD(1)=DELTA
      IF (DELTA.GE.DELMIN) GO TO 600
      TIME=TIME+DELTA
      GO TO 900
C
C  DETERMINE ORDER OF INTEGRATION METHOD
C
C...  SKIP IF TRAPEZOIDAL ALGORITHM USED
  630 IF ((METHOD.EQ.1).AND.(IORD.EQ.2)) GO TO 650
      IF (NUMTP.EQ.1) GO TO 650
      ORDRAT=1.05D0
      IF (IORD.GT.1) GO TO 635
      IORD=2
      CALL TRUNC(DELNEW)
      IORD=1
      IF ((DELNEW/DELTA).LE.ORDRAT) GO TO 650
      IF (MAXORD.LE.1) GO TO 650
      IORD=2
      IF (METHOD.EQ.1) GO TO 650
      CALL GETM8(LX4,NXTRM)
      GO TO 650
  635 IF (IORD.LT.MAXORD) GO TO 640
      IORD=IORD-1
      CALL TRUNC(DELNEW)
      IORD=IORD+1
      IF ((DELNEW/DELTA).LE.ORDRAT) GO TO 650
      GO TO 642
  640 IORD=IORD-1
      CALL TRUNC(DELNEW)
      IORD=IORD+1
      IF ((DELNEW/DELTA).LE.ORDRAT) GO TO 645
  642 IORD=IORD-1
      IF (IORD.EQ.1) CALL CLRMEM(LX4)
      IF (IORD.EQ.2) CALL CLRMEM(LX5)
      IF (IORD.EQ.3) CALL CLRMEM(LX6)
      IF (IORD.EQ.4) CALL CLRMEM(LX7)
      GO TO 650
  645 IORD=IORD+1
      CALL TRUNC(DELNEW)
      IORD=IORD-1
      IF ((DELNEW/DELTA).LE.ORDRAT) GO TO 650
      IORD=IORD+1
      IF (IORD.EQ.2) CALL GETM8(LX4,NXTRM)
      IF (IORD.EQ.3) CALL GETM8(LX5,NXTRM)
      IF (IORD.EQ.4) CALL GETM8(LX6,NXTRM)
      IF (IORD.EQ.5) CALL GETM8(LX7,NXTRM)
C
C  STORE OUTPUTS
C
  650 IF ((TIME+DELTA).LE.TSTART) GO TO 685
      IF ((NUMTP.EQ.0).AND.(NOSOLV.NE.0)) GO TO 685
      CALL EXTMEM(LOUTPT,NUMOUT)
      LOCO=LOUTPT+ICALC*NUMOUT
      ICALC=ICALC+1
      VALUE(LOCO+1)=TIME
      LOC=LOCATE(42)
  670 IF (LOC.EQ.0) GO TO 682
      IF (NODPLC(LOC+5).NE.0) GO TO 680
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      ISEQ=NODPLC(LOC+4)
      VALUE(LOCO+ISEQ)=VALUE(LVNIM1+NODE1)-VALUE(LVNIM1+NODE2)
      LOC=NODPLC(LOC)
      GO TO 670
  680 IPTR=NODPLC(LOC+2)
      IPTR=NODPLC(IPTR+6)
      ISEQ=NODPLC(LOC+4)
      VALUE(LOCO+ISEQ)=VALUE(LVNIM1+IPTR)
      LOC=NODPLC(LOC)
      GO TO 670
  682 IF(IPOSTP.EQ.0) GO TO 684
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C     VALUE(IBUFF+1)=TIME
C     CALL COPY8(VALUE(LVNIM1+2),VALUE(IBUFF+2),NUNODS-1)
C     IF(NUMCUR.NE.0) CALL COPY8(VALUE(LVNIM1+LOCCUR+1),
C    1  VALUE(IBUFF+NUNODS+1),NUMCUR)
C     CALL FWRITE(VALUE(IBUFF+1),NUMPOS)
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
  684 CONTINUE
C
C  UPDATE TRANSMISSION LINE DELAY TABLE
C
  685 IF (JELCNT(17).EQ.0) GO TO 694
      CALL SIZMEM(LTD,LTDSIZ)
      NUMTD=LTDSIZ/NTLIN
      IF (NUMTD.LE.3) GO TO 689
      BAKTIM=TIME-TDMAX
      IF (BAKTIM.LT.0.0D0) GO TO 689
      LCNTR=0
      LTEMP=LTD
      DO 686 I=1,NUMTD
      IF (VALUE(LTEMP+1).GE.BAKTIM) GO TO 687
      LTEMP=LTEMP+NTLIN
      LCNTR=LCNTR+1
  686 CONTINUE
      GO TO 689
  687 IF (LCNTR.LE.2) GO TO 689
      LCNTR=LCNTR-2
      NWORDS=LCNTR*NTLIN
      LTEMP=LTEMP-NTLIN-NTLIN
      CALL COPY8(VALUE(LTEMP+1),VALUE(LTD+1),LTDSIZ-NWORDS)
      CALL RELMEM(LTD,NWORDS)
      CALL SIZMEM(LTD,LTDSIZ)
  689 CALL EXTMEM(LTD,NTLIN)
      LTDPTR=LTD+LTDSIZ
      VALUE(LTDPTR+1)=TIME
      LOC=LOCATE(17)
  690 IF (LOC.EQ.0) GO TO 693
      LOCV=NODPLC(LOC+1)
      Z0=VALUE(LOCV+1)
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODE4=NODPLC(LOC+5)
      IBR1=NODPLC(LOC+8)
      IBR2=NODPLC(LOC+9)
      LSPOT=NODPLC(LOC+30)+LTDPTR
      IF ((INITF.EQ.5).AND.(NOSOLV.NE.0)) GO TO 691
      VALUE(LSPOT)=VALUE(LVNIM1+NODE3)-VALUE(LVNIM1+NODE4)
     1   +VALUE(LVNIM1+IBR2)*Z0
      VALUE(LSPOT+1)=VALUE(LVNIM1+NODE1)-VALUE(LVNIM1+NODE2)
     1   +VALUE(LVNIM1+IBR1)*Z0
      GO TO 692
  691 VALUE(LSPOT)=VALUE(LOCV+7)+VALUE(LOCV+8)*Z0
      VALUE(LSPOT+1)=VALUE(LOCV+5)+VALUE(LOCV+6)*Z0
  692 LOC=NODPLC(LOC)
      GO TO 690
C
C  ADD TWO *FAKE* BACKPOINTS TO LTD FOR INTERPOLATION NEAR TIME=0.0D0
C
  693 IF (NUMTD.NE.0) GO TO 694
      CALL EXTMEM(LTD,NTLIN+NTLIN)
      CALL COPY8(VALUE(LTD+1),VALUE(LTD+NTLIN+1),NTLIN)
      CALL COPY8(VALUE(LTD+1),VALUE(LTD+2*NTLIN+1),NTLIN)
      VALUE(LTD+2*NTLIN+1)=TIME
      VALUE(LTD+NTLIN+1)=TIME-DELTA
      VALUE(LTD+1)=TIME-DELTA-DELTA
C
C  ROTATE STATE VECTOR STORAGE
C
C.. TIME-POINT ACCEPTED
  694 CALL COPY8(DELOLD(1),DELOLD(2),6)
      DELTA=DELNEW
      DELOLD(1)=DELTA
      GO TO (710,706,702,698,696,696), IORD
  696 CALL PTRMEM(LX7,ITEMP)
      CALL PTRMEM(LX6,LX7)
      GO TO 700
  698 CALL PTRMEM(LX6,ITEMP)
  700 CALL PTRMEM(LX5,LX6)
      GO TO 704
  702 CALL PTRMEM(LX5,ITEMP)
  704 CALL PTRMEM(LX4,LX5)
      GO TO 708
  706 IF (METHOD.EQ.1) GO TO 710
      CALL PTRMEM(LX4,ITEMP)
  708 CALL PTRMEM(LX3,LX4)
      GO TO 713
  710 IF(NOLX3.EQ.0) GO TO 712
      IF(NOLX2.EQ.0) GO TO 711
      CALL PTRMEM(LX1,ITEMP)
      GO TO 714
  711 CALL PTRMEM(LX2,ITEMP)
      CALL PTRMEM(LX1,LX2)
      GO TO 714
  712 CALL PTRMEM(LX3,ITEMP)
  713 CALL PTRMEM(LX2,LX3)
      CALL PTRMEM(LX1,LX2)
  714 CALL PTRMEM(LX0,LX1)
      CALL PTRMEM(ITEMP,LX0)
C
C  CHECK BREAKPOINTS
C
  750 IF (IBKFLG.EQ.0) GO TO 760
C.. JUST ACCEPTED ANALYSIS AT BREAKPOINT
      JORD=IORD
      IORD=1
      IF (JORD.GE.5) CALL CLRMEM(LX7)
      IF (JORD.GE.4) CALL CLRMEM(LX6)
      IF (JORD.GE.3) CALL CLRMEM(LX5)
      IF ((JORD.GE.2).AND.(METHOD.NE.1)) CALL CLRMEM(LX4)
      IBKFLG=0
      NBKPT=NBKPT+1
      IF (NBKPT.GT.NUMBKP) GO TO 950
      TEMP=MIN(DELBKP,VALUE(LSBKPT+NBKPT)-TIME)
      DELTA=MIN(DELTA,0.1D0*TEMP,DELMAX)
      IF (NUMTP.EQ.0) DELTA=DELTA/10.0D0
      DELOLD(1)=DELTA
      GO TO 600
  760 DEL1=VALUE(LSBKPT+NBKPT)-TIME
      IF ((1.01D0*DELTA).LE.DEL1) GO TO 600
      IBKFLG=1
      DELBKP=DELTA
      DELTA=DEL1
      DELOLD(1)=DELTA
      GO TO 600
C
C  TRANSIENT ANALYSIS FAILED
C
  900 WRITE (IOFILE,901)
  901 FORMAT('1*ERROR*:  INTERNAL TIMESTEP TOO SMALL IN TRANSIENT ANALYS
     1IS'/)
      GO TO 910
  905 WRITE (IOFILE,906) ITL5
  906 FORMAT('1*ERROR*:  TRANSIENT ANALYSIS ITERATIONS EXCEED LIMIT OF '
     1,I5,/'0THIS LIMIT MAY BE OVERRIDDEN USING THE ITL5 PARAMETER ON TH
     2E .OPTION CARD')
  910 WRITE (IOFILE,911) TIME,DELTA,NUMNIT
  911 FORMAT(1H0,10X,'TIME = ',1PD12.5,';  DELTA = ',D12.5,';  NUMNIT =
     1',I6/)
      WRITE (IOFILE,916)
  916 FORMAT(1H0/'0LAST NODE VOLTAGES:'/)
      WRITE (IOFILE,AVHDR) (ANODE,AVLTG,I=1,NVPRLN)
      WRITE (IOFILE,AVFRM) (LPRN,NODPLC(JUNODE+I),VALUE(LVNIM1+I),
     1  I=2,NCNODS)
      GO TO 930
  920 WRITE (IOFILE,921) TIME
  921 FORMAT('0*ERROR*:  CPU TIME LIMIT EXCEEDED IN TRANSIENT ANALYSIS '
     1   ,'AT TIME = ',1PD13.6/)
  930 NOGO=1
C
C  FINISHED WITH TRANSIENT ANALYSIS
C
  950 RSTATS(10)=RSTATS(10)+NUMNIT
      RSTATS(30)=RSTATS(30)+NUMTP
      RSTATS(31)=RSTATS(31)+NUMRTP
      RSTATS(32)=RSTATS(32)+NUMNIT
      IF(IPOSTP.EQ.0) GO TO 1000
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C     IF (IPOSTP.NE.0) CALL CLSRAW
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C
C  RETURN UNNEEDED MEMORY
C
 1000 IF (MODE.EQ.2) GO TO 1010
      IF (MODEDC.NE.3) GO TO 1100
 1010 CALL CLRMEM(LVNIM1)
      CALL CLRMEM(LX0)
      CALL CLRMEM(LVN)
      CALL CLRMEM(LX1)
      IF (MEMPTR(MACINS)) CALL CLRMEM(MACINS)
      IF(NOLX2.EQ.0) CALL CLRMEM(LX2)
      CALL CLRMEM(LVNTMP)
      IF ((MODE.EQ.1).AND.(MODEDC.EQ.3)) GO TO 1020
      IF(NOLX3.EQ.0) CALL CLRMEM(LX3)
      IF (MODE.EQ.1) GO TO 1020
      CALL CLRMEM(LTD)
      IF (IORD.EQ.1) GO TO 1020
      IF (METHOD.EQ.1) GO TO 1020
      CALL CLRMEM(LX4)
      IF (IORD.EQ.2) GO TO 1020
      CALL CLRMEM(LX5)
      IF (IORD.EQ.3) GO TO 1020
      CALL CLRMEM(LX6)
      IF (IORD.EQ.4) GO TO 1020
      CALL CLRMEM(LX7)
 1020 CALL EXTMEM(LOUTPT,2*NUMOUT)
 1100 CONTINUE
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
C1100 IF(IPOSTP.NE.0) CALL CLRMEM(IBUFF)
C*************** POST-PROCESSING , UNIX DEPENDENT CODE *****************
      CALL TSEC(T2)
      RSTATS(LOCTIM)=RSTATS(LOCTIM)+T2-T1
      RETURN
      END
