      SUBROUTINE EVPOLY(RESULT,ITYPE,LCOEF,NCOEF,LARG,
     1  NARG,LEXP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     THIS ROUTINE EVALUATES A POLYNOMIAL.  LCOEF POINTS TO THE COEF-
C FICIENTS, AND LARG POINTS TO THE VALUES OF THE POLYNOMIAL ARGUMENT(S).
C
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
C
C
      IF (ITYPE) 100,200,300
C
C  INTEGRATION (POLYNOMIAL *MUST* BE ONE-DIMENSIONAL)
C
  100 RESULT=0.0D0
      ARG=1.0D0
      ARG1=VALUE(LARG+1)
      DO 110 I=1,NCOEF
      ARG=ARG*ARG1
      RESULT=RESULT+VALUE(LCOEF+I)*ARG/DBLE(I)
  110 CONTINUE
      GO TO 1000
C
C  EVALUATION OF THE POLYNOMIAL
C
  200 RESULT=VALUE(LCOEF+1)
      IF (NCOEF.EQ.1) GO TO 1000
      CALL ZERO4(NODPLC(LEXP+1),NARG)
      DO 220 I=2,NCOEF
      CALL NXTPWR(NODPLC(LEXP+1),NARG)
      IF (VALUE(LCOEF+I).EQ.0.0D0) GO TO 220
      ARG=1.0D0
      DO 210 J=1,NARG
      CALL EVTERM(VAL,VALUE(LARG+J),NODPLC(LEXP+J))
      ARG=ARG*VAL
  210 CONTINUE
      RESULT=RESULT+VALUE(LCOEF+I)*ARG
  220 CONTINUE
      GO TO 1000
C
C  PARTIAL DERIVATIVE WITH RESPECT TO THE ITYPE*TH VARIABLE
C
  300 RESULT=0.0D0
      IF (NCOEF.EQ.1) GO TO 1000
      CALL ZERO4(NODPLC(LEXP+1),NARG)
      DO 330 I=2,NCOEF
      CALL NXTPWR(NODPLC(LEXP+1),NARG)
      IF (NODPLC(LEXP+ITYPE).EQ.0) GO TO 330
      IF (VALUE(LCOEF+I).EQ.0.0D0) GO TO 330
      ARG=1.0D0
      DO 320 J=1,NARG
      IF (J.EQ.ITYPE) GO TO 310
      CALL EVTERM(VAL,VALUE(LARG+J),NODPLC(LEXP+J))
      ARG=ARG*VAL
      GO TO 320
  310 CALL EVTERM(VAL,VALUE(LARG+J),NODPLC(LEXP+J)-1)
      ARG=ARG*DBLE(NODPLC(LEXP+J))*VAL
  320 CONTINUE
      RESULT=RESULT+VALUE(LCOEF+I)*ARG
  330 CONTINUE
C
C  FINISHED
C
 1000 RETURN
      END
