      SUBROUTINE FIND(ANAME,ID,LOC,IFORCE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     THIS ROUTINE SEARCHES THE LIST WITH NUMBER 'ID' FOR AN ELEMENT
C WITH NAME 'ANAME'.  LOC IS SET TO POINT TO THE ELEMENT.  IF IFORCE IS
C NONZERO, THEN FIND EXPECTS TO HAVE TO ADD THE ELEMENT TO THE LIST, AND
C REPORTS A FATAL ERROR IF THE ELEMENT IS FOUND.  IF SUBCIRCUIT DEFINI-
C TION IS IN PROGRESS (NONZERO VALUE FOR NSBCKT), THEN FIND SEARCHES THE
C CURRENT SUBCIRCUIT DEFINITION LIST RATHER THAN THE NOMINAL ELEMENT
C LIST.
C
C SPICE VERSION 2G.6  SCCSID=TABINF 3/15/83
      COMMON /TABINF/ IELMNT,ISBCKT,NSBCKT,IUNSAT,NUNSAT,ITEMPS,NUMTEM,
     1   ISENS,NSENS,IFOUR,NFOUR,IFIELD,ICODE,IDELIM,ICOLUM,INSIZE,
     2   JUNODE,LSBKPT,NUMBKP,IORDER,JMNODE,IUR,IUC,ILC,ILR,NUMOFF,ISR,
     3   NMOFFC,ISEQ,ISEQ1,NEQN,NODEVS,NDIAG,ISWAP,IEQUA,MACINS,LVNIM1,
     4   LX0,LVN,LYNL,LYU,LYL,LX1,LX2,LX3,LX4,LX5,LX6,LX7,LD0,LD1,LTD,
     5   IMYNL,IMVN,LCVN,NSNOD,NSMAT,NSVAL,ICNOD,ICMAT,ICVAL,
     6   LOUTPT,LPOL,LZER,IRSWPF,IRSWPR,ICSWPF,ICSWPR,IRPT,JCPT,
     7   IROWNO,JCOLNO,NTTBR,NTTAR,LVNTMP
C SPICE VERSION 2G.6  SCCSID=CIRDAT 3/15/83
      COMMON /CIRDAT/ LOCATE(50),JELCNT(50),NUNODS,NCNODS,NUMNOD,NSTOP,
     1   NUT,NLT,NXTRM,NDIST,NTLIN,IBR,NUMVS,NUMALT,NUMCYC
C SPICE VERSION 2G.6  SCCSID=FLAGS 3/15/83
      COMMON /FLAGS/ IPRNTA,IPRNTL,IPRNTM,IPRNTN,IPRNTO,LIMTIM,LIMPTS,
     1   LVLCOD,LVLTIM,ITL1,ITL2,ITL3,ITL4,ITL5,ITL6,IGOOF,NOGO,KEOF
C SPICE VERSION 2G.6  SCCSID=MEMMGR 3/15/83
      COMMON /MEMMGR/ CPYKNT,ISTACK(1),LORG,ICORE,MAXCOR,MAXUSE,MEMAVL,
     1   LDVAL,NUMBLK,LOCTAB,LTAB,IFWA,NWOFF,NTAB,MAXMEM,MEMERR,NWD4,
     2   NWD8,NWD16
C SPICE VERSION 2G.6  SCCSID=STATUS 3/15/83
      COMMON /STATUS/ OMEGA,TIME,DELTA,DELOLD(7),AG(7),VT,XNI,EGFET,
     1   XMU,SFACTR,MODE,MODEDC,ICALC,INITF,METHOD,IORD,MAXORD,NONCON,
     2   ITERNO,ITEMNO,NOSOLV,MODAC,IPIV,IVMFLG,IPOSTP,ISCRCH,IOFILE
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
C
C  INDEX TO THE CONTENTS OF THE VARIOUS LISTS:
C
C        LIST      CONTENTS
C        ----      --------
C
C          1       RESISTORS
C          2       NONLINEAR CAPACITORS
C          3       NONLINEAR INDUCTORS
C          4       MUTUAL INDUCTORS
C          5       NONLINEAR VOLTAGE CONTROLLED CURRENT SOURCES
C          6       NONLINEAR VOLTAGE CONTROLLED VOLTAGE SOURCES
C          7       NONLINEAR CURRENT CONTROLLED CURRENT SOURCES
C          8       NONLINEAR CURRENT CONTROLLED VOLTAGE SOURCES
C          9       INDEPENDENT VOLTAGE SOURCES
C         10       INDEPENDENT CURRENT SOURCES
C         11       DIODES
C         12       BIPOLAR JUNCTION TRANSISTORS
C         13       JUNCTION FIELD-EFFECT TRANSISTORS (JFETS)
C         14       METAL-OXIDE-SEMICONDUCTOR JUNCTION FETS (MOSFETS)
C         15       S-PARAMETER 2-PORT NETWORK
C         16       Y-PARAMETER 2-PORT NETWORK
C         17       TRANSMISSION LINES
C         18       USED FOR TEMPERATURE SWEEPING
C         19       SUBCIRCUIT CALLS
C         20       SUBCIRCUIT DEFINITIONS
C         21       DIODE MODEL
C         22       BJT MODEL
C         23       JFET MODEL
C         24       MOSFET MODEL
C      25-30       <UNUSED>
C         31       .PRINT DC
C         32       .PRINT TRAN
C         33       .PRINT AC
C         34       .PRINT NOISE
C         35       .PRINT DISTORTION
C         36       .PLOT DC
C         37       .PLOT TR
C         38       .PLOT AC
C         39       .PLOT NOISE
C         40       .PLOT DISTORTION
C         41       OUTPUTS FOR DC
C         42       OUTPUTS FOR TRANSIENT
C         43       OUTPUTS FOR AC
C         44       OUTPUTS FOR NOISE
C         45       OUTPUTS FOR DISTORTION
C      46-50       <UNUSED>
C
      INTEGER XXOR
      DIMENSION LNOD(50),LVAL(50)
      DATA LNOD /10,14,16, 8,15,16,15,16,13, 8,
     1           18,38,27,35, 8, 8,35, 5, 5, 5,
     2            5, 5, 5, 5, 0, 0, 0, 0, 0, 0,
     3           21,21,21,21,21,21,21,21,21,21,
     4            8, 8, 8, 8, 8, 0, 0, 0, 0, 0 /
      DATA LVAL / 5, 4, 4, 2, 1, 1, 1, 1, 4, 4,
     1            3, 4, 4,16, 1, 1, 9, 2, 1, 1,
     2           19,55,17,46, 0, 0, 0, 0, 0, 0,
     3            1, 1, 1, 1, 1,17,17,17,17,17,
     4            1, 1, 1, 1, 1, 0, 0, 0, 0, 0 /
      DATA NDEFIN /2H.U/
C
C
      ANAM=ANAME
      CALL SIZMEM(IELMNT,ISIZE)
      LOCN=IELMNT+ISIZE+2
      IF (NSBCKT.EQ.0) GO TO 10
      LOCT=NODPLC(ISBCKT+NSBCKT)
      LOC=NODPLC(LOCT+3)
      IF (LOC.NE.0) GO TO 20
      NODPLC(LOCT+3)=LOCN
      GO TO 60
   10 LOC=LOCATE(ID)
      IF (LOC.NE.0) GO TO 20
      LOCATE(ID)=LOCN
      GO TO 50
C
C  SEARCH LIST FOR A NAME MATCH
C
   20 LOCV=NODPLC(LOC+1)
      IF (XXOR(ANAM,VALUE(LOCV)).NE.0) GO TO 30
      IF (NUMALT.NE.0) GO TO 30
      IF (NSBCKT.EQ.0) GO TO 25
      IF (NODPLC(LOC-1).NE.ID) GO TO 30
   25 IF (NODPLC(LOC+2).EQ.NDEFIN) GO TO 200
      IF (IFORCE.EQ.0) GO TO 200
      WRITE (IOFILE,26) ANAM
   26 FORMAT('0*ERROR*:  ABOVE LINE ATTEMPTS TO REDEFINE ',A8/)
      NOGO=1
   30 IF (NODPLC(LOC).EQ.0) GO TO 40
      LOC=NODPLC(LOC)
      GO TO 20
C
C  RESERVE SPACE FOR THIS ELEMENT
C
   40 NODPLC(LOC)=LOCN
      IF (NSBCKT.NE.0) GO TO 60
   50 IF (NUMALT.EQ.0) JELCNT(ID)=JELCNT(ID)+1
   60 LOC=LOCN
      ITEMP=LOC+LNOD(ID)*NWD4-1
      LOCV=NXTEVN(ITEMP-1)+1
      ITEMP=LOCV-ITEMP
      KTMP=LNOD(ID)*NWD4+LVAL(ID)*NWD8+ITEMP
      CALL EXTMEM(IELMNT,KTMP)
      LOCV=(LOCV-1)/NWD8+1
      IPTR=0
      IF (NSBCKT.EQ.0) GO TO 80
      IPTR=ID
   80 IF (ID.LE.24) NODPLC(LOC+LNOD(ID)-2)=NUMALT
      NODPLC(LOC-1)=IPTR
      NODPLC(LOC)=0
      NODPLC(LOC+1)=LOCV
      VALUE(LOCV)=ANAM
C
C  BACKGROUND STORAGE
C
  100 NODPLC(LOC+2)=NDEFIN
      NWORD=LNOD(ID)-4
      IF (ID.LE.24) NWORD=NWORD-1
      IF (NWORD.LT.1) GO TO 120
      CALL ZERO4(NODPLC(LOC+3),NWORD)
  120 NWORD=LVAL(ID)-1
      IF (NWORD.LT.1) GO TO 200
      CALL ZERO8(VALUE(LOCV+1),NWORD)
      IF ((ID.GE.21).AND.(ID.LE.24)) CALL UNDEFI(VALUE(LOCV+1),NWORD)
C
C  EXIT
C
  200 RETURN
      END
