/* Copyright (C) 1992, Irisa, Indiana University,
   demo of the Sigma toolbox */
 /**************************************************************************
  *                                                                        *
  *   Programme de Test pour la ToolBox                                    *
  *                                                                        *
  *************************************************************************/

#include <stdio.h>
#include "macro.h"
#include "dependence.h"
#include "ext_lib.h"
#include "ext_low.h"
#include "ext_mid.h"
#include "ext_high.h"
FILE *finput;
FILE *outfile;
extern int Warning_count;
extern int DEBUG;
char Version[256];


/*
 *
 *  some stuf to control the args 
 *
 */


/* read the parameters value or check if here and return the value */

Read_Pres_Parameter_Value(s,argc, argv)
int argc;
char *argv[];
char *s;
{
  int i;

  for (i = 1 ; i<argc; i++)
    {
      if (strcmp(argv[i],s) == 0)
        { /* we found the parameter */
          return(1);
        }
    }
  return(0);
}

Read_int_Parameter_Value(s,argc, argv)
int argc;
char *argv[];
char *s;
{
  int i;

  for (i = 1 ; i<argc; i++)
    {
      if (strcmp(argv[i],s) == 0)
        { /* we found the parameter */

          if (i+1<argc)
            return(atoi(argv[i+1]));
          else
            printf ("Value missing for %s\n", s);
          return(-1);
        }
    }
  return(-1);
}

char *
Read_string_Parameter_Value(s,argc, argv)
int argc;
char *argv[];
char *s;
{
  int i;

  for (i = 1 ; i<argc; i++)
    {
      if (strcmp(argv[i],s) == 0)
        { /* we found the parameter */

          if (i+1<argc)
            return argv[i+1];
          else
            printf ("Value missing for %s\n", s);
          return(NULL);
        }
    }
  return(NULL);
}

Write_Preambule()
{
  strcpy(Version,"Test ToolBox  version 0.2 - 07/13/92");
  printf ("%s\n", Version);
}


 /*
  *
  *  main procedure
  *
  */

main(argc,argv)
int argc;
char *argv[];
{
   int temp,i;
   int l, loop;
   char *s, *s2,s3[256];
   PTR_BFND bif;
   PTR_SYMB symb;
   
   s = Read_string_Parameter_Value("-o",argc, argv);
   if (s != NULL)
     {
      outfile = fopen(s,"w");
    } else
      outfile = stdout;

 
  
   s = Read_string_Parameter_Value("-i",argc, argv);
   if (s != NULL)
     {
       /* if you just want to initialize the toolbox uses
          Init_Tool_Box() */
       Initialize_Project_Toolbox(s);
    } else
      {
        Initialize_Project_Toolbox("essai.proj");
      }

   
   s2 = Read_string_Parameter_Value("-symb",argc, argv);
   if (s2 != NULL)
     {
       s = Read_string_Parameter_Value("-func",argc, argv);
       if (s == NULL)
         Message("No function as an argument",0);
       if (s != NULL) 
         {
           if (get_global_function_header(s))
             {
               symb = get_function_symb(s2);
               switch(var_storage(symb,&bif))
                 {
                 case 0:
                   printf("symbole %s is a local var\n",s2);
                   break;
                 case 1:
                   printf("symbole %s is a parameter var\n",s2);
                   break;
                 case 2:
                   printf("symbole %s is a common var\n",s2);
                   break;
                 default:
                   printf("symbole %s is undefined\n",s2);
                 }
               exit(0);
             } else
               Message("Error function not found",0);
         }
     }
   


   s2 = Read_string_Parameter_Value("-line",argc, argv);
   if (s2 == NULL)
       Message("No line as an argument",0);
       

   s = Read_string_Parameter_Value("-func",argc, argv);
   if (s == NULL)
     Message("No function as an argument",0);
   if ((s != NULL) && (s2 == NULL))
     {
       if (get_global_function_header(s))
         {
           Init_Unparser();
           fprintf(outfile,"%s",filter(Tool_Unparse_Bif(PROJ_FIRST_BIF ())));
         } else
           Message("Error function not found",0);
     } else
       {
         s = Read_string_Parameter_Value("-file",argc, argv);
         if ((s != NULL) && (s2 != NULL))
           {
             bif = FindNearBifNode(s,atoi(s2));
             if (bif)
               {
                 fprintf(outfile,"-----------------------------------------------\n");
                 fprintf(outfile,"----------------line %d-------------------\n",atoi(s2));
                 fprintf(outfile,"-----------------------------------------------\n");
                 Init_Unparser();
                 fprintf(outfile,"%s",filter(Tool_Unparse_Bif(bif)));
               } else
                 Message("Error line not found",0);
           } else
             Message("No file as argument",0);
       }
   
         
   
   s = Read_string_Parameter_Value("-debug",argc, argv);
   if (s == NULL)
     {
       Write_Data_Base_For_Debug();
     } else
       {
         if (strcmp("yes", s) == 0)
           Write_Data_Base_For_Debug();
       }

   if (Warning_count != 0)
     printf ("You got %d Warning\n", Warning_count);
   exit (0);
}
