      SUBROUTINE MATLOC
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     THIS ROUTINE STORES THE LOCATIONS OF THE VARIOUS MATRIX TERMS TO
C WHICH THE DIFFERENT CIRCUIT ELEMENTS CONTRIBUTE.
C
C SPICE VERSION 2G.6  SCCSID=TABINF 3/15/83
      COMMON /TABINF/ IELMNT,ISBCKT,NSBCKT,IUNSAT,NUNSAT,ITEMPS,NUMTEM,
     1   ISENS,NSENS,IFOUR,NFOUR,IFIELD,ICODE,IDELIM,ICOLUM,INSIZE,
     2   JUNODE,LSBKPT,NUMBKP,IORDER,JMNODE,IUR,IUC,ILC,ILR,NUMOFF,ISR,
     3   NMOFFC,ISEQ,ISEQ1,NEQN,NODEVS,NDIAG,ISWAP,IEQUA,MACINS,LVNIM1,
     4   LX0,LVN,LYNL,LYU,LYL,LX1,LX2,LX3,LX4,LX5,LX6,LX7,LD0,LD1,LTD,
     5   IMYNL,IMVN,LCVN,NSNOD,NSMAT,NSVAL,ICNOD,ICMAT,ICVAL,
     6   LOUTPT,LPOL,LZER,IRSWPF,IRSWPR,ICSWPF,ICSWPR,IRPT,JCPT,
     7   IROWNO,JCOLNO,NTTBR,NTTAR,LVNTMP
C SPICE VERSION 2G.6  SCCSID=CIRDAT 3/15/83
      COMMON /CIRDAT/ LOCATE(50),JELCNT(50),NUNODS,NCNODS,NUMNOD,NSTOP,
     1   NUT,NLT,NXTRM,NDIST,NTLIN,IBR,NUMVS,NUMALT,NUMCYC
C SPICE VERSION 2G.6  SCCSID=STATUS 3/15/83
      COMMON /STATUS/ OMEGA,TIME,DELTA,DELOLD(7),AG(7),VT,XNI,EGFET,
     1   XMU,SFACTR,MODE,MODEDC,ICALC,INITF,METHOD,IORD,MAXORD,NONCON,
     2   ITERNO,ITEMNO,NOSOLV,MODAC,IPIV,IVMFLG,IPOSTP,ISCRCH,IOFILE
C SPICE VERSION 2G.6  SCCSID=AC 3/15/83
      COMMON /AC/ FSTART,FSTOP,FINCR,SKW2,REFPRL,SPW2,JACFLG,IDFREQ,
     1   INOISE,NOSPRT,NOSOUT,NOSIN,IDIST,IDPRT
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
C
C  RESISTORS
C
      LOC=LOCATE(1)
  690 IF ((LOC.EQ.0).OR.(NODPLC(LOC+8).NE.0)) GO TO 700
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODPLC(LOC+4)=INDXX(NODE1,NODE2)
      NODPLC(LOC+5)=INDXX(NODE2,NODE1)
      NODPLC(LOC+6)=INDXX(NODE1,NODE1)
      NODPLC(LOC+7)=INDXX(NODE2,NODE2)
      LOC=NODPLC(LOC)
      GO TO 690
C
C  CAPACITORS
C
  700 LOC=LOCATE(2)
  710 IF ((LOC.EQ.0).OR.(NODPLC(LOC+12).NE.0)) GO TO 720
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODPLC(LOC+5)=INDXX(NODE1,NODE2)
      NODPLC(LOC+6)=INDXX(NODE2,NODE1)
      NODPLC(LOC+10)=INDXX(NODE1,NODE1)
      NODPLC(LOC+11)=INDXX(NODE2,NODE2)
      LOC=NODPLC(LOC)
      GO TO 710
C
C  INDUCTORS
C
  720 LOC=LOCATE(3)
  730 IF ((LOC.EQ.0).OR.(NODPLC(LOC+14).NE.0)) GO TO 740
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      IBR=NODPLC(LOC+5)
      NODPLC(LOC+6)=INDXX(NODE1,IBR)
      NODPLC(LOC+7)=INDXX(NODE2,IBR)
      NODPLC(LOC+8)=INDXX(IBR,NODE1)
      NODPLC(LOC+9)=INDXX(IBR,NODE2)
      NODPLC(LOC+13)=INDXX(IBR,IBR)
      LOC=NODPLC(LOC)
      GO TO 730
C
C  MUTUAL INDUCTANCES
C
  740 LOC=LOCATE(4)
  750 IF ((LOC.EQ.0).OR.(NODPLC(LOC+6).NE.0)) GO TO 760
      NL1=NODPLC(LOC+2)
      NL2=NODPLC(LOC+3)
      IBR1=NODPLC(NL1+5)
      IBR2=NODPLC(NL2+5)
      NODPLC(LOC+4)=INDXX(IBR1,IBR2)
      NODPLC(LOC+5)=INDXX(IBR2,IBR1)
      LOC=NODPLC(LOC)
      GO TO 750
C
C  NONLINEAR VOLTAGE CONTROLLED CURRENT SOURCES
C
  760 LOC=LOCATE(5)
  762 IF ((LOC.EQ.0).OR.(NODPLC(LOC+13).NE.0)) GO TO 764
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      LNOD=NODPLC(LOC+6)
      LMAT=NODPLC(LOC+7)
      DO 763 I=1,NDIM
      NODE3=NODPLC(LNOD+1)
      NODE4=NODPLC(LNOD+2)
      LNOD=LNOD+2
      NODPLC(LMAT+1)=INDXX(NODE1,NODE3)
      NODPLC(LMAT+2)=INDXX(NODE1,NODE4)
      NODPLC(LMAT+3)=INDXX(NODE2,NODE3)
      NODPLC(LMAT+4)=INDXX(NODE2,NODE4)
      LMAT=LMAT+4
  763 CONTINUE
      LOC=NODPLC(LOC)
      GO TO 762
C
C  NONLINEAR VOLTAGE CONTROLLED VOLTAGE SOURCES
C
  764 LOC=LOCATE(6)
  766 IF ((LOC.EQ.0).OR.(NODPLC(LOC+14).NE.0)) GO TO 768
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      IBR=NODPLC(LOC+6)
      LNOD=NODPLC(LOC+7)
      LMAT=NODPLC(LOC+8)
      NODPLC(LMAT+1)=INDXX(NODE1,IBR)
      NODPLC(LMAT+2)=INDXX(NODE2,IBR)
      NODPLC(LMAT+3)=INDXX(IBR,NODE1)
      NODPLC(LMAT+4)=INDXX(IBR,NODE2)
      LMAT=LMAT+4
      DO 767 I=1,NDIM
      NODE3=NODPLC(LNOD+1)
      NODE4=NODPLC(LNOD+2)
      LNOD=LNOD+2
      NODPLC(LMAT+1)=INDXX(IBR,NODE3)
      NODPLC(LMAT+2)=INDXX(IBR,NODE4)
      LMAT=LMAT+2
  767 CONTINUE
      LOC=NODPLC(LOC)
      GO TO 766
C
C  NONLINEAR CURRENT CONTROLLED CURRENT SOURCES
C
  768 LOC=LOCATE(7)
  770 IF ((LOC.EQ.0).OR.(NODPLC(LOC+13).NE.0)) GO TO 772
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      LOCVS=NODPLC(LOC+6)
      LMAT=NODPLC(LOC+7)
      DO 771 I=1,NDIM
      LOCVST=NODPLC(LOCVS+I)
      IBR=NODPLC(LOCVST+6)
      NODPLC(LMAT+1)=INDXX(NODE1,IBR)
      NODPLC(LMAT+2)=INDXX(NODE2,IBR)
      LMAT=LMAT+2
  771 CONTINUE
      LOC=NODPLC(LOC)
      GO TO 770
C
C  NONLINEAR CURRENT CONTROLLED VOLTAGE SOURCES
C
  772 LOC=LOCATE(8)
  774 IF ((LOC.EQ.0).OR.(NODPLC(LOC+14).NE.0)) GO TO 780
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      IBR=NODPLC(LOC+6)
      LOCVS=NODPLC(LOC+7)
      LMAT=NODPLC(LOC+8)
      NODPLC(LMAT+1)=INDXX(NODE1,IBR)
      NODPLC(LMAT+2)=INDXX(NODE2,IBR)
      NODPLC(LMAT+3)=INDXX(IBR,NODE1)
      NODPLC(LMAT+4)=INDXX(IBR,NODE2)
      LMAT=LMAT+4
      DO 775 I=1,NDIM
      LOCVST=NODPLC(LOCVS+I)
      KBR=NODPLC(LOCVST+6)
      NODPLC(LMAT+I)=INDXX(IBR,KBR)
  775 CONTINUE
      LOC=NODPLC(LOC)
      GO TO 774
C
C  VOLTAGE SOURCES
C
  780 LOC=LOCATE(9)
  790 IF ((LOC.EQ.0).OR.(NODPLC(LOC+11).NE.0)) GO TO 800
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      IPTR=NODPLC(LOC+6)
      NODPLC(LOC+7)=INDXX(NODE1,IPTR)
      NODPLC(LOC+8)=INDXX(NODE2,IPTR)
      NODPLC(LOC+9)=INDXX(IPTR,NODE1)
      NODPLC(LOC+10)=INDXX(IPTR,NODE2)
      LOC=NODPLC(LOC)
      GO TO 790
C
C  DIODES
C
  800 LOC=LOCATE(11)
  810 IF ((LOC.EQ.0).OR.(NODPLC(LOC+16).NE.0)) GO TO 820
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODPLC(LOC+7)=INDXX(NODE1,NODE3)
      NODPLC(LOC+8)=INDXX(NODE2,NODE3)
      NODPLC(LOC+9)=INDXX(NODE3,NODE1)
      NODPLC(LOC+10)=INDXX(NODE3,NODE2)
      NODPLC(LOC+13)=INDXX(NODE1,NODE1)
      NODPLC(LOC+14)=INDXX(NODE2,NODE2)
      NODPLC(LOC+15)=INDXX(NODE3,NODE3)
      LOC=NODPLC(LOC)
      GO TO 810
C
C  TRANSISTORS
C
  820 LOC=LOCATE(12)
  830 IF ((LOC.EQ.0).OR.(NODPLC(LOC+36).NE.0)) GO TO 840
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODE4=NODPLC(LOC+5)
      NODE5=NODPLC(LOC+6)
      NODE6=NODPLC(LOC+7)
      NODE7=NODPLC(LOC+30)
      NODPLC(LOC+10)=INDXX(NODE1,NODE4)
      NODPLC(LOC+11)=INDXX(NODE2,NODE5)
      NODPLC(LOC+12)=INDXX(NODE3,NODE6)
      NODPLC(LOC+13)=INDXX(NODE4,NODE1)
      NODPLC(LOC+14)=INDXX(NODE4,NODE5)
      NODPLC(LOC+15)=INDXX(NODE4,NODE6)
      NODPLC(LOC+16)=INDXX(NODE5,NODE2)
      NODPLC(LOC+17)=INDXX(NODE5,NODE4)
      NODPLC(LOC+18)=INDXX(NODE5,NODE6)
      NODPLC(LOC+19)=INDXX(NODE6,NODE3)
      NODPLC(LOC+20)=INDXX(NODE6,NODE4)
      NODPLC(LOC+21)=INDXX(NODE6,NODE5)
      NODPLC(LOC+24)=INDXX(NODE1,NODE1)
      NODPLC(LOC+25)=INDXX(NODE2,NODE2)
      NODPLC(LOC+26)=INDXX(NODE3,NODE3)
      NODPLC(LOC+27)=INDXX(NODE4,NODE4)
      NODPLC(LOC+28)=INDXX(NODE5,NODE5)
      NODPLC(LOC+29)=INDXX(NODE6,NODE6)
      NODPLC(LOC+31)=INDXX(NODE7,NODE7)
      NODPLC(LOC+32)=INDXX(NODE4,NODE7)
      NODPLC(LOC+33)=INDXX(NODE7,NODE4)
      NODPLC(LOC+34)=INDXX(NODE2,NODE4)
      NODPLC(LOC+35)=INDXX(NODE4,NODE2)
      LOC=NODPLC(LOC)
      GO TO 830
C
C  JFETS
C
  840 LOC=LOCATE(13)
  850 IF ((LOC.EQ.0).OR.(NODPLC(LOC+25).NE.0)) GO TO 860
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODE4=NODPLC(LOC+5)
      NODE5=NODPLC(LOC+6)
      NODPLC(LOC+9)=INDXX(NODE1,NODE4)
      NODPLC(LOC+10)=INDXX(NODE2,NODE4)
      NODPLC(LOC+11)=INDXX(NODE2,NODE5)
      NODPLC(LOC+12)=INDXX(NODE3,NODE5)
      NODPLC(LOC+13)=INDXX(NODE4,NODE1)
      NODPLC(LOC+14)=INDXX(NODE4,NODE2)
      NODPLC(LOC+15)=INDXX(NODE4,NODE5)
      NODPLC(LOC+16)=INDXX(NODE5,NODE2)
      NODPLC(LOC+17)=INDXX(NODE5,NODE3)
      NODPLC(LOC+18)=INDXX(NODE5,NODE4)
      NODPLC(LOC+20)=INDXX(NODE1,NODE1)
      NODPLC(LOC+21)=INDXX(NODE2,NODE2)
      NODPLC(LOC+22)=INDXX(NODE3,NODE3)
      NODPLC(LOC+23)=INDXX(NODE4,NODE4)
      NODPLC(LOC+24)=INDXX(NODE5,NODE5)
      LOC=NODPLC(LOC)
      GO TO 850
C
C  MOSFETS
C
  860 LOC=LOCATE(14)
  870 IF ((LOC.EQ.0).OR.(NODPLC(LOC+33).NE.0)) GO TO 900
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODE4=NODPLC(LOC+5)
      NODE5=NODPLC(LOC+6)
      NODE6=NODPLC(LOC+7)
      NODPLC(LOC+10)=INDXX(NODE1,NODE5)
      NODPLC(LOC+11)=INDXX(NODE2,NODE4)
      NODPLC(LOC+12)=INDXX(NODE2,NODE5)
      NODPLC(LOC+13)=INDXX(NODE2,NODE6)
      NODPLC(LOC+14)=INDXX(NODE3,NODE6)
      NODPLC(LOC+15)=INDXX(NODE4,NODE2)
      NODPLC(LOC+16)=INDXX(NODE4,NODE5)
      NODPLC(LOC+17)=INDXX(NODE4,NODE6)
      NODPLC(LOC+18)=INDXX(NODE5,NODE1)
      NODPLC(LOC+19)=INDXX(NODE5,NODE2)
      NODPLC(LOC+20)=INDXX(NODE5,NODE4)
      NODPLC(LOC+21)=INDXX(NODE5,NODE6)
      NODPLC(LOC+22)=INDXX(NODE6,NODE2)
      NODPLC(LOC+23)=INDXX(NODE6,NODE3)
      NODPLC(LOC+24)=INDXX(NODE6,NODE4)
      NODPLC(LOC+25)=INDXX(NODE6,NODE5)
      NODPLC(LOC+27)=INDXX(NODE1,NODE1)
      NODPLC(LOC+28)=INDXX(NODE2,NODE2)
      NODPLC(LOC+29)=INDXX(NODE3,NODE3)
      NODPLC(LOC+30)=INDXX(NODE4,NODE4)
      NODPLC(LOC+31)=INDXX(NODE5,NODE5)
      NODPLC(LOC+32)=INDXX(NODE6,NODE6)
      LOC=NODPLC(LOC)
      GO TO 870
C
C  TRANSMISSION LINES
C
  900 LOC=LOCATE(17)
  910 IF ((LOC.EQ.0).OR.(NODPLC(LOC+33).NE.0)) GO TO 1000
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODE4=NODPLC(LOC+5)
      NI1=NODPLC(LOC+6)
      NI2=NODPLC(LOC+7)
      IBR1=NODPLC(LOC+8)
      IBR2=NODPLC(LOC+9)
      NODPLC(LOC+10)=INDXX(NODE1,NODE1)
      NODPLC(LOC+11)=INDXX(NODE1,NI1)
      NODPLC(LOC+12)=INDXX(NODE2,IBR1)
      NODPLC(LOC+13)=INDXX(NODE3,NODE3)
      NODPLC(LOC+14)=INDXX(NODE4,IBR2)
      NODPLC(LOC+15)=INDXX(NI1,NODE1)
      NODPLC(LOC+16)=INDXX(NI1,NI1)
      NODPLC(LOC+17)=INDXX(NI1,IBR1)
      NODPLC(LOC+18)=INDXX(NI2,NI2)
      NODPLC(LOC+19)=INDXX(NI2,IBR2)
      NODPLC(LOC+20)=INDXX(IBR1,NODE2)
      NODPLC(LOC+21)=INDXX(IBR1,NODE3)
      NODPLC(LOC+22)=INDXX(IBR1,NODE4)
      NODPLC(LOC+23)=INDXX(IBR1,NI1)
      NODPLC(LOC+24)=INDXX(IBR1,IBR2)
      NODPLC(LOC+25)=INDXX(IBR2,NODE1)
      NODPLC(LOC+26)=INDXX(IBR2,NODE2)
      NODPLC(LOC+27)=INDXX(IBR2,NODE4)
      NODPLC(LOC+28)=INDXX(IBR2,NI2)
      NODPLC(LOC+29)=INDXX(IBR2,IBR1)
      NODPLC(LOC+31)=INDXX(NODE3,NI2)
      NODPLC(LOC+32)=INDXX(NI2,NODE3)
      LOC=NODPLC(LOC)
      GO TO 910
C
C  FINISHED
C
 1000 RETURN
      END
