      SUBROUTINE MOSFET
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     THIS ROUTINE PROCESSES MOSFETS FOR DC AND TRANSIENT ANALYSES.
C
C SPICE VERSION 2G.6  SCCSID=TABINF 3/15/83
      COMMON /TABINF/ IELMNT,ISBCKT,NSBCKT,IUNSAT,NUNSAT,ITEMPS,NUMTEM,
     1   ISENS,NSENS,IFOUR,NFOUR,IFIELD,ICODE,IDELIM,ICOLUM,INSIZE,
     2   JUNODE,LSBKPT,NUMBKP,IORDER,JMNODE,IUR,IUC,ILC,ILR,NUMOFF,ISR,
     3   NMOFFC,ISEQ,ISEQ1,NEQN,NODEVS,NDIAG,ISWAP,IEQUA,MACINS,LVNIM1,
     4   LX0,LVN,LYNL,LYU,LYL,LX1,LX2,LX3,LX4,LX5,LX6,LX7,LD0,LD1,LTD,
     5   IMYNL,IMVN,LCVN,NSNOD,NSMAT,NSVAL,ICNOD,ICMAT,ICVAL,
     6   LOUTPT,LPOL,LZER,IRSWPF,IRSWPR,ICSWPF,ICSWPR,IRPT,JCPT,
     7   IROWNO,JCOLNO,NTTBR,NTTAR,LVNTMP
C SPICE VERSION 2G.6  SCCSID=CIRDAT 3/15/83
      COMMON /CIRDAT/ LOCATE(50),JELCNT(50),NUNODS,NCNODS,NUMNOD,NSTOP,
     1   NUT,NLT,NXTRM,NDIST,NTLIN,IBR,NUMVS,NUMALT,NUMCYC
C SPICE VERSION 2G.6  SCCSID=MOSARG 3/15/83
      COMMON /MOSARG/ VTO,BETA,GAMMA,PHI,PHIB,COX,XNSUB,XNFS,XD,XJ,XLD,
     1   XLAMDA,UO,UEXP,VBP,UTRA,VMAX,XNEFF,XL,XW,VBI,VON,VDSAT,QSPOF,
     2   BETA0,BETA1,CDRAIN,XQCO,XQC,FNARRW,FSHORT,LEV
C SPICE VERSION 2G.6  SCCSID=STATUS 3/15/83
      COMMON /STATUS/ OMEGA,TIME,DELTA,DELOLD(7),AG(7),VT,XNI,EGFET,
     1   XMU,SFACTR,MODE,MODEDC,ICALC,INITF,METHOD,IORD,MAXORD,NONCON,
     2   ITERNO,ITEMNO,NOSOLV,MODAC,IPIV,IVMFLG,IPOSTP,ISCRCH,IOFILE
C SPICE VERSION 2G.6  SCCSID=KNSTNT 3/15/83
      COMMON /KNSTNT/ TWOPI,XLOG2,XLOG10,ROOT2,RAD,BOLTZ,CHARGE,CTOK,
     1   GMIN,RELTOL,ABSTOL,VNTOL,TRTOL,CHGTOL,EPS0,EPSSIL,EPSOX,
     2   PIVTOL,PIVREL
C SPICE VERSION 2G.6  SCCSID=DEBUG 3/15/83
      COMMON/DEBUG/ IDEBUG(20)
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
C
C
      DIMENSION VBDO(1),VBSO(1),VGSO(1),VDSO(1),CDO(1),CBSO(1),CBDO(1),
     1   GMO(1),GDSO(1),GMBSO(1),GBDO(1),GBSO(1),
     2   QB(1),CQB(1),QG(1),CQG(1),QD(1),CQD(1),
     3   CGGBO(1),CGDBO(1),CGSBO(1),CBGBO(1),CBDBO(1),CBSBO(1),
     4   CGBO(1),CGDO(1),CGSO(1),VONO(1),VDSATO(1)
      DIMENSION QBD(1),CQBD(1),QBS(1),CQBS(1),
     1          QGS(1),CQGS(1),QGD(1),CQGD(1),QGB(1),CQGB(1)
      EQUIVALENCE (VBDO (1),VALUE( 1)),(VBSO (1),VALUE( 2)),
     1            (VGSO (1),VALUE( 3)),(VDSO (1),VALUE( 4)),
     2            (CDO  (1),VALUE( 5)),(CBSO (1),VALUE( 6)),
     3            (CBDO (1),VALUE( 7)),(GMO  (1),VALUE( 8)),
     4            (GDSO (1),VALUE( 9)),(GMBSO(1),VALUE(10)),
     5            (GBDO (1),VALUE(11)),(GBSO (1),VALUE(12)),
     6            (QB   (1),QGS  ( 1), VALUE(13)),
     7            (CQB  (1),CQGS ( 1), VALUE(14)),
     8            (QG   (1),QGD  ( 1), VALUE(15)),
     9            (CQG  (1),CQGD ( 1), VALUE(16)),
     A            (QD   (1),QGB  ( 1), VALUE(17)),
     B            (CQD  (1),CQGB ( 1), VALUE(18)),
     C            (CGGBO(1),CGBO  (1), VALUE(19)),
     D            (CGDBO(1),CGDO  (1), VALUE(20)),
     E            (CGSBO(1),CGSO  (1), VALUE(21)),
     F            (CBGBO(1),VONO  (1), VALUE(22)),
     G            (CBDBO(1),VDSATO(1), VALUE(23)),
     H            (CBSBO(1),           VALUE(24))
      EQUIVALENCE (QBD  (1),VALUE(25)),(CQBD (1),VALUE(26)),
     1            (QBS  (1),VALUE(27)),(CQBS (1),VALUE(28))
C
C
      LOC=LOCATE(14)
   10 IF ((LOC.EQ.0).OR.(NODPLC(LOC+33).NE.0)) RETURN
      LOCV=NODPLC(LOC+1)
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NODE3=NODPLC(LOC+4)
      NODE4=NODPLC(LOC+5)
      NODE5=NODPLC(LOC+6)
      NODE6=NODPLC(LOC+7)
      LOCM=NODPLC(LOC+8)
      IOFF=NODPLC(LOC+9)
      TYPE=NODPLC(LOCM+2)
      LOCM=NODPLC(LOCM+1)
      LOCT=NODPLC(LOC+26)
C
C  DC MODEL PARAMETERS
C
      XJ=VALUE(LOCM+27)
      XLD=VALUE(LOCM+28)
      XL=VALUE(LOCV+1)-2.0D0*XLD
      XW=VALUE(LOCV+2)
      DEVMOD=VALUE(LOCV+8)
      VTO=TYPE*VALUE(LOCM+2)
      VDSAT=TYPE*VALUE(LOCV+10)
      VINIT=VALUE(LOCM+43)
      AD=VALUE(LOCV+3)
      AS=VALUE(LOCV+4)
      PD=VALUE(LOCV+11)
      PS=VALUE(LOCV+12)
      IF (VALUE(LOCM+21).EQ.0.0D0.
     1   OR.AD.EQ.0.0D0.OR.AS.EQ.0.0D0) GO TO 12
      CDSAT=VALUE(LOCM+21)*AD
      CSSAT=VALUE(LOCM+21)*AS
      GO TO 15
   12 CDSAT=VALUE(LOCM+11)
      CSSAT=VALUE(LOCM+11)
   15 IF ((VALUE(LOCM+7).LE.0.0D0).AND.
     1              (VALUE(LOCM+8).LE.0.0D0)) GO TO 17
      GDPR=VALUE(LOCM+7)
      GSPR=VALUE(LOCM+8)
      GO TO 19
   17 GDPR=VALUE(LOCM+16)/VALUE(LOCV+13)
      GSPR=VALUE(LOCM+16)/VALUE(LOCV+14)
   19 COVLGS=VALUE(LOCM+13)*XW
      COVLGD=VALUE(LOCM+14)*XW
      COVLGB=VALUE(LOCM+15)*XL
      LEV=VALUE(LOCM+1)
C
C     MOS1, MOS2 AND MOS3 MODEL PARAMETERS
C
      BETA=VALUE(LOCM+3)*XW/XL
      GAMMA=VALUE(LOCM+4)
      PHI=VALUE(LOCM+5)
      XLAMDA=VALUE(LOCM+6)
      PHIB=VALUE(LOCM+12)
      COX=VALUE(LOCM+22)*XW*XL
      XNSUB=VALUE(LOCM+23)
      XNFS=VALUE(LOCM+25)
      UO=VALUE(LOCM+29)
      VBP=VALUE(LOCM+30)
      UEXP=VALUE(LOCM+31)
      UTRA=VALUE(LOCM+32)
      VBI=TYPE*VALUE(LOCM+44)
      XD=VALUE(LOCM+45)
      VMAX=VALUE(LOCM+33)
      XNEFF=VALUE(LOCM+34)
      XQCO=VALUE(LOCM+35)
      FNARRW=VALUE(LOCM+39)
      IF (LEV.EQ.3) FNARRW=FNARRW/XW
C
C     INITIALIZATION
C
      ICHECK=1
      IBYPAS=0
      GO TO (100,20,30,50,60,70), INITF
   20 IF (IOFF.NE.0) GO TO 40
      VDS=TYPE*VALUE(LOCV+5)
      VGS=TYPE*VALUE(LOCV+6)
      VBS=TYPE*VALUE(LOCV+7)
      IF (VDS.NE.0.0D0) GO TO 300
      IF (VGS.NE.0.0D0) GO TO 300
      IF (VBS.NE.0.0D0) GO TO 300
      IF ((MODE.EQ.1).AND.(MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 300
      VBS=VINIT
      VGS=VTO
      VDS=0.0D0
      GO TO 300
   30 IF (IOFF.EQ.0) GO TO 100
   40 VBS=0.0D0
      VGS=0.0D0
      VDS=0.0D0
      GO TO 300
   50 VBS=VBSO(LX0+LOCT)
      VGS=VGSO(LX0+LOCT)
      VDS=VDSO(LX0+LOCT)
      GO TO 300
   60 VBS=VBSO(LX1+LOCT)
      VGS=VGSO(LX1+LOCT)
      VDS=VDSO(LX1+LOCT)
      GO TO 300
   70 XFACT=DELTA/DELOLD(2)
      VBSO(LX0+LOCT)=VBSO(LX1+LOCT)
      VBS=(1.0D0+XFACT)*VBSO(LX1+LOCT)-XFACT*VBSO(LX2+LOCT)
      VGSO(LX0+LOCT)=VGSO(LX1+LOCT)
      VGS=(1.0D0+XFACT)*VGSO(LX1+LOCT)-XFACT*VGSO(LX2+LOCT)
      VDSO(LX0+LOCT)=VDSO(LX1+LOCT)
      VDS=(1.0D0+XFACT)*VDSO(LX1+LOCT)-XFACT*VDSO(LX2+LOCT)
      VBDO(LX0+LOCT)=VBSO(LX0+LOCT)-VDSO(LX0+LOCT)
      CDO(LX0+LOCT)=CDO(LX1+LOCT)
      CBSO(LX0+LOCT)=CBSO(LX1+LOCT)
      CBDO(LX0+LOCT)=CBDO(LX1+LOCT)
      GMO(LX0+LOCT)=GMO(LX1+LOCT)
      GDSO(LX0+LOCT)=GDSO(LX1+LOCT)
      GMBSO(LX0+LOCT)=GMBSO(LX1+LOCT)
      GBDO(LX0+LOCT)=GBDO(LX1+LOCT)
      GBSO(LX0+LOCT)=GBSO(LX1+LOCT)
      CGGBO(LX0+LOCT)=CGGBO(LX1+LOCT)
      CGDBO(LX0+LOCT)=CGDBO(LX1+LOCT)
      CGSBO(LX0+LOCT)=CGSBO(LX1+LOCT)
      CBGBO(LX0+LOCT)=CBGBO(LX1+LOCT)
      CBDBO(LX0+LOCT)=CBDBO(LX1+LOCT)
      CBSBO(LX0+LOCT)=CBSBO(LX1+LOCT)
      GO TO 110
C
C  COMPUTE NEW NONLINEAR BRANCH VOLTAGES
C
  100 VBS=TYPE*(VALUE(LVNIM1+NODE4)-VALUE(LVNIM1+NODE6))
      VGS=TYPE*(VALUE(LVNIM1+NODE2)-VALUE(LVNIM1+NODE6))
      VDS=TYPE*(VALUE(LVNIM1+NODE5)-VALUE(LVNIM1+NODE6))
  110 VBD=VBS-VDS
      VGD=VGS-VDS
      VGDO=VGSO(LX0+LOCT)-VDSO(LX0+LOCT)
      DELVBS=VBS-VBSO(LX0+LOCT)
      DELVBD=VBD-VBDO(LX0+LOCT)
      DELVGS=VGS-VGSO(LX0+LOCT)
      DELVDS=VDS-VDSO(LX0+LOCT)
      DELVGD=VGD-VGDO
      IF (DEVMOD.LT.0.0D0) GO TO 120
      CDHAT=CDO(LX0+LOCT)-GBDO(LX0+LOCT)*DELVBD+GMBSO(LX0+LOCT)*DELVBS
     1   +GMO(LX0+LOCT)*DELVGS+GDSO(LX0+LOCT)*DELVDS
      GO TO 130
  120 CDHAT=CDO(LX0+LOCT)-(GBDO(LX0+LOCT)-GMBSO(LX0+LOCT))*DELVBD
     1   -GMO(LX0+LOCT)*DELVGD+GDSO(LX0+LOCT)*DELVDS
  130 CBHAT=CBSO(LX0+LOCT)+CBDO(LX0+LOCT)+GBDO(LX0+LOCT)*DELVBD
     1   +GBSO(LX0+LOCT)*DELVBS
C
C  BYPASS IF SOLUTION HAS NOT CHANGED
C
      IF (INITF.EQ.6) GO TO 200
      TOL=RELTOL*MAX(ABS(VBS),ABS(VBSO(LX0+LOCT)))+VNTOL
      IF (ABS(DELVBS).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(VBD),ABS(VBDO(LX0+LOCT)))+VNTOL
      IF (ABS(DELVBD).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(VGS),ABS(VGSO(LX0+LOCT)))+VNTOL
      IF (ABS(DELVGS).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(VDS),ABS(VDSO(LX0+LOCT)))+VNTOL
      IF (ABS(DELVDS).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(CDHAT),ABS(CDO(LX0+LOCT)))+ABSTOL
      IF (ABS(CDHAT-CDO(LX0+LOCT)).GE.TOL) GO TO 200
      TOL=RELTOL*MAX(ABS(CBHAT),ABS(CBSO(LX0+LOCT)+CBDO(LX0+LOCT)))
     1   +ABSTOL
      IF (ABS(CBHAT-(CBSO(LX0+LOCT)+CBDO(LX0+LOCT))).GE.TOL) GO TO 200
      VBS=VBSO(LX0+LOCT)
      VBD=VBDO(LX0+LOCT)
      VGS=VGSO(LX0+LOCT)
      VDS=VDSO(LX0+LOCT)
      VGD=VGS-VDS
      VGB=VGS-VBS
      CD=CDO(LX0+LOCT)
      CBS=CBSO(LX0+LOCT)
      CBD=CBDO(LX0+LOCT)
      CDRAIN=DEVMOD*(CD+CBD)
      GM=GMO(LX0+LOCT)
      GDS=GDSO(LX0+LOCT)
      GMBS=GMBSO(LX0+LOCT)
      GBD=GBDO(LX0+LOCT)
      GBS=GBSO(LX0+LOCT)
      DEVMOD=VALUE(LOCV+8)
      IF (MODE.NE.1) GO TO 135
      IF ((MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 135
      IF (XQCO.GT.0.5D0) GO TO 742
      GO TO 850
  135 IF (XQCO.LE.0.5D0) GO TO 140
      CGB=CGBO(LX0+LOCT)
      CGD=CGDO(LX0+LOCT)
      CGS=CGSO(LX0+LOCT)
      VGS1=VGSO(LX1+LOCT)
      VGB1=VGS1-VBSO(LX1+LOCT)
      VGD1=VGS1-VDSO(LX1+LOCT)
      GO TO 735
  140 CGGB=CGGBO(LX0+LOCT)
      CGDB=CGDBO(LX0+LOCT)
      CGSB=CGSBO(LX0+LOCT)
      CBGB=CBGBO(LX0+LOCT)
      CBDB=CBDBO(LX0+LOCT)
      CBSB=CBSBO(LX0+LOCT)
      XQC=VALUE(LOCV+15)
      IBYPAS=1
      GO TO 755
C
C  LIMIT NONLINEAR BRANCH VOLTAGES
C
  200 VON=TYPE*VALUE(LOCV+9)
      IF (VDSO(LX0+LOCT).LT.0.0D0) GO TO 205
      CALL FETLIM(VGS,VGSO(LX0+LOCT),VON)
      VDS=VGS-VGD
      CALL LIMVDS(VDS,VDSO(LX0+LOCT))
      VGD=VGS-VDS
      GO TO 210
  205 CALL FETLIM(VGD,VGDO,VON)
      VDS=VGS-VGD
      CALL LIMVDS(-VDS,-VDSO(LX0+LOCT))
      VGS=VGD+VDS
  210 IF (VDS.LT.0.0D0) GO TO 220
      VCRIT=VT*LOG(VT/(ROOT2*CSSAT))
      CALL PNJLIM(VBS,VBSO(LX0+LOCT),VT,VCRIT,ICHECK)
      VBD=VBS-VDS
      GO TO 300
  220 VCRIT=VT*LOG(VT/(ROOT2*CDSAT))
      CALL PNJLIM(VBD,VBDO(LX0+LOCT),VT,VCRIT,ICHECK)
      VBS=VBD+VDS
C
C  DETERMINE DC CURRENT AND DERIVATIVES
C
  300 VBD=VBS-VDS
      VGD=VGS-VDS
      VGB=VGS-VBS
      IF (VBS.GT.0.0D0) GO TO 310
      GBS=CSSAT/VT
      CBS=GBS*VBS
      GBS=GBS+GMIN
      GO TO 320
  310 EVBS=EXP(VBS/VT)
      GBS=CSSAT*EVBS/VT+GMIN
      CBS=CSSAT*(EVBS-1.0D0)
  320 IF (VBD.GT.0.0D0) GO TO 330
      GBD=CDSAT/VT
      CBD=GBD*VBD
      GBD=GBD+GMIN
      GO TO 400
  330 EVBD=EXP(VBD/VT)
      GBD=CDSAT*EVBD/VT+GMIN
      CBD=CDSAT*(EVBD-1.0D0)
C
C  COMPUTE DRAIN CURRENT AND DERIVATIVES
C
  400 IF (VDS.LT.0.0D0) GO TO 450
C
C  NORMAL MODE
C
      DEVMOD=1.0D0
      VALUE(LOCV+8)=DEVMOD
      GO TO (405,410,415), LEV
  405 CALL MOSEQ1(VDS,VBS,VGS,GM,GDS,GMBS)
      GO TO 460
  410 CALL MOSEQ2(VDS,VBS,VGS,GM,GDS,GMBS,
     1   QGATE,QCHAN,QBULK,CGGB,CGDB,CGSB,CBGB,CBDB,CBSB)
      GO TO 460
  415 CALL MOSEQ3(VDS,VBS,VGS,GM,GDS,GMBS,
     1   QGATE,QCHAN,QBULK,CGGB,CGDB,CGSB,CBGB,CBDB,CBSB)
      GO TO 460
C
C  INVERSE MODE
C
  450 DEVMOD=-1.0D0
      VALUE(LOCV+8)=DEVMOD
      GO TO (452,453,454), LEV
  452 CALL MOSEQ1(-VDS,VBD,VGD,GM,GDS,GMBS)
      GO TO 460
  453 CALL MOSEQ2(-VDS,VBD,VGD,GM,GDS,GMBS,
     1   QGATE,QCHAN,QBULK,CGGB,CGSB,CGDB,CBGB,CBSB,CBDB)
      GO TO 460
  454 CALL MOSEQ3(-VDS,VBD,VGD,GM,GDS,GMBS,
     1   QGATE,QCHAN,QBULK,CGGB,CGSB,CGDB,CBGB,CBSB,CBDB)
  460 VALUE(LOCV+9)=TYPE*VON
      VALUE(LOCV+10)=TYPE*VDSAT
      IF (XQCO.LE.0.5D0) VALUE(LOCV+15)=XQC
C
C  COMPUTE EQUIVALENT DRAIN CURRENT SOURCE
C
  490 CD=DEVMOD*CDRAIN-CBD
      IF (MODE.NE.1) GO TO 500
      IF ((MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 500
      IF (INITF.EQ.4) GO TO 500
      GO TO 650
C
C  CHARGE STORAGE ELEMENTS
C
C.. BULK-DRAIN AND BULK-SOURCE DEPLETION CAPACITANCES
C
  500 CZBD=0.0D0
      CZBS=0.0D0
      CZBDSW=0.0D0
      CZBSSW=0.0D0
      IF ((VALUE(LOCM+9).EQ.0.0D0).OR.(VALUE(LOCM+10).EQ.0.0D0))
     1   GO TO 505
      CZBD=VALUE(LOCM+9)
      CZBS=VALUE(LOCM+10)
      GO TO 510
  505 IF (VALUE(LOCM+17).EQ.0.0D0) GO TO 510
      CZBD=VALUE(LOCM+17)*AD
      CZBS=VALUE(LOCM+17)*AS
  510 IF (VALUE(LOCM+19).EQ.0.0D0) GO TO 515
      CZBDSW=VALUE(LOCM+19)*PD
      CZBSSW=VALUE(LOCM+19)*PS
  515 PHIB=VALUE(LOCM+12)
      XMJ=VALUE(LOCM+18)
      XMJSW=VALUE(LOCM+20)
      TWOP=PHIB+PHIB
      FCPB=VALUE(LOCM+38)
      FCPB2=FCPB*FCPB
      F1=VALUE(LOCM+40)
      F2=VALUE(LOCM+41)
      F3=VALUE(LOCM+42)
      CZSF2=CZBS/F2
      CZSWF2=CZBSSW/F2
      CZDF2=CZBD/F2
      CZDWF2=CZBDSW/F2
      IF (VBS.GE.FCPB) GO TO 520
      ARG=1.0D0-VBS/PHIB
      SARG=EXP(-XMJ*LOG(ARG))
      SARGSW=EXP(-XMJSW*LOG(ARG))
      QBS(LX0+LOCT)=PHIB*(CZBS*(1.0D0-ARG*SARG)/(1.0D0-XMJ)
     1                +CZBSSW*(1.0D0-ARG*SARGSW)/(1.0D0-XMJSW))
      CAPBS=CZBS*SARG+CZBSSW*SARGSW
      GO TO 525
  520 QBS(LX0+LOCT)=F1*(CZBS+CZBSSW)+F3*(VBS-FCPB)*(CZSF2+CZSWF2)
     1    +(VBS*VBS-FCPB*FCPB)*(CZSF2*XMJ+CZSWF2*XMJSW)
      CAPBS=F3*(CZSF2+CZSWF2)+VBS/PHIB*(CZSF2*XMJ+CZSWF2*XMJSW)
  525 IF (VBD.GE.FCPB) GO TO 530
      ARG=1.0D0-VBD/PHIB
      SARG=EXP(-XMJ*LOG(ARG))
      SARGSW=EXP(-XMJSW*LOG(ARG))
      QBD(LX0+LOCT)=PHIB*(CZBD*(1.0D0-ARG*SARG)/(1.0D0-XMJ)
     1              +CZBDSW*(1.0D0-ARG*SARGSW)/(1.0D0-XMJSW))
      CAPBD=CZBD*SARG+CZBDSW*SARGSW
      GO TO 560
  530 QBD(LX0+LOCT)=F1*(CZBD+CZBDSW)+F3*(VBD-FCPB)*(CZDF2+CZDWF2)
     1    +(VBD*VBD-FCPB*FCPB)*(CZDF2*XMJ+CZDWF2*XMJSW)
      CAPBD=F3*(CZDF2+CZDWF2)+VBD/PHIB*(CZDF2*XMJ+CZDWF2*XMJSW)
C
  560 IF (XQCO.LE.0.5D0) GO TO 650
      IF ((MODE.EQ.1).AND.(MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 650
      IF (INITF.NE.4) GO TO 600
      GO TO 705
C
CC    CALCULATE EQUIVALENT CONDUCTANCES AND CURRENTS FOR
CC    DEPLETION CAPACITORS
C
  600 IF (INITF.NE.5) GO TO 610
      QBD(LX1+LOCT)=QBD(LX0+LOCT)
      QBS(LX1+LOCT)=QBS(LX0+LOCT)
  610 CALL INTGR8(GEQ,CEQ,CAPBD,LOCT+24)
      GBD=GBD+GEQ
      CBD=CBD+CQBD(LX0+LOCT)
      CD=CD-CQBD(LX0+LOCT)
      CALL INTGR8(GEQ,CEQ,CAPBS,LOCT+26)
      GBS=GBS+GEQ
      CBS=CBS+CQBS(LX0+LOCT)
      IF (INITF.NE.5) GO TO 650
      CQBD(LX1+LOCT)=CQBD(LX0+LOCT)
      CQBS(LX1+LOCT)=CQBS(LX0+LOCT)
C
C  CHECK CONVERGENCE
C
  650 IF (INITF.NE.3) GO TO 660
      IF (IOFF.NE.0) GO TO 680
  660 IF (ICHECK.EQ.1) GO TO 670
      TOL=RELTOL*MAX(ABS(CDHAT),ABS(CD))+ABSTOL
      IF (ABS(CDHAT-CD).GE.TOL) GO TO 670
      TOL=RELTOL*MAX(ABS(CBHAT),ABS(CBS+CBD))+ABSTOL
      IF (ABS(CBHAT-(CBS+CBD)).LE.TOL) GO TO 680
  670 NONCON=NONCON+1
  680 VBSO(LX0+LOCT)=VBS
      VBDO(LX0+LOCT)=VBD
      VGSO(LX0+LOCT)=VGS
      VDSO(LX0+LOCT)=VDS
      CDO(LX0+LOCT)=CD
      CBSO(LX0+LOCT)=CBS
      CBDO(LX0+LOCT)=CBD
      GMO(LX0+LOCT)=GM
      GDSO(LX0+LOCT)=GDS
      GMBSO(LX0+LOCT)=GMBS
      GBDO(LX0+LOCT)=GBD
      GBSO(LX0+LOCT)=GBS
      IF (XQCO.LE.0.5D0) GO TO 690
      VONO(LX0+LOCT)=VON
      VDSATO(LX0+LOCT)=VDSAT
      GO TO 700
  690 CGGBO(LX0+LOCT)=CGGB
      CGDBO(LX0+LOCT)=CGDB
      CGSBO(LX0+LOCT)=CGSB
      CBGBO(LX0+LOCT)=CBGB
      CBDBO(LX0+LOCT)=CBDB
      CBSBO(LX0+LOCT)=CBSB
      GO TO 750
C
C     XQCO > 0.5D0 USE MEYER"S CAPACITOR MODEL
C
  700 IF (MODE.NE.1) GO TO 705
      IF ((MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 705
      IF (INITF.EQ.4) GO TO 705
      GO TO 742
C
C     CALCULATE MEYER'S CAPACITORS
C
  705 VON1=VON
      VGS1=VGS
      VGD1=VGD
      VGB1=VGS-VBS
      VDSAT1=VDSAT
      IF ((MODE.NE.2).OR.(INITF.EQ.5)) GO TO 710
      VON1=VONO(LX1+LOCT)
      VGS1=VGSO(LX1+LOCT)
      VGD1=VGS1-VDSO(LX1+LOCT)
      VGB1=VGS1-VBSO(LX1+LOCT)
      VDSAT1=VDSATO(LX1+LOCT)
  710 IF (DEVMOD.LT.0.0D0) GO TO 715
      CALL CMEYER (VGS1,VGD1,VGB1,VON1,VDSAT1,VGS,VGD,VGB,
     1   COVLGS,COVLGD,COVLGB,CGS1,CGD1,CGB1,CGS,CGD,CGB)
      GO TO 720
  715 CALL CMEYER (VGD1,VGS1,VGB1,VON1,VDSAT1,VGD,VGS,VGB,
     1   COVLGD,COVLGS,COVLGB,CGD1,CGS1,CGB1,CGD,CGS,CGB)
  720 CGS=0.5D0*(CGS+CGS1)
      CGD=0.5D0*(CGD+CGD1)
      CGB=0.5D0*(CGB+CGB1)
C
C     STORE SMALL-SIGNAL PARAMETERS (FOR MEYER"S MODEL)
C
      IF (MODE.NE.1) GO TO 730
      IF (INITF.NE.4) GO TO 730
      VALUE(LX0+LOCT+24)=CAPBD
      VALUE(LX0+LOCT+26)=CAPBS
      VALUE(LX0+LOCT+12)=CGS-COVLGS
      VALUE(LX0+LOCT+14)=CGD-COVLGD
      VALUE(LX0+LOCT+16)=CGB-COVLGB
      GO TO 1000
CC
  730 IF (INITF.NE.6) GO TO 735
      QGS(LX0+LOCT)=(1.0D0+XFACT)*QGS(LX1+LOCT)-XFACT*QGS(LX2+LOCT)
      QGD(LX0+LOCT)=(1.0D0+XFACT)*QGD(LX1+LOCT)-XFACT*QGD(LX2+LOCT)
      QGB(LX0+LOCT)=(1.0D0+XFACT)*QGB(LX1+LOCT)-XFACT*QGB(LX2+LOCT)
      GO TO 745
  735 QGS(LX0+LOCT)=(VGS-VGS1)*CGS
      QGD(LX0+LOCT)=(VGD-VGD1)*CGD
      QGB(LX0+LOCT)=(VGB-VGB1)*CGB
      IF((MODE.NE.2).OR.(INITF.EQ.5))GO TO 740
      QGS(LX0+LOCT)=QGS(LX0+LOCT)+QGS(LX1+LOCT)
      QGD(LX0+LOCT)=QGD(LX0+LOCT)+QGD(LX1+LOCT)
      QGB(LX0+LOCT)=QGB(LX0+LOCT)+QGB(LX1+LOCT)
  740 IF((MODE.EQ.1).AND.(MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 742
      IF (INITF.NE.5) GO TO 745
      QGS(LX0+LOCT)=CGS*VGS
      QGD(LX0+LOCT)=CGD*VGD
      QGB(LX0+LOCT)=CGB*VGB
      QGS(LX1+LOCT)=QGS(LX0+LOCT)
      QGD(LX1+LOCT)=QGD(LX0+LOCT)
      QGB(LX1+LOCT)=QGB(LX0+LOCT)
C
C     INITIALIZE TO ZERO CHARGE CONDUCTANCES AND CURRENT
C
  742 GCGS=0.0D0
      CEQGS=0.0D0
      GCGD=0.0D0
      CEQGD=0.0D0
      GCGB=0.0D0
      CEQGB=0.0D0
      GO TO  870
CC
 745  IF(CGS.EQ.0.0D0) VALUE(LX0+LOCT+13)=0.0D0
      IF(CGD.EQ.0.0D0) VALUE(LX0+LOCT+15)=0.0D0
      IF(CGB.EQ.0.0D0) VALUE(LX0+LOCT+17)=0.0D0
CC
CC    CALCULATE EQUIVALENT CONDUCTANCES AND CURRENTS FOR
CC    MEYER"S CAPACITORS
CC
      CALL INTGR8(GCGS,CEQGS,CGS,LOCT+12)
      CALL INTGR8(GCGD,CEQGD,CGD,LOCT+14)
      CALL INTGR8(GCGB,CEQGB,CGB,LOCT+16)
      CEQGS=CEQGS-GCGS*VGS+AG(1)*QGS(LX0+LOCT)
      CEQGD=CEQGD-GCGD*VGD+AG(1)*QGD(LX0+LOCT)
      CEQGB=CEQGB-GCGB*VGB+AG(1)*QGB(LX0+LOCT)
      IF (INITF.NE.5) GO TO 870
      CQGS(LX1+LOCT)=CQGS(LX0+LOCT)
      CQGD(LX1+LOCT)=CQGD(LX0+LOCT)
      CQGB(LX1+LOCT)=CQGB(LX0+LOCT)
      GO TO 870
C
C.. BULK AND CHANNEL CHARGE (PLUS OVERLAPS)
C
  750 IF (MODE.NE.1) GO TO 755
      IF ((MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 755
      IF (INITF.EQ.4) GO TO 755
      GO TO 850
  755 IF (DEVMOD.EQ.-1.0D0) GO TO 760
      CALL MOSCAP(VGD,VGS,VGB,COVLGD,COVLGS,COVLGB,
     1   CAPBD,CAPBS,CGGB,CGDB,CGSB,CBGB,CBDB,CBSB,
     2   GCGGB,GCGDB,GCGSB,GCBGB,GCBDB,GCBSB,
     3   GCDGB,GCDDB,GCDSB,GCSGB,GCSDB,GCSSB,
     4   QGATE,QCHAN,QBULK,QDRN,QSRC)
      GO TO 780
  760 CALL MOSCAP(VGS,VGD,VGB,COVLGS,COVLGD,COVLGB,
     1   CAPBS,CAPBD,CGGB,CGSB,CGDB,CBGB,CBSB,CBDB,
     2   GCGGB,GCGSB,GCGDB,GCBGB,GCBSB,GCBDB,
     3   GCSGB,GCSSB,GCSDB,GCDGB,GCDSB,GCDDB,
     4   QGATE,QCHAN,QBULK,QSRC,QDRN)
  780 IF (IBYPAS.EQ.1) GO TO 860
      QG(LX0+LOCT)=QGATE
      QD(LX0+LOCT)=QDRN-QBD(LX0+LOCT)
      QB(LX0+LOCT)=QBULK+QBD(LX0+LOCT)+QBS(LX0+LOCT)
C
C  STORE SMALL-SIGNAL PARAMETERS
C
  790 IF ((MODE.EQ.1).AND.(MODEDC.EQ.2).AND.(NOSOLV.NE.0)) GO TO 850
      IF (INITF.NE.4) GO TO 800
      VALUE(LX0+LOCT+18)=CGGB
      VALUE(LX0+LOCT+19)=CGDB
      VALUE(LX0+LOCT+20)=CGSB
      VALUE(LX0+LOCT+21)=CBGB
      VALUE(LX0+LOCT+22)=CBDB
      VALUE(LX0+LOCT+23)=CBSB
      VALUE(LX0+LOCT+24)=CAPBD
      VALUE(LX0+LOCT+26)=CAPBS
      GO TO 1000
C
C  TRANSIENT ANALYSIS
C
  800 IF (INITF.NE.5) GO TO 810
      QB(LX1+LOCT)=QB(LX0+LOCT)
      QG(LX1+LOCT)=QG(LX0+LOCT)
      QD(LX1+LOCT)=QD(LX0+LOCT)
C.. INTEGRATE QB
  810 CALL INTGR8(GEQ,CEQ,0.0D0,LOCT+12)
C.. INTEGRATE QG
      CALL INTGR8(GEQ,CEQ,0.0D0,LOCT+14)
C.. INTEGRATE QD
      CALL INTGR8(GEQ,CEQ,0.0D0,LOCT+16)
      GO TO 860
C
C     INITIALIZE TO ZERO CHARGE CONDUCTANCES AND CURRENT
C
  850 CEQQG=0.0D0
      CEQQB=0.0D0
      CEQQD=0.0D0
      GCDGB=0.0D0
      GCDDB=0.0D0
      GCDSB=0.0D0
      GCSGB=0.0D0
      GCSDB=0.0D0
      GCSSB=0.0D0
      GCGGB=0.0D0
      GCGDB=0.0D0
      GCGSB=0.0D0
      GCBGB=0.0D0
      GCBDB=0.0D0
      GCBSB=0.0D0
      GO TO 900
C
C     EVALUATE EQUIVALENT CHARGE CURRENTS
C
  860 CGATE=CQG(LX0+LOCT)
      CQBULK=CQB(LX0+LOCT)
      CQDRN=CQD(LX0+LOCT)
      CEQQG=CGATE-GCGGB*VGB+GCGDB*VBD+GCGSB*VBS
      CEQQB=CQBULK-GCBGB*VGB+GCBDB*VBD+GCBSB*VBS
      CEQQD=CQDRN-GCDGB*VGB+GCDDB*VBD+GCDSB*VBS
      IF (INITF.NE.5) GO TO 900
      CQB(LX1+LOCT)=CQB(LX0+LOCT)
      CQG(LX1+LOCT)=CQG(LX0+LOCT)
      CQD(LX1+LOCT)=CQD(LX0+LOCT)
      GO TO 900
C
CC   DO THE MAPPING FROM MEYER"S CAPACITOR MODEL INTO THE CHARGE
CC   ORIENTED MODEL
CC
  870 CEQQG=CEQGS+CEQGB+CEQGD
      CEQQB=-CEQGB
      CEQQD=-CEQGD
      GCBDB=0.0D0
      GCBSB=0.0D0
      GCDSB=0.0D0
      GCSDB=0.0D0
      GCGDB=-GCGD
      GCGSB=-GCGS
      GCBGB=-GCGB
      GCDGB=-GCGD
      GCSGB=-GCGS
      GCSSB=GCGS
      GCDDB=GCGD
      GCGGB=GCGD+GCGS+GCGB
C
C     STORE CHARGE STORAGE INFO FOR MEYER'S CAP IN LX TABLE
C
      CGBO(LX0+LOCT)=CGB
      CGSO(LX0+LOCT)=CGS
      CGDO(LX0+LOCT)=CGD
C
C  LOAD CURRENT VECTOR
C
  900 CEQBS=TYPE*(CBS-(GBS-GMIN)*VBS)
      CEQBD=TYPE*(CBD-(GBD-GMIN)*VBD)
      CEQQG=TYPE*CEQQG
      CEQQB=TYPE*CEQQB
      CEQQD=TYPE*CEQQD
      XNRM=1.0D0
      XREV=0.0D0
      IF (DEVMOD.LT.0.0D0) GO TO 910
      CDREQ=TYPE*(CDRAIN-GDS*VDS-GM*VGS-GMBS*VBS)
      GO TO 920
  910 XNRM=0.0D0
      XREV=1.0D0
      CDREQ=-TYPE*(CDRAIN-GDS*(-VDS)-GM*VGD-GMBS*VBD)
  920 VALUE(LVN+NODE2)=VALUE(LVN+NODE2)-CEQQG
      VALUE(LVN+NODE4)=VALUE(LVN+NODE4)-CEQBS-CEQBD-CEQQB
      VALUE(LVN+NODE5)=VALUE(LVN+NODE5)-CDREQ+CEQBD-CEQQD
      VALUE(LVN+NODE6)=VALUE(LVN+NODE6)+CDREQ+CEQBS
     1   +CEQQG+CEQQB+CEQQD
C
C  LOAD Y MATRIX
C
      LOCY=LVN+NODPLC(LOC+27)
      VALUE(LOCY)=VALUE(LOCY)+GDPR
      LOCY=LVN+NODPLC(LOC+28)
      VALUE(LOCY)=VALUE(LOCY)+GCGGB
      LOCY=LVN+NODPLC(LOC+29)
      VALUE(LOCY)=VALUE(LOCY)+GSPR
      LOCY=LVN+NODPLC(LOC+30)
      VALUE(LOCY)=VALUE(LOCY)+GBD+GBS-GCBGB-GCBDB-GCBSB
      LOCY=LVN+NODPLC(LOC+31)
      VALUE(LOCY)=VALUE(LOCY)+GDPR+GDS+GBD+XREV*(GM+GMBS)+GCDDB
      LOCY=LVN+NODPLC(LOC+32)
      VALUE(LOCY)=VALUE(LOCY)+GSPR+GDS+GBS+XNRM*(GM+GMBS)+GCSSB
      LOCY=LVN+NODPLC(LOC+10)
      VALUE(LOCY)=VALUE(LOCY)-GDPR
      LOCY=LVN+NODPLC(LOC+11)
      VALUE(LOCY)=VALUE(LOCY)-GCGGB-GCGDB-GCGSB
      LOCY=LVN+NODPLC(LOC+12)
      VALUE(LOCY)=VALUE(LOCY)+GCGDB
      LOCY=LVN+NODPLC(LOC+13)
      VALUE(LOCY)=VALUE(LOCY)+GCGSB
      LOCY=LVN+NODPLC(LOC+14)
      VALUE(LOCY)=VALUE(LOCY)-GSPR
      LOCY=LVN+NODPLC(LOC+15)
      VALUE(LOCY)=VALUE(LOCY)+GCBGB
      LOCY=LVN+NODPLC(LOC+16)
      VALUE(LOCY)=VALUE(LOCY)-GBD+GCBDB
      LOCY=LVN+NODPLC(LOC+17)
      VALUE(LOCY)=VALUE(LOCY)-GBS+GCBSB
      LOCY=LVN+NODPLC(LOC+18)
      VALUE(LOCY)=VALUE(LOCY)-GDPR
      LOCY=LVN+NODPLC(LOC+19)
      VALUE(LOCY)=VALUE(LOCY)+(XNRM-XREV)*GM+GCDGB
      LOCY=LVN+NODPLC(LOC+20)
      VALUE(LOCY)=VALUE(LOCY)-GBD+(XNRM-XREV)*GMBS-
     1   GCDGB-GCDDB-GCDSB
      LOCY=LVN+NODPLC(LOC+21)
      VALUE(LOCY)=VALUE(LOCY)-GDS-XNRM*(GM+GMBS)+GCDSB
      LOCY=LVN+NODPLC(LOC+22)
      VALUE(LOCY)=VALUE(LOCY)-(XNRM-XREV)*GM+GCSGB
      LOCY=LVN+NODPLC(LOC+23)
      VALUE(LOCY)=VALUE(LOCY)-GSPR
      LOCY=LVN+NODPLC(LOC+24)
      VALUE(LOCY)=VALUE(LOCY)-GBS-(XNRM-XREV)*GMBS-
     1   GCSGB-GCSDB-GCSSB
      LOCY=LVN+NODPLC(LOC+25)
      VALUE(LOCY)=VALUE(LOCY)-GDS-XREV*(GM+GMBS)+GCSDB
 1000 LOC=NODPLC(LOC)
      GO TO 10
      END
