      SUBROUTINE MOSQ2(VDS,VBS,VGS,VDSAT,VTH,VBIN,GAMASD,COX,PHI,
     1   QG,QC,QB,CGGB,CGDB,CGSB,CBGB,CBDB,CBSB)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     INITIALIZE CHARGES;
C     CHANGE REFERENCE VOLTAGES FOR CHARGE COMPUTATION
C
      QG=0.0D0
      QB=0.0D0
      VBD=VBS-VDS
      VGB=VGS-VBS
      VD=MAX(PHI-VBD,1.0D-8)
      VS=MAX(PHI-VBS,1.0D-8)
      VG=VGB-VBIN+PHI
      VSP5=SQRT(VS)
C
C     DETERMINE OPERATING REGION
C
      IF (VGS.LE.VTH) GO TO 1100
C
C     COMPUTE CHARGES FOR "ON" REGION
C
 1020 VSAT=VDSAT+VS
      VS2=VS*VS
      VS3=VS2*VS
      VS5=VS3*VS2
      VS1P5=VS*VSP5
      VS2P5=VS1P5*VS
 1025 IF (VD.GE.VSAT) GO TO 1035
      VE=VD
 1030 DVEDVD=1.0D0
      DVEDVG=0.0D0
      GO TO 1040
 1035 VE=VSAT
      DVEDVD=0.0D0
      DVEDVG=0.0D0
 1040 VE2=VE*VE
      VE3=VE2*VE
      VE5=VE2*VE3
      VEP5=SQRT(VE)
      VE1P5=VE*VEP5
      VE2P5=VE1P5*VE
      TERM0=VE+VS
      TERM1=VEP5+VSP5
      TERM2=VEP5*VSP5
      TERM3=VE2+VS2
      TERM4=VE*VS
      TERM5=TERM0*TERM1
      TERM6=(TERM3+TERM4)+TERM2*TERM0
      TERM7=(TERM3+TERM4)*TERM1
      TERM10=VEP5+0.5D0*VSP5
      TERM11=1.5D0*VE+VSP5*TERM10
      TERM12=2.0D0*VE1P5+VSP5*TERM11
      TERM20=0.5D0*VEP5+VSP5
      TERM21=1.5D0*VS+VEP5*TERM20
      TERM22=2.0D0*VS1P5+VEP5*TERM21
      ARGN=0.5D0*VG*TERM5-0.4D0*GAMASD*TERM6-TERM7/3.0D0
      ARGD=VG*TERM1-GAMASD*(TERM0+TERM2)/1.5D0-0.5D0*TERM1*TERM0
      ARGD2=ARGD*ARGD
      QG=COX*(VG-ARGN/ARGD)
      DGNDVE=0.5D0*VG*TERM11-0.4D0*GAMASD*TERM12-
     1   (2.5D0*VE2+VSP5*TERM12)/3.0D0
      DDDVE=0.5D0*VG-GAMASD*TERM10/1.5D0-0.5D0*TERM11
      DQGDVE=-COX/ARGD*(DGNDVE-(VG-QG/COX)*DDDVE)
      DGNDVS=0.5D0*VG*TERM21-0.4D0*GAMASD*TERM22-
     1   (2.5D0*VS2+VEP5*TERM22)/3.0D0
      DDDVS=0.5D0*VG-GAMASD*TERM20/1.5D0-0.5D0*TERM21
      CGDB=-COX/(ARGD*VEP5)*(DGNDVE-(VG-QG/COX)*DDDVE)*DVEDVD
      CGSB=-COX/(ARGD*VSP5)*(DGNDVS-(VG-QG/COX)*DDDVS)
      CGGB=COX*(1.0D0-TERM1/ARGD*(0.5D0*TERM0-VG+QG/COX))
      ARGN=VG*(TERM0+TERM2)/1.5D0-0.5D0*GAMASD*TERM5-0.4D0*TERM6
      DGNDVE=VG*TERM10/1.5D0-0.5D0*GAMASD*TERM11-0.4D0*TERM12
      DGNDVS=VG*TERM20/1.5D0-0.5D0*GAMASD*TERM21-0.4D0*TERM22
      QB=-GAMASD*COX*ARGN/ARGD
      CBDB=-COX/(VEP5*ARGD)*(QB/COX*DDDVE+GAMASD*DGNDVE)*DVEDVD
      CBSB=-COX/(VSP5*ARGD)*(QB/COX*DDDVS+GAMASD*DGNDVS)
      CBGB=-COX/ARGD*(GAMASD*(TERM0+TERM2)/1.5D0+QB/COX*TERM1)
      GO TO 2000
C
C  FINISH SPECIAL CASES
C
 1100 IF (VG.GT.0.0D0) GO TO 1110
      QG=COX*VG
      CGGB=COX
      GO TO 1120
 1110 GAMMA2=GAMASD*0.5D0
      SQARG=SQRT(GAMMA2*GAMMA2+VG)
      QG=GAMASD*COX*(SQARG-GAMMA2)
      CGGB=0.5D0*COX*GAMASD/SQARG
 1120 QB=-QG
      CBGB=-CGGB
      CGDB=0.0D0
      CGSB=0.0D0
      CBDB=0.0D0
      CBSB=0.0D0
C
C  FINISHED
C
 2000 QC=-(QG+QB)
 2050 RETURN
      END
