      SUBROUTINE NLCSRC
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     THIS ROUTINE LOADS THE NONLINEAR CONTROLLED SOURCES INTO THE
C COEFFICIENT MATRIX.
C
C SPICE VERSION 2G.6  SCCSID=TABINF 3/15/83
      COMMON /TABINF/ IELMNT,ISBCKT,NSBCKT,IUNSAT,NUNSAT,ITEMPS,NUMTEM,
     1   ISENS,NSENS,IFOUR,NFOUR,IFIELD,ICODE,IDELIM,ICOLUM,INSIZE,
     2   JUNODE,LSBKPT,NUMBKP,IORDER,JMNODE,IUR,IUC,ILC,ILR,NUMOFF,ISR,
     3   NMOFFC,ISEQ,ISEQ1,NEQN,NODEVS,NDIAG,ISWAP,IEQUA,MACINS,LVNIM1,
     4   LX0,LVN,LYNL,LYU,LYL,LX1,LX2,LX3,LX4,LX5,LX6,LX7,LD0,LD1,LTD,
     5   IMYNL,IMVN,LCVN,NSNOD,NSMAT,NSVAL,ICNOD,ICMAT,ICVAL,
     6   LOUTPT,LPOL,LZER,IRSWPF,IRSWPR,ICSWPF,ICSWPR,IRPT,JCPT,
     7   IROWNO,JCOLNO,NTTBR,NTTAR,LVNTMP
C SPICE VERSION 2G.6  SCCSID=CIRDAT 3/15/83
      COMMON /CIRDAT/ LOCATE(50),JELCNT(50),NUNODS,NCNODS,NUMNOD,NSTOP,
     1   NUT,NLT,NXTRM,NDIST,NTLIN,IBR,NUMVS,NUMALT,NUMCYC
C SPICE VERSION 2G.6  SCCSID=STATUS 3/15/83
      COMMON /STATUS/ OMEGA,TIME,DELTA,DELOLD(7),AG(7),VT,XNI,EGFET,
     1   XMU,SFACTR,MODE,MODEDC,ICALC,INITF,METHOD,IORD,MAXORD,NONCON,
     2   ITERNO,ITEMNO,NOSOLV,MODAC,IPIV,IVMFLG,IPOSTP,ISCRCH,IOFILE
C SPICE VERSION 2G.6  SCCSID=FLAGS 3/15/83
      COMMON /FLAGS/ IPRNTA,IPRNTL,IPRNTM,IPRNTN,IPRNTO,LIMTIM,LIMPTS,
     1   LVLCOD,LVLTIM,ITL1,ITL2,ITL3,ITL4,ITL5,ITL6,IGOOF,NOGO,KEOF
C SPICE VERSION 2G.6  SCCSID=KNSTNT 3/15/83
      COMMON /KNSTNT/ TWOPI,XLOG2,XLOG10,ROOT2,RAD,BOLTZ,CHARGE,CTOK,
     1   GMIN,RELTOL,ABSTOL,VNTOL,TRTOL,CHGTOL,EPS0,EPSSIL,EPSOX,
     2   PIVTOL,PIVREL
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
C
C  NONLINEAR VOLTAGE-CONTROLLED CURRENT SOURCES
C
      LOC=LOCATE(5)
   10 IF ((LOC.EQ.0).OR.(NODPLC(LOC+13).NE.0)) GO TO 100
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      LNOD=NODPLC(LOC+6)
      LMAT=NODPLC(LOC+7)
      LCOEF=NODPLC(LOC+8)
      CALL SIZMEM(NODPLC(LOC+8),NCOEF)
      LARG=NODPLC(LOC+9)
      LEXP=NODPLC(LOC+10)
      LIC=NODPLC(LOC+11)
      LOCT=NODPLC(LOC+12)+1
      ICHECK=0
      DO 20 I=1,NDIM
      CALL UPDATE(VALUE(LIC+I),LOCT,NODPLC(LNOD+1),NODPLC(LNOD+2),2,
     1   ICHECK)
      VALUE(LARG+I)=VALUE(LX0+LOCT)
      LOCT=LOCT+2
      LNOD=LNOD+2
   20 CONTINUE
      CALL EVPOLY(COLD,0,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=NODPLC(LOC+12)
      IF (ICHECK.EQ.1) GO TO 30
      IF (INITF.EQ.6) GO TO 30
      TOL=RELTOL*MAX(ABS(COLD),ABS(VALUE(LX0+LOCT)))+ABSTOL
      IF (ABS(COLD-VALUE(LX0+LOCT)).LT.TOL) GO TO 40
   30 NONCON=NONCON+1
   40 VALUE(LX0+LOCT)=COLD
      CEQ=COLD
      DO 50 I=1,NDIM
      CALL EVPOLY(GEQ,I,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=LOCT+2
      VALUE(LX0+LOCT)=GEQ
      CEQ=CEQ-GEQ*VALUE(LARG+I)
      LOCY=LVN+NODPLC(LMAT+1)
      VALUE(LOCY)=VALUE(LOCY)+GEQ
      LOCY=LVN+NODPLC(LMAT+2)
      VALUE(LOCY)=VALUE(LOCY)-GEQ
      LOCY=LVN+NODPLC(LMAT+3)
      VALUE(LOCY)=VALUE(LOCY)-GEQ
      LOCY=LVN+NODPLC(LMAT+4)
      VALUE(LOCY)=VALUE(LOCY)+GEQ
      LMAT=LMAT+4
   50 CONTINUE
      VALUE(LVN+NODE1)=VALUE(LVN+NODE1)-CEQ
      VALUE(LVN+NODE2)=VALUE(LVN+NODE2)+CEQ
      LOC=NODPLC(LOC)
      GO TO 10
C
C  NONLINEAR VOLTAGE CONTROLLED VOLTAGE SOURCES
C
  100 LOC=LOCATE(6)
  110 IF ((LOC.EQ.0).OR.(NODPLC(LOC+14).NE.0)) GO TO 200
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      IPTR=NODPLC(LOC+6)
      LNOD=NODPLC(LOC+7)
      LMAT=NODPLC(LOC+8)
      LCOEF=NODPLC(LOC+9)
      CALL SIZMEM(NODPLC(LOC+9),NCOEF)
      LARG=NODPLC(LOC+10)
      LEXP=NODPLC(LOC+11)
      LIC=NODPLC(LOC+12)
      LOCT=NODPLC(LOC+13)+2
      ICHECK=0
      DO 120 I=1,NDIM
      CALL UPDATE(VALUE(LIC+I),LOCT,NODPLC(LNOD+1),NODPLC(LNOD+2),2,
     1   ICHECK)
      VALUE(LARG+I)=VALUE(LX0+LOCT)
      LOCT=LOCT+2
      LNOD=LNOD+2
  120 CONTINUE
      CALL EVPOLY(VOLT,0,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=NODPLC(LOC+13)
      IF (ICHECK.EQ.1) GO TO 130
      IF (INITF.EQ.6) GO TO 130
      TOL=RELTOL*MAX(ABS(VOLT),ABS(VALUE(LX0+LOCT)))+VNTOL
      IF (ABS(VOLT-VALUE(LX0+LOCT)).LT.TOL) GO TO 140
  130 NONCON=NONCON+1
  140 VALUE(LX0+LOCT)=VOLT
      VALUE(LX0+LOCT+1)=VALUE(LVNIM1+IPTR)
      VEQ=VOLT
      LOCY=LVN+NODPLC(LMAT+1)
      VALUE(LOCY)=+1.0D0
      LOCY=LVN+NODPLC(LMAT+2)
      VALUE(LOCY)=-1.0D0
      LOCY=LVN+NODPLC(LMAT+3)
      VALUE(LOCY)=+1.0D0
      LOCY=LVN+NODPLC(LMAT+4)
      VALUE(LOCY)=-1.0D0
      LMAT=LMAT+4
      LOCT=LOCT+1
      DO 150 I=1,NDIM
      CALL EVPOLY(VGAIN,I,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=LOCT+2
      VALUE(LX0+LOCT)=VGAIN
      VEQ=VEQ-VGAIN*VALUE(LARG+I)
      LOCY=LVN+NODPLC(LMAT+1)
      VALUE(LOCY)=VALUE(LOCY)-VGAIN
      LOCY=LVN+NODPLC(LMAT+2)
      VALUE(LOCY)=VALUE(LOCY)+VGAIN
      LMAT=LMAT+2
  150 CONTINUE
      VALUE(LVN+IPTR)=VEQ
      LOC=NODPLC(LOC)
      GO TO 110
C
C  NONLINEAR CURRENT-CONTROLLED CURRENT SOURCES
C
  200 LOC=LOCATE(7)
  210 IF ((LOC.EQ.0).OR.(NODPLC(LOC+13).NE.0)) GO TO 300
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      LVS=NODPLC(LOC+6)
      LMAT=NODPLC(LOC+7)
      LCOEF=NODPLC(LOC+8)
      CALL SIZMEM(NODPLC(LOC+8),NCOEF)
      LARG=NODPLC(LOC+9)
      LEXP=NODPLC(LOC+10)
      LIC=NODPLC(LOC+11)
      LOCT=NODPLC(LOC+12)+1
      ICHECK=0
      DO 220 I=1,NDIM
      IPTR=NODPLC(LVS+I)
      IPTR=NODPLC(IPTR+6)
      CALL UPDATE(VALUE(LIC+I),LOCT,IPTR,1,2,ICHECK)
      VALUE(LARG+I)=VALUE(LX0+LOCT)
      LOCT=LOCT+2
  220 CONTINUE
      CALL EVPOLY(CSRC,0,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=NODPLC(LOC+12)
      IF (ICHECK.EQ.1) GO TO 230
      IF (INITF.EQ.6) GO TO 230
      TOL=RELTOL*MAX(ABS(CSRC),ABS(VALUE(LX0+LOCT)))+ABSTOL
      IF (ABS(CSRC-VALUE(LX0+LOCT)).LT.TOL) GO TO 240
  230 NONCON=NONCON+1
  240 VALUE(LX0+LOCT)=CSRC
      CEQ=CSRC
      DO 250 I=1,NDIM
      CALL EVPOLY(CGAIN,I,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=LOCT+2
      VALUE(LX0+LOCT)=CGAIN
      CEQ=CEQ-CGAIN*VALUE(LARG+I)
      LOCY=LVN+NODPLC(LMAT+1)
      VALUE(LOCY)=VALUE(LOCY)+CGAIN
      LOCY=LVN+NODPLC(LMAT+2)
      VALUE(LOCY)=VALUE(LOCY)-CGAIN
      LMAT=LMAT+2
  250 CONTINUE
      VALUE(LVN+NODE1)=VALUE(LVN+NODE1)-CEQ
      VALUE(LVN+NODE2)=VALUE(LVN+NODE2)+CEQ
      LOC=NODPLC(LOC)
      GO TO 210
C
C  NONLINEAR CURRENT CONTROLLED VOLTAGE SOURCES
C
  300 LOC=LOCATE(8)
  310 IF ((LOC.EQ.0).OR.(NODPLC(LOC+14).NE.0)) GO TO 1000
      NODE1=NODPLC(LOC+2)
      NODE2=NODPLC(LOC+3)
      NDIM=NODPLC(LOC+4)
      IBR=NODPLC(LOC+6)
      LVS=NODPLC(LOC+7)
      LMAT=NODPLC(LOC+8)
      LCOEF=NODPLC(LOC+9)
      CALL SIZMEM(NODPLC(LOC+9),NCOEF)
      LARG=NODPLC(LOC+10)
      LEXP=NODPLC(LOC+11)
      LIC=NODPLC(LOC+12)
      LOCT=NODPLC(LOC+13)+2
      ICHECK=0
      DO 320 I=1,NDIM
      IPTR=NODPLC(LVS+I)
      IPTR=NODPLC(IPTR+6)
      CALL UPDATE(VALUE(LIC+I),LOCT,IPTR,1,2,ICHECK)
      VALUE(LARG+I)=VALUE(LX0+LOCT)
      LOCT=LOCT+2
  320 CONTINUE
      CALL EVPOLY(VOLT,0,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=NODPLC(LOC+13)
      IF (ICHECK.EQ.1) GO TO 330
      IF (INITF.EQ.6) GO TO 330
      TOL=RELTOL*MAX(ABS(VOLT),ABS(VALUE(LX0+LOCT)))+VNTOL
      IF (ABS(VOLT-VALUE(LX0+LOCT)).LT.TOL) GO TO 340
  330 NONCON=NONCON+1
  340 VALUE(LX0+LOCT)=VOLT
      VALUE(LX0+LOCT+1)=VALUE(LVNIM1+IBR)
      VEQ=VOLT
      LOCY=LVN+NODPLC(LMAT+1)
      VALUE(LOCY)=+1.0D0
      LOCY=LVN+NODPLC(LMAT+2)
      VALUE(LOCY)=-1.0D0
      LOCY=LVN+NODPLC(LMAT+3)
      VALUE(LOCY)=+1.0D0
      LOCY=LVN+NODPLC(LMAT+4)
      VALUE(LOCY)=-1.0D0
      LMAT=LMAT+4
      LOCT=LOCT+1
      DO 350 I=1,NDIM
      CALL EVPOLY(TRANSR,I,LCOEF,NCOEF,LARG,NDIM,LEXP)
      LOCT=LOCT+2
      VALUE(LX0+LOCT)=TRANSR
      VEQ=VEQ-TRANSR*VALUE(LARG+I)
      LOCY=LVN+NODPLC(LMAT+I)
      VALUE(LOCY)=VALUE(LOCY)-TRANSR
  350 CONTINUE
      VALUE(LVN+IBR)=VEQ
      LOC=NODPLC(LOC)
      GO TO 310
C
C  FINISHED
C
 1000 RETURN
      END
