/* scale.f -- translated by f2c (version of 27 June 1992  14:50:07).
   You must link the resulting object file with the libraries:
	-lf2c -lm -lc   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal twopi, xlog2, xlog10, root2, rad, boltz, charge, ctok, gmin, 
	    reltol, abstol, vntol, trtol, chgtol, eps0, epssil, epsox, pivtol,
	     pivrel;
} knstnt_;

#define knstnt_1 knstnt_

/* Subroutine */ int scale_(xmin, xmax, n, xminp, xmaxp, del)
doublereal *xmin, *xmax;
integer *n;
doublereal *xminp, *xmaxp, *del;
{
    /* Initialized data */

    static doublereal vint[5] = { 1.,2.,5.,10.,20. };
    static doublereal eps = 1e-12;

    /* System generated locals */
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    double d_lg10(), exp();

    /* Local variables */
    doublereal a, b;
    integer i;
    doublereal xfact;
    integer m1, m2, np, nx;
    doublereal fm1, fm2;
    integer nal;


/*     THIS ROUTINE DETERMINES THE 'OPTIMAL' SCALE TO USE FOR THE PLOT OF 
*/
/* SOME OUTPUT VARIABLE. */


/*  ADAPTED FROM ALGORITHM 463 OF 'COLLECTED ALGORITHMS OF THE CACM' */

/* SPICE VERSION 2G.6  SCCSID=KNSTNT 3/15/83 */


/* ...  TRAP TOO-SMALL DATA SPREAD */
/* *********************************************************** */
/*  TEMPORILY CHECK 'EQUALITY' THIS WAY */
    if (*xmin == 0. && *xmax == 0.) {
	goto L4;
    }
/* Computing MAX */
    d__2 = abs(*xmin), d__3 = abs(*xmax);
    if ((d__1 = (*xmax - *xmin) / max(d__2,d__3), abs(d__1)) >= 1e-4) {
	goto L10;
    }
L4:
    if (*xmin >= 0.) {
	goto L5;
    }
    *xmax = *xmin * .5 + eps;
    *xmin = *xmin * 1.5 - eps;
    goto L10;
L5:
    *xmax = *xmin * 1.5 + eps;
    *xmin = *xmin * .5 - eps;
/* ...  FIND APPROXIMATE INTERVAL SIZE, NORMALIZED TO [1,10] */
L10:
    a = (*xmax - *xmin) / (doublereal) (*n);
    nal = (integer) d_lg10(&a);
    if (a < 1.) {
	--nal;
    }
    xfact = exp(knstnt_1.xlog10 * (doublereal) nal);
    b = a / xfact;
/* ...  FIND CLOSEST PERMISSIBLE INTERVAL SIZE */
    for (i = 1; i <= 3; ++i) {
	if (b < vint[i - 1] + eps) {
	    goto L30;
	}
/* L20: */
    }
    i = 4;
/* ...  COMPUTE INTERVAL SIZE */
L30:
    *del = vint[i - 1] * xfact;
    fm1 = *xmin / *del;
    m1 = (integer) fm1;
    if (fm1 < 0.) {
	--m1;
    }
    if ((d__1 = (doublereal) m1 + 1. - fm1, abs(d__1)) < eps) {
	++m1;
    }
/* ...  COMPUTE NEW MAXIMUM AND MINIMUM LIMITS */
    *xminp = *del * (doublereal) m1;
    fm2 = *xmax / *del;
    m2 = (integer) (fm2 + 1.);
    if (fm2 < -1.) {
	--m2;
    }
    if ((d__1 = fm2 + 1. - (doublereal) m2, abs(d__1)) < eps) {
	--m2;
    }
    *xmaxp = *del * (doublereal) m2;
    np = m2 - m1;
/* ...  CHECK WHETHER ANOTHER LOOP REQUIRED */
    if (np <= *n) {
	goto L40;
    }
    ++i;
    goto L30;
/* ...  DO FINAL ADJUSTMENTS AND CORRECT FOR ROUNDOFF ERROR(S) */
L40:
    nx = (*n - np) / 2;
/* Computing MIN */
    d__1 = *xmin, d__2 = *xminp - (doublereal) nx * *del;
    *xminp = min(d__1,d__2);
/* Computing MAX */
    d__1 = *xmax, d__2 = *xminp + (doublereal) (*n) * *del;
    *xmaxp = max(d__1,d__2);
    return 0;
} /* scale_ */

