/* setmem.f -- translated by f2c (version of 27 June 1992  14:50:07).
   You must link the resulting object file with the libraries:
	-lf2c -lm -lc   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal value[200000];
} blank_;

#define blank_1 blank_

struct {
    doublereal cpyknt;
    integer istack[1], lorg, icore, maxcor, maxuse, memavl, ldval, numblk, 
	    loctab, ltab, ifwa, nwoff, ntab, maxmem, memerr, nwd4, nwd8, 
	    nwd16;
} memmgr_;

#define memmgr_1 memmgr_

/* Table of constant values */

static integer c__1 = 1;
static integer c__6 = 6;

/* Subroutine */ int setmem_(ipntr, ksize)
integer *ipntr, *ksize;
{
    /* Local variables */
    extern integer locf_();
    integer nevn, icheck, ifamwa;
#define cvalue ((complex *)&blank_1)
    extern /* Subroutine */ int errmem_();
    extern integer nxtmem_();
    extern /* Subroutine */ int memory_();
    extern integer nxtevn_();


/*     THIS ROUTINE PERFORMS DYNAMIC MEMORY MANAGEMENT.  IT IS USED IN */
/*     SPICE2, AND USEABLE IN ANY PROGRAM. */

/*     MEMORY IS MANAGED WITHIN AN ARRAY SELECTED BY THE CALLING PROGRAM. 
*/
/*     ONE MAY EITHER DIMENSION THIS ARRAY TO THE 'MAXMEM' SIZE, OR MORE 
*/
/*     DESIRABLY, FIND THE ADDRESS OF THE FIRST AVAILABLE WORD OF MEMORY 
*/
/*     ABOVE YOUR PROGRAM, AND DIMENSION YOUR ARRAY TO '1'.  PASSING THE 
*/
/*     ADDRESS OF THE FIRST DATA WORD AVAILABLE PERMITS THE MANAGER TO */
/*     USE 'ILLEGAL' INDICES INTO THE DATA AREA. */

/*     THIS ROUTINE MUST HAVE ACCESS TO AN INTEGER FUNCTION CALLED 'LOCF' 
*/
/*     WHICH RETURNS THE ADDRESS OF ITS ARGUMENT.  ADDRESSES AS USED BY T 
*/
/*     PROGRAM REFER TO 'INTEGER' ADDRESSES, NOT BYTE ADDRESSES. */

/* ENTRY POINTS: */
/*      SETMEM - SET INITIAL MEMORY */
/*      GETM4  - GET BLOCK FOR TABLE OF INTEGERS */
/*      GETM8  - GET BLOCK FOR TABLE OF FLOATING POINT VARIABLES */
/*      GETM16 - GET BLOCK FOR TABLE OF COMPLEX VARIABLES */
/*      RELMEM - RELEASE PART OF BLOCK */
/*      EXTMEM - EXTEND SIZE OF EXISTING BLOCK */
/*      SIZMEM - DETERMINE SIZE OF EXISTING BLOCK */
/*      CLRMEM - RELEASE BLOCK */
/*      PTRMEM - RESET MEMORY POINTER */
/*      CRUNCH - FORCE MEMORY COMPACTION */
/*      AVLM4  - AMOUNT OF SPACE AVAILABLE (INTEGERS) */
/*      AVLM8  - AMOUNT OF SPACE AVAILABLE (REAL) */
/*      AVLM16 - AMOUNT OF SPACE AVAILABLE (COMPLEX) */

/* CALLING SEQUENCES: */
/*      CALL SETMEM(IMEM(1),MAXMEM) */
/*      CALL SETMEM(IMEM(1),MAXMEM,KFAMWA)  CDC MACHINES RUNNING UNDER */
/*                                          CALIDOSCOPE KFAMWA IS THE ADD 
*/
/*                                          OF THE FIRST AVAILABLE WORD */

/*      CALL GETM4 (IPNTR,BLKSIZ)  WHERE BLKSIZE IS THE NUMBER OF ENTRIES 
*/
/*      CALL GETM8 (IPNTR,BLKSIZ) */
/*      CALL GETM16(IPNTR,BLKSIZ) */
/*      CALL RELMEM(IPNTR,RELSIZ) */
/*      CALL EXTMEM(IPNTR,EXTSIZ)  EXTSIZ IS THE NUMBER OF ENTRIES TO BE 
*/
/*      CALL SIZMEM(IPNTR,BLKSIZ) */
/*      CALL CLRMEM(IPNTR) */
/*      CALL PTRMEM(IPNTR1,IPNTR2) */
/*      CALL AVLM4(ISPACE) */
/*      CALL AVLM8(ISPACE) */
/*      CALL AVLM16(ISPACE) */
/*      CALL CRUNCH */
/*      CALL SLPMEM(IPNTR,SLPSIZ)  EXPRESS DESIRE FOR *SLPSIZ* EXTRA ENTR 
*/


/* GENERAL COMMENTS: */
/*      FOR EACH BLOCK WHICH IS ALLOCATED, A MULTI-WORD ENTRY IS MAINTAIN 
*/
/* IN A TABLE KEPT IN HIGH MEMORY, OF THE FORM */

/*        WORD      CONTENTS */
/*        ----      -------- */

/*          1       INDEX OF IMEM(.) INTO ORIGIN OF BLOCK */
/*                    I.E. CONTENTS OF POINTER (USED FOR ERROR CHECK) */
/*          2       BLOCK SIZE (IN WORDS) */
/*          3       NUMBER OF WORDS IN USE */
/*          4       ADDRESS OF VARIABLE CONTAINING BLOCK ORIGIN */
/*          5       NUMBER OF WORDS USED PER TABLE ENTRY */
/*          6       SLOP SIZE (IN WORDS) */

/*      ALL ALLOCATED BLOCKS ARE AN 'EVEN' (NXTEVN) NUMBER OF WORDS IN LE 
*/
/* WHERE A 'WORD' IS THE STORAGE UNIT REQUIRED FOR AN 'INTEGER' VARIABLE. 
*/
/*      SINCE BLOCK REPOSITIONING MAY BE NECESSARY, THE CONVENTION THAT */

/* ONLY ONE VARIABLE CONTAIN A BLOCK ORIGIN SHOULD BE OBSERVED. */
/*      FOR *GETMEM*, *IPNTR* IS SET SUCH THAT *ARRAY(IPNTR+1)* IS THE */
/* FIRST WORD OF THE ALLOCATED BLOCK.  'IPNTR' IS SET TO ADDRESS THE FIRS 
*/
/* ENTRY OF THE TABLE WHEN USED WITH THE APPROPRIATE VARIABLE TYPE, I.E., 
*/
/* NODPLC(IPNTR+1), VALUE(IPNTR+1), OR CVALUE(IPNTR+1). */
/*      FOR *CLRMEM*, *IPNTR* IS SET TO 'INVALID' TO ENABLE RAPID DETECTI 
*/
/* OF AN ATTEMPT TO USE A CLEARED BLOCK. */
/*      IF ANY FATAL ERRORS ARE FOUND, A MESSAGE IS PRINTED AND A FLAG */
/* SET INHIBITING FURTHER ACTION UNTIL *SETMEM* IS CALLED.  (IN THIS */
/* CONTEXT, INSUFFICIENT MEMORY IS CONSIDERED A FATAL ERROR.) */
/*      THROUGHOUT THIS ROUTINE, *LDVAL* ALWAYS CONTAINS THE SUBSCRIPT OF 
*/
/* THE LAST ADDRESSABLE WORD OF MEMORY, *MEMAVL* ALWAYS CONTAINS THE */
/* NUMBER OF AVAILABLE WORDS OF MEMORY, *NUMBLK* ALWAYS CONTAINS THE */
/* NUMBER OF ALLOCATED BLOCKS, AND ISTACK(*LOCTAB* +1) ALWAYS CONTAINS */
/* THE FIRST WORD OF THE BLOCK TABLE. */

/* SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83 */
/* SPICE VERSION 2G.6  SCCSID=MEMMGR 3/15/83 */


/* ...  APPROXIMATE TIME REQUIRED TO COPY *NWORDS* INTEGER VALUES */

/*  NXTEVN ROUNDS THE NUMBER UP TO THE NEXT 'EVEN' VALUE.  THE VALUE */
/*  USED FOR THIS 'EVEN' NUMBER IS THE SMALLEST NUMBER INTO WHICH ONE */
/*  CAN DIVIDE NWD4,NWD8,AND NWD16. */


/*  NXTMEM  RETURNS NEXT HIGHER MEMORY SIZE */



/* ***  SETMEM - SET INITIAL MEMORY */

    /* Parameter adjustments */
    --ipntr;

    /* Function Body */
    memmgr_1.nwd4 = 1;
    memmgr_1.nwd8 = locf_(&blank_1.value[1]) - locf_(blank_1.value);
    memmgr_1.nwd16 = locf_(&cvalue[1]) - locf_(cvalue);
    memmgr_1.memerr = 0;
    nevn = nxtevn_(&c__1);
/*     CHECK THAT NXTEVN FUNCTION RETURNS A NUMBER DIVISIBLE BY */
/*     NWD4, NWD8, NWD16; ALSO CHECK THAT THE MEMORY INCREMENT */
/*     NXTMEM(.) IS AN INTEGER MULTIPLE OF NXTEVN(1) */
    icheck = nevn % memmgr_1.nwd4 + nevn % memmgr_1.nwd8 + nevn % 
	    memmgr_1.nwd16 + nxtmem_(&c__1) % nevn;
    if (icheck == 0) {
	goto L2;
    }
    memmgr_1.memerr = 1;
    errmem_(&c__6, &memmgr_1.memerr, &ipntr[1]);
L2:
    memmgr_1.cpyknt = 0.;
    ifamwa = locf_(&ipntr[1]);
    memmgr_1.maxmem = *ksize;
    memmgr_1.ntab = nxtevn_(&c__6);
/* ... ADD 'LORG' TO AN ADDRESS AND YOU GET THE 'ISTACK' INDEX TO THAT WOR
 */
    memmgr_1.lorg = 1 - locf_(memmgr_1.istack);
    memmgr_1.ifwa = ifamwa + memmgr_1.lorg - 1;
    memmgr_1.nwoff = locf_(&ipntr[1]) + memmgr_1.lorg - 1;
    memmgr_1.icore = nxtmem_(&c__1);
/* ... DON'T TAKE CHANCES, BACK OFF FROM 'END OF MEMORY' BY NXTEVN(1) */
    memmgr_1.ldval = memmgr_1.ifwa + nxtmem_(&c__1) - nxtevn_(&c__1);
    memmgr_1.memavl = memmgr_1.ldval - memmgr_1.ntab - memmgr_1.ifwa;
    memmgr_1.maxcor = 0;
    memmgr_1.maxuse = 0;
    memory_();
    if (memmgr_1.memerr != 0) {
	errmem_(&c__6, &memmgr_1.memerr, &ipntr[1]);
    }
    memmgr_1.numblk = 1;
    memmgr_1.loctab = memmgr_1.ldval - memmgr_1.ntab;
    memmgr_1.istack[memmgr_1.loctab] = 0;
    memmgr_1.istack[memmgr_1.loctab + 1] = memmgr_1.memavl;
    memmgr_1.istack[memmgr_1.loctab + 2] = 0;
    memmgr_1.istack[memmgr_1.loctab + 3] = -1;
    memmgr_1.istack[memmgr_1.loctab + 4] = 1;
    memmgr_1.istack[memmgr_1.loctab + 5] = 0;
    return 0;
} /* setmem_ */

#undef cvalue


