      SUBROUTINE TRUNC(DELNEW)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     THIS ROUTINE DETERMINES THE NEW TRANSIENT STEPSIZE BY EITHER
C CALLING TERR TO ESTIMATE THE LOCAL TRUNCATION ERROR, OR BY CHECKING
C ON THE NUMBER OF ITERATIONS NEEDED TO CONVERGE AT THE LAST TIMEPOINT.
C
C SPICE VERSION 2G.6  SCCSID=MISCEL 3/15/83
      COMMON /MISCEL/ ATIME,APROG(3),ADATE,ATITLE(10),DEFL,DEFW,DEFAD,
     1  DEFAS,RSTATS(50),IWIDTH,LWIDTH,NOPAGE
C SPICE VERSION 2G.6  SCCSID=CIRDAT 3/15/83
      COMMON /CIRDAT/ LOCATE(50),JELCNT(50),NUNODS,NCNODS,NUMNOD,NSTOP,
     1   NUT,NLT,NXTRM,NDIST,NTLIN,IBR,NUMVS,NUMALT,NUMCYC
C SPICE VERSION 2G.6  SCCSID=STATUS 3/15/83
      COMMON /STATUS/ OMEGA,TIME,DELTA,DELOLD(7),AG(7),VT,XNI,EGFET,
     1   XMU,SFACTR,MODE,MODEDC,ICALC,INITF,METHOD,IORD,MAXORD,NONCON,
     2   ITERNO,ITEMNO,NOSOLV,MODAC,IPIV,IVMFLG,IPOSTP,ISCRCH,IOFILE
C SPICE VERSION 2G.6  SCCSID=FLAGS 3/15/83
      COMMON /FLAGS/ IPRNTA,IPRNTL,IPRNTM,IPRNTN,IPRNTO,LIMTIM,LIMPTS,
     1   LVLCOD,LVLTIM,ITL1,ITL2,ITL3,ITL4,ITL5,ITL6,IGOOF,NOGO,KEOF
C SPICE VERSION 2G.6  SCCSID=TRAN 3/15/83
      COMMON /TRAN/ TSTEP,TSTOP,TSTART,DELMAX,TDMAX,FORFRE,JTRFLG
C SPICE VERSION 2G.6  SCCSID=BLANK 3/15/83
      COMMON /BLANK/ VALUE(200000)
      INTEGER NODPLC(64)
      COMPLEX CVALUE(32)
      EQUIVALENCE (VALUE(1),NODPLC(1),CVALUE(1))
C
C
      CALL TSEC(T1)
      IF (LVLTIM.NE.0) GO TO 5
      DELNEW=MIN(TSTEP,DELMAX)
      RETURN
    5 IF (LVLTIM.NE.1) GO TO 10
      DELNEW=DELTA
      IF (ITERNO.GT.ITL3) RETURN
      DELNEW=MIN(2.0D0*DELTA,TSTEP,DELMAX)
      RETURN
C
C  CAPACITORS
C
   10 DELNEW=1.0D20
      LOC=LOCATE(2)
   20 IF ((LOC.EQ.0).OR.(NODPLC(LOC+12).NE.0)) GO TO 30
      LOCT=NODPLC(LOC+8)
      CALL TERR(LOCT,DELNEW)
      LOC=NODPLC(LOC)
      GO TO 20
C
C  INDUCTORS
C
   30 LOC=LOCATE(3)
   40 IF ((LOC.EQ.0).OR.(NODPLC(LOC+14).NE.0)) GO TO 50
      LOCT=NODPLC(LOC+11)
      CALL TERR(LOCT,DELNEW)
      LOC=NODPLC(LOC)
      GO TO 40
C
C  DIODES
C
   50 LOC=LOCATE(11)
   60 IF ((LOC.EQ.0).OR.(NODPLC(LOC+16).NE.0)) GO TO 70
      LOCT=NODPLC(LOC+11)
      CALL TERR(LOCT+3,DELNEW)
      LOC=NODPLC(LOC)
      GO TO 60
C
C  BJTS
C
   70 LOC=LOCATE(12)
   80 IF ((LOC.EQ.0).OR.(NODPLC(LOC+36).NE.0)) GO TO 90
      LOCT=NODPLC(LOC+22)
      CALL TERR(LOCT+8,DELNEW)
      CALL TERR(LOCT+10,DELNEW)
      CALL TERR(LOCT+12,DELNEW)
      LOC=NODPLC(LOC)
      GO TO 80
C
C  JFETS
C
   90 LOC=LOCATE(13)
  100 IF ((LOC.EQ.0).OR.(NODPLC(LOC+25).NE.0)) GO TO 110
      LOCT=NODPLC(LOC+19)
      CALL TERR(LOCT+9,DELNEW)
      CALL TERR(LOCT+11,DELNEW)
      LOC=NODPLC(LOC)
      GO TO 100
C
C  MOSFETS
C
  110 LOC=LOCATE(14)
  120 IF ((LOC.EQ.0).OR.(NODPLC(LOC+33).NE.0)) GO TO 200
      LOCT=NODPLC(LOC+26)
      CALL TERR(LOCT+12,DELNEW)
      CALL TERR(LOCT+14,DELNEW)
      CALL TERR(LOCT+16,DELNEW)
      LOC=NODPLC(LOC)
      GO TO 120
C
C  DELTA IS ALLOWED ONLY TO DOUBLE AT EACH TIMEPOINT
C
  200 DELNEW=MIN(2.0D0*DELTA,DELNEW,DELMAX)
      CALL TSEC(T2)
      RSTATS(42)=RSTATS(42)+T2-T1
      RETURN
      END
