C
C$ann[Define("SVM", 1)]
C
C     BECAUSE BENCHMARK SET
C     TEST: BBS.2.1.5
C     VERSION: 1.0
C     DATE: 10/02/92
C
      PROGRAM MAIN5

C***  IMPLICIT NONE

C -------------------------------------------------------------------------
C
C     THIS IS THE MAIN PROGRAM CALLING "FLUX"
C
C           CLASS 2 : APPLICATION KERNELS
C           SUBCLASS 1 : CONTRIBUTION LOOPS
C
C     SEE COMMENTS IN ROUTINE "MKMESH" TO GET
C     A COMPLETE DESCRIPTION OF THE MESH
C
C -------------------------------------------------------------------------

C     MAXIMUM NUMBER OF ELEMENTS ON X ,Y ,Z AXES
C
C     50x50x50 = 125000 ELEMENTS, 132651 NODES, 382500 FACES
C              = ABOUT  16 MBYTES FOR THE MESH ONLY
C
C     40x40x40 =  64000 ELEMENTS,  68921 NODES, 196800 FACES
C              = ABOUT 3.9 MBYTES FOR THE MESH ONLY
C
C     23x23x23 =  12167 ELEMENTS,  13824 NODES,  38088 FACES
C              = ABOUT 1.6 MBYTES FOR THE MESH ONLY

      INTEGER    IMAX ,JMAX ,KMAX

      PARAMETER (IMAX = 25)
      PARAMETER (JMAX = 25)
      PARAMETER (KMAX = 25)

C---- MAXIMUM NUMBER OF ELEMENTS ,NODES ,FACES ,BOUNDARY FACES AND REFERENCES

      INTEGER   MAXNEL ,MAXNOD ,MAXFAC ,MAXBOF ,MAXREF

      PARAMETER (MAXNEL =  25    *  25    *  25)

      PARAMETER (MAXNOD = (25+1) * (25+1) * (25+1))

      PARAMETER (MAXFAC =  25    *  25    * (25+1)
     .                  + (25+1) *  25    *  25
     .                  +  25    * (25+1) *  25)

      PARAMETER (MAXBOF = (25*25 + 25*25 + 25*25) * 2)

      PARAMETER (MAXREF = 6)

C---------------------------------------------------------

      INTEGER NBNOD ,NBNEL ,NBFAC ,BOUNDF
      INTEGER IMAXI ,JMAXI ,KMAXI
      INTEGER NODES  (8 ,25  * 25  * 25) ,
     .     FACE   (6 , 25    *  25    * (25+1)
     .     + (25+1) *  25    *  25
     .     +  25    * (25+1) *  25)
      INTEGER FABOUN (MAXBOF)    ,PTRFAB (2 ,MAXREF)
      INTEGER NUNIT ,CONVER ,I ,NEL ,INFO (25 * 25 * 25)
      INTEGER TEMP(10)

      DOUBLE PRECISION  X   (3 ,(25+1) * (25+1) * (25+1)) ,ORIGIN (3)
      DOUBLE PRECISION  VARFAC (25    *  25    * (25+1)
     .                  + (25+1) *  25    *  25
     .                  +  25    * (25+1) *  25) 
     +     ,FACNEL (25*25*25), TMPFAC (25*25*25, 0:15)

      DOUBLE PRECISION  ELAPSE ,DELTA ,TOTAL ,PERCAL

      CHARACTER*64 FRESU
      CHARACTER*8  FTOPO
      CHARACTER    RESP

C      COMMON /IDILIO/ NODES ,FACE ,FABOUN ,PTRFAB ,INFO
C      COMMON /RAOUL/  X ,ORIGIN ,FACNEL ,VARFAC

      EXTERNAL FLUX ,MKMESH ,ELAPSE

C shared Declaration for memory usage
C$ann[Shared(nodes)]
C$ann[Shared(x)]
C shared section declaration  Parallel Uses
C$ann[Shared(face)]
C$ann[Shared(facnel)]
C$ann[Shared(tmpfac)]
C$ann[Shared(varfac)]
C$ann[Shared(info)]
C To get some value on all processors
C$ann[Shared(temp)]

C---- FILE UNIT NUMBER

      NUNIT = 33

C---- CRITICAL PART REPEAT NUMBER

      CONVER = 10

C---- INPUT SIZE OF THE MESH

C$ann[BeginSeq()]

      WRITE (*,5001) 'X' ,IMAX
      READ  (*,*) IMAXI

      WRITE (*,5001) 'Y' ,JMAX
      READ  (*,*) JMAXI

      WRITE (*,5001) 'Z' ,KMAX
      READ  (*,*) KMAXI

C---- WRITING RESULTS

      WRITE (*,'(A)') 'WRITING RESULTS (Y/N) ?'
      READ  (*,'(A)') RESP

C---- MESH GENERATION

      ORIGIN (1) = 0.
      ORIGIN (2) = 0.
      ORIGIN (3) = 0.

C print for debug 
      print *,'Starting Mesh Computation'

      CALL MKMESH (IMAXI  ,JMAXI  ,KMAXI
     .            ,MAXNEL ,MAXNOD ,MAXFAC ,MAXBOF ,MAXREF ,ORIGIN
     .            ,NBNEL  ,NBNOD  ,NBFAC  ,BOUNDF
     .            ,X      ,NODES  ,FACE   ,FABOUN ,PTRFAB)

C print for debug 
      print *,'End Mesh Computation'
C---- CRITICAL PART REPEATED "CONVER" TIMES
      TEMP(1) = NBNEL
      TEMP(2) = NBFAC
      TEMP(3) = BOUNDF 
      
C$ann[EndSeq()]

       NBNEL  = TEMP(1) 
       NBFAC  = TEMP(2) 
       BOUNDF = TEMP(3) 

      DELTA = ELAPSE (TOTAL)

      DO 10 I = 1 ,CONVER
C$ann[BeginSeq()]
        print *,'Step in repeat loop', I
C$ann[EndSeq()]

         CALL FLUX (NBNEL  ,NBFAC  ,BOUNDF ,FACE
     .        ,FACNEL ,VARFAC ,INFO, TMPFAC)

10    CONTINUE

      DELTA = ELAPSE (TOTAL)

C$ann[BeginSeq()]

C print for debug 
      print *,'End Computation (start writing resul)'
C---- TIMING RESULTS

      FTOPO = 'XXxXXxXX'

      WRITE (FTOPO (1:2) ,'(I2.2)') IMAXI
      WRITE (FTOPO (4:5) ,'(I2.2)') JMAXI
      WRITE (FTOPO (7:8) ,'(I2.2)') KMAXI

      PERCAL = DELTA / CONVER

      WRITE (*,501) 'FLUX (' , FTOPO ,') : ' ,DELTA
     .     ,' SECONDS (' ,PERCAL ,' PER CALL)'

C---- WRITING RESULTS IF REQUESTED

      IF ((RESP .EQ. 'Y') .OR. (RESP .EQ. 'y')) THEN

         FRESU = 'FLUX.' // FTOPO
         OPEN    (NUNIT ,FILE = FRESU)
         WRITE   (NUNIT ,500) (FACNEL (NEL) ,NEL = 1 ,NBNEL)
         ENDFILE (NUNIT)
         CLOSE   (NUNIT)

      END IF

C----
500   FORMAT (6 (2X ,1PE10.3))
501   FORMAT (3A ,1PE10.3 ,A ,1PE10.3 ,A)
5001  FORMAT ('NUMBER OF ELEMENTS ON ' ,A1 ,' (MAX = ' ,I2.2 ,') ?')
C----

C$ann[EndSeq()]
      END
C ----------------------------------------------------------------------
C          CONTRIBUTION LOOP ON FACES TO CALCULATE AN ELEMENT VARIABLE
C ----------------------------------------------------------------------

      SUBROUTINE FLUX (NBNEL  ,NBFAC  ,BOUNDF ,FACE
     .                ,FACNEL ,VARFAC ,INFO,TMPFAC)

C***  IMPLICIT NONE

      INTEGER NBNEL ,NBFAC ,BOUNDF
      INTEGER FACE (6 ,NBFAC)

      DOUBLE PRECISION  FACNEL (NBNEL) ,VARFAC (NBFAC)
CBODIN 32 is the number of proc
      DOUBLE PRECISION TMPFAC(NBNEL,0:15)
      INTEGER INFO   (NBNEL)

      INTEGER NEL ,NEP ,NEM ,NF ,INTFAC,PROC, NBPROC
      DOUBLE PRECISION  ALPHA

C---- INITIALISATIONS

      ALPHA = 1. / 3.

      NBPROC = numnodes() -1

C$ann[DoShared("BLOCK")]
      DO 8 I = 0,NBPROC  
         DO 9  NEL = 1 ,NBNEL
            TMPFAC(NEL,I) = 0.
 9       CONTINUE
 8    CONTINUE

C$ann[DoShared("BLOCK")]
C$ann[WeakCoherency(facnel)]
C $ann[WeakCoherency(info)] Not two arrays simultaneously???
      DO 10 NEL = 1 ,NBNEL
         FACNEL (NEL) = 0.
         INFO   (NEL) = 1
10    CONTINUE

C$ann[DoShared("BLOCK")]
C$ann[WeakCoherency(varfac)]
      DO 15 NF = 1 ,NBFAC
         VARFAC (NF) = 1.
15    CONTINUE
 
C---- INTERNAL FACES

      INTFAC = NBFAC - BOUNDF

C Parallel computation then merge result
C$ann[DoShared("BLOCK")]
      DO 20 NF = 1 ,INTFAC
         PROC = mynode()
         NEP = FACE (5 ,NF)
         NEM = FACE (6 ,NF)
         TMPFAC(NEP,PROC) =  TMPFAC(NEP,PROC) + VARFAC (NF)
     .               * (ALPHA * INFO (NEP) + (1. - ALPHA) * INFO (NEM))

         TMPFAC(NEM,PROC) = TMPFAC(NEM,PROC)  - VARFAC (NF)
     .               * (ALPHA * INFO (NEP) + (1. - ALPHA) * INFO (NEM))

20    CONTINUE

C---- BOUNDARY FACES This one is not in original form
C$ann[DoShared("BLOCK")]
      DO 30 NF = INTFAC + 1 ,NBFAC
         PROC = mynode()
         NEP = FACE (5 ,NF)
         TMPFAC(NEP,PROC) = TMPFAC(NEP,PROC) + VARFAC (NF) * INFO (NEP)

30    CONTINUE

C for debug 
C       print *,'nb proc',NBPROC

CBODIN added to merge result
C$ann[DoShared("BLOCK")]
C$ann[WeakCoherency(facnel)]
      DO 40 NEL = 1 ,NBNEL
         DO 41 I = 0, NBPROC
            FACNEL (NEL) = FACNEL (NEL) + TMPFAC(NEL,I) 
 41      CONTINUE
40    CONTINUE

      END


C$ann[NoSideEffect()]
      SUBROUTINE MKMESH ( IMAXI  ,JMAXI  ,KMAXI 
     .                   ,MAXNEL ,MAXNOD ,MAXFAC ,MAXBOF ,MAXREF ,ORIGIN
     .                   ,NBNEL  ,NBNOD  ,NBFAC  ,BOUNDF
     .                   ,X      ,NODES  ,FACE   ,FABOUN ,PTRFAB)

C***  IMPLICIT NONE
C -------------------------------------------------------------------------
C
C     MESH GENERATION ROUTINE
C
C     THE SHAPE OF THE MESH IS A PARALLELIPIPED, DEFINED BY THE NUMBER OF
C     ELEMENTS "IMAXI" ON X AXIS, "JMAXI" ON Y AXIS AND "KMAXI" ON Z AXIS
C
C     IN ALL TEST PROGRAMS USING "MKMESH", THE MESH HAS TO BE CONSIDERED
C     AS AN UNSTRUCTURED MESH EVEN IF IT IS GENERATED AS A STRUCTURED MESH.
C
C     A MESH IS MADE OF NODES ,FACES AND HEXAEDRAL ELEMENTS.
C
C     A NODE IS IDENTIFIED BY :
C       - ITS NUMBER IN THE NODE SET
C       - A 3D COORDINATE
C     (HERE, "X" ARRAY)
C
C     A FACE IS IDENTIFIED BY :
C       - ITS NUMBER IN THE FACE SET
C       - 4 NUMBERS OF NODES CONSTITUTING THE FACE
C       - 2 NUMBERS OF NEIGHBOURING ELEMENTS
C     (HERE, "FACE" ARRAY)
C
C     FACES ARE ORIENTED ENTITIES. THIS ORIENTATION DEPENDS ON THE ORDER
C     FOLLOWED BY THE 4 SELECTED NODES TO DEFINE EACH FACE.
C     THUS, FACE (5 ,*) ALWAYS REPRESENTS THE NEIGHBOURING ELEMENT POINTED
C     BY THE NORMAL OF THE FACE ,AND FACE (6 ,*) THE NEIGHBOURING ELEMENT
C     TO THE OTHER SIDE OF THE FACE.
C
C     FUTHERMORE, MESH BOUNDARIES ARE IDENTIFIED BY FACES, CALLED BOUNDARY FACES.
C     THE NORMAL IS ASSUMED TO BE INCOMING FOR ALL BOUNDARY FACES, I.E THE NEIGHBOURING
C     ELEMENT "FACE (6 ,*)" DOES NOT EXIST. (AT GENERATION TIME, SPECIAL ATTENTION
C     IS GIVEN TO BOUNDARY FACES ORIENTATION)
C
C     BOUNDARY FACES ARE GROUPED ACCORDING TO THEIR BELONGING TO THE
C     PARALLELIPIPED FACES (THUS, THERE IS HERE 6 "REFERENCES"). THIS MIGTH
C     BE USEFULL WHEN MATCHING TWO MESHES USING A DOMAIN DECOMPOSITION METHOD.
C        REFERENCE 1 =  NODE PLAN IJ, K = 1
C        REFERENCE 2 =  NODE PLAN IJ, K = KMAXI + 1
C        REFERENCE 3 =  NODE PLAN IK, J = 1
C        REFERENCE 4 =  NODE PLAN IK, J = JMAXI + 1
C        REFERENCE 5 =  NODE PLAN JK ,I = 1
C        REFERENCE 6 =  NODE PLAN JK ,I = IMAXI + 1
C
C     AN ELEMENT IS IDENTIFIED BY :
C       - ITS NUMBER IN THE ELEMENT SET
C       - 8 NUMBERS OF NODES CONSTITUTING THE ELEMENT
C     (HERE, "NODE" ARRAY)
C
C     ARGUMENTS :
C
C     INPUT VARIABLES
C       - IMAXI                   NUMBER OF ELEMENTS REQUESTED ON X AXIS
C       - JMAXI                   NUMBER OF ELEMENTS REQUESTED ON Y AXIS
C       - KMAXI                   NUMBER OF ELEMENTS REQUESTED ON Z AXIS
C       - MAXNEL                  MAXIMUM NUMBER OF ELEMENTS
C       - MAXNOD                  MAXIMUM NUMBER OF NODES
C       - MAXFAC                  MAXIMUM NUMBER OF FACES
C       - MAXBOF                  MAXIMUM NUMBER OF BOUNDARY FACES
C       - MAXREF                  MAXIMUM NUMBER OF REFERENCE
C                                 A REFERENCE IS A NUMBER GROUPING BOUNDARY 
C                                 FACES. IT IS HERE THE NUMBER OF A FACE OF
C                                 THE MESH (FROM 1 TO 6)
C       - ORIGIN(1:3)             COORDINATES OF THE ORIGINE OF THE MESH
C                                 WHICH IS THE NODE (I=1 ,J=1 ,K=1)
C
C     OUTPUT VARIABLES
C       - NBNEL                   ACTUAL TOTAL NUMBER OF ELEMENTS
C       - NBNOD                   ACTUAL TOTAL NUMBER OF NODES
C       - NBFAC                   ACTUAL TOTAL NUMBER OF FACES
C       - BOUNDF                  ACTUAL NUMBER OF BOUNDARY FACES
C       - X    (1:3 ,1:NBNOD)     3 COORDINATES  FOR EACH NODE
C       - NODE (1:8 ,1:NBNEL)     8 NODE NUMBERS FOR EACH ELEMENT
C       - FACE (1:6 ,1:NBFAC)     4 NODE NUMBERS FOR EACH FACE ( K = 1,4 )
C                                 2 ELEMENT NUMBERS FOR EACH FACE ( K = 5,6 )
C                                 ( FACE (6 ,NF) = 0 IF NF IS A BOUNDARY FACE )
C                                 FACES FROM 1 TO (NBFAC - BOUNDF + 1) ARE
C                                 INTERNAL FACES
C                                 FACES FROM "BOUNDF" TO "NBFAC" ARE
C                                 BOUNDARY FACES
C       - FABOUN (1:MAXBOF)       LIST OF BOUNDARY FACES ORDERED BY "REFERENCE"
C       - PTRFAB (1:2 ,1:MAXREF)  POINTER ARRAY OF EACH "REFERENCE" IN FABOUN
C                                 PTRFAB (1 ,REF): BEGINING POINTER OF REFERENCE
C                                                  "REF" IN FABOUN
C                                 PTRFAB (2 ,REF): ENDING POINTER OF REFERENCE
C                                                  "REF" IN FABOUN
C
C     DESCIPTION OF A (03 x 03 x 03) MESH: 27 ELEMENTS, 64 NODES ,108 FACES
C                                          54 INTERNAL FACES + 54 BOUNDARY FACES
C
C     THE MESH IS GENERATED BY HORIZONTAL ELEMENT SLICES.
C
C                ELEMENT NUMBERING                     NODE NUMBERING
C
C               /-------/-------/-------/             61-----62------63------64
C              /       /       /       /|            /       /       /       /|
C             /  25   /  26   /  27   / |           /       /       /       / |
C            /       /       /       /  |          /       /       /       /  |
C           /-------/-------/-------/ 27/         57-----58------59------60  48
C          /       /       /       /|  /|        /       /       /       /|  /|
C         /  22   /  23   /  24   / | / |       /       /       /       / | / |
C        /       /       /       /  |/  |      /       /       /       /  |/  |
C       /-------/-------/-------/ 24/ 18/     53-----54------55------56  44  32
C      /       /       /       /|  /|  /|    /       /       /       /|  /|  /|
C     /  19   /  20   /  21   / | / | / |   /       /       /       / | / | / |
C    /       /       /       /  |/  |/  |  /       /       /       /  |/  |/  |
C   /-------/-------/-------/ 21/ 15/ 9 / 49-----50------51------52  40  28  16
C   |       |       |       |  /|  /|  /  |       |       |       |  /|  /|  / 
C   |  19   |  20   |  21   | / | / | /   |       |       |       | / | / | /  
C   |       |       |       |/  |/  |/    |       |       |       |/  |/  |/   
C   |-------|-------|-------/ 12/ 6 /     33-----34------35------36  24  12    
C   |       |       |       |  /|  /      |       |       |       |  /|  /     
C   |  10   |  11   |  12   | / | /       |       |       |       | / | /      
C   |       |       |       |/  |/        |       |       |       |/  |/       
C   |-------|-------|-------/ 3 /         17-----18------19------20   8        
C   |       |       |       |  /          |       |       |       |  /         
C   |   1   |   2   |   3   | /   Z       |       |       |       | /          
C   |       |       |       |/    ^  Y    |       |       |       |/           
C   |-------|-------|-------/     | /     1-------2-------3-------4            
C                                 |/
C                                 /----->X
C 
C     FACE NUMBERING FOLLOWS HORIZONTAL SLICES OF ELEMENTS.
C
C                FACE NUMBERING                    FACE NUMBERING (FIRST SLICE)
C
C               /-------/-------/-------/                     STEP 1
C              /       /       /       /| 
C             /  106  /  107  /  108  / | 
C            /       /       /       /  | 
C           /-------/-------/-------/ 99/ 
C          /       /       /       /|  /| 
C         /  103  /  104  /  105  / | / | 
C        /       /       /       /  |/  | 
C       /-------/-------/-------/ 98/ 87/ 
C      /       /       /       /|  /|  /| 
C     /  100  /  101  /  102  / | / | / | 
C    /       /       /       /  |/  |/  | 
C   /-------/-------/-------/ 97/ 86/ 75/             /-------/-------/-------/
C   |       |       |       |  /|  /|  /             /       /       /       / 
C   |  88   |  89   |  90   | / | / | /             /  61   /  62   /  63   /  
C   |       |       |       |/  |/  |/             /       /       /       /   
C   |-------|-------|-------/ 85/ 74/             /-------/-------/-------/    
C   |       |       |       |  /|  /             /       /       /       /     
C   |  76   |  77   |  78   | / | /             /  58   /  59   /  60   /      
C   |       |       |       |/  |/             /       /       /       /       
C   |-------|-------|-------/ 73/             /-------/-------/-------/        
C   |       |       |       |  /             /       /       /       /         
C   |  64   |  65   |  66   | /             /  55   /  56   /  57   /          
C   |       |       |       |/    Z        /       /       /       /           
C   |-------|-------|-------/     ^  Y    /-------/-------/-------/            
C                                 | /     
C                                 |/      
C                                 /----->X
C
C                              FACE NUMBERING (FIRST SLICE)
C
C                         STEP 2                                STEP 3
C
C               /-------/-------/-------/             /       /       /       /
C               |       |       |       |            /|      /|      /|      /|
C               |   67  |  68   |  69   |           / |     / |     / |     / |
C               |       |       |       |          /  |    /  |    /  |    /  |
C           /-------/-------/-------/---/         / 72/   / 9 /   / 12/   / 75/
C           |       |       |       |            /|  /   /|  /   /|  /   /|  / 
C           |   4   |   5   |   6   |           / | /   / | /   / | /   / | /  
C           |       |       |       |          /  |/   /  |/   /  |/   /  |/   
C       /-------/-------/-------/---/         / 71/   / 8 /   / 11/   / 74/    
C       |       |       |       |            /|  /   /|  /   /|  /   /|  /     
C       |   1   |   2   |   3   |           / | /   / | /   / | /   / | /      
C       |       |       |       |          /  |/   /  |/   /  |/   /  |/       
C   /-------/-------/-------/---/         / 70/   / 7 /   / 10/   / 73/        
C   |       |       |       |             |  /    |  /    |  /    |  /         
C   |  64   |  65   |  66   |             | /     | /     | /     | /          
C   |       |       |       |     Z       |/      |/      |/      |/           
C   /-------/-------/-------/     ^  Y    /       /       /       /            
C                                 | /     
C                                 |/      
C                                 /----->X
C
C     
C -----------------------------------------------------------------------------

      INTEGER   IMAXI  ,JMAXI  ,KMAXI
      INTEGER   MAXNEL ,MAXNOD ,MAXFAC ,MAXBOF ,MAXREF
      INTEGER   NBNEL  ,NBNOD  ,NBFAC ,BOUNDF
      DOUBLE PRECISION    X      (3 ,MAXNOD) ,ORIGIN (3)
      INTEGER   NODES  (8 ,MAXNEL) ,FACE   (6 ,MAXFAC)
      INTEGER   FABOUN (MAXBOF)    ,PTRFAB (2 ,MAXREF)

      INTEGER   NEL ,KNO ,NFACE ,BFACE ,KFACE
      INTEGER   I ,J ,K ,II ,JJ ,KK ,ESLICE ,NSLICE
      LOGICAL   ERROR

C---- BEGIN

      II = IMAXI + 1
      JJ = JMAXI + 1
      KK = KMAXI + 1

C---- DIMENSION CHECKING

      ERROR = .FALSE.

      IF ( (IMAXI * JMAXI * KMAXI) .GT. MAXNEL ) THEN

         WRITE (*,*) 'NUMBER OF ELEMENTS (MAXNEL) OVERFLOW.'
     .        ,' CURRENT : ' ,MAXNEL
     .        ,' REQUESTED : ' ,(IMAXI * JMAXI * KMAXI)
         ERROR = .TRUE.

      END IF

      IF ( (II * JJ * KK) .GT. MAXNOD ) THEN

         WRITE (*,*) 'NUMBER OF NODES (MAXNOD) OVERFLOW.'
     .        ,' CURRENT : ' ,MAXNOD
     .        ,' REQUESTED : ' ,(II * JJ * KK)
         ERROR = .TRUE.

      END IF

      IF ( (IMAXI * JMAXI * KK
     .   +  II    * JMAXI * KMAXI
     .   +  IMAXI * JJ    * KMAXI) .GT. MAXFAC) THEN

         WRITE (*,*) 'NUMBER OF FACES (MAXFAC) OVERFLOW.'
     .        ,' CURRENT : ' ,MAXFAC
     .        ,' REQUESTED : ' ,(IMAXI * JMAXI * KK
     .                        +  II    * JMAXI * KMAXI
     .                        +  IMAXI * JJ    * KMAXI)
         ERROR = .TRUE.

      END IF

C print for debug 
      print *,'Step 1 Mesh computation'

C---- WE STOP HERE IF OVERFLOW

      IF (ERROR) STOP

C---- ONE HORIZONTAL ELEMENT SLICE

      ESLICE = IMAXI * JMAXI

C---- ONE HORIZONTAL NODES SLICE

      NSLICE = II * JJ

C---- DEFINITION OF NODES BY 3D COORDINATES

      KNO = 0

      DO 10 K = 1 ,KK
         DO 20 J = 1 ,JJ
            DO 30 I = 1 ,II

               KNO = KNO + 1
               X (1 ,KNO) = I - 1 + ORIGIN (1)
               X (2 ,KNO) = J - 1 + ORIGIN (2)
               X (3 ,KNO) = K - 1 + ORIGIN (3)

30          CONTINUE
20       CONTINUE
10    CONTINUE

C---- TOTAL NUMBER OF NODES

      NBNOD = KNO

C---- DEFINITION OF ELEMENTS BY MEANS OF THEIR NODES

C print for debug 
      print *,'Step 2 Mesh computation'
      NEL = 0

      DO 110 K = 1 ,KMAXI
         DO 120 J = 1 ,JMAXI
            DO 130 I = 1 ,IMAXI

               NEL = NEL + 1
               NODES (1 ,NEL) = I  + (J - 1) * II + (K - 1) * NSLICE
               NODES (2 ,NEL) = NODES (1 ,NEL) + 1
               NODES (3 ,NEL) = (I + 1) + J * II + (K - 1) * NSLICE
               NODES (4 ,NEL) = NODES (3 ,NEL) - 1
               NODES (5 ,NEL) = I  + (J - 1) * II + K * NSLICE
               NODES (6 ,NEL) = NODES (5 ,NEL) + 1
               NODES (7 ,NEL) = (I + 1) + J * II + K * NSLICE
               NODES (8 ,NEL) = NODES (7 ,NEL) - 1

130         CONTINUE
120      CONTINUE
110   CONTINUE

C---- TOTAL NUMBER OF ELEMENTS

      NBNEL = NEL

C---- NUMBER OF BOUNDARY FACES

      BOUNDF = (IMAXI*JMAXI + JMAXI*KMAXI + IMAXI*KMAXI) * 2

C---- TOTAL NUMBER OF FACES

      NBFAC  = IMAXI*JMAXI*KK + JMAXI*KMAXI*II + IMAXI*KMAXI*JJ

C---- NUMBER OF THE FIRST BOUNDARY FACE ( - 1 )

      BFACE  = NBFAC - BOUNDF

C---- NUMBER OF THE FIRST INTERNAL FACE ( - 1 )

      KFACE  = 0

C---- BEGINING POINTERS OF REFERENCES IN "FABOUN" ARRAY

C print for debug 
      print *,'Step 3 Mesh computation'

      PTRFAB (1 ,1) = 1
      PTRFAB (1 ,2) = PTRFAB (1 ,1) + IMAXI * JMAXI
      PTRFAB (1 ,3) = PTRFAB (1 ,2) + IMAXI * JMAXI
      PTRFAB (1 ,4) = PTRFAB (1 ,3) + IMAXI * KMAXI
      PTRFAB (1 ,5) = PTRFAB (1 ,4) + IMAXI * KMAXI
      PTRFAB (1 ,6) = PTRFAB (1 ,5) + JMAXI * KMAXI

      IF ( (PTRFAB (1 ,6) + JMAXI * KMAXI - 1) .GT. MAXBOF ) THEN

         WRITE (*,*) 'BOUNDARY FACES (MAXBOF) OVERFLOW.'
     .        ,' CURRENT : ', MAXBOF
     .        ,' REQUESTED : ',(PTRFAB (1 ,6) + JMAXI * KMAXI - 1)
         STOP

      END IF

C---- AT THE MOMENT, END = (BEGIN - 1) FOR ALL POINTERS

      PTRFAB (2 ,1) = PTRFAB (1 ,1) - 1
      PTRFAB (2 ,2) = PTRFAB (1 ,2) - 1
      PTRFAB (2 ,3) = PTRFAB (1 ,3) - 1
      PTRFAB (2 ,4) = PTRFAB (1 ,4) - 1
      PTRFAB (2 ,5) = PTRFAB (1 ,5) - 1
      PTRFAB (2 ,6) = PTRFAB (1 ,6) - 1

C---- THE MOST EXTERNAL LOOP IS ON Z AXIS, IN ORDER TO GENERATE FACES BY SLICE

      DO 200 K = 1 ,KK

C------------------------------------------- FACES ON ONE XY PLAN. STEP 1 BEGIN

         DO 210 J = 1 ,JMAXI
            DO 215 I = 1 ,IMAXI

               IF ((K .EQ. 1) .OR. (K .EQ. KK)) THEN

C---------------- THIS IS A BOUNDARY FACE

                  BFACE = BFACE + 1
                  NFACE = BFACE

C---------------- THERE IS ONLY ONE NEIGHBOURING ELEMENT
C---------------- "FACE (6 ,NFACE)" IS UNDEFINED

                  FACE (6 ,NFACE) = 0

               ELSE

C---------------- THIS IS AN INTERNAL FACE

                  KFACE = KFACE + 1
                  NFACE = KFACE

C---------------- THERE ARE TWO NEIGHBOURING ELEMENTS
C---------------- "FACE (6 ,NFACE)" IS DEFINED

                  FACE (6 ,NFACE) = I + (J-1) * IMAXI + (K-2) * ESLICE

               END IF

C------------- THE SELECTION OF NODES 1 AND 3 OF EACH FACE
C------------- DO NOT DEPEND ON THE ORIENTATION OF THE FACE

               FACE (1 ,NFACE) = I  + (J - 1) * II + (K - 1) * NSLICE
               FACE (3 ,NFACE) = (I + 1) + J * II + (K - 1) * NSLICE

C------------- THE SELECTION OF NODES 2 AND 4 OF EACH FACE
C------------- DEPEND ON THE ORIENTATION OF THE FACE

               IF (K .EQ. KK) THEN
                  FACE (2 ,NFACE) = FACE (3 ,NFACE) - 1
                  FACE (4 ,NFACE) = FACE (1 ,NFACE) + 1
                  FACE (5 ,NFACE) = I + (J-1) * IMAXI + (K-2) * ESLICE
               ELSE
                  FACE (2 ,NFACE) = FACE (1 ,NFACE) + 1
                  FACE (4 ,NFACE) = FACE (3 ,NFACE) - 1
                  FACE (5 ,NFACE) = I + (J-1) * IMAXI + (K-1) * ESLICE
               END IF

C------------- BOUNDARY FACES BELONGING TO REFERENCE NUMBER 1

               IF (K .EQ. 1) THEN
                  PTRFAB (2 ,1) = PTRFAB (2 ,1) + 1
                  FABOUN ( PTRFAB (2 ,1) ) = NFACE
               END IF

C------------- BOUNDARY FACES BELONGING TO REFERENCE NUMBER 2

               IF (K .EQ. KK) THEN
                  PTRFAB (2 ,2) = PTRFAB (2 ,2) + 1
                  FABOUN ( PTRFAB (2 ,2) ) = NFACE
               END IF

215         CONTINUE
210      CONTINUE

C print for debug 
      print *,'Step 4 Mesh computation',K
C--------------------------------------------- FACES ON ONE XY PLAN. STEP 1 END

         IF (K .LT. KK) THEN

C---------------------------------------------- FACES ON XZ PLANS. STEP 2 BEGIN

            DO 220 J = 1 ,JJ
               DO 225 I = 1 ,IMAXI

                  IF ((J .EQ. 1) .OR. (J .EQ. JJ)) THEN

C------------------- THIS IS A BOUNDARY FACE

                     BFACE = BFACE + 1
                     NFACE = BFACE

C------------------- THERE IS ONLY ONE NEIGHBOURING ELEMENT
C------------------- "FACE (6 ,NFACE)" IS UNDEFINED

                     FACE (6 ,NFACE) = 0

                  ELSE

C------------------- THIS IS AN INTERNAL FACE

                     KFACE = KFACE + 1
                     NFACE = KFACE

C------------------- THERE ARE TWO NEIGHBOURING ELEMENTS
C------------------- "FACE (6 ,NFACE)" IS DEFINED

                     FACE (6 ,NFACE) = I + (J-1)*IMAXI + (K-1)*ESLICE

                  END IF

C---------------- THE SELECTION OF NODES 1 AND 3 OF EACH FACE
C---------------- DO NOT DEPEND ON THE ORIENTATION OF THE FACE

                  FACE (1 ,NFACE) = I  + (J-1) * II + (K-1) * NSLICE
                  FACE (3 ,NFACE) = (I + 1) + (J-1) * II + K * NSLICE

C---------------- THE SELECTION OF NODES 2 AND 4 OF EACH FACE
C---------------- DEPEND ON THE ORIENTATION OF THE FACE

                  IF (J .EQ. 1) THEN
                     FACE (2 ,NFACE) = FACE (3 ,NFACE) - 1
                     FACE (4 ,NFACE) = FACE (1 ,NFACE) + 1
                     FACE (5 ,NFACE) = I + (J-1)*IMAXI + (K-1)*ESLICE
                  ELSE
                     FACE (2 ,NFACE) = FACE (1 ,NFACE) + 1
                     FACE (4 ,NFACE) = FACE (3 ,NFACE) - 1
                     FACE (5 ,NFACE) = I + (J-2)*IMAXI + (K-1)*ESLICE
                  END IF

C------------- BOUNDARY FACES BELONGING TO REFERENCE NUMBER 3

               IF (J .EQ. 1) THEN
                  PTRFAB (2 ,3) = PTRFAB (2 ,3) + 1
                  FABOUN ( PTRFAB (2 ,3) ) = NFACE
               END IF

C------------- BOUNDARY FACES BELONGING TO REFERENCE NUMBER 4

               IF (J .EQ. JJ) THEN
                  PTRFAB (2 ,4) = PTRFAB (2 ,4) + 1
                  FABOUN ( PTRFAB (2 ,4) ) = NFACE
               END IF

225            CONTINUE
220         CONTINUE

C------------------------------------------------ FACES ON XZ PLANS. STEP 2 END

C---------------------------------------------- FACES ON YZ PLANS. STEP 3 BEGIN

C print for debug 
      print *,'Step 5 Mesh computation',K

            DO 230 I = 1 ,II
               DO 235 J = 1 ,JMAXI

                  IF ((I .EQ. 1) .OR. (I .EQ. II)) THEN

C------------------- THIS IS A BOUNDARY FACE

                     BFACE = BFACE + 1
                     NFACE = BFACE

C------------------- THERE IS ONLY ONE NEIGHBOURING ELEMENT
C------------------- "FACE (6 ,NFACE)" IS UNDEFINED

                     FACE (6 ,NFACE) = 0

                  ELSE

C------------------- THIS IS AN INTERNAL FACE

                     KFACE = KFACE + 1
                     NFACE = KFACE

C------------------- THERE ARE TWO NEIGHBOURING ELEMENTS
C------------------- "FACE (6 ,NFACE)" IS DEFINED

                     FACE (6 ,NFACE) = I-1 + (J-1)*IMAXI + (K-1)*ESLICE

                  END IF

C---------------- THE SELECTION OF NODES 1 AND 3 OF EACH FACE
C---------------- DO NOT DEPEND ON THE ORIENTATION OF THE FACE

                  FACE (1 ,NFACE) = I  + (J-1) * II + (K-1) * NSLICE
                  FACE (3 ,NFACE) = I  + J * II + K * NSLICE

C---------------- THE SELECTION OF NODES 2 AND 4 OF EACH FACE
C---------------- DEPEND ON THE ORIENTATION OF THE FACE

                  IF (I .EQ. II) THEN
                     FACE (2 ,NFACE) = I  + (J - 1) * II + K * NSLICE
                     FACE (4 ,NFACE) = I  + J * II + (K - 1) * NSLICE
                     FACE (5 ,NFACE) = I-1 + (J-1)*IMAXI + (K-1)*ESLICE
                  ELSE
                     FACE (2 ,NFACE) = I  + J * II + (K - 1) * NSLICE
                     FACE (4 ,NFACE) = I  + (J - 1) * II + K * NSLICE
                     FACE (5 ,NFACE) = I + (J-1)*IMAXI + (K-1)*ESLICE
                  END IF

C------------- BOUNDARY FACES BELONGING TO REFERENCE NUMBER 5

               IF (I .EQ. 1) THEN
                  PTRFAB (2 ,5) = PTRFAB (2 ,5) + 1
                  FABOUN ( PTRFAB (2 ,5) ) = NFACE
               END IF

C------------- BOUNDARY FACES BELONGING TO REFERENCE NUMBER 6

               IF (I .EQ. II) THEN
                  PTRFAB (2 ,6) = PTRFAB (2 ,6) + 1
                  FABOUN ( PTRFAB (2 ,6) ) = NFACE
               END IF

235            CONTINUE
230         CONTINUE

C------------------------------------------------ FACES ON YZ PLANS. STEP 3 END

         END IF

200   CONTINUE

      END
