      PROGRAM FLO52Q
C*************************************************************************C
C     THIS CODE IS OBTAINED FROM ANTHONY JAMESON			  C
C     SHOULD BE DISTRIBUTED TO AND USED ONLY BY THE MEMBERS OF THE	  C
C     'PERFECT' GROUP FOR GROUP PURPOSES.				  C
C*************************************************************************C
C
C     ANALYSIS OF TRANSONIC FLOW PAST AN AIRFOIL
C     BY SOLUTION OF UNSTEADY EULER EQUATIONS
C     FINITE VOLUME METHOD WITH CENTRAL DIFFERENCE SCHEME
C     MULTISTAGE SCHEME WITH MULTIPLE GRIDS.
C     NOT FOR DISTRIBUTION WITHOUT PERMISSION OF ANTONY JAMESON.
C
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/CNV/ RTRMS,RTMAX,IRT,JRT,HRMS,HMAX,IH,JH,NSUP
      COMMON/RKC/ C(6)
      COMMON/CRD/ A0(193),S0(193),B0(33),XSING1,YSING1,XSING2,YSING2,
     .            TRAIL,SLOPT,GAP,BOUND,EX,BUNCH
      COMMON/GEO/ XP(385),YP(385),NP
      COMMON/MGR/ KODE,MODE
      COMMON/SYM/ ISYM
      COMMON/OUT/ CP(193),SCAL,CHORD,XM,YM,CL,CD,CM
      COMMON/SAV/ COUNT1(501),COUNT2(501),RES(501),FSUP(501),
     .            CLM(501),CDM(501),CMM(501),IOUT
      DIMENSION   W(36384),W1(36384),WR(10000),P(9096),
     .            X(18192),VOL(9096),DTL(9096)
      DIMENSION   TITLE(20)
      DIMENSION   FCYC(6),FPRNT(6),FOUT(6),FTIM(6),
     .            GPRNT(6),HPRNT(6),GMESH(6)
C
      REAL T1,T2,T3,T4
C
      IREAD     = 5
      IWRIT     = 6
C
      OPEN(UNIT=IREAD,FILE='TFI5')
      OPEN(UNIT=IWRIT,FILE='TFO6')
      OPEN(UNIT=7,FILE='TFV')
      OPEN(UNIT=99,FILE='TFT99')
C
C.....CALL TIMING ROUTINES
C
      CALL CPUTIM(T1)
      CALL ELAPSE(T2)
C
      TIM       = T1
      WRITE (IWRIT,700) TIM
      RAD       = 45./ATAN(1.)
      WRITE (IWRIT,600)
      WRITE (IWRIT,2)
    2 FORMAT(14H0PROGRAM FLO52,30X,
     .       35HANTONY JAMESON,PRINCETON UNIVERSITY/
     .       35H0AIRFOIL ANALYSIS IN TRANSONIC FLOW,
     .       40H BY SOLUTION OF UNSTEADY EULER EQUATIONS)             
      READ  (IREAD,530) (TITLE(I),I=1,20)
      WRITE (IWRIT,630) (TITLE(I),I=1,20)
      READ  (IREAD,500)
      READ  (IREAD,510) FNX,FNY,FMESH,FILOUT
      NX        = FNX
      NY        = FNY
C     OUTPUT FILE IOUT ----> PRNTFF
C     IOUT      = FILOUT
      MMESH     = FMESH
      IF (NX.LT.1) GO TO 301
      IL        = NX  +1
      JL        = NY  +1
      I2        = NX  +2
      J2        = NY  +2
      READ  (IREAD,500)
      READ  (IREAD,510) BOUND,EX,BUNCH
      IF (BOUND.LE.0.) BOUND = .99
      IF (BOUND.GE.1.) BOUND = .99
      READ  (IREAD,500)
      DO 12 M=1,MMESH
   12 READ  (IREAD,510) FCYC(M),FPRNT(M),FOUT(M),FTIM(M),
     .                  GPRNT(M),HPRNT(M),GMESH(M)
      READ  (IREAD,500)
      READ  (IREAD,510) CFL,BC,QFIL,VIS2,VIS4,HM,SMOOPI,SMOOPJ
      READ  (IREAD,500)
      READ  (IREAD,510) C(1),C(2),C(3),C(4),C(5),C(6)
      MSTAGE    = 1
      DO 14 K=1,6
      IF (C(K).NE.0.) MSTAGE = K
   14 CONTINUE
      FSTAGE    = MSTAGE
      READ  (IREAD,500)
      READ  (IREAD,510) VIS0
      READ  (IREAD,500)
      READ  (IREAD,510) RM,AL
      ALPHA     = AL/RAD
      CA        = COS(ALPHA)
      SA        = SIN(ALPHA)
      READ  (IREAD,500)
      READ  (IREAD,510) FSYM,FNU,FNL
      ISYM      = FSYM
      IF (ISYM.LT.0) GO TO 41
      NU        = FNU
      NL        = FNL
      READ  (IREAD,500)
      READ  (IREAD,510) TRAIL,SLOPT,XSING1,YSING1
      NP        = NL  +NU  -1
      READ  (IREAD,500)
      DO 22 I=NL,NP
   22 READ  (IREAD,510) XP(I),YP(I)
      M         = NL  +1
      IF (ISYM.GT.0) GO TO 25
      READ  (IREAD,500)
      DO 24 I=1,NL
      M         = M  -1
   24 READ (IREAD,510) XP(M),YP(M)
      GO TO 31
   25 DO 26 I=NL,NP
      M         = M  -1
      XP(M)     = XP(I)
   26 YP(M)     = -YP(I)
   31 CHORD     = XP(1)  -XP(NL)
      XM        = XP(NL)  +.25*CHORD
      YM        = YP(NL)
      WRITE (IWRIT,32)
   32 FORMAT(18H0INPUT COORDINATES/
     .       1H0,2X,12H      X     ,12H      Y     )             
      DO 34 I=1,NP
   34 WRITE (IWRIT,610) XP(I),YP(I)
      WRITE (IWRIT,36)
   36 FORMAT(1H0,2X,12H    XSING   ,12H    YSING   ,12H  TE SLOPE  ,
     .              12H  TE ANGLE  )             
      WRITE (IWRIT,610) XSING1,YSING1,SLOPT,TRAIL
      TRAIL     = TRAIL/RAD
   41 IF (MMESH.EQ.1) GO TO 51
      DO 42 M=2,MMESH
      NX        = NX  +NX
   42 NY        = NY  +NY
   51 IL        = NX  +1
      JL        = NY  +1
      I2        = NX  +2
      J2        = NY  +2
      K         = 1
      KX        = 1
      KW        = 1
      CALL COORD
      IF (ISYM.LT.0) GO TO 61
      CALL GEOM
      CALL MESH  (I2,J2,X(KX))
      GO TO 71
   61 CALL CIRCLE(I2,J2,X(KX))
      CHORD     = 2.
      XM        = -.5
      YM        = 0.
   71 WRITE (IWRIT,600)
      WRITE (IWRIT,72)
   72 FORMAT(42H0MAPPED COORDINATES AND FAR FIELD FUNCTION/
     .       1H0,2X,12H     A0     ,12H     S0     )         
      DO 74 I=1,IL
   74 WRITE (IWRIT,610) A0(I),S0(I)
      WRITE (IWRIT,600)
      WRITE (IWRIT,76)
   76 FORMAT(1H0,2X,12H     B0     )
      DO 78 J=1,JL
   78 WRITE (IWRIT,610) B0(J)
      WRITE (IWRIT,80)
   80 FORMAT(1H0,2X,12H    BOUND   ,12H     EX     ,12H    BUNCH   )
      WRITE (IWRIT,610) BOUND,EX,BUNCH
      CALL GRID  (I2,J2,X(KX),TITLE)
      IF (MMESH.EQ.1) GO TO 91
      DO 82 M=2,MMESH
      II2       = NX/2  +2
      JJ2       = NY/2  +2
      NC        = I2*J2
      KKX       = KX  +2*NC
      CALL XPAND (I2,J2,X(KX),II2,JJ2,X(KKX))
      KX        = KKX
      K         = K  +NC
      KW        = KW  +4*NC
      NX        = NX/2
      NY        = NY/2
      IL        = NX  +1
      JL        = NY  +1
      I2        = NX  +2
   82 J2        = NY  +2
   91 VT        = 1.
      IF (CFL.LT.0.) VT = 0.
      CFL       = ABS(CFL)
      GAMMA     = 1.4
      RHO0      = 1.
      P0        = 1.
      C0        = SQRT(GAMMA*P0/RHO0)
      EI0       = P0/((GAMMA  -1.)*RHO0)
      U0        = RM*C0*CA
      V0        = RM*C0*SA
      H0        = GAMMA*EI0  +.5*(U0*U0  +V0*V0)
      M         = 1
      CALL METRIC(I2,J2,X(KX),VOL(K))
      CALL INIT  (I2,J2,W(KW),P(K))
  101 MCYC      = FCYC(M)
      NTIM      = FTIM(M)
      NOUT      = FOUT(M)
      NPRNT     = FPRNT(M)
      IPRNT     = GPRNT(M)
      LPRNT     = HPRNT(M)
      LPRNT     = MAX(1,LPRNT)
      NMESH     = GMESH(M)
      IF (IPRNT.GT.0) CALL PRNTXY(LPRNT,I2,J2,X(KX),VOL(K))
      IF (IPRNT.GT.1)
     .CALL PRNTFF(0,0.,LPRNT,I2,J2,W(KW),P(K))
      L         = (MCYC  -1)/500  +1
      NOUT      = MAX(NOUT,L)
      NRES      = 0
      NCYC      = 0
      TOT       = 0.
C
      CALL  CPUTIM(TIM)
C
      WRITE (IWRIT,700) TIM
  201 WRITE (IWRIT,600)
      WRITE (IWRIT,202)
  202 FORMAT(24H0TIME DEPENDENT SOLUTION)
      WRITE (IWRIT,204)
  204 FORMAT(1H0,2X,12H MACH NUMBER,12H ANG ATTACK )
      WRITE (IWRIT,610) RM,AL
      WRITE (IWRIT,206)
  206 FORMAT(46H0MULTI STAGE RUNGE KUTTA SCHEME WITH SMOOTHING)
      WRITE (IWRIT,208)
  208 FORMAT(1H0,2X,12H CFL NUMBER ,12H   N STAGE  ,12H   SMOOPI   ,
     .              12H   SMOOPJ   ,12H     BC     ,12H  H FACTOR  )         
      WRITE (IWRIT,610) CFL,FSTAGE,SMOOPI,SMOOPJ,BC,HM
      WRITE (IWRIT,210)
  210 FORMAT(1H0,2X,12H    C(1)    ,12H    C(2)    ,12H    C(3)    ,
     .              12H    C(4)    ,12H    C(5)    ,12H    C(6)    )        
      WRITE (IWRIT,610) C(1),C(2),C(3),C(4),C(5),C(6)
      WRITE (IWRIT,212)
  212 FORMAT(1H0,2X,12H    VIS 2   ,12H    VIS 4   ,12H    VIS 0   ,
     .              12H    QFIL    )                           
      WRITE (IWRIT,610) VIS2,VIS4,VIS0,QFIL
      WRITE (IWRIT,214)
  214 FORMAT(1H0,2X,12H     NX     ,12H     NY     ,12H   N MESH   )         
      WRITE (IWRIT,640) NX,NY,NMESH
      WRITE (IWRIT,220)
  220 FORMAT(1H0,2X,5HCYCLE,10H   WORK   ,
     .              10H MAX DR/DT,4H  I ,4H  J ,10H AVG DR/DT,
     .              10HMAX ENTHPY,4H  I ,4H  J ,10HAVG ENTHPY,
     .              5HN SUP)                 
      N         = NMESH
  221 NCYC      = NCYC  +1
      KXPAND    = 1
      II2       = NX/2  +2
      JJ2       = NY/2  +2
      NC        = I2*J2
      KK        = K  +NC
      KKX       = KX  +2*NC
      KKW       = KW  +4*NC
      LW        = 1
      LLW       = 1
      KODE      = 1
      MODE      = 0
      NSUP      = -1
      IF (NCYC.EQ.1.OR.MOD(NCYC,NPRNT).EQ.0) NSUP = 0
      WORK      = 1.
  231 TOT       = TOT  +WORK
      IF ((MOD(NCYC-1,NTIM).EQ.0.OR.NCYC.LE.10))
     .CALL STEP  (I2,J2,W(KW),P(K),X(KX),VOL(K),DTL(K))
      CALL EULER (I2,J2,W(KW),W1(KW),P(K),X(KX),VOL(K),DTL(K),WR(LW))
      KODE      = 1
      IF (N.LT.NMESH.OR.MOD(NCYC-1,NOUT).NE.0) GO TO 241
      WRITE (IWRIT,650) NCYC,TOT,RTMAX,IRT,JRT,RTRMS,
     .                  HMAX,IH,JH,HRMS,NSUP
      IF (NCYC.EQ.1) RTRMS0 = RTRMS
      NRES          = NRES  +1
      COUNT1(NRES)  = TOT   -1.
      COUNT2(NRES)  = NCYC  -1
      RES(NRES)     = RTRMS
      FSUP(NRES)    = NSUP
C     CLM(NRES)     = CL
C     CDM(NRES)     = CD
C     CMM(NRES)     = CM
  241 IF (NCYC.GE.MCYC) GO TO 271
      IF (MOD(NCYC,NPRNT).EQ.0.AND.N.EQ.NMESH) GO TO 271
      IF (KXPAND.EQ.-1) GO TO 251
      IF (N.EQ.1) GO TO 221
      KODE      = -1
      CALL EULER (I2,J2,W(KW),W1(KW),P(K),X(KX),VOL(K),DTL(K),WR(LW))
      CALL COLLC (I2,J2,W(KW),VOL(K),II2,JJ2,W(KKW),WR(LLW))
      IF (NCYC.EQ.1) CALL XPAND (I2,J2,X(KX),II2,JJ2,X(KKX))
      KODE      = 2
      MODE      = 1
      NX        = NX/2
      NY        = NY/2
      IL        = NX  +1
      JL        = NY  +1
      I2        = NX  +2
      J2        = NY  +2
      II2       = NX/2  +2
      JJ2       = NY/2  +2
      NC        = I2*J2
      K         = KK
      KX        = KKX
      KW        = KKW
      LW        = LLW
      KK        = K  +NC
      KKX       = KX  +2*NC
      KKW       = KW  +4*NC
      LLW       = LW  +4*NC
      N         = N  -1
      WORK      = .25*WORK
      IF (NCYC.EQ.1) CALL METRIC(I2,J2,X(KX),VOL(K))
      IF (N.EQ.1) KXPAND = -1
      GO TO 231
  251 NX        = NX  +NX
      NY        = NY  +NY
      IL        = NX  +1
      JL        = NY  +1
      I2        = NX  +2
      J2        = NY  +2
      II2       = NX/2  +2
      JJ2       = NY/2  +2
      NC        = I2*J2
      KK        = K
      KKX       = KX
      KKW       = KW
      K         = K  -NC
      KX        = KX  -2*NC
      KW        = KW  -4*NC
      CALL ADDX  (I2,J2,W(KW),P(K),X(KX),II2,JJ2,W(KKW),W1(KKW))
      N         = N  +1
      IF (N.EQ.NMESH) GO TO 221
      GO TO 251
  271 CALL PRNTFF(NCYC,0.,LPRNT,I2,J2,W(KW),P(K))
      WRITE (IWRIT,600)
      WRITE (IWRIT,282)
  282 FORMAT(24H0SECTION CHARACTERISTICS/
     .       1H0,2X,12H MACH NUMBER,12H ANG ATTACK ,
     .              12H     CL     ,12H     CD     ,12H     CM     )          
C
      WRITE (IWRIT,610) RM,AL,CL,CD,CM
C
      IF (M.GE.MMESH) THEN
C
      IVAL=0
C
      WRITE(7,811)
811   FORMAT(1X,'OUTPUT FOR PERFECT CLUB BENCHMARK: FLO52Q'/
     *       1X,'$Revision: 1.6 $ $Author: kipp $'/)              
      WRITE(7,812)
812   FORMAT(1X,'VALIDATION PARAMETERS:'/)
C
      WRITE (7,610) RM,AL,CL,CD,CM
C
      IF (ABS((RM-0.8000)/ 0.8000).GE.1E-2) IVAL=1
      IF (ABS((AL-1.2500)/ 1.2500).GE.1E-2) IVAL=1
      IF (ABS((CL-0.3532)/ 0.3532).GE.1E-2) IVAL=1
      IF (ABS((CD-0.0229)/ 0.0229).GE.1E-2) IVAL=1
      IF (ABS((CM+0.0376)/(-0.0376)).GE.1E-2) IVAL=1
C
      IF(IVAL.EQ.0) THEN
        WRITE(7,813)
813     FORMAT(//1X,'RESULTS FOR THIS RUN ARE:   VALID')
      ELSE
        WRITE(7,814)
814     FORMAT(//1X,'RESULTS FOR THIS RUN ARE: INVALID')
      ENDIF
C
      ENDIF
C
      CALL CPLOT (I2,J2,X(KX))
      CALL GRAPH (I2,J2,X(KX),TITLE,RM,AL,NCYC,RTRMS,ISYM)
      RATE1     = (RTRMS/RTRMS0)**(1./(TOT  -1.))
      RATE2     = (RTRMS/RTRMS0)**(1./FLOAT(NCYC  -1))
      WRITE (IWRIT,292)
  292 FORMAT(1H0,2X,12H   RTRMS 1  ,12H   RTRMS 2  ,12H    WORK    ,
     .              12HREDUCTN/WORK,12H REDUCTN/CYC)            
      WRITE (IWRIT,660) RTRMS0,RTRMS,TOT,RATE1,RATE2
C
      CALL CPUTIM(TIM)
C
      WRITE (IWRIT,700) TIM
      IF (NCYC.LT.MCYC) GO TO 201
      CALL RPLOT (NRES,RES,FSUP,COUNT1,TITLE,RM,AL,NX,NY,0)
      CALL RPLOT (NRES,RES,FSUP,COUNT2,TITLE,RM,AL,NX,NY,1)
      IF (M.GE.MMESH) GO TO 301
      M         = M  +1
      NX        = NX  +NX
      NY        = NY  +NY
      IL        = NX  +1
      JL        = NY  +1
      I2        = NX  +2
      J2        = NY  +2
      II2       = NX/2  +2
      JJ2       = NY/2  +2
      NC        = I2*J2
      KK        = K
      KKX       = KX
      KKW       = KW
      K         = K  -NC
      KX        = KX  -2*NC
      KW        = KW  -4*NC
      CALL METRIC(I2,J2,X(KX),VOL(K))
      CALL ADDX  (I2,J2,W(KW),P(K),X(KX),II2,JJ2,W(KKW),W1(KKW))
      GO TO 101
C
  301 CONTINUE
C
      CALL CPUTIM(T3)
      CALL ELAPSE(T4)
C
      WRITE(7,*)
      WRITE(7,*) 'ELAPSED CPU TIME IN SECONDS: ',T3-T1
C MFLOPS = MFLOP ON 1 CPU CRAY/CPU TIME
      WRITE(7,*) 'MFLOPS RATE: ', 548.951/(T3-T1)
      WRITE(7,*) 'ELAPSED WALLCLOCK TIME IN SECONDS: ',
     *            MOD(T4-T2+1000000.0,1000000.0)              
C
  500 FORMAT(1X)
  510 FORMAT(8F10.6)
  530 FORMAT(20A4)
  600 FORMAT(1H1)
  610 FORMAT(1X,6F12.4)
  630 FORMAT(1H0,18A4)
  640 FORMAT(1X,6I12)
  650 FORMAT(1X,I5,F10.3,1X,E10.3,2I4,2E10.3,2I4,E10.3,I5)
  660 FORMAT(1X,2E12.4,3F12.4)
  700 FORMAT(1H0,5HTIME ,F10.2,7HSECONDS)
      END
C     NAME=COORD
      SUBROUTINE  COORD
      COMMON/LIM/ IL,JL
      COMMON/CRD/ A0(193),S0(193),B0(33),XSING1,YSING1,XSING2,YSING2,
     1            TRAIL,SLOPT,GAP,BOUND,EX,BUNCH
      PI        = 4.*ATAN(1.)
      DX        = 2.*PI/FLOAT(IL  -1)
      DO 12 I=1,IL
      S         = (I  -1)*DX
   12 A0(I)     = S  +BUNCH*SIN(S)
      DY        = 1./FLOAT(JL  -1)
C     B         = -1.  -LOG(1.  -BOUND)
      B         = -EX  -LOG(1.  -BOUND)
      B0(1)     = 1.
      DO 22 J=2,JL
      R         = (J  -1)*DY
C     IF (EX.GT.0.)
C    .B0(J)     = EXP((1.  +B*R**EX)*R)
      IF (EX.GT.0.)
     .B0(J)     = EXP((EX  +B*R**2)*R)
      IF (EX.LE.0.)
     .B0(J)     = 1./(1.  -BOUND*R)
   22 CONTINUE
      RETURN
      END
C     NAME=GEOM
      SUBROUTINE  GEOM
      COMMON/LIM/ IL,JL
      COMMON/CRD/ A0(193),S0(193),B0(33),XSING1,YSING1,XSING2,YSING2,
     1            TRAIL,SLOPT,GAP,BOUND,EX,BUNCH
      COMMON/GEO/ XP(385),YP(385),NP
      DIMENSION   XS(385),YS(385),D1(385),D2(385),D3(385)
      PI        = 4.*ATAN(1.)
      XSING2    = .5*(XP(1) +XP(NP))
      YSING2    = .5*(YP(1)  +YP(NP))
      GAP       = ABS(XP(NP)  -XP(1))  +ABS(YP(NP)  -YP(1))
      Q         = 2.  -TRAIL/PI
      P         = 1./Q
      P0        = .5*(XSING2  -XSING1)
      Q0        = .5*(YSING2  -YSING1)
      ALPHA     = ATAN2(Q0,P0)
      BETA      = P*(ALPHA  -ATAN(SLOPT))
      X0        = COS(BETA)
      Y0        = SIN(BETA)
      ANGL      = -Q*(.5*PI  +BETA)
      U         = COS(ANGL)
      V         = SIN(ANGL)
      T         = BETA
      C         = 1.
      D         = 0.
      N1        = 1
      N2        = NP
      IF (GAP.GT.1.E-04) GO TO 11
      XS(1)     = 0.
      YS(1)     = 0.
      XS(NP)    = PI  +PI
      YS(NP)    = 0.
      N1        = 2
      N2        = NP  -1
   11 DO 12 N=N1,N2
      A1        = XP(N)  -XSING1
      B1        = YP(N)  -YSING1
      R1        = SQRT(A1**2  +B1**2)
      IF (R1.LE.1.E-04) GO TO 13
      A2        = XP(N)  -XSING2
      B2        = YP(N)  -YSING2
      R2        = SQRT(A2**2  +B2**2)
      R         = (R2/R1)**P
      A         = A1*A2  +B1*B2
      B         = A1*B2  -B1*A2
      ANGL      = ANGL  +ATAN2((U*B  -V*A),(U*A  +V*B))
      U         = A
      V         = B
      S         = X0/(1.  +R*(R  -2.*COS(P*ANGL)))
      A         = S*(1.  -R**2)
      B         = 2.*S*R*SIN(P*ANGL)  -Y0
      R         = SQRT(A**2  +B**2)
      T         = T  +ATAN2((C*B  -D*A),(C*A  +D*B))
      C         = A
      D         = B
      XS(N)     = -T
      YS(N)     = R  -1.
      GO TO 12
   13 ANGL      = Q*(.5*PI  +BETA)
      U         = COS(ANGL)
      V         = SIN(ANGL)
      C         = -X0
      D         = -Y0
      T         = BETA  -PI
      XS(N)     = -T
      YS(N)     = 0.
   12 CONTINUE
      CALL SPLIF  (1,NP,XS,YS,D1,D2,D3,1,0.,1,0.,0,0.,IND)
      CALL INTPL  (1,IL,A0,S0,1,NP,XS,YS,D1,D2,D3,0)
      RETURN
      END
C     NAME=MESH
      SUBROUTINE  MESH  (I2,J2,X)
C     GENERATES MESH
      COMMON/LIM/ IL,JL
      COMMON/CRD/ A0(193),S0(193),B0(33),XSING1,YSING1,XSING2,YSING2,
     1            TRAIL,SLOPT,GAP,BOUND,EX,BUNCH
      COMMON/OUT/ CP(193),SCAL,CHORD,XM,YM,CL,CD,CM
      DIMENSION   X(I2,J2,2)
      PI        = 4.*ATAN(1.)
      Q         = 2.  -TRAIL/PI
      P         = 1./Q
      P0        = .5*(XSING2  -XSING1)
      Q0        = .5*(YSING2  -YSING1)
      R0        = SQRT(P0**2  +Q0**2)
      ALPHA     = ATAN2(Q0,P0)
      BETA      = P*(ALPHA  -ATAN(SLOPT))
      X0        = COS(BETA)
      Y0        = SIN(BETA)
      SCAL      = P*R0/X0
      X1        = 1.  -2.*X0**2
      Y1        = -2.*Y0*X0
      X2        = 1.
      Y2        = 0.
      P0        = P0/SCAL
      Q0        = Q0/SCAL
      X0        = .5*(XSING2  +XSING1)/SCAL
      Y0        = .5*(YSING2  +YSING1)/SCAL
      DO 12 J=1,JL
      IA        = 1
      IB        = IL
      ANGL      = 0.
      U         = 1.
      V         = 0.
      IF (J.NE.1) GO TO 13
      ANGL      = -.5*PI  -BETA
      U         = COS(ANGL)
      V         = SIN(ANGL)
      IF (GAP.GT.1.E-04) GO TO 13
      X(1,1,1)  = X0  +P0
      X(1,1,2)  = Y0  +Q0
      X(IL,1,1) = X0  +P0
      X(IL,1,2) = Y0  +Q0
      IA        = 2
      IB        = IL  -1
   13 S1        = 1.  -(FLOAT(J  -1)/FLOAT(JL  -1))**2
      DO 12 I=IA,IB
      R         = B0(J)  +S1*S0(I)
      A         = R*COS(A0(I))
      B         = -R*SIN(A0(I))
      A1        = A  -X1
      B1        = B  -Y1
      R1        = SQRT(A1**2  +B1**2)
      IF (R1.LE.1.E-04) GO TO 15
      A2        = A  -X2
      B2        = B  -Y2
      R2        = SQRT(A2**2  +B2**2)
      R         = (R2/R1)**Q
      A         = A1*A2  +B1*B2
      B         = A1*B2  -B1*A2
      ANGL      = ANGL  +ATAN2((U*B  -V*A),(U*A  +V*B))
      U         = A
      V         = B
      S         = 1./(1.  +R*(R  -2.*COS(Q*ANGL)))
      A         = S*(1.  -R**2)
      B         = 2.*S*R*SIN(Q*ANGL)
      X(I,J,1)  = X0  +P0*A  -Q0*B
      X(I,J,2)  = Y0  +Q0*A  +P0*B
      GO TO 12
   15 ANGL      = .5*PI  +BETA
      U         = COS(ANGL)
      V         = SIN(ANGL)
      X(I,J,1)  = XSING1/SCAL
      X(I,J,2)  = YSING1/SCAL
   12 CONTINUE
      RETURN
      END
C     NAME=SPLIF
      SUBROUTINE  SPLIF(M,N,S,F,FP,FPP,FPPP,KM,VM,KN,VN,MODE,FQM,IND)
C     SPLINE FIT - JAMESON
C     INTEGRAL PLACED IN FPPP IF MODE GREATER THAN 0
C     IND SET TO ZERO IF DATA ILLEGAL
      DIMENSION   S(1),F(1),FP(1),FPP(1),FPPP(1)
      IND       = 0
      K         = ABS(N  -M)
      IF (K  -1) 81,81,1
    1 K         = (N  -M)/K
      I         = M
      J         = M  +K
      DS        = S(J)  -S(I)
      D         = DS
      IF (DS) 11,81,11
   11 DF        = (F(J)  -F(I))/DS
      IF (KM  -2) 12,13,14
   12 U         = .5
      V         = 3.*(DF  -VM)/DS
      GO TO 25
   13 U         = 0.
      V         = VM
      GO TO 25
   14 U         = -1.
      V         = -DS*VM
      GO TO 25
   21 I         = J
      J         = J  +K
      DS        = S(J)  -S(I)
      IF (D*DS) 81,81,23
   23 DF        = (F(J)  -F(I))/DS
      B         = 1./(DS  +DS  +U)
      U         = B*DS
      V         = B*(6.*DF  -V)
   25 FP(I)     = U
      FPP(I)    = V
      U         = (2.  -U)*DS
      V         = 6.*DF  +DS*V
      IF (J  -N) 21,31,21
   31 IF (KN  -2) 32,33,34
   32 V         = (6.*VN  -V)/U
      GO TO 35
   33 V         = VN
      GO TO 35
   34 V         = (DS*VN  +FPP(I))/(1.  +FP(I))
   35 B         = V
      D         = DS
   41 DS        = S(J)  -S(I)
      U         = FPP(I)  -FP(I)*V
      FPPP(I)   = (V  -U)/DS
      FPP(I)    = U
      FP(I)     = (F(J)  -F(I))/DS  -DS*(V  +U  +U)/6.
      V         = U
      J         = I
      I         = I  -K
      IF (J  -M) 41,51,41
   51 I         = N  -K
      FPPP(N)   = FPPP(I)
      FPP(N)    = B
      FP(N)     = DF  +D*(FPP(I)  +B  +B)/6.
      IND       = 1
      IF (MODE) 81,81,61
   61 FPPP(J)   = FQM
      V         = FPP(J)
   71 I         = J
      J         = J  +K
      DS        = S(J)  -S(I)
      U         = FPP(J)
      FPPP(J)   = FPPP(I)  +.5*DS*(F(I)  +F(J)  -DS*DS*(U  +V)/12.)
      V         = U
      IF (J  -N)  71,81,71
   81 RETURN
      END
C     NAME=INTPL
      SUBROUTINE  INTPL(MI,NI,SI,FI,M,N,S,F,FP,FPP,FPPP,MODE)
C     INTERPOLATION USING TAYLOR SERIES - JAMESON
C     ADDS CORRECTION FOR PIECEWISE CONSTANT FOURTH DERIVIATIVE
C     IF MODE GREATER THAN 0
      DIMENSION   SI(1),FI(1),S(1),F(1),FP(1),FPP(1),FPPP(1)
      K         = ABS(N  -M)
      K         = (N  -M)/K
      I         = M
      MIN       = MI
      NIN       = NI
      D         = S(N)  -S(M)
      IF (D*(SI(NI)  -SI(MI))) 11,13,13
   11 MIN       = NI
      NIN       = MI
   13 KI        = ABS(NIN  -MIN)
      IF (KI) 21,21,15
   15 KI        = (NIN  -MIN)/KI
   21 II        = MIN  -KI
      C         = 0.
      IF (MODE) 31,31,23
   23 C         = 1.
   31 II        = II  +KI
      SS        = SI(II)
   33 I         = I  +K
      IF (I  -N) 35,37,35
   35 IF (D*(S(I)  -SS)) 33,33,37
   37 J         = I
      I         = I  -K
      SS        = SS  -S(I)
      FPPPP     = C*(FPPP(J)  -FPPP(I))/(S(J)  -S(I))
      FF        = FPPP(I)  +.25*SS*FPPPP
      FF        = FPP(I)  +SS*FF/3.
      FF        = FP(I)  +.5*SS*FF
      FI(II)    = F(I)  +SS*FF
      IF (II  -NIN) 31,41,31
   41 RETURN
      END
C     NAME=CIRCLE
      SUBROUTINE  CIRCLE(I2,J2,X)
C     GENERATES MESH FOR CIRCLE
      COMMON/LIM/ IL,JL
      COMMON/CRD/ A0(193),S0(193),B0(33),XSING1,YSING1,XSING2,YSING2,
     .            TRAIL,SLOPT,GAP,BOUND,EX,BUNCH
      COMMON/OUT/ CP(193),SCAL,CHORD,XM,YM,CL,CD,CM
      DIMENSION   X(I2,J2,2)
      DO 12 I=1,IL
      DO 12 J=1,JL
      X(I,J,1)  = COS(A0(I))*B0(J)
   12 X(I,J,2)  = -SIN(A0(I))*B0(J)
      SCAL      = 1.
      RETURN
      END
C     NAME=XPAND
      SUBROUTINE  XPAND (I2,J2,X,II2,JJ2,XX)
C     XPANDS MESH
      COMMON/LIM/ IL,JL
      DIMENSION   X(I2,J2,2),XX(II2,JJ2,2)
      JJ        = 0
      DO 10 J=1,JL,2
      JJ        = JJ  +1
      II        = 0
      DO 10 I=1,IL,2
      II        = II  +1
      XX(II,JJ,1) = X(I,J,1)
      XX(II,JJ,2) = X(I,J,2)
   10 CONTINUE
      RETURN
      END
C     NAME=METRIC
      SUBROUTINE METRIC(I2,J2,X,VOL)
C     CELL AREAS
      COMMON/LIM/ IL,JL
      DIMENSION   X(I2,J2,2),VOL(I2,J2)
      DO 10 J=2,JL
      DO  5 I=2,IL
      VOL(I,J)  = .5*((X(I,J,1) -X(I-1,J-1,1))*(X(I-1,J,2) -X(I,J-1,2))
     .               -(X(I,J,2) -X(I-1,J-1,2))*(X(I-1,J,1) -X(I,J-1,1)))
    5 CONTINUE
      VOL(1,J)  = VOL(IL,J)
      VOL(I2,J) = VOL(2,J)
   10 CONTINUE
      DO 15 I=1,I2
      VOL(I,1)  = VOL(I,2)
      VOL(I,J2) = VOL(I,JL)
   15 CONTINUE
      RETURN
      END
C     NAME=INIT
      SUBROUTINE INIT  (I2,J2,W,P)
C     INITIAL FLOW FIELD
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      DIMENSION   W(I2,J2,4),P(I2,J2)
      DO 20 J=1,J2
      DO 20 I=1,I2
      W(I,J,1)  = RHO0
      W(I,J,2)  = RHO0*U0
      W(I,J,3)  = RHO0*V0
      W(I,J,4)  = RHO0*H0  -P0
      P(I,J)    = P0
   20 CONTINUE
      RETURN
      END
C     NAME=STEP
      SUBROUTINE STEP  (I2,J2,W,P,X,VOL,DTL)
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/FIL/ RADI(194,34),RADJ(194,34),FW(193,33,4),RFIL
      DIMENSION   W(I2,J2,4),P(I2,J2),X(I2,J2,2),VOL(I2,J2),DTL(I2,J2)
      DIMENSION   QSI(193),CSI(193),QSJ(193),CSJ(193)
      DTMIN     = 0.
      IMIN      = 0
      JMIN      = 0
      DO 20 J=2,JL
      DO 10 I=2,IL
      QQ        = .5*(W(I,J,2)**2  +W(I,J,3)**2)/W(I,J,1)
      P(I,J)    = (GAMMA  -1.)*(W(I,J,4)  -QQ)
      CC        = GAMMA*P(I,J)/W(I,J,1)
      XX        = .5*(X(I,J,1)  -X(I-1,J,1)  +X(I,J-1,1)  -X(I-1,J-1,1))
      YX        = .5*(X(I,J,2)  -X(I-1,J,2)  +X(I,J-1,2)  -X(I-1,J-1,2))
      XY        = .5*(X(I,J,1)  -X(I,J-1,1)  +X(I-1,J,1)  -X(I-1,J-1,1))
      YY        = .5*(X(I,J,2)  -X(I,J-1,2)  +X(I-1,J,2)  -X(I-1,J-1,2))
      QSI(I)    = (YY*W(I,J,2)  -XY*W(I,J,3))/W(I,J,1)
      CSI(I)    = CC*(XY**2  +YY**2)
      QSJ(I)    = (XX*W(I,J,3)  -YX*W(I,J,2))/W(I,J,1)
      CSJ(I)    = CC*(XX**2  +YX**2)
   10 CONTINUE
      DO 20 I=2,IL
      RADI(I,J) = ABS(QSI(I))  +SQRT(CSI(I))
      RADJ(I,J) = ABS(QSJ(I))  +SQRT(CSJ(I))
      DTL(I,J)  = VOL(I,J)/(RADI(I,J)  +RADJ(I,J))
   20 CONTINUE
      IF (VT.EQ.0.) GO TO 31
      DTMIN     = DTL(2,2)
      DO 30 J=2,JL
      DO 30 I=2,IL
      IF (DTL(I,J).GT.DTMIN) GO TO 30
      DTMIN     = DTL(I,J)
      IMIN      = I
      JMIN      = J
   30 CONTINUE
   31 DO 35 J=2,JL
      DTL(1,J)    = DTL(IL,J)
      DTL(I2,J)   = DTL(2,J)
      RADI(1,J)   = RADI(IL,J)
      RADI(I2,J)  = RADI(2,J)
   35 CONTINUE
      DO 40 I=1,I2
      DTL(I,1)    = DTL(I,2)
      DTL(I,J2)   = DTL(I,JL)
      RADJ(I,1)   = RADJ(I,2)
      RADJ(I,J2)  = RADJ(I,JL)
   40 CONTINUE
      RETURN
      END
C     NAME=EULER
      SUBROUTINE EULER (I2,J2,W,W1,P,X,VOL,DTL,WR)
C     FOUR EQUATION MODEL
C     MULTI STAGE RUNGE KUTTA SCHEME WITH SMOOTHING
C     CENTRAL DIFFERENCES WITH ADDED ARTIFICIAL VISCOSITY
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/CNV/ RTRMS,RTMAX,IRT,JRT,HRMS,HMAX,IH,JH,NSUP
      COMMON/RKC/ C(6)
      COMMON/FIL/ RADI(194,34),RADJ(194,34),FW(193,33,4),RFIL
      COMMON/ADD/ DW(194,34,4)
      COMMON/MGR/ KODE,MODE
      DIMENSION   W(I2,J2,4),W1(I2,J2,4),WR(I2,J2,4),P(I2,J2),
     .            X(I2,J2,2),VOL(I2,J2),DTL(I2,J2)
      MDISSP    = 1
      IF (QFIL.GT.0.) MDISSP = 2
      IF (KODE.LT.2) GO TO 11
      DO 10 J=2,J2
      DO 10 I=1,I2
      QQ        = .5*(W(I,J,2)**2  +W(I,J,3)**2)/W(I,J,1)
      P(I,J)    = (GAMMA  -1.)*(W(I,J,4)  -QQ)
   10 CONTINUE
      CALL BCWALL(I2,J2,W,P,X)
   11 ISMOOP    = 0
      IF (SMOOPI.NE.0..OR.SMOOPJ.NE.0.) ISMOOP = 1
      IF (MOD(MSTAGE,2).EQ.0.AND.(SMOOPI.LT.0..OR.SMOOPJ.LT.0.))
     .ISMOOP    = -1
      M         = 1
      DO 15 J=2,JL
      DO 15 I=2,IL
      FW(I,J,1) = 0.
      FW(I,J,2) = 0.
      FW(I,J,3) = 0.
      FW(I,J,4) = 0.
   15 CONTINUE
      RFIL      = 1.
      IF (MODE.EQ.0) CALL DFLUX (I2,J2,W,P,VOL,DTL)
      IF (MODE.GT.0) CALL DFLUXC(I2,J2,W,P,VOL,DTL)
      IF (KODE.LE.0) GO TO 21
      DO 20 J=1,J2
      DO 20 I=1,I2
      W1(I,J,1) = W(I,J,1)
      W1(I,J,2) = W(I,J,2)
      W1(I,J,3) = W(I,J,3)
      W1(I,J,4) = W(I,J,4)
   20 CONTINUE
   21 FN        = .5*C(M)*CFL
      FT        = (1.  -VT)*FN
      GT        = VT*FN*DTMIN
      CALL EFLUX (I2,J2,W,P,X)
      DO 40 J=2,JL
      DO 40 I=2,IL
      DW(I,J,1) = DW(I,J,1)  +FW(I,J,1)
      DW(I,J,2) = DW(I,J,2)  +FW(I,J,2)
      DW(I,J,3) = DW(I,J,3)  +FW(I,J,3)
      DW(I,J,4) = DW(I,J,4)  +FW(I,J,4)
   40 CONTINUE
      IF (MODE.EQ.0) GO TO 45
      IF (KODE.LT.2.OR.M.GT.1) GO TO 43
      DO 42 J=2,JL
      DO 42 I=2,IL
      WR(I,J,1) = WR(I,J,1)  -DW(I,J,1)
      WR(I,J,2) = WR(I,J,2)  -DW(I,J,2)
      WR(I,J,3) = WR(I,J,3)  -DW(I,J,3)
      WR(I,J,4) = WR(I,J,4)  -DW(I,J,4)
   42 CONTINUE
   43 DO 44 J=2,JL
      DO 44 I=2,IL
      DW(I,J,1) = DW(I,J,1)  +WR(I,J,1)
      DW(I,J,2) = DW(I,J,2)  +WR(I,J,2)
      DW(I,J,3) = DW(I,J,3)  +WR(I,J,3)
      DW(I,J,4) = DW(I,J,4)  +WR(I,J,4)
   44 CONTINUE
   45 IF (KODE.LE.0) RETURN
      DO 46 J=2,JL
      DO 46 I=2,IL
      DT        = (FT*DTL(I,J)  +GT)/VOL(I,J)
      DW(I,J,1) = DT*DW(I,J,1)
      DW(I,J,2) = DT*DW(I,J,2)
      DW(I,J,3) = DT*DW(I,J,3)
      DW(I,J,4) = DT*DW(I,J,4)
   46 CONTINUE
      IF (ISMOOP.GT.0) CALL PSMOO
      DO 50 J=2,JL
      DO 48 I=2,IL
      W(I,J,1)  = W1(I,J,1)  -DW(I,J,1)
      W(I,J,2)  = W1(I,J,2)  -DW(I,J,2)
      W(I,J,3)  = W1(I,J,3)  -DW(I,J,3)
      W(I,J,4)  = W1(I,J,4)  -DW(I,J,4)
      QQ        = .5*(W(I,J,2)**2  +W(I,J,3)**2)/W(I,J,1)
      P(I,J)    = (GAMMA  -1.)*(W(I,J,4)  -QQ)
   48 CONTINUE
      W(1,J,1)  = W(IL,J,1)
      W(1,J,2)  = W(IL,J,2)
      W(1,J,3)  = W(IL,J,3)
      W(1,J,4)  = W(IL,J,4)
      P(1,J)    = P(IL,J)
      W(I2,J,1) = W(2,J,1)
      W(I2,J,2) = W(2,J,2)
      W(I2,J,3) = W(2,J,3)
      W(I2,J,4) = W(2,J,4)
      P(I2,J)   = P(2,J)
   50 CONTINUE
      IF (M.EQ.MSTAGE) GO TO 51
      CALL BCWALL(I2,J2,W,P,X)
      M         = M  +1
      RFIL      = QFIL
      IF (M.LE.MDISSP.AND.MODE.EQ.0) CALL DFLUX (I2,J2,W,P,VOL,DTL)
      IF (M.LE.MDISSP.AND.MODE.GT.0) CALL DFLUXC(I2,J2,W,P,VOL,DTL)
      IF (SMOOPI.LT.0..OR.SMOOPJ.LT.0.) ISMOOP    = -ISMOOP
      GO TO 21
   51 IF (MODE.GT.0.OR.HM.LE.0.) GO TO 61
      DO 60 J=2,JL
      DO 55 I=2,IL
      RH        = W(I,J,4)  +P(I,J)  -W(I,J,1)*H0
      F         = 1./(1.  +HM*RH/W(I,J,1))
      W(I,J,1)  = F*W(I,J,1)
      W(I,J,2)  = F*W(I,J,2)
      W(I,J,3)  = F*W(I,J,3)
      W(I,J,4)  = RH/(1.  +HM)  -P(I,J)  +W(I,J,1)*H0
      QQ        = .5*(W(I,J,2)**2  +W(I,J,3)**2)/W(I,J,1)
      P(I,J)    = (GAMMA  -1.)*(W(I,J,4)  -QQ)
   55 CONTINUE
      W(1,J,1)  = W(IL,J,1)
      W(1,J,2)  = W(IL,J,2)
      W(1,J,3)  = W(IL,J,3)
      W(1,J,4)  = W(IL,J,4)
      P(1,J)    = P(IL,J)
      W(I2,J,1) = W(2,J,1)
      W(I2,J,2) = W(2,J,2)
      W(I2,J,3) = W(2,J,3)
      W(I2,J,4) = W(2,J,4)
      P(I2,J)   = P(2,J)
   60 CONTINUE
   61 CALL BCWALL(I2,J2,W,P,X)
      IF (MODE.EQ.0) CALL BCFAR (I2,J2,W,P,X)
      IF (MODE.GT.0) RETURN
      HRMS      = 0.
      HMAX      = 0.
      IH        = 0
      JH        = 0
      RTRMS     = 0.
      RTMAX     = 0.
      IRT       = 0
      JRT       = 0
      MLOC      = NSUP
      NSUP      = 0
      DO 70 J=2,JL
      DO 70 I=2,IL
      QQ        = (W(I,J,2)**2  +W(I,J,3)**2)/W(I,J,1)
      NSUP      = NSUP  +MIN(1.,QQ/(GAMMA*P(I,J)))
      H         = (W(I,J,4)  +P(I,J))/W(I,J,1)  -H0
      HRMS      = HRMS  +H**2
      DT        = CFL*((1.  -VT)*DTL(I,J)  +VT*DTMIN)
      RT        = DW(I,J,1)/DT
      RTRMS     = RTRMS  +RT**2
   70 CONTINUE
      RTRMS     = SQRT(RTRMS/FLOAT((IL  -1)*(JL  -1)))
      HRMS      = SQRT(HRMS/FLOAT((IL  -1)*(JL  -1)))
      IF (MLOC.LT.0) RETURN
      DO 80 J=2,JL
      DO 80 I=2,IL
      H         = (W(I,J,4)  +P(I,J))/W(I,J,1)  -H0
      IF (ABS(H).LE.ABS(HMAX)) GO TO 75
      HMAX      = H
      IH        = I
      JH        = J
   75 DT        = CFL*((1.  -VT)*DTL(I,J)  +VT*DTMIN)
      RT        = DW(I,J,1)/DT
      IF (ABS(RT).LE.ABS(RTMAX)) GO TO 80
      RTMAX     = RT
      IRT       = I
      JRT       = J
   80 CONTINUE
      RETURN
      END
C     NAME=EFLUX
      SUBROUTINE EFLUX (I2,J2,W,P,X)
C     EULER FLUXES
      COMMON/LIM/ IL,JL
      COMMON/ADD/ DW(194,34,4)
CSRD  COMMON/FLX/ FS(193,33,4)
      COMMON/FLX/ FS(193,34,4)
      DIMENSION   W(I2,J2,4),P(I2,J2),X(I2,J2,2)
      DO 10 J=2,JL
      DO 10 I=1,IL
      XY        = X(I,J,1)  -X(I,J-1,1)
      YY        = X(I,J,2)  -X(I,J-1,2)
      PA        = P(I+1,J)  +P(I,J)
      QSP       = (YY*W(I+1,J,2)  -XY*W(I+1,J,3))/W(I+1,J,1)
      QSM       = (YY*W(I,J,2)  -XY*W(I,J,3))/W(I,J,1)
      FS(I,J,1) = QSP*W(I+1,J,1)  +QSM*W(I,J,1)
      FS(I,J,2) = QSP*W(I+1,J,2)  +QSM*W(I,J,2)  +YY*PA
      FS(I,J,3) = QSP*W(I+1,J,3)  +QSM*W(I,J,3)  -XY*PA
      FS(I,J,4) = QSP*(W(I+1,J,4)  +P(I+1,J))  +QSM*(W(I,J,4)  +P(I,J))
   10 CONTINUE
      DO 20 N=1,4
      DO 20 J=2,JL
      DO 20 I=2,IL
      DW(I,J,N) = FS(I,J,N)  -FS(I-1,J,N)
   20 CONTINUE
      DO 25 I=2,IL
      XX        = X(I,1,1)  -X(I-1,1,1)
      YX        = X(I,1,2)  -X(I-1,1,2)
      PA        = P(I,2)    +P(I,1)
      FS(I,1,1) = 0.
      FS(I,1,2) = -YX*PA
      FS(I,1,3) =  XX*PA
      FS(I,1,4) = 0.
   25 CONTINUE
      DO 30 J=2,JL
      DO 30 I=2,IL
      XX        = X(I,J,1)  -X(I-1,J,1)
      YX        = X(I,J,2)  -X(I-1,J,2)
      PA        = P(I,J+1)  +P(I,J)
      QSP       = (XX*W(I,J+1,3)  -YX*W(I,J+1,2))/W(I,J+1,1)
      QSM       = (XX*W(I,J,3)  -YX*W(I,J,2))/W(I,J,1)
      FS(I,J,1) = QSP*W(I,J+1,1)  +QSM*W(I,J,1)
      FS(I,J,2) = QSP*W(I,J+1,2)  +QSM*W(I,J,2)  -YX*PA
      FS(I,J,3) = QSP*W(I,J+1,3)  +QSM*W(I,J,3)  +XX*PA
      FS(I,J,4) = QSP*(W(I,J+1,4)  +P(I,J+1))  +QSM*(W(I,J,4)  +P(I,J))
   30 CONTINUE
      DO 40 N=1,4
      DO 40 J=2,JL
      DO 40 I=2,IL
      DW(I,J,N) = DW(I,J,N)  +FS(I,J,N)  -FS(I,J-1,N)
   40 CONTINUE
      RETURN
      END
C     NAME=DFLUX
      SUBROUTINE DFLUX (I2,J2,W,P,VOL,DTL)
C     FOUR EQUATION MODEL
C     BLENDED SECOND AND FOURTH DIFFERENCES
      COMMON/LIM/ IL,JL
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/FIL/ RADI(194,34),RADJ(194,34),FW(193,33,4),RFIL
CSRD  COMMON/FLX/ FS(193,33,4)
      COMMON/FLX/ FS(193,34,4)
C
      COMMON/ADD/ DW(194,34,4)
      COMMON/SYM/ ISYM
      DIMENSION   W(I2,J2,4),P(I2,J2),VOL(I2,J2),DTL(I2,J2)
CSRD  DIMENSION   DP(195,33),EP(193,33),DIS2(193,33),DIS4(193,33)
      DIMENSION   DP(195,35),EP(193,33),DIS2(193,33),DIS4(193,33)
C
      SFIL      = 1.  -RFIL
      FIS2      = .5*RFIL*VIS2
      FIS4      = RFIL*VIS4/64.
      DO 30 J=2,JL
      DO 10 I=2,IL
      DP(I,J)   = ABS((P(I+1,J)  -2.*P(I,J)  +P(I-1,J))/
     .                (P(I+1,J)  +2.*P(I,J)  +P(I-1,J)))
   10 CONTINUE
      IF (ISYM.LT.0) GO TO 11
      DP(2,J)     = 0.
      DP(IL,J)    = 0.
   11 DP(1,J)     = DP(IL,J)
      DP(IL+1,J)  = DP(2,J)
      DP(IL+2,J)  = DP(3,J)
      DO 12 I=2,IL
      EP(I,J)   = MAX(DP(I-1,J),DP(I,J),DP(I+1,J),DP(I+2,J))
   12 CONTINUE
C     IF (ISYM.GE.0) EP(IL,J) = 0.
      EP(1,J)   = EP(IL,J)
      IF (VIS0.LT.0.) GO TO 15
      DO 14 I=1,IL
      FIL       = VOL(I+1,J)/DTL(I+1,J)  +VOL(I,J)/DTL(I,J)
      DIS2(I,J) = FIL*FIS2*EP(I,J)
      DIS4(I,J) = FIL*FIS4
      DIS4(I,J) = DIM(DIS4(I,J),DIS2(I,J))
   14 CONTINUE
      GO TO 17
   15 DO 16 I=1,IL
      FIL       = RADI(I+1,J)  +RADI(I,J)
      DIS2(I,J) = FIL*FIS2*EP(I,J)
      DIS4(I,J) = FIL*FIS4
      DIS4(I,J) = DIM(DIS4(I,J),DIS2(I,J))
   16 CONTINUE
   17 DO 18 N=1,4
      DO 18 I=1,IL
      FS(I,J,N) = W(I+1,J,N)  -W(I,J,N)
   18 CONTINUE
      DO 20 I=1,IL
      FS(I,J,4) = FS(I,J,4)  +P(I+1,J)  -P(I,J)
   20 CONTINUE
      DO 30 N=1,4
      IF (ISYM.LT.0) GO TO 25
      FS(1,J,N)   = FS(2,J,N)
      FS(IL,J,N)  = FS(IL-1,J,N)
   25 FS(I2,J,N)  = FS(2,J,N)
      DO 26 I=2,IL
      DW(I,J,N) = FS(I+1,J,N)  -2.*FS(I,J,N)  +FS(I-1,J,N)
   26 CONTINUE
      IF (ISYM.LT.0) GO TO 27
      DW(IL,J,N)  = 0.
   27 DW(1,J,N)   = DW(IL,J,N)
      DO 28 I=1,IL
      FS(I,J,N) = DIS2(I,J)*FS(I,J,N)  -DIS4(I,J)*DW(I,J,N)
   28 CONTINUE
      DO 30 I=2,IL
      FW(I,J,N) = SFIL*FW(I,J,N)  -FS(I,J,N)  +FS(I-1,J,N)
   30 CONTINUE
      DO 38 J=3,JL
      DO 38 I=2,IL
      DP(I,J)   = ABS((P(I,J+1)  -2.*P(I,J)  +P(I,J-1))/
     .                (P(I,J+1)  +2.*P(I,J)  +P(I,J-1)))
   38 CONTINUE
      DO 40 I=2,IL
      DP(I,1)     = 0.
      DP(I,2)     = 0.
      DP(I,JL+1)  = 0.
      DP(I,JL+2)  = 0.
   40 CONTINUE
      DO 42 J=2,JL
      DO 42 I=2,IL
      EP(I,J)   = MAX(DP(I,J-1),DP(I,J),DP(I,J+1),DP(I,J+2))
   42 CONTINUE
      EP(I,1)   = EP(I,2)
      IF (VIS0.LT.0.) GO TO 45
      DO 44 J=1,JL
      DO 44 I=2,IL
      FIL       = VOL(I,J+1)/DTL(I,J+1)  +VOL(I,J)/DTL(I,J)
      DIS2(I,J) = FIL*FIS2*EP(I,J)
      DIS4(I,J) = FIL*FIS4
      DIS4(I,J) = DIM(DIS4(I,J),DIS2(I,J))
   44 CONTINUE
      GO TO 47
   45 DO 46 J=1,JL
      DO 46 I=2,IL
      FIL       = RADJ(I,J+1)  +RADJ(I,J)
      DIS2(I,J) = FIL*FIS2*EP(I,J)
      DIS4(I,J) = FIL*FIS4
      DIS4(I,J) = DIM(DIS4(I,J),DIS2(I,J))
   46 CONTINUE
   47 DO 48 N=1,4
      DO 48 J=2,JL
      DO 48 I=2,IL
      FS(I,J,N) = W(I,J+1,N)  -W(I,J,N)
   48 CONTINUE
      DO 50 J=2,JL
      DO 50 I=2,IL
      FS(I,J,4) = FS(I,J,4)  +P(I,J+1)  -P(I,J)
   50 CONTINUE
      DO 60 N=1,4
      DO 52 I=2,IL
      FS(I,1,N)     = FS(I,2,N)
      FS(I,JL+1,N)  = FS(I,JL,N)
   52 CONTINUE
      DO 54 J=2,JL
      DO 54 I=2,IL
      DW(I,J,N) = FS(I,J+1,N)  -2.*FS(I,J,N)  +FS(I,J-1,N)
   54 CONTINUE
      DO 56 I=2,IL
      DW(I,1,N) = 0.
   56 CONTINUE
      DO 58 J=1,JL
      DO 58 I=2,IL
      FS(I,J,N) = DIS2(I,J)*FS(I,J,N)  -DIS4(I,J)*DW(I,J,N)
   58 CONTINUE
      DO 60 J=2,JL
      DO 60 I=2,IL
      FW(I,J,N) = FW(I,J,N)  -FS(I,J,N)  +FS(I,J-1,N)
   60 CONTINUE
      RETURN
      END
C     NAME=DFLUXC
      SUBROUTINE DFLUXC(I2,J2,W,P,VOL,DTL)
C     FOUR EQUATION MODEL
C     SECOND DIFFERENCES WITH FIXED COEFFICIENT
      COMMON/LIM/ IL,JL
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/FIL/ RADI(194,34),RADJ(194,34),FW(193,33,4),RFIL
CSRD  COMMON/FLX/ FS(193,33,4)
      COMMON/FLX/ FS(193,34,4)
      DIMENSION   W(I2,J2,4),P(I2,J2),VOL(I2,J2),DTL(I2,J2)
      DIMENSION   DIS(193,33)
      SFIL      = 1.  -RFIL
      FIS0      = RFIL*ABS(VIS0)/32.
      DO 20 J=2,JL
      IF (VIS0.LT.0.) GO TO 13
      DO 12 I=1,IL
      DIS(I,J)  = FIS0*(VOL(I+1,J)/DTL(I+1,J)  +VOL(I,J)/DTL(I,J))
   12 CONTINUE
      GO TO 15
   13 DO 14 I=1,IL
      DIS(I,J)  = FIS0*(RADI(I+1,J)  +RADI(I,J))
   14 CONTINUE
   15 DO 16 N=1,4
      DO 16 I=1,IL
      FS(I,J,N) = DIS(I,J)*(W(I+1,J,N)  -W(I,J,N))
   16 CONTINUE
      DO 18 I=1,IL
      FS(I,J,4) = FS(I,J,4)  +DIS(I,J)*(P(I+1,J)  -P(I,J))
   18 CONTINUE
      DO 20 N=1,4
      DO 20 I=2,IL
      FW(I,J,N) = SFIL*FW(I,J,N)  -FS(I,J,N) +FS(I-1,J,N)
   20 CONTINUE
      IF (VIS0.LT.0.) GO TO 33
      DO 32 J=1,JL
      DO 32 I=2,IL
      DIS(I,J)  = FIS0*(VOL(I,J+1)/DTL(I,J+1)  +VOL(I,J)/DTL(I,J))
   32 CONTINUE
      GO TO 35
   33 DO 34 J=1,JL
      DO 34 I=2,IL
      DIS(I,J)  = FIS0*(RADJ(I,J+1)  +RADJ(I,J))
   34 CONTINUE
   35 DO 36 N=1,4
      DO 36 J=1,JL
      DO 36 I=2,IL
      FS(I,J,N) = DIS(I,J)*(W(I,J+1,N)  -W(I,J,N))
   36 CONTINUE
      DO 38 J=1,JL
      DO 38 I=2,IL
      FS(I,J,4) = FS(I,J,4)  +DIS(I,J)*(P(I,J+1)  -P(I,J))
   38 CONTINUE
      DO 40 N=1,4
      DO 40 J=2,JL
      DO 40 I=2,IL
      FW(I,J,N) = FW(I,J,N)  -FS(I,J,N)  +FS(I,J-1,N)
   40 CONTINUE
      RETURN
      END
C     NAME=PSMOO
      SUBROUTINE PSMOO
      COMMON/LIM/ IL,JL
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/ADD/ DW(194,34,4)
      A         = ABS(SMOOPI)
      R         = A/(A  +.5  +SQRT(A  +.25))
      T         = 1./(1.  +R)
      DO 40 N=1,4
      DO 10 J=2,JL
      DW(1,J,N) = 0.
   10 CONTINUE
      DO 20 I=2,IL
      DO 20 J=2,JL
      DW(I,J,N) = DW(I,J,N)  -R*(DW(I,J,N)  -DW(I-1,J,N))
   20 CONTINUE
      I         = IL
      DO 30 J=2,JL
      DW(I,J,N) = T*DW(I,J,N)
   30 CONTINUE
      DO 40 II=3,IL
      I         = I  -1
      DO 40 J=2,JL
      DW(I,J,N) = DW(I,J,N)  -R*(DW(I,J,N)  -DW(I+1,J,N))
   40 CONTINUE
      A         = ABS(SMOOPJ)
      R         = A/(A  +.5  +SQRT(A  +.25))
      T         = 1./(1.  +R)
      DO 80 N=1,4
      DO 50 I=2,IL
      DW(I,1,N) = 0.
   50 CONTINUE
      DO 60 J=2,JL
      DO 60 I=2,IL
      DW(I,J,N) = DW(I,J,N)  -R*(DW(I,J,N)  -DW(I,J-1,N))
   60 CONTINUE
      J         = JL
      DO 70 I=2,IL
      DW(I,J,N) = T*DW(I,J,N)
   70 CONTINUE
      DO 80 JJ=3,JL
      J         = J  -1
      DO 80 I=2,IL
      DW(I,J,N) = DW(I,J,N)  -R*(DW(I,J,N)  -DW(I,J+1,N))
   80 CONTINUE
      RETURN
      END
C     NAME=BCFAR
      SUBROUTINE BCFAR (I2,J2,W,P,X)
C     FAR FIELD BOUNDARY CONDITION
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/OUT/ CP(193),SCAL,CHORD,XM,YM,CL,CD,CM
      DIMENSION   W(I2,J2,4),P(I2,J2),X(I2,J2,2)
      PI        = 4.*ATAN(1.)
      GMG       = (GAMMA  -1.)/GAMMA
      GM        = 1./(GAMMA  -1.)
      GMM       = GAMMA*RM**2
      A         = (2.*GM  +1.)*GM
      S0        = RHO0**GAMMA/P0
      DO 10 I=2,IL
      CP(I)     = ((P(I,2)  +P(I,1))/P0  -2.)/GMM
   10 CONTINUE
      CALL FORCF (I2,J2,X)
      IF (RM.GE.1.) GO TO 41
      X0        = X(1,1,1)  -.5*CHORD/SCAL
      BETA      = SQRT(1.  -RM**2)
      CIRC      = .25*CHORD*CL*RM*C0*BETA/(PI*SCAL)
      IF (BC.GE.0.) GO TO 21
      DO 20 I=2,IL
      XX        = X(I,JL,1)  -X(I-1,JL,1)
      YX        = X(I,JL,2)  -X(I-1,JL,2)
      QN        = XX*W(I,JL,3)  -YX*W(I,JL,2)
      IF (QN.GT.0.) GO TO 15
      XA        = .5*(X(I,JL,1)  +X(I-1,JL,1))  -X0
      YA        = .5*(X(I,JL,2)  +X(I-1,JL,2))
      R         = SQRT(XA**2  +YA**2)
      ANGL      = ATAN2(YA,XA)
      C         = COS(ANGL)
      S         = SIN(ANGL)
      QV        = CIRC/(R*(1.  -(RM*(S*CA  -C*SA))**2))
      UF        = U0  +QV*S
      VF        = V0  -QV*C
      P(I,J2)   = P(I,JL)
      W(I,J2,1) = P(I,J2)/(GMG*(H0  -.5*(UF**2  +VF**2)))
      W(I,J2,2) = W(I,J2,1)*UF
      W(I,J2,3) = W(I,J2,1)*VF
      W(I,J2,4) = W(I,J2,1)*H0  -P(I,J2)
      GO TO 20
   15 U         = W(I,JL,2)/W(I,JL,1)
      V         = W(I,JL,3)/W(I,JL,1)
      W(I,J2,1) = P0/(GMG*(H0  -.5*(U**2  +V**2)))
      W(I,J2,2) = W(I,J2,1)*U
      W(I,J2,3) = W(I,J2,1)*V
      W(I,J2,4) = W(I,J2,1)*H0  -P0
   20 CONTINUE
      GO TO 51
   21 IF (BC.GT.0.) GO TO 31
      DO 30 I=2,IL
      XA        = .5*(X(I,JL,1)  +X(I-1,JL,1))  -X0
      YA        = .5*(X(I,JL,2)  +X(I-1,JL,2))
      R         = SQRT(XA**2  +YA**2)
      ANGL      = ATAN2(YA,XA)
      C         = COS(ANGL)
      S         = SIN(ANGL)
      QV        = CIRC/(R*(1.  -(RM*(S*CA  -C*SA))**2))
      UF        = U0  +QV*S
      VF        = V0  -QV*C
      CF        = SQRT((GAMMA  -1.)*(H0  -.5*(UF**2  +VF**2)))
      XX        = X(I,JL,1)  -X(I-1,JL,1)
      YX        = X(I,JL,2)  -X(I-1,JL,2)
      D         = 1./SQRT(XX**2  +YX**2)
      XX        = XX*D
      YX        = YX*D
      U         = W(I,JL,2)/W(I,JL,1)
      V         = W(I,JL,3)/W(I,JL,1)
      C         = SQRT(GAMMA*P(I,JL)/W(I,JL,1))
      ER        = XX*V   -YX*U   +2.*GM*C
      FR        = XX*VF  -YX*UF  -2.*GM*CF
      C         = .25*(ER  -FR)/GM
      QN        = .5*(ER  +FR)
      QT        = XX*UF  +YX*VF
      S         = S0
      IF (QN.LE.0.) GO TO 25
      QT        = XX*U   +YX*V
      S         = W(I,JL,1)**GAMMA/P(I,JL)
   25 U         = XX*QT  -YX*QN
      V         = XX*QN  +YX*QT
      CC        = C**2/GAMMA
      W(I,J2,1) = (S*CC)**GM
      W(I,J2,2) = W(I,J2,1)*U
      W(I,J2,3) = W(I,J2,1)*V
      P(I,J2)   = W(I,J2,1)*CC
      W(I,J2,4) = W(I,J2,1)*H0  -P(I,J2)
   30 CONTINUE
      GO TO 51
   31 DO 40 I=2,IL
      XA        = .5*(X(I,JL,1)  +X(I-1,JL,1))  -X0
      YA        = .5*(X(I,JL,2)  +X(I-1,JL,2))
      R         = SQRT(XA**2  +YA**2)
      ANGL      = ATAN2(YA,XA)
      C         = COS(ANGL)
      S         = SIN(ANGL)
      QV        = CIRC/(R*(1.  -(RM*(S*CA  -C*SA))**2))
      UF        = U0  +QV*S
      VF        = V0  -QV*C
      CF        = SQRT((GAMMA  -1.)*(H0  -.5*(UF**2  +VF**2)))
      XX        = X(I,JL,1)  -X(I-1,JL,1)
      YX        = X(I,JL,2)  -X(I-1,JL,2)
      D         = 1./SQRT(XX**2  +YX**2)
      XX        = XX*D
      YX        = YX*D
      U         = W(I,JL,2)/W(I,JL,1)
      V         = W(I,JL,3)/W(I,JL,1)
      C         = SQRT(GAMMA*P(I,JL)/W(I,JL,1))
      QN        = XX*V   -YX*U
      S         = S0
      QT        = XX*UF  +YX*VF
      R         = XX*V   -YX*U  +2.*GM*C
      T         = -1.
      IF (QN.LE.0.) GO TO 35
      S         = W(I,JL,1)**GAMMA/P(I,JL)
      QT        = XX*U   +YX*V
      R         = XX*VF  -YX*UF  -2.*GM*CF
      T         = 1.
   35 B         = -T*GM*R
      C         = .5*(R**2  +QT**2)  -H0
      C         = (SQRT(B**2  -A*C)  +B)/A
      QN        = R  +2.*T*GM*C
      U         = XX*QT  -YX*QN
      V         = XX*QN  +YX*QT
      CC        = C**2/GAMMA
      W(I,J2,1) = (S*CC)**GM
      W(I,J2,2) = W(I,J2,1)*U
      W(I,J2,3) = W(I,J2,1)*V
      P(I,J2)   = W(I,J2,1)*CC
      W(I,J2,4) = W(I,J2,1)*H0  -P(I,J2)
   40 CONTINUE
      GO TO 51
   41 DO 50 I=2,IL
      XX        = X(I,JL,1)  -X(I-1,JL,1)
      YX        = X(I,JL,2)  -X(I-1,JL,2)
      QN        = XX*W(I,JL,3)  -YX*W(I,JL,2)
      IF (QN.LE.0.) GO TO 50
      W(I,J2,1) = W(I,JL,1)
      W(I,J2,2) = W(I,JL,2)
      W(I,J2,3) = W(I,JL,3)
      W(I,J2,4) = W(I,JL,4)
      P(I,J2)   = P(I,JL)
   50 CONTINUE
   51 W(1,J2,1)   = W(IL,J2,1)
      W(1,J2,2)   = W(IL,J2,2)
      W(1,J2,3)   = W(IL,J2,3)
      W(1,J2,4)   = W(IL,J2,4)
      P(1,J2)     = P(IL,J2)
      W(I2,J2,1)  = W(2,J2,1)
      W(I2,J2,2)  = W(2,J2,2)
      W(I2,J2,3)  = W(2,J2,3)
      W(I2,J2,4)  = W(2,J2,4)
      P(I2,J2)    = P(2,J2)
      RETURN
      END
C     NAME=BCWALL
      SUBROUTINE BCWALL(I2,J2,W,P,X)
C     SURFACE PRESSURE
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/PRM/ DTMIN,IMIN,JMIN,CFL,VT,HM,
     .            QFIL,VIS0,VIS2,VIS4,BC,SMOOPI,SMOOPJ,MSTAGE
      COMMON/SYM/ ISYM
      DIMENSION   W(I2,J2,4),P(I2,J2),X(I2,J2,2)
      DIMENSION   XX(194),YX(194),SX(194),XXX(194),YXX(194)
      DO 10 I=2,IL
      A         = X(I,1,1)  -X(I-1,1,1)
      B         = X(I,1,2)  -X(I-1,1,2)
      SX(I)     = 1./SQRT(A**2  +B**2)
      XX(I)     = A*SX(I)
      YX(I)     = B*SX(I)
   10 CONTINUE
      SX(1)     = SX(IL)
      XX(1)     = XX(IL)
      YX(1)     = YX(IL)
      SX(I2)    = SX(2)
      XX(I2)    = XX(2)
      YX(I2)    = YX(2)
      IF (ISYM.LT.0) GO TO 11
      A         = X(1,1,1)  -X(1,2,1)
      B         = X(1,1,2)  -X(1,2,2)
      SX(1)     = 1./SQRT(A**2  +B**2)
      XX(1)     = A*SX(1)
      YX(1)     = B*SX(1)
      A         = X(IL,2,1)  -X(IL,1,1)
      B         = X(IL,2,2)  -X(IL,1,2)
      SX(I2)    = 1./SQRT(A**2  +B**2)
      XX(I2)    = A*SX(I2)
      YX(I2)    = B*SX(I2)
   11 DO 20 I=2,IL
      XXX(I)    = .5*(XX(I+1)  -XX(I-1))
      YXX(I)    = .5*(YX(I+1)  -YX(I-1))
   20 CONTINUE
      IF (ISYM.LT.2) GO TO 21
      ILE       = I2/2
      A         = X(ILE,2,1)  -X(ILE,1,1)
      B         = X(ILE,2,2)  -X(ILE,1,2)
      SXN       = 1./SQRT(A**2  +B**2)
      XXN       = A*SXN
      YXN       = B*SXN
      XXX(ILE)    = .5*(XXN  -XX(ILE-1))
      YXX(ILE)    = .5*(YXN  -YX(ILE-1))
      XXX(ILE+1)  = .5*(XX(ILE+2)  +XXN)
      YXX(ILE+1)  = .5*(YX(ILE+2)  +YXN)
   21 DO 30 I=2,IL
      QT        = XX(I)*W(I,2,2)  +YX(I)*W(I,2,3)
      QN        = YX(I)*W(I,2,2)  -XX(I)*W(I,2,3)
      W(I,1,1)  = W(I,2,1)
      W(I,1,2)  = XX(I)*QT  -YX(I)*QN
      W(I,1,3)  = XX(I)*QN  +YX(I)*QT
      RA        = W(I,2,1)  +W(I,1,1)
      RUA       = W(I,2,2)  +W(I,1,2)
      RVA       = W(I,2,3)  +W(I,1,3)
      PX        = .5*(P(I+1,2)  -P(I-1,2))
      XY        = .5*(X(I,2,1)  -X(I,1,1)  +X(I-1,2,1)  -X(I-1,1,1))
      YY        = .5*(X(I,2,2)  -X(I,1,2)  +X(I-1,2,2)  -X(I-1,1,2))
      QS        = (YY*RUA  -XY*RVA)/RA
      GXY       = XX(I)*XY  +YX(I)*YY
      QXY       = .5*QS*(XXX(I)*RVA  -YXX(I)*RUA)
      PY        = (PX*GXY  +QXY)*SX(I)
      P(I,1)    = DIM(P(I,2),PY)
      W(I,1,4)  = W(I,2,4)  +P(I,2)  -P(I,1)
   30 CONTINUE
      W(1,1,1)  = W(IL,1,1)
      W(1,1,2)  = W(IL,1,2)
      W(1,1,3)  = W(IL,1,3)
      W(1,1,4)  = W(IL,1,4)
      P(1,1)    = P(IL,1)
      W(I2,1,1) = W(2,1,1)
      W(I2,1,2) = W(2,1,2)
      W(I2,1,3) = W(2,1,3)
      W(I2,1,4) = W(2,1,4)
      P(I2,1)   = P(2,1)
      RETURN
      END
C     NAME=COLLC
      SUBROUTINE  COLLC (I2,J2,W,VOL,II2,JJ2,WW,WR)
C     COLLECTS RESIDUALS FOR THE NEXT MESH
      COMMON/LIM/ IL,JL
      COMMON/ADD/ DW(194,34,4)
      COMMON/MGR/ KODE,MODE
      DIMENSION   W(I2,J2,4),VOL(I2,J2),WW(II2,JJ2,4),WR(II2,JJ2,4)
      IIL       = II2  -1
      DO 10 N=1,4
      JJ        = 1
      DO 10 J=2,JL,2
      JJ        = JJ  +1
      II        = 1
      DO 10 I=2,IL,2
      II        = II  +1
      WR(II,JJ,N) = DW(I,J,N)     +DW(I+1,J,N)
     .             +DW(I,J+1,N)   +DW(I+1,J+1,N)
   10 CONTINUE
      DO 20 N=1,4
      DO 20 J=1,J2
      DO 20 I=1,I2
      DW(I,J,N)   = VOL(I,J)*W(I,J,N)
   20 CONTINUE
      DO 30 N=1,4
      JJ        = 1
      DO 30 J=2,JL,2
      JJ        = JJ  +1
      II        = 1
      DO 25 I=2,IL,2
      II        = II  +1
      WW(II,JJ,N) = (DW(I,J,N)     +DW(I+1,J,N)
     .              +DW(I,J+1,N)   +DW(I+1,J+1,N))/
     .              (VOL(I,J)      +VOL(I+1,J)
     .              +VOL(I,J+1)    +VOL(I+1,J+1))
   25 CONTINUE
      WW(1,JJ,N)    = WW(IIL,JJ,N)
      WW(II2,JJ,N)  = WW(2,JJ,N)
   30 CONTINUE
      DO 40 N=1,4
      II        = 1
      DO 35 I=2,IL,2
      II        = II  +1
      WW(II,JJ2,N)  = (DW(I,J2,N)  +DW(I+1,J2,N))/
     .                (VOL(I,J2)   +VOL(I+1,J2))
   35 CONTINUE
      WW(1,JJ2,N)   = WW(IIL,JJ2,N)
      WW(II2,JJ2,N) = WW(2,JJ2,N)
   40 CONTINUE
      RETURN
      END
C     NAME=ADDX
      SUBROUTINE  ADDX  (I2,J2,W,P,X,II2,JJ2,WW,W1)
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/ADD/ DW(194,34,4)
      COMMON/MGR/ KODE,MODE
      DIMENSION   W(I2,J2,4),P(I2,J2),X(I2,J2,2),
     .            WW(II2,JJ2,4),W1(II2,JJ2,4)
      IIL       = II2  -1
      J1        = JL
      IF (MODE.NE.0) GO TO 11
      J1        = J2
      DO 10 J=1,J2
      DO 10 I=1,I2
      W(I,J,1)  = 0.
      W(I,J,2)  = 0.
      W(I,J,3)  = 0.
      W(I,J,4)  = 0.
   10 CONTINUE
      GO TO 21
   11 DO 20 N=1,4
      DO 20 JJ=1,JJ2
      DO 20 II=1,II2
      WW(II,JJ,N)   = WW(II,JJ,N)  -W1(II,JJ,N)
   20 CONTINUE
   21 DO 40 N=1,4
      JJ        = 1
      DO 30 J=2,J2,2
      JJ        = JJ  +1
      II        = 1
      DO 30 I=2,I2,2
      II        = II  +1
      DW(I,J,N)     =  .5625*WW(II,JJ,N)    +.1875*WW(II-1,JJ,N)
     .                +.1875*WW(II,JJ-1,N)  +.0625*WW(II-1,JJ-1,N)
      DW(I-1,J,N)   =  .1875*WW(II,JJ,N)    +.5625*WW(II-1,JJ,N)
     .                +.0625*WW(II,JJ-1,N)  +.1875*WW(II-1,JJ-1,N)
      DW(I,J-1,N)   =  .1875*WW(II,JJ,N)    +.0625*WW(II-1,JJ,N)
     .                +.5625*WW(II,JJ-1,N)  +.1875*WW(II-1,JJ-1,N)
      DW(I-1,J-1,N) =  .0625*WW(II,JJ,N)    +.1875*WW(II-1,JJ,N)
     .                +.1875*WW(II,JJ-1,N)  +.5625*WW(II-1,JJ-1,N)
   30 CONTINUE
      DW(2,2,N)     = .75*WW(2,2,N)  +.25*WW(IIL,2,N)
      DW(IL,2,N)    = .25*WW(2,2,N)  +.75*WW(IIL,2,N)
      DO 40 J=2,J1
      DO 35 I=2,IL
      W(I,J,N)  = W(I,J,N)  +DW(I,J,N)
   35 CONTINUE
      W(1,J,N)  = W(IL,J,N)
      W(I2,J,N) = W(2,J,N)
   40 CONTINUE
      DO 50 J=2,J1
      DO 45 I=2,IL
      QQ        = .5*(W(I,J,2)**2  +W(I,J,3)**2)/W(I,J,1)
      P(I,J)    = (GAMMA  -1.)*(W(I,J,4)  -QQ)
   45 CONTINUE
      P(1,J)    = P(IL,J)
      P(I2,J)   = P(2,J)
   50 CONTINUE
      CALL BCWALL(I2,J2,W,P,X)
      RETURN
      END
C     NAME=PRNTXY
      SUBROUTINE PRNTXY(LPRNT,I2,J2,X,VOL)
C     PRINTS MESH
      COMMON/LIM/ IL,JL
      DIMENSION   X(I2,J2,2),VOL(I2,J2)
      IWRIT     = 6
      WRITE (IWRIT,10)
   10 FORMAT(5H1MESH)
      DO 20 I=1,IL,LPRNT
      WRITE (IWRIT,12)
   12 FORMAT(1H0,2X,4H  I ,4H  J ,
     .              12H      X     ,12H      Y     ,12H    AREA    )         
      DO 20 J=1,JL
      WRITE (IWRIT,14) I,J,X(I,J,1),X(I,J,2),VOL(I+1,J+1)
   14 FORMAT(1X,2I4,3E12.4)
   20 CONTINUE
      RETURN
      END
C     NAME=PRNTFF
      SUBROUTINE PRNTFF(NCYC,TIME,LPRNT,I2,J2,W,P)
C     PRINTS FLOW FIELD
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/GEO/ XP(385),YP(385),NP
      COMMON/SAV/ COUNT1(501),COUNT2(501),RES(501),FSUP(501),
     .            CLM(501),CDM(501),CMM(501),IOUT
      DIMENSION   W(I2,J2,4),P(I2,J2)
      IWRIT     = 6
      WRITE (IWRIT,10)
   10 FORMAT(11H1FLOW FIELD/
     .       1H0,2X,6H NCYC ,12H    TIME    )                           
      WRITE (IWRIT,12) NCYC,TIME
   12 FORMAT(1X,I6,F12.4)
      DO 30 I=2,I2,LPRNT
      WRITE (IWRIT,22)
   22 FORMAT(1H0,2X,4H  I ,4H  J ,
     .              10H    RHO   ,10H     U    ,10H     V    ,
     .              10H     H    ,10H     P    ,10H   MACH   ,
     .              10H     S    )                     
      DO 30 J=2,J2
      U         = W(I,J,2)/W(I,J,1)
      V         = W(I,J,3)/W(I,J,1)
      QQ        = U*U  +V*V
      H         = (W(I,J,4)  +P(I,J))/W(I,J,1)  -H0
      FM        = SQRT((W(I,J,1)*QQ)/(GAMMA*P(I,J)))
      S         = (P(I,J)/P0)*(RHO0/W(I,J,1))**GAMMA  -1.
      WRITE (IWRIT,24) I,J,W(I,J,1),U,V,H,P(I,J),FM,S
   24 FORMAT(1X,2I4,7F10.4)
   30 CONTINUE
      JJ        = J2  -2
      DO 40 J=2,J2,JJ
      WRITE (IWRIT,22)
      DO 40 I=1,I2
      U         = W(I,J,2)/W(I,J,1)
      V         = W(I,J,3)/W(I,J,1)
      QQ        = U*U  +V*V
      H         = (W(I,J,4)  +P(I,J))/W(I,J,1)  -H0
      FM        = SQRT((W(I,J,1)*QQ)/(GAMMA*P(I,J)))
      S         = (P(I,J)/P0)*(RHO0/W(I,J,1))**GAMMA  -1.
      WRITE (IWRIT,24) I,J,W(I,J,1),U,V,H,P(I,J),FM,S
   40 CONTINUE
C ----------     OUTPUT ON FILE     ----------
C     REWIND IOUT
C     WRITE (IOUT) I2,J2
C     WRITE (IOUT) COUNT1,COUNT2,RES,FSUP,CLM,CDM,CMM
C     WRITE (IOUT) XP,YP
C     DO 50 J=1,JL
C     WRITE (IOUT) ((X(I,J,N),N=1,2),I=1,IL)
C  50 CONTINUE
C     WRITE (IOUT) SCAL
C     DO 60 J=1,J2
C     WRITE (IOUT) ((W(I,J,N),N=1,4),I=1,I2)
C     WRITE (IOUT) (P(I,J),I=1,I2)
C  60 CONTINUE
C --------------------------------------------
      RETURN
      END
C     NAME=FORCF
      SUBROUTINE  FORCF (I2,J2,X)
C     CALCULATES SECTION FORCE COEFFICIENTS
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/OUT/ CP(193),SCAL,CHORD,XM,YM,CL,CD,CM
      DIMENSION   X(I2,J2,2)
      CL        = 0.
      CD        = 0.
      CM        = 0.
      DO 12 I=2,IL
      DX        = SCAL*(X(I,1,1)  -X(I-1,1,1))/CHORD
      DY        = SCAL*(X(I,1,2)  -X(I-1,1,2))/CHORD
      XA        = (.5*SCAL*(X(I,1,1)  +X(I-1,1,1))  -XM)/CHORD
      YA        = (.5*SCAL*(X(I,1,2)  +X(I-1,1,2))  -YM)/CHORD
      DCL       = -CP(I)*DX
      DCD       = CP(I)*DY
      CL        = CL  +DCL
      CD        = CD  +DCD
   12 CM        = CM  +DCD*YA  -DCL*XA
      DCL       = CL*CA  -CD*SA
      CD        = CL*SA  +CD*CA
      CL        = DCL
      RETURN
      END
C     NAME=CPLOT
      SUBROUTINE  CPLOT (I2,J2,X)
C     PLOTS CP AT THE MID POINTS OF THE MESH INTERVALS
      COMMON/LIM/ IL,JL
      COMMON/DAT/ GAMMA,RM,RHO0,P0,EI0,H0,C0,U0,V0,CA,SA
      COMMON/OUT/ CP(193),SCAL,CHORD,XM,YM,CL,CD,CM
      DIMENSION   X(I2,J2,2)
      CHARACTER*1 KODE(2), LINE(110)
      DATA        KODE/' ','+'/
C      DIMENSION   KODE(2),LINE(110) ***3/7/89
C      DATA        KODE/1H ,1H+/     ***HOLERITH EDITING NOT ANSI
      IWRIT     = 6
      CP0       = ((1.  +.2*RM**2)**3.5  -1.)/(.7*RM**2)
      WRITE (IWRIT,10)
C  10 FORMAT(11H1PLOT OF CP/        ****3/7/89 NOT ANSI
C    .       1H0,2X,8H    X   ,8H   CP   )                      
   10 FORMAT(1X,'PLOT OF CP',/,'0',2X,'    X   ','   CP   ')  
      DO 20 I=1,110
   20 LINE(I)   = KODE(1)
      DO 30 I=2,IL
      XA        = .5*SCAL*(X(I,1,1)  +X(I-1,1,1))
      K         = 20.*(CP0  -CP(I))  +2.5
      K         = MAX(K,1)
      K         = MIN(K,110)
      LINE(K)   = KODE(2)
      WRITE (IWRIT,22) XA,CP(I),LINE
   22 FORMAT(1X,F10.4,F8.4,110A1)
      LINE(K)   = KODE(1)
   30 CONTINUE
      RETURN
      END
C     NAME=GRID
      SUBROUTINE  GRID  (I2,J2,X,TITLE)
C     PLOTS MESH
      COMMON/LIM/ IL,JL
      DIMENSION   X(I2,J2,2)
      DIMENSION   TITLE(1),R(48)
      NX        = IL  -1
      NY        = JL  -1
      CALL NGRAPH (950,250,150,'FELT-TIP','BLACK   ','WHITE   ',0)
      CALL SETB99 (R,48)
      WRITE(99,12) (TITLE(I),I=1,12)
   12 FORMAT(12A4)
      CALL SYMBOL(0.,-.5,.14,R,0.,48)
      CALL SETB99 (R,16)
      WRITE(99,14) NX,NY
   14 FORMAT(5HGRID ,I4,3H X ,I4)
      CALL SYMBOL(0.,-.75,.14,R,0.,16)
      XMAX      = X(1,1,1)
      XMIN      = X(1,1,1)
      DO 22 I=2,IL
      XMAX      = MAX(X(I,1,1),XMAX)
   22 XMIN      = MIN(X(I,1,1),XMIN)
      SCALE     = 2.5/(XMAX  -XMIN)
      JMAX      = 1
      DO 36 J=1,JL
      DO 32 I=1,IL
      XP        = SCALE*(X(I,J,1)  -XMIN)  +1.25
      YP        = SCALE*X(I,J,2)  +5.
      IF (XP.LT.-.5.OR.XP.GT.5.5.OR.YP.LT.1..OR.YP.GT.9.) GO TO 36
   32 CONTINUE
      KP        = 3
      DO 34 I=1,IL
      XP        = SCALE*(X(I,J,1)  -XMIN)  +1.25
      YP        = SCALE*X(I,J,2)  +5.
      CALL PLOT(XP,YP,KP)
      KP        = 2
   34 CONTINUE
      JMAX      = J
   36 CONTINUE
      DO 42 I=1,IL
      KP        = 3
      DO 42 J=1,JMAX
      XP        = SCALE*(X(I,J,1)  -XMIN)  +1.25
      YP        = SCALE*X(I,J,2)  +5.
      CALL PLOT(XP,YP,KP)
      KP        = 2
   42 CONTINUE
      CALL ENDPLT
      RETURN
      END
C     NAME=GRAPH
      SUBROUTINE  GRAPH (I2,J2,X,TITLE,FMACH,AL,NCYC,ARES,ISYM)
C     PLOTS PROFILE AND PRESSURE DISTRIBUTION
      COMMON/LIM/ IL,JL
      COMMON/OUT/ CP(193),SCAL,CHORD,XM,YM,CL,CD,CM
      DIMENSION   X(I2,J2,2)
      DIMENSION   TITLE(1),R(48)
      NX        = IL  -1
      NY        = JL  -1
      CALL NGRAPH (950,250,150,'FELT-TIP','BLACK   ','WHITE   ',0)
      CALL SYMBOL(-2.,-1.,.07,3,0.,-1)
      CALL SETB99 (R,48)
      WRITE(99,12) (TITLE(I),I=1,12)
   12 FORMAT(12A4)
      CALL SYMBOL(0.,-.25,.14,R,0.,48)
      CALL SETB99 (R,28)
      WRITE(99,14) FMACH,AL
   14 FORMAT(5HMACH ,F7.3,4X,5HALPHA,F7.3)
      CALL SYMBOL(0.,-.5,.14,R,0.,28)
      CALL SETB99 (R,44)
      WRITE(99,16) CL,CD,CM
   16 FORMAT(5HCL   ,F7.4,4X,5HCD   ,F7.4,4X,5HCM   ,F7.4)
      CALL SYMBOL(0.,-.75,.14,R,0.,44)
      CALL SETB99 (R,44)
      WRITE(99,18) NX,NY,NCYC,ARES
   18 FORMAT(6HGRID  ,I3,1HX,I2,4X,8HNCYC    ,I4,4X,3HRES,E9.3)
      CALL SYMBOL(0.,-1.,.14,R,0.,44)
      XMIN      = X(1,1,1)
      DO 22 I=2,IL
   22 XMIN      = MIN(X(I,1,1),XMIN)
      SCALE     = 5./(X(1,1,1)  -XMIN)
      IF (ISYM.LT.0) GO TO 41
      XP        = 5.
      YP        = .5
      CALL PLOT(XP,YP,3)
      DO 32 I=2,IL
      XP        = SCALE*(X(I,1,1)  -XMIN)
      YP        = SCALE*X(I,1,2)  +.5
   32 CALL PLOT(XP,YP,2)
   41 IFLAG     = 1
      DO 42 I=2,IL
   42 IF (CP(I).LT.-2.) IFLAG = 2
      CPINT     = -.4*IFLAG
      CPORIG    = 1.  +3./IFLAG
      CPSCAL    = -2.5/IFLAG
C 3/8/89 REMOVE HOLERITHS
C     CALL AXIS(-.5,1.,2HCP,2,8.,90.,1.2,CPINT)
      CALL AXIS(-.5,1.,'CP',2,8.,90.,1.2,CPINT)
      CPC       = -10.
      IF (FMACH.GT.0.)
     1CPC       = (((5.  +FMACH**2)/6.)**3.5  -1.)/(.7*FMACH**2)
      XP        = -.5
      YP        = CPORIG  +CPSCAL*CPC
      IF (CPC.GE.-5.2) CALL SYMBOL(XP,YP,.40,15,0.,-1)
      DO 52 I=2,IL
      IF (CP(I).LT.-5.2) GO TO 52
      XP        = SCALE*(.5*(X(I,1,1)  +X(I-1,1,1))  -XMIN)
      YP        = CPORIG  +CPSCAL*CP(I)
      CALL SYMBOL(XP,YP,.07,3,0.,-1)
   52 CONTINUE
      CALL SYMBOL(6.5,-1.,.07,3,0.,-1)
      CALL ENDPLT
      RETURN
      END
C     NAME=RPLOT
      SUBROUTINE  RPLOT(NRES,RES,FSUP,COUNT,TITLE,RM,AL,NX,NY,IND)
C     PLOTS CONVERGENCE RATE
      DIMENSION   RES(1),FSUP(1),COUNT(1),TITLE(1),R(48)
      CALL NGRAPH(950,250,125,'FELT-TIP','BLACK   ','WHITE   ',0)
      CALL SYMBOL(-2.,-1.,.07,3,0.,-1)
      CALL SYMBOL(6.5,-1.,.07,3,0.,-1)
      IF (IND.NE.0) GO TO 11
      RES1      = RES(1)
      RES2      = RES(NRES)
   11 RATE      = (RES2/RES1)**(1./COUNT(NRES))
      CALL SETB99(R,48)
      WRITE (99,12)  (TITLE(I),I=1,12)
   12 FORMAT(12A4)
      CALL SYMBOL(0.,0.,.14,R,0.,48)
      CALL SETB99(R,36)
      WRITE (99,14)  RM,AL
   14 FORMAT(5HMACH ,F11.3,4X,5HALPHA,F11.3)
      CALL SYMBOL(0.,-.25,.14,R,0.,36)
      CALL SETB99(R,36)
      WRITE (99,16)  RES1,RES2
   16 FORMAT(7HRESID1 ,E9.3,4X,7HRESID2 ,E9.3)
      CALL SYMBOL(0.,-.5,.14,R,0.,36)
      CALL SETB99(R,36)
      WRITE (99,18)  COUNT(NRES),RATE
   18 FORMAT(5HWORK ,F11.2,4X,5HRATE ,F11.4)
      CALL SYMBOL(0.,-.75,.14,R,0.,36)
      CALL SETB99(R,16)
      WRITE (99,20)  NX,NY
   20 FORMAT(10HGRID      ,I3,1HX,I2)
      CALL SYMBOL(0.,-1.,.14,R,0.,16)
      IF (IND.NE.0) GO TO 31
      RMIN      = 0.
      RMAX      = 0.
      RES1      = RES(1)
      FSUPF     = FSUP(NRES)
      IF (ABS(FSUPF).GT.1.D-06)  FSUPF = 1./FSUPF
      DO 22 I=1,NRES
      FSUP(I)   = FSUP(I)*FSUPF
      RES(I)    = LOG(RES(I)/RES1)
      RMAX      = MAX(RMAX,RES(I))
   22 RMIN      = MIN(RMIN,RES(I))
   31 YSCAL     = 1./LOG(10.)
      YINT      = 2.
      IF (YSCAL*RMIN.LT.-12.) YINT = 4.
      YLOW      = -6.*YINT
      YSCAL     = YSCAL/YINT
      XINT      = 200.
      IF (COUNT(NRES).LT.99.) XINT = 100.
      IF (COUNT(NRES).GT.1200.) XINT = 500.
      IF (COUNT(NRES).GT.6000.) XINT = 1000.
      XSCAL     = 1./XINT
C 3/8/89 REMOVE HOLLERITHS
C     CALL AXIS(-.5,1.,10HLOG(ERROR),10,8.,90.,YLOW,YINT) 
C     CALL AXIS(-.5,1.,4HWORK,-4,6.,0.,0.,XINT)
C     CALL AXIS(5.5,1.,4HNSUP,-4,8.,90.,-.2,.2)
      CALL AXIS(-.5,1.,'LOG(ERROR)',10,8.,90.,YLOW,YINT)  
      CALL AXIS(-.5,1.,'WORK',-4,6.,0.,0.,XINT)
      CALL AXIS(5.5,1.,'NSUP',-4,8.,90.,-.2,.2)
      XP        = XSCAL*COUNT(1)  -.5
      YP        = 7.
      CALL PLOT(XP,YP,3)
      DO 32 I=2,NRES
      XP        = XSCAL*COUNT(I)  -.5
      YP        = MIN(2.,YSCAL*RES(I))  +7.
   32 CALL PLOT(XP,YP,2)
      XP        = XSCAL*COUNT(1)  -.5
      YP        = MIN(7.,5.*FSUP(1))  +2.
      CALL PLOT(XP,YP,3)
      DO 34  I=2,NRES
      XP        = XSCAL*COUNT(I)  -.5
      YP        = MIN(7.,5.*FSUP(I))  +2.
   34 CALL PLOT(XP,YP,2)
      CALL SYMBOL(-2.,-1.,.07,3,0.,-1)
      CALL SYMBOL(6.5,-1.,.07,3,0.,-1)
      CALL ENDPLT
      RETURN
      END
      SUBROUTINE PLOT(R1,R2,I1)
      DIMENSION RA(48)
      CHARACTER*(*) CH1, CH2, CH3
      ENTRY NGRAPH(I1,I2,I3,CH1,CH2,CH3,I4)
      ENTRY SETB99(RA,I1)
      ENTRY SYMBOL(R1,R2,R3,R4,I1,I2,I3)
      ENTRY AXIS(R1,R2,CH1,I1,R3,R4,R5,R6)
      ENTRY ENDPLT
      RETURN
      END
