C CALCUL DU POTENTIEL ATOME-ATOME : HCl perturbe par CO2
C HCl  : MOLECULE LINEAIRE HETERONUCLEAIRE DE LA FORME A-B
C CO2  : molecule lineaie traitee comme une molecule a DEUX sites
C cf : C.S.MURPHY,...(MOLECULAR Physics,1981,vol. 44,n 1,p135
C L'AXE DES z EST ORIENTE >0 DE B VERS A:soit A=H  et  B=Cl
C CALCUL DES FONCTIONS Ul1l2m(r) D'APRES : J.DOWNS,K.E.GUBBINS,S.MURAD,
C C.G.GRAY (Molecular Physics,1979,vol.37,n 1,p129)
C
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON/B1/ISUV
      COMMON/CTE/RH,RCL,RO,EHH,ECLCL,EOO,EHO,ECLO,SHH,SCLCL,SOO,SHO,SCLO
      SAVE
C
      NIN=5
      NOUT=6
C
      ISUV=30
      I=0
C
      IRMIN=1
      IRMAX=500
      RINI=0.05
      RPAS=0.01
C
C LES LONGUEURS SONT COMPTEES EN : ANGSTROM
C CONSTANTES POUR LE CALCUL DES POTENTIELS DE LENARD-JONES :
      RH=1.2221
      RCL=0.0349
      RO=2.32/2.
C
      SHH=2.735
      SCLCL=3.353
      SOO=3.344
C
      EHH=13.
      ECLCL=173.5
      EOO=136.7
C CALCUL DES CONSTANTES POUR HCl-CO2 :
      SOO=SOO/(2.**(1./6.))
      EHO=DSQRT(EHH*EOO)
      ECLO=DSQRT(ECLCL*EOO)
      SHO=0.5*(SHH+SOO)
      SCLO=0.5*(SCLCL+SOO)
C
      PI=3.14159265
C
C
C CALCUL DU POTENTIEL ANISOTROPE
C
98765 DO 10 L1=1,2
      DO 11 L2=2,2,1
      CTEL=1./DSQRT(DBLE((2.*L1+1.)*(2.*L2+1.)))
      MSUP=MIN0(L1,L2)
      MINF=-MSUP
      DO 13 M=0,MSUP,1
      WRITE(NOUT,11000) L1,L2,M
      WRITE(NOUT,1400)
      DO 14 IR=IRMIN,IRMAX
      R=RINI+(IR-1.)*RPAS
      SOM=0.
      LINF=ABS(L1-L2)
      LSUP=L1+L2
      DO 15 L=LINF,LSUP,1
      SL=L1+L2+L
      LTEST=SL/2.
      IF(SL-2*LTEST) 15,20,15
   20 TERM1=U(L1,L2,L,0,0,R)
      KK=2*L
      LL=2*L1
      MM=2*L2
      NN=L
      NN1=L1-M
      NN2=L2+M
      TERM2=CLEBSC(KK,LL,MM,NN,NN1,NN2)
C     WRITE(6,*) L1,L2,L,CTEL,TERM2,TERM1
      SOM=TERM1*TERM2*CTEL+SOM
   15 CONTINUE
      VANISO=SOM
      WRITE(NOUT,*) VANISO
   14 CONTINUE
      WRITE(NOUT,1300)
   13 WRITE(NOUT,1300)
   11 CONTINUE
   10 CONTINUE
11000 FORMAT(10X,'CALCUL DE U(',I2,I2,I2,')',/)
 1300 FORMAT(1X,80(1H*)/)
10000 FORMAT(5X,F6.4,5X,6(1PE15.8,2X))
 1400 FORMAT(5X,'CALCUL DU POTENTIEL ATOME-ATOME POUR HCl-CO2 --  ',
     &'CALCUL EXACT INCLUANT TOUS LES TERMES JUSQU A L ORDRE: ',/)
14000 FORMAT(6X,'U+V=',6X,6(I2,16X),/)
99999 STOP
      END












      FUNCTION CLEBSC (K,L,M,N,N1,N2)
      IMPLICIT DOUBLE PRECISION (A-H,O-Y)
      SAVE
      INTEGER P,P1,P2
      CP(N,M)=DSQRT(DBLE(N-M)*DBLE(N+M+2))
      CM(N,M)=DSQRT(DBLE(N+M)*DBLE(N-M+2))
      IF(K.LT.0.OR.L.LT.0.OR.M.LT.0) GO TO 1
      IF(N.LT.0.OR.N1.LT.0.OR.N2.LT.0) GO TO 1
      IF(N.GT.K.OR.N1.GT.L.OR.N2.GT.M) GO TO 1
      IF(2*(N-N1-N2).NE.K-L-M) GO TO 1
      ENTRY CLEBSC1 (K,L,M,N,N1,N2)
      IF (K.GT.L+M.OR.K.LT.ABS(L-M)) GO TO 1
      ISG=1
      P=N
      P1=N1
      P2=N2
      IF (2*P.LE.K) GO TO 80
      P=K-P
      P1=L-P1
      P2=M-P2
      IF(MOD(K-L-M,4).NE.0) ISG=-1
 80   IF (P-P2.LE.1) GO TO 50
      A=CGZZZZ (K,L,M,P1-P+P2)
      J2=P-P2
      DO 20 I=1,J2
      B=A
      J=K+2-2*I
      J1=K-M-I*2
  20  A=A*CP(L,J1)/CM(K,J)
      IF (P2.EQ.0) GO TO 2
      N3=J2+1
      J=J-2
      B=(CP(K,J)*B-A*CM(L,J1+2))/CM(M,M)
      GO TO 60
 50   A=CGZZZZ (K,L,M,P1)
      IF (P.EQ.0) GO TO 2
      B=CGZZZZ (K,L,M,P1-1)
      J=K
      J1=L-2*P1
      N3=1
 60   YZ=CP(L,J1)
 70   J2=J-J1-2
      X=CM(K,J)
      A=(CP(M,J2)*A+YZ*B)/X
      IF (N3.GE.P) GO TO 2
      N3=N3+1
      J=J-2
      B=(X*B-YZ*A)/CM(M,J2)
      GO TO 70
 2    CLEBSC=A*ISG
      RETURN
 1    CLEBSC=0.
      RETURN
      END







      FUNCTION CGZZZZ (K,L,M,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
      INTEGER*4 I,J1,J2
      IF (N.LT.0.OR.N.GT.L) GO TO 1
      A=1.
      C=1.
      D=1.
      IF (L.EQ.0) GO TO 30
      N1=1
      DO 10 I=1,L
      J1=L+2-2*I
      J2=2-J1+K
      N1=-N1
      IF (J2.LT.-M.OR.J2.GT.M+2) GO TO 20
      H1=(M+J2)
      H2=(M-J2+2)
      H3=(L+J1)
      H4=(L-J1+2)
      HULP=H1*H2/H3/H4
      C=C*HULP
      IF (HULP.LE.0.) GO TO 20
      D=D+C
 20   IF (I.EQ.N) A=N1*DSQRT(C)
      IF (ABS(D).LT.1E30) GO TO 10
      D=D*1E-30
      C=C*1E-30
      A=A*1E-15
 10   CONTINUE
 30   CGZZZZ=A/DSQRT(D)
      RETURN
 1    CGZZZZ=0.
      RETURN
      END




      FUNCTION U(J1,J2,J,N1,N2,XR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON/CTE/RH,RCL,RO,EHH,ECLCL,EOO,EHO,ECLO,SHH,SCLCL,SOO,SHO,SCLO
      SAVE
C
      DAA=4.*EHO*(SHO**12)
      EAA=4.*EHO*(SHO**6)
      R12=(XR)**12
      R6=(XR)**6
      UAA1=(DAA/R12)*F(12,J1,J2,J,RH,RO,XR)
      UAA2=(EAA/R6)*F(6,J1,J2,J,RH,RO,XR)
      UAA=UAA1-UAA2
C
      UAB=UAA
      UAB=((-1)**J2)*UAB
C
      DBA=4.*ECLO*(SCLO**12)
      EBA=4.*ECLO*(SCLO**6)
      UBA1=(DBA/R12)*F(12,J1,J2,J,RCL,RO,XR)
      UBA2=(EBA/R6)*F(6,J1,J2,J,RCL,RO,XR)
      UBA=(UBA1-UBA2)
C
      UBB=UBA
      UBB=((-1)**J)*UBB
C
      UBA=((-1.)**J1)*UBA

      U=(UAA+UAB+UBA+UBB)
C
      RETURN
      END





      FUNCTION F(NN,LL1,LL2,LL,RRA,RRB,RR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
      KK=2*LL
      LLL=2*LL1
      MM=2*LL2
      N0=LL
      NN1=LL1
      NN2=LL2
      C=CLEBSC(KK,LLL,MM,N0,NN1,NN2)
      GLAMDA=LL1+LL2+LL
      GLAMDA=GLAMDA/2.
      SLAMDA=GLAMDA-LL
      X=NN/2.
      FN2=DISFAC(X,GLAMDA)
      X=(NN-1.)/2.
      FN12=DISFAC(X,SLAMDA)
      X=1./2.
      SSS=LL1
      FL1=DISFAC(X,SSS)
      SSS=LL2
      FL2=DISFAC(X,SSS)
      AA=GLAMDA+NN/2.
      BB=LAMDA+(NN-1.)/2.
      CC=LL1+3./2.
      DD=LL2+3./2.
      XX=(RRA/RR)**2
      YY=(RRB/RR)**2
      FF=APPELL(AA,BB,CC,DD,XX,YY)
C
C     WRITE(6,10000) NN,AA,BB,CC,DD,XX,YY
10000 FORMAT(5X,'APPELL=','NN= ',I2,2X,6(1PE15.8,2X))
C
C     CC=(1.)/(DSQRT((2.*LL1+1.)*(2.*LL2+1.)))
      RRRR=((FN2*FN12)/(FL1*FL2))
C     WRITE(6,*) NN,LL1,LL2,LL,RRA,RRB,RR,C,FN2,FN12,FL1,FL2,RRRR,FF
      RRAB=(RRA)**LL1
      RRAB=RRAB*(RRB**LL2)*((-1.)**LL2)
      RR2=RR**(-LL1-LL2)
      RRR=RRAB*RR2
C     WRITE(6,*) RRAB,RR2,RRR
      F=C*RRRR*RRR*FF
      RETURN
      END






      FUNCTION APPELL(A,B,C,D,X,Y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C ATTENTION : il faut boucler sur u (par exemple) et la SOMME u+v pour que
C la comparaison formules du Journal de Physique avec la fonction de Appel
C ait un sens (termes du meme degre)
      parameter (isuv=30)
      DOUBLE PRECISION factorial(0:isuv)
      DOUBLE  PRECISION fa(0:isuv), fb(0:isuv), fc(0:isuv), fd(0:isuv)
      DOUBLE  PRECISION som1(0:isuv)
      save
c
      call facto(isuv,factorial)
c
*     do i = 0, isuv
*        fa(i) = disfac(a,float(i))
*        fb(i) = disfac(b,float(i))
*        fc(i) = disfac(c,float(i))
*        fd(i) = disfac(d,float(i))
*     end do
      fa(0) = 1.
      fb(0) = 1.
      fc(0) = 1.
      fd(0) = 1.
      do i = 1, isuv
         fa(i) = fa(i-1)*(a+i-1)
         fb(i) = fb(i-1)*(b+i-1)
         fc(i) = fc(i-1)*(c+i-1)
         fd(i) = fd(i-1)*(d+i-1)
      end do
c
      do iu=0,isuv
        som = 0.
        do iuvmax=iu,isuv
          iv=iuvmax-iu
          iuv=iu+iv
          terma=fa(iuv)*fb(iuv)
          terma=terma/(fc(iu)*fd(iv))
          terma=terma/(factorial(iu)*factorial(iv))
          termb=(x**iu)*(y**iv)
          term=terma*termb
          som=som+term
        end do
        som1(iu) = som
      end do
      som=0.
      do iu=0,isuv
        som = som + som1(iu)
      enddo
      APPELL=SOM
      RETURN
      END

      subroutine facto(n,x)
      implicit none
      integer n
      DOUBLE  PRECISION   x(0:n)
c
c     --------------------------------------------------------
c     computes the factorials of the integers from 0 through n
c     --------------------------------------------------------
c
      integer i
c
      x(0) = 1.
      do i = 1, n
         x(i) = x(i-1)*dble(i)
      end do
c
      return
      end


      FUNCTION DISFAC(ALPHA,SS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C     WRITE(6,3000) ALPHA,SS
C3000 FORMAT(5X,'ALPHA=',F5.2,5X,'SS= ',F3.1)
      IF(SS) 9,10,9
   10 F=1.
      DISFAC=1.
      GO TO 50
    9 TERM1=(ALPHA+SS-1.)+1.
      TERM2=(ALPHA-1.)+1.
      IFAIL=0
      FACT1=S14AAF(TERM1,IFAIL)
      FACT2=S14AAF(TERM2,IFAIL)
      DISFAC=FACT1/FACT2
C  50 WRITE(6,1000) ALPHA,SS,F
C1000 FORMAT(5X,'ALPHA=',F5.2,3X,'SS= ',F3.1,3X,'DISFAC= ',F8.3)
   50 RETURN
      END

      FUNCTION FISO(XR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      SAVE
      R=XR
      RH=1.2221
C     WRITE(6,*) R
      RCL=-0.0349
      EHH=13.
      ECLCL=173.5
      EHCL=47.5
      SHH=2.735
      SCLCL=3.353
      SHCL=3.044
      SHH12=SHH**12
      SHH6=SHH**6
      SHCL12=SHCL**12
      SHCL6=SHCL**6
      SCL12=SCLCL**12
      SCL6=SCLCL**6
C     WRITE(6,*) SHH12,SHH6
C     WRITE(6,*) SHCL12,SHCL6
C     WRITE(6,*) SCL12,SCL6
      THH=F(12,0,0,0,RH,RH,R)*(SHH**12)
      THH=THH-(SHH**6)*F(6,0,0,0,RH,RH,R)
      THH=4.*EHH*THH
C     WRITE(6,*) THH
      THCL=F(12,0,0,0,RH,RCL,R)*(SHCL**12)
      THCL=THCL-F(6,0,0,0,RH,RCL,R)*(SHCL**6)
      THCL=4.*EHCL*THCL
C     WRITE(6,*) THCL
      TCLCL=F(12,0,0,0,RCL,RCL,R)*(SCLCL**12)
      TCLCL=TCLCL-F(6,0,0,0,RCL,RCL,R)*(SCLCL**6)
      TCLCL=TCLCL*4.*ECLCL
C     WRITE(6,*) TCLCL
C     WRITE(6,*) THH,THCL,THCL,TCLCL
      FISO=THH+2.*THCL+TCLCL
      RETURN
      END
cGLD GouldEurope: values supplied, 87/11/05
cGLD GouldEurope: C15 comment lines enabled, 87/11/05
      DOUBLE PRECISION FUNCTION S14AAF(X,IFAIL)
      SAVE
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 7C REVISED IER-184 (MAY 1979)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     GAMMA FUNCTION
C
C     **************************************************************
C
C     TO EXTRACT THE CORRECT CODE FOR A PARTICULAR MACHINE-RANGE,
C     ACTIVATE THE STATEMENTS CONTAINED IN COMMENTS BEGINNING  CDD ,
C     WHERE  DD  IS THE APPROXIMATE NUMBER OF SIGNIFICANT DECIMAL
C     DIGITS REPRESENTED BY THE MACHINE
C     DELETE THE ILLEGAL DUMMY STATEMENTS OF THE FORM
C     * EXPANSION (NNNN) *
C
C     ALSO INSERT APPROPRIATE DATA STATEMENTS TO DEFINE CONSTANTS
C     WHICH DEPEND ON THE RANGE OF NUMBERS REPRESENTED BY THE
C     MACHINE, RATHER THAN THE PRECISION (SUITABLE STATEMENTS FOR
C     SOME MACHINES ARE CONTAINED IN COMMENTS BEGINNING CRD WHERE
C     D IS A DIGIT WHICH SIMPLY DISTINGUISHES A GROUP OF MACHINES).
C     DELETE THE ILLEGAL DUMMY DATA STATEMENTS WITH VALUES WRITTEN
C     *VALUE*
C
C     **************************************************************
C
C     .. Parameters ..
      CHARACTER*6                      SRNAME
      PARAMETER                        (SRNAME='S14AAF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION                 X
      INTEGER                          IFAIL
C     .. Local Scalars ..
      DOUBLE PRECISION                 G, GBIG, T, XBIG, XMINV, XSMALL,
     *                                 Y
      INTEGER                          I, M
C     .. Local Arrays ..
      CHARACTER*1                      P01REC(1)
C     .. External Functions ..
      INTEGER                          P01ABF
      EXTERNAL                         P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC                        ABS, SIGN, DBLE
C     .. Data statements ..
C08   DATA XSMALL/1.0D-8/
C09   DATA XSMALL/3.0D-9/
C12   DATA XSMALL/1.0D-12/
      DATA XSMALL/3.0D-15/
C17   DATA XSMALL/1.0D-17/
C19   DATA XSMALL/1.7D-18/
C
cGLD  DATA XBIG,GBIG,XMINV/ *VALUE*,*VALUE*,*VALUE* /
      DATA XBIG,GBIG,XMINV / 0.56000000D+02,0.1269640D+74,0.14D-75 /
C     XBIG = LARGEST X SUCH THAT  GAMMA(X) .LT. MAXREAL
C                            AND  1.0/GAMMA(X+1.0) .GT. MINREAL
C             (ROUNDED DOWN TO AN INTEGER)
C     GBIG = GAMMA(XBIG)
C     XMINV = MAX(1.0/MAXREAL,MINREAL)  (ROUNDED UP)
C     FOR IEEE SINGLE PRECISION
CR0   DATA XBIG,GBIG,XMINV /33.0E0,2.6E+35,1.2E-38/
C     FOR IBM 360/370 AND SIMILAR MACHINES
CR1   DATA XBIG,GBIG,XMINV /57.0D0,7.1D+74,1.4D-76/
C     FOR DEC-10, HONEYWELL, UNIVAC 1100 (S.P.)
CR2   DATA XBIG,GBIG,XMINV /34.0D0,8.7D+36,5.9D-39/
C     FOR ICL 1900
CR3   DATA XBIG,GBIG,XMINV /58.0D0,4.0D+76,1.8D-77/
C     FOR CDC 7600/CYBER
CR4   DATA XBIG,GBIG,XMINV /164.0D0,2.0D+291,3.2D-294/
C     FOR UNIVAC 1100 (D.P.)
CR5   DATA XBIG,GBIG,XMINV /171.0D0,7.3D+306,1.2D-308/
C     FOR IEEE DOUBLE PRECISION
CR7   DATA XBIG,GBIG,XMINV /170.0D0,4.3D+304,2.3D-308/
C     .. Executable Statements ..
C
C     ERROR 1 AND 2 TEST
      T = ABS(X)
      IF (T.GT.XBIG) GO TO 160
C     SMALL RANGE TEST
      IF (T.LE.XSMALL) GO TO 140
C     MAIN RANGE REDUCTION
      M = X
      IF (X.LT.0.0D0) GO TO 80
      T = X - DBLE(M)
      M = M - 1
      G = 1.0D0
      IF (M) 20, 120, 40
   20 G = G/X
      GO TO 120
   40 DO 60 I = 1, M
         G = (X-DBLE(I))*G
   60 CONTINUE
      GO TO 120
   80 T = X - DBLE(M-1)
C     ERROR 4 TEST
      IF (T.EQ.1.0D0) GO TO 220
      M = 1 - M
      G = X
      DO 100 I = 1, M
         G = (DBLE(I)+X)*G
  100 CONTINUE
      G = 1.0D0/G
  120 T = 2.0D0*T - 1.0D0
C
cGLD  * EXPANSION (0026) *
C
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = ((((((((((((+1.88278283D-6)*T-5.48272091D-6)
C08  *    *T+1.03144033D-5)*T-3.13088821D-5)*T+1.01593694D-4)
C08  *    *T-2.98340924D-4)*T+9.15547391D-4)*T-2.42216251D-3)
C08  *    *T+9.04037536D-3)*T-1.34119055D-2)*T+1.03703361D-1)
C08  *    *T+1.61692007D-2)*T + 8.86226925D-1
C
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = (((((((((((((-6.463247484D-7)*T+1.882782826D-6)
C09  *    *T-3.382165478D-6)*T+1.031440334D-5)*T-3.393457634D-5)
C09  *    *T+1.015936944D-4)*T-2.967655076D-4)*T+9.155473906D-4)
C09  *    *T-2.422622002D-3)*T+9.040375355D-3)*T-1.341184808D-2)
C09  *    *T+1.037033609D-1)*T+1.616919866D-2)*T + 8.862269255D-1
C
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = (((((((((((((((-7.613347676160D-8)*T+2.218377726362D-7)
C12  *    *T-3.608242105549D-7)*T+1.106350622249D-6)
C12  *    *T-3.810416284805D-6)*T+1.138199762073D-5)
C12  *    *T-3.360744031186D-5)*T+1.008657892262D-4)
C12  *    *T-2.968993359366D-4)*T+9.158021574033D-4)
C12  *    *T-2.422593898516D-3)*T+9.040332894085D-3)
C12  *    *T-1.341185067782D-2)*T+1.037033635205D-1)
C12  *    *T+1.616919872669D-2)*T + 8.862269254520D-1
C
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 15E.16
      Y = (((((((((((((((-1.243191705600000D-10
     *    *T+3.622882508800000D-10)*T-4.030909644800000D-10)
     *    *T+1.265236705280000D-9)*T-5.419466096640000D-9)
     *    *T+1.613133578240000D-8)*T-4.620920340480000D-8)
     *    *T+1.387603440435200D-7)*T-4.179652784537600D-7)
     *    *T+1.253148247777280D-6)*T-3.754930502328320D-6)
     *    *T+1.125234962812416D-5)*T-3.363759801664768D-5)
     *    *T+1.009281733953869D-4)*T-2.968901194293069D-4)
     *    *T+9.157859942174304D-4)*T-2.422595384546340D-3
      Y = ((((Y*T+9.040334940477911D-3)*T-1.341185057058971D-2)
     *    *T+1.037033634220705D-1)*T+1.616919872444243D-2)*T +
     *     8.862269254527580D-1
C
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 17E.18
C17   Y = (((((((((((((((-1.46381209600000000D-11
C17  *    *T+4.26560716800000000D-11)*T-4.01499750400000000D-11)
C17  *    *T+1.27679856640000000D-10)*T-6.13513953280000000D-10)
C17  *    *T+1.82243164160000000D-9)*T-5.11961333760000000D-9)
C17  *    *T+1.53835215257600000D-8)*T-4.64774927155200000D-8)
C17  *    *T+1.39383522590720000D-7)*T-4.17808776355840000D-7)
C17  *    *T+1.25281466396672000D-6)*T-3.75499034136576000D-6)
C17  *    *T+1.12524642975590400D-5)*T-3.36375833240268800D-5)
C17  *    *T+1.00928148823365120D-4)*T-2.96890121633200000D-4
C17   Y = ((((((Y*T+9.15785997288933120D-4)*T-2.42259538436268176D-3)
C17  *    *T+9.04033494028101968D-3)*T-1.34118505705967765D-2)
C17  *    *T+1.03703363422075456D-1)*T+1.61691987244425092D-2)*T +
C17  *     8.86226925452758013D-1
C
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = (((((((((((((((+6.7108864000000000000D-13
C19  *    *T-1.6777216000000000000D-12)*T+6.7108864000000000000D-13)
C19  *    *T-4.1523609600000000000D-12)*T+2.4998051840000000000D-11)
C19  *    *T-6.8985815040000000000D-11)*T+1.8595971072000000000D-10)
C19  *    *T-5.6763875328000000000D-10)*T+1.7255563264000000000D-9)
C19  *    *T-5.1663077376000000000D-9)*T+1.5481318277120000000D-8)
C19  *    *T-4.6445740523520000000D-8)*T+1.3931958370304000000D-7)
C19  *    *T-4.1782339907584000000D-7)*T+1.2528422549504000000D-6)
C19  *    *T-3.7549858152857600000D-6)*T+1.1252456510305280000D-5
C19   Y = (((((((((Y*T-3.3637584239226880000D-5)
C19  *    *T+1.0092815021080832000D-4)
C19  *    *T-2.9689012151880000000D-4)*T+9.1578599714350784000D-4)
C19  *    *T-2.4225953843706897600D-3)*T+9.0403349402888779200D-3)
C19  *    *T-1.3411850570596516480D-2)*T+1.0370336342207529018D-1)
C19  *    *T+1.6169198724442506740D-2)*T + 8.8622692545275801366D-1
C
      S14AAF = Y*G
      IFAIL = 0
      GO TO 240
C
C     ERROR 3 TEST
  140 IF (T.LT.XMINV) GO TO 200
      S14AAF = 1.0D0/X
      IFAIL = 0
      GO TO 240
C
C     ERROR EXITS
  160 IF (X.LT.0.0D0) GO TO 180
      IFAIL = P01ABF(IFAIL,1,SRNAME,0,P01REC)
      S14AAF = GBIG
      GO TO 240
C
  180 IFAIL = P01ABF(IFAIL,2,SRNAME,0,P01REC)
      S14AAF = 0.0D0
      GO TO 240
C
  200 IFAIL = P01ABF(IFAIL,3,SRNAME,0,P01REC)
      T = X
      IF (X.EQ.0.0D0) T = 1.0D0
      S14AAF = SIGN(1.0D0/XMINV,T)
      GO TO 240
C
  220 IFAIL = P01ABF(IFAIL,4,SRNAME,0,P01REC)
      S14AAF = GBIG
C
  240 RETURN
      END
      INTEGER FUNCTION P01AAF(IFAIL,ERROR,SRNAME)
C     MARK 1 RELEASE.  NAG COPYRIGHT 1971
C     MARK 3 REVISED
C     MARK 4A REVISED, IER-45
C     MARK 4.5 REVISED
C     MARK 7 REVISED (DEC 1978)
C     MARK 11 REVISED (FEB 1984)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     RETURNS THE VALUE OF ERROR OR TERMINATES THE PROGRAM.
C     TEST IF NO ERROR DETECTED
C     .. Scalar Arguments ..
      DOUBLE PRECISION        SRNAME
      INTEGER                 ERROR, IFAIL
C     .. Local Scalars ..
      INTEGER                 NOUT
C     .. External Subroutines ..
      EXTERNAL                X04AAF
C     .. Intrinsic Functions ..
      INTRINSIC               MOD
C     .. Executable Statements ..
      IF (ERROR.EQ.0) GO TO 40
C     DETERMINE OUTPUT UNIT FOR MESSAGE
      CALL X04AAF(0,NOUT)
C     TEST FOR SOFT FAILURE
      IF (MOD(IFAIL,10).EQ.1) GO TO 20
C     HARD FAILURE
      WRITE (NOUT,FMT=99999) SRNAME, ERROR
C     ******************** IMPLEMENTATION NOTE ********************
C     THE FOLLOWING STOP STATEMENT MAY BE REPLACED BY A CALL TO AN
C     IMPLEMENTATION-DEPENDENT ROUTINE TO DISPLAY A MESSAGE AND/OR
C     ABORT THE PROGRAM.
C     *************************************************************
      STOP
C     SOFT FAIL
C     TEST IF ERROR MESSAGES SUPPRESSED
   20 IF (MOD(IFAIL/10,10).EQ.0) GO TO 40
      WRITE (NOUT,FMT=99999) SRNAME, ERROR
   40 P01AAF = ERROR
      RETURN
C
99999 FORMAT (/' ERROR DETECTED BY NAG LIBRARY ROUTINE ',A8,' - IFAIL ',
     *  '= ',I5,//)
      END
      INTEGER FUNCTION P01ABF(IFAIL,IERROR,SRNAME,NREC,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     P01ABF is the error-handling routine for the NAG Library.
C
C     P01ABF either returns the value of IERROR through the routine
C     name (soft failure), or terminates execution of the program
C     (hard failure). Diagnostic messages may be output.
C
C     If IERROR = 0 (successful exit from the calling routine),
C     the value 0 is returned through the routine name, and no
C     message is output
C
C     If IERROR is non-zero (abnormal exit from the calling routine),
C     the action taken depends on the value of IFAIL.
C
C     IFAIL = 1: soft failure, silent exit (i.e. no messages are output)
C     IFAIL =-1: soft failure, noisy exit (i.e. messages are output)
C     IFAIL = 0: hard failure, noisy exit
C
C     For compatibility with certain routines included before Mark 12
C     P01ABF also allows an alternative specification of IFAIL in which
C     it is regarded as a decimal integer with least significant digits
C     cba. Then
C
C     a = 0: hard failure  a = 1: soft failure
C     b = 0: silent exit   b = 1: noisy exit
C
C     except that hard failure now always implies a noisy exit.
C
C     S.Hammarling, M.P.Hooper and J.J.du Croz, NAG Central Office.
C
C     .. Scalar Arguments ..
      INTEGER                 IERROR, IFAIL, NREC
      CHARACTER*(*)           SRNAME
C     .. Array Arguments ..
      CHARACTER*(*)           REC(*)
C     .. Local Scalars ..
      INTEGER                 I, NERR
      CHARACTER*72            MESS
C     .. External Subroutines ..
      EXTERNAL                P01ABZ, X04AAF, X04BAF
C     .. Intrinsic Functions ..
      INTRINSIC               ABS, MOD
C     .. Executable Statements ..
      IF (IERROR.NE.0) THEN
C        Abnormal exit from calling routine
         IF (IFAIL.EQ.-1 .OR. IFAIL.EQ.0 .OR.
     *       (IFAIL.GT.0 .AND. MOD(IFAIL/10,10).NE.0)) THEN
C           Noisy exit
            CALL X04AAF(0,NERR)
            DO 20 I = 1, NREC
               CALL X04BAF(NERR,REC(I))
   20       CONTINUE
            WRITE (MESS,FMT=99999) SRNAME, IERROR
            CALL X04BAF(NERR,MESS)
            IF (ABS(MOD(IFAIL,10)).NE.1) THEN
C              Hard failure
               CALL X04BAF(NERR,
     *                     ' ** NAG hard failure - execution terminated'
     *                     )
               CALL P01ABZ
            ELSE
C              Soft failure
               CALL X04BAF(NERR,
     *                     ' ** NAG soft failure - control returned')
            END IF
         END IF
      END IF
      P01ABF = IERROR
      RETURN
C
99999 FORMAT (' ** ABNORMAL EXIT from NAG Library routine ',A,': IFAIL',
     *  ' =',I6)
      END
      SUBROUTINE X04AAF(I,NERR)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     .. Scalar Arguments ..
      INTEGER           I, NERR
C     .. Local Scalars ..
      INTEGER           NERR1
C     .. Save statement ..
      SAVE              NERR1
C     .. Data statements ..
      DATA              NERR1/0/
C     .. Executable Statements ..
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END
      SUBROUTINE X04BAF(NOUT,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     X04BAF writes the contents of REC to the unit defined by NOUT.
C
C     Trailing blanks are not output, except that if REC is entirely
C     blank, a single blank character is output.
C     If NOUT.lt.0, i.e. if NOUT is not a valid Fortran unit identifier,
C     then no output occurs.
C
C     .. Scalar Arguments ..
      INTEGER           NOUT
      CHARACTER*(*)     REC
C     .. Local Scalars ..
      INTEGER           I
C     .. Intrinsic Functions ..
      INTRINSIC         LEN
C     .. Executable Statements ..
      IF (NOUT.GE.0) THEN
C        Remove trailing blanks
         DO 20 I = LEN(REC), 2, -1
            IF (REC(I:I).NE.' ') GO TO 40
   20    CONTINUE
C        Write record to external file
   40    WRITE (NOUT,FMT=99999) REC(1:I)
      END IF
      RETURN
C
99999 FORMAT (A)
      END
      SUBROUTINE P01ABZ
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     Terminates execution when a hard failure occurs.
C
C     ******************** IMPLEMENTATION NOTE ********************
C     The following STOP statement may be replaced by a call to an
C     implementation-dependent routine to display a message and/or
C     to abort the program.
C     *************************************************************
C     .. Executable Statements ..
      STOP
      END
