       program 

C CALCUL DU POTENTIEL ATOME-ATOME : HCl perturbe par CO2
C HCl  : MOLECULE LINEAIRE HETERONUCLEAIRE DE LA FORME A-B
C CO2  : molecule lineaie traitee comme une molecule a DEUX sites
C cf : C.S.MURPHY,...(MOLECULAR Physics,1981,vol. 44,n 1,p135
C L'AXE DES z EST ORIENTE >0 DE B VERS A:soit A=H  et  B=Cl
C CALCUL DES FONCTIONS Ul1l2m(r) D'APRES : J.DOWNS,K.E.GUBBINS,S.MURAD,
C C.G.GRAY (Molecular Physics,1979,vol.37,n 1,p129)
C     
C     
       implicit double precision (a -h, o -z) 
       common /b1/isuv
       common /cte/rh,rcl, ro, ehh, eclcl, eoo, eho, eclo, shh, sclcl, s
     +oo, sho, sclo
       save 

C     
       nin = 5
       nout = 6

C     
       isuv = 30
       i = 0

C     
       irmin = 1
       irmax = 500
       rini = 0.05
       rpas = 0.01

C     
C LES LONGUEURS SONT COMPTEES EN : ANGSTROM
C CONSTANTES POUR LE CALCUL DES POTENTIELS DE LENARD-JONES :
       rh = 1.2221
       rcl = 0.0349
       ro = 2.32 / 2.

C     
       shh = 2.735
       sclcl = 3.353
       soo = 3.344

C     
       ehh = 13.
       eclcl = 173.5
       eoo = 136.7

C CALCUL DES CONSTANTES POUR HCl-CO2 :
       soo = soo / 2.** (1. / 6.)
       eho = dsqrt (ehh * eoo)
       eclo = dsqrt (eclcl * eoo)
       sho = 0.5 * (shh + soo)
       sclo = 0.5 * (sclcl + soo)

C     
       pi = 3.14159265

C     
C     
C CALCUL DU POTENTIEL ANISOTROPE
C     
98765       do 10 l1 = 1,2
          do 11 l2 = 2,2,1
             ctel = 1. / dsqrt (dble ((2. * l1 + 1.) * (2. * l2 + 1.)))
             msup = min0 (l1,l2)
             minf =  (-(msup))
             do 13 m = 0,msup,1
                write (unit = nout,fmt = 11000)l1,l2,m
                write (unit = nout,fmt = 1400)
                do 14 ir = irmin,irmax
                   r = rini + (ir -1.) * rpas
                   som = 0.
                   linf = abs (l1 -l2)
                   lsup = l1 + l2
                   do 15 l = linf,lsup,1
                      sl = l1 + l2 + l
                      ltest = sl / 2.
                      if (sl -2 * ltest) 15,20,15
20                      term1 = u (l1,l2,l,0,0,r)
                      kk = 2 * l
                      ll = 2 * l1
                      mm = 2 * l2
                      nn = l
                      nn1 = l1 -m
                      nn2 = l2 + m
                      term2 = clebsc (kk,ll,mm,nn,nn1,nn2)

C     WRITE(6,*) L1,L2,L,CTEL,TERM2,TERM1
                      som = term1 * term2 * ctel + som
15                   continue
                   vaniso = som
                   write (unit = nout,fmt = *)vaniso
14                continue
                write (unit = nout,fmt = 1300)
13                write (unit = nout,fmt = 1300)
11          continue
10       continue
11000       FORMAT(10X,'CALCUL DE U(',I2,I2,I2,')',/)
1300       FORMAT(1X,80(1H*)/)
10000       FORMAT(5X,F6.4,5X,6(1PE15.8,2X))
1400       FORMAT(5X,'CALCUL DU POTENTIEL ATOME-ATOME POUR HCl-CO2 --  '
     +,'CALCUL EXACT INCLUANT TOUS LES TERMES JUSQU A L ORDRE: ',/)
14000       FORMAT(6X,'U+V=',6X,6(I2,16X),/)
       stop
       end
       real function clebsc (k, l, m, n, n1, n2) 
       implicit double precision (a -h, o -y) 
       save 
       integer p,p1,p2
       cp (n, m) = dsqrt (dble (n -m) * dble (n + m + 2))
       cm (n, m) = dsqrt (dble (n + m) * dble (n -m + 2))
       if (k .lt. 0 .or. l .lt. 0 .or. m .lt. 0)        goto 1
 
       if (n .lt. 0 .or. n1 .lt. 0 .or. n2 .lt. 0)        goto 1
 
       if (n .gt. k .or. n1 .gt. l .or. n2 .gt. m)        goto 1
 
       if (2 * (n -n1 -n2) .ne. k -l -m)        goto 1
 
       entry clebsc1(k,l,m,n,n1,n2)
       if (k .gt. l + m .or. k .lt. abs (l -m))        goto 1
 
       isg = 1
       p = n
       p1 = n1
       p2 = n2
       if (2 * p .le. k)        goto 80
 
       p = k -p
       p1 = l -p1
       p2 = m -p2
       if (mod (k -l -m,4) .ne. 0)        isg =  (-(1))
 
80       if (p -p2 .le. 1)        goto 50
 
       a = cgzzzz (k,l,m,p1 -p + p2)
       j2 = p -p2
       do 20 i = 1,j2
          b = a
          j = k + 2 -2 * i
          j1 = k -m -i * 2
20          a = a * cp (l,j1) / cm (k,j)
       if (p2 .eq. 0)        goto 2
 
       n3 = j2 + 1
       j = j -2
       b = (cp (k,j) * b -a * cm (l,j1 + 2)) / cm (m,m)
       goto 60
50       a = cgzzzz (k,l,m,p1)
       if (p .eq. 0)        goto 2
 
       b = cgzzzz (k,l,m,p1 -1)
       j = k
       j1 = l -2 * p1
       n3 = 1
60       yz = cp (l,j1)
70       j2 = j -j1 -2
       x = cm (k,j)
       a = (cp (m,j2) * a + yz * b) / x
       if (n3. ge. p)        goto 2
 
       n3 = n3 + 1
       j = j -2
       b = (x * b -yz * a) / cm (m,j2)
       goto 70
2       clebsc = a * isg
       return
1       clebsc = 0.
       return
       end

       real function cgzzzz (k, l, m, n) 
       implicit double precision (a -h, o -z) 
       save 
       integer*(4) i,j1,j2
       if (n .lt. 0 .or. n .gt. l)        goto 1
 
       a = 1.
       c = 1.
       d = 1.
       if (l .eq. 0)        goto 30
 
       n1 = 1
       do 10 i = 1,l
          j1 = l + 2 -2 * i
          j2 = 2 -j1 + k
          n1 =  (-(n1))
          if (j2 .lt.  (-(m)) .or. j2 .gt. m + 2)           goto 20
 
          h1 = m + j2
          h2 = m -j2 + 2
          h3 = l + j1
          h4 = l -j1 + 2
          hulp = h1 * h2 / h3 / h4
          c = c * hulp
          if (hulp .le. 0.)           goto 20
 
          d = d + c
20          if (i .eq. n)           a = n1 * dsqrt (c)
 
          if (abs (d) .lt. 1e30)           goto 10
 
          d = d * 1e-30
          c = c * 1e-30
          a = a * 1e-15
10       continue
30       cgzzzz = a / dsqrt (d)
       return
1       cgzzzz = 0.
       return
       end

       real function u (j1, j2, j, n1, n2, xr) 
       implicit double precision (a -h, o -z) 
       common /cte/rh,rcl, ro, ehh, eclcl, eoo, eho, eclo, shh, sclcl, s
     +oo, sho, sclo
       save 

C     
       daa = 4. * eho * sho** 12
       eaa = 4. * eho * sho** 6
       r12 = xr** 12
       r6 = xr** 6
       uaa1 = daa / r12 * f (12,j1,j2,j,rh,ro,xr)
       uaa2 = eaa / r6 * f (6,j1,j2,j,rh,ro,xr)
       uaa = uaa1 -uaa2

C     
       uab = uaa
       uab =  (-(1))** j2 * uab

C     
       dba = 4. * eclo * sclo** 12
       eba = 4. * eclo * sclo** 6
       uba1 = dba / r12 * f (12,j1,j2,j,rcl,ro,xr)
       uba2 = eba / r6 * f (6,j1,j2,j,rcl,ro,xr)
       uba = uba1 -uba2

C     
       ubb = uba
       ubb =  (-(1))** j * ubb

C     
       uba =  (-(1.))** j1 * uba
       u = uaa + uab + uba + ubb

C     
       return
       end

       real function f (nn, ll1, ll2, ll, rra, rrb, rr) 
       implicit double precision (a -h, o -z) 
       save 
       kk = 2 * ll
       lll = 2 * ll1
       mm = 2 * ll2
       n0 = ll
       nn1 = ll1
       nn2 = ll2
       c = clebsc (kk,lll,mm,n0,nn1,nn2)
       glamda = ll1 + ll2 + ll
       glamda = glamda / 2.
       slamda = glamda -ll
       x = nn / 2.
       fn2 = disfac (x,glamda)
       x = (nn -1.) / 2.
       fn12 = disfac (x,slamda)
       x = 1. / 2.
       sss = ll1
       fl1 = disfac (x,sss)
       sss = ll2
       fl2 = disfac (x,sss)
       aa = glamda + nn / 2.
       bb = lamda + (nn -1.) / 2.
       cc = ll1 + 3. / 2.
       dd = ll2 + 3. / 2.
       xx = (rra / rr)** 2
       yy = (rrb / rr)** 2
       ff = appell (aa,bb,cc,dd,xx,yy)

C     
C     WRITE(6,10000) NN,AA,BB,CC,DD,XX,YY
10000       FORMAT(5X,'APPELL=','NN= ',I2,2X,6(1PE15.8,2X))

C     
C     CC=(1.)/(DSQRT((2.*LL1+1.)*(2.*LL2+1.)))
       rrrr = fn2 * fn12 / (fl1 * fl2)

C     WRITE(6,*) NN,LL1,LL2,LL,RRA,RRB,RR,C,FN2,FN12,FL1,FL2,RRRR,FF
       rrab = rra** ll1
       rrab = rrab * rrb** ll2 *  (-(1.))** ll2
       rr2 = rr** ( (-(ll1)) -ll2)
       rrr = rrab * rr2

C     WRITE(6,*) RRAB,RR2,RRR
       f = c * rrrr * rrr * ff
       return
       end

       real function appell (a, b, c, d, x, y) 
       implicit double precision (a -h, o -z) 

C ATTENTION : il faut boucler sur u (par exemple) et la SOMME u+v pour que
C la comparaison formules du Journal de Physique avec la fonction de Appel
C ait un sens (termes du meme degre)
       parameter (isuv = 30)
       double precision factorial(0:isuv)
       double precision fa(0:isuv),fb(0:isuv),fc(0:isuv),fd(0:isuv)
       double precision som1(0:isuv)
       save 

c     
       call facto(isuv,factorial)

c     
*     do i = 0, isuv
*        fa(i) = disfac(a,float(i))
*        fb(i) = disfac(b,float(i))
*        fc(i) = disfac(c,float(i))
*        fd(i) = disfac(d,float(i))
*     end do
       fa(0) = 1.
       fb(0) = 1.
       fc(0) = 1.
       fd(0) = 1.
       do  i = 1,isuv
          fa(i) = fa(i -1) * (a + i -1)
          fb(i) = fb(i -1) * (b + i -1)
          fc(i) = fc(i -1) * (c + i -1)
          fd(i) = fd(i -1) * (d + i -1)
       enddo

c     
       do  iu = 0,isuv
          som = 0.
          do  iuvmax = iu,isuv
             iv = iuvmax -iu
             iuv = iu + iv
             terma = fa(iuv) * fb(iuv)
             terma = terma / (fc(iu) * fd(iv))
             terma = terma / (factorial(iu) * factorial(iv))
             termb = x** iu * y** iv
             term = terma * termb
             som = som + term
          enddo
          som1(iu) = som
       enddo
       som = 0.
       do  iu = 0,isuv
          som = som + som1(iu)
       enddo
       appell = som
       return
       end

       subroutine facto (n, x)

C      implicit none
       integer n
       double precision x(0:n)

c     
c     --------------------------------------------------------
c     computes the factorials of the integers from 0 through n
c     --------------------------------------------------------
c     
       integer i

c     
       x(0) = 1.
       do  i = 1,n
          x(i) = x(i -1) * dble (i)
       enddo

c     
       return
       end

       real function disfac (alpha, ss) 
       implicit double precision (a -h, o -z) 
       save 

C     WRITE(6,3000) ALPHA,SS
C3000 FORMAT(5X,'ALPHA=',F5.2,5X,'SS= ',F3.1)
       if (ss) 9,10,9
10       f = 1.
       disfac = 1.
       goto 50
9       term1 = alpha + ss -1. + 1.
       term2 = alpha -1. + 1.
       ifail = 0
       fact1 = s14aaf (term1,ifail)
       fact2 = s14aaf (term2,ifail)
       disfac = fact1 / fact2

C  50 WRITE(6,1000) ALPHA,SS,F
C1000 FORMAT(5X,'ALPHA=',F5.2,3X,'SS= ',F3.1,3X,'DISFAC= ',F8.3)
50       return
       end

       real function fiso (xr) 
       implicit double precision (a -h, o -z) 
       save 
       r = xr
       rh = 1.2221

C     WRITE(6,*) R
       rcl =  (-(0.0349))
       ehh = 13.
       eclcl = 173.5
       ehcl = 47.5
       shh = 2.735
       sclcl = 3.353
       shcl = 3.044
       shh12 = shh** 12
       shh6 = shh** 6
       shcl12 = shcl** 12
       shcl6 = shcl** 6
       scl12 = sclcl** 12
       scl6 = sclcl** 6

C     WRITE(6,*) SHH12,SHH6
C     WRITE(6,*) SHCL12,SHCL6
C     WRITE(6,*) SCL12,SCL6
       thh = f (12,0,0,0,rh,rh,r) * shh** 12
       thh = thh -shh** 6 * f (6,0,0,0,rh,rh,r)
       thh = 4. * ehh * thh

C     WRITE(6,*) THH
       thcl = f (12,0,0,0,rh,rcl,r) * shcl** 12
       thcl = thcl -f (6,0,0,0,rh,rcl,r) * shcl** 6
       thcl = 4. * ehcl * thcl

C     WRITE(6,*) THCL
       tclcl = f (12,0,0,0,rcl,rcl,r) * sclcl** 12
       tclcl = tclcl -f (6,0,0,0,rcl,rcl,r) * sclcl** 6
       tclcl = tclcl * 4. * eclcl

C     WRITE(6,*) TCLCL
C     WRITE(6,*) THH,THCL,THCL,TCLCL
       fiso = thh + 2. * thcl + tclcl
       return
       end


cGLD GouldEurope: values supplied, 87/11/05
cGLD GouldEurope: C15 comment lines enabled, 87/11/05
       double precision function s14aaf (x, ifail) 
       save 

C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 7C REVISED IER-184 (MAY 1979)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     GAMMA FUNCTION
C     
C     **************************************************************
C     
C     TO EXTRACT THE CORRECT CODE FOR A PARTICULAR MACHINE-RANGE,
C     ACTIVATE THE STATEMENTS CONTAINED IN COMMENTS BEGINNING  CDD ,
C     WHERE  DD  IS THE APPROXIMATE NUMBER OF SIGNIFICANT DECIMAL
C     DIGITS REPRESENTED BY THE MACHINE
C     DELETE THE ILLEGAL DUMMY STATEMENTS OF THE FORM
C     * EXPANSION (NNNN) *
C     
C     ALSO INSERT APPROPRIATE DATA STATEMENTS TO DEFINE CONSTANTS
C     WHICH DEPEND ON THE RANGE OF NUMBERS REPRESENTED BY THE
C     MACHINE, RATHER THAN THE PRECISION (SUITABLE STATEMENTS FOR
C     SOME MACHINES ARE CONTAINED IN COMMENTS BEGINNING CRD WHERE
C     D IS A DIGIT WHICH SIMPLY DISTINGUISHES A GROUP OF MACHINES).
C     DELETE THE ILLEGAL DUMMY DATA STATEMENTS WITH VALUES WRITTEN
C     *VALUE*
C     
C     **************************************************************
C     
C     .. Parameters ..
       character*(6) srname
       parameter (srname = 'S14AAF')

C     .. Scalar Arguments ..
       double precision x
       integer ifail

C     .. Local Scalars ..
       double precision g,gbig,t,xbig,xminv,xsmall,y
       integer i,m

C     .. Local Arrays ..
       character*(1) p01rec(1)

C     .. External Functions ..
       integer p01abf
       external p01abf

C     .. Intrinsic Functions ..
       intrinsic abs,sign,dble

C     .. Data statements ..
C08   DATA XSMALL/1.0D-8/
C09   DATA XSMALL/3.0D-9/
C12   DATA XSMALL/1.0D-12/
       DATA XSMALL/3.0D-15/

C17   DATA XSMALL/1.0D-17/
C19   DATA XSMALL/1.7D-18/
C     
cGLD  DATA XBIG,GBIG,XMINV/ *VALUE*,*VALUE*,*VALUE* /
       DATA XBIG,GBIG,XMINV / 0.56000000D+02,0.1269640D+74,0.14D-75 /

C     XBIG = LARGEST X SUCH THAT  GAMMA(X) .LT. MAXREAL
C                            AND  1.0/GAMMA(X+1.0) .GT. MINREAL
C             (ROUNDED DOWN TO AN INTEGER)
C     GBIG = GAMMA(XBIG)
C     XMINV = MAX(1.0/MAXREAL,MINREAL)  (ROUNDED UP)
C     FOR IEEE SINGLE PRECISION
CR0   DATA XBIG,GBIG,XMINV /33.0E0,2.6E+35,1.2E-38/
C     FOR IBM 360/370 AND SIMILAR MACHINES
CR1   DATA XBIG,GBIG,XMINV /57.0D0,7.1D+74,1.4D-76/
C     FOR DEC-10, HONEYWELL, UNIVAC 1100 (S.P.)
CR2   DATA XBIG,GBIG,XMINV /34.0D0,8.7D+36,5.9D-39/
C     FOR ICL 1900
CR3   DATA XBIG,GBIG,XMINV /58.0D0,4.0D+76,1.8D-77/
C     FOR CDC 7600/CYBER
CR4   DATA XBIG,GBIG,XMINV /164.0D0,2.0D+291,3.2D-294/
C     FOR UNIVAC 1100 (D.P.)
CR5   DATA XBIG,GBIG,XMINV /171.0D0,7.3D+306,1.2D-308/
C     FOR IEEE DOUBLE PRECISION
CR7   DATA XBIG,GBIG,XMINV /170.0D0,4.3D+304,2.3D-308/
C     .. Executable Statements ..
C     
C     ERROR 1 AND 2 TEST
       t = abs (x)
       if (t .gt. xbig)        goto 160
 

C     SMALL RANGE TEST
       if (t .le. xsmall)        goto 140
 

C     MAIN RANGE REDUCTION
       m = x
       if (x .lt. 0.0d0)        goto 80
 
       t = x -dble (m)
       m = m -1
       g = 1.0d0
       if (m) 20,120,40
20       g = g / x
       goto 120
40       do 60 i = 1,m
          g = (x -dble (i)) * g
60       continue
       goto 120
80       t = x -dble (m -1)

C     ERROR 4 TEST
       if (t .eq. 1.0d0)        goto 220
 
       m = 1 -m
       g = x
       do 100 i = 1,m
          g = (dble (i) + x) * g
100       continue
       g = 1.0d0 / g
120       t = 2.0d0 * t -1.0d0

C     
cGLD  * EXPANSION (0026) *
C     
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = ((((((((((((+1.88278283D-6)*T-5.48272091D-6)
C08  *    *T+1.03144033D-5)*T-3.13088821D-5)*T+1.01593694D-4)
C08  *    *T-2.98340924D-4)*T+9.15547391D-4)*T-2.42216251D-3)
C08  *    *T+9.04037536D-3)*T-1.34119055D-2)*T+1.03703361D-1)
C08  *    *T+1.61692007D-2)*T + 8.86226925D-1
C     
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = (((((((((((((-6.463247484D-7)*T+1.882782826D-6)
C09  *    *T-3.382165478D-6)*T+1.031440334D-5)*T-3.393457634D-5)
C09  *    *T+1.015936944D-4)*T-2.967655076D-4)*T+9.155473906D-4)
C09  *    *T-2.422622002D-3)*T+9.040375355D-3)*T-1.341184808D-2)
C09  *    *T+1.037033609D-1)*T+1.616919866D-2)*T + 8.862269255D-1
C     
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = (((((((((((((((-7.613347676160D-8)*T+2.218377726362D-7)
C12  *    *T-3.608242105549D-7)*T+1.106350622249D-6)
C12  *    *T-3.810416284805D-6)*T+1.138199762073D-5)
C12  *    *T-3.360744031186D-5)*T+1.008657892262D-4)
C12  *    *T-2.968993359366D-4)*T+9.158021574033D-4)
C12  *    *T-2.422593898516D-3)*T+9.040332894085D-3)
C12  *    *T-1.341185067782D-2)*T+1.037033635205D-1)
C12  *    *T+1.616919872669D-2)*T + 8.862269254520D-1
C     
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 15E.16
       y = ((((((((((((((( (-(1.243191705600000d-10)) * t + 3.6228825088
     +00000d-10) * t -4.030909644800000d-10) * t + 1.265236705280000d-9)
     + * t -5.419466096640000d-9) * t + 1.613133578240000d-8) * t -4.620
     +920340480000d-8) * t + 1.387603440435200d-7) * t -4.17965278453760
     +0d-7) * t + 1.253148247777280d-6) * t -3.754930502328320d-6) * t +
     + 1.125234962812416d-5) * t -3.363759801664768d-5) * t + 1.00928173
     +3953869d-4) * t -2.968901194293069d-4) * t + 9.157859942174304d-4)
     + * t -2.422595384546340d-3
       y = ((((y * t + 9.040334940477911d-3) * t -1.341185057058971d-2) 
     +* t + 1.037033634220705d-1) * t + 1.616919872444243d-2) * t + 8.86
     +2269254527580d-1

C     
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 17E.18
C17   Y = (((((((((((((((-1.46381209600000000D-11
C17  *    *T+4.26560716800000000D-11)*T-4.01499750400000000D-11)
C17  *    *T+1.27679856640000000D-10)*T-6.13513953280000000D-10)
C17  *    *T+1.82243164160000000D-9)*T-5.11961333760000000D-9)
C17  *    *T+1.53835215257600000D-8)*T-4.64774927155200000D-8)
C17  *    *T+1.39383522590720000D-7)*T-4.17808776355840000D-7)
C17  *    *T+1.25281466396672000D-6)*T-3.75499034136576000D-6)
C17  *    *T+1.12524642975590400D-5)*T-3.36375833240268800D-5)
C17  *    *T+1.00928148823365120D-4)*T-2.96890121633200000D-4
C17   Y = ((((((Y*T+9.15785997288933120D-4)*T-2.42259538436268176D-3)
C17  *    *T+9.04033494028101968D-3)*T-1.34118505705967765D-2)
C17  *    *T+1.03703363422075456D-1)*T+1.61691987244425092D-2)*T +
C17  *     8.86226925452758013D-1
C     
C     EXPANSION (0026) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = (((((((((((((((+6.7108864000000000000D-13
C19  *    *T-1.6777216000000000000D-12)*T+6.7108864000000000000D-13)
C19  *    *T-4.1523609600000000000D-12)*T+2.4998051840000000000D-11)
C19  *    *T-6.8985815040000000000D-11)*T+1.8595971072000000000D-10)
C19  *    *T-5.6763875328000000000D-10)*T+1.7255563264000000000D-9)
C19  *    *T-5.1663077376000000000D-9)*T+1.5481318277120000000D-8)
C19  *    *T-4.6445740523520000000D-8)*T+1.3931958370304000000D-7)
C19  *    *T-4.1782339907584000000D-7)*T+1.2528422549504000000D-6)
C19  *    *T-3.7549858152857600000D-6)*T+1.1252456510305280000D-5
C19   Y = (((((((((Y*T-3.3637584239226880000D-5)
C19  *    *T+1.0092815021080832000D-4)
C19  *    *T-2.9689012151880000000D-4)*T+9.1578599714350784000D-4)
C19  *    *T-2.4225953843706897600D-3)*T+9.0403349402888779200D-3)
C19  *    *T-1.3411850570596516480D-2)*T+1.0370336342207529018D-1)
C19  *    *T+1.6169198724442506740D-2)*T + 8.8622692545275801366D-1
C     
       s14aaf = y * g
       ifail = 0
       goto 240

C     
C     ERROR 3 TEST
140       if (t .lt. xminv)        goto 200
 
       s14aaf = 1.0d0 / x
       ifail = 0
       goto 240

C     
C     ERROR EXITS
160       if (x .lt. 0.0d0)        goto 180
 
       ifail = p01abf (ifail,1,srname,0,p01rec)
       s14aaf = gbig
       goto 240

C     
180       ifail = p01abf (ifail,2,srname,0,p01rec)
       s14aaf = 0.0d0
       goto 240

C     
200       ifail = p01abf (ifail,3,srname,0,p01rec)
       t = x
       if (x .eq. 0.0d0)        t = 1.0d0
 
       s14aaf = sign (1.0d0 / xminv,t)
       goto 240

C     
220       ifail = p01abf (ifail,4,srname,0,p01rec)
       s14aaf = gbig

C     
240       return
       end

       integer function p01aaf (ifail, error, srname) 

C     MARK 1 RELEASE.  NAG COPYRIGHT 1971
C     MARK 3 REVISED
C     MARK 4A REVISED, IER-45
C     MARK 4.5 REVISED
C     MARK 7 REVISED (DEC 1978)
C     MARK 11 REVISED (FEB 1984)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     RETURNS THE VALUE OF ERROR OR TERMINATES THE PROGRAM.
C     TEST IF NO ERROR DETECTED
C     .. Scalar Arguments ..
       double precision srname
       integer error,ifail

C     .. Local Scalars ..
       integer nout

C     .. External Subroutines ..
       external x04aaf

C     .. Intrinsic Functions ..
       intrinsic mod

C     .. Executable Statements ..
       if (error .eq. 0)        goto 40
 

C     DETERMINE OUTPUT UNIT FOR MESSAGE
       call x04aaf(0,nout)

C     TEST FOR SOFT FAILURE
       if (mod (ifail,10) .eq. 1)        goto 20
 

C     HARD FAILURE
       write (unit = nout,fmt = 99999)srname,error

C     ******************** IMPLEMENTATION NOTE ********************
C     THE FOLLOWING STOP STATEMENT MAY BE REPLACED BY A CALL TO AN
C     IMPLEMENTATION-DEPENDENT ROUTINE TO DISPLAY A MESSAGE AND/OR
C     ABORT THE PROGRAM.
C     *************************************************************
       stop

C     SOFT FAIL
C     TEST IF ERROR MESSAGES SUPPRESSED
20       if (mod (ifail / 10,10) .eq. 0)        goto 40
 
       write (unit = nout,fmt = 99999)srname,error
40       p01aaf = error
       return

C     
99999       FORMAT (/' ERROR DETECTED BY NAG LIBRARY ROUTINE ',A8,' - IF
     +AIL ',  '= ',I5,//)
       end

       integer function p01abf () 

C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C     
C     P01ABF is the error-handling routine for the NAG Library.
C     
C     P01ABF either returns the value of IERROR through the routine
C     name (soft failure), or terminates execution of the program
C     (hard failure). Diagnostic messages may be output.
C     
C     If IERROR = 0 (successful exit from the calling routine),
C     the value 0 is returned through the routine name, and no
C     message is output
C     
C     If IERROR is non-zero (abnormal exit from the calling routine),
C     the action taken depends on the value of IFAIL.
C     
C     IFAIL = 1: soft failure, silent exit (i.e. no messages are output)
C     IFAIL =-1: soft failure, noisy exit (i.e. messages are output)
C     IFAIL = 0: hard failure, noisy exit
C     
C     For compatibility with certain routines included before Mark 12
C     P01ABF also allows an alternative specification of IFAIL in which
C     it is regarded as a decimal integer with least significant digits
C     cba. Then
C     
C     a = 0: hard failure  a = 1: soft failure
C     b = 0: silent exit   b = 1: noisy exit
C     
C     except that hard failure now always implies a noisy exit.
C     
C     S.Hammarling, M.P.Hooper and J.J.du Croz, NAG Central Office.
C     
C     .. Scalar Arguments ..
       integer ierror,ifail,nrec
       character*(*) srname

C     .. Array Arguments ..
       character*(*) rec(*)

C     .. Local Scalars ..
       integer i,nerr
       character*(72) mess

C     .. External Subroutines ..
       external p01abz,x04aaf,x04baf

C     .. Intrinsic Functions ..
       intrinsic abs,mod

C     .. Executable Statements ..
       if (ierror .ne. 0) then 
 
C        Abnormal exit from calling routine
          if (ifail .eq.  (-(1)) .or. ifail .eq. 0 .or. ifail .gt. 0 .an
     +d. mod (ifail / 10,10) .ne. 0) then 
 
C           Noisy exit
             call x04aaf(0,nerr)
             do 20 i = 1,nrec
                call x04baf(nerr,rec(i))
20             continue
             write (unit = mess,fmt = 99999)srname,ierror
             call x04baf(nerr,mess)
             if (abs (mod (ifail,10)) .ne. 1) then 
 
C              Hard failure
                call x04baf(nerr,' ** NAG hard failure - execution termi
     +nated')
                call p01abz()
               else

C              Soft failure
                call x04baf(nerr,' ** NAG soft failure - control returne
     +d')
             endif
           endif
        endif
       p01abf = ierror
       return

C     
99999       FORMAT (' ** ABNORMAL EXIT from NAG Library routine ',A,': I
     +FAIL',  ' =',I6)
       end

       subroutine x04aaf (i, nerr)

C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C     
C     .. Scalar Arguments ..
       integer i,nerr

C     .. Local Scalars ..
       integer nerr1

C     .. Save statement ..
       save nerr1

C     .. Data statements ..
       DATA              NERR1/0/

C     .. Executable Statements ..
       if (i .eq. 0)        nerr = nerr1
 
       if (i .eq. 1)        nerr1 = nerr
 
       return
       end

       subroutine x04baf (nout, rec)

C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C     
C     X04BAF writes the contents of REC to the unit defined by NOUT.
C     
C     Trailing blanks are not output, except that if REC is entirely
C     blank, a single blank character is output.
C     If NOUT.lt.0, i.e. if NOUT is not a valid Fortran unit identifier,
C     then no output occurs.
C     
C     .. Scalar Arguments ..
       integer nout
       character*(*) rec

C     .. Local Scalars ..
       integer i

C     .. Intrinsic Functions ..
       intrinsic len

C     .. Executable Statements ..
       if (nout. ge. 0) then 
 
C        Remove trailing blanks
          do 20 i = len (rec),2, (-(1))
             if (rec(i:i) .ne. ' ')              goto 40
 
20          continue

C        Write record to external file
40          write (unit = nout,fmt = 99999)rec(1,i)
        endif
       return

C     
99999       FORMAT (A)
       end

       subroutine p01abz ()

C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C     
C     Terminates execution when a hard failure occurs.
C     
C     ******************** IMPLEMENTATION NOTE ********************
C     The following STOP statement may be replaced by a call to an
C     implementation-dependent routine to display a message and/or
C     to abort the program.
C     *************************************************************
C     .. Executable Statements ..
       stop
       end

