/* Copyright (C) 1992, Irisa, Indiana University, 
   demo of the Sigma toolbox */
 /**************************************************************************
  *                                                                        *
  *   Programme de Test pour la ToolBox                                    *
  *                                                                        *
  *************************************************************************/

#include <stdio.h>
#include "macro.h"
#include "dependence.h"
#include "ext_lib.h"
#include "ext_low.h"
#include "ext_mid.h"
#include "ext_high.h"

FILE *finput;
FILE *outfile;
extern int Warning_count;
extern int DEBUG;
char Version[256];

/*
 *
 *  some stuf to control the args 
 *
 */


/* read the parameters value or check if here and return the value */

Read_Pres_Parameter_Value(s,argc, argv)
int argc;
char *argv[];
char *s;
{
  int i;

  for (i = 1 ; i<argc; i++)
    {
      if (strcmp(argv[i],s) == 0)
        { /* we found the parameter */
          return(1);
        }
    }
  return(0);
}

Read_int_Parameter_Value(s,argc, argv)
int argc;
char *argv[];
char *s;
{
  int i;

  for (i = 1 ; i<argc; i++)
    {
      if (strcmp(argv[i],s) == 0)
        { /* we found the parameter */

          if (i+1<argc)
            return(atoi(argv[i+1]));
          else
            printf("Value missing for %s\n",s);
          return(-1);
        }
    }
  return(-1);
}

char *
Read_string_Parameter_Value(s,argc, argv)
int argc;
char *argv[];
char *s;
{
  int i;

  for (i = 1 ; i<argc; i++)
    {
      if (strcmp(argv[i],s) == 0)
        { /* we found the parameter */

          if (i+1<argc)
            return argv[i+1];
          else
            printf("Value missing for %s\n",s);
          return(NULL);
        }
    }
  return(NULL);
}

Write_Preambule()
{
  strcpy(Version,"Test ToolBox  version 0.1 - 04/24/92");
  printf("%s\n", Version);
}

 /*
  *
  *  main procedure
  *
  */

main(argc,argv)
int argc;
char *argv[];
{
   int temp,i;
   int l, loop;
   char *s, s1[256];

   Write_Preambule();

   s = Read_string_Parameter_Value("-o",argc, argv);
   if (s != NULL)
     {
      outfile = fopen(s,"w");
    } else
      outfile = stdout;

 
  
   s = Read_string_Parameter_Value("-i",argc, argv);
   if (s != NULL)
     {
       /* if you just want to initialize the toolbox uses
          Init_Tool_Box() */
       Initialize_Project_Toolbox(s);
    } else
      {
        Initialize_Project_Toolbox("demo.proj");
      }
   Init_Annotation();
   Example_Annotation_Uses();
    Write_Data_Base_For_Debug();
   UnparseProgram(outfile);
   if (Warning_count != 0)
     printf("You got %d Warning\n",Warning_count);
   exit(0);
}
