/* declaration pour la toolbox 19/12/91 */

/* The following include files are sigma  include files */
#include "defs.h"
#include "bif.h"
#include "ll.h"
#include "symb.h"
#include "sets.h"
#include "db.h"
#include "vparse.h"

/*  
 * There are 3 types  of macros:
 *       the first type deals with bif nodes and are named BIF_XXX
 *       the second type deals with symbol nodes and are named SYMB_XXX 
 *       the last type deasl with  low level nodes and are named NODE_XXX
 */

/* Macros for BIF NODE */
#define DECL_SOURCE_LINE(FUNC) ((FUNC)->g_line)
#define DECL_SOURCE_FILE(FUNC) (default_filename)
/* give the code of a node */
#define BIF_CODE(NODE) ((NODE)->variant)
#define BIF_LINE(NODE) ((NODE)->g_line)
/* give the identifier */
#define BIF_ID(NODE)   ((NODE)->id)
#define BIF_NEXT(NODE)   ((NODE)->thread)
#define BIF_CP(NODE)   ((NODE)->control_parent)
#define BIF_LABEL(NODE) ((NODE)->label)
#define BIF_LL1(NODE)  ((NODE)->entry.template.ll_ptr1)
#define BIF_LL2(NODE)  ((NODE)->entry.template.ll_ptr2)
#define BIF_LL3(NODE)  ((NODE)->entry.template.ll_ptr3)
#define BIF_SYMB(NODE)  ((NODE)->entry.template.symbol)
#define BIF_BLOB1(NODE)  ((NODE)->entry.template.bl_ptr1)
#define BIF_BLOB2(NODE)  ((NODE)->entry.template.bl_ptr2)
#define BIF_FLOW(NODE)  ((NODE)->entry.template.bl_ptr1->ref)
#define BIF_FLOW_TRUE(NODE)  ((NODE)->entry.template.bl_ptr1->ref)
#define BIF_FLOW_FALSE_EXIST(NODE)  ((NODE)->entry.template.bl_ptr2)
#define BIF_FLOW_FALSE(NODE)  ((NODE)->entry.template.bl_ptr2->ref)
#define BIF_FILE_NAME(NODE) ((NODE)->filename)
#define BIF_CMNT(NODE) ((NODE)->entry.template.cmnt_ptr)
#define BIF_LABEL_USE(NODE) ((NODE)->entry.template.lbl_ptr)
#define BIF_SETS(NODE)       ((NODE)->entry.template.sets)



/* Macros for LOW LEVEL NODE*/

/* Give the code of the node */
#define NODE_CODE(NODE) ((NODE)->variant)
/* give the identifier */
#define NODE_ID(NODE)   ((NODE)->id)
#define NODE_NEXT(NODE) ((NODE)->thread)
#define NODE_CHAIN(NODE) ((NODE)->thread)
#define NODE_TYPE(NODE) ((NODE)->type)
#define NODE_STR(NODE)  ((NODE)->entry.string_val)
#define NODE_STRING_POINTER(NODE)  ((NODE)->entry.string_val)
#define NODE_IV(NODE)   ((NODE)->entry.ival)

/* use for integer constant 
   the boolean value is use if the constante is big
   (two integers) */
#define NODE_INT_CST_LOW(NODE)   ((NODE)->entry.ival)
/* la partie haute est dans les noeuds info 
   A modifier par la suite */


#define NODE_CV(NODE)   ((NODE)->entry.cval)
#define NODE_DV(NODE)   ((NODE)->entry.dval)
#define NODE_REAL_CST(NODE)   ((NODE)->entry.dval)
#define NODE_BV(NODE)   ((NODE)->entry.bval)
#define NODE_ARRAY_OP(NODE) ((NODE)->entry.array_op)
#define NODE_TEMPLATE(NODE) ((NODE)->entry.template)
#define NODE_SYMB(NODE) ((NODE)->entry.template.symbol)
#define NODE_TEMPLATE_LL1(NODE) ((NODE)->entry.template.ll_ptr1)
#define NODE_TEMPLATE_LL2(NODE) ((NODE)->entry.template.ll_ptr2)
#define NODE_OPERAND0(NODE) ((NODE)->entry.template.ll_ptr1)
#define NODE_PURPOSE(NODE) ((NODE)->entry.template.ll_ptr1)
#define NODE_OPERAND1(NODE) ((NODE)->entry.template.ll_ptr2)
#define NODE_OPERAND2(NODE) bif_sorry("OPERAND2")
#define NODE_VALUE(NODE) ((NODE)->entry.template.ll_ptr2)
#define NODE_STRING_LENGTH(NODE) (strlen((NODE)->entry.string_val))
#define NODE_LABEL(NODE)          ((NODE)->entry.label_list.lab_ptr)
#define NODE_LIST_ITEM(NODE)       ((NODE)->entry.list.item)
#define NODE_LIST_NEXT(NODE)       ((NODE)->entry.list.next)

/* For symbole NODE */
#define SYMB_CODE(NODE)   ((NODE)->variant)
#define SYMB_ID(NODE)   ((NODE)->id)
#define SYMB_IDENT(NODE)   ((NODE)->ident)
#define SYMB_BLOC_NEXT(NODE)   ((NODE)->next_symb)
#define SYMB_NEXT(NODE)   ((NODE)->thread)
#define SYMB_LIST(NODE)   ((NODE)->id_list)
#define SYMB_TYPE(NODE)   ((NODE)->type)
#define SYMB_SCOPE(NODE)   ((NODE)->scope)
#define SYMB_UD_CHAIN(NODE) ((NODE)->ud_chain)
#define SYMB_ENTRY(NODE)   ((NODE)->entry)
#define SYMB_NEXT_DECL(NODE)   ((NODE)->entry.var_decl.next_in)
#define SYMB_NEXT_FIELD(NODE)   ((NODE)->entry.field.next)
#define SYMB_BASE_NAME(NODE)   ((NODE)->entry.template.base_name)
#define SYMB_FUNC_HEDR(NODE)   ((NODE)->entry.func_decl.func_hedr)
#define SYMB_FUNC_PARAM(NODE)   ((NODE)->entry.proc_decl.in_list)
#define SYMB_FUNC_NB_PARAM(NODE) ((NODE)->entry.proc_decl.num_input)
#define SYMB_FUNC_OUTPUT(NODE)   ((NODE)->entry.proc_decl.num_output)
/* for BLOB NODE */

#define  BLOB_NEXT(NODE) ((NODE)->next)
#define  BLOB_VALUE(NODE) ((NODE)->ref)
#define  HEAD_BLOB(NODE)  ((NODE)->head_blob)

/* for type node */
#define TYPE_CODE(NODE)  ((NODE)->variant)
#define TYPE_ID(NODE)  ((NODE)->id)
#define TYPE_UD_CHAIN(NODE) ((NODE)->ud_chain)
#define TYPE_BASE(NODE)   ((NODE)->entry.template.base_type)
#define TYPE_RANGES(NODE) ((NODE)->entry.template.ranges)
#define TYPE_DIM(NODE) ((NODE)->entry.ar_decl.num_dimensions)
#define TYPE_DECL_BASE(NODE) ((NODE)->entry.ar_decl.base_type)
#define TYPE_DECL_RANGES(NODE) ((NODE)->entry.ar_decl.ranges)
#define TYPE_NEXT(NODE) ((NODE)->thread)
#define TYPE_DESCRIP(NODE) ((NODE)->entry.descriptive)
#define TYPE_DESCRIP_BASE_TYPE(NODE) ((NODE)->entry.descriptive.base_type)
#define TYPE_FIELDS(NODE) ((NODE)->entry.re_decl.first)
#define TYPE_UNSIGNED(NODE) ((NODE)->entry.descriptive.signed_flag)
#define TYPE_LONG_SHORT(NODE) ((NODE)->entry.descriptive.long_short_flag)
#define TYPE_MODE_FLAG(NODE) ((NODE)->entry.descriptive.mod_flag)
#define TYPE_STORAGE_FLAG(NODE) ((NODE)->entry.descriptive.storage_flag)
#define TYPE_ACCESS_FLAG(NODE) ((NODE)->entry.descriptive.access_flag)
#define TYPE_SYMB_DERIVE(NODE) ((NODE)->entry.derived_type)
/* sepcial case for enumeral type */
#define TYPE_VALUES(NODE) ((NODE)->entry.template.ranges) /* wrong, to verify */

/* Other */
#define FILE_OF_CURRENT_PROJ(PROJ) ((PROJ)->proj_name)
#define FUNCT_NAME(FUNC) ((FUNC)->entry.template.symbol->ident)
#define FUNCT_SYMB(FUNC) ((FUNC)->entry.template.symbol)
#define FUNCT_FIRST_PAR(FUNC) ((FUNC)->entry.template.symbol->entry.func_decl.in_list)


extern int xmalloc();

#define MIN(X,Y) ((X) < (Y) ? (X) : (Y))
#define MAX(X,Y) ((X) > (Y) ? (X) : (Y))
#define CEIL(x,y) (((x) + (y) - 1) / (y))

/* extern pour Bif */

/* other type of low level node and decl */
#define CEIL_DIV_EXPR 1000
#define MAX_OP  1001
#define BIF_PARM_DECL 1002 
#define BIF_SAVE_EXPR 1003
#define MIN_OP 1004
#define BIF_ADDR_EXPR 1005
#define BIF_NOP_EXPR 1006
#define BIF_RTL_EXPR 1007
#define TRUNC_MOD_EXPR 1008
#define TRUNC_DIV_EXPR 1009
#define FLOOR_DIV_EXPR 1010
#define FLOOR_MOD_EXPR 1011
#define CEIL_MOD_EXPR 1012
#define ROUND_DIV_EXPR 1013
#define ROUND_MOD_EXPR 1014
#define RDIV_EXPR 1015
#define EXACT_DIV_EXPR 1016
#define COND_EXPR EXPR_IF 
#define CONVERT_EXPR 1017
#define MINUS_EXPR SUBT_OP
#define CONST_DECL 1018 /* to be modify */
#define ABS_EXPR 1019
#define BIT_NOT_EXPR BIT_COMPLEMENT_OP
#define NEGATE_EXPR MINUS_OP
#define TRUTH_ANDIF_EXPR 1020
#define TRUTH_AND_EXPR 1021
#define TRUTH_NOT_EXPR 1022
#define TRUTH_ORIF_EXPR 1023
#define POSTINCREMENT_EXPR PLUSPLUS_OP
#define PREINCREMENT_EXPR 1024
#define MINUS_EXPR SUBT_OP
#define PREDECREMENT_EXPR 1025
#define COMPOUND_EXPR 1026
#define ENUMERAL_TYPE T_ENUM
#define FLOAT_EXPR 1027
#define RSHIFT_EXPR RSHIFT_OP
#define LSHIFT_EXPR  LSHIFT_OP
#define BIT_IOR_EXPR 1028
#define BIT_XOR_EXPR 1029
#define BIT_ANDTC_EXPR 1030
#define ERROR_MARK NULL
#define TRUTH_OR_EXPR 1031
#define FIX_TRUNC_EXPR 1032
#define RROTATE_EXPR 1033
#define LROTATE_EXPR 1034
#define RANGE_EXPR 1035
#define POSTDECREMENT_EXPR 1036
#define COMPONENT_REF RECORD_REF /* NODE SYMB define for this node */
#define INDIRECT_REF DEREF_OP
#define REFERENCE_TYPE 1037
#define CONSTRUCTOR 1038
#define FIX_FLOOR_EXPR 1039
#define FIX_ROUND_EXPR 1040
#define FIX_CEIL_EXPR 1041
#define FUNCTION_DECL 1042
#define MODIFY_EXPR 1043
#define REFERENCE_EXPR  1044
#define RESULT_DECL 1045
#define PARM_DECL 1046 /* not used */
#define CALL_EXPR 1047
#define INIT_EXPR 1048


/* other type for type node */
#define T_LITERAL 1100 /* not use */
#define T_SIZE 1101
#define LAST_CODE T_SIZE
/* end other type of node */

/* definition for project */

#define PROJ_FIRST_SYMB(PROJ) (pointer_on_file_proj->head_symb)
#define PROJ_FIRST_TYPE(PROJ) (pointer_on_file_proj->head_type)
#define PROJ_FIRST_LLND(PROJ) (pointer_on_file_proj->head_llnd)
#define PROJ_FIRST_BIF(PROJ) (pointer_on_file_proj->head_bfnd)
#define PROJ_FIRST_CMNT(PROJ) (pointer_on_file_proj->head_cmnt)
#define PROJ_FIRST_LABEL(PROJ) (pointer_on_file_proj->head_lab)

#define CUR_FILE_NUM_BIFS(PROJ) (pointer_on_file_proj->num_bfnds)
#define CUR_FILE_NUM_LLNDS(PROJ) (pointer_on_file_proj->num_llnds)
#define CUR_FILE_NUM_SYMBS(PROJ) (pointer_on_file_proj->num_symbs)
#define CUR_FILE_NUM_TYPES(PROJ) (pointer_on_file_proj->num_types)
#define CUR_FILE_NUM_LABEL(PROJ) (pointer_on_file_proj->num_label)
#define CUR_FILE_NUM_BLOBS(PROJ) (pointer_on_file_proj->num_blobs)
#define CUR_FILE_CUR_BFND(PROJ) (pointer_on_file_proj->cur_bfnd)
#define CUR_FILE_CUR_LLND(PROJ) (pointer_on_file_proj->cur_llnd)
#define CUR_FILE_CUR_SYMB(PROJ) (pointer_on_file_proj->cur_symb)
#define CUR_FILE_CUR_TYPE(PROJ) (pointer_on_file_proj->cur_type)
#define CUR_FILE_GLOBAL_BFND(PROJ) (pointer_on_file_proj->global_bfnd)
#define CUR_FILE_NAME(PROJ) (pointer_on_file_proj->filename)
#define CUR_FILE_HEAD_FILE(PROJ) (pointer_on_file_proj->head_file)


#define FILE_GOBAL_BFND(PROJ) ((PROJ)->global_bfnd)
#define FILE_FILENAME(PROJ)  ((PROJ)->filename)
#define FILE_LANGUAGE(PROJ) ((PROJ)->lang)


#define CUR_PROJ_FILE_CHAIN(PROJ) (cur_proj->file_chain)
#define CUR_PROJ_NAME(PROJ) (cur_proj->proj_name)

#define PROJ_FILE_CHAIN(PROJ) ((PROJ)->file_chain)
                                
/* use as a general pointer */

typedef  char *POINTER;
enum typenode { BIFNODE, LLNODE, SYMBNODE, TYPENODE, BLOBNODE,
                  BLOB1NODE};


#define MAXTILE 10 /* nombre maximum de boucle que l'on peut tiler */
#define MAX_STMT 100 /* nombre d'instruction d'une boucle */


/**************** For Comment Nodes *****************************/


#define CMNT_ID(NODE)      ((NODE)->id)
#define CMNT_TYPE(NODE)    ((NODE)->type)
#define CMNT_STRING(NODE)  ((NODE)->string)
#define CMNT_NEXT(NODE)    ((NODE)->thread)
#define CMNT_NEXT_ATTACH(NODE)    ((NODE)->next)


/**************** For LABEL NODES *****************************/

#define LABEL_ID(NODE)             ((NODE)->id)
#define LABEL_NEXT(NODE)           ((NODE)->next)
#define LABEL_UD_CHAIN(NODE)       ((NODE)->ud_chain)
#define LABEL_USED(NODE)           ((NODE)->labused)
#define LABEL_ILLEGAL(NODE)        ((NODE)->labinacc)
#define LABEL_DEFINED(NODE)        ((NODE)->labdefined)
#define LABEL_SCOPE(NODE)          ((NODE)->scope)
#define LABEL_BODY(NODE)           ((NODE)->statbody)
#define LABEL_SYMB(NODE)           ((NODE)->label_name)
#define LABEL_TYPE(NODE)           ((NODE)->labtype)
#define LABEL_STMTNO(NODE)         ((NODE)->stateno)


/**************** Misceallous ***********************************/

#define LABEL_KIND   100000  /* bigger than the variant of all kind of node*/
#define BLOB_KIND    100001  

/************** For Sets Node ********************************/

#define SETS_GEN(NODE)       ((NODE)->gen)
#define SETS_INDEF(NODE)     ((NODE)->in_def)
#define SETS_USE(NODE)       ((NODE)->use)
#define SETS_INUSE(NODE)     ((NODE)->in_use)
#define SETS_OUTDEF(NODE)    ((NODE)->out_def)
#define SETS_OUTUSE(NODE)    ((NODE)->out_use)
#define SETS_ARRAYEF(NODE)   ((NODE)->arefl)

#define SETS_REFL_SYMB(NODE) ((NODE)->id)
#define SETS_REFL_NEXT(NODE) ((NODE)->next)
#define SETS_REFL_NODE(NODE) ((NODE)->node)
#define SETS_REFL_REF(NODE) ((NODE)->node->refer)
#define SETS_REFL_STMT(NODE) ((NODE)->node->stmt)




