
/* expand high_level.c of toolbox*/

#include <stdio.h>
#include <malloc.h>
#include "macro.h"
#include "tag" 
#include "exp.h"
#include "ext_low.h"
#include "ext_ann.h"
#include "ext_lib.h"
#include "ext_mid.h"
  
/*************************************************************************
*   FUNCTION: Split the factor of symb in expr.                          * 
*   INPUT   : The expression and the symb                                *
*   OUTPUT  : The factor of the symb and the remain                      *
*i************************************************************************/    


PTR_DIS spit(expr,symb)
PTR_LLND expr;
PTR_SYMB symb;
{
  PTR_DIS ll,temp1,temp2;

  if (!expr || !symb)
  {
     Message("the expr or symb is NULL",0);
     return NULL;
  }

  ll=(PTR_DIS)malloc(sizeof(PTR_DIS));
  temp1=(PTR_DIS)malloc(sizeof(PTR_DIS));
  temp2=(PTR_DIS)malloc(sizeof(PTR_DIS));
  switch(NODE_CODE(expr))
  {
    case INT_VAL:
         ll->remain=expr;
         ll->factor=bif_build(INT_VAL,T_INT,NULL,NULL);
         NODE_IV(ll->factor)=0;
         break;
    case VAR_REF:
         if(NODE_SYMB(expr)=symb)
         {
           ll->remain=bif_build(INT_VAL,T_INT,NULL,NULL);
           NODE_IV(ll->remain)=0;
           ll->factor=bif_build(INT_VAL,T_INT,NULL,NULL);
           NODE_IV(ll->factor)=1;
         }
         else
         {
           ll->remain=expr;
           ll->factor=bif_build(INT_VAL,T_INT,NULL,NULL);
           NODE_IV(ll->factor)=0;
         }
           break;
    case ADD_OP:
         ll->remain=(PTR_LLND)bif_make_node(ADD_OP);
         ll->factor=(PTR_LLND)bif_make_node(ADD_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         NODE_OPERAND1(ll->factor)=temp2->factor;
         break;

    case SUBT_OP:
         ll->remain=(PTR_LLND)bif_make_node(SUBT_OP);
         ll->factor=(PTR_LLND)bif_make_node(SUBT_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         NODE_OPERAND1(ll->factor)=temp2->factor;
         break;
    case MINUS_OP:
         ll->remain=(PTR_LLND)bif_make_node(MINUS_OP);
         ll->factor=(PTR_LLND)bif_make_node(MINUS_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         break;
    case MULT_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb)
              &&Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
           return NULL;
         ll->remain=(PTR_LLND)bif_make_node(MULT_OP);
         ll->factor=(PTR_LLND)bif_make_node(MULT_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb))
         {
           NODE_OPERAND0(ll->factor)=temp1->factor;
           NODE_OPERAND1(ll->factor)=temp2->remain;
         }
         if(Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         {
           NODE_OPERAND0(ll->factor)=temp2->factor;
           NODE_OPERAND1(ll->factor)=temp1->remain;
         }
         break;
    case DIV_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         return NULL;
         ll->remain=(PTR_LLND)bif_make_node(DIV_OP);
         ll->factor=(PTR_LLND)bif_make_node(DIV_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         NODE_OPERAND1(ll->factor)=temp2->remain;
         break;
    case EXP_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb)
              ||Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         return NULL;
         ll->remain=(PTR_LLND)bif_make_node(EXP_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         break;
    case MOD_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb)
              ||Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         return NULL;
         ll->remain=(PTR_LLND)bif_make_node(MOD_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         break; 
    default:
         return NULL;
  }
  return ll;
}

/**************************************************************
* FUNCTION: It can determine whether the loop1 and loop2 are  *
*             perfectly nested.                               *
* INPUT   : the loop1 and loop2;                              *
* OUTPUT  : if they are perfectly nested ,return TRUE.        *
*           otherwise return FALSE.                           *
* NOTE    : loop1 suround loop2.                              * 
***************************************************************/   
int Perfectly(loop1,loop2)
PTR_BFND loop1;
PTR_BFND loop2;
{
  if (loop1 && loop2 && BIF_CODE(loop1)==FOR_NODE && BIF_CODE(loop2)==
FOR_NODE && BIF_NEXT(loop1)==loop2 && blob_list_length(BIF_BLOB1(loop1
))==2)
    return TRUE;
  else
    return FALSE;
}


/***************************************************************
* INPUT  :the scope of BFND to be copied ,begin and end;       * 
* OUTPUT :the list of BFNDs copied;                            *
****************************************************************/
PTR_BFND Bif_Copy(begin,end)
PTR_BFND begin,end;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;

 if (! begin || ! end) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = Get_Last_Label_Id();

 lenght = 0;
 for (temp = begin; temp!=end ; temp = BIF_NEXT(temp))
   {
     lenght++;
     lastnode = temp;
   }
      lenght++;
     lastnode = temp;
 
 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 bzero(alloue, 2* lenght * sizeof(PTR_BFND));

 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 bzero(label_insection, 2* lenght * sizeof(PTR_LABEL));
 temp = begin;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) bif_make_node (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = bif_copy_expr (BIF_LL1 (temp));
      BIF_LL2 (copie) = bif_copy_expr (BIF_LL2 (temp));
      BIF_LL3 (copie) = bif_copy_expr (BIF_LL3 (temp));
      if (last)
        BIF_NEXT(last) = copie;

  
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
        {
          /* create a new label */

          maxlabelname++;
          LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
          LABEL_BODY(label_insection[2*i+1]) == copie;
          LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
          LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
          LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
          BIF_LABEL(copie) = label_insection[2*i+1];
          label_insection[2*i] = BIF_LABEL(temp);
        }

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = begin;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1];
     lab = NULL;

     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;

         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {
                 lab = NODE_LABEL(ptl);
                 trouve = 0;
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);
           }
         temp = BIF_NEXT(temp);
         continue;
       }

        
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
         lab = NODE_LABEL(BIF_LL3(temp));
         cas = 2;      
       }
     else
       {
         lab = BIF_LABEL_USE(temp);
         cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
         int trouve = 0;
         for (j = 0; j < lenght; j++)
           {
             if (label_insection[2*j])
               if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                 {
                   trouve = j+1;
                   break;
                 }
           }
         if(trouve)
           {
             if (cas == 1)
               {
                 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
               }

             if (cas == 2)
               {
                 if (BIF_LL3(copie))
                   {
                     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1
];
                   }
               }
           } else
             {
               if (cas == 1)
                 BIF_LABEL_USE(copie) = lab; /* outside */
               /* if ((cas == 2) no change */
             }
       }
     temp = BIF_NEXT(temp);
   }

 /* on met a jour le blob list */
 copie = alloue[1];
 for (temp = begin; temp<=end ; temp = BIF_NEXT(temp))
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp;
              blobtemp = BLOB_NEXT(blobtemp))
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp;
              blobtemp = BLOB_NEXT(blobtemp))
           {

             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];
 for (temp = begin; temp<=end ; temp = BIF_NEXT(temp))
   {
     if (In_Section(begin, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       }
     copie = BIF_NEXT(copie);
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}










 
