/* Copyright (C) 1992, Irisa, Indiana University, 
   subroutines of the Sigma toolbox */


/**************************************************************************
* * * Low level of Sigmacs toolbox for * * * * *
**************************************************************************/

#include <stdio.h>
#include <malloc.h>
#include "gvarargs.h"  /* for special arg passing */
#include "macro.h"
#include "ext_lib.h"

#define MAX_FILE 1000 /*max number of files in a project*/

char Current_File_name[256];

int debug =NO; /* used in db.c*/


PTR_FILE pointer_on_file_proj;
int show_deps = 0; /* for the analysis */
int number_of_bif_node = 0;
int number_of_ll_node = 0;
int number_of_symb_node  = 0;
int number_of_type_node = 0;
char  *default_filename;
int Warning_count = 0;
PTR_BFND Redo_Bif_Next_Chain();

PTR_LABEL Get_Last_Label();
PTR_BFND Get_Node_Before ();
char *filter();
PTR_BFND Get_Last_Node_List();
int *Evaluate_Expression();

extern char* Tool_Unparse_Bif ();

int CountNullBifNext = 0; /* for internal debugging */

/* data structure for record of type and decl (id -> decl_info) */

/* Indexed by enum tree_code, contains a character which is
   `e' for an expression, `r' for a reference, `c' for a constant,
   `d' for a decl, `t' for a type, `s' for a statement,
   and `x' for anything else (TREE_LIST, IDENTIFIER, etc).  */

char node_code_type[LAST_CODE];

/* Number of argument-words in each kind of tree-node.  */

int node_code_length[LAST_CODE];

enum typenode node_code_kind[LAST_CODE];

void init_table_info();


struct  bif_stack_level *stack_level = NULL;
struct  bif_stack_level *current_level = NULL;

PTR_BFND  get_function_header();

/*****************************************************************************
 *                                                                           *
 *                   Procedure of general use                                *
 *                                                                           *
 *****************************************************************************/

int
  xmalloc (size)
int size;
{
  register int val = (int) malloc (size);

  if (val == 0)
    Message ("virtual memory exhausted",0);
  return val;
}


int
Message(s, l)
char *s;
int l;
{
  if (l != 0)
    fprintf(stderr,"Warning : %s line %d\n",s, l);
  else
    fprintf(stderr,"Warning : %s\n",s);
 Warning_count++;
}



/************************CONSTRUCTION DES NOEUDS******************************/

POINTER
bif_make_node (code)
     int code;
{
  register PTR_BFND tb;
  register PTR_LLND tl;
  register PTR_TYPE tt;
  register PTR_SYMB ts;
  register PTR_LABEL tlab;
  register PTR_BLOB tbl;
  register int length;
  register int kind;
  
  if (code == LABEL_KIND)
    { /* lets create a label */
      PTR_LABEL last;
      
      length = sizeof (struct Label); 
      tlab = (PTR_LABEL) xmalloc(length);
      bzero(tlab, length);
      last = Get_Last_Label();
      LABEL_ID(tlab) = ++CUR_FILE_NUM_LABEL();
      LABEL_NEXT(last) = tlab;
      return (POINTER) tlab;
    }

  if (code == BLOB_KIND)
    { 
      length = sizeof (struct blob);
      tbl = (PTR_BLOB) xmalloc (length);
      bzero (tbl, length);
      CUR_FILE_NUM_BLOBS()++; 
      return (POINTER) tbl;
    }
  

  kind = (int) node_code_kind[(int) code];
  switch (kind)
    {
    case BIFNODE:
      length = sizeof (struct bfnd);      
      break;
    case LLNODE :
     length = sizeof (struct llnd);  
      break;
    case SYMBNODE:
     length = sizeof (struct symb);  
      break;
    case TYPENODE:
     length = sizeof (struct data_type);   
      break;
    default:
      Message("Node inconnu",0);
    }

  switch (kind)
    {
    case BIFNODE:
      tb = (PTR_BFND) xmalloc(length);
      bzero(tb, length);
      BIF_ID (tb)  = ++CUR_FILE_NUM_BIFS ();
      number_of_bif_node++;
      /*BIF_ID (tb) = number_of_bif_node++;*/
      BIF_CODE(tb) = code;
      BIF_FILE_NAME(tb) = CUR_FILE_HEAD_FILE();/* recently added, to check */
      CUR_FILE_CUR_BFND() = tb;
      BIF_LINE(tb) = 0; /* set to know that this is a new node */ 
      break;
    case LLNODE :
      tl = (PTR_LLND) xmalloc(length);
      bzero(tl, length);
      NODE_ID (tl) = ++CUR_FILE_NUM_LLNDS();
      NODE_NEXT (tl) = LLNULL;
      number_of_ll_node++;
      if (CUR_FILE_NUM_LLNDS() == 1)
	PROJ_FIRST_LLND () = tl;
      else
	NODE_NEXT (CUR_FILE_CUR_LLND()) = tl;
      CUR_FILE_CUR_LLND() = tl;
      NODE_CODE(tl) = code;
      break;
    case SYMBNODE:
      ts = (PTR_SYMB)  xmalloc(length); 
      bzero(ts, length);
      number_of_symb_node++;
      SYMB_ID (ts) = ++CUR_FILE_NUM_SYMBS();
      SYMB_CODE(ts) = code;
      if (CUR_FILE_NUM_SYMBS() == 1)
	PROJ_FIRST_SYMB () =  ts;
      else
	SYMB_NEXT (CUR_FILE_CUR_SYMB()) = ts;
      CUR_FILE_CUR_SYMB() = ts;
      SYMB_NEXT (ts) = NULL;
      SYMB_SCOPE (ts) = PROJ_FIRST_BIF ();/* the default value */
      break;
    case TYPENODE:
      /*tt = (PTR_TYPE) alloc_type ( cur_file ); xmalloc(length);
      number_of_type_node++;
      TYPE_ID (tt) = number_of_type_node++;
      TYPE_NEXT (tt) = NULL;*/
      
      tt = (PTR_TYPE) xmalloc (length);
      bzero (tt, length);
      number_of_type_node++;
      TYPE_ID (tt) = ++CUR_FILE_NUM_TYPES();
      TYPE_CODE (tt) = code;
      TYPE_NEXT (tt) = NULL;
      if (CUR_FILE_NUM_TYPES () == 1)
        PROJ_FIRST_TYPE() = tt;
      else 
        TYPE_NEXT (CUR_FILE_CUR_TYPE()) = tt;
      CUR_FILE_CUR_TYPE() = tt;
      break;
    default:
      Message("Node inconnu",0);
    }


  switch (kind)
    {
    case BIFNODE:
      return (POINTER) tb; 
    case LLNODE :
      return (POINTER) tl;
    case SYMBNODE:
      return (POINTER) ts; 
    case TYPENODE:
      return (POINTER) tt;
    default:
      Message("Node inconnu",0);
    }

}

/**********************FIN DE CONSTRUCTION DES NOEUDS*************************/


/************************CONSTRUCTION DES LOW LEVEL NODES*********************/

PTR_LLND
bif_copy_llnode (node)
     PTR_LLND node;
{
  register PTR_LLND t;
  register int code;

  if (!node)
    return NULL;
  

    code = NODE_CODE (node);
  if (node_code_kind[(int) code] != LLNODE)
    Message("bif_copy_node != low_level_node",0);

  t = (PTR_LLND) bif_make_node (code);
  NODE_SYMB(t)  = NODE_SYMB(node);
  NODE_TYPE(t) = NODE_TYPE(node);
  NODE_OPERAND0(t) = NODE_OPERAND0(node);
  NODE_OPERAND1(t) = NODE_OPERAND1(node);
  return t;
}


PTR_LLND
bif_copy_expr (node)
     PTR_LLND node;
{
  register PTR_LLND t;
  register int code;
  
  if (!node)
    return NULL;

  code = NODE_CODE (node);
  if (node_code_kind[(int) code] != LLNODE)
    Message("bif_copy_node != low_level_node",0);

  t = (PTR_LLND) bif_make_node (code);
  NODE_SYMB(t)  = NODE_SYMB(node);
  NODE_TYPE(t) = NODE_TYPE(node);
  NODE_OPERAND0(t) = bif_copy_expr(NODE_OPERAND0(node));
  NODE_OPERAND1(t) = bif_copy_expr(NODE_OPERAND1(node));
  return t;
}



PTR_LLND
bif_build_int (low)
     int low;
{
  register PTR_LLND t =  (PTR_LLND) bif_make_node(INT_VAL);
  NODE_TYPE(t) = NULL;
  NODE_INT_CST_LOW (t) = low;
  return t;
}

PTR_LLND
bif_build (va_alist)
     va_dcl
{

  register va_list p;
  int code;
  register PTR_LLND t;
  register int length;

  va_start (p);

  code = va_arg (p, int);
  t = (PTR_LLND) bif_make_node (code);
  length = node_code_length[code];
  NODE_TYPE(t) = va_arg (p, PTR_TYPE);

  if (code == VAR_REF)
    {
      register PTR_SYMB arg0 = va_arg (p, PTR_SYMB);
      NODE_SYMB (t) = arg0;
      va_end (p);
      return t;
    } else
      {
	if (length != 0)
	  {
	    if (length == 2)
	      {
		/* This is equivalent to the loop below, but faster.  */
		register PTR_LLND arg0 = va_arg (p, PTR_LLND);
		register PTR_LLND arg1 = va_arg (p, PTR_LLND);
		NODE_OPERAND0 (t) = arg0;
		NODE_OPERAND1 (t) = arg1;
		va_end (p);
		return t;
	      }
	  else 
	    if (length == 1)
	      {
		/* This is equivalent to the loop below, but faster.  */
		register PTR_LLND arg0 = va_arg (p, PTR_LLND);
	      
		NODE_OPERAND0 (t) = arg0;
		va_end (p);
		return t;
	      } else
		Message("A low level node have more than two operands",0);
	  }
      }	
  va_end (p);
  return t;
}


/*********************FIN DE CONSTRUCTIONS DES LOW LEVEL NODES****************/

/************************CONSTRUCTION DES NOEUDS SYMB*************************/

PTR_SYMB
bif_build_decl (code, name, type)
     int code;
     char *name;
     PTR_TYPE type;
{
  register PTR_SYMB t;
  char *str;
  
  
  str = (char *) xmalloc(strlen(name) +1);
  strcpy(str,name);
 
  t = (PTR_SYMB) bif_make_node (code);
  SYMB_IDENT (t) = str;
  SYMB_TYPE (t) = type;
  return t;
}


/**********************FIN DE CONSTRUCTION DES NOEUDS SYMBS*******************/


/* Check the langage */

int Check_Lang_C(proj)
PTR_PROJ proj;
{
  PTR_FILE ptf;
  PTR_BLOB ptb;
  
  for (ptb = PROJ_FILE_CHAIN (proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);

/*      if (debug)
	fprintf(stderr,"%s\n",FILE_FILENAME (ptf)); */

      if (FILE_LANGUAGE (ptf) != CSrc)
	return(FALSE);
    }
  return(TRUE);
}


int Check_Lang_Fortran(proj)
PTR_PROJ proj;
{
  PTR_FILE ptf;
  PTR_BLOB ptb;
  
  for (ptb = PROJ_FILE_CHAIN (proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);
    /*  if (debug)
	fprintf(stderr,"%s\n",FILE_FILENAME (ptf)); */

      if (FILE_LANGUAGE(ptf) != ForSrc)
	return(FALSE);
    }
  return(TRUE);
}




/* Procedure for unparse a program use when debug is required 
   the current project is taking */

void UnparseProgram(fout)
     FILE *fout;
{
  char *s;
  PTR_BLOB b, bl;
  PTR_FILE f;

  if (Check_Lang_Fortran(cur_proj))
    {  
      Init_Unparser();
      fprintf(fout,"%s",filter(Tool_Unparse_Bif(PROJ_FIRST_BIF ())));
    } else
      for (b = CUR_PROJ_FILE_CHAIN(); b; b = BLOB_NEXT (b)) {
        f = (PTR_FILE) BLOB_VALUE (b);
        if (f) {
          for (bl = BIF_BLOB1 (FILE_GOBAL_BFND (f)); bl; bl = BLOB_NEXT (bl))
            {
              if (Check_Lang_Fortran(cur_proj))
                {      /* old unparser */        
                  s = funparse_blck(BLOB_VALUE(bl));
                  fprintf(fout,"%s\n", filter(s));
                  myfree();              
                }
              else
                {              
                  s = cunparse_blck(BLOB_VALUE(bl));
                  fprintf(fout,"%s\n",s);
                }
            }
        }
      }

}



void UnparsePROC()
{
  char *s;
  PTR_BLOB b, bl;
  PTR_FILE f;

  for (b = CUR_PROJ_FILE_CHAIN(); b; b = BLOB_NEXT (b)) {
    f = (PTR_FILE) BLOB_VALUE (b);
    if (f) {
      for (bl = BIF_BLOB1 (FILE_GOBAL_BFND (f)); bl; bl = BLOB_NEXT (bl))
        if (FILE_LANGUAGE (f) == ForSrc ||
            FILE_LANGUAGE (f) == CSrc && 
            BIF_CODE (BLOB_VALUE (bl)) == FUNC_HEDR)
          {
            if (Check_Lang_Fortran(cur_proj))
              {
                s = funparse_blck(BLOB_VALUE(bl));
                 fprintf(stdout,"%s\n", filter(s));
                 myfree();
              }
            else
              {                
                s = cunparse_blck(BLOB_VALUE(bl));
                fprintf(stdout,"%s\n", s);
              }
          }
    }
  }

}


int
open_proj_toolbox(proj_name, proj_file)
char * proj_name;
char * proj_file;
{
        char *mem[MAX_FILE];          /* for file in the project */
        int   no = 0;           /* number of file in the project */
        int   c;
        FILE *fd;               /* file descriptor for project */
        char **p, *t;
        char *tmp, tmpa[2000];

        tmp = &(tmpa[0]);

        if ((fd = fopen(proj_file, "r")) == NULL)
                return -1;

        p = mem;
        t = tmp;
        while((c = getc(fd)) != EOF){
            if(c != ' ')        /* assum no blanks in filename */
                if(c == '\n') {
                    if (t != tmp) {
                        /* not a blank line */
                        *t = '\0';
                        *p = malloc((unsigned) (strlen(tmp) + 1));
                        strcpy(*p++, tmp);
                        t = tmp;
                      }
                } else  *t++ = c;
        }

        fclose(fd);
        no = p - mem;
        if (no > 0)
            /* Now make it the active project */
            if ((cur_proj = OpenProj(proj_name, no, mem))) {
                cur_file = (PTR_FILE) BLOB_VALUE (CUR_PROJ_FILE_CHAIN());
                pointer_on_file_proj = cur_file;
                return 0;
            } else{
                fprintf(stderr,"-2 Cannot open project\n");
                return -2;
                }
        else{
            fprintf(stderr,"-3 No files in the project\n");
            return -3;

            }
}

static int ToolBOX_INIT = 0;

Reset_Tool_Box()
{
  Init_Tool_Box();
}

Init_Tool_Box()
{

  PTR_BLOB ptb;

  pointer_on_file_proj = cur_file;
  number_of_type_node = CUR_FILE_NUM_TYPES() + 1;
  number_of_ll_node = CUR_FILE_NUM_LLNDS() + 1 ;
  number_of_bif_node = CUR_FILE_NUM_BIFS() + 1;
  number_of_symb_node = CUR_FILE_NUM_SYMBS() + 1;

  strcpy(Current_File_name,CUR_FILE_NAME());
  if (ToolBOX_INIT)
    return 0;

  ToolBOX_INIT = 1;

  make_a_malloc_stack();

/* initialisation des noeuds */
#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) node_code_type[SYM] = TYPE;
#include"bif_node.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) node_code_length[SYM] =LENGTH;
#include"bif_node.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) node_code_kind[SYM] = NT;
#include"bif_node.def"
#undef DEFNODECODE

  
  for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      pointer_on_file_proj = (PTR_FILE) BLOB_VALUE (ptb);
      Redo_Bif_Next_Chain(PROJ_FIRST_BIF ());
    }

  pointer_on_file_proj = cur_file;
  number_of_type_node = CUR_FILE_NUM_TYPES() + 1;
  number_of_ll_node = CUR_FILE_NUM_LLNDS() + 1 ;
  number_of_bif_node = CUR_FILE_NUM_BIFS() + 1;
  number_of_symb_node = CUR_FILE_NUM_SYMBS() + 1;
  
  return 1;
  
}



Initialize_Project_Toolbox(name)
char *name;
{

  PTR_BLOB ptb;

  /* Create the project ... take in input the file.proj*/

  if( open_proj_toolbox(name,name) < 0){
          fprintf(stderr,"opening project: %s\n",name);
          fprintf(stderr,"*** could not open project ***\n");
          exit(0);
        }

  /*debug = YES;*/
  /* cur_proj is the current project */
  /*if (debug)
    fprintf(stderr,"Files %s\n",CUR_PROJ_NAME());*/

  /* We check the language */
  if (Check_Lang_Fortran(cur_proj) == FALSE)
    {
      Message("This is not  Fortran\n",0);
    }

  strcpy(Current_File_name,CUR_FILE_NAME());


  number_of_type_node = CUR_FILE_NUM_TYPES() + 1;
  number_of_ll_node = CUR_FILE_NUM_LLNDS() + 1 ;
  number_of_bif_node = CUR_FILE_NUM_BIFS() + 1;
  number_of_symb_node = CUR_FILE_NUM_SYMBS() + 1;


  if (ToolBOX_INIT)
    return 0;
  ToolBOX_INIT = 1;

  make_a_malloc_stack();

/* initialisation des noeuds */
#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) node_code_type[SYM] = TYPE;
#include"bif_node.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) node_code_length[SYM] =LENGTH;
#include"bif_node.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) node_code_kind[SYM] = NT;
#include"bif_node.def"
#undef DEFNODECODE

  /* update the BIF_NEXT */

  for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      pointer_on_file_proj = (PTR_FILE) BLOB_VALUE (ptb);
      Reset_Bif_Next_Chain(PROJ_FIRST_BIF ());
/*      CountNullBifNext = 0;
      Count_Bif_Next_Chain(PROJ_FIRST_BIF ())
      printf("1-Nombre de bif_next a NULL %d\n", CountNullBifNext); */
      Redo_Bif_Next_Chain(PROJ_FIRST_BIF ());
      CountNullBifNext = 0;
      Count_Bif_Next_Chain(PROJ_FIRST_BIF ());
      if (CountNullBifNext != 1)
        {
          Message("Pb with redo Bif Next Chain",0);
          printf("2-Nombre de bif_next a NULL %d\n", CountNullBifNext);
        }
    }

  pointer_on_file_proj = cur_file;
  number_of_type_node = CUR_FILE_NUM_TYPES() + 1;
  number_of_ll_node = CUR_FILE_NUM_LLNDS() + 1 ;
  number_of_bif_node = CUR_FILE_NUM_BIFS() + 1;
  number_of_symb_node = CUR_FILE_NUM_SYMBS() + 1;
  
}



/* call the routine in the sigmacs library to do the global analysis 
   necessaire seulement si interprocedural, sinon cfp calcul les
   (sauf si -nodep donne)
   dependences
 */

do_glob_analysis_toolbox()
{
    PTR_BFND p;
    if(cur_proj && cur_file) {
	GlobalAnal(cur_proj);
	p = CUR_FILE_GLOBAL_BFND();
	reset_scalar_propogation(p);
	(void) build_sets(1, p, (PTR_REFL)NULL, (PTR_REFL)NULL, (PTR_REFL)NULL, (PTR_REFL)NULL, 1);
	(void) build_sets(1, p, (PTR_REFL)NULL, (PTR_REFL)NULL, (PTR_REFL)NULL, (PTR_REFL)NULL, 2);
	gendeps(p); 
	relink(cur_file);
	return 0;
    } else
	return 1;
}


/* For debug  */


void Write_Data_Base_For_Debug()
{
  PTR_BFND thebif;
  int i;

  thebif = PROJ_FIRST_BIF(cur_proj);
  i = 1;
  for (;thebif;thebif=BIF_NEXT(thebif), i++) 
       BIF_ID(thebif) = i;     
   
  CUR_FILE_NUM_BIFS() = i-1;

  write_nodes(cur_file,"debug.dep");

}


/**************************************************************************/
/*           TO update line number                                        */

/* filtre les lignes de plus de 72 caractere en affichant 
   printf("%s",temp); to be modified with sprintf */

char *
filter_old(s)
char *s;
{
  char c, c_last;
  int i = 1;
  int j;
  int last_sep = 0;
  char temp[1024];
  int temp_i = 0;
  int commentline = 0;
  char *resul, *init;
  
  /* allocate very simple, but to redo later, allocate two times the size */
  make_a_malloc_stack();
  resul = (char *) mymalloc(2*strlen(s));
  bzero(resul,2*strlen(s));
  init = resul;
  
  
  /* find the separator */
  c = s[0];
  c_last = c;
  if ((c != ' ')
      &&(c != '\n')
      && (c != '0')
      && (c != '1') 
      && (c != '2') 
      && (c != '3') 
      && (c != '4') 
      && (c != '5') 
      && (c != '6') 
      && (c != '7') 
      && (c != '8') 
      && (c != '9'))
    commentline = 1;
  else
    commentline = 0;

  while (c!='\0')
    {
      if ((c==' ')|| (c=='+') || (c=='*') || (c=='=') || (c=='(') || (c==')')
          || (c=='-') || (c=='=') || (c==','))
        last_sep = temp_i;

      temp[temp_i] = c;
      if (c == '\n')
        {
          temp[temp_i +1 ] = '\0';
          sprintf(resul,"%s",temp);
          resul = resul + strlen(temp);
          temp_i = -1;
          last_sep = 0;
        }

      if (c_last ==  '\n')
        {
          
          if ((c != ' ')
              &&(c != '\n')
              && (c != '0')
              && (c != '1') 
              && (c != '2') 
              && (c != '3') 
              && (c != '4') 
              && (c != '5') 
              && (c != '6') 
              && (c != '7') 
              && (c != '8') 
              && (c != '9'))
            commentline = 1;
          else
            commentline = 0;
        }

      if ((temp_i == 60) && !commentline)
        { char save;
         /* insert where necessary */
          if (last_sep != 0)
            {
              save = temp[last_sep];
              temp[last_sep]  = '\0';
              sprintf(resul,"%s\n",temp);
              resul = resul + strlen(temp) +1;
              sprintf(resul,"     +");
              resul = resul + strlen("     +");
              commentline = 0;
              temp[last_sep] = save;
              /* initialize temp */
              for (j = last_sep; j <= temp_i; j++)
                {
                  temp [j - last_sep] = temp[j];
                }
              temp_i = temp_i - last_sep;
              last_sep = 0;
            } else
              Message(" ERREUR FILTER\n", 0);
        }
      
      c_last = c;
      c =s[i];
      i++;
      temp_i++;      
    }

  return init;  
}


/* cut at 72 can cut everywhere...*/
char *
filter(s)
char *s;
{
  char c;
  int i = 1;
  char temp[1024];
  int temp_i = 0;
  int buf_i = 0;
  int commentline = 0;
  char *resul, *init;
  
  /* allocate very simple, but to redo later, allocate two times the size */
  make_a_malloc_stack();
  resul = (char *) mymalloc(2*strlen(s));
  bzero(resul,2*strlen(s));
  init = resul;
  
  
  /* find the separator */
  c = s[0];

  if ((c != ' ')
      &&(c != '\n')
      && (c != '0')
      && (c != '1') 
      && (c != '2') 
      && (c != '3') 
      && (c != '4') 
      && (c != '5') 
      && (c != '6') 
      && (c != '7') 
      && (c != '8') 
      && (c != '9'))
    commentline = 1;
  else
    commentline = 0;

  temp_i = 0;
  i = 0;
  buf_i =0;
  while (c!='\0')
    {
      c = s[i];
      temp[ buf_i] = c;
      if (c == '\n')
        {
          temp[ buf_i+1] = '\0';
          sprintf(resul,"%s",temp);
          resul = resul + strlen(temp);
          temp_i = -1;
          buf_i = -1;
          if ((s[i+1] != ' ')
              &&(s[i+1] != '\n')
              && (s[i+1] != '0')
              && (s[i+1] != '1') 
              && (s[i+1] != '2') 
              && (s[i+1] != '3') 
              && (s[i+1] != '4') 
              && (s[i+1] != '5') 
              && (s[i+1] != '6') 
              && (s[i+1] != '7') 
              && (s[i+1] != '8') 
              && (s[i+1] != '9'))
            commentline = 1;
          else
            commentline = 0;
        } else
          {
            if ((temp_i == 71) && !commentline)
              { 
                /* insert where necessary */
                temp[ buf_i+1]  = '\0';
                sprintf(resul,"%s\n",temp);
                resul = resul + strlen(temp)+1;
                sprintf(resul,"     +");
                resul = resul + strlen("     +");
                commentline = 0;
                bzero(temp,1024);
                temp_i = strlen("     +")-1;
                buf_i = -1;
              }
          }
      i++;
      temp_i++;
      buf_i++;
    }

  return init;  
}


int
Size_in_Line(s)
     char *s;
{
  int line = 0;
  char *pt = s;
  while (pt)
    {
      if (*pt == '\0')
        break;
      if (*pt == '\n')
        line++;
      pt++;
    }
  return line;
}


/* partant du numero de ligne start, renumerote les bif nodes 
 Procedure recursive On commence par tout les noeud dans la section
 puis on compte le nombre de ligne*/

int 
Renumbered_Code_Section(bifstart, startline)
     PTR_BFND bifstart;
     int startline;
{
  
  PTR_BFND  previous;
  int j, k ,cpt;
  PTR_BLOB temp;
  char *string;
  

 if (!bifstart)
    return 0;
  
  previous = bifstart;
  cpt = startline;
  BIF_LINE(bifstart) = startline;
  if (BIF_BLOB1(bifstart))
    {
      
      for (temp = BIF_BLOB1(bifstart); temp ; temp = BLOB_NEXT(temp))
        {
          previous = BLOB_VALUE(temp);
          BIF_LINE(previous) = cpt;
          string = funparse_bfnd(previous);
          j = Size_in_Line(string);
          if (BIF_CODE (previous) == CONTROL_END) 
            j = 1;
          cpt = cpt +j;
          k = Renumbered_Code_Section(BLOB_VALUE(temp), cpt);
          cpt = cpt+k;
          free(string);
        }

      for (temp = BIF_BLOB2(bifstart); temp ; temp = BLOB_NEXT(temp))
        {
          previous = BLOB_VALUE(temp);
          BIF_LINE(previous) = cpt;
          string = funparse_bfnd(previous);
          j = Size_in_Line(string);
          if (BIF_CODE (previous) == CONTROL_END) 
            j = 1;
          cpt = cpt +j;
          k = Renumbered_Code_Section(BLOB_VALUE(temp), cpt);
          cpt = cpt+k;
          free(string);
        }
      string = funparse_blck(bifstart);
      j = Size_in_Line(string);
      free(string);
      string = funparse_bfnd(bifstart);
      k = Size_in_Line(string);
      free(string);
      return j - k; /* j nb lines including bifstart, on ne le veut pas*/
    }
  else
    return cpt - startline;
}


int 
Renumbered_Follow(bifstart,line)
     PTR_BFND bifstart;
     int line;
{
  PTR_BFND temp;
  int diff;
  
  if (!bifstart)
    return;
  
  /* on renumerote tous les noeuds qui suivent */

  diff =  line - BIF_LINE(bifstart);
  
  for (temp = BIF_NEXT(bifstart);  temp;  temp = BIF_NEXT(temp))
    {
      BIF_LINE(temp) = BIF_LINE(temp) + diff;      
    }
}

/**************************END OF LINE UPDATE********************************/


/*************************GESTION DES LISTES BLOB*****************************/


int
  Find_Bif_In_Blob_Liste1 (bif_source, bif_cherche)
PTR_BFND bif_source, bif_cherche;
{
  PTR_BLOB temp;
  
  if ((bif_cherche == NULL) || (bif_source == NULL)) 
    return FALSE;
  
  for (temp = BIF_BLOB1 (bif_source); temp ; temp = BLOB_NEXT (temp))
    if (BLOB_VALUE (temp) == bif_cherche)
      return TRUE;
  return FALSE;
}

int
  Find_Bif_In_Blob_Liste2 (bif_source, bif_cherche)
PTR_BFND bif_source, bif_cherche;
{
  PTR_BLOB temp;
  
  if ((bif_cherche == NULL) || (bif_source == NULL)) 
    return FALSE;

  for (temp = BIF_BLOB2 (bif_source); temp ; temp = BLOB_NEXT (temp))
    if (BLOB_VALUE (temp) == bif_cherche)
      return TRUE;
  return FALSE;
}




PTR_BLOB
  append_blob(b1, b2)
PTR_BLOB b1, b2;
{
    if (b1) {
        register PTR_BLOB p, q;

        for (p = b1; p; p = BLOB_NEXT (p)) /* skip to the end of b1 */
            q = p;
        BLOB_NEXT (q) = b2;
    } else
        b1 = b2;
    return b1;
}

/* 
 *delete a bif node from the list of blob node
 */
PTR_BFND
delete_bfnd_from_blob_ud_label (bf,label)
     PTR_BFND bf;
     PTR_LABEL label;
{
    PTR_BLOB first;
    PTR_BLOB bl1, bl2;

    if (label) {
      first = LABEL_UD_CHAIN(label);     
      if (first && (BLOB_VALUE (first) == bf))
	{
	  bl2 = first;
	  LABEL_UD_CHAIN(label) = BLOB_NEXT (first);
	  return (BLOB_VALUE (bl2));
	}

      for (bl1 = bl2 = first; bl1; bl1 = BLOB_NEXT (bl1)) {
	if (BLOB_VALUE (bl1) == bf) {
	  BLOB_NEXT (bl2) = BLOB_NEXT (bl1);
	  return (BLOB_VALUE (bl2));
	}
	bl2 = bl1;
      }
      return NULL;
    }
    return NULL;
}


/* 
 *delete a bif node from the list of blob node
 */
PTR_BFND
delete_bfnd_from_blob (bf)
    PTR_BFND bf;
{
    PTR_BFND cp;
    PTR_BLOB bl1, bl2;

    if (bf) {
      cp = BIF_CP (bf);
      /* search the first branch */
      if (BIF_BLOB1 (cp) && (BLOB_VALUE (BIF_BLOB1 (cp)) == bf))
	{
	  bl2 = BIF_BLOB1 (cp);
	  BIF_BLOB1 (cp) = BLOB_NEXT (BIF_BLOB1 (cp));
	  return (BLOB_VALUE (bl2));
	}

      for (bl1 = bl2 = BIF_BLOB1 (cp); bl1; bl1 = BLOB_NEXT (bl1)) {
	if (BLOB_VALUE (bl1) == bf) {
	  BLOB_NEXT (bl2) = BLOB_NEXT (bl1);
	  return (BLOB_VALUE (bl2));
	}
	bl2 = bl1;
      }
      return NULL;
    }
    return NULL;
}


int
blob_list_length(first)
PTR_BLOB first;
{
  PTR_BLOB tail;
  int len = 0;
  if (first == NULL)
    return(0);
  for (tail = first; tail; tail = BLOB_NEXT(tail) )
    len++;
return(len);
}


/* 
 *
 * append dans la blob liste d'un noeud bif, un noeud bif
 *
 */

Append_In_Blob_Liste1(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl1;

  if (BIF_BLOB1(noeud) == NULL)
    {
      BIF_BLOB1(noeud) = (PTR_BLOB) bif_make_node (BLOB_KIND);
      BLOB_VALUE(BIF_BLOB1(noeud)) = biftoinsert; 
      BLOB_NEXT(BIF_BLOB1(noeud)) = NULL;
    } else
      {
        /* on va cherche le dernier dans la liste */
        for (bl1 = BIF_BLOB1(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_NEXT(bl1) == NULL)
              break;
          }
        BLOB_NEXT(bl1) = (PTR_BLOB) bif_make_node (BLOB_KIND);
        BLOB_VALUE(BLOB_NEXT(bl1)) = biftoinsert; 
        BLOB_NEXT(BLOB_NEXT(bl1)) = NULL;
      }
  
  return 1;
}


Append_In_Blob_Liste2(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl1;

  if (BIF_BLOB2(noeud) == NULL)
    {
      BIF_BLOB2(noeud) = (PTR_BLOB) bif_make_node (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert;      
      BLOB_NEXT (BIF_BLOB2(noeud)) = NULL;
    } else
      {
        /* on va cherche le dernier dans la liste */
        for (bl1 = BIF_BLOB2(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_NEXT(bl1) == NULL)
              break;
          }
        BLOB_NEXT(bl1) = (PTR_BLOB) bif_make_node (BLOB_KIND);
        BLOB_VALUE(BLOB_NEXT(bl1)) = biftoinsert;
        BLOB_NEXT(BLOB_NEXT(bl1)) = NULL;
      }
  
  return 1;
}


First_In_Blob_Liste1(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl2;

  if (BIF_BLOB1(noeud) == NULL)
    {
      BIF_BLOB1(noeud) = (PTR_BLOB) bif_make_node (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB1(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB1(noeud)) = NULL;
    } else
      {
        bl2 = BIF_BLOB1(noeud);
        BIF_BLOB1(noeud) = (PTR_BLOB) bif_make_node (BLOB_KIND);
        BLOB_VALUE (BIF_BLOB1(noeud)) = biftoinsert;
        BLOB_NEXT (BIF_BLOB1(noeud)) =  bl2 ;
      }
  return 1;
}



First_In_Blob_Liste2(biftoinsert, noeud)
     PTR_BFND biftoinsert, noeud;
{
  PTR_BLOB bl2;

  if (BIF_BLOB2(noeud) == NULL)
    {
      BIF_BLOB2(noeud) = (PTR_BLOB) bif_make_node (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB2(noeud)) = NULL;
    } else
      {
        bl2 = BIF_BLOB2(noeud);
        BIF_BLOB2(noeud) = (PTR_BLOB) bif_make_node (BLOB_KIND);
        BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert; 
        BLOB_NEXT (BIF_BLOB2(noeud)) =  bl2 ;
      }
  return 1;
}



Insert_In_Blob_Liste1(biftoinsert, current, noeud)
     PTR_BFND biftoinsert, noeud,current;
{
  PTR_BLOB bl1 = NULL, bl2;

  if (BIF_BLOB1(noeud) == NULL)
    {
      BIF_BLOB1(noeud) = (PTR_BLOB) bif_make_node (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB1(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB1(noeud)) = NULL;
    } else
      {
       /* on va cherche current  dans la liste */
        for (bl1 = BIF_BLOB1(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_VALUE(bl1) == current)
              break;
          }

        if (!bl1)
          {
            Message("Probleme dans Insert_In_Blob_Liste1",0);
	    return FALSE;
          }

        bl2 = BLOB_NEXT(bl1);
        BLOB_NEXT(bl1) = (PTR_BLOB) bif_make_node (BLOB_KIND);
        BLOB_VALUE (BLOB_NEXT(bl1)) = biftoinsert;
        BLOB_NEXT (BLOB_NEXT(bl1)) =  bl2; 

      }
  return TRUE;
}

Insert_In_Blob_Liste2(biftoinsert, current, noeud)
     PTR_BFND biftoinsert, noeud,current;
{
  PTR_BLOB bl1 = NULL, bl2;

  if (BIF_BLOB2(noeud) == NULL)
    {
      BIF_BLOB2(noeud) = (PTR_BLOB)  bif_make_node (BLOB_KIND);
      BLOB_VALUE (BIF_BLOB2(noeud)) = biftoinsert;
      BLOB_NEXT (BIF_BLOB2(noeud)) = NULL;
    } else
      {
       /* on va cherche current  dans la liste */
        for (bl1 = BIF_BLOB2(noeud); bl1; bl1 = BLOB_NEXT(bl1)) 
          {
            if (BLOB_VALUE(bl1) == current)
              break;
          }

        if (!bl1)
          {
            Message("Probleme dans Insert_In_Blob_Liste2",0);
            abort();
          }

        bl2 = BLOB_NEXT(bl1);
        BLOB_NEXT(bl1) = (PTR_BLOB)  bif_make_node (BLOB_KIND);
        BLOB_VALUE (BLOB_NEXT(bl1)) = biftoinsert;
        BLOB_NEXT(BLOB_NEXT(bl1)) =   bl2 ; 

      }
  return 1;
}


/* enleve in noeud de la liste de bif node si s'y trouve */
PTR_BLOB
Delete_Elt_Blob_Liste(b1,b2)
     PTR_BFND b1,b2;
{
  PTR_BLOB temp, last, res = NULL;
  
  if (!b1)
    return NULL;
  
  last = NULL;
  for (temp = BIF_BLOB1(b1) ; temp ; temp = BLOB_NEXT (temp))
    {
      if (BLOB_VALUE(temp) == b2)
        {
          res = temp;
          if (last  == NULL)
            {
              BIF_BLOB1(b1) = BLOB_NEXT (temp);              
              break;
            }          
          else
            {
              BLOB_NEXT (last) = BLOB_NEXT (temp);
              break;
            }
        }
      last = temp;      
    }
  
  if (!res)
    {
      last = NULL;
      for (temp = BIF_BLOB2(b1) ; temp ; temp = BLOB_NEXT (temp))
        {
          if (BLOB_VALUE(temp) == b2)
            {
               res = temp;
              if (last  == NULL)
                {
                  BIF_BLOB2(b1) = BLOB_NEXT (temp);
                  break;
                }          
              else
                {
                  BLOB_NEXT (last) = BLOB_NEXT (temp);
                  break;
                }
            }
          last = temp; 
        }
    }
  return res;
}

/********************* FIN DE GESTION DES LISTES BLOB ***********************/



/*****************************GESTION DES NOEUDS BIFS*************************/
Update_Control_Parent(first,last,cp)
PTR_BFND first,cp,last;

{
  PTR_BFND temp;
  
  for (temp = first; temp && (temp != last); temp = BIF_NEXT(temp))
    {      
      if (!In_Section(first,last,BIF_CP(temp)))
        BIF_CP(temp) = cp;
    }

  if (!In_Section(first,last,BIF_CP(last)))
    BIF_CP(last) = cp;
}


PTR_BFND 
Get_Where_to_Insert_in_Blob(where,cpin)
PTR_BFND where, cpin;
{
  PTR_BFND temp;
  PTR_BLOB blob;
  
  if (!cpin || !where)
    return NULL;

  if (Find_Bif_In_Blob_Liste1 (cpin, where))
    return where;
  if (Find_Bif_In_Blob_Liste2 (cpin, where))
    return where;

  
  for (blob = BIF_BLOB1(cpin) ; blob; blob = BLOB_NEXT(blob))
    {
      temp = Get_Where_to_Insert_in_Blob(where,BLOB_VALUE(blob));
      if (temp)
        return BLOB_VALUE(blob);
    }

  for (blob = BIF_BLOB2(cpin) ; blob; blob = BLOB_NEXT(blob))
    {
      temp = Get_Where_to_Insert_in_Blob(where,BLOB_VALUE(blob));
      if (temp)
        return BLOB_VALUE(blob);
    }

  return NULL;
  
}


/* Given a node where we want to insert another node, 
   compute the control parent */
PTR_BFND 
  Compute_Control_Parent(where)
PTR_BFND where;
{
  PTR_BFND cp;

      
  if (!where)
    {
      Message("where not defined in Compute_Control_Parent: abort()",0);
      abort();
    }

  if (!BIF_CP(where))
    {
      switch(BIF_CODE(where))
        { /* node that can be a bif control parent */
        case  GLOBAL	       :
        case  PROG_HEDR      :
        case  PROC_HEDR	:	
        case  BASIC_BLOCK	:
        case  IF_NODE		:
        case  LOOP_NODE	:	
        case  FOR_NODE	:	
        case  FORALL_NODE	:
        case  WHILE_NODE	:
        case  CDOALL_NODE	:
        case  SDOALL_NODE	:
        case  DOACROSS_NODE	:
        case  CDOACROSS_NODE	:
        case  FUNC_HEDR	:
          return where;     
        default:
          Message("No Control Parent in Compute_Control_Parent: abort()",0);
          abort();
        }
    }

  switch(BIF_CODE(where))
    {
    case CONT_STAT :
    case CONTROL_END :
	  cp = BIF_CP(BIF_CP(where)); /* handle by the function insert in */
          break;
      /* that a node with a list of blobs */
    case  GLOBAL	:
    case  PROG_HEDR     :
    case  PROC_HEDR	:	
    case  BASIC_BLOCK	:
    case  IF_NODE	:
    case  LOOP_NODE	:	
    case  FOR_NODE	:	
    case  FORALL_NODE	:
    case  WHILE_NODE	:
    case  CDOALL_NODE	:
    case  SDOALL_NODE	:
    case  DOACROSS_NODE	:
    case  CDOACROSS_NODE :
    case  FUNC_HEDR	:
      cp = where;
          break; 
    case   ELSEIF_NODE    :
        default:
          cp = BIF_CP(where); /* dont specify it */
    }

  return cp;  
}


Insert_List_of_BifNode(first,where,cpin)
PTR_BFND first,where;
PTR_BFND cpin;
{
  PTR_BFND cp;
  PTR_BFND biforblob;
  PTR_BFND temp, last;  
  int inblob2;

  if (!first)
    return 0;
  
  if (!where)
    {
      Message("where not defined in Insert_List_of_BifNode: abort()",0);
      abort();
    }

  if (!cpin)
    cp = Compute_Control_Parent(where);
  else
    cp = cpin;

  /* find where in the blob list where to insert it */
  /* treat first the special case of if_node */
  if ((BIF_CODE(where) == CONTROL_END) &&
      (BIF_CODE(BIF_CP(where)) == IF_NODE) &&
      (!Find_Bif_In_Blob_Liste2 (BIF_CP(where),where)) &&
      BIF_BLOB2(BIF_CP(where)))
    {
      cp = BIF_CP(where);
      inblob2 = TRUE;
      biforblob = NULL;
      last =  Get_Last_Node_List(first);
    }
    else
      {
        biforblob =  Get_Where_to_Insert_in_Blob(where,cp);
        last =  Get_Last_Node_List(first);
        inblob2 = Find_Bif_In_Blob_Liste2 (cp,biforblob);
        if (BIF_CODE(where) == ELSEIF_NODE)
          inblob2 = TRUE;
      }

  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!In_Section(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
              if (inblob2)
                First_In_Blob_Liste2(temp, cp);
              else
                First_In_Blob_Liste1(temp, cp);
            } else
              {
                if (inblob2)
                  Insert_In_Blob_Liste2(temp,biforblob, cp);
                else
                  Insert_In_Blob_Liste1(temp,biforblob, cp);
              }          
          biforblob = temp;       
        }
    }

  Update_Control_Parent(first,last,cp); 
  BIF_NEXT(last) = BIF_NEXT(where);
  BIF_NEXT(where) = first;
  return 1;  
}


First_in_List_of_BifNode_blob1(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL; 
  last =  Get_Last_Node_List(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!In_Section(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                First_In_Blob_Liste1(temp, cpin);
            } else
              {
                  Insert_In_Blob_Liste1(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }

  Update_Control_Parent(first,last,cpin); 
  return 1;
}


Append_in_List_of_BifNode_blob1(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL; 
  last =  Get_Last_Node_List(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!In_Section(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                Append_In_Blob_Liste1(temp, cpin);
            } else
              {
                  Insert_In_Blob_Liste1(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }

  Update_Control_Parent(first,last,cpin); 
  return 1;
}



First_in_List_of_BifNode_blob2(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL;  
  last =  Get_Last_Node_List(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!In_Section(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                First_In_Blob_Liste2(temp, cpin);
            } else
              {
                  Insert_In_Blob_Liste2(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }

  Update_Control_Parent(first,last,cpin); 
  return 1;
}


Append_in_List_of_BifNode_blob2(first,cpin)
PTR_BFND first;
PTR_BFND cpin;
{
  PTR_BFND biforblob;
  PTR_BFND temp, last;  

  if (!first || !cpin)
    return 0;
  
  biforblob = NULL;  
  last =  Get_Last_Node_List(first);
  for (temp = first; temp; temp = BIF_NEXT(temp))
    {      
      if (!In_Section(first,last,BIF_CP(temp)))
        {
          if (!biforblob)
            {
                Append_In_Blob_Liste2(temp, cpin);
            } else
              {
                  Insert_In_Blob_Liste2(temp,biforblob, cpin);
              }          
          biforblob = temp;       
        }
    }

  Update_Control_Parent(first,last,cpin); 
  return 1;
}





Insert_Bifnode_Before(bif_current, biftoinsert, cpin)
     PTR_BFND bif_current, biftoinsert,cpin;
{
  PTR_BFND  the_one_before = NULL;

  if (! bif_current || ! biftoinsert)
    {
      Message("NULL bif node in biftoinsert\n",0);
      exit(-1);
    }
  
  
  if (BIF_CODE (bif_current) == GLOBAL)
    {
      Message("Cannot insert before global\n",0);
      exit(-1);
    }  

  the_one_before = Get_Node_Before (bif_current);
  Insert_List_of_BifNode (biftoinsert, the_one_before,cpin);
  
} 



/* warning to be used carefully; i.e. remove sons before a root */
PTR_BFND
Delete_Bif_Node (bif)
     PTR_BFND bif;
{
  PTR_BFND temp;
  
  temp = Get_Node_Before (bif);
  Delete_Elt_Blob_Liste (BIF_CP (bif), bif);
  if (temp) 
    BIF_NEXT (temp) = BIF_NEXT (bif);
  return temp;
}


/**********************FIN DE GESTION DES NOEUDS BIFS*************************/



/**************************OBSERVATEURS SUR LES BIFS**************************/

PTR_BFND
Get_Node_Before(b)
     PTR_BFND b;
{
  PTR_BFND temp, first;
  
  if (!b)
    return NULL;

  if (BIF_CP(b))
    first = BIF_CP(b);
  else
    first = PROJ_FIRST_BIF ();

  for (temp = first; temp ; temp = BIF_NEXT(temp))
    {
      if (BIF_NEXT(temp) == b)
        return temp;
    }
 
  if (BIF_CP(b))
    {
      for (temp = BIF_CP(BIF_CP(b)); temp ; temp = BIF_NEXT(temp))
        {
          if (BIF_NEXT(temp) == b)
            return temp;
        }
    }
  if (debug)
    Message("Node Before not found ",0);
  return NULL;
}



In_Section(bif_depart, bif_fin, noeud)
     PTR_BFND bif_depart, bif_fin, noeud;
{
  PTR_BFND temp;
  
  if (! noeud)
    return FALSE;
  
  for (temp = bif_depart; temp; temp = BIF_NEXT (temp))
    {
      if (temp ==  noeud)
        return TRUE;
      if (temp == bif_fin)
        return FALSE;
    }
  return FALSE;
  
}


PTR_BFND Extract_Bif_Section (bif_depart, bif_fin)
     PTR_BFND bif_depart, bif_fin;
{
  PTR_BFND temp;
  
  if (bif_depart && bif_fin)
    {
      for (temp = bif_depart; temp !=  bif_fin; temp = BIF_NEXT (temp))
        {
          if (!In_Section(bif_depart, bif_fin,BIF_CP (temp)))
            {
              Delete_Elt_Blob_Liste(BIF_CP (temp),temp);
              BIF_CP (temp) = NULL;              
            }
        }
  
      /* on traite maintenant bif_fin */
      if (!In_Section(bif_depart, bif_fin,BIF_CP ( bif_fin)))
        {
          Delete_Elt_Blob_Liste(BIF_CP (bif_fin), bif_fin);
           BIF_CP (bif_fin) = NULL;   
        }

      temp = Get_Node_Before(bif_depart);
      if (temp && bif_fin)
        BIF_NEXT(temp) = BIF_NEXT (bif_fin);
      BIF_NEXT (bif_fin) = NULL;
    }  
  
  return bif_depart;
}



PTR_BFND
Get_Last_Node_List(b)
     PTR_BFND b;
{
  PTR_BFND temp;  
  for (temp = b; temp; temp = BIF_NEXT(temp))
    {      
      if (!BIF_NEXT(temp))
        {
          return temp;          
        }
    }
  return temp;  
}


PTR_BFND
Get_Last_Node_Of_Stmt(b)
     PTR_BFND b;
{
  PTR_BLOB temp,last = NULL;
  
  if (BIF_BLOB2(b))
    {
      for (temp = BIF_BLOB2(b); temp ; temp = BLOB_NEXT(temp))
        {
          last = temp;
        }
    } else
     {
       for (temp = BIF_BLOB1(b); temp ; temp = BLOB_NEXT(temp))
         {
           last = temp;
         }      
     } 
  if (last)
    {      
        return BLOB_VALUE(last);
    }
  else
    return b;
}


/***********************FIN DES OBSERVATEURS SUR LES BIFS*********************/


/************************MANIPULATION DES LOW LEVEL NODES*********************/

/* remplace une variable dans une expression Attention premiere 
 expression pas une var ref, sinon faux */

Replace_Var_In_Expression(exprold, symb, exprnew)
     PTR_SYMB symb;
     PTR_LLND exprold, exprnew;
{
  if (!exprold)
    return ;

  if (Is_Var_Ref_To_Symb(NODE_OPERAND0(exprold),symb))
    NODE_OPERAND0(exprold) = exprnew;
  else
    Replace_Var_In_Expression(NODE_OPERAND0(exprold), symb, exprnew);
  
      
  if (Is_Var_Ref_To_Symb(NODE_OPERAND1(exprold),symb))
    NODE_OPERAND1(exprold) = exprnew;
  else
    Replace_Var_In_Expression(NODE_OPERAND1(exprold), symb, exprnew);
  
}

/* remplace une reference a une variable symb dans une section de code */

Replace_Var_In_Section (debut, fin, symb, expr)
     PTR_BFND debut, fin;
     PTR_SYMB symb;
     PTR_LLND expr;
{
  PTR_BFND temp;
  
  for (temp = debut; temp; temp = BIF_NEXT(temp))
    {
      if (Is_Var_Ref_To_Symb(BIF_LL1(temp),symb))
        BIF_LL1(temp) = expr;
      else
        Replace_Var_In_Expression(BIF_LL1(temp), symb, expr);

      if (Is_Var_Ref_To_Symb(BIF_LL2(temp),symb))
        BIF_LL2(temp) = expr;
      else
        Replace_Var_In_Expression(BIF_LL2(temp), symb, expr);

      if (Is_Var_Ref_To_Symb(BIF_LL3(temp),symb))
        BIF_LL3(temp) = expr;
      else
        Replace_Var_In_Expression(BIF_LL3(temp), symb, expr);
      if (fin && (temp == fin))
        break;
    }  
}
  
   
PTR_LLND
  Replace_Symbol_Ref (ll, symb, array)
     PTR_LLND ll;
     PTR_SYMB symb, array;
{

if (! ll ) return NULL;

if ((NODE_CODE (ll) == VAR_REF) && (NODE_SYMB (ll) == symb))
  {
    NODE_CODE (ll) = ARRAY_REF;
    NODE_SYMB (ll) = array;
  }
NODE_OPERAND0 (ll) = Replace_Symbol_Ref (NODE_OPERAND0 (ll), symb, array);
NODE_OPERAND1 (ll) = Replace_Symbol_Ref (NODE_OPERAND1 (ll), symb, array);
return ll;
}



/* use with vectorize */
PTR_LLND
  Replace_Index_In_Expression (expr, symb, borne_inf, borne_sup)
     PTR_LLND expr;
     PTR_SYMB symb;
     PTR_LLND borne_inf, borne_sup;
{
  PTR_LLND ll_temp1, ll_temp2, express, d_inf, d_sup;
  int *res_inf, *res_sup;
  
  if (!expr) 
    return NULL;

  if (Is_Var_Ref_To_Symb(NODE_OPERAND0 (expr),symb))
    {
      ll_temp1 = bif_copy_expr (expr);
      Replace_Var_In_Expression (ll_temp1, symb, borne_inf);
      res_inf = Evaluate_Expression (ll_temp1);

      ll_temp2 = bif_copy_expr (expr);
      Replace_Var_In_Expression (ll_temp2, symb, borne_sup);
      res_sup = Evaluate_Expression (ll_temp2);

      if (res_inf [0] != -1)
        d_inf = bif_build_int (res_inf [1]);
      else
        d_inf = ll_temp1;

      if (res_sup [0] != -1)
        d_sup = bif_build_int (res_sup [1]);
      else
        d_sup = ll_temp2;
    }
  else
    {
      d_inf = borne_inf;
      d_sup = borne_sup;
    }
  
  express = bif_build (EXPR_LIST, NULL, 
                       bif_build (DDOT, NULL, d_inf, d_sup),
                       NULL);
  return express;
}


Replace_Index_In_Array_Ref (expr, symb, borne_inf, borne_sup)
     PTR_LLND expr;
     PTR_SYMB symb;
     PTR_LLND borne_inf, borne_sup;
{
  PTR_LLND ll_temp;
  
    if (!expr)
    return NULL;
  
  if (NODE_CODE (expr) == ARRAY_REF) 
    {
      ll_temp = NODE_OPERAND0 (expr);
      while (ll_temp)
        {
          if (Is_Var_In_Expression (NODE_OPERAND0 (ll_temp), symb))
            NODE_OPERAND0 (ll_temp) = Replace_Index_In_Expression 
                                      (NODE_OPERAND0 (ll_temp), 
                                      symb, borne_inf, borne_sup);
          ll_temp = NODE_OPERAND1 (ll_temp);
        }
    }
  else 
    {
      Replace_Index_In_Array_Ref (NODE_OPERAND0 (expr), symb, 
                                  borne_inf, borne_sup);
      
      Replace_Index_In_Array_Ref (NODE_OPERAND1 (expr), symb, 
                                  borne_inf, borne_sup);
    }
}

Replace_Index_In_Section (bif, symb, borne_inf, borne_sup)
     PTR_BFND bif;
     PTR_SYMB symb;
     PTR_LLND borne_inf, borne_sup;
{
  PTR_BFND temp;
  
  for (temp = bif; temp; temp = BIF_NEXT(temp))
    {
          
      if (Is_Var_In_Expression (BIF_LL1 (temp), symb))
        Replace_Index_In_Array_Ref (BIF_LL1 (temp), symb, 
                                    borne_inf, borne_sup);

      if (Is_Var_In_Expression (BIF_LL2 (temp), symb))
        Replace_Index_In_Array_Ref (BIF_LL2 (temp), symb, 
                                    borne_inf, borne_sup);

      if (Is_Var_In_Expression (BIF_LL3 (temp), symb))
        Replace_Index_In_Array_Ref (BIF_LL3 (temp), symb, 
                                    borne_inf, borne_sup);
    }  
}



int  
  *Evaluate_Expression (expr)
     PTR_LLND expr;
{
  int *res, *op1, *op2;
  
  res = (int *) xmalloc (2 * sizeof(int));
  bzero (res, 2 * sizeof (int));
  op1 = (int *) xmalloc (2 * sizeof(int));
  bzero (op1, 2 * sizeof (int));
  op2 = (int *) xmalloc (2 * sizeof(int));
  bzero (op2, 2 * sizeof (int));
  if (! expr)
    {
      res [0] = -1;
      return res;
    }
  
  switch (BIF_CODE (expr)) 
    {
    case INT_VAL: 
      res [1] = NODE_INT_CST_LOW (expr);
      free(op1); free(op2);
      return res;
    case ADD_OP :
      op1  = Evaluate_Expression (NODE_OPERAND0 (expr));
      op2  = Evaluate_Expression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) && (op2 [0] == -1))
        res [0] = -1;
      else
            if ((op1 [0] == -1) && (op2 [0] != -1))
            {
                 res [0] = -1;
                 NODE_OPERAND1 (expr) = bif_build_int (op2[1]);
            }  
           else
                if ((op1 [0] != -1) && (op2 [0] == -1))
                {
                     res [0] = -1;
                     NODE_OPERAND0 (expr) = bif_build_int (op1[1]); 
                }
                else
                     res [1] = op1 [1] + op2 [1];
      free(op1); free(op2);
      return res;
   case MULT_OP :
      op1  = Evaluate_Expression (NODE_OPERAND0 (expr));
      op2  = Evaluate_Expression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
           if ((op1 [0] == -1) && (op2 [0] != -1))
            {
                 res [0] = -1;
                 NODE_OPERAND1 (expr) = bif_build_int (op2[1]);
            }  
           else
                if ((op1 [0] != -1) && (op2 [0] == -1))
                {
                     res [0] = -1;
                     NODE_OPERAND0 (expr) = bif_build_int (op1[1]); 
                }
                else
                     res [1] = op1 [1] * op2 [1];
      free(op1); free(op2);
      return res;
   case SUBT_OP :
      op1  = Evaluate_Expression (NODE_OPERAND0 (expr));
      op2  = Evaluate_Expression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
           if ((op1 [0] == -1) && (op2 [0] != -1))
            {
                 res [0] = -1;
                 NODE_OPERAND1 (expr) = bif_build_int (op2[1]);
            }  
           else
                if ((op1 [0] != -1) && (op2 [0] == -1))
                {
                     res [0] = -1;
                     NODE_OPERAND0 (expr) = bif_build_int (op1[1]); 
                }
                else
                     res [1] = op1 [1] - op2 [1];
      free(op1); free(op2);
      return res;
   case DIV_OP :
        op1  = Evaluate_Expression (NODE_OPERAND0 (expr));
      op2  = Evaluate_Expression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
           if ((op1 [0] == -1) && (op2 [0] != -1))
            {
                 res [0] = -1;
                 NODE_OPERAND1 (expr) = bif_build_int (op2[1]);
            }  
           else
                if ((op1 [0] != -1) && (op2 [0] == -1))
                {
                     res [0] = -1;
                     NODE_OPERAND0 (expr) = bif_build_int (op1[1]); 
                }
                else
        res [1] = op1 [1] / op2 [1];
      free(op1); free(op2);
      return res;
   case MOD_OP :
      op1  = Evaluate_Expression (NODE_OPERAND0 (expr));
      op2  = Evaluate_Expression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
           if ((op1 [0] == -1) && (op2 [0] != -1))
            {
                 res [0] = -1;
                 NODE_OPERAND1 (expr) = bif_build_int (op2[1]);
            }  
           else
                if ((op1 [0] != -1) && (op2 [0] == -1))
                {
                     res [0] = -1;
                     NODE_OPERAND0 (expr) = bif_build_int (op1[1]); 
                }
                else
                     res [1] = op1 [1] % op2 [1];
      free(op1); free(op2);
      return res;
   case EXP_OP :
      op1  = Evaluate_Expression (NODE_OPERAND0 (expr));
      op2  = Evaluate_Expression (NODE_OPERAND1 (expr));
      if ((op1 [0] == -1) || (op2 [0] == -1))
        res [0] = -1;
      else
           if ((op1 [0] == -1) && (op2 [0] != -1))
            {
                 res [0] = -1;
                 NODE_OPERAND1 (expr) = bif_build_int (op2[1]);
            }  
           else
                if ((op1 [0] != -1) && (op2 [0] == -1))
                {
                     res [0] = -1;
                     NODE_OPERAND0 (expr) = bif_build_int (op1[1]); 
                }
                else
                     res [1] = op1 [1] ^ op2 [1];
      free(op1); free(op2);
      return res;

    case MINUS_OP :
      op1  = Evaluate_Expression (NODE_OPERAND0 (expr));
      if (op1 [0] == -1)
        res [0] = -1;
      else
        res [1] = - op1 [1];      
      free(op1);
      return res;
   default :
     res [0] = -1;
      free(op1); free(op2);
      return res;
    }
}


 
/********************FIN DE MANIPULATION DES LOW LEVEL NODES******************/


/*************************MANIPULATION DES BIF NODES**************************/

PTR_BFND
  Duplicate_stmts (body)
     PTR_BFND body;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;

 if (! body) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = Get_Last_Label_Id();
 
 lenght = 0;
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     lenght++;
     lastnode = temp;     
   }
 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 bzero(alloue, 2* lenght * sizeof(PTR_BFND));
 
 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 bzero(label_insection, 2* lenght * sizeof(PTR_LABEL)); 
 temp = body;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) bif_make_node (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = bif_copy_expr (BIF_LL1 (temp));
      BIF_LL2 (copie) = bif_copy_expr (BIF_LL2 (temp));
      BIF_LL3 (copie) = bif_copy_expr (BIF_LL3 (temp));
      if (last)
        BIF_NEXT(last) = copie;

     
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
	{
	  /* create a new label */
	  label_insection[2*i+1] = (PTR_LABEL) bif_make_node(LABEL_KIND); 
	  maxlabelname++;
	  LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
	  LABEL_BODY(label_insection[2*i+1]) == copie;
	  LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
	  LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
	  LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
	  BIF_LABEL(copie) = label_insection[2*i+1];
	  label_insection[2*i] = BIF_LABEL(temp);
	} 	  

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = body;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1]; 
     lab = NULL;
     
     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;	
         
         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {                
                 lab = NODE_LABEL(ptl);
                 trouve = 0;	 
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);             
           }
         temp = BIF_NEXT(temp);
         continue;         
       }
     
         
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
	 lab = NODE_LABEL(BIF_LL3(temp));
	 cas = 2;	
       }
     else
       {
	 lab = BIF_LABEL_USE(temp);
	 cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
	 int trouve = 0;	 
	 for (j = 0; j < lenght; j++)
	   {
	     if (label_insection[2*j])
	       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
		 {
		   trouve = j+1;
		   break;
		 }
	   }
	 if(trouve)
	   {
	     if (cas == 1)
	       {
		 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
	       }
	     if (cas == 2)
	       {
		 if (BIF_LL3(copie))
		   {
		     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1];
		   }
	       }
	   } else
	     {
	       if (cas == 1)
		 BIF_LABEL_USE(copie) = lab; /* outside */
	       /* if ((cas == 2) no change */
	     }
       }
     temp = BIF_NEXT(temp);
   }
 
 /* on met a jour le blob list */
 copie = alloue[1];
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp; 
              blobtemp = BLOB_NEXT(blobtemp)) 
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];
 for (temp = body; temp ; temp = BIF_NEXT(temp))
   {
     if (In_Section(body, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       }
     copie = BIF_NEXT(copie);
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}
     

/*********************FIN DE MANIPULATION DES BIFS NODES**********************/


/*********************OBSERVATEURS SUR LES LOW LEVEL NODES*******************/



/* indique si une var ref a symb pour symbole*/

Is_Var_Ref_To_Symb(expr,symb)
     PTR_LLND expr;
     PTR_SYMB symb;
{
  
  if (!expr)
    return FALSE;

  if (NODE_CODE(expr) != VAR_REF)
    return FALSE;
  
  if (NODE_SYMB(expr) != symb)
    return FALSE;

    return TRUE;
  
}

/*indique s'il existe une occurrence de var dans expr*/

Is_Var_In_Expression (expr, symb)
     PTR_LLND expr;
     PTR_SYMB symb;
{
  
 if (!expr || !symb)
    return FALSE;

 if (Is_Var_Ref_To_Symb (expr,symb))
   return TRUE;
 else
   return (Is_Var_In_Expression (NODE_OPERAND0 (expr), symb) ||
           Is_Var_In_Expression (NODE_OPERAND1 (expr), symb));
}




Is_Symbol_Declare (scope, symb)
     PTR_BFND scope;
     PTR_SYMB symb;
{
  if (SYMB_SCOPE (symb) == scope) 
    return TRUE;
  else 
    if (BIF_CODE (scope) == GLOBAL) 
      return FALSE;
    else 
      return (Is_Symbol_Declare (BIF_CP (scope), symb));
}






/*
 * retourne un type si existe 
 *
 */

PTR_TYPE
Return_to_me_type(tt)
     int tt;
{
  PTR_TYPE ttype = NULL;
  
  for (ttype = PROJ_FIRST_TYPE () ; ttype; ttype = TYPE_NEXT(ttype))
    {
      if (TYPE_CODE(ttype) == tt)
	return ttype;
    }
  return (ttype);
}


/* return the real type */
PTR_TYPE
Get_Type_Derived(type)
     PTR_TYPE type;
{
  if (TYPE_CODE(type) == T_DERIVED_TYPE)
    {
      return(Get_Type_Derived(NODE_TYPE(TYPE_SYMB_DERIVE(type))));      
    } else
      if  (TYPE_CODE(type) == T_DESCRIPT)
	{
	  return(Get_Type_Derived(TYPE_BASE(type))); 
	} else
	  return(type);

}




PTR_SYMB 
get_function_symb(name)
     char *name;
{
  PTR_SYMB tsymb;

 for (tsymb = PROJ_FIRST_SYMB(cur_proj) ; tsymb; tsymb = SYMB_NEXT(tsymb))
   {
     if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0))
       return tsymb;
   }
  return NULL;
}

PTR_BFND 
get_function_header(symb)
     PTR_SYMB symb;
{
  PTR_BFND thebif;
  if ((SYMB_CODE(symb) != FUNCTION_NAME) &&
      (SYMB_CODE(symb) != PROCEDURE_NAME))
    return NULL;

  /* have to look in the bif list   return SYMB_FUNC_HEDR(symb); seens not to be set */

  thebif = PROJ_FIRST_BIF();
  for (;thebif;thebif=BIF_NEXT(thebif)) 
    {
      if (((BIF_CODE(thebif) == FUNC_HEDR)  ||
           (BIF_CODE(thebif) == PROC_HEDR)  || 
           (BIF_CODE(thebif) == PROG_HEDR))
          &&
          (BIF_SYMB(thebif) == symb))
        return thebif;
    }

  return NULL;
}
     

PTR_BFND 
get_global_function_header(name)
     char *name;
{
  PTR_SYMB tsymb;
  PTR_FILE ptf;
  PTR_BLOB ptb;
  PTR_BFND tmp;
  
  for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);
      cur_file = ptf;      
      /* reset the toolbox and pointers*/
      Init_Tool_Box();
      
      for (tsymb = PROJ_FIRST_SYMB() ; tsymb; tsymb = SYMB_NEXT(tsymb))
        {
          if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0)
              && ((SYMB_CODE(tsymb) == FUNCTION_NAME) ||
                  (SYMB_CODE(tsymb) == PROCEDURE_NAME)))
            {
              tmp = get_function_header(tsymb);
              if (tmp)
                return tmp;
            }
        }
    }
  return NULL;
}


/* return true if declare in the function or global */
int
in_scope(header, symb)
     PTR_BFND header;
     PTR_SYMB symb;
{
  PTR_BFND temp;

  if (!SYMB_SCOPE(symb))
     return FALSE;

  if (BIF_CODE(SYMB_SCOPE(symb)) == GLOBAL)
    return TRUE;

  temp = SYMB_SCOPE(symb);
  while (temp)
    {
      if (temp == header)
	return TRUE;
      temp = BIF_CP(temp);
    }
  return FALSE;
}

int
local_to_func(header, symb)
     PTR_BFND header;
     PTR_SYMB symb;
{
  PTR_BFND temp;

  if (!SYMB_SCOPE(symb))
     return FALSE;

  if (BIF_CODE(SYMB_SCOPE(symb)) == GLOBAL)
    return FALSE;

  temp = SYMB_SCOPE(symb);
  if (temp == header)
    return FALSE;    /* this a parameter */
  while (temp)
    {
      if (temp == header)
	return TRUE;
      temp = BIF_CP(temp);
    }
  return FALSE;
}

int
bif_list_length_expr_list(first)
PTR_LLND first;
{
  PTR_LLND tail;
  int len = 0;
  if (first == NULL)
    return(0);
  for (tail = first; tail; tail = NODE_OPERAND1(tail) )
    len++;
return(len);
}



/* Function for scanning the type of expression and set it correctly then 
   we must run the conversion type is the type we want */

PTR_TYPE
Get_type_for_expression(expr)
     PTR_LLND expr;
{
  int code;

  if (expr == NULL)
    {
       return (NULL);
    }
  
  code = NODE_CODE(expr);
  
  switch(code)
    {
    case FLOAT_VAL	:
    case DOUBLE_VAL     :
    case INT_VAL:
    case BOOL_VAL	:
    case CHAR_VAL	:
    case STRING_VAL	:
    case COMPLEX_VAL	:
    case CONST_REF:
    case VAR_REF:
    case ARRAY_REF:
    case FUNC_CALL      :
      return NODE_TYPE(expr);
      break;
      /* Added by T. Priol - 12/1/91
    case VAR_REF:
    case ARRAY_REF:
      if (NODE_TYPE(expr))
	return(NODE_TYPE(expr));
      else
	return SYMB_TYPE(NODE_SYMB(expr));
      break;
      */
    case EXPR_LIST :
      { PTR_LLND temp_ll;
	PTR_TYPE resul;
      
	for (temp_ll = expr ; temp_ll ; temp_ll = NODE_OPERAND1(temp_ll))
	  resul = Get_type_for_expression (NODE_OPERAND0(temp_ll));

	return resul;
      }
      break;
    case  EXACT_DIV_EXPR :
    case RDIV_EXPR	:
    case ADD_OP		:
    case SUBT_OP	:
    case MULT_OP	:
    case DIV_OP		:
      {
	PTR_TYPE targ0, targ1;
	
	targ0 = Get_type_for_expression(NODE_OPERAND0(expr));
	targ1 = Get_type_for_expression(NODE_OPERAND1(expr));
	
	if ((targ0 == NULL)||(targ1 == NULL))
	  Message("Get_type_for_expression()",0);
	if ((targ0 == NULL)&&(targ1 == NULL))
	  Message("Get_type_for_expression()",0);
	
	if (targ0 == NULL)
	  targ0 = targ1;	
      return  targ0;
      }
      break;
    case MINUS_OP	:
      {
	PTR_TYPE targ0;
	
	targ0 = Get_type_for_expression(NODE_OPERAND0(expr));
	
	if (targ0 == NULL)
	  Message("Get_type_for_expression()",0);
	return  targ0;	
      }
      break;
      case DEREF_OP :
	{ PTR_TYPE targ0;
	  /* the type to return is the one of the element reference */
	  targ0 = Get_type_for_expression(NODE_OPERAND0(expr));

	  /* targ0 is the type of the reference expression,
	     should be a pointer */

	  if (TYPE_CODE(targ0) == T_POINTER)
	    return (TYPE_BASE(targ0));
	  else
	    NODE_TYPE(expr);
	}
	break;
	/* array ref should be added soon */
      default :
	return  NODE_TYPE(expr);
    }

}


/****************************************************************
 *								*
 *   Get_ll_with_id  -- find the low level node in the current	*
 *		   active file with given id number		*
 *								*
 *   Input:							*
 *	id -- the low level node id number			*
 *								*
 *   Output:							*
 *	the corresponding low level node pointer if found	*
 *	nil otherwise						*
 *								*
 ****************************************************************/
PTR_LLND
Get_ll_with_id (id)
    int id;
{
    PTR_LLND ll;

    for (ll = PROJ_FIRST_LLND (); ll ; ll = NODE_NEXT (ll))
	if (NODE_ID (ll) == id)
	    return ll;
    return NULL;
}


PTR_BFND
Get_bif_with_id (id)
     int id;
{
  PTR_BFND bif;
  
  for (bif = PROJ_FIRST_BIF (); bif ; bif = BIF_NEXT (bif))
    if (BIF_ID (bif) == id)
      return bif;
  return NULL;
}

PTR_SYMB
Get_symb_with_id (id)
     int id;
{
  PTR_SYMB symb;
  
  for (symb = PROJ_FIRST_SYMB (); symb ; symb = SYMB_NEXT (symb))
    if (SYMB_ID (symb) == id)
      return symb;
  return NULL;
}


PTR_TYPE 
Get_type_with_id (id)
     int id;
     
{
  PTR_TYPE type;
  
  for (type = PROJ_FIRST_TYPE (); type ; type = TYPE_NEXT (type))
    if (TYPE_ID (type) == id)
      return type;
  return NULL;
}


PTR_LABEL 
Get_label_with_id (id)
     int id;
{
  PTR_LABEL label;
  
  for (label = PROJ_FIRST_LABEL (); label ; label = LABEL_NEXT (label))
    if (LABEL_ID (label) == id)
      return label;
  return NULL;
}

PTR_CMNT
Get_cmnt_with_id (id)
     int id;
{
  PTR_CMNT comment;
  
  for (comment = PROJ_FIRST_CMNT (); comment ; comment = CMNT_NEXT (comment))
    if (CMNT_ID (comment) == id)
      return comment;
  return NULL;
}


  
     

/******************** Has to deal with label **************************/


Get_Last_Label_Id()
{
  int maxlabelname;
  PTR_LABEL lab;
  
  maxlabelname = 0;
  for (lab = PROJ_FIRST_LABEL(); lab; lab = LABEL_NEXT(lab))
    {
      if (maxlabelname < LABEL_STMTNO(lab))
      {
	maxlabelname =  LABEL_STMTNO(lab);
       }
    }

  return maxlabelname;
}
   
 
PTR_LABEL
Get_Last_Label()
{
  PTR_LABEL lab;
  
  for (lab = PROJ_FIRST_LABEL(); lab; lab = LABEL_NEXT(lab))
    {
      if  (!LABEL_NEXT(lab))
	return lab;
    }

  return NULL;
}
    



/* to add to low level */

PTR_SYMB 
Get_Symb(name, scope)
     char *name;
     PTR_BFND scope;
{
  PTR_SYMB tsymb;
  PTR_BFND temp;
  
 for (tsymb = PROJ_FIRST_SYMB(cur_proj) ; tsymb; tsymb = SYMB_NEXT(tsymb))
   {
     if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0))
       {
         /* we check the scope */
         temp = scope;         
         while (temp)
           {
             if (SYMB_SCOPE(tsymb) == temp)
                  return tsymb;
	     if (BIF_CODE(temp) != GLOBAL)
	       temp = BIF_CP(temp);
	     else
	       temp = NULL;
           }
       }
   }
  /* si non trouver on en recupere 1 */
  for (tsymb = PROJ_FIRST_SYMB(cur_proj) ; tsymb; tsymb = SYMB_NEXT(tsymb))
    {
       if ( SYMB_IDENT(tsymb) && (strcmp (name, SYMB_IDENT(tsymb)) == 0))
         {
           return tsymb;
         }
     }
  return NULL;
}

Build_Linear_Rep(exp,coef,symb,size, last)
     PTR_LLND exp;
     int *coef;
     PTR_SYMB *symb;
     int size;
     int *last;    
{
  return Build_Linear_Rep_Sign(exp,coef,symb,size, last,1,1);
}


/* initialy coeff are 0, return 1 if Ok, 0 if abort*/
Build_Linear_Rep_Sign(exp,coef,symb,size, last,sign,factor)
     PTR_LLND exp;
     int *coef;
     PTR_SYMB *symb;
     int size;
     int *last;  
     int sign;     
     int factor;
{
  int code;
  int i, *res1,*res2;
  
  if (!exp)
    return TRUE;
  
  code = NODE_CODE(exp);
  switch (code)
    {
    case VAR_REF:
      for (i=0; i< size; i++)
        {
          if (NODE_SYMB(exp) == symb[i])
            {
              coef[i] = coef[i] + sign*factor;
              break;
            }
        }
      break;
    case SUBT_OP:
      Build_Linear_Rep_Sign(NODE_OPERAND0(exp),coef,symb,size,last,sign,factor);
      Build_Linear_Rep_Sign(NODE_OPERAND1(exp),coef,symb,size,last,-1*sign,factor);
      break;
    case ADD_OP:
      Build_Linear_Rep_Sign(NODE_OPERAND0(exp),coef,symb,size,last,sign,factor);
      Build_Linear_Rep_Sign(NODE_OPERAND1(exp),coef,symb,size,last,sign,factor);
      break;
    case MULT_OP:
      res1 = Evaluate_Expression (NODE_OPERAND0(exp));
      res2 = Evaluate_Expression (NODE_OPERAND1(exp));
      if ((res1[0] != -1) && (res2[0] != -1))
        {
          *last = *last + factor*sign*(res1[1]*res2[1]);
        } else
          {
            if (res1[0] != -1) 
              {
                /* la constante est le fils gauche */
                if (NODE_CODE(NODE_OPERAND1(exp)) != VAR_REF)
                  return  Build_Linear_Rep_Sign(NODE_OPERAND1(exp),coef,symb,size, last,sign,res1[1]*factor);
                for (i=0; i< size; i++)
                  {
                    if (NODE_SYMB(NODE_OPERAND1(exp)) == symb[i])
                      {
                        coef[i] = coef[i] + factor*sign*(res1[1]);
                        break;
                      }
                  }
              } else
                if (res2[0] != -1) 
                  {
                    /* la constante est le fils droit */
                    if (NODE_CODE(NODE_OPERAND0(exp)) != VAR_REF)
                      return  Build_Linear_Rep_Sign(NODE_OPERAND0(exp),coef,symb,size, last,sign,res2[1]*factor);

                    for (i=0; i< size; i++)
                      {
                        if (NODE_SYMB(NODE_OPERAND0(exp)) == symb[i])
                          {
                            coef[i] = coef[i] + factor*sign*(res2[1]);
                            break;
                          }
                      }
                  } else                    
                    return FALSE;
          }
      break;
    case INT_VAL:
      *last = *last + factor*sign*(NODE_INT_CST_LOW(exp));
      break;
    default:
      
      return FALSE;
    }
  return TRUE;
}



/* indique si une var ref a symb */

Is_String_Val_With_Val(expr,str)
     PTR_LLND expr;
     char *str;
{
  if (!str)
    return FALSE;
  if (!expr)
    return FALSE;

  if (NODE_CODE(expr) != STRING_VAL)
    return FALSE;
  
  if (strcmp(NODE_STRING_POINTER(expr),str) == 0)
    return TRUE;

    return FALSE;
  
}


/* remplace une variable dans une expression Attention premiere 
 expression pas une var ref, sinon faux */

Replace_String_In_Expression(exprold, str, exprnew)
     char *str;
     PTR_LLND exprold, exprnew;
{
  if (!exprold || !exprnew)
    return ;

  if (Is_String_Val_With_Val(NODE_OPERAND0(exprold),str))
    NODE_OPERAND0(exprold) = exprnew;
  else
    Replace_String_In_Expression(NODE_OPERAND0(exprold), str, exprnew);
  
      
  if (Is_String_Val_With_Val(NODE_OPERAND1(exprold),str))
    NODE_OPERAND1(exprold) = exprnew;
  else
    Replace_String_In_Expression(NODE_OPERAND1(exprold), str, exprnew);
  
}



char *
Get_Function_Name_For_Call(pt)
PTR_LLND pt;
{
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;
  if (NODE_SYMB(pt))
    return SYMB_IDENT(NODE_SYMB(pt));
  else
    return NULL;
}



PTR_BFND
Get_Last_Node_Of_Project()
{
  PTR_BFND temp;

  for (temp = PROJ_FIRST_BIF();  temp;  temp = BIF_NEXT(temp))
    {
      if (!BIF_NEXT(temp))
	return temp;
    }
  return NULL;
}




PTR_LLND
  Follow_Llnd(ll,c)
PTR_LLND ll;
int c;
{
  PTR_LLND pt;
  if(c == 2)
    {
      pt = ll;
      while(pt)
	{
	  if (NODE_OPERAND1(pt) == NULL)
	    return pt;
	  pt = NODE_OPERAND1(pt);	  
	}
    } else
      {
        pt = ll;
        while(pt)
          {
            if (NODE_OPERAND1(pt) == NULL)
              return NODE_OPERAND0(pt);
            pt = NODE_OPERAND1(pt);	  
          }
      }
  return NULL;
}


PTR_LLND
Get_First_Parameter_For_Call(pt)
PTR_LLND pt;
{
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;

  if (!NODE_OPERAND0(pt))
    return NULL;
  pt = NODE_OPERAND0 (NODE_OPERAND0(pt));
  return pt;

}



PTR_LLND
Get_Second_Parameter_For_Call (pt)
PTR_LLND pt;
{
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;

  if (!NODE_OPERAND0(pt))
    return NULL;

  pt = NODE_OPERAND1(NODE_OPERAND0(pt));
  if (!pt)
    return NULL;
  else
    return NODE_OPERAND0(pt);

}

/* a remplacer par celle de la SVM*/

PTR_LLND
Get_Nieme_Parameter_For_Call (pt, i)
PTR_LLND pt;
int i;
{
  int j;
  PTR_LLND expr;
  
  if (!pt)
    return NULL;

  if (NODE_CODE(pt) != FUNC_CALL)
    return NULL;

  if (!NODE_OPERAND0(pt))
    return NULL;

  expr = NODE_OPERAND0(pt);
  for (j=2; j<=i ; j++)
    {
      if (!NODE_OPERAND1 (expr))
        return NULL;
      expr = NODE_OPERAND1 (expr);
    }
  if (!NODE_OPERAND0(expr))
    return NULL;
  else
    return NODE_OPERAND0(expr);
}


/*******************************MISCELLANEOUS*******************************/
char *
Remove_Carriage_Return(str)
char *str;
{
  int i =0;

  if (str == NULL)
    return NULL;

  while (str[i] != '\0')
    {
      if (str[i] == '\n')
	str[i] = ' ';
      i++;
    }
  return str;
}




int 
  Apply_To_Bif (bif, f)
     PTR_BFND bif;
     int (*f)();
{
  PTR_BLOB blob;
  int resul;
  
  if (!bif)
    return FALSE;
  
  resul = f(bif);  

  for (blob = BIF_BLOB1 (bif); blob; blob = BLOB_NEXT (blob))
    {
      resul = resul |  Apply_To_Bif (BLOB_VALUE (blob), f);
    }
  
  for (blob = BIF_BLOB2 (bif); blob; blob = BLOB_NEXT (blob))
    {
      resul =  resul | Apply_To_Bif (BLOB_VALUE (blob), f);
    }
  return resul;
  
}
           

char *
Change_Carriage_Return(str)
char *str;
{
  int i =0;

  if (str == NULL)
    return NULL;

  while (str[i] != '\0')
    {
      if (str[i] == '\n')
	str[i] = '\0';
      i++;
    }
  return str;
}

/* return a list of llnnode for all the array reference to an array */

PTR_LLND
Look_for_Arrayref_In_Expr(lln, symb)
PTR_LLND lln;
PTR_SYMB symb;
{
  PTR_LLND resul = NULL;
  PTR_LLND ll,pt;

  if (!lln || !symb)
    return NULL;

  if (NODE_OPERAND0(lln) && (NODE_CODE(NODE_OPERAND0(lln)) == ARRAY_REF) &&
	  (NODE_SYMB(NODE_OPERAND0(lln)) == symb))
	{
	  resul = bif_build(EXPR_LIST,NULL,NODE_OPERAND0(lln), resul);
	}
      else
	{
	  ll = Look_for_Arrayref_In_Expr(NODE_OPERAND0(lln), symb);
	  if (ll)
	    {
	      if (resul)
		{
		  pt = Follow_Llnd(resul,2);
		  NODE_OPERAND1(pt) = ll;
		} else
		  resul = ll;
	    }
	}

  
  if (NODE_OPERAND1(lln) && (NODE_CODE(NODE_OPERAND1(lln)) == ARRAY_REF) &&
      (NODE_SYMB(NODE_OPERAND1(lln)) == symb))
    {
      resul = bif_build(EXPR_LIST,NULL,NODE_OPERAND1(lln), resul);
    }
  else
    {
      ll = Look_for_Arrayref_In_Expr(NODE_OPERAND1(lln), symb);
      if (ll)
	{
	   if (resul)
	     {
	       pt = Follow_Llnd(resul,2);
		  NODE_OPERAND1(pt) = ll;
	     } else
	       resul = ll;
	}
    }
  return resul;

}

PTR_LLND
Look_for_Arrayref_In_Section(b, symb)
     PTR_BFND b;
     PTR_SYMB symb;
{
  PTR_BFND temp;
  PTR_LLND resul = NULL;
  PTR_LLND ll,pt;

  if (!b || !symb)
    return NULL;

  for (temp = b; temp; temp = BIF_NEXT(temp))
    {
      if (BIF_LL1(temp) && (NODE_CODE(BIF_LL1(temp)) == ARRAY_REF) &&
	  (NODE_SYMB(BIF_LL1(temp)) == symb))
	{
	  resul = bif_build(EXPR_LIST,NULL,BIF_LL1(temp), resul);
	}
      else
	{
	  ll = Look_for_Arrayref_In_Expr(BIF_LL1(temp), symb);
	  if (ll)
	    {
	      if (resul)
		{
		  pt = Follow_Llnd(resul,2);
		  NODE_OPERAND1(pt) = ll;
		} else
		  resul = ll;
	    }
	}

      if (BIF_LL2(temp) && (NODE_CODE(BIF_LL2(temp)) == ARRAY_REF) &&
	  (NODE_SYMB(BIF_LL2(temp)) == symb))
	{
	  resul = bif_build(EXPR_LIST,NULL,BIF_LL2(temp), resul);
	}
      else
	{
	  ll = Look_for_Arrayref_In_Expr(BIF_LL2(temp), symb);
	  if (ll)
	    {
	      if (resul)
		{
		  pt = Follow_Llnd(resul,2);
		  NODE_OPERAND1(pt) = ll;
		} else
		  resul = ll;
	    }
	}

      if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == ARRAY_REF) &&
	  (NODE_SYMB(BIF_LL3(temp)) == symb))
	{
	  resul = bif_build(EXPR_LIST,NULL,BIF_LL3(temp), resul);
	}
      else
	{
	  ll = Look_for_Arrayref_In_Expr(BIF_LL3(temp), symb);
	  if (ll)
	    {
	      if (resul)
		{
		  pt = Follow_Llnd(resul,2);
		  NODE_OPERAND1(pt) = ll;
		} else
		  resul = ll;
	    }
	}

    }
    
return resul;
}

  
/* reset to null the bif_next */

Reset_Bif_Next_Chain(start)
     PTR_BFND start;
{
  PTR_BLOB blob;

  if (!start)
    return NULL;
    
  BIF_NEXT(start) = NULL;

  for (blob = BIF_BLOB1(start); blob ; blob = BLOB_NEXT(blob))
    {
      Reset_Bif_Next_Chain(BLOB_VALUE(blob));
    }
  for (blob = BIF_BLOB2(start); blob ; blob = BLOB_NEXT(blob))
    {
       Reset_Bif_Next_Chain(BLOB_VALUE(blob));
    }
}


Count_Bif_Next_Chain(start)
     PTR_BFND start;
{
  PTR_BLOB blob;

  if (!start)
    return NULL;
    
  if (BIF_NEXT(start) == NULL)
    {
      CountNullBifNext++;
/*      printf("Bif_Next is Null %d (line %d)\n",BIF_CODE(start), BIF_LINE(start));*/
      
    }

  for (blob = BIF_BLOB1(start); blob ; blob = BLOB_NEXT(blob))
    {
      Count_Bif_Next_Chain(BLOB_VALUE(blob));
    }
  for (blob = BIF_BLOB2(start); blob ; blob = BLOB_NEXT(blob))
    {
       Count_Bif_Next_Chain(BLOB_VALUE(blob));
    }
}


/* Redo the BIF_NEXT Field for the DATA base so it is correct in the data 
   return the last also reset the BIF_ID to be added to low level and call
   in init toolbax */
static idfirst = 1;

PTR_BFND
Redo_Bif_Next_Chain(start)
     PTR_BFND start;
{
  PTR_BLOB blob;
  PTR_BFND last;

  if (!start)
    return NULL;
  
  BIF_ID(start) = idfirst;
  idfirst++;
  
  if (BIF_BLOB1(start))
    {
      BIF_NEXT(start) = BLOB_VALUE(BIF_BLOB1(start));
    }
  last = start;
  for (blob = BIF_BLOB1(start); blob ; blob = BLOB_NEXT(blob))
    {
      last = Redo_Bif_Next_Chain(BLOB_VALUE(blob));
      if (BLOB_NEXT(blob))
        BIF_NEXT(last) = BLOB_VALUE(BLOB_NEXT(blob));
      
      if (!last)
        last = BLOB_VALUE(blob);
    }

  if (last)
    {
      if (BIF_BLOB2(start))
        BIF_NEXT(last) = BLOB_VALUE(BIF_BLOB2(start));
    }
  for (blob = BIF_BLOB2(start); blob ; blob = BLOB_NEXT(blob))
    {
      last = Redo_Bif_Next_Chain(BLOB_VALUE(blob));
      if (BLOB_NEXT(blob))
        BIF_NEXT(last) = BLOB_VALUE(BLOB_NEXT(blob));
      if (!last)
        last = BLOB_VALUE(blob);
    }
  return last;
}

/******************************END MISCELLANEOUS****************************/

/****************************** Added by D.Windheiser ************************/

/* find the bif node corresponding to a given line number
   Note that if line is a continuation line, there is no bif node 
   with this line number
   So the corresponding bif node is the bif node with the
   largest line number lower or equal to the line num 
*/

/****************************************************************
 *								*
 *   FindNearBifNode -- find the corresponding BIF node given a	*
 *		    filename and line number			*
 *								*
 *   Input:							*
 *	    filename - name of the file to be looked upon	*
 *	    line     - line number to be checked		*
 *								*
 *   Output:							*
 *	    A bif pointer (PTR_BFND) points to the bif node	*
 *	    corresponds to the given line number		*
*	    NULL if error occured				*
 *								*
 ****************************************************************/

PTR_BFND rec_num_near_search();

PTR_BFND
FindNearBifNode(filename, line)
	char	*filename;
	int	 line;
	
{
  PTR_FILE ptf;
  PTR_BLOB ptb;
  

  for (ptb = PROJ_FILE_CHAIN (cur_proj); ptb ; ptb =  BLOB_NEXT (ptb))
    {
      ptf = (PTR_FILE) BLOB_VALUE (ptb);
      cur_file = ptf;      
      /* reset the toolbox and pointers*/
      Reset_Tool_Box();
      
      if (strcmp(Current_File_name,filename) == 0)
        { /* now look for the line number */
          return rec_num_near_search(line);
        }
    }
  fprintf(stderr,"%s",filename);
  Message("No such file in this project",0);
  return NULL;
}

/****************************************************************
 *								*
 *  rec_num_near_search --                                      *
 *                    search for the bif node that	        *
 *		      corresponds to the num'th line in the	*
 *		      current file           			*
 *								*
 *  Inputs:							*
 *         - line number of current file                        *
 *								*
 *  Output:							*
 *	The bif node pointer if one exists for the given line	*
 *	in the given file					*
 *								*
 ****************************************************************/
PTR_BFND
rec_num_near_search(num)
     int	 num;
{
  PTR_BFND temp,last = NULL;
  
  for (temp = PROJ_FIRST_BIF (); temp ; temp = BIF_NEXT(temp))
    {
      if (BIF_LINE(temp) == num)
        return temp;
      if (BIF_LINE(temp) > num)
        return last;
      last =temp;
    }
  return(NULL);
}



