/* Copyright (C) 1992, Irisa, Indiana University, 
   subroutines of the Sigma toolbox */
 /**************************************************************************
  *                                                                        *
  *   Middle level of Sigmacs toolbox for  Fortran                         *
  *                                                                        *
  *                                                                        *
  **************************************************************************/

#include <stdio.h>
#include <malloc.h>
#include "gvarargs.h"  /*for special arg passing */
#include "macro.h"
#include "ext_lib.h"
#include "ext_low.h"

#define MAXARGS 64  /* nombre maximum d'arguments*/ 


PTR_LLND Loop_Set_Step();
PTR_LLND Loop_Set_Borne_Inf();
PTR_LLND Loop_Set_Borne_Sup();
PTR_SYMB bif_build_decl ();


int NB_VARIABLE=0;
int NB_VAR_INDUCT=0;

/* 
 *
 * creation d'une boucle for 
 * Body est une liste de BFND lies par le champs thread (BIF_NEXT())
 *
 */

PTR_BFND
  Make_For_Loop(varindex,borne_inf, borne_sup, step, body)
PTR_SYMB varindex;
PTR_LLND borne_inf, borne_sup, step;
PTR_BFND body;
{
  PTR_BFND loop,enddo;
  
  loop = (PTR_BFND) bif_make_node(FOR_NODE);
  enddo =  (PTR_BFND) bif_make_node(CONTROL_END);

  /* creation des borne de la boucle */
  BIF_SYMB (loop) =  varindex;
  Loop_Set_Step(loop, step );
  Loop_Set_Borne_Inf(loop, borne_inf);
  Loop_Set_Borne_Sup(loop, borne_sup);

  /* creation de la boucle */
  Append_In_Blob_Liste1(enddo, loop);
  BIF_CP(enddo) = loop;
  BIF_NEXT(loop)  = enddo;

  /* on insere le corps */
  Insert_List_of_BifNode (body, loop, NULL);

  return loop;
}


PTR_LLND 
Loop_Set_Borne_Inf (loop,new_borne_inf)
     PTR_BFND loop;
     PTR_LLND new_borne_inf;
{
  PTR_LLND borne_inf= NULL;

  if (BIF_LL1 (loop))
    {
     borne_inf = NODE_OPERAND0 (BIF_LL1 (loop));
     NODE_OPERAND0 (BIF_LL1 (loop)) = new_borne_inf;
    }
  else
    {
      borne_inf = NULL;
      if (new_borne_inf)
        BIF_LL1(loop) = bif_build(DDOT,NODE_TYPE(new_borne_inf),
                                  new_borne_inf,NULL);
      else
        BIF_LL1(loop) = bif_build(DDOT,NULL,new_borne_inf,NULL);
    }
  return borne_inf;
}


PTR_LLND 
Loop_Set_Borne_Sup (loop,new_borne_sup)
     PTR_BFND loop;
     PTR_LLND new_borne_sup;
{
  PTR_LLND borne_sup= NULL;
  
 if (BIF_LL1 (loop))
    {
      borne_sup = NODE_OPERAND1 (BIF_LL1 (loop));
      NODE_OPERAND1 (BIF_LL1 (loop)) = new_borne_sup;
    }
  else
    {
      borne_sup = NULL;
      if (new_borne_sup)
        BIF_LL1(loop) = bif_build(DDOT,NODE_TYPE(new_borne_sup),
                                  NULL,new_borne_sup);
      else
         BIF_LL1(loop) = bif_build(DDOT,NULL,
                                  NULL,new_borne_sup);
    }
   return borne_sup;
}


PTR_LLND 
Loop_Set_Step (loop,new_step)
     PTR_BFND loop;
     PTR_LLND new_step;
{
  PTR_LLND step= NULL;

  step = BIF_LL2 (loop);
  BIF_LL2 (loop) = new_step;
  return step;
}


PTR_SYMB
Loop_Set_Index (loop, new_index)
     PTR_BFND loop;
     PTR_SYMB new_index;
{
  PTR_SYMB index;

  index = BIF_SYMB (loop);
  BIF_SYMB (loop) = new_index;
  return index;
}


PTR_LLND 
Loop_Get_Borne_Inf (loop)
     PTR_BFND loop;
{
  PTR_LLND borne_inf= NULL;

  if (BIF_LL1 (loop))
    {
     borne_inf = NODE_OPERAND0 (BIF_LL1 (loop));
    }
  return borne_inf;
}


PTR_LLND 
Loop_Get_Borne_Sup (loop)
     PTR_BFND loop;
{
  PTR_LLND borne_sup= NULL;
  
 if (BIF_LL1 (loop))
    {
      borne_sup = NODE_OPERAND1 (BIF_LL1 (loop));
    }
   return borne_sup;
}


PTR_LLND 
Loop_Get_Step (loop)
     PTR_BFND loop;
{
  PTR_LLND step= NULL;

  step = BIF_LL2 (loop);
  return step;
}

PTR_SYMB 
Loop_Get_Index (loop)
     PTR_BFND loop;
{
  PTR_SYMB index = NULL;
  
  index = BIF_SYMB (loop);
  return (index);
}



/* look for a scope to declare */
PTR_BFND
  Get_Scope_For_Declare(scope)
PTR_BFND scope;
{
  
  PTR_BFND temp;
  
  temp = scope;
  while(temp)
    {
      if ((BIF_CODE(temp) == PROC_HEDR) ||
          (BIF_CODE(temp) == PROG_HEDR) ||
          (BIF_CODE(temp) == GLOBAL) ||
          (BIF_CODE(temp) == FUNC_HEDR))
        break;
      temp = BIF_CP(temp);
    }
  return(temp);
}

PTR_BFND
  Get_Scope_For_Label(scope)
PTR_BFND scope;
{
  
  PTR_BFND temp;
  
  temp = scope;
  while(temp)
    {
      if ((BIF_CODE(temp) == PROC_HEDR) ||
          (BIF_CODE(temp) == PROG_HEDR) ||
          (BIF_CODE(temp) == GLOBAL) ||
          (BIF_CODE(temp) == FUNC_HEDR))
        break;
      temp = BIF_CP(temp);
    }
  return(temp);
}


PTR_LLND 
  Make_Array_Ref (va_alist)
     va_dcl
{
  register va_list p;
  PTR_LLND first, temp, expr, ref;
  PTR_SYMB symb;
  int nb_dim, i;
    
  va_start (p);
  symb = va_arg (p,PTR_SYMB);
  nb_dim = va_arg (p,int);
  ref = bif_build (ARRAY_REF, NULL, NULL);
  NODE_SYMB (ref) = symb;
  first = NULL;
  for (i = 0;i < nb_dim;i++)
    {
      expr = va_arg (p,PTR_LLND);
      temp = bif_build (EXPR_LIST,NULL,NULL,NULL);
      NODE_OPERAND0 (temp) = expr;
      if (! first) 
        first = NODE_OPERAND0 (ref) = temp;
      else
        first = NODE_OPERAND1 (first) = temp;
    }
  va_end (p);
  return ref;
}


PTR_LLND  
  Make_Array_Ref_With_Tab (symb, nb_dim, tab_expr)
     PTR_SYMB symb;
     int nb_dim;
     PTR_LLND tab_expr[];
{
  PTR_LLND first, temp, ref;
  int i;
    
  ref = bif_build (ARRAY_REF, NULL, NULL);
  NODE_SYMB (ref) = symb;
  first = NULL;
  for (i = 1;i <= nb_dim;i++)
    {
      temp = bif_build (EXPR_LIST,NULL,NULL,NULL);
      NODE_OPERAND0 (temp) = tab_expr [i];
      if (! first) 
        first = NODE_OPERAND0 (ref) = temp;
      else
        first = NODE_OPERAND1 (first) = temp;
    }
  return ref;
}



PTR_BFND
  Declare_Array (scope,name,type,dim,val_dim_sup)
     PTR_BFND scope;
     char *name;
     PTR_TYPE type; /* type de base du tableaux */
     int dim;
     int *val_dim_sup;
{
  PTR_SYMB symbol;
  PTR_BFND decl;
  PTR_LLND expr,list_borne,ll,temp;
  PTR_TYPE type_tab;
  int i;
     
  
  decl = (PTR_BFND) bif_make_node (DIM_STAT);
  type_tab = (PTR_TYPE) bif_make_node (T_ARRAY);
  
  symbol = (PTR_SYMB) bif_build_decl (VARIABLE_NAME, name, type_tab);

  /* pour la declaration */
  list_borne = bif_build(EXPR_LIST,NULL,bif_build_int(val_dim_sup[1]),NULL);
  ll = list_borne;
  for(i=2; i<= dim; i++)
    {
      NODE_OPERAND1(list_borne) = bif_build(EXPR_LIST,NULL,
                                            bif_build_int(val_dim_sup[i]),
                                            NULL);
      list_borne= NODE_OPERAND1(list_borne);
    }
  
  /* on cree le noeud bif de declaration */
  expr = bif_build(EXPR_LIST,NULL,temp = bif_build(ARRAY_REF,type_tab,ll)
                   ,NULL);
  NODE_SYMB(temp) = symbol;
  
  BIF_LL1(decl) = expr;

  /* pour le type */
  list_borne = bif_build(EXPR_LIST,NULL,bif_build_int(val_dim_sup[1]),NULL);
  ll = list_borne;
  for(i=2; i<= dim; i++)
    {
      NODE_OPERAND1(list_borne) = bif_build(EXPR_LIST,NULL,
                                            bif_build_int(val_dim_sup[i]),
                                            NULL);
      list_borne= NODE_OPERAND1(list_borne);
    }

  /* on finie de creer le type */
  TYPE_DIM(type_tab) = dim;
  TYPE_BASE(type_tab) = type;
  TYPE_RANGES(type_tab) = ll;
 
  /* on finie de cree le symbole (scope principalement) */
  SYMB_SCOPE(symbol) = scope;
  
  return decl;
}

/*
 *
 * Cree une liste de bif node representant une procedure
 * Le parametre 1 est une chaine : nom de la procedure
 * Le parametre 2 est le type de la proc 
 * Le parametre 3 est un PTR_BFND : corps de la procedure
 * Le parametre 4 est le nombre de parametre (int)
 * Le parametre 5, ..., : les PTR_SYMB representant les parametres, 
 * suivie de son type 
 *
 */
     
PTR_BFND
  Make_Procedure (va_alist)
      va_dcl
{
  register va_list p;
  PTR_BFND proc, body, decl, cend, last, tempbif;
  char *name;
  PTR_SYMB procsymb, args, firstarg;
  PTR_TYPE typeproc, typearg[MAXARGS];
  PTR_LLND expr,temp;
  int nbargs, i;
  

  va_start (p);
  proc = (PTR_BFND) bif_make_node (PROC_HEDR);
  cend = (PTR_BFND) bif_make_node (CONTROL_END);
  name =  va_arg (p,char *);
  typeproc =  va_arg (p,PTR_TYPE);
  body = va_arg (p,PTR_BFND);
  nbargs = va_arg (p,int);

  if (nbargs >= MAXARGS)
    {
      Message("Sorry To many args in Make_Procedure ",0);
      exit(1);
    }
  
  procsymb = (PTR_SYMB) bif_build_decl (PROCEDURE_NAME, name, typeproc);
  args = NULL;
  firstarg = NULL;
  /* on construit la liste des symboles argument*/
  for (i = 0; i< nbargs; i++)
    {
      if (firstarg)
        {          
          SYMB_LIST(args) = va_arg (p,PTR_SYMB);
          typearg[i] = va_arg (p,PTR_TYPE);
          SYMB_NEXT_DECL(args) = SYMB_LIST(args);
          args = SYMB_LIST(args);
        }      
      else
        {
          firstarg = va_arg (p,PTR_SYMB);
          typearg[i] = va_arg (p,PTR_TYPE);
          args = firstarg;
        }
    }
  BIF_SYMB(proc) = procsymb;
  /* on installe les parametres */
  SYMB_FUNC_PARAM(procsymb) = firstarg;
  SYMB_FUNC_NB_PARAM(procsymb) = nbargs;
  SYMB_FUNC_OUTPUT(procsymb) = (PROCEDURE_NAME == FUNCTION_NAME);
  /* fin d'installation des parametres */
  
  /* on declare maintenant les parametres */
  args = firstarg;
  tempbif = proc;
  
   for (i = 0; i< nbargs; i++)
    {
      if ( TYPE_CODE(typearg[i]) == T_ARRAY)
        {
          decl = (PTR_BFND) bif_make_node (DIM_STAT);
          /* warning should be a copie for the liste of bounds TYPE_RANGES*/
          expr = bif_build(EXPR_LIST,NULL,temp = bif_build(ARRAY_REF,
                                                           typearg[i],
                                                           TYPE_RANGES(typearg[i]))
                           ,NULL);
          NODE_SYMB(temp) = args;
          args =  SYMB_LIST(args);
          BIF_LL1(decl) = expr;
          BIF_CP(decl) = proc;
          Append_In_Blob_Liste1(decl, proc);
          BIF_NEXT(tempbif) = decl;
          BIF_NEXT(decl) = NULL;
          
        } else
          { /* assume a variable */
            decl = (PTR_BFND) bif_make_node (VAR_DECL);
            expr = bif_build(EXPR_LIST,NULL,temp = bif_build(VAR_REF,
                                                             typearg[i],
                                                             args)
                             ,NULL);
            args =  SYMB_LIST(args);
            BIF_LL1(decl) = expr;
            BIF_LL2(decl) = bif_build(TYPE_OP,typearg[i],NULL);
            BIF_CP(decl) = proc;
            Append_In_Blob_Liste1(decl, proc);
            BIF_NEXT(tempbif) = decl;
            BIF_NEXT(decl) = NULL;
          }
      tempbif = decl;      
    }

  /* insertion du corps de la procedure */
  last = NULL;
  if (body)
    {
      last = body;
      for (tempbif = body; tempbif; tempbif = BIF_NEXT(tempbif))
        {
          if (BIF_CP(tempbif) == NULL)
            {
              Append_In_Blob_Liste1(tempbif, proc);
              BIF_CP(tempbif) = proc;
            }
          last = tempbif;
        }
      
      /* on met la thread a jour */
      BIF_NEXT(proc) = body;
    }


  for (tempbif = proc; tempbif; tempbif = BIF_NEXT(tempbif))
    {
      last = tempbif;
    }
  Append_In_Blob_Liste1(cend, proc);
  BIF_CP(cend) = proc;
  if (last)
    {
      BIF_NEXT(last) = cend;
    } else
      BIF_NEXT(proc)  = cend;

  va_end (p);
  return proc;

}


PTR_LLND
  Make_Function_Call (va_alist)
     va_dcl
{
  register va_list p;
  PTR_SYMB symb;
  PTR_TYPE type;
  PTR_LLND func_call, temp, op, last;
  int i,taille; /* nb parametres*/
  
  va_start (p);
  symb = va_arg (p,PTR_SYMB);
  type = va_arg (p,PTR_TYPE);
  taille = va_arg (p,int);
  func_call = bif_build (FUNC_CALL,type,NULL);
  NODE_SYMB (func_call) = symb;

  last = NULL;
  temp = NULL;
  
  for (i=1;i<=taille;i++)
    {
      op = va_arg (p,PTR_LLND);
      temp = bif_build (EXPR_LIST,NULL,op,NULL);
      if (!last) 
        NODE_OPERAND0 (func_call) = temp;
      else
        NODE_OPERAND1 (last) = temp;
      last  = temp;      
    }
  va_end (p);
  return func_call;
}


PTR_LLND
  Make_Function_Call_bis (va_alist)
     va_dcl
{
  register va_list p;
  PTR_SYMB symb;
  PTR_TYPE type;
  PTR_LLND func_call, temp, *op, last;
  int i,taille; /* nb parametres*/
  
  va_start (p);
  symb = va_arg (p,PTR_SYMB);
  type = va_arg (p,PTR_TYPE);
  taille = va_arg (p,int);
  func_call = bif_build (FUNC_CALL,type,NULL);
  NODE_SYMB (func_call) = symb;

  last = NULL;
  temp = NULL;
  
  op = va_arg (p,PTR_LLND *);
  for (i=0;i< taille;i++)
    {
      temp = bif_build (EXPR_LIST,NULL,op[i],NULL);
      if (!last) 
        NODE_OPERAND0 (func_call) = temp;
      else
        NODE_OPERAND1 (last) = temp;
      last  = temp;      
    }
  va_end (p);
  return func_call;
}


PTR_BFND
  Make_Procedure_Call (va_alist)
     va_dcl
{
  register va_list p;
  PTR_BFND proc_call;
  PTR_LLND temp, op,last;
  int i, taille;
   
  va_start (p);
  proc_call = (PTR_BFND) bif_make_node (PROC_STAT);
  BIF_SYMB (proc_call) = va_arg (p,PTR_SYMB);
  taille = va_arg (p,int);

  last = NULL;
  temp = NULL;
  for (i=1;i<=taille;i++)
    {
      op = va_arg (p,PTR_LLND);
      temp = bif_build (EXPR_LIST,NULL,op,NULL);
      if (!last) 
        BIF_LL1 (proc_call) = temp;
      else
        NODE_OPERAND1 (last) = temp;
      last  = temp;      
    }
   va_end (p);
  return proc_call;
}


PTR_LLND
  Make_Linear_Expression (taille,last,symb,coeff)
int taille;
PTR_LLND last;
PTR_SYMB symb[];
PTR_LLND coeff[];
  {
    PTR_LLND linear_expr, vref;
    int i;
    PTR_TYPE type;
    int *res;
    
    linear_expr = NULL;
    
    if (taille == 0)
      return NULL;
    
    type = SYMB_TYPE(symb[0]);
    
    vref = bif_build(VAR_REF,type, symb[0]);    
    res = Evaluate_Expression(coeff[0]);
    if ((res[0] == -1) ||  (res[1] != 1))
      {     
        linear_expr = bif_build (MULT_OP,type,coeff[0],vref);
      }
    else
      linear_expr = vref;
    free(res);

    if (last)
      {
       linear_expr =  bif_build (ADD_OP,type,linear_expr,last); 
      }
    for (i=1;i < taille ;i++)
      {
        vref = bif_build(VAR_REF,type, symb[i]);
        res = Evaluate_Expression(coeff[i]);
        
        if ((res[0] == -1) ||  (res[1] != 1))
          {           
            linear_expr = bif_build (ADD_OP,type,linear_expr, 
                                     bif_build (MULT_OP,type,coeff[i],vref));
          }
        else
          linear_expr = bif_build (ADD_OP,type,linear_expr, vref);
        free(res);
      }
    return linear_expr;
}

PTR_LLND
  Make_Linear_Expression_From_Int (taille,last,symb,coeff)
int taille;
int last;
PTR_SYMB symb[];
int coeff[];
{
  PTR_LLND coef[256], expr;
  PTR_SYMB nsymb[256];
  int i,ntaille;
    
  if ((taille == 0) || (taille >= 256))
    return NULL;
  
  ntaille = 0;
  for (i=0;i < taille ;i++)
      {
        if (coeff[i])
          {
            coef[ntaille] = bif_build_int(coeff[i]);
            nsymb[ntaille] = symb[i];
            ntaille ++;            
          }
      }
  if (last)
    expr=  Make_Linear_Expression (ntaille,bif_build_int(last),nsymb,coef);
  else
    expr= Make_Linear_Expression (ntaille,NULL,nsymb,coef);
  if (expr)
    return expr;
  else
    return bif_build_int(last);
}

/* matrice carre */
PTR_LLND
  Make_Linear_Expression_From_Int_List(taille,last,symb,coeff)
int taille;
int last;
PTR_SYMB symb[];
int *coeff;
{
  int i;
  PTR_LLND resul;
  
  if ((taille == 0) || (taille >= 256))
    return NULL;
  resul = Make_Linear_Expression_From_Int (taille,
                                           NULL,symb,
                                           coeff);
  resul = bif_build(EXPR_LIST, NULL,resul,NULL); 
  for (i=1;i < taille ;i++)
    {
      resul = bif_build(EXPR_LIST, 
                        Make_Linear_Expression_From_Int (taille,
                                                         NULL,symb,
                                                         &(coeff[taille*i])),
                        resul ); 
    }
}


PTR_BFND
Make_Assign (lhs,rhs)
     PTR_LLND lhs, rhs;
{
  PTR_BFND assign;
  
  if ((! lhs) || (! rhs)) return NULL;
  
  assign = (PTR_BFND)bif_make_node (ASSIGN_STAT);
  BIF_LL1 (assign) = lhs;
  BIF_LL2 (assign) = rhs;
  return assign;
}


PTR_BFND
  Make_If_Then_Else (corpsif,corpselse,condition)
PTR_BFND corpsif, corpselse;
PTR_LLND condition;
{
  PTR_BFND debutif, elsif, finif, last;
  
  if (!corpsif)
    {
      Message("cannot build if with no statement",0);
      return NULL;
    }
  
  debutif = (PTR_BFND) bif_make_node (IF_NODE);
  if (corpselse) 
    elsif = (PTR_BFND) bif_make_node (CONTROL_END);
  finif = (PTR_BFND) bif_make_node (CONTROL_END);
  BIF_LL1 (debutif) = condition;
  
  /* warning does not update the BIF_NEXT */
  First_in_List_of_BifNode_blob1(corpsif, debutif);
  First_in_List_of_BifNode_blob2(corpselse, debutif);
  BIF_NEXT(debutif) = corpsif;
  if (corpselse) 
    {           
      Append_in_List_of_BifNode_blob1(elsif,debutif);
      Append_in_List_of_BifNode_blob2(finif,debutif);
      BIF_NEXT(elsif) = corpselse;
      last = Get_Last_Node_List(corpselse);
      BIF_NEXT(last) = finif;
      last = Get_Last_Node_List(corpsif);
      BIF_NEXT(last) = elsif;
    } else
      {
        Append_in_List_of_BifNode_blob1(finif,debutif);
        last = Get_Last_Node_List(corpsif);
	BIF_NEXT(last) = finif;
      }  
  return debutif;
}  
     

int
Declare_Scalar (symb,cp)
     PTR_SYMB symb;
     PTR_BFND cp;
{
  PTR_BFND decl;
  PTR_LLND expr;
  PTR_TYPE type;
  
  if ((symb == NULL) || (cp == NULL))
    return FALSE;
  type=(PTR_TYPE)xmalloc(sizeof(PTR_TYPE));  
  cp = Get_Scope_For_Declare(cp);
  type = SYMB_TYPE(symb);
  if (!type)
    abort();
  decl = (PTR_BFND) bif_make_node (VAR_DECL);
  expr = bif_build(EXPR_LIST,NULL, bif_build(VAR_REF,
                                             type,
                                             symb)
                   ,NULL);
  BIF_LL1(decl) = expr;
  BIF_LL2(decl) = bif_build(TYPE_OP,type,NULL);
  BIF_CP(decl) = cp;
  First_In_Blob_Liste1(decl, cp);
  BIF_NEXT(decl) = BIF_NEXT(cp);
  BIF_NEXT(cp) = decl;

  return TRUE;
}


int 
  Perfectly_Nested (loop)
    PTR_BFND loop;
{
  int i = 0;
  PTR_BFND temp = loop;
  
  if (!loop)
    return 0;

  while (temp && BIF_NEXT (temp) &&
	 (BIF_CODE (BIF_NEXT (temp)) == FOR_NODE) &&
	 (BIF_CODE (temp) == FOR_NODE) 
	 && (Is_Good_Loop (temp)) &&
	 (blob_list_length(BIF_BLOB1 (temp)) == 2))
    {
      i++;
      temp = BIF_NEXT (temp);
    }
  
  if (temp &&
      (BIF_CODE (temp) == FOR_NODE) && 
      (Is_Good_Loop (temp)))
    i++;
  return  i;
}

int
  Is_Good_Loop (loop)
     PTR_BFND loop;
{
  PTR_BFND bif;
  
  if (BIF_CODE (loop) != FOR_NODE) 
    return FALSE;

  bif = Get_Last_Node_Of_Stmt (loop);
  if (BIF_CODE (bif) != CONTROL_END)
    return FALSE;
  else 
    return TRUE;
}


PTR_BFND 
  Extract_Loop_Body (b)
PTR_BFND b;
{
  PTR_BFND body, before_cend;
  
  if (!b)
    return NULL;
  
   before_cend = Get_Node_Before(Get_Last_Node_Of_Stmt(b));
  /* on enleve le corps de la boucle la plus interne */

  if (before_cend != b)
    body =  Extract_Bif_Section (BIF_NEXT(b), before_cend);
  else
    body =  NULL;
  
  return body;
}

PTR_BFND 
  Get_Next_Nested_Loop (b)
PTR_BFND b;
{
  PTR_BLOB blob;
  
  for(blob = BIF_BLOB1(b) ; blob; blob = BLOB_NEXT(blob))
    {
      if (BIF_CODE(BLOB_VALUE(blob)) == FOR_NODE)
        return(BLOB_VALUE(blob));
    }
  return(NULL);
}

PTR_BFND 
Get_Internal_Loop (b)
     PTR_BFND b;
{
  PTR_BFND loop;
  int nb;
  
  nb = Perfectly_Nested (b);
  loop = b;
  while (Get_Next_Nested_Loop(loop) && nb)
    {
      loop = Get_Next_Nested_Loop(loop);
      nb --;
    }
  
  return loop;
}


PTR_BFND 
  Get_Previous_Nested_Loop (b)
PTR_BFND b;
{
  PTR_BFND loop;
  
  if (!b) return NULL;
  
  loop = BIF_CP(b);
  while(loop)
    {
      if (BIF_CODE(loop) == FOR_NODE)
        return loop;       
      if (BIF_CODE(loop) == GLOBAL)
        return NULL;
      loop = BIF_CP(loop);      
    }        
  return(NULL);
}


PTR_BLOB
Get_Label_UD_chain(label,scope)
     PTR_LABEL label;
     PTR_BFND scope;     
{
  PTR_BFND func, last, temp;
  PTR_BLOB blob, first;
  PTR_LABEL tl;
  
  if (!label)
    return NULL;
  

  func = Get_Scope_For_Label(scope);
  if (!func)
    return NULL;
  last = Get_Last_Node_Of_Stmt (func);
  
  blob = NULL;
  first = NULL;
  for (temp = func; temp && (temp != last); temp= BIF_NEXT(temp))
    {
      tl = BIF_LABEL_USE(temp);      
      if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
        tl = NODE_LABEL(BIF_LL3(temp));
      
      if (tl && (LABEL_STMTNO(tl) == LABEL_STMTNO(label)))
        {
          if (blob)
            {              
              BLOB_NEXT(blob) = (PTR_BLOB) bif_make_node (BLOB_KIND);
              blob = BLOB_NEXT(blob);
              BLOB_VALUE(blob) = temp;              
            } else
              {
                blob = (PTR_BLOB) bif_make_node (BLOB_KIND);
                BLOB_VALUE(blob) = temp;  
                first = blob;
              }
        }
    }
  return first;
}

int
Convert_Loop (loop)
     PTR_BFND loop;
{
  PTR_BFND cend, bif, lastcend;
  PTR_BLOB blob, list_ud;
  PTR_LABEL label;
  PTR_CMNT comment;
  
  
  if (! loop) 
    return 0;

  if (BIF_CODE (loop) != FOR_NODE)
    return 0;
  
   if (!Is_Good_Loop (loop))
    {
      bif = Get_Last_Node_Of_Stmt (loop);
      if (!bif)
        return 0; 
      while (BIF_CODE(bif) == FOR_NODE)
        {          
          /* because of continue stmt shared by loops */
          bif = Get_Last_Node_Of_Stmt (bif);
          if (!bif)
            return 0; 
        }
      if (BIF_CODE (bif) == CONT_STAT)
        {
          if (BIF_LABEL (bif) != NULL) 
            {
              label = BIF_LABEL(bif);
              if (BIF_LABEL_USE (loop) && 
                  (LABEL_STMTNO(BIF_LABEL_USE (loop)) == LABEL_STMTNO(label))) 
                {                 
                  list_ud = Get_Label_UD_chain(label,loop);                  
                  if (blob_list_length(list_ud) <= 1)
                    {
                      cend = (PTR_BFND) bif_make_node (CONTROL_END);
                      BIF_CP (cend) = loop;
                      BIF_LABEL_USE (loop) = NULL;
                      BIF_CMNT(cend) = BIF_CMNT(bif);
                      bif = Delete_Bif_Node (bif);                       
                      Insert_List_of_BifNode (cend,bif,loop);
                    } else
                      { /* more than on uses of the label check if ok */
                        for (blob = list_ud ;blob; 
                             blob = BLOB_NEXT (blob))
                          {
                            if (!BLOB_VALUE(blob) ||
                                (BIF_CODE(BLOB_VALUE(blob)) !=  FOR_NODE)) 
                              return 0;                            
                          }
                        /* we insert as much enddo than necessary */
                        comment = BIF_CMNT(bif);  
                        bif = Delete_Bif_Node (bif);
                        lastcend = bif;                        
                        for (blob = list_ud;blob; 
                             blob = BLOB_NEXT (blob))
                          {
                            if (BLOB_VALUE(blob) && 
                                (BIF_CODE(BLOB_VALUE(blob)) == FOR_NODE))
                              {
                                BIF_LABEL_USE (BLOB_VALUE(blob)) = NULL;
                                cend = (PTR_BFND) bif_make_node (CONTROL_END);
                                BIF_CMNT(cend) = comment;
                                comment = NULL;                                
                                BIF_CMNT(bif) = NULL;
                                Insert_List_of_BifNode (cend,lastcend,
                                                        BLOB_VALUE(blob));
                                /*lastcend = Get_Node_Before(cend); */
                              }
                          }
                      }
                  return 1;                  
                }
              else
                return 0;  /* something is wrong the label is not the same */
            }         
          else
            { /* should not appear CONTINUE without label */
              BIF_CMNT(cend) = BIF_CMNT(bif);
              bif = Delete_Bif_Node (bif);
              Insert_List_of_BifNode (cend,bif,loop);
              return 0; 
            }
              
        }     
      else 
        { /* this not a enddo or a cont stat; probably a statement */
          label = BIF_LABEL(bif);
          list_ud = Get_Label_UD_chain(label,loop);  
          if (label && blob_list_length(list_ud) <= 1)
            {
              cend = (PTR_BFND) bif_make_node (CONTROL_END);
              Insert_List_of_BifNode (cend,bif,loop);
              BIF_LABEL (bif) = NULL;
              BIF_LABEL_USE (loop) = NULL;
            } else
              return 0;
        }
      return 1;
    }  
  else
    return 1;
 }


int 
  Loop_Conversion (loop)
PTR_BFND loop;
{
  return Apply_To_Bif (loop, Convert_Loop);
}

  

/* Cette procedure genere un nouveau symbole pour le type donne qui peut   *
 * etre soit un entier, reel, caractere , tableau                          */

PTR_SYMB 
  Generate_Variable_Name (bif, type)
PTR_BFND bif;
PTR_TYPE type;
{
  PTR_BFND scope;
  PTR_SYMB symb;
  int nb, max = 0;
  char name [10], charnb [10];
  
  if (NB_VARIABLE == 0)
    {
      nb = 0;      
      for (symb = PROJ_FIRST_SYMB (cur_proj); symb; symb = SYMB_NEXT (symb))
        {
          
          if (SYMB_IDENT(symb) && (strncmp(SYMB_IDENT (symb),"X$",2) == 0))
            if (sscanf (SYMB_IDENT (symb),"X$%d",&nb) != 0) /*res de scanf ?*/
              if (nb > max) max = nb;
        }
      NB_VARIABLE = max;      
    }
  sprintf (charnb,"%d",++NB_VARIABLE);
  strcpy (name,"X$");
  strcat (name,charnb);
  symb = (PTR_SYMB) bif_build_decl (VARIABLE_NAME,name,type);
  scope = Get_Scope_For_Declare (bif);
  SYMB_SCOPE (symb) = scope;
  return symb;
}

PTR_SYMB
  Install_Variable (bif, type)
PTR_BFND bif;
PTR_TYPE type;
{
  PTR_SYMB symb;
  
  symb = Generate_Variable_Name (bif, type);
  Declare_Scalar (symb, bif);
  return symb;
}



int 
  Verif_Func (low)
     PTR_LLND low;
{

  if (! low) 
    return FALSE;
  if (NODE_CODE(low) == FUNC_CALL)
    return TRUE;
  return (Verif_Func (NODE_OPERAND0(low)) ||
          Verif_Func (NODE_OPERAND1 (low)));
}


int 
  Verif_Assign (loop)
     PTR_BFND loop;
{
   
  int code ,func;
  PTR_BFND temp,last;
  
  last = loop;
  while (last)
    {      
      last = Get_Last_Node_Of_Stmt(last);
      if (last && !BIF_BLOB1(last))
        break;
    }
  if (!last)
    return FALSE;
    
  if (loop)
    {      
      for (temp = loop; temp && (temp != last); temp = BIF_NEXT (temp))
        {
          code = BIF_CODE(temp);
          if (code == ASSIGN_STAT)
            {
              func = Verif_Func (NODE_OPERAND0 (temp)) || 
                Verif_Func (NODE_OPERAND1 (temp));
              if (func) return FALSE;
            }
          else
            if ((code != FOR_NODE) && (code != CONTROL_END) &&
                (code != CONT_STAT))
              return FALSE;
        }
    } else
      return FALSE;
  return TRUE;
}



int 
  Verif_Assign_If (loop)
     PTR_BFND loop;
{
   
  int code ,func;
  PTR_BFND temp, last;
  
   
  last = loop;
  while (last)
    {      
      last = Get_Last_Node_Of_Stmt(last);
      if (last && !BIF_BLOB1(last))
        break;
    }
  if (!last)
    return FALSE;
  
  for (temp = loop; temp != last; temp = BIF_NEXT (temp))
       {
        code = BIF_CODE(temp);
        if (code == ASSIGN_STAT)
          {
            func = Verif_Func (NODE_OPERAND0 (temp)) ||
              Verif_Func (NODE_OPERAND1 (temp));
            if (func) return FALSE;
          }
       else
         if ((code != FOR_NODE) && (code != CONTROL_END) &&
             (code != CONT_STAT) && (code != IF_NODE))
           return FALSE;
      }
  return TRUE;
}

        
int
Generate_Alternative_Code(temp,cond)
     PTR_LLND cond;
     PTR_BFND temp;
{
  PTR_BFND where,cp,theif,theloop1,theloop2,last;

  where = Get_Node_Before(temp);
  cp = BIF_CP(temp);
  if (!cp || ! where)
     return FALSE;
  
  if(BIF_CODE(cp) == GLOBAL)
    return FALSE;

  last = Get_Last_Node_Of_Stmt(temp);
  theloop1 = Extract_Bif_Section (temp,last);
  theloop2 = Duplicate_stmts(theloop1);
  theif = Make_If_Then_Else (theloop1,theloop2,cond);
  Insert_List_of_BifNode(theif,where, NULL);
  return TRUE;
}

void
Localize_Array_Section(loop,ll, update_needed)
     int  update_needed;
     PTR_BFND loop;
     PTR_LLND ll; /* ARRAY SECTION IN FORTRAN */
{
  int i,j;
  PTR_LLND inf[10],sup[10], temp,theref,indexlist;
  PTR_BFND assign, init, assign2,body;
  PTR_SYMB arraysymb, local;
  PTR_SYMB symbs[10];  
  PTR_TYPE type_int;
  char name[256];
  PTR_BFND last;

  int nb; /* number of dimension */

  type_int = Return_to_me_type(T_INT);
  
  if (!loop || !ll)
    return;

  if (NODE_CODE(ll) != ARRAY_REF)
    return;
  if (BIF_CODE(loop) != FOR_NODE)
    return;
  
  arraysymb = NODE_SYMB(ll);
  nb = bif_list_length_expr_list(NODE_OPERAND0 (ll));
  
  if ((nb == 0) || (nb > 3))
    return;
  for (j = 0; j < nb; j++)
    { 
      symbs[j] =  Generate_Variable_Name (BIF_CP(loop),type_int );
      Declare_Scalar(symbs[j],BIF_CP(loop));
    }
  
  temp = NODE_OPERAND0 (ll);
  for (j = 0; j < nb; j++)
    { 
      if (NODE_OPERAND0 (temp) && (NODE_CODE(NODE_OPERAND0 (temp)) == DDOT))
	{
	  inf[j] = NODE_OPERAND0(NODE_OPERAND0(temp));
	  sup[j] = NODE_OPERAND1(NODE_OPERAND0(temp));
	}
	else
	  {
	    Message("Localize_Array_Section not array expression",0);
	    return;
	  }
      temp = NODE_OPERAND1(temp); 
    }

  sprintf(name,"Temp_%s",SYMB_IDENT(arraysymb));
  local = bif_build_decl (VARIABLE_NAME,name,type_int);


  body = Extract_Loop_Body(loop);/* for Look_for_Arrayref_In_Section 
				    need that*/
  
  /* change in the loop body  the reference to the variable */
  temp = Look_for_Arrayref_In_Section(body,arraysymb);
  while(temp)
    {
      theref = NODE_OPERAND0(temp);
      NODE_SYMB(theref) = local;
      indexlist = NODE_OPERAND0(theref);
      for (j = 0; j < nb; j++)
	{ 
	  if (indexlist)
	    {
	      NODE_OPERAND0(indexlist) = bif_build(SUBT_OP,type_int,
						   NODE_OPERAND0(indexlist),
						   inf[j]);	      
	      indexlist = NODE_OPERAND1(indexlist);
	    }
	}
      temp = NODE_OPERAND1(temp);
    }
  Insert_List_of_BifNode (body ,loop, loop);

  /* need to make the assign statement */
  switch (nb)
    {
    case 1:
     assign = Make_Assign(Make_Array_Ref(local,nb,
				      bif_build(SUBT_OP,type_int,inf[0],
				        bif_build(VAR_REF,type_int,symbs[0]))),
			  Make_Array_Ref(arraysymb,nb,
				       bif_build(VAR_REF,type_int,symbs[0])));
     if (update_needed)
       assign2 = Make_Assign(Make_Array_Ref(arraysymb,nb,
			        bif_build(VAR_REF,type_int,symbs[0])),
		    Make_Array_Ref(local,nb,
				   bif_build(SUBT_OP,type_int,inf[0],
				  bif_build(VAR_REF,type_int,symbs[0]))));
      break;
    case 2:
     assign = Make_Assign(Make_Array_Ref(local,nb,
				      bif_build(SUBT_OP,type_int,inf[0],
				        bif_build(VAR_REF,type_int,symbs[0])),
				      bif_build(SUBT_OP,type_int,inf[1],
				        bif_build(VAR_REF,type_int,symbs[1]))
					 ),
			  Make_Array_Ref(arraysymb,nb,
				    bif_build(VAR_REF,type_int,symbs[0]),
				    bif_build(VAR_REF,type_int,symbs[1])));
     if (update_needed)
       assign2 = Make_Assign(Make_Array_Ref(arraysymb,nb,
				    bif_build(VAR_REF,type_int,symbs[0]),
				    bif_build(VAR_REF,type_int,symbs[1])),
			     Make_Array_Ref(local,nb,
				      bif_build(SUBT_OP,type_int,inf[0],
				        bif_build(VAR_REF,type_int,symbs[0])),
				      bif_build(SUBT_OP,type_int,inf[1],
				        bif_build(VAR_REF,type_int,symbs[1]))
					 ));
      break;
    case 3:
     assign =  Make_Assign(Make_Array_Ref(local,nb,
				      bif_build(SUBT_OP,type_int,inf[0],
				        bif_build(VAR_REF,type_int,symbs[0])),
				      bif_build(SUBT_OP,type_int,inf[1],
				        bif_build(VAR_REF,type_int,symbs[1])),
				      bif_build(SUBT_OP,type_int,inf[2],
				        bif_build(VAR_REF,type_int,symbs[2]))
					 ),
			   Make_Array_Ref(arraysymb,nb,
				    bif_build(VAR_REF,type_int,symbs[0]),
				    bif_build(VAR_REF,type_int,symbs[1]),
				    bif_build(VAR_REF,type_int,symbs[2])));
     if (update_needed)
       assign2 = Make_Assign(Make_Array_Ref(arraysymb,nb,
				    bif_build(VAR_REF,type_int,symbs[0]),
				    bif_build(VAR_REF,type_int,symbs[1]),
				    bif_build(VAR_REF,type_int,symbs[2])),
			     Make_Array_Ref(local,nb,
				      bif_build(SUBT_OP,type_int,inf[0],
				        bif_build(VAR_REF,type_int,symbs[0])),
				      bif_build(SUBT_OP,type_int,inf[1],
				        bif_build(VAR_REF,type_int,symbs[1])),
				      bif_build(SUBT_OP,type_int,inf[2],
				        bif_build(VAR_REF,type_int,symbs[2]))
					 ));
      break;
    default:
      Message("In localize Array too many dimension ",0);
      return;
    }
  
  /* now make the loop */
  init = assign;
  for (i = nb -1 ; i>=0; i--)
    { /* on cree les boucles */
      init = Make_For_Loop(symbs[i],inf[i], sup[i], NULL, init);           
    }

  /* insert in the loop */
  last = Get_Node_Before(loop);
  Insert_List_of_BifNode (init, last, NULL);
  
  
  if (update_needed)
    { 
      init = assign2;
      for (i = nb -1 ; i>=0; i--)
	{ /* on cree les boucles */
	  init = Make_For_Loop(symbs[i],inf[i], sup[i], NULL, init);           
	}
      last = Get_Last_Node_Of_Stmt(loop);
      Insert_List_of_BifNode (init, last, NULL);
    }

}


int 
  Check_Index (bif)
   PTR_BFND bif;
{
  PTR_SYMB varindex;
  PTR_LLND borne_inf, borne_sup, step; 
  PTR_BFND prev;

  if (!bif)
     return FALSE;

  if (BIF_CODE (bif) != FOR_NODE) 
    return FALSE;
  
  prev = Get_Previous_Nested_Loop (bif);

  borne_inf = Loop_Get_Borne_Inf (bif);
  borne_sup = Loop_Get_Borne_Sup (bif);
  step = Loop_Get_Step (bif);
  while (prev)
    {
      varindex = Loop_Get_Index (prev);
      if (Is_Var_In_Expression (borne_inf, varindex) ||
          Is_Var_In_Expression (borne_sup, varindex) ||
          Is_Var_In_Expression (step, varindex))
        return TRUE;
      prev = Get_Previous_Nested_Loop (prev);
    }

  return FALSE;
}



int 
  Check_Right_Assign (bif)
     PTR_BFND bif;
{
  PTR_BFND prev;
  PTR_SYMB varindex;
  PTR_LLND expr;
  
  if (!bif) 
    return FALSE;
  
  if (BIF_CODE (bif) != ASSIGN_STAT)
    return FALSE;
  
  expr = BIF_LL2 (bif);
  prev = Get_Previous_Nested_Loop (bif);
 
  while (prev)
    {
      varindex = Loop_Get_Index (prev);
      if (Is_Var_In_Expression (expr, varindex))
        return TRUE;
      prev = Get_Previous_Nested_Loop (prev);
    }
  return FALSE;
}


int 
  Check_Left_Assign (bif)
     PTR_BFND bif;
{
 PTR_BFND prev;
 PTR_SYMB varindex, varbif;
 PTR_LLND expr;
 
 if (!bif) 
   return FALSE;
  
 if (BIF_CODE (bif) != ASSIGN_STAT)
   return FALSE;
 
 expr = BIF_LL1 (bif);
  if (NODE_CODE (expr) != VAR_REF)
   return FALSE;
 varbif = NODE_SYMB (expr);
 
  prev = Get_Previous_Nested_Loop (bif);
  
 while (prev)
   {
     varindex = Loop_Get_Index (prev);
     if (varbif == varindex)
       return TRUE;
     prev = Get_Previous_Nested_Loop (prev);
   }
 return FALSE;
}
                    

int 
  No_Dependent_Index (loop)
     PTR_BFND loop;
{
  
  return !Apply_To_Bif (loop, Check_Index);
}



int 
  No_Basic_Induction (loop)
     PTR_BFND loop;
{
  return ! Apply_To_Bif (loop, Check_Right_Assign);
}

     
int 
  No_Def_Of_Induction (loop)
     PTR_BFND loop;
{
  return !Apply_To_Bif (loop, Check_Left_Assign);
}



/****************************** Added by D.Windheiser ************************/



Is_Parameter_of_Func(symb,decl_bf)
     PTR_BFND* decl_bf;
     PTR_SYMB symb;
{
  PTR_BFND func;
  PTR_SYMB funcsymb;

  *decl_bf = NULL;
  func = SYMB_SCOPE(symb);
  if ((BIF_CODE(func) != PROC_HEDR) &&
      (BIF_CODE(func) != FUNC_HEDR))
    return FALSE;
  
  if (BIF_SYMB(func))
    {
      for (funcsymb = SYMB_FUNC_PARAM(BIF_SYMB(func));funcsymb;
           funcsymb = SYMB_NEXT_DECL(funcsymb))
        {
          if (funcsymb == symb)
            {
              *decl_bf = func;
              return TRUE;
            }
        }
    } else
      {
        Message("Symbol of function not found",0);
        exit(1);
      }
  return FALSE;
}

Look_For_Ref_In_Expr(expr, symb)
     PTR_SYMB symb;
     PTR_LLND expr;
{
  if (!expr)
    return FALSE;

  if ((NODE_CODE(expr) == VAR_REF) || (NODE_CODE(expr) == ARRAY_REF))
    {
      if (NODE_SYMB(expr) == symb)
        return TRUE;
    }
  
  return (Look_For_Ref_In_Expr(NODE_OPERAND0(expr), symb) ||
          Look_For_Ref_In_Expr(NODE_OPERAND1(expr), symb));
}

Is_Common_Var(symb,decl_bf)
     PTR_BFND* decl_bf;
     PTR_SYMB symb;
{
  PTR_BFND scope, last,temp;

  *decl_bf = NULL;
  scope = SYMB_SCOPE(symb);
  if (!scope)
    {
      Message("Symbole scope not found",0);
      return FALSE;
    }

  last = Get_Last_Node_Of_Stmt(scope);

  /* no look in section */
  for (temp = scope; temp && (temp!=last) ; temp = BIF_NEXT(temp))
    {
      if (BIF_CODE(temp) == COMM_STAT)
        {/* look in the list of bif_node */
          if (Look_For_Ref_In_Expr(BIF_LL1(temp), symb))
            {
              *decl_bf =  temp;
              return TRUE;
            }
        }
    }
  return FALSE;
}


Is_Local_Var(symb,decl_bf)
     PTR_BFND* decl_bf;
     PTR_SYMB symb;
{
  PTR_BFND scope, last,temp;

  *decl_bf = NULL;
  scope = SYMB_SCOPE(symb);
  if (!scope)
    {
      Message("Symbole scope not found",0);
      return FALSE;
    }

  last = Get_Last_Node_Of_Stmt(scope);

  /* no look in section */
  for (temp = scope; temp && (temp!=last) ; temp = BIF_NEXT(temp))
    {
      if ((BIF_CODE(temp) == VAR_DECL) || 
          (BIF_CODE(temp) == DIM_STAT))
        {/* look in the list of bif_node */
          if (Look_For_Ref_In_Expr(BIF_LL1(temp), symb))
            {
              *decl_bf =  temp;
              return TRUE;
            }
        }
    }
  return FALSE;
}
/*
Encore une autre fonction qui me semble utile:
var_storage permet de  determiner si une variable
dont le symbole est sy est une variable locale (0), un argument (1)
ou un common (2) et decl_bf pointe sur la declaration pour
une variable locale, la fonction  ou la routine pour une
variable locale et le common pour une variable common.
*/

int
var_storage(sy, decl_bf)
     PTR_SYMB sy;
     PTR_BFND* decl_bf;
{
  if (!sy)
    return -1;

  if (Is_Parameter_of_Func(sy, decl_bf))
    return 1;
  if (Is_Common_Var(sy,decl_bf))
     return 2;
  if (Is_Local_Var(sy,decl_bf))
    return 0;

  return -1;
}
