/* Copyright (C) 1992, Irisa, Indiana University,
   demo of the Sigma toolbox */
 /**************************************************************************
  *                                                                        *
  *   Programme de Test pour la ToolBox                                    *
  *                                                                        *
  *************************************************************************/

#include <stdio.h>
#include "macro.h"
#include "dependence.h"
#include "ext_lib.h"
#include "ext_low.h"
#include "ext_mid.h"
#include "ext_high.h"
/*static FILE *finput;
static FILE *outfile;*//*modified by yrq 5.13.94*/
static int TabNumber =0;
static int Number_Of_Flag = 0;
#define MAXFLAG 64
#define  MAXLFLAG 256
static char TabOfFlag[MAXFLAG][MAXLFLAG];
static int  FlagLenght[MAXFLAG];
static int  FlagOn[MAXFLAG];
#define MAXLENGHTBUF 750000
static int Buf_pointer = 0;
static char UnpBuf[MAXLENGHTBUF];
static char *Buf_address;


/* usage exemple
    Init_Unparser(); or Reset_Unparser(); if Init_Unparser(); has been done

    fprintf(outfile,"%s",Tool_Unparse_Bif(PROJ_FIRST_BIF ()));
*/

/*****************************************************************************/
/*****************************************************************************/
/*****                                                                   *****/
/*****    UNPARSE.C:     Gregory HOGDAL / Eric MARCHAND    July 1992     *****/
/*****    Modified F. Bodin 08/92                                        *****/
/*****                                                                   *****/
/*****************************************************************************/
/*****************************************************************************/

/***********************************/
/* function de unparse des bif node */
/***********************************/

#include "f90.h"

typedef struct 
{
  char *str;
  char *(* fct)();
} UNP_EXPR;


static UNP_EXPR Unparse_Def[LAST_CODE];

/************ Unparse Flags **************/
static int In_Write_Flag = 0;
static int In_Param_Flag = 0;
static int In_Impli_Flag = 0;
/*****************************************/

/*************** TYPE names in ASCII form ****************/
static char *ftype_name[] = {"integer",
                             "real",
                             "double precision",
                             "character",
                             "logical",
                             "character",
                             "gate",
                             "event",
                             "sequence",
                             "",
                             "",
                             "",
                             "",
                             "complex"};
/*********************************************************/

/******* Precedence table of operators for Fortran *******/
static char precedence[] = {5,      /* .eq. */
                            5,      /* .lt. */
                            5,      /* .gt. */
                            5,      /* .ne. */
                            5,      /* .le. */
                            5,      /* .ge. */
                            3,      /*  +   */
                            3,      /*  -   */
                            8,      /* .or. */
                            2,      /*  *   */
                            2,      /*  /   */
                            0,      /* none */
                            7,      /* .and. */
                            1,      /*  **  */
                            0,      /* none */
                            4,      /*  //  */
                            8,      /* .xor. */
                            9,      /* .eqv. */
                            9,     /* .neqv. */
                            1,     /* Minus_op*/
                            1      /* not op */
                            };

#define type_index(X)   (X-T_INT)                 /* gives the index of a type to access the Table "ftype_name" from a type code */
#define binop(n)    (n >= EQ_OP && n <= NEQV_OP)  /* gives the boolean value of the operation "n" being binary (not unary) */

/* manage the unparse buffer */


char *create_unp_str(str)
     char *str;
{
  char *pt;

  if (!str)
    return NULL;
    
  pt = (char *) xmalloc(strlen(str)+1);
  bzero(pt, strlen(str)+1);
  strcpy(pt,str);
  return pt;
}     


char *alloc_str(size)
     int size;
{
  char *pt;

  if (!(size++)) return NULL;
  pt = (char *) xmalloc(size);
  bzero(pt, size);
  return pt;
}     

Reset_Unparser()
{
  int i;

  /* initialize the number of flag */
  Number_Of_Flag = 0;
  for (i=0; i < MAXFLAG ; i++)
    {
      TabOfFlag[i][0] = '\0';
      FlagLenght[i] = 0;
      FlagOn[i] = 0;
    }
  /* setbuffer to 0 */
  Buf_pointer = 0;  
  Buf_address = &(UnpBuf[0]); /* may be reallocated */
  bzero(UnpBuf,MAXLENGHTBUF);
}

Init_Unparser()
{
  int i;
  

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) Unparse_Def[SYM].str = create_unp_str( NAME);
#include"unparse.def"
#undef DEFNODECODE

#define DEFNODECODE(SYM, NAME, TYPE, LENGTH, NT) Unparse_Def[SYM].fct = NULL;
#include"unparse.def"
#undef DEFNODECODE
  /* initialize the number of flag */
  Number_Of_Flag = 0;
  for (i=0; i < MAXFLAG ; i++)
    {
      TabOfFlag[i][0] = '\0';
      FlagLenght[i] = 0;
      FlagOn[i] = 0;
    }
  /* setbuffer to 0 */
  Buf_pointer = 0;  
  Buf_address = &(UnpBuf[0]); /* may be reallocated */
  bzero(UnpBuf,MAXLENGHTBUF);
}

/* function to manage the unparse buffer */

BufPutChar(c)
     char c;
{
  if (Buf_pointer >= MAXLENGHTBUF)
    {
      Message("Unparse Buffer Full",0);
      return 0;
    }
  Buf_address[Buf_pointer] = c;
  Buf_pointer++;
  return 1;
}

BufPutString(s,len)
     char *s;
     int len;
{
  int lenght;
  lenght = len;
  if (lenght <= 0)
    lenght  = strlen(s);
  
  if (Buf_pointer + lenght>= MAXLENGHTBUF)
    {
      Message("Unparse Buffer Full",0);
      return 0;
    }
  strncpy(&(Buf_address[Buf_pointer]),s,lenght);
  Buf_pointer += lenght;
  return 1;
}


BufPutInt(i)
     int i;
{
  int lenght;
  char s[MAXLFLAG];
  
  sprintf(s,"%d",i);
  lenght = strlen(s);
  
  if (Buf_pointer + lenght>= MAXLENGHTBUF)
    {
      Message("Unparse Buffer Full",0);
      return 0;
    }
  strncpy(&(Buf_address[Buf_pointer]),s,lenght);
  Buf_pointer += lenght;
  return 1;
}

Get_Flag_val(str, i)
     char  *str;
     int *i;
{
  int j, con;
  char sflag[MAXLFLAG];
  (*i)++; /* skip the paranthesis */  
  /* extract the flag name */
  j = *i;
  con = 0;
  
  while ((str[j]  != '\0') && (str[j]  != ')'))
    {
      sflag[con] = str[j];      
      con ++;      
      j ++;
    }
  sflag[con] = '\0';
  con ++; 
  
  /* look in table if flag is in */
  
  for (j = 0 ;  j < Number_Of_Flag; j++)
    {
      if (strncmp(TabOfFlag[j],sflag, con) == 0)
          break;
    }
  *i += con;      
  if (j >= Number_Of_Flag)
    {
      /* not found  */
      return 0;
    }
  else          
    return FlagOn[j];

}

Treat_Flag(str, i, val)
     char  *str;
     int *i;
     int val;     
{
  int j, con;
  char sflag[MAXLFLAG];
  (*i)++; /* skip the paranthesis */  
  /* extract the flag name */
  j = *i;
  con = 0;
  
  while ((str[j]  != '\0') && (str[j]  != ')'))
    {
      sflag[con] = str[j];      
      con ++;      
      j ++;
    }
  sflag[con] = '\0';
  con ++; 
  
  /* look in table if flag is in */
  
  for (j = 0 ;  j < Number_Of_Flag; j++)
    {
      if (strncmp(TabOfFlag[j],sflag, con) == 0)
          break;
    }
      if (j >= Number_Of_Flag)
        {
          /* not found  */
          strcpy(TabOfFlag[Number_Of_Flag],sflag);
          FlagOn[Number_Of_Flag] = val;
          FlagLenght[Number_Of_Flag] = con-1;
          Number_Of_Flag++;          
        } else
          FlagOn[j] = val;
      *i += con;      
}

char *
Tool_Unparse_Symbol (symb)
     PTR_SYMB symb;
{
  if (!symb)
    return NULL;
  BufPutString (SYMB_IDENT(symb),0);
}


typedef struct
{
  int typ;
  union {char *S;
         int  I;
        } val;
} operand;

/* macro def. of operand type */
#define UNDEF_TYP   0
#define STRING_TYP  1
#define INTEGER_TYP 2

/* macro def. of comparison operators */
#define COMP_UNDEF -1 /* Bodin */
#define COMP_EQUAL 0
#define COMP_DIFF  1



Get_Type_Operand (str, iptr, ptype,Op)
     char *str;
     int *iptr;
     PTR_TYPE ptype;
     operand *Op;
{

  Op->typ = UNDEF_TYP;
  if (strncmp(&(str[*iptr]),"%STRCST", strlen("%STRCST"))== 0)               /* %STRCST : String Constant */
    {
      int i_save;

      *iptr += strlen("%STRCST");
      while (str[*iptr] == ' ') {(*iptr)++;} /* skip spaces before string */
      if (str[*iptr] != '\'')
        {
          Message (" *** Missing \"'\" after %STRCST *** ",0);
        }
      i_save = ++(*iptr);
      while ((str[*iptr] != '\0') && (str[*iptr] != '\'')) (*iptr)++;
      Op->val.S = alloc_str ((*iptr) - i_save);
      strncpy (Op->val.S, &(str[i_save]), (*iptr) - i_save);
      Op->typ = STRING_TYP;
    } else
  if (strncmp(&(str[*iptr]),"%NULL", strlen("%NULL"))== 0)                   /* %NULL : Integer Constant (or false boolean) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = 0;
      *iptr += strlen("%NULL");
    } else
  if (strncmp(&(str[*iptr]),"%INIMPLI", strlen("%INIMPLI"))== 0)             /* %INIMPLI : In_Impli_Statement (integer / boolean flag) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = In_Impli_Flag;
      *iptr += strlen("%INIMPLI");
    } else
      {
        Message (" *** Unknown operand in %IF (condition) for Type Node *** ",0);
      }
}

Get_LL_Operand (str, iptr, ll, Op)
     char *str;
     int *iptr;
     PTR_LLND ll;
     operand *Op;
{

  Op->typ = UNDEF_TYP;
  if (strncmp(&(str[*iptr]),"%CHECKFLAG", strlen("%CHECKFLAG"))== 0)  
    {
      Op->typ = INTEGER_TYP;
      *iptr += strlen("%CHECKFLAG");
      Op->val.I = Get_Flag_val(str, iptr);
    } else
  if (strncmp(&(str[*iptr]),"%STRCST", strlen("%STRCST"))== 0)               /* %STRCST : String Constant */
    {
      int i_save;

      *iptr += strlen("%STRCST");
      while (str[*iptr] == ' ') {(*iptr)++;} /* skip spaces before string */
      if (str[*iptr] != '\'')
        {
          Message  (" *** Missing \"'\" after %STRCST *** ",0);
        }
      i_save = ++(*iptr);
      while ((str[*iptr] != '\0') && (str[*iptr] != '\'')) (*iptr)++;
      Op->val.S = alloc_str ((*iptr) - i_save);
      strncpy (Op->val.S, &(str[i_save]), (*iptr) - i_save);
      Op->typ = STRING_TYP;
    } else
  if (strncmp(&(str[*iptr]),"%SYMBOL", strlen("%SYMBOL"))== 0)               /* %SYMBOL : Symbol pointer (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) NODE_SYMB (ll);
      *iptr += strlen("%SYMBOL");
    } else
  if (strncmp(&(str[*iptr]),"%SYMBID", strlen("%SYMBID"))== 0)               /* %SYMBID : Symbol identifier (string) */
    {
      Op->typ = STRING_TYP;
      if (NODE_SYMB (ll))
        Op->val.S = SYMB_IDENT (NODE_SYMB (ll));
      else
        Op->val.S = NULL;
      *iptr += strlen("%SYMBID");
    } else
  if (strncmp(&(str[*iptr]),"%NULL", strlen("%NULL"))== 0)                   /* %NULL : Integer Constant (or false boolean) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = 0;
      *iptr += strlen("%NULL");
    } else
  if (strncmp(&(str[*iptr]),"%LL1", strlen("%LL1"))== 0)                     /* %LL1 : Low Level Node 1 (integer) */
    {
      Op->typ = INTEGER_TYP;      
      Op->val.I = (int) NODE_TEMPLATE_LL1 (ll);
      *iptr += strlen("%LL1");
    } else
  if (strncmp(&(str[*iptr]),"%LL2", strlen("%LL2"))== 0)                     /* %LL2 : Low Level Node 2 (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) NODE_TEMPLATE_LL2 (ll);
      *iptr += strlen("%LL2");
    } else
  if (strncmp(&(str[*iptr]),"%LABUSE", strlen("%LABUSE"))== 0)               /* %LABUSE : label ptr (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) NODE_LABEL (ll);
      *iptr += strlen("%LABUSE");
    } else
  if (strncmp(&(str[*iptr]),"%L1CODE", strlen("%L1CODE"))== 0)               /* %L1CODE : Code (variant) of Low Level Node 1 (integer) */
    {
      Op->typ = INTEGER_TYP;
      if (NODE_TEMPLATE_LL1 (ll))
        Op->val.I = NODE_CODE (NODE_TEMPLATE_LL1 (ll));
      else
        Op->val.I = NULL;
      *iptr += strlen("%L1CODE");
    } else
  if (strncmp(&(str[*iptr]),"%L2CODE", strlen("%L2CODE"))== 0)               /* %L2CODE : Code (variant) of Low Level Node 2 (integer) */
    {
      Op->typ = INTEGER_TYP;
      if (NODE_TEMPLATE_LL2 (ll))
        Op->val.I = NODE_CODE (NODE_TEMPLATE_LL2 (ll));
      else
        Op->val.I = NULL;
      *iptr += strlen("%L2CODE");
    } else
  if (strncmp(&(str[*iptr]),"%INWRITE", strlen("%INWRITE"))== 0)             /* %INWRITE : In_Write_Statement (integer / boolean flag) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = In_Write_Flag;
      *iptr += strlen("%INWRITE");
    } else
  if (strncmp(&(str[*iptr]),"%INPARAM", strlen("%INPARAM"))== 0)             /* %INPARAM : In_Param_Statement (integer / boolean flag) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = In_Param_Flag;
      *iptr += strlen("%INPARAM");
    } else
  if (strncmp(&(str[*iptr]),"%INIMPLI", strlen("%INIMPLI"))== 0)             /* %INIMPLI : In_Impli_Statement (integer / boolean flag) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = In_Impli_Flag;
      *iptr += strlen("%INIMPLI");
    } else
      if (strncmp(&(str[*iptr]),"%L1L2*L1CODE", strlen("%L1L2*L1CODE"))== 0)       /* %L1L2L1CODE : Code (variant) of Low Level Node 1 of Low Level Node 2 of Low Level Node 1 (integer) */
    {
      PTR_LLND temp;
      
      Op->typ = INTEGER_TYP;
      if (NODE_OPERAND0(ll))
        {
          temp = NODE_OPERAND0(ll);
          while (temp && NODE_OPERAND1(temp)) temp =  NODE_OPERAND1(temp);
          if (temp && NODE_OPERAND0(temp))
            Op->val.I = NODE_CODE (NODE_OPERAND0(temp));
          else
            Op->val.I = NULL;
        }
      else
        Op->val.I = NULL;
      *iptr += strlen("%L1L2*L1CODE");
    } else
      {
        Message  (" *** Unknown operand in %IF (condition) for LL Node *** ",0);
      }
}


Get_Bif_Operand (str, iptr, bif,Op)
     char *str;
     int *iptr;
     PTR_BFND bif;
     operand *Op;
{

  Op->typ = UNDEF_TYP;
  if (strncmp(&(str[*iptr]),"%ELSIFBLOB2", strlen("%ELSIFBLOB2"))== 0)  
    {
      Op->typ = INTEGER_TYP;
      *iptr += strlen("%ELSIFBLOB2");
      if (BIF_BLOB2(bif) && (BIF_CODE(BLOB_VALUE(BIF_BLOB2(bif))) == ELSEIF_NODE))
        Op->val.I = 1;
      else
        Op->val.I = 0;      
    } else
  if (strncmp(&(str[*iptr]),"%LABEL", strlen("%LABEL"))== 0)  
    {
      Op->typ = INTEGER_TYP;
      *iptr += strlen("%LABEL");
      Op->val.I = (int) BIF_LABEL(bif);
    } else
  if (strncmp(&(str[*iptr]),"%CHECKFLAG", strlen("%CHECKFLAG"))== 0)  
    {
      Op->typ = INTEGER_TYP;
      *iptr += strlen("%CHECKFLAG");
      Op->val.I = Get_Flag_val(str, iptr);
    } else
  if (strncmp(&(str[*iptr]),"%BLOB1", strlen("%BLOB1"))== 0)  
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) BIF_BLOB1(bif);
      *iptr += strlen("%BLOB1");
    } else
  if (strncmp(&(str[*iptr]),"%BLOB2", strlen("%BLOB2"))== 0)  
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int)  BIF_BLOB2(bif);
      *iptr += strlen("%BLOB2");
    } else
      if (strncmp(&(str[*iptr]),"%BIFCP", strlen("%BIFCP"))== 0)  
        {
          Op->typ = INTEGER_TYP;
          if (BIF_CP(bif))
            Op->val.I = BIF_CODE(BIF_CP(bif));
          else
            Op->val.I = 0;          
          *iptr += strlen("%BIFCP");
        } else
          if (strncmp(&(str[*iptr]),"%VALINT", strlen("%VALINT"))== 0)  
            {
              Op->typ = INTEGER_TYP;              
              Op->val.I = atoi(&(str[*iptr + strlen("%VALINT")]));    /* %VALINT-12232323  space is necessary after the number*/
              /* skip to next statement */
              while (str[*iptr] != ' ') (*iptr)++;
            } else
  if (strncmp(&(str[*iptr]),"%RECURSBIT", strlen("%RECURSBIT"))== 0)         /* %RECURSBIT : Symbol Attribut (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = RECURSIVE_BIT;
      *iptr += strlen("%RECURSBIT");
    } else
  if (strncmp(&(str[*iptr]),"%EXPR_LIST", strlen("%EXPR_LIST"))== 0)         /* %EXPR_LIST : int constant EXPR_LIST code for Low Level Node (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = EXPR_LIST;
      *iptr += strlen("%EXPR_LIST");
    } else
  if (strncmp(&(str[*iptr]),"%SPEC_PAIR", strlen("%SPEC_PAIR"))== 0)         /* %SPEC_PAIR : int constant SPEC_PAIR code for Low Level Node (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = SPEC_PAIR;
      *iptr += strlen("%SPEC_PAIR");
    } else
  if (strncmp(&(str[*iptr]),"%IOACCESS", strlen("%IOACCESS"))== 0)           /* %IOACCESS : int constant IOACCESS code for Low Level Node (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = IOACCESS;
      *iptr += strlen("%IOACCESS");
    } else
  if (strncmp(&(str[*iptr]),"%STRCST", strlen("%STRCST"))== 0)               /* %STRCST : String Constant */
    {
      int i_save;

      *iptr += strlen("%STRCST");
      while (str[*iptr] == ' ') {(*iptr)++;} /* skip spaces before string */
      if (str[*iptr] != '\'')
        {
          Message  (" *** Missing \"'\" after %STRCST *** ",0);
        }
      i_save = ++(*iptr);
      while ((str[*iptr] != '\0') && (str[*iptr] != '\'')) (*iptr)++;
      Op->val.S = alloc_str ((*iptr) - i_save);
      strncpy (Op->val.S, &(str[i_save]), (*iptr) - i_save);
      Op->typ = STRING_TYP;
       (*iptr)++; /* skip the ' */
    } else
  if (strncmp(&(str[*iptr]),"%SYMBOL", strlen("%SYMBOL"))== 0)               /* %SYMBOL : Symbol pointer (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) BIF_SYMB (bif);
      *iptr += strlen("%SYMBOL");
    } else
  if (strncmp(&(str[*iptr]),"%SATTR", strlen("%SATTR"))== 0)                 /* %SATTR : Symbol Attribut (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (BIF_SYMB (bif))->attr;
      *iptr += strlen("%SATTR");
    } else
  if (strncmp(&(str[*iptr]),"%SYMBID", strlen("%SYMBID"))== 0)               /* %SYMBID : Symbol identifier (string) */
    {
      Op->typ = STRING_TYP;
      if (BIF_SYMB (bif))
        Op->val.S = SYMB_IDENT (BIF_SYMB (bif));
      else
        Op->val.S = NULL;
      *iptr += strlen("%SYMBID");
    } else
  if (strncmp(&(str[*iptr]),"%NULL", strlen("%NULL"))== 0)                   /* %NULL : Integer Constant (or false boolean) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = 0;
      *iptr += strlen("%NULL");
    } else
  if (strncmp(&(str[*iptr]),"%LL1", strlen("%LL1"))== 0)                     /* %LL1 : Low Level Node 1 (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) BIF_LL1 (bif);
      *iptr += strlen("%LL1");
    } else
  if (strncmp(&(str[*iptr]),"%LL2", strlen("%LL2"))== 0)                     /* %LL2 : Low Level Node 2 (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) BIF_LL2 (bif);
      *iptr += strlen("%LL2");
    } else
  if (strncmp(&(str[*iptr]),"%LL3", strlen("%LL3"))== 0)                     /* %LL3 : Low Level Node 3 (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) BIF_LL3 (bif);
      *iptr += strlen("%LL3");
    } else
  if (strncmp(&(str[*iptr]),"%LABUSE", strlen("%LABUSE"))== 0)               /* %LABUSE : label ptr (used for do : doend) (integer) */
    {
      Op->typ = INTEGER_TYP;
      Op->val.I = (int) BIF_LABEL_USE (bif);
      *iptr += strlen("%LABUSE");
    } else
  if (strncmp(&(str[*iptr]),"%L1CODE", strlen("%L1CODE"))== 0)               /* %L1CODE : Code (variant) of Low Level Node 1 (integer) */
    {
      Op->typ = INTEGER_TYP;
      if (BIF_LL1 (bif))
        Op->val.I = NODE_CODE (BIF_LL1 (bif));
      else
        Op->val.I = NULL;
      *iptr += strlen("%L1CODE");
    } else
  if (strncmp(&(str[*iptr]),"%L2CODE", strlen("%L2CODE"))== 0)               /* %L2CODE : Code (variant) of Low Level Node 2 (integer) */
    {
      Op->typ = INTEGER_TYP;
      if (BIF_LL2 (bif))
        Op->val.I = NODE_CODE (BIF_LL2 (bif));
      else
        Op->val.I = NULL;
      *iptr += strlen("%L2CODE");
    } else
  if (strncmp(&(str[*iptr]),"%L1L2L1CODE", strlen("%L1L2L1CODE"))== 0)       /* %L1L2L1CODE : Code (variant) of Low Level Node 1 of Low Level Node 2 of Low Level Node 1 (integer) */
    {
      Op->typ = INTEGER_TYP;
      if (BIF_LL1 (bif) && NODE_TEMPLATE_LL2 (BIF_LL1 (bif)) && NODE_TEMPLATE_LL1 (NODE_TEMPLATE_LL2 (BIF_LL1 (bif))))
        Op->val.I = NODE_CODE (NODE_TEMPLATE_LL1 (NODE_TEMPLATE_LL2 (BIF_LL1 (bif))));
      else
        Op->val.I = NULL;
      *iptr += strlen("%L1L2L1CODE");
    } else
      if (strncmp(&(str[*iptr]),"%L1L2*L1CODE", strlen("%L1L2*L1CODE"))== 0)       /* %L1L2L1CODE : Code (variant) of Low Level Node 1 of Low Level Node 2 of Low Level Node 1 (integer) */
    {
      PTR_LLND temp;
      
      Op->typ = INTEGER_TYP;
      if (BIF_LL1 (bif) && NODE_TEMPLATE_LL2 (BIF_LL1 (bif)) && NODE_TEMPLATE_LL1 (NODE_TEMPLATE_LL2 (BIF_LL1 (bif))))
        {
          temp = BIF_LL1 (bif);
          while (NODE_OPERAND1(temp)) temp =  NODE_OPERAND1(temp);
          if (NODE_TEMPLATE_LL1 (temp))
            Op->val.I = NODE_CODE (NODE_TEMPLATE_LL1 (temp));
          else
            Op->val.I = NULL;
        }
      else
        Op->val.I = NULL;
      *iptr += strlen("%L1L2*L1CODE");
    } else
  if (strncmp(&(str[*iptr]),"%L2L1STR", strlen("%L2L1STR"))== 0)             /* %L2L1STR : String (string_val) of Low Level Node 1 of Low Level Node 2 (string) */
    {
      Op->typ = STRING_TYP;
      if (BIF_LL2 (bif) && NODE_TEMPLATE_LL1 (BIF_LL2 (bif)))
        Op->val.S = NODE_STR (NODE_TEMPLATE_LL1 (BIF_LL2 (bif)));
      else
        Op->val.S = NULL;
      *iptr += strlen("%L2L1STR");
    } else
      {
        Message  (" *** Unknown operand in %IF (condition) for Bif Node *** ",0);
      }
}


int
GetComp (str, iptr)
     char *str;
     int *iptr;
{
  int Comp;

  if (strncmp(&(str[*iptr]),"==", strlen("==")) == 0)         /* == : Equal */
    {
      Comp = COMP_EQUAL;
      *iptr += strlen("==");
    } else
  if (strncmp(&(str[*iptr]),"!=", strlen("!=")) == 0)         /* != : Different */
    {
      Comp = COMP_DIFF;
      *iptr += strlen("!=");
    } else
      {
        Message (" *** Unknown comparison operator in %IF (condition) *** ",0);
        Comp = COMP_UNDEF;
      }
  return Comp;
}

int
Eval_Type_Condition(str, ptype)
     char *str;
     PTR_TYPE ptype;
{
  int Result;
  int i = 0;
  operand Op1, Op2;
  int Comp;

  while (str[i] == ' ') {i++;} /* skip spaces before '(condition)' */
  if (str[i++] != '(')
    {
      Message  (" *** Missing (condition) after %IF *** ",0);
      
      return 0;
    } else
  while (str[i] == ' ') {i++;} /* skip spaces before first operand */
  Get_Type_Operand(str, &i, ptype, &Op1);
  while (str[i] == ' ') {i++;} /* skip spaces before the comparison operator */
  Comp = GetComp(str, &i);
  while (str[i] == ' ') {i++;} /* skip spaces before second operand */
  Get_Type_Operand(str, &i, ptype, &Op2);
  while (str[i] == ' ') {i++;} /* skip spaces before the closing round bracket */
  if (str[i] != ')')
    {
      Message (" *** Missing ')' after %IF (condition *** ",0);
      return i;
    } else
  i++;
  if ((Op1.typ != UNDEF_TYP) && (Op1.typ == Op2.typ) && (Comp !=COMP_UNDEF))
    {
      switch (Op1.typ)
        {
          case STRING_TYP : Result = strcmp (Op1.val.S, Op2.val.S);
            break;
          case INTEGER_TYP : Result = Op1.val.I - Op2.val.I;
            break;
        }
      if (Comp == COMP_EQUAL) Result = !Result;
      if (Result) return i; /* continue from here to the corresponding %ELSE if exists */
      else                  /* continue at the corresponding %ELSE */
        {
          int ifcount_local = 1;
          while (str[i])
            {
              while (str[i] != '%') {
                                      if (str[i]) i++;
                                      else return i;
                                    }
              i++;
              if (strncmp(&(str[i]),"IF", strlen("IF"))== 0)                 /* Counts %IF */
                {
                  ifcount_local++;
                  i += strlen("IF");
                } else
              if (strncmp(&(str[i]),"ENDIF", strlen("ENDIF"))== 0)           /* Counts %ENDIF ; stop skipping if corresponding */
                {
                  ifcount_local--;
                  i += strlen("ENDIF");
                  if (ifcount_local == 0) return i;
                } else
              if (strncmp(&(str[i]),"ELSE", strlen("ELSE"))== 0)             /* Counts %ELSE ; stop skipping if corresponding*/
                {
                  i += strlen("ELSE");
                  if (ifcount_local == 1) return i;
                }
            }
          return i;
        }
    } else
        {
          Message (" *** Error in condition for %IF command *** 1",0);
          return i;
        }
}


int
Eval_LLND_Condition(str, ll)
     char *str;
     PTR_LLND ll;
{
  int Result = 0;
  int i = 0;
  operand Op1, Op2;
  int Comp = 0;

  while (str[i] == ' ') {i++;} /* skip spaces before '(condition)' */
  if (str[i++] != '(')
    {
      Message  (" *** Missing (condition) after %IF *** ",0);
      return 0;
    } else
  while (str[i] == ' ') {i++;} /* skip spaces before first operand */
 Get_LL_Operand(str, &i, ll, &Op1);
  while (str[i] == ' ') {i++;} /* skip spaces before the comparison operator */
  Comp = GetComp(str, &i);
  while (str[i] == ' ') {i++;} /* skip spaces before second operand */
  Get_LL_Operand(str, &i, ll, &Op2);
  while (str[i] == ' ') {i++;} /* skip spaces before the closing round bracket */
  if (str[i] != ')')
    {
      Message (" *** Missing ')' after %IF (condition *** ",0);
      i++;      
      return i;
    }  else
       i++; 

  if ((Op1.typ != UNDEF_TYP) && (Op1.typ == Op2.typ) && (Comp != COMP_UNDEF))
    {
      switch (Op1.typ)
        {
          case STRING_TYP : Result = strcmp (Op1.val.S, Op2.val.S);
            break;
          case INTEGER_TYP : Result = Op1.val.I - Op2.val.I;
            break;
        }
      if (Comp == COMP_EQUAL) Result = !Result;
      if (Result) return i; /* continue from here to the corresponding %ELSE if exists */
      else                  /* continue at the corresponding %ELSE */
        {
          int ifcount_local = 1;
          while (str[i])
            {
              while (str[i] != '%') {
                                      if (str[i]) i++;
                                      else return i;
                                    }
              i++;
              if (strncmp(&(str[i]),"IF", strlen("IF"))== 0)                 /* Counts %IF */
                {
                  ifcount_local++;
                  i += strlen("IF");
                } else
              if (strncmp(&(str[i]),"ENDIF", strlen("ENDIF"))== 0)           /* Counts %ENDIF ; stop skipping if corresponding */
                {
                  ifcount_local--;
                  i += strlen("ENDIF");
                  if (ifcount_local == 0) return i;
                } else
              if (strncmp(&(str[i]),"ELSE", strlen("ELSE"))== 0)             /* Counts %ELSE ; stop skipping if corresponding*/
                {
                  i += strlen("ELSE");
                  if (ifcount_local == 1) return i;
                }
            }
          return i;
        }
    } else
        {
          Message  (" *** Error in condition for %IF command *** 2",0);
          return i;
        }
}


int
Eval_Bif_Condition(str, bif)
     char *str;
     PTR_BFND bif;
{
  int Result;
  int i = 0;
  operand Op1, Op2;
  int Comp;

  while (str[i] == ' ') {i++;} /* skip spaces before '(condition)' */
  if (str[i++] != '(')
    {
      Message (" *** Missing (condition) after %IF *** ",0);
      return 0;
    } else
  while (str[i] == ' ') {i++;} /* skip spaces before first operand */
  Get_Bif_Operand(str, &i, bif, &Op1);
  while (str[i] == ' ') {i++;} /* skip spaces before the comparison operator */
  Comp = GetComp(str, &i);
  while (str[i] == ' ') {i++;} /* skip spaces before second operand */
  Get_Bif_Operand(str, &i, bif, &Op2);
  while (str[i] == ' ') {i++;} /* skip spaces before the closing round bracket */

  if (str[i] != ')')
    {
      Message  (" *** Missing ')' after %IF (condition *** ",0);
      return i;
    } else
  i++;
  if ((Op1.typ != UNDEF_TYP) && (Op1.typ == Op2.typ) && (Comp != COMP_UNDEF))
    {
      switch (Op1.typ)
        {
          case STRING_TYP : Result = strcmp (Op1.val.S, Op2.val.S);
            break;
          case INTEGER_TYP : Result = Op1.val.I - Op2.val.I;
            break;
        }
      if (Comp == COMP_EQUAL) Result = !Result;
      if (Result) return i; /* continue from here to the corresponding %ELSE if exists */
      else                  /* continue at the corresponding %ELSE */
        {
          int ifcount_local = 1;
          while (str[i])
            {
              while (str[i] != '%') {
                                      if (str[i]) i++;
                                      else return i;
                                    }
              i++;
              if (strncmp(&(str[i]),"IF", strlen("IF"))== 0)                 /* Counts %IF */
                {
                  ifcount_local++;
                  i += strlen("IF");
                } else
              if (strncmp(&(str[i]),"ENDIF", strlen("ENDIF"))== 0)           /* Counts %ENDIF ; stop skipping if corresponding */
                {
                  ifcount_local--;
                  i += strlen("ENDIF");
                  if (ifcount_local == 0) return i;
                } else
              if (strncmp(&(str[i]),"ELSE", strlen("ELSE"))== 0)             /* Counts %ELSE ; stop skipping if corresponding*/
                {
                  i += strlen("ELSE");
                  if (ifcount_local == 1) return i;
                }
            }
          return i;
        }
    } else
        {
          Message  (" *** Error in condition for %IF command *** 3",0);
          return i;
        }
}


int
SkipToEndif (str)
     char *str;
{
  int ifcount_local = 1;
  int i = 0;

  while (str[i])
    {
      while (str[i] != '%') {
                              if (str[i]) i++;
                              else return i;
                            }
      i++;
      if (strncmp(&(str[i]),"IF", strlen("IF"))== 0)                         /* Counts %IF */
        {
          ifcount_local++;
          i += strlen("IF");
        } else
      if (strncmp(&(str[i]),"ENDIF", strlen("ENDIF"))== 0)                   /* Counts %ENDIF ; stop skipping if corresponding */
        {
          ifcount_local--;
          i += strlen("ENDIF");
          if (ifcount_local == 0) return i;
        }
    }
  return i;
}

char *Tool_Unparse2_LLnode (); 

char *
Tool_Unparse_Type (ptype, def)
     PTR_TYPE ptype;
     int def;        /* def = 1 : defined type
                        def = 0 : named type */
{
  int variant;
  int kind;
  char *str;
  char c;
  int i;

  if (!ptype)
    return NULL;

  variant = TYPE_CODE (ptype);
  kind = (int) node_code_kind [(int) variant];
  if (kind != (int)TYPENODE)
    Message ("Error in Unparse, not a type node", 0);

  str = Unparse_Def [variant].str;

  /* now we have to interpret the code to unparse it */

  if (str == NULL)
    return NULL;
  if (strcmp ( str, "n") == 0)
    {
      Message("Node not define for unparse",0);
      return NULL;
    }
  

  i = 0 ;
  c = str[i];
  while (c != '\0')
    {
      if (c == '%')
        {
          i++;
          c = str[i];
          /******** WE HAVE TO INTERPRET THE COMMAND *********/
          if (c  == '%')                                                 /* %% : Percent Sign */
            {
              BufPutString ("%%",0);
              i++;
            } else
          if (strncmp(&(str[i]),"ERROR", strlen("ERROR"))== 0)           /* %ERROR : Generate error message */
            {
              Message("Error in Unparse, not a llnd node",0);
              BufPutString ("--- unparsing error  ",0);
              i += strlen("ERROR");
              BufPutString (" ---",0);
            } else
          if (strncmp(&(str[i]),"NL", strlen("NL"))== 0)                 /* %NL : NewLine */
            {
              int j;
              BufPutChar ('\n');
/*              for (j = 0; j < TabNumber; j++)
                if (j>1)
                  BufPutString ("   ",0);
                else
                  BufPutString ("       ",0);*/
               i += strlen("NL");
            } else
              if (strncmp(&(str[i]),"NOTABNL", strlen("NOTABNL"))== 0)                 /* %NL : NewLine */
            {
              BufPutChar ('\n');
              i += strlen("NOTABNL");
            } else
              if (strncmp(&(str[i]),"TABNAME", strlen("TABNAME"))== 0)       /* %TABNAME : Self Name from Table */
                {
                  BufPutString (ftype_name [type_index (TYPE_CODE (ptype))],0);
                  i += strlen("TABNAME");
                } else
                  if (strncmp(&(str[i]),"TAB", strlen("TAB"))== 0)               /* %TAB : Tab */
               {
              BufPutString ("       ",0);
              i += strlen("TAB");
            } else
              if (strncmp(&(str[i]),"PUTTAB", strlen("PUTTAB"))== 0)               /* %TAB : Tab */
                {
                  int j;
                  for (j = 0; j < TabNumber; j++)
                    if (j>0)
                  BufPutString ("   ",0);
                else
                    BufPutString ("       ",0);
                  i += strlen("PUTTAB");
                } else
                  if (strncmp(&(str[i]),"IF", strlen("IF"))== 0)                 /* %IF : If ; syntax : %IF (condition) then_bloc [%ELSE else_bloc] %ENDIF */
            {
              i += strlen("IF");
              i += Eval_Type_Condition(&(str[i]), ptype);
            } else
          if (strncmp(&(str[i]),"ELSE", strlen("ELSE"))== 0)             /* %ELSE : Else */
            {
              i += strlen("ELSE");
              i += SkipToEndif(&(str[i]));  /* skip to the corresponding endif */
            } else
          if (strncmp(&(str[i]),"ENDIF", strlen("ENDIF"))== 0)           /* %ENDIF : End of If */
            {
              i += strlen("ENDIF");
            } else
          if (strncmp(&(str[i]),"BASETYPE", strlen("BASETYPE"))== 0)     /* %BASETYPE : Base Type Name Identifier */
            {
              BufPutString (ftype_name [type_index (TYPE_CODE (TYPE_BASE (ptype)))],0);
              i += strlen("BASETYPE");
            } else
          if (strncmp(&(str[i]),"RANGES", strlen("RANGES"))== 0)         /* %RANGES : Ranges */
            {
              Tool_Unparse2_LLnode (TYPE_RANGES (ptype));
              i += strlen("RANGES");
            } else
          if (strncmp(&(str[i]),"NAMEID", strlen("NAMEID"))== 0)         /* %NAMEID : Name Identifier */
            {
              BufPutString ( ptype->name->ident,0);
              i += strlen("NAMEID");
            } else
          if (strncmp(&(str[i]),"RANGLL1", strlen("RANGLL1"))== 0)       /* %RANGLL1 : Low Level Node 1 of Ranges */
            {
              if (TYPE_RANGES (ptype))
                Tool_Unparse2_LLnode (NODE_TEMPLATE_LL1 (TYPE_RANGES (ptype)));
              i += strlen("RANGLL1");
            } else
          Message  (" *** Unknown type node COMMAND *** ",0);
        }
       else
         {
           BufPutChar (c);
           i++;
         }
      c = str[i];
    }
  return  Buf_address;
}


char *
Tool_Unparse2_LLnode(ll)
     PTR_LLND ll;
{
  int variant;
  int kind;
  char *str;
  char c;
  int i;
  
  if (!ll)
    return NULL;
  
  variant = NODE_CODE (ll);
  kind = (int) node_code_kind[(int) variant];
  if (kind != (int)LLNODE)
    {
      Message("Error in Unparse, not a llnd node",0);
      BufPutString ("------ERROR--------",0);
      return NULL;
    }
  
  
  str = Unparse_Def[variant].str;
  
  /* now we have to interpret the code to unparse it */
  
  if (str == NULL)
    return NULL;
  if (strcmp( str, "n") == 0)
    return NULL;

  i = 0 ;
  c = str[i];
  while (c != '\0')
    {
      if (c == '%')
        {
          i++;
          c = str[i];
          /******** WE HAVE TO INTERPRET THE COMMAND *********/
          if (c  == '%')                                                 /* %% : Percent Sign */
            {
              BufPutString ("%%",0);
              i++;
            } else
          if (strncmp(&(str[i]),"ERROR", strlen("ERROR"))== 0)           /* %ERROR : Generate error message */
            {
              Message ("--- unparsing error : ",0);
              BufPutString ("------ERROR--------",0);
              i += strlen("ERROR");
            } else
          if (strncmp(&(str[i]),"NL", strlen("NL"))== 0)                 /* %NL : NewLine */
            {
              int j;
              BufPutChar ('\n');
/*              for (j = 0; j < TabNumber; j++)
                if (j>1)
                  BufPutString ("   ",0);
                else
                  BufPutString ("       ",0);*/
               i += strlen("NL");
            } else
          if (strncmp(&(str[i]),"TAB", strlen("TAB"))== 0)               /* %TAB : Tab */
            {
              BufPutString ("       ",0);
              i += strlen("TAB");
            } else
          if (strncmp(&(str[i]),"IF", strlen("IF"))== 0)                 /* %IF : If ; syntax : %IF (condition) then_bloc [%ELSE else_bloc] %ENDIF */
            {
              i += strlen("IF");
              i += Eval_LLND_Condition(&(str[i]), ll);
            } else
          if (strncmp(&(str[i]),"ELSE", strlen("ELSE"))== 0)             /* %ELSE : Else */
            {
              i += strlen("ELSE");
              i += SkipToEndif(&(str[i]));  /* skip to the corresponding endif */
            } else
          if (strncmp(&(str[i]),"ENDIF", strlen("ENDIF"))== 0)           /* %ENDIF : End of If */
            {
              i += strlen("ENDIF");
            } else
          if (strncmp(&(str[i]),"LL1", strlen("LL1"))== 0)               /* %LL1 : Low Level Node 1 */
            {
              Tool_Unparse2_LLnode(NODE_TEMPLATE_LL1(ll));
              i += strlen("LL1");
            } else
          if (strncmp(&(str[i]),"LL2", strlen("LL2"))== 0)               /* %LL2 : Low Level Node 2 */
            {
              Tool_Unparse2_LLnode(NODE_TEMPLATE_LL2(ll));
              i += strlen("LL2");
            } else
          if (strncmp(&(str[i]),"SYMBID", strlen("SYMBID"))== 0)         /* %SYMBID : Symbol identifier */
            {
              Tool_Unparse_Symbol (NODE_SYMB (ll));
              i += strlen("SYMBID");
            } else
          if (strncmp(&(str[i]),"TYPE", strlen("TYPE"))== 0)             /* %TYPE : Type */
            {
              Tool_Unparse_Type (NODE_TYPE (ll), 1);
              i += strlen("TYPE");
            } else
          if (strncmp(&(str[i]),"L1SYMBCST", strlen("L1SYMBCST"))== 0)   /* %L1SYMBCST  : Constant Value of Low Level Node Symbol */
            {
              if (NODE_TEMPLATE_LL1 (ll) && NODE_SYMB (NODE_TEMPLATE_LL1 (ll)))
                {
                   Tool_Unparse2_LLnode((NODE_SYMB (NODE_TEMPLATE_LL1 (ll)))->entry.const_value);
                }
              i += strlen("L1SYMBCST");
            } else
          if (strncmp(&(str[i]),"INTVAL", strlen("INTVAL"))== 0)         /* %INTVAL : Integer Value */
            {
              BufPutInt (NODE_INT_CST_LOW (ll));
              i += strlen("INTVAL");
            } else
          if (strncmp(&(str[i]),"STATENO", strlen("STATENO"))== 0)       /* %STATENO : Statement number */
            {
              if (NODE_LABEL (ll))
                {
                  BufPutInt ( LABEL_STMTNO (NODE_LABEL (ll)));
                }
              i += strlen("STATENO");
            } else
          if (strncmp(&(str[i]),"STRVAL", strlen("STRVAL"))== 0)         /* %STRVAL : String Value */
            {
              BufPutString (NODE_STR (ll),0);
              i += strlen("STRVAL");
            } else
          if (strncmp(&(str[i]),"BOOLVAL", strlen("BOOLVAL"))== 0)       /* %BOOLVAL : String Value */
            {
              BufPutString (NODE_BV (ll) ? ".TRUE." : ".FALSE.",0);
              i += strlen("BOOLVAL");
            } else
          if (strncmp(&(str[i]),"CHARVAL", strlen("CHARVAL"))== 0)       /* %CHARVAL : Char Value */
            {
              BufPutChar (NODE_CV (ll));
              i += strlen("CHARVAL");
            } else
          if (strncmp(&(str[i]),"ORBPL1", strlen("ORBPL1"))== 0)         /* %ORBPL1 : Openning Round Brackets on Precedence of Low Level Node 1 */
            {
              int llvar = NODE_CODE (NODE_TEMPLATE_LL1 (ll));
              if (binop (llvar) && (precedence [variant - EQ_OP] < precedence [llvar - EQ_OP]))
                BufPutString ("(",0);
              i += strlen("ORBPL1");
            } else
          if (strncmp(&(str[i]),"CRBPL1", strlen("CRBPL1"))== 0)         /* %CRBPL1 : Closing Round Brackets on Precedence of Low Level Node 1 */
            {
              int llvar = NODE_CODE (NODE_TEMPLATE_LL1 (ll));
              if (binop (llvar) && (precedence [variant - EQ_OP] < precedence [llvar - EQ_OP]))
                BufPutString (")",0);
              i += strlen("CRBPL1");
            } else
          if (strncmp(&(str[i]),"ORBPL2", strlen("ORBPL2"))== 0)         /* %ORBPL2 : Openning Round Brackets on Precedence of Low Level Node 2 */
            {
              int llvar = NODE_CODE (NODE_TEMPLATE_LL2 (ll));
              if (binop (llvar) && (precedence [variant - EQ_OP] <= precedence [llvar - EQ_OP]))
                BufPutString ("(",0);
              i += strlen("ORBPL2");
            } else
          if (strncmp(&(str[i]),"CRBPL2", strlen("CRBPL2"))== 0)         /* %CRBPL2 : Closing Round Brackets on Precedence of Low Level Node 2 */
            {
              int llvar = NODE_CODE (NODE_TEMPLATE_LL2 (ll));
              if (binop (llvar) && (precedence [variant - EQ_OP] <= precedence [llvar - EQ_OP]))
                BufPutString (")",0);
              i += strlen("CRBPL2");
            } else 
              if (strncmp(&(str[i]),"VARLIST", strlen("VARLIST"))== 0)       /* %VARLIST : list of variables / parameters */
            {
              PTR_SYMB symb;
              if (NODE_SYMB (ll))
                symb = SYMB_FUNC_PARAM (NODE_SYMB (ll));
              else
                symb = NULL;
              while (symb)
                {
                  BufPutString ( SYMB_IDENT (symb),0);
                  symb = SYMB_NEXT_DECL (symb);
                  if (symb) BufPutString (", ",0);
                }
              i += strlen("VARLIST");
            } else
          Message  (" *** Unknown low level node COMMAND *** ",0);
        }
       else
         {
           BufPutChar ( c);
           i++; /* Bodin */
         }
      c = str[i];
    }
  return Buf_address;
}

char *
Tool_Unparse_Bif(bif)
     PTR_BFND bif;
{
  int variant;
  int kind;
  char *str;
  char c;
  int i;

  if (!bif)
    return NULL;

  variant = BIF_CODE(bif);
  kind = (int) node_code_kind[(int) variant];
  if (kind  != (int)BIFNODE)
    Message("Error in Unparse, not a bif node",0);
  
  str = Unparse_Def[variant].str;
  
  /* now we have to interpret the code to unparse it */
  
  if (str == NULL)
    return NULL;
  if (strcmp( str, "n") == 0)
    if (strcmp ( str, "n") == 0)
    {
      Message("Node not define for unparse",BIF_LINE(bif));
      return NULL;
    }


  i = 0 ;
  c = str[i];
  while ((c != '\0') && (c != '\n'))
    {
      if (c == '%')
        {
          i++;
          c = str[i];
          /******** WE HAVE TO INTERPRET THE COMMAND *********/
          if (c  == '%')                                                 /* %% : Percent Sign */
            {
              BufPutString ("%%",0);
              i++;
            } else
              if (strncmp(&(str[i]),"CMNT", strlen("CMNT"))== 0)
            {               
              i = i + strlen("CMNT");
              /* print the attached comment first */
              if (BIF_CMNT(bif))
                {       
                  int j;
                  if (CMNT_STRING(BIF_CMNT(bif)))
                    {
                      BufPutChar('\n');
                      BufPutString(CMNT_STRING(BIF_CMNT(bif)),0);
                    }
/*                  for (j = 0; j < TabNumber; j++)
                    if (j>1)
                      BufPutString ("   ",0);
                    else
                      BufPutString ("       ",0);*/
                }
            } else
              if (strncmp(&(str[i]),"SETFLAG", strlen("SETFLAG"))== 0)
            {               
              i = i + strlen("SETFLAG");
              Treat_Flag(str, &i,1);
            } else
              if (strncmp(&(str[i]),"UNSETFLAG", strlen("UNSETFLAG"))== 0) 
            {               
              i = i + strlen("UNSETFLAG");
              Treat_Flag(str, &i,0);
            } else
          if (strncmp(&(str[i]),"ERROR", strlen("ERROR"))== 0)           /* %ERROR : Generate error message */
            {
              Message("--- unparsing error : ",0);
              i += strlen("ERROR");
              BufPutString (" ---",0);
            } else
              if (strncmp(&(str[i]),"NL", strlen("NL"))== 0)                 /* %NL : NewLine */
            { int j;              
              BufPutChar ('\n');
/*              for (j = 0; j < TabNumber; j++)
                if (j>1)
                  BufPutString ("   ",0);
                else
                  BufPutString ("       ",0);*/
              i += strlen("NL");
            } else
              if (strncmp(&(str[i]),"NOTABNL", strlen("NOTABNL"))== 0)                 /* %NL : NewLine */
            {
              BufPutChar ('\n');
              i += strlen("NOTABNL");
            } else
              if (strncmp(&(str[i]),"TAB", strlen("TAB"))== 0)               /* %TAB : Tab */
                {
              BufPutString ("       ",0);
              i += strlen("TAB");
            } else
              if (strncmp(&(str[i]),"PUTTAB", strlen("PUTTAB"))== 0)               /* %TAB : Tab */
                {
                  int j;
                  for (j = 0; j < TabNumber; j++)
                    if (j>0)
                      BufPutString ("   ",0);
                    else
                      BufPutString ("       ",0);
                  i += strlen("PUTTAB");
                } else
              if (strncmp(&(str[i]),"INCTAB", strlen("INCTAB"))== 0)               /* increment tab */
            {
              TabNumber++;              
              i += strlen("INCTAB");
            }  else
              if (strncmp(&(str[i]),"DECTAB", strlen("DECTAB"))== 0)               /*deccrement tab */
            {
              if (TabNumber>1)
                TabNumber--;              
              i += strlen("DECTAB");
            }  else
          if (strncmp(&(str[i]),"IF", strlen("IF"))== 0)                 /* %IF : If ; syntax : %IF (condition) then_bloc [%ELSE else_bloc] %ENDIF */
            {
              i += strlen("IF");
              i += Eval_Bif_Condition(&(str[i]), bif);
            } else
          if (strncmp(&(str[i]),"ELSE", strlen("ELSE"))== 0)             /* %ELSE : Else */
            {
              i += strlen("ELSE");
              i += SkipToEndif(&(str[i]));  /* skip to the corresponding endif */
            } else
          if (strncmp(&(str[i]),"ENDIF", strlen("ENDIF"))== 0)           /* %ENDIF : End of If */
            {
              i += strlen("ENDIF");
            } else
          if (strncmp(&(str[i]),"BLOB1", strlen("BLOB1"))== 0)           /* %BLOB1 : All Blob 1 */
            {
              PTR_BLOB blob;

              for (blob = BIF_BLOB1(bif);blob; blob = BLOB_NEXT (blob))
                {
                  Tool_Unparse_Bif(BLOB_VALUE(blob));
                }
              i += strlen("BLOB1");
            } else
          if (strncmp(&(str[i]),"BLOB2", strlen("BLOB2"))== 0)           /* %BLOB2 : All Blob 2 */
            {
              PTR_BLOB blob;

              for (blob = BIF_BLOB2(bif);blob; blob = BLOB_NEXT (blob))
                {
                  Tool_Unparse_Bif(BLOB_VALUE(blob));
                }
              i += strlen("BLOB2");
            } else
          if (strncmp(&(str[i]),"LL1", strlen("LL1"))== 0)               /* %LL1 : Low Level Node 1 */
            {
              Tool_Unparse2_LLnode(BIF_LL1(bif));
              i += strlen("LL1");
            } else
          if (strncmp(&(str[i]),"LL2", strlen("LL2"))== 0)               /* %LL2 : Low Level Node 2 */
            {
              Tool_Unparse2_LLnode (BIF_LL2 (bif));
              i += strlen("LL2");
            } else
          if (strncmp(&(str[i]),"LL3", strlen("LL3"))== 0)               /* %LL3 : Low Level Node 3 */
            {
              Tool_Unparse2_LLnode(BIF_LL3(bif));
              i += strlen("LL3");
            } else
          if (strncmp(&(str[i]),"L2L2", strlen("L2L2"))== 0)             /* %L2L2 : Low Level Node 2 of Low Level Node 2 */
            {
              if (BIF_LL2 (bif))
                Tool_Unparse2_LLnode (NODE_TEMPLATE_LL2 (BIF_LL2 (bif)));
              i += strlen("L2L2");
            } else
          if (strncmp(&(str[i]),"SYMBID", strlen("SYMBID"))== 0)         /* %SYMBID : Symbol identifier */
            {
              Tool_Unparse_Symbol(BIF_SYMB(bif));
              i += strlen("SYMBID");
            } else
          if (strncmp(&(str[i]),"STATENO", strlen("STATENO"))== 0)       /* %STATENO : Statement number */
            {
              if (BIF_LABEL_USE (bif))
                {
                  BufPutInt (LABEL_STMTNO (BIF_LABEL_USE (bif)));
                }
              i += strlen("STATENO");
            } else
              if (strncmp(&(str[i]),"LABEL", strlen("LABEL"))== 0)       /* %STATENO : Statement number */
                {
              if (BIF_LABEL(bif))
                {
                  BufPutInt (LABEL_STMTNO (BIF_LABEL(bif)));
                }
              i += strlen("LABEL");
            } else
          if (strncmp(&(str[i]),"SYMBTYPE", strlen("SYMBTYPE"))== 0)     /* SYMBTYPE : Type of Symbol */
            {
              if (BIF_SYMB (bif) && SYMB_TYPE (BIF_SYMB (bif)))
                  BufPutString ( ftype_name [type_index (TYPE_CODE (SYMB_TYPE (BIF_SYMB (bif))))],0);
              i += strlen("SYMBTYPE");
            } else
          if (strncmp(&(str[i]),"L1SYMBID", strlen("L1SYMBID"))== 0)     /* %L1SYMBID : Symbol of Low Level Node 1 */
            {
              if (BIF_LL1 (bif))
                  Tool_Unparse_Symbol (NODE_SYMB (BIF_LL1 (bif)));
              i += strlen("L1SYMBID");
            } else
          if (strncmp(&(str[i]),"VARLIST", strlen("VARLIST"))== 0)       /* %VARLIST : list of variables / parameters */
            {
              PTR_SYMB symb;
              if (BIF_SYMB (bif))
                symb = SYMB_FUNC_PARAM (BIF_SYMB (bif));
              else
                symb = NULL;
              while (symb)
                {
                  BufPutString ( SYMB_IDENT (symb),0);
                  symb = SYMB_NEXT_DECL (symb);
                  if (symb) BufPutString (", ",0);
                }
              i += strlen("VARLIST");
            } else
          if (strncmp(&(str[i]),"INWRITEON", strlen("INWRITEON"))== 0)   /* %INWRITEON : In_Write_Statement Flag ON */
            {
              In_Write_Flag = 1;
              i += strlen("INWRITEON");
            } else
          if (strncmp(&(str[i]),"INWRITEOFF", strlen("INWRITEOFF"))== 0) /* %INWRITEOFF : In_Write_Statement Flag OFF */
            {
              In_Write_Flag = 0;
              i += strlen("INWRITEOFF");
            } else
          if (strncmp(&(str[i]),"INPARAMON", strlen("INPARAMON"))== 0)   /* %INPARAMON : In_Param_Statement Flag ON */
            {
              In_Param_Flag = 1;
              i += strlen("INPARAMON");
            } else
          if (strncmp(&(str[i]),"INPARAMOFF", strlen("INPARAMOFF"))== 0) /* %INPARAMOFF : In_Param_Statement Flag OFF */
            {
              In_Param_Flag = 0;
              i += strlen("INPARAMOFF");
            } else
          if (strncmp(&(str[i]),"INIMPLION", strlen("INIMPLION"))== 0)   /* %INIMPLION : In_Impli_Statement Flag ON */
            {
              In_Impli_Flag = 1;
              i += strlen("INIMPLION");
            } else
          if (strncmp(&(str[i]),"INIMPLIOFF", strlen("INIMPLIOFF"))== 0) /* %INIMPLIOFF : In_Impli_Statement Flag OFF */
            {
              In_Impli_Flag = 0;
              i += strlen("INIMPLIOFF");
            } else
              if (strncmp(&(str[i]),"DUMMY", strlen("DUMMY"))== 0) /* %DUMMY Do nothing */
            {
              i += strlen("DUMMY");
            } else
          Message (" *** Unknown bif node COMMAND *** ",0);
        }
       else
         {
           BufPutChar( c);
           i++;
         }
      c = str[i];
    }
  return Buf_address;
}

