/*
 * check_wr --  simple program to check the consistency of
 *		read_nodes/write_nodes.
 *
 * Usage:
 *		check_wr <dep_filename>
 *
 *	This will generate dep_filename1, i.e. append an extra
 *	'1' at the end, so that you can "cmp" the new one with
 *	the original one.
 */

#include <string.h>
#include "db.h"

int	debug;


main(argc, argv, envp)
    int	  argc;
    char *argv[];
    char *envp[];
{
    int		 len;
    char	 out[50];
    char	*progname;
    FILE	*fd_in;
    PTR_FILE	 f;

    progname = *argv++;
    if (argc < 2)
    {
       fprintf(stderr,"Usage: %s [-d nnn] <filename>\n", progname);
       exit(1);
    }
    argc--;
    if (**argv == '-')
       if ((*argv)[1] == 'd') 
       {
	  argv++;
	  debug = atoi(*argv++);
	  printf("debug = %d\n",debug);
       } 
       else 
       {
	  fprintf(stderr,"Usage: %s [-d nnn] <filename>\n", progname);
	  exit(1);
      }

    /* Now open the dep file */
    if ((fd_in=fopen(*argv, "r")) == NULL) 
    {
	fprintf(stderr,"Cannot open file \"%s\" fore read.\n", *argv);
	exit(1);
    }
    if ((f = (PTR_FILE) calloc(1, sizeof(struct file_obj))) == NULL) 
    {
	fprintf(stderr, "main -- No more space\n");
	exit(1);
    }

    f->fid = fd_in;
    read_nodes(f);

    /* Prepare to dump it out again */
    strcpy(out, *argv);
    len = strlen(out);
    out[len] = '1';
    out[len+1] = '\0';
    f->global_bfnd->control_parent = NULL;
    write_nodes(f, out);

    exit(0);
} /* main */
