#include "db.h"


static FILE *fd;

#define FOLLOW_BIF_POINTER_TO_ID(VAR) \
    (bf_ptr->entry.template.VAR? bf_ptr-> entry.template.VAR->id: -1)

#define FOLLOW_LL_POINTER_TO_ID(VAR) \
    (ll_ptr-> entry.template.VAR? ll_ptr-> entry.template.VAR->id: -1)

#define FOLLOW_SYMB_POINTER_1_TO_ID(VAR) \
    (sy_ptr->VAR? sy_ptr->VAR->id: -1)

#define FOLLOW_SYMB_POINTER_2_TO_ID(VAR) \
    (sy_ptr->entry.VAR? sy_ptr->entry.VAR->id: -1)

#define FOLLOW_TYPE_POINTER_TO_ID(VAR) \
    (ty_ptr->entry.VAR? ty_ptr->entry.VAR->id: -1)

#define FOLLOW_DEP_TO_ID(VAR) \
    (dep->VAR? dep->VAR->id: -1)

#define FOLLOW_BIF_POINT_TO_ID(VAR) \
    (bf_ptr->VAR? bf_ptr->VAR->id: -1)

#define FOLLOW_LL_POINT_TO_ID(VAR) \
    (ll_ptr->VAR? ll_ptr->VAR->id: -1)

char   *tag[610];


/*------------------------------------------------------*
 *		      write_sizes			*
 *------------------------------------------------------*/
static void
write_sizes(f)
	PTR_FILE f;
{
	int	n1, n2, n3, n4, n5, n6, n7, n8, n9, n10;

	n1 = f->num_blobs;
	n2 = f->num_bfnds;
	n3 = f->num_llnds;
	n4 = f->num_symbs;
	n5 = f->num_types;
	n6 = f->num_label;
	n7 = f->global_bfnd->id;
	n8 = f->num_dep;
	n9 = f->num_cmnt;
	n10= f->num_files;

        fprintf(fd,"\n #blob  #bfnd  #llnd  #symb    #type  #labl  GblBf #deps  #cmnt  #file\n");
	fprintf(fd,"---------------------------------------------------------------------\n");
	fprintf(fd,"%5d  %5d  %5d  %5d	%4d  %5d  %5d  %5d  %5d  %5d\n\n",
	       n1, n2, n3, n4, n5, n6, n7, n8, n9, n10);
}


/*------------------------------------------------------*
 *		   write_blob_list			*
 *							*
 *	dump the blob list with the given head		*
 *------------------------------------------------------*/
static void
write_blob_list(head)
	PTR_BLOB head;
{
	register PTR_BLOB bl_ptr;

	fprintf(fd," %5s", " ");
	for (bl_ptr = head; bl_ptr; bl_ptr = bl_ptr->next)
		fprintf(fd,"%5d ", bl_ptr->ref->id);
	fprintf(fd,"%5d\n", EOL);
}


/*------------------------------------------------------*
 *		   write_prop_list			*
 *							*
 *	dump the prop list with the given head		*
 *------------------------------------------------------*/
static void
write_prop_list(head)
	PTR_PLNK head;
{
	register PTR_PLNK pl_ptr;

	fprintf(fd," %5s", " ");
	for (pl_ptr = head; pl_ptr; pl_ptr = pl_ptr->next)
		fprintf(fd," | %10s & %10s", pl_ptr->prop_name,pl_ptr->prop_val);
	fprintf(fd,"%5d\n", EOL);
}


/*------------------------------------------------------*
 *                 write_refl_list                      *
 *                                                      *
 *      dump the refl list with the given head          *
 *------------------------------------------------------*/
static void
write_refl_list(head)
        PTR_REFL head;
{
        register PTR_REFL rf_ptr;
        struct ref *ref_ptr;
        int     l, m, n;
        l = rf_ptr->id? rf_ptr->id->id: -1;
        ref_ptr=rf_ptr->node;
        if(ref_ptr)
          {
             m = ref_ptr->stmt? ref_ptr->stmt->id: -1;
             n = ref_ptr->refer? ref_ptr->refer->id: -1;
          }
        else
          {
             m = -2;
             n = -2;
          }

        fprintf(fd," %5s", " ");
        for (rf_ptr = head; rf_ptr; rf_ptr = rf_ptr->next)
              {
                fprintf(fd,"<%5d ",l);
                fprintf(fd," %4d", m);
                fprintf(fd," %4d> ", n);
              }
        fprintf(fd,"%5d\n", EOL);
}

/*------------------------------------------------------*
 *                 write_aref_list                      *
 *                                                      *
 *      dump the aref list with the given head          *
 *------------------------------------------------------*/
static void
write_aref_list(head)
        PTR_AREF head;
{
        register PTR_AREF af_ptr;
        int n1, n2, n3, n4, n5, n6, n7, n8;
        n1 = head->id?head->id->id: -1;
        n2 = head->decl_ranges? head->decl_ranges->id: -1;
        n3 = head->use_bnd0? head->use_bnd0->id: -1;
        n4 = head->mod_bnd0? head->mod_bnd0->id: -1;
        n5 = head->use_bnd1? head->use_bnd1->id: -1;
        n6 = head->mod_bnd1? head->mod_bnd1->id: -1;
        n7 = head->use_bnd2? head->use_bnd2->id: -1;
        n8 = head->mod_bnd2? head->mod_bnd2->id: -1;

        fprintf(fd," %5s", " ");
        for (af_ptr = head; af_ptr; af_ptr = af_ptr->next)
                fprintf(fd," %5d %5d %5d %5d %5d %5d %5d %5d ",n1,n2
,n3, n4,n5,n6,n7,n8);
        fprintf(fd,"%5d\n", EOL);
}



/*------------------------------------------------------*
 *		    write_bif_node			*
 *							*
 *	    routines to print one bif node		*
 *------------------------------------------------------*/
static void
write_bif_node(bf_ptr)
	PTR_BFND bf_ptr;
{
	int n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15;
        int n16, n17;

	n1 = bf_ptr->id;
	n2 = bf_ptr->variant;
	n3 = bf_ptr->control_parent ? bf_ptr->control_parent->id : -1;
	n4 = FOLLOW_BIF_POINTER_TO_ID(bf_ptr1);
	n5 = FOLLOW_BIF_POINTER_TO_ID(cmnt_ptr);
	n6 = FOLLOW_BIF_POINTER_TO_ID(symbol);
	n7 = FOLLOW_BIF_POINTER_TO_ID(ll_ptr1);
	n8 = FOLLOW_BIF_POINTER_TO_ID(ll_ptr2);
	n9 = FOLLOW_BIF_POINTER_TO_ID(ll_ptr3);
	n10 = FOLLOW_BIF_POINTER_TO_ID(dep_ptr1);
	n11 = FOLLOW_BIF_POINTER_TO_ID(dep_ptr2);
	n12 = bf_ptr->label? bf_ptr->label->id: -1;
	n13 = FOLLOW_BIF_POINTER_TO_ID(lbl_ptr);
	n14 = bf_ptr->g_line;
	n15 = bf_ptr->l_line;
        n16 = bf_ptr->index;
        n17 = FOLLOW_BIF_POINT_TO_ID(thread);

	fprintf(fd,"%3d %3d %3d %3d %3d %4d %4d %4d %4d %4d %4d %3d %3d %3d %3d %6d %3d %12s\n",
	      n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16, n17,
	      tag[bf_ptr->variant]);

        fprintf(fd,"         bl_ptr1:");
	write_blob_list(bf_ptr->entry.template.bl_ptr1);
        fprintf(fd,"         bl_ptr2:");
	write_blob_list(bf_ptr->entry.template.bl_ptr2);
        fprintf(fd,"         prop_list:");
	write_prop_list(bf_ptr->prop_list);
        fprintf(fd,"         sets: ");
        if(bf_ptr->entry.template.sets)
         {
           fprintf(fd,"\n");
           fprintf(fd,"              gen:");
           write_refl_list(bf_ptr->entry.template.sets->gen);
           fprintf(fd,"              in_def:");
           write_refl_list(bf_ptr->entry.template.sets->in_def);
           fprintf(fd,"              use:");
           write_refl_list(bf_ptr->entry.template.sets->use);
           fprintf(fd,"              in_use:");
           write_refl_list(bf_ptr->entry.template.sets->in_use);
           fprintf(fd,"              out_def:");
           write_refl_list(bf_ptr->entry.template.sets->out_def);
           fprintf(fd,"              out_use:");
           write_refl_list(bf_ptr->entry.template.sets->out_use);
            if(bf_ptr->entry.template.sets->arefl)
                {
                    fprintf(fd,"              aref: id decl_ranges usbnd0 mdbnd0 usbnd1 mdbnd1 usbnd2 mdbnd2 \n");
                    write_aref_list(bf_ptr->entry.template.sets->arefl);
                }
               else
                  fprintf(fd," aref: -1\n");

         }
        else
           fprintf(fd,"        -1 \n");

}



/*------------------------------------------------------*
 *		  write_bif_nodes			*
 *							*
 *	     routines to print bif nodes		*
 *------------------------------------------------------*/
static void
write_bif_nodes(f)
	PTR_FILE f;
{
	register PTR_BFND bf_ptr;

 fprintf(fd," id var  cp bp1 cmnt sym  lp1  lp2 lp3  dp1  dp2 lab lbl glin llin index thread \n");
	for (bf_ptr = f->head_bfnd; bf_ptr; bf_ptr = bf_ptr->thread)
		write_bif_node(bf_ptr);
}


/*------------------------------------------------------*
 *		     write_ll_node			*
 *							*
 *	       print out one low level node		*
 *------------------------------------------------------*/
static void  /*let 's try */ 
write_ll_node(ll_ptr)
	PTR_LLND ll_ptr;
{
	int	n1, n2, n3, n4;

	n1 = ll_ptr->id;
	n2 = ll_ptr->variant;
	n3 = ll_ptr->type ? ll_ptr->type->id : -1;
        n4 = FOLLOW_LL_POINT_TO_ID(thread);
	fprintf(fd,"%5d %5d %5d %5d", n1, n2, n3, n4);
	switch (ll_ptr->variant) {
	    case (INT_VAL):
		fprintf(fd,"%17d", ll_ptr->entry.ival);
		break;
	    case (DOUBLE_VAL):
	    case (FLOAT_VAL):
		fprintf(fd,"%17s", ll_ptr->entry.string_val);
		break;
	    case (BOOL_VAL):
		fprintf(fd,"%17s", ll_ptr->entry.bval ? ".T" : ".F");
		break;
	    case (CHAR_VAL):
		fprintf(fd,"%16c%c", '.', ll_ptr->entry.cval);
		break;
	    case (STMT_STR):
	    case (KEYWORD_VAL):
	    case (STRING_VAL):
		fprintf(fd," \"%s\" ", ll_ptr->entry.string_val);
		break;
	    case (RANGE_OP):
          /*      n1 = ll_ptr->entry.template.symbol ?
                        ll_ptr->entry.template.symbol->id :
                        -1;
                n2 = ll_ptr->entry.template.ll_ptr1?ll_ptr->entry.template.ll_ptr1->id : -1;
		n3 = -1;
                fprintf(fd,"%5d %5d %5d", n1, n2, n3);
                break;   */
	    case (UPPER_OP):
	    case (LOWER_OP):
		n1 = ll_ptr->entry.array_op.symbol ?
			ll_ptr->entry.array_op.symbol->id :
			-1;
		n2 = ll_ptr->entry.array_op.dim;
		fprintf(fd,"%11d %5d", n1, n2);
		break;
	    case (LABEL_REF):
/*		n1 = FOLLOW_LL_POINTER_TO_ID(symbol);
 */		n1 = ll_ptr->entry.label_list.lab_ptr->id;
		fprintf(fd,"%5d %11s", n1, " ");
		break;
	    case  (ARITH_ASSGN_OP): /* New added for VPC++ */
		n1 = (int) ll_ptr->entry.template.symbol;
		n2 = FOLLOW_LL_POINTER_TO_ID(ll_ptr1);
		n3 = FOLLOW_LL_POINTER_TO_ID(ll_ptr2);
		fprintf(fd,"%5d %5d %5d", n1, n2, n3);	
		break;
	   default:
		n1 = FOLLOW_LL_POINTER_TO_ID(symbol);
		n2 = FOLLOW_LL_POINTER_TO_ID(ll_ptr1);
		n3 = FOLLOW_LL_POINTER_TO_ID(ll_ptr2);
		fprintf(fd,"%5d %5d %5d", n1, n2, n3);	
	}
	fprintf(fd,"%30s\n", tag[ll_ptr->variant]);
}


/*------------------------------------------------------*
 *		  write_ll_nodes			*
 *							*
 *		dump low level nodes			*
 *------------------------------------------------------*/
static void
write_ll_nodes(f)
	PTR_FILE f;
{
	register PTR_LLND ll_ptr;

        fprintf(fd,"  id varnt  type  thread  symb   ll1   ll2   tag...\n");
	for (ll_ptr = f->head_llnd; ll_ptr; ll_ptr = ll_ptr->thread)
		write_ll_node(ll_ptr);
}


/*------------------------------------------------------*
 *		    write_symb_node			*
 *							*
 *		print out one symbol node		*
 *------------------------------------------------------*/
static void 
write_symb_node(sy_ptr)
	PTR_SYMB sy_ptr;
{
	int	n1, n2, n3, n4, n5, n6, n7, n8,n9, n10, n11, n12, n13, n14;
        int     n15, n16, n17;
	char   *s1, *s2;
        PTR_HASH hash_ptr;

	n1 = sy_ptr->id;
	n2 = sy_ptr->variant;
	n3 = FOLLOW_SYMB_POINTER_1_TO_ID(type);
	n4 = sy_ptr->attr;
	n5 = FOLLOW_SYMB_POINTER_1_TO_ID(next_symb);
	n6 = sy_ptr->scope? sy_ptr->scope->id: -1;
        n12= FOLLOW_SYMB_POINTER_1_TO_ID(outer);  
        n13= FOLLOW_SYMB_POINTER_1_TO_ID(id_list);    
        n14= FOLLOW_SYMB_POINTER_1_TO_ID(thread);
        n15= sy_ptr->dovar;
        n16= sy_ptr->decl;
        hash_ptr=sy_ptr->parent;
	s1 = sy_ptr->ident;
        if (hash_ptr)
           { 
             n17= hash_ptr->id_attr?  hash_ptr->id_attr->id: -1;
             s2 = hash_ptr->ident;
           }
        else
           { n17=-1;
             s2="     ";
           }
	fprintf(fd,"%4d %4d %4d %4d %4d %4d %4d %6d %6d %6d %4d   <%3d %10s> %15s ", n1,n2,n3,n4,n5,n6,n12,n13,n14,n15,n16,n17,s2,s1);

	switch (sy_ptr->variant) {
	    case DEFAULT:
	    case TYPE_NAME:
		fprintf(fd,"%17s", " ");
		break;
	    case CONST_NAME:
		n1 = FOLLOW_SYMB_POINTER_2_TO_ID(const_value);
		fprintf(fd,"value=%17d", n1);
		break;
	    case ENUM_NAME:
	    case FIELD_NAME:
		n1 = sy_ptr->entry.field.tag;
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(field.next);
		n3 = FOLLOW_SYMB_POINTER_2_TO_ID(field.base_name);
		n4 = FOLLOW_SYMB_POINTER_2_TO_ID(field.declared_name);	 /*  NEW ADDED FOR VPC */
		n5 = FOLLOW_SYMB_POINTER_2_TO_ID(field.restricted_bit); /* NEW for VPC++ */
                n6 = sy_ptr->entry.field.offset;

		fprintf(fd,"tag=%5d nxt=%5d base=%5d\n", n1, n2, n3);
                fprintf(fd,"offset=%5d",n6);
		fprintf(fd,"dec_name=%51d restr=%5d", n4,n5);
		break;
	    case VARIABLE_NAME:
		n1 = sy_ptr->entry.var_decl.local;
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(var_decl.next_in);
		n3 = FOLLOW_SYMB_POINTER_2_TO_ID(var_decl.next_out);
                n4 = sy_ptr->entry.var_decl.offset;
                n5 = sy_ptr->entry.var_decl.dovar; 
		fprintf(fd,"local=%5d nxt_in=%5d nxt_out=%5d", n1, n2, n3);
                fprintf(fd,"offset=%7d dovar=%3d",n4,n5);
		break;
	    case PROGRAM_NAME:
		n1 = FOLLOW_SYMB_POINTER_2_TO_ID(prog_decl.symb_list);
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(prog_decl.prog_hedr);
                n3 = sy_ptr->entry.prog_decl.label_list? sy_ptr->entry.prog_decl.label_list->id: -1;
		fprintf(fd,"symb_lst=%11d prog_hedr=%5d", n1, n2);
                fprintf(fd,"lab_list=%5d",n3);
		break;
	    case PROCEDURE_NAME:
	    case FUNCTION_NAME:
		n1 = sy_ptr->entry.proc_decl.num_input;
		n2 = sy_ptr->entry.proc_decl.num_output;
		n3 = sy_ptr->entry.proc_decl.num_io;
		n4 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.in_list);
		n5 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.out_list);
		n6 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.symb_list);
		n7 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.proc_hedr);
                n8 = sy_ptr->entry.proc_decl.seen;    
                n9 = sy_ptr->entry.proc_decl.local_size;
                n10= sy_ptr->entry.proc_decl.label_list? sy_ptr->entry.proc_decl.label_list->id: -1;
                n11= sy_ptr->entry.proc_decl.call_list? sy_ptr->entry.proc_decl.call_list->id: -1; 
		fprintf(fd,"n_in=%5d n_out=%5d n_io=%5d\n", n1, n2, n3);
		fprintf(fd,"	     in_l=%5d out_l=%5d sy_l=%5d p_hdr=%5d", n4, n5, n6, n7);
                fprintf(fd,"seen=%3d local_size=%5d lad_list=%3d call_list=%3d",n8,n9,n10,n11);
		break;
	    case MEMBER_FUNC:	 /*  NEW ADDED FOR VPC */
		n1 = sy_ptr->entry.member_func.num_input;
		n2 = sy_ptr->entry.member_func.num_output;
		n3 = sy_ptr->entry.member_func.num_io;
		n4 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.in_list);
		n5 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.out_list);
		n6 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.symb_list);
		n7 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.func_hedr);
		n8 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.next);
		n9 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.base_name);
		n10 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.declared_name);
		fprintf(fd,"n_in=%5d n_out=%5d n_io=%5d\n", n1, n2, n3);
		fprintf(fd,"in_l=%29d out_l=%5d sy_l=%5d f_hdr=%5d\n", n4, n5, n6, n7);
		fprintf(fd,"	   m_nxt=%5d b_name=%5d dec_name=%5d", n8, n9, n10);
		break;
/*	    case VARIANT_FIELD	:
		n1 = sy_ptr->entry.field.tag;
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(variant_field.next);
		n3 = FOLLOW_SYMB_POINTER_2_TO_ID(variant_field.base_name);
		n4 = sy_ptr->entry.variant_field.variant_list->id;
		fprintf(fd,"f.tag=%5d f.nxt=%5d b_name=%5d vl_id=%5d", n1, n2, n3, n4);
		break;
*/
	    default:
		fprintf(fd,"%17s", " ");
		break;
	}
	fprintf(fd,"%18s\n", tag[sy_ptr->variant]);
}


/*------------------------------------------------------*
 *		write_symb_nodes			*
 *							*
 *		dump symbol table			*
 *------------------------------------------------------*/
static void
write_symb_nodes(f)
	PTR_FILE f;
{
	register PTR_SYMB sy_ptr;
	fprintf(fd,"  id  var type attr next scope outer id_list thread dovar decl      parent             variable-name\n");
	for (sy_ptr = f->head_symb; sy_ptr; sy_ptr = sy_ptr->thread)
	{	write_symb_node(sy_ptr);
                fprintf(fd,"         ud_chain:");
	        write_blob_list(sy_ptr->ud_chain);
        }       
}


/*------------------------------------------------------*
 *		  write_type_node			*
 *							*
 *	      print out one type node			*
 *------------------------------------------------------*/
static void 
write_type_node(ty_ptr)
	PTR_TYPE ty_ptr;
{
	int	n1, n2, n3;
	int	n4, n5, n6;   /*  NEW ADDED FOR VPC */
        int     n7, n8;  /* ADD FOR MORE INFORMATION */

	n1 = ty_ptr->id;
	n2 = ty_ptr->variant;
	n3 = ty_ptr->name ? ty_ptr->name->id : -1;
        n4 = FOLLOW_TYPE_POINTER_TO_ID(template.ranges);
        n7 = ty_ptr->length;          
        n8 = ty_ptr->thread? ty_ptr->thread->id: -1;
	
	fprintf(fd,"%4d %4d %4d %4d %4d %7d   ", n1, n2, n3, n4, n7, n8);

	switch (ty_ptr->variant) {
	    case DEFAULT:
	    case T_INT:
	    case T_FLOAT:
	    case T_DOUBLE:
	    case T_VOID :  /*  NEW ADDED FOR VPC */
	    case T_CHAR:
	    case T_BOOL:
	    case T_STRING:
	    case T_COMPLEX:
	    case T_ENUM_FIELD:
		fprintf(fd,"%17s", " ");
		break;

	    case T_SUBRANGE:
		n1 = FOLLOW_TYPE_POINTER_TO_ID(subrange.base_type);
		n2 = FOLLOW_TYPE_POINTER_TO_ID(subrange.lower);
		n3 = FOLLOW_TYPE_POINTER_TO_ID(subrange.upper);
		fprintf(fd,"base_t=%5d lo=%5d up=%5d", n1, n2, n3);
		break;

	    case T_ARRAY:
		n1 = ty_ptr->entry.ar_decl.num_dimensions;
		n2 = FOLLOW_TYPE_POINTER_TO_ID(ar_decl.base_type);
		n3 = FOLLOW_TYPE_POINTER_TO_ID(ar_decl.ranges);
		fprintf(fd,"dim=%5d base_t=%5d rngs=%5d", n1, n2, n3);
		break;

	    case T_LIST:
		n1 = FOLLOW_TYPE_POINTER_TO_ID(base_type);
		fprintf(fd,"base_t=%17d", n1);
		break;

	    case T_RECORD:
		n1 = ty_ptr->entry.re_decl.num_fields;
		n2 = FOLLOW_TYPE_POINTER_TO_ID(re_decl.first);
                n3 = ty_ptr->entry.re_decl.record_size;
		fprintf(fd,"n_flds=%11d first=%5d size=%3d", n1, n2, n3);
		break;
	    case T_DESCRIPT:   /*  NEW ADDED FOR VPC */
		n1 = ty_ptr->entry.descriptive.signed_flag ;
		n2 = ty_ptr->entry.descriptive.long_short_flag;
		n3 = ty_ptr->entry.descriptive.mod_flag ;
		n4 = ty_ptr->entry.descriptive.storage_flag ;
		n5 = ty_ptr->entry.descriptive.access_flag ;
		n6 = ty_ptr->entry.descriptive.base_type? ty_ptr->entry.descriptive.base_type->id:-1 ;
                n7= ty_ptr->entry.descriptive.ranges? ty_ptr->entry.descriptive.ranges->id: -1;    
		     
		fprintf(fd,"sgned=%5d ls_flg=%5d mod_flg=%5d\n",n1,n2,n3);
		fprintf(fd,"sto_flg=%23d accs_flg=%5d base_t=%5d ranges=%5d",n4,n5,n6,n7);
		break;
	    case T_POINTER :   /*  NEW ADDED FOR VPC */
		n1 = FOLLOW_TYPE_POINTER_TO_ID(template.base_type);
		n2 = ty_ptr->entry.template.dummy1 ; /* indirect level */
		fprintf(fd,"base_t=%11d ind_lev=%5d", n1,n2);
		break;
		
	    case T_FUNCTION:   /*  NEW ADDED FOR VPC */
		n1 = FOLLOW_TYPE_POINTER_TO_ID(template.base_type);
		fprintf(fd,"base_t=%17d", n1);
		break;

	    case T_DERIVED_TYPE :   /*	NEW ADDED FOR VPC */
		n1 = FOLLOW_TYPE_POINTER_TO_ID(derived_type);
		fprintf(fd,"der_typ=%17d", n1);
		break;
	    case T_ENUM:
	    case T_UNION:   /*	NEW ADDED FOR VPC */
	    case T_STRUCT:  /*	NEW ADDED FOR VPC */
	    case T_CLASS :  /*	NEW ADDED FOR VPC */
	    case T_DERIVED_CLASS :   /*  NEW ADDED FOR VPC */
		n1 = ty_ptr->entry.derived_class.num_fields;
		n2 = FOLLOW_TYPE_POINTER_TO_ID(derived_class.first);
		n3 = FOLLOW_TYPE_POINTER_TO_ID(derived_class.original_class);
		fprintf(fd,"num_flds=%5d first=%5d parent=%5d", n1, n2,n3);
		break;
		
	    default:
		break;
	}
	fprintf(fd,"%30s\n", tag[ty_ptr->variant]);
}


/*------------------------------------------------------*
 *		    write_type_nodes			*
 *------------------------------------------------------*/
static void
write_type_nodes(f)
	PTR_FILE f;
{
	PTR_TYPE ty_ptr;

	fprintf(fd,"  id  var name ranges length thread\n");
	for (ty_ptr = f->head_type; ty_ptr; ty_ptr = ty_ptr->thread)
           {	write_type_node(ty_ptr);
                fprintf(fd,"         ud_chain:");
                write_blob_list(ty_ptr->ud_chain);
           }
}


/*------------------------------------------------------*
 *		    write_label_node			*
 *------------------------------------------------------*/
static void 
write_label_node(lb_ptr)
	PTR_LABEL lb_ptr;
{
	int	n1, n2, n4, n5, n6, n7, n8, n9, n10;
	long	n3;

	n1 = lb_ptr->id;
	n2 = (int)lb_ptr->stateno;
	n3 = lb_ptr->labtype;
	n4 = lb_ptr->statbody ? lb_ptr->statbody->id : -1;
	n5 = lb_ptr->label_name ? lb_ptr->label_name->id : -1 ;
        n6 = lb_ptr->labused;
        n7 = lb_ptr->labinacc;
        n8 = lb_ptr->labdefined;
        n9 = lb_ptr->scope? lb_ptr->scope->id: -1;
        n10= lb_ptr->next? lb_ptr->next->id: -1;
	fprintf(fd,"%5d %5d %5d %5d %5d %6d %6d %6d %5d %5d\n", n1, n2, n3, n4, n5, n6, n7, n8, n9, n10);
}


/*------------------------------------------------------*
 *		    write_label_nodes			*
 *------------------------------------------------------*/
static void 
write_label_nodes(f)
	PTR_FILE f;
{
	PTR_LABEL lb_ptr;

        fprintf(fd,"  id stateno  labtype statbody labname labused labinacc labdefined scope  next\n");
	for (lb_ptr = f->head_lab; lb_ptr; lb_ptr = lb_ptr->next)
               {	write_label_node(lb_ptr);
     			fprintf(fd,"         ud_chain:");
                        write_blob_list(lb_ptr->ud_chain);
               }
}


/*------------------------------------------------------*
 *		  write_comment_node			*
 *							*
 *	      print out one comment node		*
 *------------------------------------------------------*/
static void 
write_comment_node(cm_ptr)
	PTR_CMNT cm_ptr;
{
	int	n1, n2, n3, n4, n5;
	char	*s;

	n1 = cm_ptr->id;
	n2 = cm_ptr->type;
	n3 = cm_ptr->next ? cm_ptr->next->id : -1;
	s  = cm_ptr->string;
        n4 = cm_ptr->thread? cm_ptr->thread->id : -1;
        n5 = cm_ptr->counter;

	fprintf(fd,"%5d %5d %5d %5d %5d\n%s\n", n1, n2, n3, n4, n5, s);
}


/*------------------------------------------------------*
 *		    write_comment_nodes 		*
 *------------------------------------------------------*/
static void
write_comment_nodes(f)
	PTR_FILE f;
{
	PTR_CMNT cm_ptr;

        fprintf(fd,"  id  type   next   thread   counter     string\n");
	for (cm_ptr = f->head_cmnt; cm_ptr; cm_ptr = cm_ptr->thread)
		write_comment_node(cm_ptr);
}


/*------------------------------------------------------*
 *		    write_filename_nodes		*
 *------------------------------------------------------*/
static void
write_filename_nodes(f)
	PTR_FILE f;
{
	PTR_FNAME filep;

	for (filep = f->head_file; filep; filep = filep->next)
		fprintf(fd,"%5d %s\n", filep->id, filep->name);
}


/*------------------------------------------------------*
 *		   write_dep_node			*
 *							*
 *	    print out one dependence node		*
 *------------------------------------------------------*/
static void 
write_dep_node(dep)
	PTR_DEP dep;
{
	register int j;
	int	n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11,n12;

	n1 = dep->id;
	n2 = dep->type;
	n3 = FOLLOW_DEP_TO_ID(symbol);
	n4 = FOLLOW_DEP_TO_ID(from.stmt);
	n5 = FOLLOW_DEP_TO_ID(from.refer);
	n6 = FOLLOW_DEP_TO_ID(to.stmt);
	n7 = FOLLOW_DEP_TO_ID(to.refer);
	n8 = FOLLOW_DEP_TO_ID(from_fwd);
	n9 = FOLLOW_DEP_TO_ID(from_back);
	n10 = FOLLOW_DEP_TO_ID(to_fwd);
	n11 = FOLLOW_DEP_TO_ID(to_back);
        n12 = dep->thread? dep->thread->id: -1;

	fprintf(fd,"%4d %4d %4d %4d %4d %4d %4d %4d %4d %4d %4d %4d",
	       n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12);

	for (j = 0; j < MAX_DEP; j++)
		fprintf(fd," %2d", (int) dep->direct[j]);

	fprintf(fd,"\n");
}


static
char   *sdeptype[] = {
	 "Flow dependence",
	 "Anti dependence",
	 "Output dependence",
	 "	  "
};

/*------------------------------------------------------*
 *		    write_one_dep			*
 *							*
 *	    print out one dependence relation		*
 *------------------------------------------------------*/
static void 
write_one_dep(dep)
	PTR_DEP  dep;
{
	int i;

	fprintf(fd,"  %-18s,", sdeptype[dep->type]);
	fprintf(fd," symb = %-5s,", dep->symbol ? dep->symbol->ident : " ");
	fprintf(fd," from node %2d(%2d) to node %2d(%2d), dir vector = ",
	   dep->from.stmt->id,dep->from.refer->id,dep->to.stmt->id,dep->to.refer->id);
	for (i = 0; i <= MAX_LP_DEPTH; i++)
		fprintf(fd,"  %d", dep->direct[i]);
	fprintf(fd,".\n");
}


/*--------------------------------------------------------*
 *		    write_dep_comments			  *
 *							  *
 * write out the dependence relations in readable formats *
 *--------------------------------------------------------*/
static void 
write_dep_comments(f)
	PTR_FILE	f;
{
	register PTR_DEP dep;

	if (!f->num_dep)
		return;
	fprintf(fd,"\n\n");
	fprintf(fd," The following %d dependence relations are found:\n",f->num_dep);
	for (dep = f->head_dep; dep && dep->id != -1; dep = dep->thread)
		write_one_dep(dep);
}


/*------------------------------------------------------*
 *		    write_dep_nodes			*
 *------------------------------------------------------*/
static void 
write_dep_nodes(f)
	PTR_FILE	f;
{
	register PTR_DEP dep;

	if (!f->num_dep)
		return;

	fprintf(fd,"  id type symb f-bf f-ll t-bf t-ll ffwd fbak tfwd tbak thread d-vec\n");
	for (dep = f->head_dep; dep && dep->id != -1; dep = dep->thread)
		write_dep_node(dep);
}


int dump_nodes(f, name)
	PTR_FILE f;
	char *name;
{
#include "tag.h"		/* associate string with variant tags */

	if (*name) {		/* filename specified? */
		if ((fd = fopen (name, "w")) == NULL)
			return -1;
	} else
		fd = stdout;

	fprintf(fd,"Source is \"%s\"\n", f->head_file->name);
	write_sizes(f); 	fprintf(fd,"\n");
	write_bif_nodes(f);	fprintf(fd,"\n");
	write_ll_nodes(f);	fprintf(fd,"\n");
	write_symb_nodes(f);	fprintf(fd,"\n");
	write_type_nodes(f);	fprintf(fd,"\n");
	write_label_nodes(f);	fprintf(fd,"\n");
	write_comment_nodes(f); fprintf(fd,"\n");
	write_filename_nodes(f);fprintf(fd,"\n");
	write_dep_nodes(f);
	write_dep_comments(f);
	if (fd != stderr)
		return fclose(fd);
	return 0;
}
