
/* vdecl.c for VPC++                              */
/* Created by Jenq-Kuen Lee Nov 16, 1987         */
/* last modified date /16/06/87/                 */
/* last modified date /16/02/88/                 */
     	
#include "vparse.h"
#include "tag"
#include "vpc.h"
#include "db.h"
#include "vextern.h"

PTR_LLND find_suit_declarator();	
PTR_BLOB follow_blob() ;
PTR_TYPE follow_type() ;
PTR_LLND follow_record_id(),follow_llnd();
PTR_BFND chain_up();
PTR_SYMB find_type_symbol_global();
PTR_SYMB match_name(),find_type_symbol(),install_entry_2();
extern  PTR_SYMB count_first();
extern  int      count_fields_num(),count_record_size();
PTR_TYPE follow_type_1();
PTR_SYMB check_extern_second_part();



int
map_status(rid_value)
int rid_value;
{
   switch (rid_value) {
   case (int) RID_SYN:     return(BIT_SYN);
   case (int) RID_SHARED:  return(BIT_SHARED);
   case (int) RID_PRIVATE: return(BIT_PRIVATE);
   case (int) RID_FUTURE:  return(BIT_FUTURE);
   case (int) RID_VIRTUAL: return(BIT_VIRTUAL);
   case (int) RID_INLINE:  return(BIT_INLINE);


   case (int) RID_UNSIGNED:return(BIT_UNSIGNED);
   case (int) RID_SIGNED : return(BIT_SIGNED);


   case (int) RID_SHORT :  return(BIT_SHORT);
   case (int) RID_LONG :   return(BIT_LONG);


   case (int) RID_VOLATILE:return(BIT_VOLATILE);
   case (int) RID_CONST   :return(BIT_CONST);


   case (int) RID_TYPEDEF :return(BIT_TYPEDEF); 
   case (int) RID_EXTERN  :return(BIT_EXTERN);
   case (int) RID_AUTO :   return(BIT_AUTO);
   case (int) RID_STATIC : return(BIT_STATIC);
   case (int) RID_REGISTER:return(BIT_REGISTER);
   case (int) RID_FRIEND:  return(BIT_FRIEND);
   default: return(0);
   }

 }
	
/* Handle decl statement like  <long int kk> ;   */
/*                                               */
/* ptr1    stand for <long int>  i.e. type_ptr   */
/* ll_ptr1 stand for <kk>  i.e. exprlist         */
/* return  stand for expr_list ll_node           */

PTR_LLND
chain_type_declarator(ptr1, access_flag, ll_ptr1)
PTR_TYPE ptr1;
PTR_LLND ll_ptr1;
int access_flag ;
	
{
PTR_TYPE oldptr,temptr,pp1 ;
PTR_LLND lptr1,lptr2 ;
PTR_SYMB symbptr,symb2;
int type_flag ,double_appear;

             pp1 = ptr1 ;
             type_flag = OFF ;
             if (ptr1->variant == T_DESCRIPT)
	       {  if (ptr1->entry.descriptive.long_short_flag&BIT_TYPEDEF)
		         type_flag = ON ; 
                  else   type_flag = OFF ;
		}
              else   
                {  if (access_flag) 
                      {  pp1 = get_type(fi,T_DESCRIPT) ;
                         pp1->entry.descriptive.base_type = ptr1 ;
                         type_flag = OFF ;
                         pp1->entry.descriptive.long_short_flag|=map_status(access_flag) ; 
		       }
		 }
	     for ( lptr1=ll_ptr1 ; lptr1  ; lptr1 = lptr1->entry.template.ll_ptr2)
		    { lptr2 = find_suit_declarator(lptr1);
    	              symbptr = lptr2->entry.template.symbol ;
                      if (type_flag ==ON) symbptr->variant = TYPE_NAME ;
		      double_appear = OFF;
    	              for (oldptr = temptr = symbptr->type; temptr ; temptr =  temptr->entry.template.base_type)
			{ if ((temptr->variant != T_POINTER)&&(temptr->variant!=T_FUNCTION)&&(temptr->variant!=T_ARRAY))
			    {  double_appear = ON;
			       break;
			     }
    	                  else   oldptr = temptr;
			}
		      if (double_appear == OFF) {
			if (oldptr == NULL)
			  symbptr->type = pp1;
			else
			  oldptr->entry.template.base_type = pp1 ;
		      }
		      symb2=check_extern_second_part(symbptr);
		      if(symb2) lptr2->entry.template.symbol= symb2;
    		    }
	     for ( lptr1=ll_ptr1 ; lptr1  ; lptr1 = lptr1->entry.template.ll_ptr2)
	       { lptr2 = find_suit_declarator(lptr1);
		 symbptr = lptr2->entry.template.symbol ;
		 symbptr->ud_chain = (PTR_BLOB) NULL;
		 symbptr->decl     = NULL;
	       }
              ll_ptr1->type= ptr1;
    	      return(ll_ptr1);
}
    	




	
/* Handle decl statement like  <long int foo()> ;   */
/* ptr1    stand for <long int>  i.e. type_pt   r   */
/* ll_ptr1 stand for <foo>  i.e. FUNCTION_REF       */
/* return  stand for FUNCTION    ll_node            */

void
chain_type_declarator_2(ptr1, symbptr)
PTR_TYPE ptr1;
PTR_SYMB symbptr ;
	
{
PTR_TYPE oldptr,temptr;
PTR_LLND lptr1,lptr2 ;
int type_flag ;
int double_appear = OFF;

    for (oldptr = temptr = symbptr->type; temptr ; temptr =  temptr->entry.template.base_type)
      { if ((temptr->variant != T_POINTER)&&(temptr->variant!=T_FUNCTION)&&(temptr->variant!=T_ARRAY))
	  {  double_appear = ON;
	     break;
	   }
        else   oldptr = temptr;
      }
   if (double_appear == OFF) {
     if (oldptr == NULL)
       symbptr->type = ptr1;
     else
       oldptr->entry.template.base_type = ptr1;
   }
}
    	


    	
    	/*
    	 * <1> type_decl : T_DERIVED_CLASS, T_ENUM , T_STRUCT, T_UNION, T_CLASS
    	 * <2> original_class : SMNULL if (type != T_DERIVED_CLASS)
    	 */
    	
    	PTR_TYPE
    	install_struct(type_decl, original_class)
    	    int      type_decl ;
    	    PTR_LLND original_class ;
    	 {  PTR_SYMB symb_ptr;
    	    PTR_BFND bf1 ;
    	    PTR_SYMB count_first();
    	    int  count_fields_num(),count_record_size();
    	
	  if (type_decl == T_DERIVED_CLASS)
    	    {
    	        bf1 = pred_bfnd ;
    	        new_cur_type = get_type(fi,T_DERIVED_CLASS);
		/* for multiple inheritance need more */
                new_cur_type->entry.derived_class.original_class = pred_bfnd;
    	        new_cur_type->entry.derived_class.num_fields = count_fields_num( pred_bfnd);
    	        new_cur_type->entry.derived_class.record_size = count_record_size(pred_bfnd);
    	        new_cur_type->entry.derived_class.first = count_first(pred_bfnd);
    	        symb_ptr = pred_bfnd->entry.template.symbol;
    	        if (symb_ptr) symb_ptr->type = new_cur_type ;
    	        pred_bfnd = pred_bfnd->control_parent ;
    	      }
    	    else   {
    	        bf1 = pred_bfnd ;
      	        new_cur_type = get_type(fi,type_decl);
                new_cur_type->entry.derived_class.original_class = pred_bfnd;
  	        new_cur_type->entry.derived_class.num_fields = count_fields_num( pred_bfnd);
    	        new_cur_type->entry.derived_class.record_size = count_record_size(pred_bfnd);
    	        new_cur_type->entry.derived_class.first = count_first(pred_bfnd);
    	        symb_ptr = pred_bfnd->entry.template.symbol;
    	        if (symb_ptr) symb_ptr->type = new_cur_type ;
    	        pred_bfnd = pred_bfnd->control_parent ;
    	  }
    	  return(new_cur_type);
    	 }
    	
    	
    	
    	
    	/*
    	 * <1> type_decl : CLASS_DECL, ENUM_DECL STRUCT_DECL, UNION_DECL
    	 * <2> symbol    : SMNULL if not appear
    	 */
    	
    	void
    	enter_inner_level( var_decl,symbol)
   	  int      var_decl ;
   	  PTR_SYMB symbol ;
   	{   PTR_BFND bf1 ;
   	
   	     bf1 = get_bfnd(fi,var_decl,symbol,LLNULL,LLNULL,LLNULL);
             chain_up(pred_bfnd,bf1);
   	     pred_bfnd = bf1 ;
   	     cur_flag = var_decl;
   	     first_symbol = SMNULL;
   	  }
   	
   	
   	/*
   	 * <1> type_decl : CLASS_DECL, ENUM_DECL STRUCT_DECL, UNION_DECL
   	 * <2> symbol    : SMNULL if not appear
   	 */
   	
   	PTR_TYPE 
   	set_struct_typename(var_decl,symbol)
   	  int      var_decl ;
   	  PTR_SYMB symbol;
   	{   PTR_BFND bf1 ;
   	
   	     bf1 = get_bfnd(fi,var_decl,symbol,LLNULL,LLNULL,LLNULL);
             chain_up(pred_bfnd,bf1);
   	     cur_flag = var_decl;
             return(symbol->type);
   	  }
   	
   	
   	
   	
   	/* <1> Given two bif node and linked it together ;
   	 *  
   	 * <2> if pred_bfnd->index == BRANCH_OFF then link it use blob1 
   	 *     else                    link it use blob two
   	 */
   	
   	PTR_BFND
   	chain_up(mother_bfnd,child_bfnd)
   	PTR_BFND mother_bfnd;
   	PTR_BFND child_bfnd ;

   	{  PTR_BLOB blob1,blob2,old_blob ;
   	
   	  switch (mother_bfnd->index) {
   	  case BRANCH_OFF :
   	    
   	     if (child_bfnd)
   	     { 
   	       blob1 = make_blob(fi,child_bfnd,BLNULL);
   	       for (blob2 = old_blob = mother_bfnd->entry.template.bl_ptr1;
   	            blob2 ;
   	            blob2 = blob2->next)   old_blob = blob2;
   	       if (old_blob) old_blob->next = blob1 ;
   	       else  mother_bfnd->entry.template.bl_ptr1 = blob1 ;
   	       child_bfnd->control_parent = mother_bfnd ;
   	     }
   	       break ;
   	   case  BRANCH_ON :
   	     if (child_bfnd)
   	     { 
   	       blob1 = make_blob(fi,child_bfnd,BLNULL);
   	       for (blob2 = old_blob = mother_bfnd->entry.template.bl_ptr2;
   	            blob2 ;
   	            blob2 = blob2->next)   old_blob = blob2;
   	       if (old_blob) old_blob->next = blob1 ;
   	       else  mother_bfnd->entry.template.bl_ptr2 = blob1 ;
   	       child_bfnd->control_parent = mother_bfnd ;
   	     }
	      break ;
   	     default : err("System Down ");
   	   }
   	 }
   	
   	
   	
   	
   	/*
   	 *  <1> declarator
   	 *
   	 *  <2> parmlist 
   	 *  Memo : ll_p1 needs check 
   	 */
   	PTR_LLND
   	func_declarator_appear(l_ptr1,l_ptr2,symb1 )
   	PTR_LLND l_ptr1,l_ptr2;
        PTR_SYMB symb1 ;   	
   {   PTR_TYPE type_1 ;
   	    PTR_LLND ll_p1 ;
   	    PTR_LLND follow_llnd();
   	    PTR_LLND old_ptr ;
            PTR_TYPE type ;
            int level_var,empty_var ;
   	
   	    switch(l_ptr1->variant)  { 
            case DEREF_OP :  ll_p1 =make_llnd(fi,FUNCTION_OP,l_ptr1,LLNULL,SMNULL);
   	                     /* needs check */
   	                     type_1 = get_type(fi,T_FUNCTION);
                             if (!symb1->type)
   			       {  symb1->type = type_1 ;
   				}
   	                     else 
   	                       { type = follow_type(symb1,&level_var,&empty_var);
				 type->entry.template.base_type = type_1 ;

   			       }
                        
   	                     break ;
            case FUNCTION_REF :
   	    case RECORD_REF :
   	    case VAR_REF :
   	                    old_ptr = follow_llnd(l_ptr1,1);
/* The following stat is deleted, we will set it up when we link param with */
/* function_ref                                                             */
/*   	                    old_ptr->entry.template.ll_ptr1 = l_ptr2 ; */
   	                    old_ptr->variant = FUNCTION_REF ;
   	                    cur_flag = cur_flag | RULE_PARAM ;
   	                    ll_p1 =l_ptr1 ;
   	                    break ;
	    default:        err("unexpected format ");
   	    }
   	    return(ll_p1);
   
         }
   
   	
   
   	
        /*
   	 * <1> ll_node1 : LHS low level node
   	 *
   	 * <2> ll_node2 : range_list in the RHS
   	 */
   	PTR_LLND
   	chain_array_range(ll_node1,ll_node2)
   	PTR_LLND ll_node1,ll_node2 ;
   	
   	{   PTR_LLND ll_ptr2,llpr_1 ,follow_llnd(); 
 
   	
   	   if (! ll_node1->entry.template.ll_ptr1)
              {  /* find one */
   
	        ll_node1->variant = ARRAY_REF ;
   	        llpr_1=ll_node1->entry.template.ll_ptr1 = make_llnd(fi,EXPR_LIST,ll_node2,LLNULL,SMNULL);
   	        new_cur_type = get_type(fi,T_ARRAY);
                new_cur_type->entry.ar_decl.ranges =  llpr_1 ;
                new_cur_symb->type = new_cur_type ;
             }
   	   else {
   	        ll_ptr2 = follow_llnd(ll_node1->entry.template.ll_ptr1,2) ;
   	        ll_ptr2->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,ll_node2,LLNULL,SMNULL);
   	      }
   	   return(ll_node1);
   	
   	 }
   	
   	
   	/* <1> Very important subroutine
   	 *     
   	 *
   	 */
   	
   	
   	PTR_LLND
   	follow_llnd(lptr1,sw)
   	PTR_LLND lptr1 ;
   	int sw ;
    
   	{
   	  PTR_LLND old_ptr,lptr;
   	
   	     switch (sw) {
   	     case 1 : for (old_ptr=lptr = lptr1->entry.template.ll_ptr1 ; lptr ; lptr=lptr->entry.template.ll_ptr1)
   	                  old_ptr = lptr ;
   	              if (! old_ptr) old_ptr = lptr1 ;
                      break ;
   	     case 2 : for (old_ptr=lptr = lptr1->entry.template.ll_ptr2 ; lptr ; lptr=lptr->entry.template.ll_ptr2)
                          old_ptr = lptr ;
   	              if (! old_ptr) old_ptr = lptr1 ;
   	              break ;
   	     }
   	     return(old_ptr);
   	}
   	
   


        /* stop when VAR_REF, ARRAY_REF, FUNCTION_REF   */
   	
   	PTR_LLND
   	follow_llnd_until_symb(lptr1,sw)
   	PTR_LLND lptr1 ;
   	int sw ;
    
   	{
   	  PTR_LLND old_ptr,lptr;
   	
   	     switch (sw) {
   	     case 1 : for (old_ptr=lptr = lptr1->entry.template.ll_ptr1 ; lptr ; lptr=lptr->entry.template.ll_ptr1)
   	                    { old_ptr = lptr ;
                              if ((old_ptr->variant == VAR_REF)|| (old_ptr->variant== ARRAY_REF) ||(old_ptr->variant== FUNCTION_REF))
                             break;
			     }
   	              if (! old_ptr) old_ptr = lptr1 ;
                      break ;
   	     case 2 : for (old_ptr=lptr = lptr1->entry.template.ll_ptr2 ; lptr ; lptr=lptr->entry.template.ll_ptr2)
                       {   old_ptr = lptr ;
                           if ((old_ptr->variant == VAR_REF)|| (old_ptr->variant== ARRAY_REF) ||(old_ptr->variant== FUNCTION_REF))
                           break;
                        }
   	              if (! old_ptr) old_ptr = lptr1 ;
   	              break ;
   	     }
   	     return(old_ptr);
   	}
   	
   
/*  primary :- primary [ expr_vector ]
 *  <1> check the LHS format
 *  <2> return : NO if incorrect format at LHS
 *               ID_ONLY if LHS only have id format (including multiple id)
 *               RANGE_APPEAR if LHS format owns both id and range_list
 */

PTR_LLND check_array_id_format(ll_ptr,state)
int *state;
PTR_LLND ll_ptr ;

{   PTR_LLND temp,temp1;

      temp = ll_ptr;
      switch (ll_ptr->variant) {
      case VAR_REF : 
                     *state = ID_ONLY ;
                     return(ll_ptr);
/*      case POINTST_OP:
      case RECORD_REF :
                     temp = ll_ptr->entry.template.ll_ptr2;
                     if (temp->variant == VAR_REF)
                       { *state = ID_ONLY ;
                         return(temp);
		       }
  */
      case ARRAY_REF :
                     temp1 = follow_llnd(temp->entry.template.ll_ptr1,2);
                     *state = RANGE_APPEAR;
		     return(temp1);
      case  ARRAY_OP:temp1 = follow_llnd(temp->entry.template.ll_ptr2,2);
                     *state =RANGE_APPEAR ;
                     return(temp1);
	default :    *state = ARRAY_OP_NEED ;
                     return(temp);
      }
  }


/* Used Place :
 *      Primary :- primary  . identifier
 *
 * <1> given two low level node
 *     ptr1 : stands for the current LHS format for record structure
 *   h_ptr2 : stands for the new field hash_entry
 *
 * <2> sw : FUNCTION_ONLY represent Needs function
 *      
 * <3> side effect : right_symbol = symbol_ptr for h_ptr2;
 */

int
check_field_decl(ptr1,h_ptr2,sw)
PTR_LLND ptr1 ;
PTR_HASH h_ptr2 ;
int sw ;

{  PTR_LLND  last_ll ;
   PTR_SYMB symbptr,first ;
   PTR_TYPE typeptr_1;
   int      finding,num ;
   int      dummy_level,empty_var;


   typeptr_1 = follow_type_1(ptr1->type, &dummy_level,&empty_var);
   if (dummy_level != 0) err(" not a proper member or union/struct requierd");
   if (empty_var == YES) err("struct/union type definition have not appeared");
   switch (typeptr_1->variant) {
   case T_RECORD :
   case T_UNION :
   case T_STRUCT :
   case T_ENUM :
   case T_CLASS :
           finding = NO ;  right_symbol =SMNULL ;
           for (first=typeptr_1->entry.derived_class.first; first  ;  )
             { if (!strcmp(first->ident,h_ptr2->ident))
		 { finding = YES;
                   right_symbol = first ;
                   break ;
                 }
               else
                 {
                   if (first->variant == FIELD_NAME)
                       first = first->entry.field.next;
		   else
  		       first = first->entry.member_func.next;
                 }
	     }
          if (finding == NO) { err("error fields"); return(NO); }
          else 
	    {  if (first->variant == MEMBER_FUNC)
                    if (sw == FUNCTION_ONLY) return(YES);
                    else                     return(YES);
               else
                    if (sw == FUNCTION_ONLY) return(NO);
                    else                     return(YES);
          
	     }
     default :  err("not implemented");
	 }
 }

/*  Same as check_field_decl except input argument are two symbol_ptr
 *  if sw == FUNCTION_ONLY then entry2 must be function_name
 *  side effect : right_symb = symbol_ptr for entry2
 */
int
check_field_decl_2(symb1,entry2,sw)
PTR_SYMB symb1 ;
PTR_HASH entry2 ;
int sw ;

{  PTR_LLND  last_ll ;
   PTR_SYMB symbptr,first ;
   PTR_TYPE typeptr_1;
   int      finding,num;
   int      temp_level,empty_var;
 


   typeptr_1 = follow_type(symb1, &temp_level,&empty_var);
   if (empty_var == YES) err("struct/union type definition have not appeared");
   switch (typeptr_1->variant) {
   case T_RECORD :
   case T_UNION :
   case T_STRUCT :
   case T_ENUM :
   case T_CLASS :
           finding = NO ;
           for (first=typeptr_1->entry.derived_class.first;first ; )
             { if (!strcmp(first->ident,entry2->ident))
		 { finding = YES;
                   right_symbol = first;
                   break ;
                 }
               else
                 {
                   if (first->variant == FIELD_NAME)
                       first = first->entry.field.next;
		   else
  		       first = first->entry.member_func.next;
                 }
	     }
          if (finding == NO) { err("error fields"); return(NO); }
          else 
	    {  if (first->variant == MEMBER_FUNC)
                    if (sw == FUNCTION_ONLY) return(YES);
                    else                     return(YES);
               else
                    if (sw == FUNCTION_ONLY) return(NO);
                    else                     return(YES);
          
	     }
     default :  err("not implemented");
	 }
 }



/* Important basic routine
 * <1> if a linked type , follow the link
 * <2> if the last one of the type line is typename, follow the new typename
 * <3> return the target type (last type) in the link
 * <4> derived_class needs more
 */
PTR_TYPE
follow_type(symb1, level,empty_sw)
PTR_SYMB symb1 ;
int  *level ;
int  *empty_sw;
{  PTR_TYPE follow_type_1();
   PTR_TYPE type;
   int      temp_level,temp_sw ;
  
   type = follow_type_1(symb1->type, &temp_level,&temp_sw) ;
   *empty_sw= temp_sw;
   *level = temp_level ;
   return(type);
}


PTR_TYPE
follow_type_1(passing_type, level_depth,empty_sw)
PTR_TYPE passing_type;
int      *level_depth;
int      *empty_sw;

{ PTR_TYPE type,old_type ;
  PTR_SYMB temp_symbptr;
  int level,temp_sw ;

  level = 0;
  temp_sw = NO;
  for (old_type= type=passing_type ;type ; )
   {   old_type = type ;
       switch(type->variant) {
       case T_ARRAY :
	    level = level + num_dimension(type);
            type = type->entry.template.base_type ;
            break;
       case T_FUNCTION :
            type = type->entry.template.base_type ;
            break;
       case T_POINTER  :
            level = level + type->entry.template.dummy1 ;
            type = type->entry.template.base_type ;
            break;
       case T_DESCRIPT :
            type = type->entry.descriptive.base_type ;
            break;
       case T_DERIVED_TYPE :
            temp_symbptr = type->entry.derived_type;
	    if (!(type = temp_symbptr->type))
	      {
		temp_sw=YES;
		old_type =(PTR_TYPE) temp_symbptr;
	      }
            break;
       
       /* case T_DERIVED_CLASS :
            err("not implementin........");
            break;  */
       default :
            type = (PTR_TYPE) NULL ;
	  }
     }
   *level_depth = level ;
   *empty_sw    = temp_sw;
   return(old_type);
}



/* check_format_function()
 * <1> Used by :  primary :- primary ( primary )
 * <2>  return value : low_ptr point to last id field if *state==FUNC_CALL
 *                     LLNULL                         if *state==FUNCTION_OP
 */

PTR_LLND 
check_format_function(ll_ptr,state)
PTR_LLND ll_ptr;
int      *state ;
{    PTR_LLND  ll_ptr2 ;


   if ((ll_ptr->variant==RECORD_REF) ||(ll_ptr->variant==FUNC_CALL))
     {   ll_ptr2 = follow_llnd(ll_ptr,1);
         *state = FUNC_CALL;
         return(ll_ptr2);
       }
   else
     {   if (!(primary_flag && EXPR_LR)) err("syntax error 4");
         else         *state = FUNCTION_OP ;
         return(LLNULL);
       }

 }
                 





/*  RETURN VALUE :
 *  <1> ONE  if current declaration is not a field
 *  <2> TWO  is a member but is first one
 *  <3> THREE if it is  a Field and is not first one
 *
 */
int
find_first_field(pred)
PTR_BFND  pred ;
{   PTR_LLND l2,ll_ptr1;
    PTR_BFND bf1 ;
    PTR_BLOB blob;
    int state ;

    switch (pred->variant) {
    case ENUM_DECL :
    case STRUCT_DECL:
    case UNION_DECL:
    case CLASS_DECL:
    case DERIVED_CLASS_DECL :
          if (!(blob=pred->entry.template.bl_ptr1))
	    {  state = (!first_symbol) ? TWO : THREE ; }
          else
            {  
             for ( ; blob ; blob = blob->next )
	     {
               bf1 = blob->ref ;
               ll_ptr1 = bf1->entry.template.ll_ptr1 ;
               if ( ll_ptr1) 
		 {  l2 = follow_llnd_until_symb(ll_ptr1,1);
                    first_symbol = l2->entry.template.symbol;
                    state = THREE ;
		    break ;
		  }
	      }
             if (!blob)  state = (!first_symbol) ? TWO : THREE ; 
	   }
            break;
     default : state = ONE ;
      }
     return(state);
}    
 

/*  RETURN fist_filed_symb */
PTR_SYMB
find_first_field_2(pred)
PTR_BFND  pred ;
{   PTR_LLND l2,ll_ptr1;
    PTR_BFND bf1 ;
    PTR_SYMB symbol;
    PTR_BLOB blob;
    int state ;

    switch (pred->variant) {
    case ENUM_DECL :
    case STRUCT_DECL:
    case UNION_DECL:
    case CLASS_DECL:
    case DERIVED_CLASS_DECL :
          if (!(blob=pred->entry.template.bl_ptr1))
                return(SMNULL);
          else
            {  
             for ( ; blob ; blob = blob->next )
	     {
               bf1 = blob->ref ;
               ll_ptr1 = bf1->entry.template.ll_ptr1 ;
               if ( ll_ptr1) 
		 {  l2 = follow_llnd(ll_ptr1,1);
                    symbol = l2->entry.template.symbol;
                    return(symbol);
		  }
	     }
	   }
            break;
     default : state = ONE ;
      }
     return(SMNULL);
}    
 


void
chain_field_symb(first_one, current_one)
PTR_SYMB first_one,current_one ;
{  PTR_SYMB old_symb,symb;

     for ( old_symb = symb = first_one ;symb  ;   )
       {  old_symb = symb ;
          switch (symb->variant) {
          case FIELD_NAME : symb = symb->entry.field.next ;
                            break;
          case MEMBER_FUNC :symb = symb->entry.member_func.next ;
                            break;
	  }
	}
      if (old_symb->variant == FIELD_NAME)
          old_symb->entry.field.next = current_one ;
      else
          old_symb->entry.member_func.next = current_one ;
   }




int
map2( variant)
int variant ;
{
   switch (variant)  {
   case  VARIABLE_NAME : return(VAR_REF);
   case  FUNCTION_NAME :
   case  MEMBER_FUNC   : return(FUNCTION_REF);
   case  FIELD_NAME    : return(VAR_REF);
     default :           return(VAR_REF);

   }

 }






void 
type_checking(x1,x2)
PTR_HASH  x1;
int x2 ;
{
  /* dummy */

}



/* <1> Given a bif_node which is supposed to be a record-like declaraion 
 * <2> Try to find the first symbol in the record bif_node 
 * 
 *
 *
 */
PTR_SYMB
count_first(bf_ptr)
PTR_BFND bf_ptr ;

{ PTR_BLOB blob_1 ;
  PTR_SYMB symb ;
  PTR_LLND ll_node, ll_exprlist ,ll_node2 ;
 
  if (blob_1  = bf_ptr->entry.template.bl_ptr1)
     {
         ll_node = blob_1->ref->entry.template.ll_ptr1 ;
         ll_exprlist = ll_node->entry.template.ll_ptr1 ;
         ll_node2 = find_suit_declarator(ll_exprlist);
         symb = ll_node2->entry.template.symbol;
       }
   else symb = SMNULL ;
   return(symb);
 
}



int
count_fields_num(bf_ptr)
PTR_BFND bf_ptr  ;

{    int num ;
     PTR_SYMB symb ;

     symb = count_first(bf_ptr);
     num = follow_field(symb,ONE);
     
}

count_record_size(bf_ptr)
PTR_BFND bf_ptr  ;

{
     return(0) ;
    /* dummy */
   }

int
follow_field(symbptr,sw)
PTR_SYMB symbptr;
int      sw ;

{  int count ;  
   PTR_SYMB symb1 ;

      count = 0 ;
      for (symb1 = symbptr ;   symb1 ;  )
	{     count++ ;
              switch (symb1->variant) {
              case MEMBER_FUNC :
                    symb1 = symb1->entry.member_func.next ;
                    break;
              case FIELD_NAME :
                    symb1 = symb1->entry.field.next ;
                    break;
              default :
                    err("error 11 ") ;
		  }
	    }
    return(count);
}




throw_away(x1)
PTR_BLOB x1 ;
{
 /* dummy */
}


/* <1> Given a ll_node which is supposed to be a ll_ptr1 of expr_list node
 * <2> Intelligent routine will try to find declarator in this branch
 * <3> The following node is possible delarator
 *     ARRAY_REF  VAR_REF  FUNCTION_REF
 */
PTR_LLND 
find_suit_declarator(low_node)
PTR_LLND  low_node ;

{  PTR_LLND flow_ptr;
   for ( flow_ptr = low_node;flow_ptr ;flow_ptr = flow_ptr->entry.template.ll_ptr1)
     {  if ((flow_ptr->variant == VAR_REF) ||
            (flow_ptr->variant == ARRAY_REF) ||
            (flow_ptr->variant == FUNCTION_REF) ) return(flow_ptr);
      }
    if (!flow_ptr) { err("system crash");
                     return(LLNULL) ;
                   }
 }



/* <1> original_type is given
 * <2> Initial and duplicated error checking need more
 * <3> type_mod may be type_mod or sc_class
 * <4> return the original type_ptr
 */
PTR_TYPE
install_declmod(original_type,type_mod)
PTR_TYPE original_type ;
int type_mod ;

{
   original_type->entry.descriptive.long_short_flag |= map_status(type_mod);
   return(original_type);

 }



/* combine two descriptive type and clean second one */
PTR_TYPE
combine_2(original, second_one)
PTR_TYPE original;
PTR_TYPE second_one;

{ int dd ;

  original->entry.descriptive.long_short_flag |= second_one->entry.descriptive.long_short_flag;
  second_one->entry.descriptive.long_short_flag = OFF ;
  return(original);

}





PTR_LLND
lazy_install(entry , variant,err_sw)
PTR_HASH entry;
int variant ;
int err_sw;
{  int sw ;
   int decl_temp;
   PTR_LLND ll_node,lptr,expr_llnd;
   PTR_BLOB blob ;
   PTR_BFND bf1 ;
   PTR_SYMB  name ;
   PTR_SYMB install_entry();


 if ( (pred_bfnd->variant == FUNC_HEDR)&& (pred_bfnd->entry.template.symbol)&&
      (pred_bfnd->entry.template.symbol->dovar     >= XDECL ))
   {
     new_cur_symb = match_name(pred_bfnd->entry.template.symbol,entry);
     if (! new_cur_symb) { err("Unmatched Parameter symbol ");
                           ll_node = LLNULL ;
			 }
     else {
            ll_node = make_llnd(fi,map2(variant),LLNULL,LLNULL,new_cur_symb);
            new_cur_type = (PTR_TYPE) NULL ;
            cur_flag = RULE_ID ;
	  }
   }
   else
   {       
       sw = find_first_field(pred_bfnd);
       if (sw >= 2)
         {  if (variant == FUNCTION_NAME) decl_temp = MEMBER_FUNC ;
            else                          decl_temp = FIELD_NAME ;
	  }
       else    decl_temp = variant ;
       new_cur_symb = find_type_symbol(entry,decl_temp);
       if ( (! new_cur_symb) || ( new_cur_symb->scope != pred_bfnd))
           {  new_cur_symb = install_entry_2(entry,decl_temp,YES); }
       else
	 {  
	   if (err_sw ==  YES) err_symb(" redeclaration symbol ",new_cur_symb->ident);
	   else {
	     /* ud_chain used for type */
	     if (!new_cur_symb->decl)
	       {
		 new_cur_symb->ud_chain = (PTR_BLOB) new_cur_symb->type;
		 new_cur_symb->decl  = new_cur_symb->variant;
	       }
	     else 
	       {
		 if (is_complete_chain(new_cur_symb->ud_chain))
		   {  if (new_cur_symb->scope !=global_bfnd)
			err_symb("redelcaration symbol",new_cur_symb->ident);
		    }
	       }
	     new_cur_symb->type = (PTR_TYPE) NULL;
	     new_cur_symb->variant = decl_temp;
	   }
	 }

       if ( new_cur_symb) {
            if ((sw >= 2) && (name = pred_bfnd->entry.template.symbol))
	      {  if (decl_temp == MEMBER_FUNC)
                      new_cur_symb->entry.member_func.base_name = name ;
                 else new_cur_symb->entry.field.base_name       = name ;
	       }
            if (sw == 3) chain_field_symb(first_symbol,new_cur_symb);
            if (sw == 2) first_symbol = new_cur_symb ;
            ll_node = make_llnd(fi, map2(decl_temp) ,LLNULL,LLNULL,new_cur_symb); 
            new_cur_type  = (PTR_TYPE) NULL ;
            cur_flag = RULE_ID ;
	  }
     }

     switch (main_type_flag) {
     case TYPE_ONE :
     case TYPE_TWO : 
     case TYPE_FOUR : bf1 = get_bfnd(fi,VAR_DECL,SMNULL,LLNULL,LLNULL,LLNULL);
                      chain_up(pred_bfnd,bf1);   /* run forward */
                      expr_llnd = make_llnd(fi,EXPR_LIST,ll_node,LLNULL,SMNULL);
                      bf1->entry.template.ll_ptr1 = expr_llnd ;
                      main_type_flag = TYPE_CLEAN ;       
                      break ;
     case TYPE_THREE: blob = follow_blob(pred_bfnd);
                      bf1 = blob->ref;
                      expr_llnd = make_llnd(fi,EXPR_LIST,ll_node,LLNULL,SMNULL);
                      bf1->entry.template.ll_ptr1 = expr_llnd ;
                      main_type_flag = TYPE_CLEAN ;       
                      break;
     case TYPE_CLEAN: blob = follow_blob(pred_bfnd);
                      bf1 = blob->ref;
                      expr_llnd = make_llnd(fi,EXPR_LIST,ll_node,LLNULL,SMNULL);
                      lptr = follow_llnd(bf1->entry.template.ll_ptr1,2);
                      lptr->entry.template.ll_ptr2 = expr_llnd ;
                      break;
     }

     return(ll_node);

 }
/* <1> unconditionally install parameter entry since it is first time appear
 * <2> link function_name with parameter
 * <3> the scope of the parameter is function not pred_bfnd
 * <4> the only check needed is to see if the parameter name is duplicated
 */
PTR_SYMB
install_parameter(entry,variant)
PTR_HASH entry;
int variant ;
{
   PTR_SYMB install_entry_2();
   PTR_SYMB find_proc_name();
   void     chain_function_param();
   int      is_duplicated(), sw ;       
   PTR_SYMB function_symb;
   PTR_LLND ll_node ;

       function_symb = find_proc_name();
       transform_symb_node(function_symb);
       sw = is_duplicated(function_symb,entry);
       if (sw == YES)
	 { 
           err("duplicated parameter ");
           return(SMNULL) ;
	 }
       else  
	 {  new_cur_symb = install_entry_2(entry,variant,NO);
            chain_function_param(function_symb,new_cur_symb); 
            new_cur_type  = (PTR_TYPE) NULL ;
            cur_flag = RULE_ID ;
            return(new_cur_symb);
         }
 }



PTR_BLOB
follow_blob(bfnd1)
PTR_BFND bfnd1 ;
{
 PTR_BLOB blob,old_blob;

  switch ( pred_bfnd->index ) {
  case BRANCH_OFF:
    for (  old_blob = blob = bfnd1->entry.template.bl_ptr1; 
           blob ;
           blob = blob->next)
           old_blob = blob ;
    return(old_blob);
  case BRANCH_ON:
    for (  old_blob = blob = bfnd1->entry.template.bl_ptr2; 
           blob ;
           blob = blob->next)
           old_blob = blob ;
    return(old_blob);
  }
}


PTR_BLOB
follow_blob_2(bfnd1)
PTR_BFND bfnd1 ;
{
 PTR_BLOB blob,old_blob;

    for (  old_blob = blob = bfnd1->entry.template.bl_ptr2; 
           blob ;
           blob = blob->next)
           old_blob = blob ;
    return(old_blob);
}

/* <1> Using pred_bfnd to find the bif_node of the current funtion_header
 *     or the symbol_declarator which is recently parsed.
 * <2> called by install_parameter
 * <3> return symbol of the function_name
 */

PTR_SYMB 
find_proc_name()
{
  PTR_BFND bf_node;
  PTR_SYMB symb ;
  PTR_BLOB blob,old_blob ;
  PTR_LLND ll_node,llptr,lptr2 ;

    old_blob = follow_blob(pred_bfnd);
    if (! old_blob)
      {   symb = SMNULL ;
          err("UNEXPECTED at find_proc_name ");
	}
    else
      {  llptr = old_blob->ref->entry.template.ll_ptr1;
         ll_node = follow_llnd(llptr,2);
         lptr2 = ll_node->entry.template.ll_ptr1 ;
         symb = lptr2->entry.template.symbol ;
       }
   return(symb);
}




/* <1> called by install_parameter()
 * <2> question: the data strcuture seems donot allow the parameter again to
 *                be function
 * <3> chain_function_name with parameter
 */

void   
chain_function_param(functor,new_cur_symb1)
PTR_SYMB functor, new_cur_symb1 ;
{ 
   PTR_SYMB list1,old_list ;
   

   for ( old_list = list1 = functor->entry.member_func.in_list ; list1 ; list1 = list1->entry.var_decl.next_in)
         old_list = list1 ;
   if (!old_list )
       functor->entry.member_func.in_list = new_cur_symb1 ;
   else
       old_list->entry.var_decl.next_in  = new_cur_symb1 ;

 }


/* <1> called by install_parameter
 * <2> check if the parameter has alreday appeared before
 * <3> return YES if duplicated  NO otherwise
 */

int
is_duplicated(functor,entry)
PTR_SYMB functor ;
PTR_HASH entry ;
{
   PTR_SYMB list1;
   

   for ( list1 = functor->entry.member_func.in_list ; list1 ; list1 = list1->entry.var_decl.next_in)
     {
        if (!strcmp( entry->ident,list1->ident) )
           return(YES);
        
      }

      if (!list1 )   return(NO);
      
 }







transform_symb_node(functor)
PTR_SYMB functor ;
{
 PTR_SYMB base_name,next_one ;
 int tag, offset, public_bit ;
 switch(functor->variant) {
 case FIELD_NAME :
                   functor->variant = MEMBER_FUNC ;
                   base_name =functor->entry.field.base_name;
                   next_one = functor->entry.field.next;
                   tag      = functor->entry.field.tag;
                   offset   = functor->entry.field.offset ;
                   functor->entry.field.base_name = SMNULL ;
                   functor->entry.field.next      = SMNULL ;
                   functor->entry.field.tag       = NULL ;
                   functor->entry.field.offset    = NULL ;
                   functor->entry.member_func.base_name = base_name;
                   functor->entry.member_func.next = next_one ;
                   functor->entry.member_func.num_output = 0 ;
                   functor->entry.member_func.num_io = 0 ;
                   break;

 case VARIABLE_NAME :
                   functor->variant = FUNCTION_NAME ;
                   break;
 default:          break ;
		 }
}


 

PTR_SYMB
match_name(functor,entry)
PTR_SYMB functor;
PTR_HASH entry ;
{ 
   PTR_SYMB list1;
   

   for ( list1 = functor->entry.member_func.in_list ; list1 ; list1 = list1->entry.var_decl.next_in)
      {    if (! strcmp(list1->ident,entry->ident)) return(list1) ;
  
	 }
   return(SMNULL);

 }



fill_type_for_param(functor)
PTR_SYMB functor;
{ 
   PTR_SYMB list1;
   for ( list1 = functor->entry.member_func.in_list ; list1 ; list1 = list1->entry.var_decl.next_in)
     if (!list1->type) list1->type = global_default;

 }


int
is_basic_block()
{
  PTR_BLOB blob;
  PTR_BFND bf1 ;
  PTR_SYMB symb, functor,list1 ;
  PTR_LLND lptr1,ll_kptr ;

 switch (pred_bfnd->index) {
 case  BRANCH_ON :
        blob = pred_bfnd->entry.template.bl_ptr2;
        break;
 case BRANCH_OFF:
        blob = pred_bfnd->entry.template.bl_ptr1;
	break;
      }
 if ((blob)&&( pred_bfnd->variant!= FUNC_HEDR))
   return(1);
 if (pred_bfnd->variant == BASIC_BLOCK) return(1);
 if (!blob) return(0);
 blob = follow_blob(pred_bfnd);
 bf1 =  blob->ref ;
 lptr1 = bf1->entry.template.ll_ptr1 ;
 if (( lptr1) && ((bf1->variant == VAR_DECL) ||
                  (bf1->variant == CLASS_DECL) ||
		  (bf1->variant == ENUM_DECL) ||
		  (bf1->variant == UNION_DECL) ||
		  (bf1->variant == STRUCT_DECL) ||
		  (bf1->variant == DERIVED_CLASS_DECL)))
   {   ll_kptr = find_suit_declarator(lptr1);
       if (ll_kptr) symb = ll_kptr->entry.template.symbol ;
       functor = pred_bfnd->entry.template.symbol ;
       for ( list1 = functor->entry.member_func.in_list ; list1 ; list1 = list1->entry.var_decl.next_in)
       {
          if ( symb == list1)  return(0);
        }

       if (!list1 )   return(1);

     }

   return(1);
}




this_is_class(variant)
int variant ;
{
  switch(variant) {

  case CLASS_DECL :
  case UNION_DECL :
  case STRUCT_DECL :
  case ENUM_DECL :
  case DERIVED_CLASS_DECL:  return(1);
    default :               return(0);
  }

}







/* Given a TYPENAME hash_entry, to find the exact symbol for this type
 * flag : OFF  stands for find a id don't care any kind of id
 *
 */
PTR_SYMB
find_field_symb_by_type(type,entry)
PTR_HASH entry ;
PTR_TYPE type ;
{  PTR_SYMB old_symb,symb;
   PTR_TYPE final_type ;
   int      temp_level,empty_sw ;

   final_type = follow_type_1(type, &temp_level,&empty_sw);
   if (temp_level != 1) err(" not a proper pointer to struct/union  ");
   if (empty_sw == YES) err("struct/union type definition have not appeared");
   switch (final_type->variant) {
   case T_STRUCT :
   case T_ENUM :
   case T_UNION:
   case T_CLASS:
   case T_DERIVED_CLASS:

     for ( old_symb = symb = final_type->entry.derived_class.first ;symb  ; )
       {  old_symb = symb ;
          if ( ! strcmp(symb->ident,entry->ident))
              return(symb);
          switch (symb->variant) {
          case FIELD_NAME : symb = symb->entry.field.next ;
                            break;
          case MEMBER_FUNC :symb = symb->entry.member_func.next ;
                            break;
	  }
	}
      /* go head */
   default:
     err("not a proper member");
     return(SMNULL);
   }

 }



/* Need More  */
PTR_TYPE
type_conversion(type1,type2)
PTR_TYPE type1,type2;
{  PTR_TYPE type_a,type_b ;
   int level1, level2 ;
   int temp_var1,temp_var2;

   type_a = follow_type_1(type1, &level1,&temp_var1);
   type_b = follow_type_1(type2, &level2,&temp_var2);
   if ((type_a == type_b) && (level1 == level2)) return(type1);
   if ( (type_a->variant== T_CHAR) || (type_a->variant ==T_INT)|| (type_a->variant ==DEFAULT) )
     { if (level1 <= level2) return(type2);      
       else                  return(type1);      
     }
   if ( (type_b->variant== T_CHAR) || (type_b->variant ==T_INT|| (type_b->variant ==DEFAULT) ))
    { if (level2 <= level1) return(type1);
      else                  return(type2);
    }

   if ((((type_a->variant == T_DOUBLE)||(type_a->variant==T_FLOAT))&&
       ((type_b->variant == T_DOUBLE)||(type_b->variant==T_FLOAT)))&&(level1==level2)) 
     { if (type_a->variant==T_DOUBLE) return(type1);
       else                           return(type2);
     }
   warning("illegal type combination");
   return(type1);

 }


/* <1> Given the array symbol in the primary_expression
 * <2> Since the A and A[i] and A[i][j] means different type, this routine
 *     adjust these difference.
 * <3> If the array range_list appear later, the next routine adjust_deref_type
 *     will work correspondingly.
 */
PTR_TYPE
adjust_array_type(symb_ptr)
PTR_SYMB symb_ptr;
{  int counter ;
   PTR_TYPE n_type,new_base_type ;
   PTR_LLND ll_ptr,ll_ptr2 ;
   
   
   counter = 0 ;
   n_type = symb_ptr->type ;
   if (symb_ptr->type->variant == T_ARRAY)
     {   for( ll_ptr2=ll_ptr = symb_ptr->type->entry.ar_decl.ranges ;
              ll_ptr ;
              ll_ptr = ll_ptr->entry.template.ll_ptr2 )
          counter++;
          if (counter)
            {  n_type = get_type(fi,T_POINTER);
	       new_base_type = get_type(fi,T_ARRAY);
	       new_base_type->entry.ar_decl.ranges = ll_ptr2->entry.template.ll_ptr2;
	       new_base_type->entry.ar_decl.num_dimensions= counter -1;
	       new_base_type->entry.ar_decl.base_type = symb_ptr->type->entry.ar_decl.base_type;
               n_type->entry.template.base_type =new_base_type;
	     }
	 return(n_type);
       }
/*   if (symb_ptr->type->variant == FUNCTION_REF)
     {  n_type = get_type(fi,T_POINTER);
	new_base_type = get_type(fi,T_FUNCTION);
	new_base_type->entry.template.base_type = symb_ptr->type;
	n_type->entry.template.base_type = new_base_type;
	return(n_type);
      }
*/
    return(n_type);
} 


PTR_TYPE
adjust_deref_type(type, index)
PTR_TYPE type ;
int index ;
{ PTR_TYPE n_type ;
  switch (index) {
  case DEREF_OP:
/*  if (type->variant == T_POINTER)
    {  type->entry.template.dummy1-- ;
       n_type = type ;
     }
  else
*/
    {   n_type = get_type(fi,T_POINTER) ;
        n_type->entry.template.dummy1 = -1 ;
        n_type->entry.template.base_type = type ;
      }
   break;
  case ADDRESS_OP:
/*  if (type->variant == T_POINTER)
    {  type->entry.template.dummy1++ ;
       n_type = type ;
     }

  else
*/
    {   n_type = get_type(fi,T_POINTER) ;
        n_type->entry.template.base_type = type ;
      }
   break;
  }

 return(n_type); 
}






void   
change_param_scope(functor,bif_ptr)
PTR_SYMB functor;
PTR_BFND bif_ptr;
{ 
   PTR_SYMB list1 ;
   

   for ( list1 = functor->entry.member_func.in_list ; list1 ; list1 = list1->entry.var_decl.next_in)
          list1->scope = bif_ptr ;
 }


eliminate_lastlink()
{
  PTR_BLOB blob, old_blob ;
  
  switch ( pred_bfnd->index ) {
  case BRANCH_OFF:   blob = pred_bfnd->entry.template.bl_ptr1 ;
                     if (!blob) return;
                     old_blob = (PTR_BLOB) NULL ;
                     for ( blob = pred_bfnd->entry.template.bl_ptr1; 
                          (blob) && (blob->next) ;
                           blob = blob->next)
                                    old_blob = blob ;
                     if (!old_blob)
	           	        pred_bfnd->entry.template.bl_ptr1 = (PTR_BLOB) NULL;
                     else
	          	        old_blob->next = (PTR_BLOB) NULL ;
                     break;
   case BRANCH_ON:
                     blob = pred_bfnd->entry.template.bl_ptr2 ;
                     if (!blob) return;
                     old_blob = (PTR_BLOB) NULL ;
                     for ( blob = pred_bfnd->entry.template.bl_ptr2; 
                          (blob) && (blob->next) ;
                           blob = blob->next)
                                    old_blob = blob ;
                     if (!old_blob)
	           	        pred_bfnd->entry.template.bl_ptr2 = (PTR_BLOB)  NULL;
                     else
	          	        old_blob->next = (PTR_BLOB) NULL ;
                     break;
  }
}


PTR_SYMB
next_member(name)
PTR_SYMB name;
{
  switch(name->variant) {
  case FIELD_NAME:
       return(name->entry.field.next);
  case MEMBER_FUNC:
       return(name->entry.member_func.next);
     }

}


fill_comment()
{ PTR_BLOB blob1 ;
  PTR_BFND bf1 ;
  PTR_CMNT fetch_comment_queue();
 
 blob1= follow_blob(pred_bfnd);
 bf1 =blob1->ref ;
 if (!(bf1->entry.template.cmnt_ptr))
   {   bf1->entry.template.cmnt_ptr = fetch_comment_queue(); }

}

/***************************************************************************/
/* chain_up_type : A simple routine to chain two type together             */
/*                 chain(typ1,typ2) === type2--->type1                     */
/* return(type)                                                            */
/***************************************************************************/
PTR_TYPE
chain_up_type(type1,type2)
PTR_TYPE type1,type2;
{ PTR_TYPE oldptr,temptr;

  if (!type2) return(type1);
  if (!type1) return(type2);
  for (oldptr = temptr = type2;temptr;temptr=temptr->entry.template.base_type)
    oldptr = temptr;
  oldptr->entry.template.base_type = type1;
  return(type2);
}

/*****************************************************************************/
/* type: a type pointer                                                      */
/* pllnd: a range_list llnd                                                  */
/*****************************************************************************/
PTR_TYPE
chain_type_with_array_range(type,pllnd)
PTR_TYPE type;
PTR_LLND pllnd;
{ PTR_TYPE oldptr,temptr;
  PTR_TYPE return_type;
  PTR_LLND p2;

  return_type = type;
  for (oldptr = temptr = type;temptr;temptr=temptr->entry.template.base_type)
    oldptr = temptr;
  /* follow range_list   */
  if (!oldptr) return_type = oldptr = get_type(fi,T_ARRAY);
  if (oldptr->variant != T_ARRAY) 
    oldptr = oldptr->entry.template.base_type = get_type(fi,T_ARRAY);
  if (!oldptr->entry.ar_decl.ranges) 
    oldptr->entry.ar_decl.ranges = pllnd;
  else
    {  p2 = follow_llnd(oldptr->entry.ar_decl.ranges,2);
       p2->entry.template.ll_ptr2=pllnd;
     }
  return(return_type);
}

  


num_dimension(type)
PTR_TYPE type;
{  int i ;
   PTR_LLND p1;

   i = 0 ;
   for (p1 = type->entry.ar_decl.ranges; p1 ; p1 = p1->entry.template.ll_ptr2)
     i++;
   return(i);
 }

/* Need More for record_ref point_stat */
is_variable(pllnd)
PTR_LLND pllnd;
{
  PTR_LLND p1,p2;

  if (!p1) return(1);
  p1= follow_llnd(pllnd,1);
  switch (p1->variant) {
  case ARRAY_REF:
    return(0);

  case FUNCTION_REF:
  default:
    return(1);
  }
}




check_extern_first_part(symb)
PTR_SYMB symb;
{

  if (!is_same_type(symb->type,symb->ud_chain,1)) err_symb("redeclaration symbol",symb->ident);


}



PTR_SYMB
check_extern_second_part(symb)
PTR_SYMB symb;
{
  PTR_TYPE type;
  int extern1_flag, extern2_flag;
  PTR_SYMB symb2;

  if (symb->decl) {
    extern1_flag = query_extern(symb->type);
    extern2_flag = query_extern(symb->ud_chain);
    if (!is_complete_chain(symb->ud_chain))
      {
	if ((extern1_flag !=((int)RID_EXTERN))&&(symb->variant!=FUNCTION_NAME))
	    err_symb("redeclaration symbol",symb->ident);
      }
    else
      { 
	if (!is_same_type(symb->type,symb->ud_chain,2))  
	  err_symb("redelaration symbol",symb->ident);
	else 
	  if (symb->variant !=((int) symb->decl))err_symb("redelaration symbol",symb->ident);
	  else if (symb->variant == FIELD_NAME)  err_symb("redelaration symbol",symb->ident);  
	  else if ((extern1_flag !=((int) RID_EXTERN))&&(extern2_flag !=((int) RID_EXTERN))&&(symb->variant!=FUNCTION_NAME))
	    err_symb("redelaration symbol",symb->ident);
      }
  }
  else {
    if (symb->scope == global_bfnd) return(SMNULL);
    extern1_flag = query_extern(symb->type);
    if ((extern1_flag != ((int) RID_EXTERN))&&(symb->variant!=FUNCTION_NAME)) return(SMNULL);
    if (is_skip_scope(symb))
      err_symb("invalid scope",symb->ident);
    if (!(symb2=find_type_symbol_global(symb)))
      {
	change_scope(symb,global_bfnd);
      }
    else 
      {  
	if (!is_same_type(symb->type,symb2->type,2))
       	  err_symb("redeclaration symbol",symb->ident);
	else
	  remove_entry(symb);
	return(symb2);
      }
  }
  return(SMNULL);
}






is_same_type(type1,type2,sw)
PTR_TYPE type1,type2;
int sw;
{

  PTR_SYMB s1,s2;

   for ( ;(type1&&type2)  ;    )
    { if ((type1->variant != type2->variant)&&((type1->variant == T_DESCRIPT)||(type2->variant == T_DESCRIPT)))
	{ 
	  if (type1->variant == T_DESCRIPT) 
	    {
	      if (type1->entry.descriptive.long_short_flag- 
		  (type1->entry.descriptive.long_short_flag&STORAGE_FLAG))
		return(0);
	      type1 = type1->entry.template.base_type ;
	      continue;
	    }
	  if (type2->variant == T_DESCRIPT) {
	      if (type2->entry.descriptive.long_short_flag- 
		  (type2->entry.descriptive.long_short_flag&STORAGE_FLAG))
		return(0);
	      type2 = type2->entry.template.base_type ;
	      continue;
	    }
	}
      else {
       switch(type1->variant) {
       case T_POINTER  :
       case T_FUNCTION :
       case T_ARRAY    :
	 if (type1->variant !=type2->variant) return(0);
	 type1 = type1->entry.template.base_type ;
	 type2 = type2->entry.template.base_type ;
	 break ;
       case T_DESCRIPT :
	 if (type1->variant !=type2->variant) return(0);
	      if (type1->entry.descriptive.long_short_flag- 
		  (type1->entry.descriptive.long_short_flag&STORAGE_FLAG))
		return(0);
	 type1 = type1->entry.template.base_type ;
	 type2 = type2->entry.template.base_type ;
	 break ;
      case DEFAULT :
	if ((type2->variant != DEFAULT)&&(type2->variant != T_INT)) 
	  return(0);
        else return(1);
      case T_DERIVED_TYPE :
	if (type2->variant !=  T_DERIVED_TYPE) return(0);
	s1 = type1->entry.derived_type ;
	s2 = type2->entry.derived_type;
	if (s1 != s2) return(0);
	else          return(1);
       case T_INT     :
	if ((type2->variant != DEFAULT)&&(type2->variant != T_INT)) 
	  return(0);
        else return(1);
       case T_CHAR    :
	if (type2->variant != T_CHAR)
	  return(0);
        else return(1);
       case T_VOID    :
	 if (type2->variant != T_VOID)
	  return(0);
        else return(1);
       case T_DOUBLE  :
	 if (type2->variant != T_DOUBLE)
	  return(0);
	 else return(1);
	 break;
       case T_FLOAT   :
	 if (type2->variant != T_FLOAT)
	  return(0);
	 else return(1);
	 break;
       case T_UNION   :
       case T_STRUCT  :
       case T_ENUM    :
       case T_CLASS   :
       case T_DERIVED_CLASS:
       default :    
	  return(0);
       }
     }
  }
  if ((!type1) && (!type2)) return(1);
  if ((!type1) && (sw==1)) {
    switch (type2->variant) {
       case T_POINTER  :
       case T_FUNCTION :
       case T_ARRAY    :
	 return(0);
       default:
	 return(1);
       }
  }
return(0);
}


/* check if a type chain is only a right hand side of a type */
is_complete_chain(type)
PTR_TYPE type;
{
  PTR_TYPE temptr;

  for (temptr = type;temptr;temptr= temptr->entry.template.base_type)
    { if ((temptr->variant!=T_POINTER)&&(temptr->variant!=T_FUNCTION)&&(temptr->variant!=T_ARRAY))
	return(1);
 
    }
  
  return(0);
}



/*****************************************************************************/
/* Return : RID_EXTERN if extern appear                                      */
/*          RID_MAX    otherwise                                             */
/*                                                                           */
/*****************************************************************************/
query_extern(passing_type)
PTR_TYPE passing_type;
{ PTR_TYPE type,old_type ;
  PTR_SYMB temp_symbptr;
  int flag;

  flag =(int) RID_MAX;
  for (old_type= type=passing_type ;type ; )
   {   
       switch(type->variant) {
       case T_ARRAY :
       case T_FUNCTION :
       case T_POINTER  :
            type = type->entry.template.base_type ;
            break;
       case T_DESCRIPT :
	    if (type->entry.descriptive.long_short_flag & BIT_EXTERN)
	      flag = (int) RID_EXTERN;
            type = type->entry.descriptive.base_type ;
            break;
       case T_DERIVED_TYPE :
       default :
            type = (PTR_TYPE) NULL ;
	  }
     }
  return(flag);

}



/*****************************************************************************/
/* Given a symbol not defined in global but going to changed to be global    */
/* return: SMNULL if there is no same entry in global already                */
/*         symb_g if exist                                                   */
/*         Used for FIELD_NAME, VARIABLE_NAME, FUNCTION_NAME,MEMBER_FUNC     */
/*****************************************************************************/
PTR_SYMB
find_type_symbol_global(symb)
PTR_SYMB symb;
{ PTR_SYMB symb_ptr;
  int flag;

  flag = symb->variant;
  for (symb_ptr =symb->parent->id_attr ;symb_ptr; symb_ptr = symb_ptr->outer)
    {  
      if ((is_same_variant_group(symb_ptr->variant,flag))&&(symb_ptr->scope == global_bfnd))
	return(symb_ptr);
    }
   return(SMNULL);
   
 }


is_same_variant_group(variant1,variant2)
int variant1,variant2;
{
  if (((variant1== VARIABLE_NAME)||(variant1==FIELD_NAME)||
       (variant1==FUNCTION_NAME)||(variant1== MEMBER_FUNC))&&
      (((variant2== VARIABLE_NAME)||(variant2==FIELD_NAME)||
       (variant2==FUNCTION_NAME)||(variant2== MEMBER_FUNC)))) return(1);
  if (variant1==variant2) return(1);
  return(0);
}
   

/*****************************************************************************/
/* Given a symbol not defined in global but going to changed to be global    */
/* and check if there is any same name symbol lies between pred_bfnd and     */
/* global_bfnd                                                               */
/*         Used for FIELD_NAME, VARIABLE_NAME, FUNCTION_NAME,MEMBER_FUNC     */
/*****************************************************************************/
is_skip_scope(symb)
PTR_SYMB symb;
{  PTR_SYMB symb_ptr;
   PTR_BFND real_scope(),pre_scope();
   int flag;

  flag = symb->variant;
  for (symb_ptr =symb->parent->id_attr ;symb_ptr ; symb_ptr = symb_ptr->outer)
    { if (symb_ptr==symb) continue;
      if (symb_ptr->scope==global_bfnd) continue;
      if (is_same_variant_group(symb_ptr->variant,flag))
	{  PTR_BFND flow ;
	   PTR_BFND type_scope ;                    
	   
	   type_scope = real_scope(symb_ptr->scope) ;
	   for ( flow = symb->scope; flow ; flow = pre_scope(flow) )
	     if (flow == type_scope) 
	       return(1);
	 }   
    }

   return(0);
 }

   
 
PTR_TYPE 
find_constant_type(pllnd)
PTR_LLND pllnd;
{

  switch(pllnd->variant) {
  case INT_VAL:
    return(global_int);
  case FLOAT_VAL:
    return(global_float);
  case CHAR_VAL:
    return(global_char);
  default:
    return(global_default);
  }
}


int
map_assgn_op(value)
int value;
{
  switch (value) {
  case ((int) PLUS_EXPR) : 
      return(PLUS_ASSGN_OP);
  case ((int) MINUS_EXPR):
      return(MINUS_ASSGN_OP);
  case ((int) BIT_AND_EXPR):
      return(AND_ASSGN_OP);
  case ((int) BIT_IOR_EXPR):
      return(IOR_ASSGN_OP);
  case ((int) MULT_EXPR): 
      return(MULT_ASSGN_OP);
  case ((int) TRUNC_DIV_EXPR): 
      return(DIV_ASSGN_OP);
  case ((int) TRUNC_MOD_EXPR): 
      return(MOD_ASSGN_OP);
  case ((int) BIT_XOR_EXPR): 
      return(XOR_ASSGN_OP);
  case ((int) LSHIFT_EXPR):
      return(LSHIFT_ASSGN_OP);
  case ((int) RSHIFT_EXPR):
      return(RSHIFT_ASSGN_OP);
  }
  
}




