

/* $Header: /Users/nsundare/faust/vpc/RCS/vinit.c,v 2.0 92/04/02 23:09:11 nsundare Exp $ */

#include "defines.h"
#include "vpc.h"
#include "db.h"
extern PTR_FILE fi;
/* In the following "set" means set the value to YES, or 1 */
PTR_FNAME find_file_entry();
int     yylineno;               /* Used by verrors.c */
int     wait_first_include_name;
char    *first_line_name;
int     debug;
int	errline;		/* line number of 1st error */
int     lineno;			/* input line no */
int     inioctl;		/* set if processing I/O control stmt */
int     needkwd;		/* set if stmt needs keyword */
int     yydebug;
long    yystno;
int     yyleng;
int     yylisting;		/* set if listing to stdio required */
int     yylonglines;		/* set if non-standard line length allowed */
int     prflag;
int     dorange;		/* current do range label */
int     undeftype = NO;		/* set if IMPLICIT NONE */
int     maxdim = 10;		/* max allowable dimension size */
int     nowarnflag = YES;	/* set if don't want warning messages */
int     shiftcase = NO;		/* convert variable to lower case */
char    intonly;		/* set if only integer param allowed */
int     if_nesting;             /* Used to count the number of else if's */

int     errcnt = 0;		/* error count */
int     nwarn = 0;		/* number of warning */



/* important usage */

int     num_bfnds;		/* total # of bif nodes */
int     num_llnds;		/* total # of low level nodes */
int     num_symbs;		/* total # of symbol nodes */
int     num_types;		/* total # of types nodes */
int     num_blobs;		/* total # of blob nodes */
int     num_sets;		/* total # of set nodes */
int     num_cmnt;
int     num_files;
int     num_def;		/* total # of dependncy nodes */
int	num_dep;
int     num_deflst;
int     num_label;		/* total # of label nodes */

int     cur_level;		/* current block level */
int     next_level;

char   *tag[610];

PTR_SYMB global_list;

PTR_BFND head_bfnd,	/* start of bfnd chain */
	 cur_bfnd,	/* point to current bfnd */
         pred_bfnd,	/* used in finding the predecessor */
         last_bfnd;

PTR_LLND head_llnd, cur_llnd;

PTR_SYMB head_symb, cur_symb;

PTR_TYPE head_type, cur_type;

PTR_LABEL head_label, cur_label, thislabel;

PTR_BLOB head_blob, cur_blob;

PTR_SETS head_sets, cur_sets;

PTR_DEF head_def, cur_def;

PTR_DEFLST head_deflst, cur_deflst;

PTR_DEP head_dep, cur_dep, pre_dep;

PTR_CMNT head_cmnt, cur_cmnt;
PTR_FNAME head_file, cur_thread_file;
PTR_BLOB global_blob ;             /* new added */
PTR_BFND global_bfnd;
PTR_SYMB star_symb;
PTR_TYPE vartype;
PTR_CMNT comments;
PTR_CMNT cur_comment;
struct Ctlframe *ctlsp = (struct Ctlframe *)NULL;

PTR_TYPE get_type();
PTR_SYMB make_symb();
PTR_BFND get_bfnd();
PTR_BLOB make_blob();
void	 init_hash();

PTR_TYPE global_int, global_float, global_double, global_char, global_string;
PTR_TYPE global_bool, global_complex, global_default, global_void ;

char    yytext[1000];		/* text consumed for current lexeme */
char   *infname;

char    saveall;		/* set if "SAVE ALL" */
char    substars;		/* set if * parameters seen */
int     blklevel;		/* current block level */
int     parstate;	/* current parser's state */
char    headerdone;

PTR_TYPE impltype[26];		/* implicit type for 'a' to 'z' */
int     implleng[26];		/* implicit length for 'a' to 'z' */
int     implstg[26];		/* implicit storage tags */

int     procno;			/* procedure # in current file */
int     lwmno;
int     proctype;		/* procedure type */
char   *procname;		/* procedure name */
int     fudgelabel;

int     procclass;
int     nentry;			/* # of entries */
char    multitype;
long    procleng;

int     iostmt;
int     nioctl;
int     nequiv;		/* # of equivalence */
int     eqvstart;
int     nintnames;
int     mod_offset = 0 ;                /* new added for vpc */
int     old_line   = 0 ;                /* new added for vpc */
int branch_flag;                        /* new added for vpc */
int main_type_flag ;                    /* new added for vpc */
int primary_flag;                       /* new added for vpc */
int function_flag ;                     /* new added for vpc */
int friend_flag ;                       /* new added for vpc */
int cur_flag ;                          /* new added for vpc */
int declare_flag ;                      /* new added for vpc */
int recursive_yylex;                    /* new added for vpc */
int not_fetch_yet;                      /* new added for vpc */
int exception_flag ;                    /* new added for vpc */
PTR_SYMB first_symbol,right_symbol ;    /* new added for vpc */
PTR_BFND passed_bfnd;                   /* new added for vpc */
PTR_BFND new_cur_bfnd ;                 /* new added for vpc */
PTR_LLND new_cur_llnd ;                 /* new added for vpc */
PTR_TYPE new_cur_type ;                 /* new added for vpc */
PTR_SYMB new_cur_symb;                  /* new added for vpc */
char     *new_cur_fname;                /* point to recent included filename */
char     *line_pos_fname;               /* point to included filename with current token in yylex() */
PTR_CMNT new_cur_comment;               /* new added for vpc */
struct data_type second_part ;          /* new added for vpc */
PTR_HASH cur_id_entry ;                 /* new added for vpc */
int TRACEON ;                           /* new added for vpc */
int parameter_flag ;                    /* new added for vpc */
int line_pos_1;                         /* new added for vpc */
/*
 *  General initialization routine
 */
void 
initialize()
{

	errcnt = 0;		/* error count */
	nwarn = 0;		/* number of warning */
	parstate = OUTSIDE;	/* current parser's state */
	headerdone = NO;
	nequiv = 0;		/* # of equivalence */
	eqvstart = 0;
	nintnames = 0;
	if_nesting = 0;

	num_bfnds = 0;		/* total # of bif nodes */
	num_llnds = 0;		/* total # of low level nodes */
	num_symbs = 0;		/* total # of symbol nodes */
	num_types = 0;		/* total # of types nodes */
	num_blobs = 0;		/* total # of blob nodes */
	num_sets = 0;		/* total # of set nodes */
	num_cmnt = 0;
	num_def = 0;		/* total # of dependncy nodes */
	num_dep = 0;
	num_deflst = 0;
	num_label = 0;		/* total # of label nodes */
	num_files = 0 ;
        exception_flag = OFF;   /* add for VPC */
	global_list = (PTR_SYMB) NULL;
	head_bfnd = BFNULL;
	cur_bfnd = BFNULL;
	pred_bfnd = BFNULL;      /* used in finding the predecessor */
	last_bfnd = BFNULL;

	head_llnd = LLNULL;
	cur_llnd = LLNULL;

	head_symb = SMNULL;
	cur_symb = SMNULL;

	head_cmnt = CMNULL;
	cur_cmnt  = CMNULL;

	head_type = TYNULL;
	cur_type = TYNULL;

	head_label = LBNULL;
	cur_label = LBNULL;
	thislabel = LBNULL;

	head_blob = BLNULL;
	cur_blob = BLNULL;

	head_sets = (PTR_SETS)NULL;
	cur_sets = (PTR_SETS)NULL;

	head_def = (PTR_DEF)NULL;
	cur_def = (PTR_DEF)NULL;

	head_deflst = (PTR_DEFLST)NULL;
	cur_deflst = (PTR_DEFLST)NULL;

	head_dep = (PTR_DEP)NULL;
	cur_dep = (PTR_DEP)NULL;
	pre_dep = (PTR_DEP)NULL;
        head_file = (PTR_FNAME) NULL;
	global_bfnd = BFNULL;
	comments = CMNULL;
	cur_comment = CMNULL;
        

	global_int	= get_type(fi,T_INT);
	global_float	= get_type(fi,T_FLOAT);
	global_double	= get_type(fi,T_DOUBLE);
	global_char	= get_type(fi,T_CHAR);
	global_string	= get_type(fi,T_STRING);
	global_bool	= get_type(fi,T_BOOL);
	global_complex	= get_type(fi,T_COMPLEX);
	global_default	= get_type(fi,DEFAULT);
        global_void     = get_type(fi,T_VOID) ;  /* new added */
	star_symb	= make_symb(fi,DEFAULT, "*");
	global_bfnd	= get_bfnd(fi,GLOBAL, SMNULL, LLNULL, LLNULL, LLNULL);
	global_bfnd->filename=(PTR_FNAME)NULL;/*later we put something there*/
        global_bfnd->control_parent = BFNULL ;

/*        cur_blob = global_bfnd->entry.template.bl_ptr1
	      	 = make_blob (fi,BFNULL, BLNULL);                */
	pred_bfnd = global_bfnd;

	init_hash();
        init_stack(); /*for vpc comments and line_number */   
        /* Added for VPC  */
        recursive_yylex = OFF ;
	reset();
        main_type_flag =TYPE_FOUR ;
        second_part.entry.descriptive.signed_flag = OFF ;
        second_part.entry.descriptive.long_short_flag = OFF ;
        second_part.entry.descriptive.mod_flag = OFF ;
        second_part.entry.descriptive.storage_flag = OFF ;
        declare_flag = OFF ;
}


/*
 * Set implicit type and length for each alphabetic chars in the range c1 - c2
 */
void
setimpl(type, c1, c2)
	PTR_TYPE type;
/*	long    length; */
	int     c1, c2;
{
	register int i;
	char    buff[100];

	if (c1 == 0 || c2 == 0)
		return;

	if (c1 > c2) {
		sprintf(buff, "characters out of order in implicit:%c-%c", c1, c2);
		err(buff);
	} else {
/*	    type = lengtype(type, (int) length);
	    if(type != TYCHAR)
	      length = 0;
*/
		for (i = c1; i <= c2; ++i) {
			impltype[i - 'a'] = type;
/*			implleng[i - 'a'] = length; */
		}
	}
}


/*
 *  Initialization routine for each new program unit
 */
void 
procinit()
{
	parstate = OUTSIDE;
	blklevel = 1;
	saveall = NO;
	substars = NO;
	nwarn = 0;
	thislabel = LBNULL;
	needkwd = 0;

	++procno;
	proctype = T_UNKNOWN;
	procname = "MAIN_    ";
/*	procclass = CLUNKNOWN; */
	nentry = 0;
	multitype = NO;
	blklevel = 1;
	dorange = 0;

	if (undeftype)
		 setimpl(global_default, 'a', 'z');
	else {
		 setimpl(global_float, 'a', 'z');
		 setimpl(global_int, 'i', 'n');
	}
}
