/* $Header: /Users/nsundare/faust/vpc/RCS/vmakenodes.c,v 2.0 92/04/02 23:09:13 nsundare Exp $ */

#include "db.h"
#include "vextern.h"
#include "defines.h"
#include "vpc.h"

extern int num_bfnds;
extern int num_llnds;
extern int num_symbs;
extern int num_types;
extern int num_blobs;
extern int num_label;
extern int num_cmnt;
extern int yydebug;

extern PTR_BFND head_bfnd, cur_bfnd;
extern PTR_LLND head_llnd, cur_llnd;
extern PTR_SYMB head_symb, cur_symb;
extern PTR_TYPE head_type, cur_type;
extern PTR_LABEL head_label, cur_label;
extern PTR_CMNT head_cmnt, cur_cmnt;
extern PTR_CMNT comments, cur_comment;
extern PTR_BFND last_bfnd;
PTR_LABEL alloc_lab();
PTR_LABEL make_label();
extern void errstr();

PTR_FNAME
alloc_file()
{
	register PTR_FNAME new;

	new = ALLOC(file_name);
	new->id = fi->num_files = ++num_files;
	new->next = (PTR_FNAME) NULL;
	if (num_files == 1)
		head_file = fi->head_file = new;
	else
		cur_thread_file->next = new;
	cur_thread_file = new;
	return (new);
}

/*
 * Make a BIF node
 */
PTR_BFND 
get_bfnd(fi,node_type, symb_ptr, ll1, ll2, ll3)
        PTR_FILE fi;
	int     node_type;
	PTR_SYMB symb_ptr;
	PTR_LLND ll1, ll2, ll3;
{
	register PTR_BFND new_bfnd;
        PTR_CMNT fetch_comment_queue();
	PTR_FNAME fetch_line_queue(),find_file_entry();
	int  line_position;

	new_bfnd = make_bfnd(fi,node_type, symb_ptr, ll1, ll2, ll3);
        if ((node_type != GLOBAL)&&(wait_first_include_name == ON))
	  { 
	    wait_first_include_name = OFF;
	    first_line_name         = new_cur_fname;
	    global_bfnd->filename = find_file_entry(new_cur_fname);
	    global_bfnd->g_line   = 0;
	  }
	new_bfnd->entry.template.cmnt_ptr = fetch_comment_queue();
	new_bfnd->filename = fetch_line_queue( &line_position);
	new_bfnd->g_line = line_position;
	new_bfnd->l_line = 0; /* relative line number  */
	last_bfnd = new_bfnd;
	return (new_bfnd);
}




/*
/*
 * Make a new type node
 */
PTR_TYPE 
get_type(fid,node_type)
	int     node_type;
        PTR_FILE fid;
{
	register PTR_TYPE new_type;

	new_type = make_type(fid,node_type);
        if (node_type == T_POINTER)  new_type->entry.template.dummy1 = 1 ;
	return (new_type);
}

/*
 * Make a new label node
 * return <1> new_lab if this is a label never appear for definition and ref
 *        <2> LBNULL  otherwise
 */
PTR_LABEL 
get_label(fi,entry)
	PTR_HASH entry;
{
	register PTR_LABEL new_lab;
        PTR_SYMB label_symb;
        PTR_SYMB find_type_symbol(),install_entry_2();

        label_symb = find_type_symbol(entry,LABEL_NAME);
        if (! label_symb) 
	  {
       	    new_lab = make_label(fi,1);/* one is pseudo for fortran */
            label_symb = install_entry_2(entry,LABEL_NAME,UP_TO_FUNC_HEDR);
            new_lab->label_name = label_symb;
	    new_lab->stateno = NULL ;
	    new_lab->scope =   label_symb->scope;
	    new_lab->labused = NO;
	    new_lab->labdefined = NO ;
	    new_lab->labinacc = NO;
	    new_lab->labtype = LABUNKNOWN;
	    new_lab->statbody = BFNULL;
	    return (new_lab);
	  }
       else
          return((PTR_LABEL) NULL);
}



PTR_LABEL
find_label(symb)
PTR_SYMB   symb ;
{  PTR_LABEL temp_label;

   temp_label=fi->head_lab;
    for ( ; temp_label ; temp_label = temp_label->next)
      {    if (!strcmp(temp_label->label_name->ident, symb->ident))
                 return(temp_label);
	 }
    return(LBNULL);

  }




PTR_FNAME
make_file( name)
	char *name ;
{
	register PTR_FNAME new_file;

	new_file = alloc_file();

	new_file->name = name ;
	return (new_file);
}



	
void
release_nodes()
{
	register PTR_BFND p1 = head_bfnd;
	register PTR_LLND p2 = head_llnd;
	register PTR_SYMB p3 = head_symb;
	register PTR_TYPE p4 = head_type;
	register PTR_LABEL p5 =head_label;
	register PTR_BFND t1;
	register PTR_LLND t2;
	register PTR_SYMB t3;
	register PTR_TYPE t4;
	register PTR_LABEL t5;

	while (p1) {
		t1 = p1;
		p1 = p1->thread;
		cfree ((char *)t1);
	}
	
	while (p2) {
		t2 = p2;
		p2 = p2->thread;
		cfree ((char *)t2);
	}
	
	while (p3) {
		t3 = p3;
		p3 = p3->thread;
		cfree ((char *)t3);
	}
	
	while (p4) {
		t4 = p4;
		p4 = p4->thread;
		cfree ((char *)t4);
	}
	
	while (p5) {
		t5 = p5;
		p5 = p5->next;
		cfree ((char *)t5);
	}
}



/*------------------------------------------------------*
 *                    dealloc_blob                    *
 *------------------------------------------------------*/
void
dealloc_blob(b)
PTR_BLOB b;
{
      cfree(b);
      --num_blobs;
}




