/* $Header: /Users/nsundare/faust/vpc/RCS/vmisc.c,v 2.0 92/04/02 23:09:14 nsundare Exp $ */

/*
 * misc.c
 *
 * Misellanious help routines
 */

#include "defs.h"
#include "defines.h"

extern int blklevel;
extern void warn1();
PTR_LABEL make_label();

/*
 * cpn -- copies a string with specified length
 *
 * input:
 *	  n - length of the string "a"
 *	  a - the string to be copied
 *	  b - the destination string
 */
void 
cpn(n, a, b)
	register int n;
	register char *a, *b;
{
	while (--n >= 0)
		*b++ = *a++;
}


/*
 * eqn -- checks if first n characters of two strings are the same
 *
 * input:
 *	  n - length to be checked
 *	  a - string1
 *	  b - string2
 *
 * output:
 *	  YES if the first n characters are same.  NO, otherwise.
 */
int 
eqn(n, a, b)
	register int n;
	register char *a, *b;
{
	while (--n >= 0)
		if (*a++ != *b++)
			return (NO);
	return (YES);
}


/*
 * cmpstr -- compare two strings with known lengths
 *
 * input:
 *	  a  - points to string 1
 *	  b  - points to string 2
 *	  la - length of string "a"
 *	  lb - length of string "b"
 *
 * output:
 *	  a positive number if string "a" is greater than "b"
 *	  zero if these two strings are the same
 *	  a negative number if string "a" is less thatn "b"
 */
int 
cmpstr(a, b, la, lb)		/* compare two strings */
	register char *a, *b;
	long    la, lb;
{
	register char *aend, *bend;

	aend = a + la;
	bend = b + lb;
	if (la <= lb) {
		while (a < aend)
			if (*a != *b)
				return (*a - *b);
			else {
				++a;
				++b;
			}

		while (b < bend)
			if (*b != ' ')
				return (' ' - *b);
			else
				++b;
	} else {
		while (b < bend)
			if (*a != *b)
				return (*a - *b);
			else {
				++a;
				++b;
			}
		while (a < aend)
			if (*a != ' ')
				return (*a - ' ');
			else
				++a;
	}
	return (0);
}


/*
 * copyn -- makes a copy of a string with known length
 *
 * input:
 *	  n - lenght of the string "s"
 *	  s - the string to be copied
 *
 * output:
 *	  pointer to the new string
 */
/*
char   *
copyn(n, s)
	register int n;
	register char *s;
{
	register char *p, *q;
	char   *ckalloc();

	p = q = ckalloc(n);
	while (--n >= 0)
		*q++ = *s++;
	return (p);
}

*/
/*
 * copys -- makes a copy of a string
 *
 * input:
 *	  s - string to be copied
 *
 * output:
 *	  pointer to the new string
 */
/*
char   *
copys(s)
	char   *s;
{
	return (copyn(strlen(s) + 1, s));
}

*/
/*
 * convci - converts an ASCII string to binary
 *
 * input:
 *	  n - length of the string
 *	  s - the string to be converted
 *
 * output:
 *	  the converted long value
 */
long 
convci(n, s)
	register int n;
	register char *s;
{
	register long sum;

	sum = 0;
	while (n-- > 0)
		sum = 10 * sum + (*s++ - '0');
	return (sum);
}


/*
 * convic -- converts a long integer to ASCII string
 *
 * input:
 *	  n - the number to be converted
 *
 * output:
 *	  the converted string
 */
char   *
convic(n)
	long    n;
{
	static char s[20];
	register char *t;

	s[19] = '\0';
	t = s + 19;

	do {
		*--t = '0' + n % 10;
		n /= 10;
	} while (n > 0);

	return (t);
}


double 
convcd(n, s)
	int     n;
	register char *s;
{
	double  atof();
	char    v[100];
	register char *t;

	if (n > 90) {
		err("too many digits in floating constant");
		n = 90;
	}
	for (t = v; n-- > 0; s++)
		*t++ = (*s == 'd' ? 'e' : *s);
	*t = '\0';
	return (atof(v));
}


/* this label appears in a branch context */
/* The following routine needs study
PTR_LABEL 
execlab(stateno)
	long    stateno;
{
	register PTR_LABEL lp;
	char *convic();
	void execerr();

	if (lp = make_label(fi,stateno)) {
		if (lp->labinacc)
			warn1("illegal branch to inner block, statement %s",
			      convic(stateno));
		else if (lp->labdefined == NO)
			lp->blklevel = blklevel;
		lp->labused = YES;
		if (lp->labtype == LABFORMAT)
			err("may not branch to a format");
		else
			lp->labtype = LABEXEC;
	} else
		execerr("illegal label %s", convic(stateno));

	return (lp);
}

*/

int 
max(a, b)
	int     a, b;
{
	return (a > b ? a : b);
}


long 
lmax(a, b)
	long    a, b;
{
	return (a > b ? a : b);
}


long 
lmin(a, b)
	long    a, b;
{
	return (a < b ? a : b);
}


char   *
ckalloc(n)
	register int n;
{
	register char *p;
	char   *calloc();
	void fatal();

	if (p = calloc(1, (unsigned) n))
		return (p);

	fatal("out of memory");
}



int 
hextoi(c)
	register int c;
{
	register char *p;
	char *p0;

	p0 = "0123456789abcdef";
	for (p = p0; *p; ++p)
		if (*p == c)
			return (p - p0);
	return (16);
}
