

/* This is VPC version */
/* Latest Modified date is Oct 7, 1987 */ /* Date Nov 15,1987 */
/* Feb 3, 1988 /
/* BISON parser for VPC++  Modified by Jenq-kuen Lee  Sep 28, 1987    */
/* YACC parser for C syntax.         */
/*   Copyright (C) 1987 Free Software Foundation, Inc. */
/*  To whomever it may concern: I have heard that such a thing was once
 written by AT&T, but I have never seen it.  */

%{
#include "vparse.h"
#include "vpc.h"
#include "db.h"
#include "vextern.h"
%}

%start program
%union { 
         int       token ;
         char      charv ;
         char      *charp;
         PTR_BFND   bfnode ;
         PTR_LLND   ll_node ;
         PTR_SYMB   symbol  ;
         PTR_TYPE   data_type ;
         PTR_HASH   hash_entry ;
         PTR_LABEL  label ;        
         PTR_BLOB   blob_ptr ;
       }
/* all identifiers   that are not reserved words
   and are not declared typedefs in the current block */
%token IDENTIFIER
/* all identifiers   that are declared typedefs in the current block.
   In some contexts, they are treated just like IDENTIFIER,
   but they can also serve as typespecs in declarations.  */
%token TYPENAME

/* reserved words that specify storage class.
   yylval contains an IDENTIFIER_NODE which indicates which one.  */
%token SCSPEC

/* reserved words that specify type.
   yylval contains an IDENTIFIER_NODE which indicates which one.  */
%token TYPESPEC

/* reserved words that modify type: "const" or "volatile".
   yylval contains an IDENTIFIER_NODE which indicates which one.  */
%token TYPEMOD

/*character or numeric constants.
   yylval is the node for the constant.  */
%token CONSTANT

/* String constants in raw form.
   yylval is a STRING_CST node.  */
%token STRING

/* "...", used for functions with variable arglists.  */
%token ELLIPSIS

/* the reserved words */
%token SIZEOF ENUM STRUCT UNION IF ELSE WHILE DO FOR SWITCH CASE DEFAULT_TOKEN
%token BREAK CONTINUE RETURN GOTO ASM
%token CLASS PUBLIC FRIEND  ACCESSWORD OVERLOAD
%token OPERATOR COBREAK COLOOP COEXEC LOADEDOPR 

%token MULTIPLEID MULTIPLETYPENAME
/* Define the operator tokens and their precedences.
   The value is an integer because, if used, it is the tree code
   to use in the expression made from the operator.  */

%left  <charv> ','
%right <charv> '='
%right <token> ASSIGN 
%right <charv> '?' ':'
%left <charv> OROR
%left <charv> ANDAND
%left <charv> '|'
%left <charv> '^'
%left <charv> '&'
%left <token> EQCOMPARE
%left <token> ARITHCOMPARE  '>' '<' 
%left <charv> LSHIFT RSHIFT
%left <charv> '+' '-'
%left <token> '*' '/' '%'
%right <token> UNARY PLUSPLUS MINUSMINUS
%left HYPERUNARY
%left <token> DOUBLEMARK 
%left <token> POINTSAT '.'


%type <token> unop
%type <hash_entry> IDENTIFIER TYPENAME  LOADEDOPR
%type <ll_node> CONSTANT STRING  primary expr_no_commas const_expr_no_commas  
%type <ll_node> expr nonnull_exprlist exprlist const_primary element
%type <ll_node> string
%type <data_type> typed_declspecs  maintype typed_declspecs_2  
%type <token> typespecfinal typed_declfinal
%type <token>  typespec_reserved  component_decl
%type <token> typespec SCSPEC TYPESPEC TYPEMOD 
%type <ll_node> initdecls   initdcl notype_initdecls
%type <ll_node> init initlist vector_constant triplet  compound_constant vector_list

%type <ll_node> declarator inside components notype_components component_declarator
%type  <ll_node> notype_component_declarator
%type <ll_node> notype_declarator  after_type_declarator notype_initdcl
%type <ll_node> single_v_expr array_expr_a array_expr_b expr_vector multiple_id
%type <ll_node> expr_no_commas_1  
%type <ll_node> xexpr  
%type <symbol>    record_name identifier    identifiers 
%type <symbol>      notype_declarator_parm  
%type <token>  component_decl_list  nonempty_component_decl_list
%type <ll_node> enumlist enumerator
%type <data_type> typename absdcl absdcl1 typemods typed_typespecs nonempty_typemods  structsp
%type <token>  parmlist parms parm 
%type <ll_node> lexpr assign_stmt
%type <token> declarator_list    FRIEND  decl
%type <token> ACCESSWORD 
%type <token> COLOOP COEXEC COBREAK CLASS UNION STRUCT
%type <token> setspecs
%type <bfnode> datadef
%type <data_type> declmods




/* the declaration found for the last IDENTIFIER token read in.
   yylex must look this up to detect typedefs, which get token type TYPENAME,
   so it is left around in case the identifier is not a typedef but is
   used in a context which makes it a reference to a variable.  */


/* list of types and structure classes of the current declaration */
/* tree current_declspecs;  */
%{ char      *input_filename;	
   int       enum_id = 0;
   extern    int lastdecl_id;
   PTR_FNAME find_file_entry();
   extern     struct data_type second_part ;
   PTR_LLND   chain_type_declarator();
   PTR_LLND   follow_llnd();
   PTR_SYMB   find_type_symbol();
   PTR_SYMB   find_field_symb_by_type();
   PTR_LLND   check_format_function();
   PTR_LLND   check_array_id_format();
   PTR_LLND   func_declarator_appear();
   PTR_LLND   lazy_install();
   PTR_SYMB   install_parameter();
   PTR_TYPE   combine_2();
   PTR_TYPE   follow_type(), follow_type_1();
   PTR_TYPE   install_declmod();
   PTR_TYPE   install_struct(),set_struct_typename();
   PTR_BLOB   follow_blob(), follow_blob_2();      
   PTR_HASH   look_up_type(),look_up() ;
   PTR_SYMB   install_entry();
   PTR_SYMB   find_proc_name();
   PTR_SYMB   count_first();
   PTR_SYMB   next_member();
   PTR_TYPE   type_conversion();
   PTR_TYPE   adjust_deref_type();
   PTR_TYPE   adjust_array_type();
   PTR_SYMB   install_entry_2(),find_first_field_2();
   double     build_real_from_string();
   void       chain_type_declarator_2();
   PTR_LABEL  find_label();
   PTR_LABEL  make_label();
   PTR_CMNT   make_comment(),follow_comment();
   PTR_TYPE   chain_up_type();
   PTR_TYPE   chain_type_with_array_range();
   int        fill_type_for_param();
   extern     int cur_counter ;    
   PTR_TYPE find_constant_type();
%}     

%%

 program: /* empty */
          { if (TRACEON) printf("1\n ");}
	| extdefs
          { if (TRACEON) printf("2\n ");}
	;

/* the reason for the strange actions in this rule
 is so that notype_initdecls when reached via datadef
 can find a valid list of type and sc specs in $0. */

extdefs:
          extdef
          { if (TRACEON) printf("3\n ");}
	| extdefs  extdef
          { if (TRACEON) printf("4\n ");}
	;

extdef:
	fndef
          { if (TRACEON) printf("5  ");
            main_type_flag = TYPE_FOUR ;
          }
	| datadef
          { if (TRACEON) printf("6  ");
	    fill_comment();
            main_type_flag = TYPE_FOUR ;
          }
	| ASM '(' STRING ')' ';'
		{ if (TRACEON) printf("7  ");  }
	;


/* modified */
datadef:
	  ACCESSWORD  notype_initdecls ';'
         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;

           if (TRACEON) printf("8  ");
           ptr1 = global_int ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,$1,$2);
	 }
        | notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;

           if (TRACEON) printf("9  ");
           ptr1 = global_int ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,OFF,$1);


	 }
        | ACCESSWORD declmods  notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1 ;

           if (TRACEON) printf("10  ");

           ptr1 = $2 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,$1,$3);

	 }
        | declmods notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;

           if (TRACEON) printf("11  ");
           ptr1 = $1 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,OFF,$2);


	 }
	| ACCESSWORD typed_declspecs  initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND  bf1 ;

            if (TRACEON) printf("12 ");
            chain_type_declarator($2,$1,$3);
	  }
          
	| typed_declspecs initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND  bf1 ;

            if (TRACEON) printf("13 ");
            chain_type_declarator($1,OFF,$2);
	  }


        | ACCESSWORD  declmods ';'
	  { if (TRACEON) printf("empty declaration"); }
        | declmods ';'
          { if (TRACEON) printf("empty declaration"); }
	| ACCESSWORD  typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;

            if (TRACEON) printf("15  "); 
            blob = follow_blob(pred_bfnd);
          if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))
	   {
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name))
	      {  symb2= find_type_symbol(name->parent,VARIABLE_NAME);
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err_symb(" redeclaration symbol ",symb2->ident);
                 else   name->scope = pred_bfnd;
	       }
	  }
	 }

	| typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;

            if (TRACEON) printf("16  "); 
            blob = follow_blob(pred_bfnd);
         if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))

	   {
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name))
	      {  symb2= find_type_symbol(name->parent,VARIABLE_NAME);
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err_symb(" redeclaration symbol ",symb2->ident);
                 else   name->scope = pred_bfnd;
	       }
	  }
	  }
        | OVERLOAD declarator_list ';'
          { if (TRACEON) printf("17  ");
            /* Needs future work  */
          }
	| error ';'
           { if (TRACEON) printf("17.2  "); }              
	| error '}'
           { if (TRACEON) printf("17.3  "); }
	| ';'
          { if (TRACEON) printf("18  "); }
	;


fndef:	  typed_declspecs  
          declarator
		{  PTR_BFND bf1 ;
                   PTR_BLOB blob ;
		   PTR_LLND expr_llnd ;
                   PTR_SYMB symb1 ;

                   if (TRACEON) printf("19  ");
                   blob = follow_blob(pred_bfnd);
                   bf1 = blob->ref ;
                   if (bf1->variant == VAR_DECL)
		     {
                        bf1->variant = FUNC_HEDR ;
                        symb1 = bf1->entry.template.symbol = find_proc_name();
                        if (symb1->entry.member_func.seen == FUNCTION_BODY_APPEAR)
                          { 
                             err(" redeclaration function module "); 
			   }
                        else   symb1->entry.member_func.seen = FUNCTION_BODY_APPEAR ;
                        pred_bfnd = bf1 ;
                        bf1->entry.template.symbol->dovar += XDECL ;
                        expr_llnd = bf1->entry.template.ll_ptr1 ;
                        expr_llnd->entry.template.ll_ptr1 = $2 ;
                        chain_type_declarator_2($1, symb1);
		      }
                   else
		     {
                        symb1 = find_proc_name();
                        if (symb1->entry.member_func.seen == FUNCTION_BODY_APPEAR)
                          { 
                             err(" redeclaration function module "); 
			   }
                        else   symb1->entry.member_func.seen = FUNCTION_BODY_APPEAR ;
                         expr_llnd = bf1->entry.template.ll_ptr1 ;
                         expr_llnd->entry.template.ll_ptr1 = $2 ;
                         bf1 = get_bfnd(fi,FUNC_HEDR,symb1,expr_llnd,LLNULL,LLNULL);
                         blob->ref =bf1 ;
			 change_param_scope(symb1,bf1);
                         chain_type_declarator_2($1,symb1);
                         bf1->control_parent = pred_bfnd ;
                         pred_bfnd = bf1 ;
                         bf1->entry.template.symbol->dovar += XDECL ;
		       }
                      main_type_flag = TYPE_FOUR;
		      symb1->entry.member_func.func_hedr = bf1;
		 }
	  xdecls
		{ if (TRACEON) printf("20  "); 
                   pred_bfnd->entry.template.symbol->dovar -= XDECL ;
		   fill_type_for_param(pred_bfnd->entry.template.symbol);
                }
	  compstmt
		{ PTR_BFND bf1;
		  if (TRACEON) printf("21 ");
                  function_flag = OFF ;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = pred_bfnd->control_parent ;
		}
	| typed_declspecs  declarator error
		{ if (TRACEON) printf("22 "); }
	| declmods   notype_declarator
		{ PTR_BFND bf1; 
                  PTR_BLOB blob ;
                  PTR_LLND expr_llnd ;
                  PTR_SYMB symb1 ;

                   if (TRACEON) printf("23 "); 
                   $1->entry.descriptive.base_type = global_default ;
                   blob = follow_blob(pred_bfnd);
                   bf1 = blob->ref ;
                   bf1->variant = FUNC_HEDR ;
                   symb1 =bf1->entry.template.symbol = find_proc_name();
                   if (symb1->entry.member_func.seen == FUNCTION_BODY_APPEAR)
                    { 
                       err(" redeclaration function module "); 
                    }
                  else   symb1->entry.member_func.seen = FUNCTION_BODY_APPEAR ;
                   pred_bfnd = bf1 ;
                   bf1->entry.template.symbol->dovar += XDECL ;
                   expr_llnd = bf1->entry.template.ll_ptr1 ;
                   expr_llnd->entry.template.ll_ptr1 = $2 ;
                   chain_type_declarator($1,OFF,expr_llnd);
		   main_type_flag = TYPE_FOUR;
		   symb1->entry.member_func.func_hedr = bf1;
		}
	  xdecls
		{ if (TRACEON) printf("24 "); 
		  pred_bfnd->entry.template.symbol->dovar -= XDECL ;
		  fill_type_for_param(pred_bfnd->entry.template.symbol); 
                }
	  compstmt
		{ PTR_BFND bf1;
		  if (TRACEON) printf("25 ");
                  function_flag = OFF ;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = pred_bfnd->control_parent ;
		}

	| declmods  notype_declarator error
		{ if (TRACEON) printf("26 "); }
	| notype_declarator
		{ PTR_TYPE type_ptr;
                  PTR_BFND bf1;
                  PTR_BLOB blob;
                  PTR_LLND expr_llnd ;
                  PTR_SYMB symb1 ;

                  if (TRACEON) printf("27 ");
                  type_ptr = global_default ;
                  blob = follow_blob(pred_bfnd);
                  bf1 = blob->ref ;
                  bf1->variant = FUNC_HEDR ;
                  symb1=bf1->entry.template.symbol = find_proc_name();
                  if (symb1->entry.member_func.seen == FUNCTION_BODY_APPEAR)
                   { 
                      err(" redeclaration function module "); 
		    }
                  else   symb1->entry.member_func.seen = FUNCTION_BODY_APPEAR;
                  pred_bfnd = bf1 ;
                  bf1->entry.template.symbol->dovar += XDECL ;
                  expr_llnd = bf1->entry.template.ll_ptr1 ;
                  expr_llnd->entry.template.ll_ptr1 = $1 ;
                  chain_type_declarator(type_ptr,OFF,expr_llnd);
                  main_type_flag = TYPE_FOUR ;
		  symb1->entry.member_func.func_hedr = bf1;
		}
	  xdecls
		{ if (TRACEON) printf("28 "); 
                  pred_bfnd->entry.template.symbol->dovar -= XDECL ;
		  fill_type_for_param(pred_bfnd->entry.template.symbol);
                }
	  compstmt
		{ PTR_BFND bf1;
		  if (TRACEON) printf("29 ");
                  function_flag = OFF ;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = pred_bfnd->control_parent ;
		}

	|  notype_declarator error
		{ if (TRACEON) printf("30 "); }
	;



/* Must appear precede expr for resolve precedence problem */
/* A nonempty list of identifiers.  */
identifiers:	
	IDENTIFIER
		{ if (TRACEON) printf("306 ") ;
                  $$ = install_parameter($1,VARIABLE_NAME) ;
                }
	| identifiers ',' IDENTIFIER
		{ if (TRACEON) printf("307 ") ;
                  $$ = install_parameter($3,VARIABLE_NAME) ;
		}
	;


/* modified */
declarator_list :
          declarator
           { if (TRACEON) printf("31  ");}
        | declarator_list ',' declarator 
           { if (TRACEON) printf("32 ");}
        ;



identifier:
	IDENTIFIER
           { if (TRACEON) printf("33 ");}
	| TYPENAME
           { if (TRACEON) printf("34 ");}
	;

unop:     '&'
               { if (TRACEON) printf("35 ");
                 $$ = ADDRESS_OP ;
	       }

	| '-'
		{ if (TRACEON) printf("36 ");  
                 $$ = MINUS_OP ;
	       }
	| '+'
		{ if (TRACEON) printf("37 "); 
                 $$ = UNARY_ADD_OP ;
	       }
	| PLUSPLUS
		{ if (TRACEON) printf("38 "); 
                 $$ = PLUSPLUS_OP ;
	       }
	| MINUSMINUS
		{ if (TRACEON) printf("39 "); 
                 $$ = MINUSMINUS_OP ;
	       }
	| '~'
		{ if (TRACEON) printf("40 "); 
                 $$ = BIT_COMPLEMENT_OP ;
	       }

	| '!'
		{ if (TRACEON) printf("41 "); 
                 $$ = NOT_OP ;
	       }
	;

expr:	nonnull_exprlist
		{ if (TRACEON) printf("42 ");
                  $$ = $1 ;
                }
	;

exprlist:
	  /* empty */
		{ if (TRACEON) printf("43 ");
                  $$ = LLNULL ;
                }
	| nonnull_exprlist
		{ if (TRACEON) printf("44 "); 
                  $$ = $1 ; 
                }
	;

/* modified */
nonnull_exprlist:
          expr_no_commas
		{ if (TRACEON) printf("45 ");
                  $$ = make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
		  $$->type = $1->type ;
                }
	| nonnull_exprlist ',' expr_no_commas
		{ PTR_LLND ll_ptr ;

                  if (TRACEON) printf("46 ");
                  ll_ptr = follow_llnd($1,2);
                  ll_ptr->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
                  $$=$1;
                  $$->type = $3->type ;
                }
	;

/* modified */


/* modified */
vector_constant : '['  ']'   %prec ','
            {     if (TRACEON) printf("70.5 ");
                  $$ = make_llnd(fi,VECTOR_CONST,LLNULL,LLNULL,SMNULL);
                  primary_flag = VECTOR_CONST_APPEAR ;
		  /* Temporarily setting */
                  $$->type = global_int ;
		}
        | '['  vector_list  ']'  %prec ','
             {   if (TRACEON) printf("70.6 ");
                 $$ = make_llnd(fi,VECTOR_CONST,$2,LLNULL,SMNULL);
                  primary_flag = VECTOR_CONST_APPEAR ;
		  /* Temporarily setting */
                  $$->type = global_int ;
	       }
        ;

vector_list :
        |  single_v_expr
             { if (TRACEON) printf("47 ");
               $$ = make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
             }

        | vector_list ',' single_v_expr

             {
               PTR_LLND ll_node1 ;
               if (TRACEON) printf("48 ") ;
               ll_node1 = follow_llnd($1,2);
               ll_node1->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
              $$=$1;
	    }

        ;

/* modified */
single_v_expr :
          const_expr_no_commas
             { if (TRACEON) printf("49 ");
               $$ = $1;
             }
        | triplet
             { if (TRACEON) printf("50 ");
               $$ = $1;
             }
        | compound_constant
             { if (TRACEON) printf("51 "); 
               $$ = $1;
             }
        |   vector_constant
                { if (TRACEON) printf("93 ") ;
                  $$ = $1 ;
                }
        ;


 element:
         CONSTANT
            { if (TRACEON) printf("93.2 ") ;
                  $$ = $1 ;
	    }
	| IDENTIFIER
		{ PTR_SYMB symbptr;

                  if (TRACEON) printf("87 ") ; 
                  symbptr = find_type_symbol($1,VARIABLE_NAME);
                  if (! symbptr){  /* default function expected */
                                   exception_flag = ON ;
                                   cur_id_entry = $1 ;
				 }
                  else {
                      switch (symbptr->variant) {
                      case MEMBER_FUNC :
                      case FUNCTION_NAME:
                           /* primary_flag = EXCEPTION_ON ;  */
                           /* above one incorrect while nested */
                           $$ = make_llnd(fi,FUNC_CALL,LLNULL,LLNULL,symbptr);
                           break;
                      case FIELD_NAME :
                      case VARIABLE_NAME:
                           $$ = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
                           break;

			 }
                       $$->type = adjust_array_type(symbptr);
		    }
		}
       ;

 triplet :
          element ':' element ':' element     %prec '.'

            { PTR_LLND p1,p2 ;
              if (TRACEON) printf("52 ") ;
              p1 = make_llnd(fi,DDOT,$1,$3,SMNULL);
              p2 = make_llnd(fi,DDOT,p1,$5,SMNULL);
              $$ = p2 ;
	    }
         | element ':' element               %prec '.'
            { if (TRACEON) printf("53 ") ; 
              $$= make_llnd(fi,DDOT,$1,$3,SMNULL);
	    }
        ;


compound_constant :
          CONSTANT '#' CONSTANT
           { if (TRACEON) printf("54 ") ; 
             $$= make_llnd(fi,COPY_NODE,$1,$3,SMNULL);
	   }

        ;
/* modified */
array_expr_a :        /* empty */
        | expr_no_commas_1 ':' expr_no_commas_1 ':' expr_no_commas_1  %prec ','
            { PTR_LLND p1,p2 ;
              if (TRACEON) printf("55 ") ;
              p1 = make_llnd(fi,DDOT,$1,$3,SMNULL);
              p2 = make_llnd(fi,DDOT,p1,$5,SMNULL);
              $$ = p2 ;
	    }
        | expr_no_commas_1 ':' expr_no_commas_1                     %prec ','
            {
              if (TRACEON) printf("56 ") ; 
              $$= make_llnd(fi,DDOT,$1,$3,SMNULL);
	    }
        ;


expr_no_commas_1 :
             { if (TRACEON) printf("57 ") ;
                $$ = LLNULL ;
             } 
       | expr_no_commas
           { if (TRACEON) printf("58 ") ;
                 $$ = $1 ;
           }
       ;
/* modified */
array_expr_b :  expr_no_commas '#' expr_no_commas  
            { if (TRACEON) printf("59 ") ; }
        ;


/* modified */
expr_vector : expr_no_commas   /* original is expr  */
              { if (TRACEON) printf("60 ") ; }
        |  array_expr_a
              { if (TRACEON) printf("61 ") ; }
        ;
 
expr_no_commas:
	primary
           { if (TRACEON) printf("62 ") ; 
            /* Need Another way to check this one */
            /*  if (primary_flag & EXCEPTION_ON) err("syntax error 6"); */
             if (exception_flag == ON)  { err("undefined symbol");
                                          exception_flag =OFF;
                                        }
             $$=$1 ;
	   }
	| '*' expr_no_commas   %prec UNARY
		{ PTR_TYPE type ;
        
                  if (TRACEON) printf("63 ") ;
		  $$ = make_llnd(fi,DEREF_OP,$2,LLNULL,SMNULL);
                  $$->type = adjust_deref_type($2->type,DEREF_OP);

                }
	| unop expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("64 ") ; 
		  $$=make_llnd(fi,$1,$2,LLNULL,SMNULL);
                  if (($1 == ADDRESS_OP)&&(is_variable($2)))
                       $$->type = adjust_deref_type($2->type,ADDRESS_OP);
  		  else $$ ->type = $2->type ;
                }
	| '(' typename ')' expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("65 ") ; 
		  $$=make_llnd(fi,CAST_OP,$4,LLNULL,SMNULL);
                  $$->type = $2 ;

                }
	| SIZEOF expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("66 ") ; 
		  $$=make_llnd(fi,SIZE_OP,$2,LLNULL,SMNULL);
                  $$->type = global_int ;
                }
	| SIZEOF '(' typename ')'  %prec HYPERUNARY
		{ PTR_LLND ll_1 ;
		  
                  if (TRACEON) printf("67 ") ;  
                  ll_1 = make_llnd(fi,CAST_OP,LLNULL,LLNULL,SMNULL);
                  ll_1->type = $3 ;
		  $$=make_llnd(fi,SIZE_OP,ll_1,LLNULL,SMNULL);
		  $$->type = global_int ;
                }
	| expr_no_commas '+' expr_no_commas
		{ if (TRACEON) printf("68 ") ;  
		  $$=make_llnd(fi,ADD_OP,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas '-' expr_no_commas
		{ if (TRACEON) printf("69 ") ;  
		  $$=make_llnd(fi,SUBT_OP,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas '*' expr_no_commas
		{ if (TRACEON) printf("70 ") ;
		  $$=make_llnd(fi,MULT_OP,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas '/' expr_no_commas
		{ if (TRACEON) printf("71 ") ;
		  $$=make_llnd(fi,DIV_OP,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas '%' expr_no_commas
		{ if (TRACEON) printf("72 ") ;
		  $$=make_llnd(fi,MOD_OP,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas LSHIFT expr_no_commas
		{ if (TRACEON) printf("73 ") ;  
		  $$=make_llnd(fi,LSHIFT_OP,$1,$3,SMNULL);
                  $$->type = $1->type ;
                }
	| expr_no_commas RSHIFT expr_no_commas
		{ if (TRACEON) printf("74 ") ;  
		  $$=make_llnd(fi,RSHIFT_OP,$1,$3,SMNULL);
                  $$->type = $1->type ;
                }
	| expr_no_commas ARITHCOMPARE expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("75 ") ;  
                  op1 = ($2 == ((int) LE_EXPR)) ? LE_OP : GE_OP ;
		  $$=make_llnd(fi,op1,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas '<'  expr_no_commas  
                { if (TRACEON) printf("76 ") ; 
		  $$=make_llnd(fi,LT_OP,$1,$3,SMNULL);
                  $$->type = global_int ;
                }
	| expr_no_commas '>'  expr_no_commas   
                { if (TRACEON) printf("77 ") ; 
		  $$=make_llnd(fi,GT_OP,$1,$3,SMNULL);
                  $$->type = global_int ;
                }
	| expr_no_commas EQCOMPARE expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("78 ") ;  
                  op1 = ($2 == ((int) NE_EXPR)) ? NE_OP : EQ_OP  ;
     		  $$=make_llnd(fi,op1,$1,$3,SMNULL);
                  $$->type = global_int ;
                }
	| expr_no_commas '&' expr_no_commas
		{ if (TRACEON) printf("79 ") ;  
		  $$=make_llnd(fi,BITAND_OP,$1,$3,SMNULL);
                  $$->type = global_int ;
                }
	| expr_no_commas '|' expr_no_commas
		{ if (TRACEON) printf("80 ") ;  
		  $$=make_llnd(fi,BITOR_OP,$1,$3,SMNULL);
                  $$->type = global_int ;
                }
	| expr_no_commas '^' expr_no_commas
		{ if (TRACEON) printf("81 ") ;  
		  $$=make_llnd(fi,XOR_OP,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                }
	| expr_no_commas ANDAND expr_no_commas
		{ if (TRACEON) printf("82 ") ;  
		  $$=make_llnd(fi,AND_OP,$1,$3,SMNULL);
                  $$->type = global_int ;
                }
	| expr_no_commas OROR expr_no_commas
		{ if (TRACEON) printf("83 ") ; 
		  $$=make_llnd(fi,OR_OP,$1,$3,SMNULL);
                  $$->type = global_int ;
                }
	| expr_no_commas '?' expr_no_commas ':' expr_no_commas  /* expr */
		{ PTR_LLND ll_node1;

                  if (TRACEON) printf("84 ") ; 
		  ll_node1=make_llnd(fi,EXPR_IF_BODY,$3,$5,SMNULL);
		  $$=make_llnd(fi,EXPR_IF,$1,ll_node1,SMNULL);
                  $$->type = type_conversion($3->type, $5->type);
		}
	| expr_no_commas '=' expr_no_commas
		{ if (TRACEON) printf("85 ") ; 
		  $$=make_llnd(fi,ASSGN_OP,$1,$3,SMNULL);
                  $$->type = type_conversion($1->type, $3->type);
                  $$->type  =$1->type;
                }
	| expr_no_commas ASSIGN expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("86 ") ;  
                  op1 = map_assgn_op($2);
		  $$=make_llnd(fi,op1,$1,$3,NULL);
                  $$->type = type_conversion($1->type, $3->type);
                  $$->type  =$1->type;
                }

	;




 
const_expr_no_commas:
	const_primary
           { if (TRACEON) printf("62.2 ") ; 
/*              if (primary_flag & EXCEPTION_ON) err("syntax error 6");*/
             if (exception_flag == ON)  { err("undefined symbol");
                                          exception_flag =OFF;
                                        }
             $$=$1 ;
	   }
	| '*' const_expr_no_commas   %prec UNARY
		{ if (TRACEON) printf("63 ") ;
		  $$=make_llnd(fi,DEREF_OP,$2,LLNULL,SMNULL);
                }
	| unop const_expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("64 ") ; 
		  $$=make_llnd(fi,$1,$2,LLNULL,SMNULL);
                }
	| '(' typename ')' const_expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("65 ") ; 
		  $$=make_llnd(fi,CAST_OP,$2,$4,SMNULL);
                }
	| SIZEOF const_expr_no_commas  %prec UNARY
		{ if (TRACEON) printf("66 ") ; 
		  $$=make_llnd(fi,SIZE_OP,$2,LLNULL,SMNULL);
                }
	| SIZEOF '(' typename ')'  %prec HYPERUNARY
		{ if (TRACEON) printf("67 ") ;  
		  $$=make_llnd(fi,SIZE_OP,$3,LLNULL,SMNULL);
                }
	| const_expr_no_commas '+' const_expr_no_commas
		{ if (TRACEON) printf("68 ") ;  
		  $$=make_llnd(fi,ADD_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '-' const_expr_no_commas
		{ if (TRACEON) printf("69 ") ;  
		  $$=make_llnd(fi,SUBT_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '*' const_expr_no_commas
		{ if (TRACEON) printf("70 ") ;
		  $$=make_llnd(fi,MULT_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '/' const_expr_no_commas
		{ if (TRACEON) printf("71 ") ;
		  $$=make_llnd(fi,DIV_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '%' const_expr_no_commas
		{ if (TRACEON) printf("72 ") ;
		  $$=make_llnd(fi,MOD_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas LSHIFT const_expr_no_commas
		{ if (TRACEON) printf("73 ") ;  
		  $$=make_llnd(fi,LSHIFT_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas RSHIFT const_expr_no_commas
		{ if (TRACEON) printf("74 ") ;  
		  $$=make_llnd(fi,RSHIFT_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas ARITHCOMPARE const_expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("75 ") ;  
                  op1 = ($2 == ((int) LE_EXPR)) ? LE_OP : GE_OP ;
		  $$=make_llnd(fi,op1,$1,$3,SMNULL);
                }
	| const_expr_no_commas '<'  const_expr_no_commas  
                { if (TRACEON) printf("76 ") ; 
		  $$=make_llnd(fi,LT_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '>'  const_expr_no_commas   
                { if (TRACEON) printf("77 ") ; 
		  $$=make_llnd(fi,GT_OP,$1,$3,SMNULL);
                }

	| const_expr_no_commas EQCOMPARE const_expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("78 ") ;  
                  op1 = ($2 == ((int) NE_EXPR)) ? NE_OP : EQ_OP  ;
		  $$=make_llnd(fi,op1,$1,$3,SMNULL);
                }
	| const_expr_no_commas '&' const_expr_no_commas
		{ if (TRACEON) printf("79 ") ;  
		  $$=make_llnd(fi,BITAND_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '|' const_expr_no_commas
		{ if (TRACEON) printf("80 ") ;  
		  $$=make_llnd(fi,BITOR_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '^' const_expr_no_commas
		{ if (TRACEON) printf("81 ") ;  
		  $$=make_llnd(fi,XOR_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas ANDAND const_expr_no_commas
		{ if (TRACEON) printf("82 ") ;  
		  $$=make_llnd(fi,AND_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas OROR const_expr_no_commas
		{ if (TRACEON) printf("83 ") ; 
		  $$=make_llnd(fi,OR_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas '?' expr ':' const_expr_no_commas
		{ PTR_LLND ll_node1;

                  if (TRACEON) printf("84 ") ; 
		  ll_node1=make_llnd(fi,EXPR_IF_BODY,$2,$3,SMNULL);
		  $$=make_llnd(fi,EXPR_IF,$1,ll_node1,SMNULL);
		}
	| const_expr_no_commas '=' const_expr_no_commas
		{ if (TRACEON) printf("85 ") ; 
		  $$=make_llnd(fi,ASSGN_OP,$1,$3,SMNULL);
                }
	| const_expr_no_commas ASSIGN const_expr_no_commas
		{ int op1 ;

                  if (TRACEON) printf("86 ") ;  
                  op1 = map_assgn_op($2);
		  $$=make_llnd(fi,op1,$1,$3,NULL);
                }

	;


/* modified */
primary:
	IDENTIFIER
		{ PTR_SYMB symbptr;

                  if (TRACEON) printf("87 ") ; 
                  symbptr = find_type_symbol($1,VARIABLE_NAME);
                  if (! symbptr){  /* default function expected */
                                   exception_flag = ON ;
                                   cur_id_entry = $1 ;
				 }
                  else {
                      switch (symbptr->variant) {
                      case MEMBER_FUNC :
                      case FUNCTION_NAME:
                           /* primary_flag = EXCEPTION_ON ;  */
                           /* above one incorrect while nested */
                           $$ = make_llnd(fi,FUNCTION_REF,LLNULL,LLNULL,symbptr);
                           break;
                      case FIELD_NAME :
                      case VARIABLE_NAME:
                           $$ = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symbptr);
                           break;
			 }
                       $$->type = adjust_array_type(symbptr);
		    }
		}

	| CONSTANT
                { if (TRACEON) printf("88 ") ;
                  $$ = $1 ;
		  /* Temporarily setting */
                  $$->type = find_constant_type($1);
                }
	| string
		{ if (TRACEON) printf("89 ") ;
                  $$ = $1 ;    
		  /* Temporarily setting */
                  $$->type = global_int ;
                }
	| '(' expr ')'
		{ if (TRACEON) printf("90 ") ;
                  primary_flag =EXPR_LR ;
                  $$ = $2 ;
                }

	| '(' error ')'
		{ if (TRACEON) printf("91 ") ;   }
	| '(' compstmt ')'
		{ if (TRACEON) printf("92 ");

                }
        |   vector_constant       %prec '.'
                { if (TRACEON) printf("93 ") ;
                }
	| primary '('  
                {  PTR_SYMB symb;

                   if (TRACEON) printf("94.0 ") ;
                   if (exception_flag == ON)
		    {
                      /* strange behavior for default function */
                      symb= install_entry_2(cur_id_entry,FUNCTION_NAME,OTHER);
		      symb->type = global_int ;
                      exception_flag = OFF ;
                      $<ll_node>$ =  make_llnd(fi,FUNC_CALL,LLNULL,LLNULL,symb);
                      $<ll_node>$->type = symb->type ;
                     }
                   else
                      $<ll_node>$ = $1 ;
		 }

          exprlist ')'   %prec '.'
		{ PTR_LLND lnode_ptr ,llp ;
                  int      status;
                  PTR_SYMB symb;

                  if (TRACEON) printf("94 ") ;  
/*                if (primary_flag & EXCEPTION_ON) primary_flag -= EXCEPTION_ON ; */
                  llp = $<ll_node>3 ;
                  status = OFF ;
                  if ((llp->variant == FUNC_CALL) && (!llp->entry.template.ll_ptr1))
                      { 
                         lnode_ptr = llp;
                         status = FUNC_CALL ;
		       }
                  if ((!status) &&((llp->variant == RECORD_REF)||
				   (llp->variant == POINTST_OP)))
		    {
                       lnode_ptr = llp->entry.template.ll_ptr2;
		       if ((lnode_ptr)&&(lnode_ptr->variant== FUNCTION_REF))
			 {
                           lnode_ptr->variant = FUNC_CALL;
			 }
                       status = FUNC_CALL ;
		     }
                  if ((!status) &&(llp->variant== FUNCTION_REF))
		    {  llp->variant = FUNC_CALL ;
                       status = FUNC_CALL ;
		       lnode_ptr = llp;
		     }
		  if (!status) {
                       status = FUNCTION_OP;
		       lnode_ptr = llp;
		     }
                  switch (status) {
                  case FUNCTION_OP : $$ =make_llnd(fi,FUNCTION_OP,$<ll_node>3,$4,SMNULL);
                                     $$->type = $<ll_node>3->type ;
                                     break;
                  case FUNC_CALL :   lnode_ptr->entry.template.ll_ptr1=$4;
                                     $$ = $<ll_node>3 ;
                                     break;
		    default :        err("system error 10");
		  }
		}

	| primary '[' expr_vector ']'   %prec '.'
	   { int status ;
             PTR_LLND ll_ptr,lp1;

             if (TRACEON) printf("95 ") ;
             ll_ptr = check_array_id_format($1,&status);
             switch (status) {
             case NO : err("syntax error ");
                       break ;
	     case ARRAY_OP_NEED:
                       lp1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);/*mod*/
                       $$ = make_llnd(fi,ARRAY_OP,$1,lp1,SMNULL);
                       break;
             case ID_ONLY :
                       ll_ptr->variant = ARRAY_REF ;
                       ll_ptr->entry.template.ll_ptr1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
                       $$ = $1 ;
                       break;
             case RANGE_APPEAR :
	               ll_ptr->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
 	               $$ = $1 ; 
                       break;
             }
             $$->type = adjust_deref_type($1->type,DEREF_OP);
           }


	| primary '.' identifier
		{ PTR_LLND l_ptr1,l_ptr2 ;
                  int sw,tag ;

                  if (TRACEON) printf("96 ") ;  
                  sw = check_field_decl($1,$3,0);
                  if (sw==NO){ err("error member"); $$ = LLNULL;}
                  else {
                        tag  = map2( right_symbol->variant)  ;
                        l_ptr2 = make_llnd(fi,tag,LLNULL,LLNULL,right_symbol);
			$$ = make_llnd(fi,RECORD_REF,$1,l_ptr2,SMNULL);
                        $$->type = adjust_array_type(right_symbol);
                       }
                 }
/*
	| primary   DOUBLEMARK identifier
		{ PTR_LLND l_ptr1,l_ptr2 ;
                  int sw,tag;

                  if (TRACEON) printf("96 ") ;  
                  sw = check_field_decl($1,$3,FUNCTION_ONLY);
                  if (sw==NO){ err("error 18"); $$ = LLNULL;}
                  else {
                        tag  = map2( right_symbol->variant)  ;
                        l_ptr2 = make_llnd(fi,tag,LLNULL,LLNULL,right_symbol);
			$1->type = right_symbol->type ;
                        l_ptr1 = follow_llnd($1,1);
                        l_ptr1->variant = RECORD_REF ;
                        l_ptr1->entry.template.ll_ptr1 = l_ptr2;
                       }

                 }
*/
	| primary POINTSAT identifier
		{ PTR_LLND l_ptr,l_ptr2;
		  PTR_SYMB symb_ptr1;
		  int      tag ;
 
                  if (TRACEON) printf("97 ") ; 
                  /* need more error-checking  */
                  symb_ptr1= find_field_symb_by_type($1->type, $3); 
                  tag  = map2( symb_ptr1->variant)  ;
                  l_ptr = make_llnd(fi,tag,LLNULL,LLNULL,symb_ptr1);
                  $$ = make_llnd(fi,POINTST_OP,$1,l_ptr,SMNULL);
                  $$->type = adjust_array_type(symb_ptr1);
/*                l_ptr = follow_llnd($1,2);
                  l_ptr2 = make_llnd(fi,l_ptr->variant,
                                     l_ptr->entry.template.ll_ptr1,
                                     l_ptr->entry.template.ll_ptr2,
                                     l_ptr->entry.template.symbol);
                  l_ptr->variant = POINTST_OP ;
                  l_ptr->entry.template.ll_ptr1 = l_ptr2 ;
                  l_ptr->entry.template.ll_ptr2 = $3 ;
                  l_ptr->entry.template.symbol  = SMNULL ;  */
		}
                              
	| primary PLUSPLUS
		{ if (TRACEON) printf("98 ") ;
                  $$ = make_llnd(fi,PLUSPLUS_OP,LLNULL,$1,SMNULL);
		  $$->type = $1->type ;
                }
	| primary MINUSMINUS
		{ if (TRACEON) printf("99 ") ; 
                  $$ = make_llnd(fi,MINUSMINUS_OP,LLNULL,$1,SMNULL);
		  $$->type = $1->type ;
		}
	;




/* modified */
const_primary:

          CONSTANT
                { if (TRACEON) printf("88.2 ") ;
                  $$ = $1 ;    
                }
	| '(' const_expr_no_commas ')'
		{ if (TRACEON) printf("90 ") ;
                  primary_flag =EXPR_LR ;
                  $$ = $2 ;
                }

	| '(' error ')'
		{ if (TRACEON) printf("91 ") ;   }
                              
	| const_primary PLUSPLUS
		{ if (TRACEON) printf("98 ") ;
                  $$ = make_llnd(fi,PLUSPLUS_OP,LLNULL,$1,SMNULL);
                }
	| const_primary MINUSMINUS
		{ if (TRACEON) printf("99 ") ; 
                  $$ = make_llnd(fi,MINUSMINUS_OP,LLNULL,$1,SMNULL);
		}
	;

/* Produces a STRING_CST with perhaps more STRING_CSTs chained onto it.  */
string:
	  STRING
            { if (TRACEON) printf("100 ") ;
              $$ = $1 ;
            }
	| string STRING
		{ if (TRACEON) printf("101 ") ; }
	;

xdecls:
	/* empty */
           { if (TRACEON) printf("102 ") ; }
	| decls
           { if (TRACEON) printf("103 ") ; }
	;

decls:
	decl
           { if (TRACEON) printf("104 ") ;
              main_type_flag = TYPE_FOUR ;  
           }
	| errstmt
           { if (TRACEON) printf("105 ") ; }
	| decls decl
           { if (TRACEON) printf("106 ") ;
              main_type_flag = TYPE_FOUR ; 
           }
	| decl errstmt
           { if (TRACEON) printf("107 ") ; }
	;


/* records the type and storage class specs to use for processing
   the declarators that follow */
setspecs: /* empty */
           { if (TRACEON) printf("108 ") ;  }

	;

decl:
	typed_declspecs  initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND bf1 ;

            if (TRACEON) printf("109 ");
            chain_type_declarator($1,OFF,$2);
	    fill_comment();
	  }

	| declmods    notype_initdecls ';'
         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;


           if (TRACEON) printf("110 ");
           ptr1 = $1 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,OFF,$2);
           fill_comment();
	 }

	| typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;

            if (TRACEON) printf("111  "); 
            blob = follow_blob(pred_bfnd);
    	    fill_comment();
         if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))

	   {
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name))
	      {  symb2= find_type_symbol(name->parent,VARIABLE_NAME);
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err(" redeclaration symbol ");
                 else   name->scope = pred_bfnd;
	       }
	  }
	  }

	| declmods ';'
		{ if (TRACEON) printf("112 ") ; 
	          fill_comment();
                }
	| ACCESSWORD  typed_declspecs    initdecls ';'
	  { PTR_TYPE type_ptr2;
            PTR_BFND bf1;

            if (TRACEON) printf("109.2 ");
            chain_type_declarator($2,$1,$3);
	    fill_comment();
	  }

	| ACCESSWORD  declmods    notype_initdecls ';'

         { PTR_TYPE ptr1;
           PTR_LLND lptr2 ;
           PTR_BFND bf1;

           if (TRACEON) printf("110.2 ");

           ptr1 = $2 ;
           ptr1->entry.descriptive.base_type = global_default ;
           /* notype_initdecls returns expr_list ll_node */
           lptr2 = chain_type_declarator(ptr1,$1,$3);
	    fill_comment();
	 }

	| ACCESSWORD  typed_declspecs ';'
          { PTR_SYMB symb1,symb2,name;
            PTR_BLOB blob ;

            if (TRACEON) printf("111.2 "); 
            blob = follow_blob(pred_bfnd);
    	    fill_comment();
         if ((blob->ref->entry.template.bl_ptr1) &&
            ((blob->ref->variant == ENUM_DECL)||(!(blob->ref->entry.template.symbol))))
	   {
            symb1 = find_first_field_2(blob->ref);
            for ( name =symb1 ; name ; name = next_member(name) )
	      {  symb2= find_type_symbol(name->parent,VARIABLE_NAME);
                 if ((symb2) && (symb2->scope == pred_bfnd))
                   err_symb(" redeclaration symbol ",symb2->ident);
                 else   name->scope = pred_bfnd;
	       }
	  }
	  }
	| ACCESSWORD  declmods ';'
		{ if (TRACEON) printf("112.2 ") ; 
	          fill_comment();
		}
	;

/* declspecs which contain at least one type specifier or typedef name.
   (Just `const' or `short' is not enough.)
   A typedef'd name following these is taken as a name to be declared.  */

typed_declspecs:
	  maintype typed_declfinal
           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_BFND bf2;
             PTR_SYMB gsym;
	     PTR_BLOB blob2;

             if (TRACEON) printf("113 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1=$1 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $1;
                             type_ptr1 = type_ptr2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
                             blob2 = follow_blob(pred_bfnd);
                             bf2 = blob2->ref;
                             if ((gsym= bf2->entry.template.symbol))
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1 = type_ptr2;
                                $$ = type_ptr1;
                              }
                             else {
                                $$= $1 ;
			      }
                            passed_bfnd=new_cur_bfnd = bf2 ;                
                            break;
	     default :      err("System Crash ");   }
	   }

	| declmods maintype typed_declfinal
           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_SYMB gsym;
             PTR_BFND bf2;
	     PTR_BLOB blob2 ;

             if (TRACEON) printf("114 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1 = combine_2($1, &second_part);
                             type_ptr1 = $1 ;
                             type_ptr1->entry.descriptive.base_type=$2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $2 ;
                             type_ptr1 = $1 ;
                             type_ptr1 = combine_2($1,&second_part);
                             type_ptr1->entry.descriptive.base_type= type_ptr2 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
                             type_ptr1 = $1;
                             blob2 = follow_blob(pred_bfnd);
                             bf2 = blob2->ref;
                             if (gsym= bf2->entry.template.symbol)
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$ = type_ptr1 ;
                              }
                             else {
                                type_ptr2 = $2;
                                /* new_cur_type must be set inside structsp */
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$=type_ptr1;
			      }
                            passed_bfnd=new_cur_bfnd = bf2 ;                    
                            break;
	     default :      err("System Crash ");   }
	   }









typed_declspecs_2:
	  maintype typed_declfinal
           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_BFND bf2;
             PTR_BLOB blob, old_blob ,blob2;
             PTR_SYMB gsym;

             if (TRACEON) printf("113 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1=$1 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $1;
                             type_ptr1 = type_ptr2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
                             blob2 = follow_blob(pred_bfnd);
	                     bf2 = blob2->ref;
                             if ((gsym= bf2->entry.template.symbol))
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1 = type_ptr2;
                                $$ = type_ptr1;
                              }
                             else {
                                $$= $1;
			      }
                            passed_bfnd=new_cur_bfnd = bf2 ;                
                            /* break unnecerrsary link */
                          if (this_is_class(bf2->variant))
			    {   
			      eliminate_lastlink();
			    }
	                  break ;
	     default :      err("System Crash ");   }
	   }

	| declmods maintype typed_declfinal
           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_SYMB gsym;
             PTR_BLOB blob, old_blob ,blob2;
             PTR_BFND bf2;

             if (TRACEON) printf("114 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1 = combine_2($1, &second_part);
                             type_ptr1 = $1 ;
                             type_ptr1->entry.descriptive.base_type=$2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $2 ;
                             type_ptr1 = $1 ;
                             type_ptr1 = combine_2($1,&second_part);
                             type_ptr1->entry.descriptive.base_type= type_ptr2 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
                             type_ptr1 = $1;
	                     blob2 = follow_blob(pred_bfnd);
	                     bf2 = blob2->ref ;
                             if (gsym= bf2->entry.template.symbol)
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$ = type_ptr1 ;
                              }
                             else {
                                type_ptr2 = $2 ;
                                /* new_cur_type must be set inside structsp */
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$=type_ptr1;
			      }
                            passed_bfnd=new_cur_bfnd = bf2 ;                    
                            /* break unnecerrsary link */
                         if (this_is_class(bf2->variant))
			   {
			      eliminate_lastlink();
			    }

                            break;
	     default :      err("System Crash ");   }
	   }












typed_declfinal:  /* empty */
		{ if (TRACEON) printf("115 ") ;  }
	| typed_declfinal typespec_reserved
		{ if (TRACEON) printf("116 ") ;
                  install_declmod(&second_part,$2);
                }
	| typed_declfinal SCSPEC
		{ if (TRACEON) printf("117 ") ;
                  install_declmod(&second_part,$2);
                }
	;

/* List of just storage classes and type modifiers.
   A declaration can start with this, but then it cannot be used
   to redeclare a typedef-name (unless you use parentheses).  */

declmods:
	  TYPEMOD
		{ PTR_TYPE ptr;
                  if (TRACEON) printf("118 ") ;
                  ptr = get_type(fi,T_DESCRIPT);
                  $$ = install_declmod(ptr, $1);
                }


	| SCSPEC
		{ PTR_TYPE ptr;
                  if (TRACEON) printf("119 ") ;  
                  ptr = get_type(fi,T_DESCRIPT);
                  $$ = install_declmod(ptr, $1);
                }
	| declmods TYPEMOD
		{
                  if (TRACEON) printf("120 ") ;  
                  $$ = install_declmod($1,$2);
                }
	| declmods SCSPEC
		{ if (TRACEON) printf("121 ") ; 
                  $$ = install_declmod($1,$2);
                }
	;


/* Used instead of declspecs where storage classes are not allowed
   (typenames and structure components)
   Don't accept a typedef-name if anything but a modifier precedes it.  */

typed_typespecs:
	  maintype typespecfinal

           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_BFND bf2;
             PTR_SYMB gsym;
	     PTR_BLOB blob2 ;

             if (TRACEON) printf("122 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1=$1 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $1;
                             type_ptr1 = type_ptr2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
	                     blob2 = follow_blob(pred_bfnd);
                             bf2 = blob2->ref ;
                             eliminate_lastlink();
                             if ((gsym= bf2->entry.template.symbol))
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1 = type_ptr2;
                                $$ = type_ptr1;
                              }
                             else {
                                $$= $1 ;
			      }
                            /* passed_bfnd=new_cur_bfnd = bf2 ;     */
                            break;
	     default :      err("System Crash ");   }
	   }

	| nonempty_typemods maintype typespecfinal

           { PTR_TYPE type_ptr1,type_ptr2 ;
             PTR_SYMB gsym;
             PTR_BFND bf2;
	     PTR_BLOB blob2 ;

             if (TRACEON) printf("123 ") ; 
             switch (main_type_flag) {
             case TYPE_ONE : type_ptr1 = combine_2($1, &second_part);
                             type_ptr1 = $1 ;
                             type_ptr1->entry.descriptive.base_type=$2;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_TWO : type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                             type_ptr2->entry.derived_type = (PTR_SYMB) $2 ;
                             type_ptr1 = $1 ;
                             type_ptr1 = combine_2($1,&second_part);
                             type_ptr1->entry.descriptive.base_type= type_ptr2 ;
                             $$ = type_ptr1 ;
                             break ;
             case TYPE_THREE :
                             type_ptr1 = $1;
	                     blob2 = follow_blob(pred_bfnd);
	                     bf2 = blob2->ref ;
                             eliminate_lastlink();
                             if (gsym= bf2->entry.template.symbol)
	                      { type_ptr2 = get_type(fi,T_DERIVED_TYPE);
                                type_ptr2->entry.derived_type = gsym ;
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$ = type_ptr1 ;
                              }
                             else {
                                type_ptr2 = $2;
                                /* new_cur_type must be set inside structsp */
                                type_ptr1->entry.descriptive.base_type = type_ptr2;
                                $$=type_ptr1;
			      }
                            /* passed_bfnd=new_cur_bfnd = bf2 ;  */
                            break;
	     default :      err("System Crash ");   }
	   }

	;

typespecfinal:  /* empty */
		{ if (TRACEON) printf("124 ") ;  }
	| typespecfinal typespec_reserved
		{ if (TRACEON) printf("125 ") ;  }
	;

/* Any kind of typespec.  */

typespec: TYPESPEC
            { if (TRACEON) printf("126 ") ; }
	| TYPEMOD
            { if (TRACEON) printf("127 ") ; }
	| structsp
            { if (TRACEON) printf("128 ") ; }
	| TYPENAME
            { if (TRACEON) printf("129 ") ; }
	;

/* A typespec that is not a modifier.
   It is never correct to use two of these in one declaration.
   But we try to parse it and report a "semantic" error message later.  */

maintype: TYPESPEC
            { if (TRACEON) printf("130 ") ;
              switch ($1) {
              case (int) RID_CHAR :   $$ = global_char;
                                break;
              case (int) RID_INT  :   $$ = global_int ;
                                break;
              case (int) RID_FLOAT :  $$ = global_float ;
                                break ;
              case (int) RID_DOUBLE : $$ = global_double ;
                                break ;
              case (int) RID_VOID :   $$ = global_void ;
                                break ;
	      }
              main_type_flag = TYPE_ONE ;
	    }

	| structsp
            { if (TRACEON) printf("131 ") ;
              $$ = (PTR_TYPE) $1 ;
              main_type_flag = TYPE_THREE ;

            }
	| TYPENAME
            { if (TRACEON) printf("132 ") ;
              $$ = (PTR_TYPE) find_type_symbol($1,TYPE_NAME) ;
              main_type_flag = TYPE_TWO ;
            }
	;

/* A typespec that is a reserved word.
typespec_reserved: TYPESPEC
            { if (TRACEON) printf("133 ") ; }
	| TYPEMOD
            { if (TRACEON) printf("134 ") ; }
	| structsp
            { if (TRACEON) printf("135 ") ; }
	;
*/

typespec_reserved: TYPEMOD  
            { if (TRACEON) printf("134 ") ;
              $$ = $1 ;
            }
        ;


initdecls:
	initdcl
            {  PTR_BLOB blob ;
               PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("136 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              exprlist_llnd->entry.template.ll_ptr1 = $1 ;
              $$ = exprlist_llnd ;
	    }
	| initdecls ',' initdcl
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("137 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$ = exprlist_llnd ;
	    }
	;



notype_initdecls:
	notype_initdcl
            {  PTR_BLOB blob ;
               PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("138 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              exprlist_llnd->entry.template.ll_ptr1 = $1 ;
              $$ = exprlist_llnd ;
	    }

	| notype_initdecls ',' initdcl
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("139 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$ = exprlist_llnd ;
	    }

	;



initdcl:
	  declarator  '='
	
	  init
/* Note how the declaration of the variable is in effect while its init is parsed! */
		{ if (TRACEON) printf("141 ") ; 
                   $$ = make_llnd(fi,ASSGN_OP,$1,$3,SMNULL);
		}
	| declarator '='
	
	  error
		{ if (TRACEON) printf("143 ") ;  }
	| declarator
		{ if (TRACEON) printf("144 ") ;  
                  $$=$1;
                }
	;




notype_initdcl:
	  notype_declarator '='
	
	  init

		{ if (TRACEON) printf("146 ") ;  
                   $$ = make_llnd(fi,ASSGN_OP,$1,$3,SMNULL);
		}

	| notype_declarator '='
	
	  error
		{ if (TRACEON) printf("148 ") ;  }
	| notype_declarator
		{ if (TRACEON) printf("149 ") ; 
                  $$=$1 ;
                }
	;



/* modified */
init:
          expr_no_commas
                { if (TRACEON) printf("150 ") ;
                  $$=$1 ;
                }

        | '{' initlist '}'
                { if (TRACEON) printf("151 ") ; 
                  $$= make_llnd(fi,INIT_LIST,$2,LLNULL,SMNULL);
		}
        | '{' initlist ',' '}'
                { if (TRACEON) printf("152 ") ; 
                  $$= make_llnd(fi,INIT_LIST,$2,LLNULL,SMNULL); 
		}
	;

/* This chain is built in reverse order,
   and put in forward order where initlist is used.  */
/* modified */
initlist:
	inside
		{ if (TRACEON) printf("153 ") ;
                  $$ = make_llnd(fi,EXPR_LIST,$1,LLNULL,SMNULL);
		}
	| initlist ',' inside
            { PTR_LLND ll_node1;

              if (TRACEON) printf("154 ") ; 
              ll_node1 = follow_llnd($1,2);
              ll_node1->entry.template.ll_ptr2 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
              $$=$1;
	    }

	;


/* modified */
inside: 
         init
           { if (TRACEON) printf("155 ") ;
             $$=$1;
	   }
       | array_expr_a
           { if (TRACEON) printf("156 ") ;
             $$=$1 ;
	   }
       | array_expr_b
           { if (TRACEON) printf("157 ") ;
             $$=$1;
	   }

       ;


/* Any kind of declarator (thus, all declarators allowed
   after an explicit typespec).  */

declarator:
	  notype_declarator
             { PTR_LLND ll;
	       PTR_SYMB symb;
               if (TRACEON) printf("159 ") ;
	       $$= $1 ;     
	       symb = find_proc_name();
	       if (symb->decl)  {
		 check_extern_first_part(symb);
	       }
	     }
        | after_type_declarator
             { PTR_LLND ll;
	       PTR_SYMB symb;
               if (TRACEON) printf("159.2 ") ;
	       $$= $1 ;     
	       symb = find_proc_name();
	       if (symb->decl)  {
		 check_extern_first_part(symb);
	       }
	     }

          ;


after_type_declarator:
	  after_type_declarator '(' parmlist ')'  %prec '.'
		{ PTR_LLND ll; 
                  PTR_SYMB symb;

                  if (TRACEON) printf("161 ") ;
                  symb = find_proc_name();
                  ll = $1 ;
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                  
                }

	| after_type_declarator '(' identifiers ')'  %prec '.'
		{ PTR_LLND ll;
                  PTR_SYMB symb;

                  if (TRACEON) printf("162 ") ;
                  ll = $1 ;
                  symb = find_proc_name();
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                }
	| after_type_declarator '(' error ')'  %prec '.'
		{ if (TRACEON) printf("163 ") ; }
	| '(' after_type_declarator ')'
		{ PTR_LLND ll;

                  if (TRACEON) printf("164 ") ;
                  cur_flag = CLEAN ;
                  cur_flag = RULE_LR ;
                  $$ = $2 ;
                }

	| '*' typemods after_type_declarator  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                 if (TRACEON) printf("165 ") ;
                 ll=$3;
                 $$ = make_llnd(fi,DEREF_OP,ll,LLNULL,SMNULL);
                 symbptr1 = find_proc_name();
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_POINTER);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_POINTER);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                          type_1= type->entry.template.base_type=get_type(fi,T_POINTER);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }
	| after_type_declarator '[' expr ']'  %prec '.'
		{ PTR_LLND ll ;

                  if (TRACEON) printf("166 ") ;
                  ll = $1 ;
                  if (( cur_flag != (RULE_ID | RULE_ARRAY)) && (cur_flag != RULE_ID)) err("syntax error 1");
                  else 
                    { chain_array_range(ll,$3);
                      $$ = ll ;
                      cur_flag = cur_flag | RULE_ARRAY ;
                    }
                }

	| after_type_declarator '[' ']'  %prec '.'
		{ PTR_LLND ll;

                  if (TRACEON) printf("16 ") ; 
                  ll= $1 ;
                  if (( cur_flag != (RULE_ID | RULE_ARRAY)) && (cur_flag != RULE_ID)) err("syntax error 2");
                  else 
                    { chain_array_range(ll,LLNULL);
                      $$ = ll ;
                      cur_flag = cur_flag | RULE_ARRAY ;
                    }
                }

        | after_type_declarator '(' expr ')'      %prec '.'
                 {  PTR_LLND ll ;

                    if (TRACEON) printf("168 ") ;
                    ll = $1 ;
                    if ((cur_flag - RULE_ID) &&(cur_flag - RULE_ID - RULE_ARRAY))
                        err("syntax error 3");
                    else {
                        $$ = make_llnd(fi,CLASSINIT_OP,ll,$3,SMNULL);
                        cur_flag = cur_flag | RULE_CLASSINIT ;
                    }
                 }
	| TYPENAME 
            { if (TRACEON) printf("169 ") ;
                   $$=lazy_install($1,VARIABLE_NAME,NO);
	    } 
/*        | multiple_typename
            { if (TRACEON) printf("168 ") ;}
*/
	;

/* A declarator allowed whether or not there has been
   an explicit typespec.  These cannot redeclare a typedef-name.  */
 
/* modified */
notype_declarator:
	  notype_declarator '(' parmlist ')'  %prec '.'
		{ PTR_LLND ll; 
                  PTR_SYMB symb;

                  if (TRACEON) printf("169 ") ;
                  symb = find_proc_name();
                  ll = $1 ;
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                  
                }
	| notype_declarator '(' identifiers ')'  %prec '.'
		{ PTR_LLND ll;
                  PTR_SYMB symb;

                  if (TRACEON) printf("170 ") ;
                  ll = $1 ;
                  symb = find_proc_name();
                  if ((ll->variant == VAR_REF)||(ll->variant ==RECORD_REF) ||
                       (ll->variant == FUNCTION_REF))                 
                       transform_symb_node(symb);
                  $$ = func_declarator_appear(ll,$3,symb) ;
                }
	| notype_declarator '(' error ')'  %prec '.'
		{ if (TRACEON) printf("171 ") ; }
	| '(' notype_declarator ')'
		{ PTR_LLND ll;

                  if (TRACEON) printf("172 ") ;
                  cur_flag = CLEAN ;
                  cur_flag = RULE_LR ;
                  $$ = $2 ;
                }
	| '*' typemods notype_declarator  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		PTR_SYMB symbptr1 ;
		int level_num,empty_sw ;

                 if (TRACEON) printf("173 ") ;
                 ll=$3;
                 $$ = make_llnd(fi,DEREF_OP,ll,LLNULL,SMNULL);
                 symbptr1 = find_proc_name();
		if (! symbptr1->type) 
                     type = symbptr1->type = get_type(fi,T_POINTER);
                 else  /* no type checking here */
                  { type = follow_type(symbptr1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_POINTER);
                          break ;
                    case T_FUNCTION:
                    case T_POINTER :
                          type_1= type->entry.template.base_type=get_type(fi,T_POINTER);
                          break;
                    default : err("System Trouble");
                    }
                  }
             }
	| notype_declarator '[' expr_no_commas ']'  %prec '.'
		{ PTR_LLND ll ;

                  if (TRACEON) printf("174 ") ;
                  ll = $1 ;
                  if (( cur_flag != (RULE_ID | RULE_ARRAY)) && (cur_flag != RULE_ID)) err("syntax error 1");
                  else 
                    { chain_array_range(ll,$3);
                      $$ = ll ;
                      cur_flag = cur_flag | RULE_ARRAY ;
                    }
                }
	| notype_declarator '[' ']'  %prec '.'
		{ PTR_LLND ll;

                  if (TRACEON) printf("175 ") ; 
                  ll= $1 ;
                  if (( cur_flag != (RULE_ID | RULE_ARRAY)) && (cur_flag != RULE_ID)) err("syntax error 2");
                  else 
                    { chain_array_range(ll,LLNULL);
                      $$ = ll ;
                      cur_flag = cur_flag | RULE_ARRAY ;
                    }
                }

       
	| notype_declarator '(' expr ')'      %prec '.'
                 {  PTR_LLND ll ;

                    if (TRACEON) printf("176 ") ;
                    ll = $1 ;
                    if ((cur_flag - RULE_ID) &&(cur_flag - RULE_ID - RULE_ARRAY))
                        err("syntax error 3");
                    else {
                        $$ = make_llnd(fi,CLASSINIT_OP,ll,$3,SMNULL);
                        cur_flag = cur_flag | RULE_CLASSINIT ;
                    }
                 }
        | IDENTIFIER
             {
                   $$=lazy_install($1,VARIABLE_NAME,NO);

             }
        | OPERATOR LOADEDOPR  
             {  PTR_HASH entry; 
                if (TRACEON) printf("190 ") ;
                $$ = lazy_install($2,FUNCTION_NAME,NO);
	      }
        | multiple_id
             { if (TRACEON) printf("178 ") ;
               $$=$1 ; 
             }
	;

/*
multiple_typename :
          TYPENAME  DOUBLEMARK multiple_id2
        { if (TRACEON) printf("179 ") ;}
        ;

*/
/* '::'  DOUBLEMARK */
multiple_id : record_name '.'  IDENTIFIER
            { int sw ;

              if (TRACEON)  printf("180 ") ;
              sw= check_field_decl_2($1,$3,FUNCTION_ONLY);
              if (sw==NO) err("syntax error 7");
              else
		{  new_cur_symb = right_symbol ;  
                   new_cur_type = (PTR_TYPE) NULL ;
                   $$ = make_llnd(fi, FUNCTION_REF ,LLNULL,LLNULL,new_cur_symb); 
                   cur_flag = RULE_MULTIPLE_ID ;
		 }
	    }
        ;

record_name : IDENTIFIER 
           {     new_cur_symb = find_type_symbol($1,VARIABLE_NAME);
                 if (!new_cur_symb) err("syntax error 8");
                 $$=new_cur_symb;
	       }
	      
        |  record_name '.' IDENTIFIER
            { int sw ;

              if (TRACEON)  printf("180 ") ;
              sw= check_field_decl_2($1,$3,OFF);
              if (sw==NO) err("syntax error 8");
              else
		   $$ = new_cur_symb = right_symbol ;  
	    }

        ;


/*
multiple_id2 :
          IDENTIFIER
             { if (TRACEON) printf("181 ") ;}
        | TYPENAM{
             { if (TRACEON) printf("182 ") ;}
        | multiple_id
             { if (TRACEON) printf("183 ") ;}
        | multiple_typename
             { if (TRACEON) printf("184 ") ;}
        ;
*/





       







/* modified */
structsp:
	  STRUCT identifier 
               { PTR_SYMB symb1 ;
                 symb1 = find_type_symbol($2,STRUCT_NAME) ;
                 if ((!symb1) ||(!same_scope(symb1->scope,pred_bfnd)))
                        symb1 = install_entry_2($2,STRUCT_NAME,UP_TO_NODECL) ;
                 else 
		   { if (same_scope(symb1->scope,pred_bfnd)&& (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(STRUCT_DECL,symb1);           
	       }
          '{' component_decl_list '}'
		{  if (TRACEON) printf("193 ") ; 
                   $$ = install_struct(T_STRUCT,SMNULL);
                }
	| STRUCT
               { char buffer[200];
		 PTR_SYMB symb1;
		 PTR_HASH entry;
		 int status;
		 
		 sprintf(buffer,"Z%d_Dummy",enum_id++);
		 entry = look_up_type(buffer,&status);
		 symb1 = install_entry_2(entry,STRUCT_NAME,UP_TO_NODECL);
		 symb1->entry.template.seen = BEEN_SEEN;
		 enter_inner_level(STRUCT_DECL,symb1,LLNULL); 
	       }
          '{' component_decl_list '}'
                { if (TRACEON) printf("194 ") ; 
                  $$ = install_struct(T_STRUCT,SMNULL);
                } 
	| STRUCT identifier
               { PTR_SYMB symb1 ;

                 if  (TRACEON) printf("195 ") ;
                 symb1 = find_type_symbol($2,STRUCT_NAME) ;
                 if (!symb1){ symb1=install_entry_2($2,STRUCT_NAME,UP_TO_NODECL);
			      symb1->entry.template.seen = NOT_SEEN ;
			     }
                 type_checking(symb1,T_STRUCT);
                 $$ = set_struct_typename(STRUCT_DECL,symb1);
                }

	| UNION identifier
               { PTR_SYMB symb1 ;
                 symb1 = find_type_symbol($2,UNION_NAME) ;
                 if ((!symb1) ||(!same_scope(symb1->scope,pred_bfnd)))
                        symb1 = install_entry_2($2,UNION_NAME,UP_TO_NODECL) ;
                 else 
		   { if (same_scope(symb1->scope,pred_bfnd)&& (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(UNION_DECL,symb1);
               }
           '{' component_decl_list '}'
		{  if (TRACEON) printf("196 ") ;
                  $$ = install_struct(T_UNION,SMNULL);
                }
	| UNION 
               { char buffer[200];
		 PTR_HASH entry;
		 PTR_SYMB symb1;
		 int status;
		 
		 sprintf(buffer,"Z%d_Dummy",enum_id++);
		 entry = look_up_type(buffer,&status);
		 symb1 = install_entry_2(entry,UNION_NAME,UP_TO_NODECL);
		 symb1->entry.template.seen = BEEN_SEEN;
		 enter_inner_level(UNION_DECL,symb1,LLNULL); 
		}

            '{' component_decl_list '}'
		{  if (TRACEON) printf("197 ") ;
                   $$=install_struct(T_UNION,SMNULL);
		 }
	| UNION identifier
		{ PTR_SYMB symb1 ;

                 if (TRACEON) printf("198 ") ;  
                 symb1 = find_type_symbol($2,UNION_NAME) ;
                 if (!symb1){  symb1 = install_entry_2($2,UNION_NAME,UP_TO_NODECL);
                               symb1->entry.template.seen = NOT_SEEN ;
			     }
                 type_checking(symb1,T_UNION);
                 $$ = set_struct_typename(UNION_DECL,symb1);
                }
	| CLASS identifier ':' TYPENAME 
             {   PTR_SYMB symb1 ;

                 symb1 = find_type_symbol($2,CLASS_NAME) ;
                 if ((!symb1) ||( !same_scope(symb1->scope,pred_bfnd)))
                        symb1 = install_entry_2($2,CLASS_NAME,UP_TO_NODECL);
                 else 
		   { if (same_scope(symb1->scope,pred_bfnd) && (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(CLASS_DECL,symb1);           
                }
          '{' component_decl_list public_appear ':' component_decl_list '}'
                { 
                  if (TRACEON) printf("199 ") ;
                  $$ = install_struct(T_DERIVED_CLASS,$4);
                }
	| CLASS identifier   
              {  PTR_SYMB symb1;
                 symb1 = find_type_symbol($2,CLASS_NAME) ;
                 if ((!symb1) ||(!same_scope(symb1->scope,pred_bfnd)))
                        symb1 = install_entry_2($2,CLASS_NAME,UP_TO_NODECL) ;
                else 
		   { if (same_scope(symb1->scope,pred_bfnd)&& (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(CLASS_DECL,symb1);
                }
          '{' component_decl_list 
          public_appear ':' component_decl_list '}'
                {  if (TRACEON) printf("200 ");
                  $$ = install_struct(T_CLASS,SMNULL);
                }

	| CLASS 
               { char buffer[200];
		 PTR_SYMB symb1;
		 PTR_HASH entry;
		 int status;
		 
		 sprintf(buffer,"Z%d_Dummy",enum_id++);
		 entry = look_up_type(buffer,&status);
		 symb1 = install_entry_2(entry,CLASS_NAME,UP_TO_NODECL);
		 symb1->entry.template.seen = BEEN_SEEN;
		 enter_inner_level(CLASS_DECL,symb1,LLNULL); 
		}

         '{' component_decl_list public_appear ':' component_decl_list '}'
                {  if (TRACEON) printf("201 ") ; 
                  $$ = install_struct(T_CLASS,SMNULL);
                }
	| CLASS identifier
                {     PTR_SYMB symb1;
                     
                      if (TRACEON) printf("202 ") ;
                      symb1 = find_type_symbol($2,CLASS_NAME) ;
                      if (!symb1){  symb1 = install_entry_2($2,CLASS_NAME,UP_TO_NODECL) ;
                                    symb1->entry.template.seen = NOT_SEEN ;
		  	     }
                      type_checking(symb1,T_CLASS);
                      $$ = set_struct_typename(CLASS_DECL,symb1);
                }
	| ENUM identifier
              {  PTR_SYMB symb1;
                 symb1 = find_type_symbol($2,ENUM_NAME) ;
                 if ((!symb1) ||(!same_scope(symb1->scope,pred_bfnd)))
                        symb1 = install_entry_2($2,ENUM_NAME,UP_TO_NODECL);
                 else 
		   { if (same_scope(symb1->scope,pred_bfnd)&& (symb1->entry.template.seen == BEEN_SEEN))
                      err("re_declaration symbol ");
		   }
		 symb1->entry.template.seen = BEEN_SEEN;
                 enter_inner_level(ENUM_DECL,symb1); 
                }
               '{' enumlist '}'
		{  if (TRACEON) printf("203 ") ; 
                  $$ = install_struct(T_ENUM,SMNULL);
                }
	| ENUM 
               { char buffer[200];
		 PTR_SYMB symb1;
		 int status;
		 PTR_HASH entry;
		 
		 sprintf(buffer,"Z%d_Dummy",enum_id++);
		 entry = look_up_type(buffer,&status);
		 symb1 = install_entry_2(entry,ENUM_NAME,UP_TO_NODECL);
		 symb1->entry.template.seen = BEEN_SEEN;
		 enter_inner_level(ENUM_DECL,symb1,LLNULL); 
		}

              '{'  enumlist '}'
		{ if (TRACEON) printf("205 ") ;
                  $$ = install_struct(T_ENUM,SMNULL);
                }
	| ENUM identifier
		{ PTR_SYMB symb1 ;
                 
                  if (TRACEON) printf("206 ") ;
                  symb1 = find_type_symbol($2,ENUM_NAME) ;
                  if (!symb1){  symb1 = install_entry_2($2,ENUM_NAME,UP_TO_NODECL);
                               symb1->entry.template.seen = NOT_SEEN ;
			     }
                  type_checking(symb1,T_ENUM);
                  $$ = set_struct_typename(ENUM_DECL,symb1);
                }
	;



public_appear : PUBLIC
                 {}

component_decl_list:   /* empty */
		{ if (TRACEON) printf("207 ") ;  }
        | ';'
                {}
	| nonempty_component_decl_list
                {}
        ;

/* modified */
nonempty_component_decl_list:
	 component_decl
                { if (TRACEON) printf("208 ") ;
                  main_type_flag = TYPE_FOUR ;
                }
	| nonempty_component_decl_list  component_decl
		{ if (TRACEON) printf("209 ") ;
                  main_type_flag = TYPE_FOUR ;
                }
	| nonempty_component_decl_list ';'
                { if (TRACEON) printf("210 ") ;
                  main_type_flag = TYPE_FOUR ;
                }   
	;

/* modified */
component_decl:
	typed_declspecs 
        components  ';'
	  { PTR_BFND bf1;

            if (TRACEON) printf("211 ") ;
            chain_type_declarator($1,OFF,$2);
	    fill_comment();
           }
           
        | FRIEND typed_declspecs components ';'
          { PTR_BFND bf1 ;

            if (TRACEON) printf("212 ") ; 
            chain_type_declarator($2,OFF,$3);
	    fill_comment();
            /* needs more */
          }

	| declmods   notype_components  ';'
	   { PTR_BFND bf1 ;


              if (TRACEON) printf("213 ") ;
              $1->entry.descriptive.base_type = global_default;
	      chain_type_declarator($1,OFF,$2);
              fill_comment();
           }

/*
        | FRIEND declmods  notype_components  ';'
             { PTR_BFND bf1 ;
                
              if (TRACEON) printf("214 ") ; 
              $2->entry.descriptive.base_type = global_default;
              chain_type_declarator($2,OFF,$3);
	      fill_comment();
             }
*/
        | FRIEND   fndef
              { PTR_SYMB symbptr ;
                if (TRACEON) printf("215 ") ;
                /* set friend flag needed */
         
              }
        | fndef
          { if (TRACEON) printf("216 ") ;   } 
	| error
		{ if (TRACEON) printf("217 ") ;  }
	;


components:
	  /* empty */
              { if (TRACEON) printf("218 ") ;
                $$ = LLNULL ;
              }
	| component_declarator
              { PTR_BLOB blob ;
                PTR_LLND exprlist_llnd ;

                if (TRACEON) printf("219 ") ; 
                blob = follow_blob(pred_bfnd);
                exprlist_llnd = blob->ref->entry.template.ll_ptr1;
                exprlist_llnd->entry.template.ll_ptr1 = $1 ;
                $$ = exprlist_llnd ;
              }
	| components ',' component_declarator
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("220 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$= exprlist_llnd ;
	    }

	;


notype_components:
	  /* empty */
              { if (TRACEON) printf("218 ") ;
                $$ = LLNULL ;
              }
	| notype_component_declarator
              { PTR_BLOB blob ;
                PTR_LLND exprlist_llnd ;

                if (TRACEON) printf("219 ") ; 
                blob = follow_blob(pred_bfnd);
                exprlist_llnd = blob->ref->entry.template.ll_ptr1;
                exprlist_llnd->entry.template.ll_ptr1 = $1 ;
                $$ = exprlist_llnd ;
              }
	| notype_components ',' component_declarator
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("220 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$= exprlist_llnd ;
	    }

	;



component_declarator:
	declarator
		{ if (TRACEON) printf("221 ") ;
                  $$ = $1 ;
                }
	| declarator ':' expr_no_commas
		{ PTR_SYMB symb ;

                  if (TRACEON) printf("222 ") ; 
                  symb = find_proc_name();
                  if (symb->variant == FIELD_NAME)
                         symb->entry.field.restricted_bit = $3 ;
                  $$ = make_llnd(fi,BIT_NUMBER,$1,$3,SMNULL);
                 
                }

	| ':' expr_no_commas
		{ char buffer[40];
		  int status,i;
		  PTR_HASH pseudo_hash_entry;
		  PTR_SYMB symb;
		  PTR_LLND lp1;

		  if (TRACEON) printf("223 ") ;  
		  for (i=0; i<30 ; i++) buffer[i]= '\0';
		  sprintf(buffer,"%s%d","ZZZ_",num_symbs);
		  pseudo_hash_entry = look_up_type(buffer,&status);
		  lp1=lazy_install( pseudo_hash_entry,VARIABLE_NAME,NO);
		  symb = find_proc_name();
                  if (symb->variant == FIELD_NAME)
                         symb->entry.field.restricted_bit = $2;
                  $$ = make_llnd(fi,BIT_NUMBER,lp1,$2,SMNULL);
                }
	;



notype_component_declarator:
	notype_declarator
		{ if (TRACEON) printf("221 ") ;
                  $$ = $1 ;
                }
	| notype_declarator ':' expr_no_commas
		{ PTR_SYMB symb ;

                  if (TRACEON) printf("222 ") ; 
                  symb = find_proc_name();
                  if (symb->variant == FIELD_NAME)
                         symb->entry.field.restricted_bit = $3 ;
                  $$ = make_llnd(fi,BIT_NUMBER,$1,$3,SMNULL);
                 
                }

	| ':' expr_no_commas
		{ if (TRACEON) printf("223 ") ;  
                   err("Unimplemented feature, empty");
                }
	;

/* We chain the enumerators in reverse order.
   They are put in forward order where enumlist is used.
   (The order used to be significant, but no longer is so.
   However, we still maintain the order, just to be clean.)  */

enumlist:
	  enumerator
            {  PTR_BLOB blob ;
               PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("224 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              exprlist_llnd->entry.template.ll_ptr1 = $1 ;
              $$ = exprlist_llnd ;
	    }

	| enumlist ',' enumerator
            { PTR_LLND ll_node1;
              PTR_BLOB blob ;
              PTR_LLND exprlist_llnd ;

              if (TRACEON) printf("225 ") ;
              blob = follow_blob(pred_bfnd);
              exprlist_llnd = blob->ref->entry.template.ll_ptr1;
              ll_node1 = follow_llnd(exprlist_llnd,2);
              ll_node1->entry.template.ll_ptr1 = $3 ;
              $$ = exprlist_llnd ;
	    }
	| enumlist ','
             { if (TRACEON) printf("226 ") ; }
	;


enumerator:
	  identifier
		{ PTR_TYPE ptr1;
                  PTR_LLND llnd ;
		  if (TRACEON) printf("227 ") ; 
                  llnd = $$ = lazy_install($1,VARIABLE_NAME,YES);
                  ptr1 = global_default;
                  /* notype_initdecls returns expr_list ll_node */
                  chain_type_declarator(ptr1,OFF,llnd);

		}
	| identifier '=' expr_no_commas
 		{ PTR_LLND llnd ;
		  PTR_TYPE ptr1;
 
                  if (TRACEON) printf("228 ") ;  
                  llnd = lazy_install($1,VARIABLE_NAME,YES);
                  ptr1 = global_default ;
                  /* notype_initdecls returns expr_list ll_node */
                  chain_type_declarator(ptr1,OFF,llnd);
                  $$= make_llnd(fi,ASSGN_OP,llnd,$3,SMNULL);
		}
	;

typename:
	typed_typespecs absdcl
                {
                  if (TRACEON) printf("229 ") ;  
		  $$=chain_up_type($1,$2);
                }
	| nonempty_typemods absdcl
		{ PTR_TYPE new_type;
                  if (TRACEON) printf("230 ") ;
		  new_type=chain_up_type($1,$2);
		  $$=chain_up_type(global_default,new_type);
		}
	;
	
absdcl:   /* an absolute declarator */
	/* empty */
		{ if (TRACEON) printf("231 ") ; 
                  $$ = (PTR_TYPE) NULL ;
		}
	| absdcl1
              { if (TRACEON) printf("232 ") ;
	        $$ = $1 ;
	      }
	;

nonempty_typemods:
	  TYPEMOD
		{ PTR_TYPE ptr;
                  if (TRACEON) printf("233 ") ;
                  ptr = get_type(fi,T_DESCRIPT);
                  $$ = install_declmod(ptr, $1);
                }

	| nonempty_typemods TYPEMOD
		{ if (TRACEON) printf("234 ") ;  

                  $$ = install_declmod($1,$2);
                }
	;

typemods:
	  /* empty */
		{ if (TRACEON) printf("235 ") ;
		  $$ = (PTR_TYPE) NULL;
		}
	| typemods TYPEMOD
		{ PTR_TYPE ptr;
		  if (TRACEON) printf("236 ") ;  
                  if (!$1) ptr = get_type(fi,T_DESCRIPT);
		  else     ptr = $1;
                  $$ = install_declmod(ptr, $2);
                }
	;

absdcl1:  /* a nonempty absolute declarator */
	  '(' absdcl1 ')'
		{ if (TRACEON) printf("237 ") ;  
		   $$ = $2;
		}
	|   '*' typemods absdcl1  %prec UNARY
		{ PTR_TYPE type;
		  if (TRACEON) printf("238 ") ; 
                  type = get_type(fi,T_POINTER);
		  $$ = chain_up_type(type,$3);
                }
	| '*' typemods  %prec UNARY
		{ if (TRACEON) printf("239 ") ; 
                  $$ = get_type(fi,T_POINTER);
                 }
	| absdcl1 '(' parmlist ')'  %prec '.'
		{ PTR_TYPE oldptr,temptr,type1;
		  if (TRACEON) printf("240 ") ;
		  for (oldptr=temptr=$1;temptr;temptr=temptr->entry.template.base_type)
		    oldptr = temptr;
		  if (oldptr->variant != T_POINTER) err("invalid typename");
		  else {
		    type1 = get_type(fi,T_FUNCTION);
		    oldptr->entry.template.base_type = type1;
		  }
                  $$ = $1;
                }
	| absdcl1 '[' expr ']'  %prec '.'
		{ PTR_LLND p1;
		  if (TRACEON) printf("241 ") ; 
		  p1 = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
                  $$ = chain_type_with_array_range($1,p1);
                }
	| absdcl1 '[' ']'  %prec '.'
		{ PTR_LLND p1;
		  if (TRACEON) printf("242 ") ;
		  p1 = make_llnd(fi,EXPR_LIST,LLNULL,LLNULL,SMNULL);
                  $$ = chain_type_with_array_range($1,p1);
                }
	| '(' parmlist ')'  %prec '.'
		{ if (TRACEON) printf("243 ") ;
                  $$ = (PTR_TYPE) NULL ;
                }
	| '[' expr ']'  %prec '.'
		{ PTR_TYPE type;
		  PTR_LLND p1;
		  if (TRACEON) printf("244 ") ;
		  type = get_type(fi,T_ARRAY);
		  p1 = make_llnd(fi,EXPR_LIST,$2,LLNULL,SMNULL);
		  type->entry.ar_decl.ranges= p1;
		  $$ =type;
                 }
	| '[' ']'  %prec '.'
		{ PTR_TYPE type;
		  PTR_LLND p1;
		  if (TRACEON) printf("245 ") ; 
		  type = get_type(fi,T_ARRAY);
		  p1 = make_llnd(fi,EXPR_LIST,LLNULL,LLNULL,SMNULL);
		  type->entry.ar_decl.ranges= p1;
		  $$ =type;
                }
	;

/* at least one statement, the first of which parses without error.  */
/* stmts is used only after decls, so an invalid first statement
   is actually regarded as an invalid decl and part of the decls.  */

stmts:
	stmt
           { if (TRACEON) printf("246 ") ; }
	| stmts stmt
           { if (TRACEON) printf("247 ") ; }
	| stmts errstmt
           { if (TRACEON) printf("248 ") ; }
	;

errstmt:  error ';'
           { if (TRACEON) printf("249 ") ; }
	;

pushlevel:  /* empty */
           { PTR_BLOB blob ;
             PTR_BFND bf1 ;

             if (TRACEON) printf("250 ") ;
             blob = pred_bfnd->entry.template.bl_ptr1 ;
             if ( is_basic_block() )
               { bf1 = get_bfnd(fi,BASIC_BLOCK,SMNULL,LLNULL,LLNULL,LLNULL);
                 chain_up(pred_bfnd,bf1);
                 pred_bfnd = bf1 ;

	       }
	   }
	;

do_decls:   /* empty */
		{ if (TRACEON) printf("251 ") ;  }
	;

compstmt: '{' '}'
		{ if (TRACEON) printf("252 ") ;  }
	| '{' pushlevel decls do_decls stmts '}'
		{ PTR_BFND bf1;
		  if (TRACEON) printf("253 ") ;
                  if (pred_bfnd->variant == BASIC_BLOCK)
		    { 
		      bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
		      chain_up(pred_bfnd,bf1); 
		      pred_bfnd = pred_bfnd->control_parent ;
		    }
		}
	| '{' pushlevel decls do_decls '}'
		{ PTR_BFND bf1;
		  if (TRACEON) printf("254 ") ;
                  if (pred_bfnd->variant == BASIC_BLOCK)
		    { 
		      bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
		      chain_up(pred_bfnd,bf1); 
		      pred_bfnd = pred_bfnd->control_parent ;
		    }
		}
	| '{' pushlevel error '}'
		{ if (TRACEON) printf("255 ") ; 
                  if (pred_bfnd->variant == BASIC_BLOCK)
                        pred_bfnd = pred_bfnd->control_parent ;
                }
	| '{' pushlevel stmts '}'
		{ PTR_BFND bf1;
		  if (TRACEON) printf("256 ") ;
                  if (pred_bfnd->variant == BASIC_BLOCK)
		    { 
		      bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
		      chain_up(pred_bfnd,bf1); 
		      pred_bfnd = pred_bfnd->control_parent ;
		    }
                }
	;

simple_if:
	  IF '(' expr ')'
	   { PTR_BFND bf1 ;
      
                bf1 = get_bfnd(fi,IF_NODE,SMNULL,$3,LLNULL,LLNULL);
                chain_up(pred_bfnd,bf1);
                pred_bfnd = bf1 ;
           }	
	  stmt
           {   PTR_BFND bf1;
               if (TRACEON) printf("257 ") ;
	       bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
	       chain_up(pred_bfnd,bf1);
	       new_cur_bfnd = pred_bfnd ;   /* for else using */
	       pred_bfnd = pred_bfnd->control_parent;
	     }

	;



/* modified */
stmt:
	  compstmt
            { if (TRACEON) printf("258 ") ; }
	| expr ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("259 ") ;  
                  bf1 = get_bfnd(fi,EXPR_STMT_NODE,SMNULL,$1,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| simple_if ELSE 
		{   PTR_BLOB blob ;
                    if (TRACEON) printf("260 ") ;
		    if ( pred_bfnd->index == BRANCH_OFF)
                          blob = follow_blob(pred_bfnd);
                    else
                          blob = follow_blob_2(pred_bfnd);
                    pred_bfnd = blob->ref ;
                    pred_bfnd->index = BRANCH_ON;
		  }
	  stmt
		{ PTR_BFND bf1;

		  if (TRACEON) printf("261 ") ;  
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd->index = BRANCH_OFF ;
                  pred_bfnd = pred_bfnd->control_parent ;
                }
	| simple_if
		{ if (TRACEON) printf("262 ") ;  }
	| WHILE

	  '(' expr ')'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("264 ") ;  
                  bf1 = get_bfnd(fi,WHILE_NODE,SMNULL,$3,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}
	  stmt
	       {  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("265 ") ;  
		}
	| DO
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("266 ") ;  
                  bf1 = get_bfnd(fi,DO_WHILE_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}

	  stmt WHILE '(' expr ')' ';'
	       {  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd->entry.template.ll_ptr1 = $6 ;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("267 ") ;  
		}

	| FOR 
	  '(' xexpr ';'

	  xexpr ';'

	  xexpr ')'
		/* Don't let the tree nodes for $9 be discarded
		   by clear_momentary during the parsing of the next stmt.  */
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("270 ") ;  
                  bf1 = get_bfnd(fi,FOR_NODE,SMNULL,$3,$5,$7);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}

	  stmt
              {   PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("271 ") ;  
		}

	| SWITCH '(' expr ')'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("272 ") ;  
                  bf1 = get_bfnd(fi,SWITCH_NODE,SMNULL,$3,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
		}

	  stmt
	       {
		  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("273 ") ;  
		}

	| CASE expr ':'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("274 ") ;  
                  bf1 = get_bfnd(fi,CASE_NODE,SMNULL,$2,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	  stmt
                { if (TRACEON) printf("275 ") ; }
	| DEFAULT_TOKEN ':'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("276 ") ;  
                  bf1 = get_bfnd(fi,DEFAULT_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

		
	  stmt
                { if (TRACEON) printf("277 ") ; }
	| BREAK ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("278 ") ;  
                  bf1 = get_bfnd(fi,BREAK_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| CONTINUE ';'	
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("279 ") ;  
                  bf1 = get_bfnd(fi,CONTINUE_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| RETURN ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("280 ") ;  
                  bf1 = get_bfnd(fi,RETURN_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| RETURN expr ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("281 ") ;  
                  bf1 = get_bfnd(fi,RETURN_NODE,SMNULL,$2,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| ASM '(' STRING ')' ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("282 ") ;  
                  bf1 = get_bfnd(fi,ASM_NODE,SMNULL,$3,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

	| GOTO identifier ';'
		{  PTR_LABEL temp_label ;
		   PTR_SYMB  temp_symb ;
                   PTR_BFND  bf1 ;
		   if (TRACEON) printf("283 ") ; 
                   
                   bf1 = get_bfnd(fi,GOTO_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                   chain_up(pred_bfnd,bf1);
		   temp_symb = find_type_symbol($2,LABEL_NAME);
                   if (!temp_symb)
		     { temp_label = get_label(fi,$2);
                       temp_label->labused  = YES ;
		     }
                   else
                     { temp_label = find_label(temp_symb );
                       if (! temp_label) err("unexpected label ");
                       else      temp_label->labused  = YES ;
                     }
                   bf1->entry.template.lbl_ptr = temp_label ;
                }    
	| identifier ':'
		{  PTR_LABEL temp_label ;
		   PTR_SYMB  temp_symb ;
                   PTR_BFND  bf1 ;
		   
		   if (TRACEON) printf("284 ") ;
                   bf1 = get_bfnd(fi,LABEL_STAT,SMNULL,LLNULL,LLNULL,LLNULL);
                   chain_up(pred_bfnd,bf1);
                   temp_symb = find_type_symbol($1, LABEL_NAME);
                   if (!temp_symb) 
		     {   temp_label = get_label(fi,$1);
                         temp_label->labdefined = YES ;
		       }
                   else
                     { temp_label = find_label(temp_symb );
                       if (temp_label)
			 {  if ((temp_label->labdefined) == YES)
                              err("label redeclaration ");
                            else   temp_label->labdefined = YES;
			 }
                     }
                   bf1->entry.template.lbl_ptr = temp_label ;
                   temp_label->statbody = bf1 ;
		 } 
	  stmt
             { if (TRACEON) printf("285 ") ; }
        | COBREAK ';'
		{ PTR_BFND bf1 ;

                  if (TRACEON) printf("286 ") ;  
                  bf1 = get_bfnd(fi,COBREAK_NODE,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		}

        | COLOOP '(' expr_no_commas ';' lexpr ')' 
		{ PTR_BFND bf1 ;
		  PTR_HASH entry;
		  int status;
		  PTR_SYMB symb;

                  if (TRACEON) printf("287.1 ") ;  
                  bf1 = get_bfnd(fi,COLOOP_NODE,SMNULL,$3,$5,LLNULL);
		  entry = look_up_type("$COLOOP",&status);
                  symb  = install_entry_2(entry,VARIABLE_NAME,OTHER);
		  bf1->entry.template.symbol = symb;
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
        	}

          stmt 
	       {  
		  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("287 ") ;  
		}

        | COEXEC '(' xexpr  ')'
		{ PTR_BFND bf1 ;
		  PTR_HASH entry;
		  int status;
		  PTR_SYMB symb;

                  if (TRACEON) printf("287.1 ") ;  
                  bf1 = get_bfnd(fi,COEXEC_NODE,SMNULL,$3,LLNULL,LLNULL);
		  entry = look_up_type("$COEXEC",&status);
                  symb  = install_entry_2(entry,VARIABLE_NAME,OTHER);
		  bf1->entry.template.symbol = symb;
                  chain_up(pred_bfnd,bf1);
                  pred_bfnd = bf1;
        	}
          stmt
	       {
		  PTR_BFND bf1;
                  bf1 = get_bfnd(fi,CONTROL_END,SMNULL,LLNULL,LLNULL,LLNULL);
                  chain_up(pred_bfnd,bf1);
		  new_cur_bfnd = pred_bfnd;
                  pred_bfnd = pred_bfnd->control_parent;
		  if (TRACEON) printf("288 ") ;  
		}

	| ';'
            { if (TRACEON) printf("289 ") ; }
	;


/* modified */
lexpr :   assign_stmt
           { if (TRACEON) printf("290 ") ; }
        | lexpr ',' assign_stmt
           { if (TRACEON) printf("291 ") ;
             $$ = make_llnd(fi,EXPR_LIST,$1,$3,SMNULL);
	   }
        ;

/* modified */
assign_stmt: IDENTIFIER  '='  vector_constant

                {  PTR_SYMB symb ;
		   PTR_LLND ll_ptr1 ;
		 
		   if (TRACEON) printf("292 ") ;    
		   symb = find_type_symbol($1,VARIABLE_NAME); 
                   if (!symb) {  err("undefined symbol");
                                 $$ = LLNULL;
                              } 

                   else {
                          ll_ptr1 = make_llnd(fi,VAR_REF,LLNULL,LLNULL,symb);
                          $$ = make_llnd(fi,ASSGN_OP, ll_ptr1,$3,SMNULL);
                        }
                 }

        ;

/* modifed  */
array_expression:
          array_expr_a
            { if (TRACEON) printf("293 ") ;  } 
        | array_expr_b
            { if (TRACEON) printf("294 ") ;  } 
        ;


xexpr:
	/* empty */
           { if (TRACEON) printf("295 ") ;
             $$ = (PTR_LLND) LLNULL ;
           }
	| expr
           { if (TRACEON) printf("296 ") ; 
             $$ = $1 ;
           }
	;

/* This is what appears inside the parens in a function declarator.
   Is value is represented in the format that grokdeclarator expects.  */
parmlist:  /* empty */
		{ if (TRACEON) printf("297 ") ;  }
		
	| parms
  		{ if (TRACEON) printf("298 ") ;  }
		
	| parms ',' ELLIPSIS
                { if (TRACEON) printf("299 ") ; }
	;

/* A nonempty list of parameter declarations or type names.  */
parms:	
	parm
		{ if (TRACEON) printf("300 ") ; }
	| parms ',' parm
		{ if (TRACEON) printf("301 ") ;  }
	;

parm:
	  typed_declspecs_2 notype_declarator_parm
		{ PTR_BLOB blob,old_blob ;

                  if (TRACEON) printf("302 ") ;  
                   chain_type_declarator_2($1,$2);
                }
	|  typed_declspecs_2 absdcl
		{ if (TRACEON) printf("303 ") ;  }
	| declmods notype_declarator_parm
		{ if (TRACEON) printf("304 ") ; 
                  chain_type_declarator_2($1,$2);
                }
	| declmods absdcl
		{ if (TRACEON) printf("305 ") ;  }
	;



/* modified */
notype_declarator_parm:
	  notype_declarator_parm '(' parmlist ')'  %prec '.'
		{ PTR_LLND ll; 
 
/*                if (TRACEON) printf("169 ") ;
                  $$ = func_declarator_appear($1,$3) ;
                  new_cur_symb= find_symb_from_llnd($1);
                  new_cur_symb->variant = FUNCTION_NAME ;  */
                  err(" not implemented delcarator_parm ");  
                }
	| notype_declarator_parm '(' identifiers ')'  %prec '.'
		{ PTR_LLND ll;

/*                if (TRACEON) printf("170 ") ;
                  $$ = func_declarator_appear($1,$3) ;
                  new_cur_symb= find_symb_from_llnd($1);
                  new_cur_symb->variant = FUNCTION_NAME ;   */
                  err(" not implemented delcarator_parm_2 ");  
                }
	| notype_declarator_parm '(' error ')'  %prec '.'
		{ if (TRACEON) printf("171 ") ; }
	| '(' notype_declarator_parm ')'
		{ PTR_LLND ll;

                  if (TRACEON) printf("305.4 ") ;
                  cur_flag = CLEAN ;
                  cur_flag = RULE_LR ;
                  $$ = $2 ;
                }
	| '*' typemods notype_declarator_parm  %prec UNARY
	     {  PTR_TYPE type,type_1;
                PTR_LLND ll ;
		int      level_num ;
		int      empty_sw;

                 if (TRACEON) printf("305.5 ") ;
                 if (! $3->type) 
                     type = $3->type = get_type(fi,T_POINTER);
                 else  /* no type checking here */
                  { type = follow_type($3, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY :
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_POINTER);
                          break ;
                    case T_POINTER :
                          type_1= type->entry.template.base_type=get_type(fi,T_POINTER);
                          break;
                    default : err("System Trouble");
                    }
                  }
               $$ = $3  ;
             }
	| notype_declarator_parm '[' expr_no_commas ']'  %prec '.'
		{ PTR_LLND ll ;
                  PTR_TYPE type,type_1;
		  int      level_num ;
		  int      empty_sw;

                 if (TRACEON) printf("305.6 ") ;
                 if (! $1->type)  type_1 = $1->type = get_type(fi,T_ARRAY); 
                 else  /* no type checking here */
                  { type = follow_type($1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY:
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_ARRAY);
                          break ;
                    case T_POINTER :
                          type_1= type->entry.template.base_type=get_type(fi,T_ARRAY);
                          break;
                    default : err("System Trouble");
                    }
                  }
                 type_1->entry.ar_decl.ranges = make_llnd(fi,EXPR_LIST,$3,LLNULL,SMNULL);
                 $$ = $1 ;
                }
	| notype_declarator_parm '[' ']'  %prec '.'
		{ PTR_LLND ll;
                  PTR_TYPE type,type_1;
		  int      level_num ;
		  int      empty_sw;

                 if (TRACEON) printf("305.7 ") ; 
                 if (! $1->type)  type_1 = $1->type = get_type(fi,T_ARRAY); 
                 else  /* no type checking here */
                  { type = follow_type($1, &level_num,&empty_sw);
                    switch (type->variant) {
                    case T_ARRAY:
                          type_1= type->entry.ar_decl.base_type=get_type(fi,T_ARRAY);
                          break ;
                    case T_POINTER :
                          type_1= type->entry.template.base_type=get_type(fi,T_ARRAY);
                          break;
                    default : err("System Trouble");
                    }
                  }
                 type_1->entry.ar_decl.ranges = make_llnd(fi,EXPR_LIST,LLNULL,LLNULL,SMNULL);
                 $$ = $1 ;
		}

	| notype_declarator_parm '(' expr ')'      %prec '.'
                 {  PTR_LLND ll ;

                    if (TRACEON) printf("305.71  ") ;
                    err(" not implemented delcarator_parm ");  
                    $$ = $1 ;
/*
                    if ((cur_flag - RULE_ID) &&(cur_flag - RULE_ID - RULE_ARRAY))
                        err("syntax error 3");
                    else {
                        $$ = make_llnd(fi,CLASSINIT_OP,ll,$3,SMNULL);
                        cur_flag = cur_flag | RULE_CLASSINIT ;
                    }
*/
                 }
        | IDENTIFIER
             {
                if (TRACEON) printf("305.9 ");
                $$ = install_parameter($1, VARIABLE_NAME);
             }

	;



/*
declarator_parm:
       notype_declarator_parm 
        {}
     | after_type_declarator_parm
        {}
     ;
*/



%%

/* Return something to represent absolute declarators containing a *.
   TARGET is the absolute declarator that the * contains.
   TYPEMODS is a list of modifiers such as const or volatile
   to apply to the pointer type, represented as identifiers.

   We return an INDIRECT_REF whose "contents" are TARGET
   and whose type is the modifier list.  */
   

/* Temporarily  remove it. It may need rewriting later  */
/*   
static tree
make_pointer_declarator (typemods, target)
     tree typemods, target;
{
  register tree t = build1 (INDIRECT_REF, target);
  TREE_TYPE (t) = typemods;
  return t;
}
*/
/* Given a chain of STRING_CST nodes,
   concatenate them into one STRING_CST
   and give it a suitable array-of-chars data type.  */
/*
static tree
combine_strings (strings)
     tree strings;
{
  register tree value, t;
  register int length = 1;

  if (TREE_CHAIN (strings))
    {
  
      register char *p, *q;

  
      for (t = strings; t; t = TREE_CHAIN (t))
	length += TREE_STRING_LENGTH (t) - 1;

      p = (char *) oballoc (length);

      q = p;
      for (t = strings; t; t = TREE_CHAIN (t))
	{
	  bcopy (TREE_STRING_POINTER (t), q, TREE_STRING_LENGTH (t) - 1);
	  q += TREE_STRING_LENGTH (t) - 1;
	}
      *q = 0;

      value = make_node (STRING_CST);
      TREE_STRING_POINTER (value) = p;
      TREE_STRING_LENGTH (value) = length;
      TREE_LITERAL (value) = 1;
    }
  else
    {
      value = strings;
      length = TREE_STRING_LENGTH (value);
    }

  TREE_TYPE (value)
    = build_array_type (char_type_node,
			make_index_type (build_int_2 (length - 1, 0)));
  TREE_LITERAL (value) = 1;
  TREE_STATIC (value) = 1;
  layout_type (TREE_TYPE (value));
  return value;
}            */
    




int lineno;			/* current line number in file being read */

FILE *finput;			/* input file.
				   Normally a pipe from the preprocessor.  */
/* comments structure */
#define MAX_COMMENT_SIZE  1024 
char    comment_buf[MAX_COMMENT_SIZE + 2];  /* OFFSET '2' to avoid boundary */
int     comment_cursor = 0 ;
int     global_comment_type ;
/* lexical analyzer */

static int maxtoken;		/* Current length of token buffer */
static char *token_buffer;	/* Pointer to token buffer */
static int previous_value ;     /* last token to be remembered */

/* frw[i] is index in rw of the first word whose length is i. */

#define MAXRESERVED 9

static char frw[10] =
  { 0, 0, 0, 2, 6, 14, 20, 32, 36, 41 };

static char *rw[] =
  { "if", "do", "int", "for", "asm","syn",
    "case", "char", "auto", "goto", "else", "long", "void", "enum",
    "float", "short", "union", "break", "while", "const",
    "double", "static", "extern", "struct", "return", "sizeof", "switch", "signed","coexec","coloop","shared","friend",
    "typedef", "default","private","cobreak",
    "unsigned", "continue", "register", "volatile","operator" };

static short rtoken[] =
  { IF, DO, TYPESPEC, FOR, ASM,ACCESSWORD,
    CASE, TYPESPEC, SCSPEC, GOTO, ELSE, TYPEMOD, TYPESPEC, ENUM,
    TYPESPEC, TYPEMOD, UNION, BREAK, WHILE, TYPEMOD,
    TYPESPEC, SCSPEC, SCSPEC, STRUCT, RETURN, SIZEOF, SWITCH, TYPEMOD,COEXEC,COLOOP,ACCESSWORD,FRIEND,
    SCSPEC, DEFAULT_TOKEN,ACCESSWORD,COBREAK,
    TYPEMOD, CONTINUE, SCSPEC, TYPEMOD,OPERATOR };

/* This table corresponds to rw and rtoken.
   Its element is an index in ridpointers  */

#define NORID RID_UNUSED

static enum rid rid[] =
  { NORID, NORID, RID_INT, NORID, NORID,RID_SYN,
    NORID, RID_CHAR, RID_AUTO, NORID, NORID, RID_LONG, RID_VOID, NORID,
    RID_FLOAT, RID_SHORT, NORID, NORID, NORID, RID_CONST,
    RID_DOUBLE, RID_STATIC, RID_EXTERN, NORID, NORID, NORID, NORID, RID_SIGNED,NORID,NORID,RID_SHARED,NORID,
    RID_TYPEDEF, NORID,RID_PRIVATE,NORID,
    RID_UNSIGNED, NORID, RID_REGISTER, RID_VOLATILE,NORID };

/* The elements of `ridpointers' are identifier nodes
   for the reserved type names and storage classes.  
tree ridpointers[(int) RID_MAX];
static tree line_identifier;    The identifier node named "line" */





void check_newline();

void
init_lex ()
{
  extern char *malloc();

  /* Start it at 0, because check_newline is called at the very beginning
     and will increment it to 1.  */
  lineno = 0;
  maxtoken = 40;
  lastdecl_id = 0;
  wait_first_include_name= ON;
  token_buffer = malloc((unsigned)(maxtoken+1));
  check_newline();
/*
  line_identifier = get_identifier("line");
  ridpointers[(int) RID_INT] = get_identifier("int");
  ridpointers[(int) RID_CHAR] = get_identifier("char");
  ridpointers[(int) RID_VOID] = get_identifier("void");
  ridpointers[(int) RID_FLOAT] = get_identifier("float");
  ridpointers[(int) RID_DOUBLE] = get_identifier("double");
  ridpointers[(int) RID_SHORT] = get_identifier("short");
  ridpointers[(int) RID_LONG] = get_identifier("long");
  ridpointers[(int) RID_UNSIGNED] = get_identifier("unsigned");
  ridpointers[(int) RID_SIGNED] = get_identifier("signed");
  ridpointers[(int) RID_CONST] = get_identifier("const");
  ridpointers[(int) RID_VOLATILE] = get_identifier("volatile");
  ridpointers[(int) RID_AUTO] = get_identifier("auto");
  ridpointers[(int) RID_STATIC] = get_identifier("static");
  ridpointers[(int) RID_EXTERN] = get_identifier("extern");
  ridpointers[(int) RID_TYPEDEF] = get_identifier("typedef");
  ridpointers[(int) RID_REGISTER] = get_identifier("register");
  ridpointers[(int) RID_SYN] = get_identifier("syn");
  ridpointers[(int) RID_SHARED] = get_identifier("shared");
  ridpointers[(int) RID_PRIVATE] = get_identifier("private");
                                                              */
}

static void
reinit_parse_for_function ()
{
}

/* Put char into comment buffer. When the buffer is full, we make a comment */
/* structure and reset the comment_cursor. */
static int
put_char_buffer(c,sw)
char c ;
int sw;
{
  char *temptr ;
  PTR_CMNT c_ptr1,c_ptr ;

   if (( comment_cursor <= (MAX_COMMENT_SIZE -1)) && (sw == 0))
     {  *(comment_buf + comment_cursor) = c ;
        comment_cursor++;
      }
   else
     {   *(comment_buf +comment_cursor) = c ;
         *(comment_buf + comment_cursor+ 1) =  0  ;
	 temptr = copys(comment_buf);
         c_ptr1 = make_comment(fi,temptr, global_comment_type);
	 if (!new_cur_comment)
	   { 
              new_cur_comment = c_ptr1;
	    }
         else
	   {  c_ptr = follow_comment(new_cur_comment);
              c_ptr->next = c_ptr1 ;
	    }
         c_ptr1->counter = cur_counter ;
         comment_cursor = 0 ;
       }
}

static int
skip_white_space(type)
  int type ;
{
  register int c;
  register int inside;


  c = getc(finput);
  global_comment_type =type ;
/*  new_cur_comment     = (PTR_CMNT) NULL ; */

  for (;;)
    {
      switch (c)
	{
	case '/':
	  c = getc(finput);
	  if (c != '*')
	    {
	      ungetc(c, finput);
	      return '/';
	    }
          put_char_buffer('/',0); put_char_buffer('*',0);
	  c = getc(finput);

	  inside = 1;
	  while (inside)
	    {
	      if (c == '*')
		{
		  while (c == '*')
		   {  put_char_buffer(c, 0);
                      c = getc(finput);
		    }
		  if (c == '/')
		    {
		      inside = 0;
                      put_char_buffer(c,1);
		      c = getc(finput);
		    }
		}
	      else if (c == '\n')
		{
		  lineno++;
                  put_char_buffer(c,0);
		  c = getc(finput);
		}
	      else if (c == EOF)
		yyerror("unterminated comment");
	      else
		{  put_char_buffer(c,0) ; c = getc(finput);  }
	    }

	  break;

	case '\n':
	  check_newline();

	case ' ':
	case '\t':
	case '\f':
	case '\r':
	case '\b':
	  c = getc(finput);
	  break;

	case '\\':
	  c = getc(finput);
	  if (c == '\n')
	    lineno++;
	  else
	    yyerror("stray '\\' in program");
	  c = getc(finput);
	  break;

	default:
	  return (c);
	}
    }
}

/* Take care of the comments in the tail of the source code */
static int
skip_white_space_2()
{
  register int c;
  register int inside;

  c = getc(finput);
  global_comment_type =HALF ;
  for (;;)
    {
      switch (c)
	{
	case '/':
	  c = getc(finput);
	  if (c != '*')
	    {
	      ungetc(c, finput);
	      return '/';
	    }
          put_char_buffer('/',0); put_char_buffer('*',0);
	  c = getc(finput);

	  inside = 1;
	  while (inside)
	    {
	      if (c == '*')
		{
		  while (c == '*')
		   {  put_char_buffer(c, 0);
                      c = getc(finput);
		    }
		  if (c == '/')
		    {
		      inside = 0;
                      put_char_buffer(c,1);
		      c = getc(finput);
		    }
		}
	      else if (c == '\n')
		{
		  lineno++;
                  put_char_buffer(c,0);
		  c = getc(finput);
		}
	      else if (c == EOF)
		yyerror("unterminated comment");
	      else
		{  put_char_buffer(c,0) ; c = getc(finput);  }
	    }

	  break;

	case '\n':
	  /* check_newline();  */ 
           return(c);

	case ' ':
	case '\t':
	case '\f':
	case '\r':
	case '\b':
	  c = getc(finput);
	  break;

	case '\\':
	  c = getc(finput);
	  if (c == '\n')
	    lineno++;
	  else
	    yyerror("stray '\\' in program");
	  c = getc(finput);
	  break;

	default:
	  return (c);
	}
    }
}



/* make the token buffer longer, preserving the data in it.
p should point to just beyond the last valid character in the old buffer
and the value points to the corresponding place in the new one.  */

static char *
extend_token_buffer(p)
char *p;
{
  register char *newbuf;
  register char *value;
  int newlength = maxtoken * 2 + 10;
  register char *p2, *p1;
  extern char *malloc();

  newbuf = malloc((unsigned)(newlength+1));

  p2 = newbuf;
  p1 = newbuf + newlength + 1;
  while (p1 != p2) *p2++ = 0;

  value = newbuf;
  p2 = token_buffer;
  while (p2 != p)
   *value++ = *p2++;

  token_buffer = newbuf;

  maxtoken = newlength;

  return (value);
}




#define isalnum(char) ((char >= 'a' && char <= 'z') || (char >= 'A' && char <= 'Z') || (char >= '0' && char <= '9'))
#define isdigit(char) (char >= '0' && char <= '9')
#define ENDFILE -1  /* token that represents end-of-file */
#define isanop(d) ((d == '+') || (d == '-') || (d == '&') || (d == '|') || (d == '<') || (d == '>') || (d == '*') || (d == '/') || (d == '%') || (d == '^') || (d == '!') || (d == '=') )

/* At the beginning of a line,
   increment the line number
   and handle a #line directive immediately following  */

void
check_newline ()
{
  register int c;
  register int token;
  int old_recursive_yylex ;
  int l ;
  short temp_shorts[8];
  int   temp_count;
  int   temp_base;
  char *p;

  while (1)
    {
      c = getc (finput);
      lineno++;

      if (c != '#')
	{
	  /* If no #, unread the character,
	     except don't bother if it is whitespace.  */
	  if (c == ' ' || c == '\t')
	    return;
	  ungetc (c, finput);
	  return;
	}

      /* Skip whitespace after the #.  */

      while (1)
	{
	  c = getc (finput);
	  if (! (c == ' ' || c == '\t'))
	    break;
	}

      /* If the # is the only nonwhite char on the line,
	 just ignore it.  Check the new newline.  */
      if (c == '\n')
	continue;

      /* Something follows the #; read a token.  */
      /* -----------------reserved---------------*/

      if ( (c- '0') > 9 ) 
	{  yyerror ("invalid #line");
	   /*skip the rest of this line.  */
	   while ((c = getc (finput)) != '\n');
	   continue;
	 }
      for ( temp_count =0 ; temp_count < 8 ; temp_count++)
            temp_shorts[temp_count] = 0 ;
      temp_base =10;
      while (isdigit(c))
	{  c = c -'0';
           for (temp_count =0 ; temp_count < 8; temp_count++)
	     {   
                     (temp_shorts[temp_count] *= temp_base) ;
		     if (temp_count)
                       {   temp_shorts[temp_count] += (temp_shorts[temp_count-1] >> 8 );
			   temp_shorts[temp_count -1] &= (1 <<8) -1 ;
			 }
		     else temp_shorts[0] += c ;
             }
          c = getc(finput);
	 }
         l = (temp_shorts[3]<<24)+(temp_shorts[2]<<16)+(temp_shorts[1]<<8)+temp_shorts[0];
         ungetc(c,finput);
         while (1)
	   {
	     c = getc (finput);
	     if (! (c == ' ' || c == '\t'))
	     break;
	   }

         if (c != '"')  {   yyerror ("invalid #line");
			    /*skip the rest of this line.  */
			    while ((c = getc (finput)) != '\n');
			    continue;
			  }
	c = getc(finput);
	p = token_buffer;

	while (c != '"')
	  {
	    if (c == '\\')
	      {
                /* New Added Three lines */
                if (p == token_buffer + maxtoken)
	          p = extend_token_buffer(p);
  	        *p++ = c;

		c = readescape ();
		if (c < 0)
		  goto skipnew_2;
	      }
	    else if (c == '\n')
	      {
		if (pedantic)
		  warning ("ANSI C forbids newline in string constant");
		lineno++;
	      }

	    if (p == token_buffer + maxtoken)
	      p = extend_token_buffer(p);
	    *p++ = c;

	  skipnew_2:
	    c = getc (finput);
	  }

	*p++ = 0;
        new_cur_fname = input_filename =  copys(token_buffer);
        if (wait_first_include_name == ON)
	  { 
	    wait_first_include_name = OFF;
	    first_line_name         = new_cur_fname;
	    global_bfnd->filename = find_file_entry(new_cur_fname);
	    global_bfnd->g_line   = 0;
	  }
        lineno = l - 1 ;
        /*skip the rest of this line.  */
        while ((c = getc (finput)) != '\n');
	
    }
} 






int
readescape ()
{
  register int c = getc (finput);
  register int count, code;

  switch (c)
    {
    case 'x':
      code = 0;
      count = 0;
      while (1)
	{
	  c = getc (finput);
	  if (!(c >= 'a' && c <= 'f')
	      && !(c >= 'A' && c <= 'F')
	      && !(c >= '0' && c <= '9'))
	    {
	      ungetc (c, finput);
	      break;
	    }
	  if (c >= 'a' && c <= 'z')
	    c -= 'a' - 'A';
	  code *= 16;
	  if (c >= 'a' && c <= 'f')
	    code += c - 'a' + 10;
	  if (c >= 'A' && c <= 'F')
	    code += c - 'A' + 10;
	  if (c >= '0' && c <= '9')
	    code += c - '0';
	  count++;
	  if (count == 3)
	    break;
	}
      if (count == 0)
	yyerror ("\\x used with no following hex digits");
      return code;

    case '0':  case '1':  case '2':  case '3':  case '4':
    case '5':  case '6':  case '7':
      code = 0;
      count = 0;
      while ((c <= '7') && (c >= '0') && (count++ < 3))
	{
	  code = (code * 8) + (c - '0');
	  c = getc (finput);
	}
      ungetc (c, finput);
      return code;

    case '\\': case '\'': case '"':
      return c;

    case '\n':
      lineno++;
      return -1;

    case 'n':
      return c ;  /*     return TARGET_NEWLINE; */

    case 't':
      return c;  /*      return TARGET_TAB; */

    case 'r':
      return c;/*      return TARGET_CR; */

    case 'f':
      return c;/*       return TARGET_FF;*/

    case 'b':
      return c;/*       return TARGET_BS;*/

    case 'a':
      return c; /*      return TARGET_BELL;*/

    case 'v':
      return c; /*      return TARGET_VT;*/
    }
  return c;
}

 
int
yylex()
{
  register int c;
  register char *p;
  register int value;
  int low,high ;
  char *str1 ;
  double  ddval ;
  int type;
  int c3;



  if (recursive_yylex == OFF) new_cur_comment = (PTR_CMNT) NULL ;

  /* line_pos_1 = lineno +1 ; */
  c = skip_white_space(FULL);
  /*  yylloc.first_line = lineno;*/

  switch (c)
    {
    case EOF:
      value = ENDFILE; break;

    case 'A':  case 'B':  case 'C':  case 'D':  case 'E':
    case 'F':  case 'G':  case 'H':  case 'I':  case 'J':
    case 'K':  case 'L':  case 'M':  case 'N':  case 'O':
    case 'P':  case 'Q':  case 'R':  case 'S':  case 'T':
    case 'U':  case 'V':  case 'W':  case 'X':  case 'Y':
    case 'Z':
    case 'a':  case 'b':  case 'c':  case 'd':  case 'e':
    case 'f':  case 'g':  case 'h':  case 'i':  case 'j':
    case 'k':  case 'l':  case 'm':  case 'n':  case 'o':
    case 'p':  case 'q':  case 'r':  case 's':  case 't':
    case 'u':  case 'v':  case 'w':  case 'x':  case 'y':
    case 'z':
    case '_':

      p = token_buffer;
      while (isalnum(c) || (c == '_') || (c == '~'))
	{
	  if (p >= token_buffer + maxtoken)
	    p = extend_token_buffer(p);
	  *p++ = c;
	  c = getc(finput);
	}

      *p = 0;
      ungetc(c, finput);

      value = IDENTIFIER;


      if (p - token_buffer <= MAXRESERVED)
	{
	  register int lim = frw [p - token_buffer + 1];
	  register int i;

	  for (i = frw[p - token_buffer]; i < lim; i++)
	    if (rw[i][0] == token_buffer[0] && !strcmp(rw[i], token_buffer))
	      {
		if (rid[i])
		  yylval.token = (int) rid[i] ;
                  value = (int) rtoken[i];
		break;
	      }
	}

      if (value == IDENTIFIER)
	{ int t_status ;
/* temp move it out */

          yylval.hash_entry = look_up_type(token_buffer,&t_status);
          if ((t_status)&&(lastdecl_id ==0))   value = TYPENAME;       

        }

      break;

    case '0':  case '1':  case '2':  case '3':  case '4':
    case '5':  case '6':  case '7':  case '8':  case '9':
    case '.':
      {
	int base = 10;
	int count = 0;
	int largest_digit = 0;
	/* for multi-precision arithmetic,
	   we store only 8 live bits in each short,
	   giving us 64 bits of reliable precision */
	short shorts[8];
	int floatflag = 0;  /* Set 1 if we learn this is a floating constant */

	for (count = 0; count < 8; count++)
	  shorts[count] = 0;

	p = token_buffer;
	*p++ = c;

	if (c == '0')
	  {
	    *p++ = (c = getc(finput));
	    if ((c == 'x') || (c == 'X'))
	      {
		base = 16;
		*p++ = (c = getc(finput));
	      }
	    else
	      {
		base = 8;
	      }
	  }

	while (c == '.'
	       || (isalnum (c) && (c != 'l') && (c != 'L')
		   && (c != 'u') && (c != 'U')
		   && (!floatflag || ((c != 'f') && (c != 'F')))))
	  {
	    if (c == '.')
	      {
		if (base == 16)
		  yyerror ("floating constant may not be in radix 16");
		floatflag = 1;
		base = 10;
		*p++ = c = getc (finput);
		/* Accept '.' as the start of a floating-point number
		   only when it is followed by a digit.
		   Otherwise, unread the following non-digit
		   and use the '.' as a structural token.  */
		if (p == token_buffer + 2 && !isdigit (c))
		  {
		    if (c == '.')
		      {
			c = getc (finput);
			if (c == '.')
			  { if (TRACEON) printf("TOKEN = %d",ELLIPSIS);
                            value = ELLIPSIS ;
			    goto done ;
                          }
			yyerror ("syntax error");
		      }
		    ungetc (c, finput);
		    value = '.';
                    goto done;
		  }
	      }
	    else
	      {
		if (isdigit(c))
		  {
		    c = c - '0';
		  }
		else if (base <= 10)
		  {
		    if ((c&~040) == 'E')
		      {
			if (base == 8)
			  yyerror ("floating constant may not be in radix 8");
			base = 10;
			floatflag = 1;
			break;   /* start of exponent */
		      }
		    yyerror ("nondigits in number and not hexadecimal");
		    c = 0;
		  }
		else if (c >= 'a')
		  {
		    c = c - 'a' + 10;
		  }
		else
		  {
		    c = c - 'A' + 10;
		  }
		if (c >= largest_digit)
		  largest_digit = c;
	    
		for (count = 0; count < 8; count++)
		  {
		    (shorts[count] *= base);
		    if (count)
		      {
			shorts[count] += (shorts[count-1] >> 8);
			shorts[count-1] &= (1<<8)-1;
		      }
		    else shorts[0] += c;
		  }
    
		*p++ = (c = getc(finput));
	      }
	  }

	if (largest_digit >= base)
	  yyerror ("numeric constant contains digits beyond the radix");

	/* Remove terminating char from the token buffer and delimit the string */
	*--p = 0;

	if (floatflag)
	  {
	    enum rid type = DOUBLE_TYPE_CONST ;

	    /* Read explicit exponent if any, and put it in tokenbuf.  */

	    if ((c == 'e') || (c == 'E'))
	      {
		*p++ = c;
		c = getc(finput);
		if ((c == '+') || (c == '-'))
		  {
		    *p++ = c;
		    c = getc(finput);
		  }
	        while (isdigit(c))
		  {
		    *p++ = c;
		    c = getc(finput);
		  }
	      }

	    *p = 0;

	    while (1)
	      {
		if (c == 'f' || c == 'F')
		  type = FLOAT_TYPE_CONST ;
		else if (c == 'l' || c == 'L')
		  type = LONG_DOUBLE_TYPE_CONST ;
		else
		  {
		    if (isalnum (c))
		      {
			yyerror ("garbage at end of number");
			while (isalnum (c))
			  c = getc (finput);
		      }
		    break;
		  }
		c = getc (finput);
	      }

	    ungetc(c, finput);

/*	    ddval = build_real_from_string (token_buffer, 0);  */
            str1= copys(token_buffer);
            yylval.ll_node = make_llnd(fi,FLOAT_VAL,LLNULL,LLNULL,str1);

	  }
	else
	  {
	    enum rid  type;

	    int spec_unsigned = 0;
	    int spec_long = 0;

	    while (1)
	      {
		if (c == 'u' || c == 'U')
		  {
		    spec_unsigned = 1;
		  }
		else if (c == 'l' || c == 'L')
		  {
		    spec_long = 1;
		  }
		else
		  {
		    if (isalnum (c))
		      {
			yyerror ("garbage at end of number");
			while (isalnum (c))
			  c = getc (finput);
		      }
		    break;
		  }
		c = getc (finput);
	      }

	    ungetc (c, finput);

	    /* This is simplified by the fact that our constant
	       is always positive.  */

	    low= (shorts[3]<<24) + (shorts[2]<<16) + (shorts[1]<<8) + shorts[0] ;
	    high = (shorts[7]<<24) + (shorts[6]<<16) + (shorts[5]<<8) + shorts[4] ;
	    



    /* Reserved Temporarily   UNDONE 5
	    if (!spec_long && !spec_unsigned
		&& int_fits_type_p (yylval.ttype, integer_type_node))
	      type = integer_type_node;

	    else if (!spec_long && base != 10
		&& int_fits_type_p (yylval.ttype, unsigned_type_node))
	      type = unsigned_type_node;

	    else if (!spec_unsigned
		&& int_fits_type_p (yylval.ttype, long_integer_type_node))
	      type = long_integer_type_node;

	    else
	      type = long_unsigned_type_node;    */


	      type = LONG_UNSIGNED_TYPE_CONST ;
          yylval.ll_node = make_llnd(fi,INT_VAL,LLNULL,LLNULL,low);	
	 }

	value = CONSTANT; break;
      }

    case '\'':
      c = getc(finput);
      {
	register int code = 0;

      tryagain:

	if (c == '\\')
	  {
	    c = readescape ();
	    if (c < 0)
	      goto tryagain;
	  }
	else if (c == '\n')
	  {
	    if (pedantic)
	      warning ("ANSI C forbids newline in character constant");
	    lineno++;
	  }

	c3= c;
	code = c;

	c = getc (finput);
	if (c != '\'')
	  yyerror("malformatted character constant");

	/* If char type is signed, sign-extend the constant.  */
        /* UNDONE 6 */
/*	if (CHAR_TYPE_CONST == UNSIGNED_CHAR_TYPE_CONST
	    || (code >> (BITS_PER_UNIT - 1)) == 0)

	  {
             low = code;
             high = 0 ;
	   }
         else
	   {  low = code | ((-1) << BITS_PER_UNIT );
              high = -1 ;
	  }
*/
        yylval.ll_node = make_llnd(fi,CHAR_VAL,LLNULL,LLNULL,low);
	yylval.ll_node->entry.cval = c3;  
	value = CONSTANT; break;
      }

    case '"':
      {
	c = getc(finput);
	p = token_buffer;

	while (c != '"')
	  {
	    if (c == '\\')
	      {
                /* New Added Three lines */
                if (p == token_buffer + maxtoken)
	          p = extend_token_buffer(p);
  	        *p++ = c;

		c = readescape ();
		if (c < 0)
		  goto skipnewline;
	      }
	    else if (c == '\n')
	      {
		if (pedantic)
		  warning ("ANSI C forbids newline in string constant");
		lineno++;
	      }

	    if (p == token_buffer + maxtoken)
	      p = extend_token_buffer(p);
	    *p++ = c;

	  skipnewline:
	    c = getc (finput);
	  }

	*p++ = 0;

	str1= copys(token_buffer);
        yylval.ll_node = make_llnd(fi,STRING_VAL,LLNULL,LLNULL,str1);
	value = STRING; break;
      }
      
    case '+':
    case '-':
    case '&':
    case '|':
    case '<':
    case '>':
    case '*':
    case '/':
    case '%':
    case '^':
    case '!':
    case '=':
      {
	register int c1;
        if ( previous_value == OPERATOR )
           {
             p = token_buffer;
             while (isanop(c) )
              {
                  if (p >= token_buffer + maxtoken)
	          p = extend_token_buffer(p);
	          *p++ = c;
	          c = getc(finput);
               }
             *p = 0;
             ungetc(c, finput);
             value =  LOADEDOPR ;
             yylval.hash_entry = look_up(token_buffer);
             break;
            }
      combine:

	switch (c)
	  {
	  case '+':
	    yylval.token = (int) PLUS_EXPR; break;
	  case '-':
	    yylval.token = (int) MINUS_EXPR; break;
	  case '&':
	    yylval.token = (int) BIT_AND_EXPR; break;
	  case '|':
	    yylval.token = (int) BIT_IOR_EXPR; break;
	  case '*':
	    yylval.token = (int) MULT_EXPR; break;
	  case '/':
	    yylval.token = (int) TRUNC_DIV_EXPR; break;
	  case '%':
	    yylval.token = (int) TRUNC_MOD_EXPR; break;
	  case '^':
	    yylval.token = (int) BIT_XOR_EXPR; break;
	  case LSHIFT:
	    yylval.token = (int) LSHIFT_EXPR; break;
	  case RSHIFT:
	    yylval.token = (int) RSHIFT_EXPR; break;
	  case '<':
	    yylval.token = (int) LT_EXPR; break;
	  case '>':
	    yylval.token = (int) GT_EXPR; break;
	  }	

	c1 = getc(finput);

	if (c1 == '=')
	  {
	    switch (c)
	      {
	      case '<':
		value = ARITHCOMPARE; yylval.token = (int) LE_EXPR; goto done;
	      case '>':
		value = ARITHCOMPARE; yylval.token = (int) GE_EXPR; goto done;
	      case '!':
		value = EQCOMPARE; yylval.token = (int) NE_EXPR; goto done;
	      case '=':
		value = EQCOMPARE; yylval.token = (int) EQ_EXPR; goto done;
	      }	
	    value = ASSIGN; goto done;
	  }
	else if (c == c1)
	  switch (c)
	    {
	    case '+':
	      value = PLUSPLUS; goto done;
	    case '-':
	      value = MINUSMINUS; goto done;
	    case '&':
	      value = ANDAND; goto done;
	    case '|':
	      value = OROR; goto done;
/* testing  */
/*            case ':':
              value = DOUBLEMARK; goto done;  */

	    case '<':
	      c = LSHIFT;
	      goto combine;
	    case '>':
	      c = RSHIFT;
	      goto combine;
	    }
	else if ((c == '-') && (c1 == '>'))
	  { value = POINTSAT; goto done; }
	ungetc (c1, finput);


        value = c;
	goto done;
      }

    default:
      value = c;
    }

done:

  if (recursive_yylex == OFF) {
    previous_value = value ;
    line_pos_1 = lineno ;
    c = skip_white_space_2();
    if (c == '\n') check_newline();
    else           ungetc(c, finput);
    if (value != '}') 
      { c = skip_white_space(NEXT_FULL);
	if (c == '\n') lineno++ ;
	else           ungetc(c, finput);
      }
    set_up_momentum(value,yylval.token);
    line_pos_fname = new_cur_fname;
    automata_driver(value);
    put_comment_queue();
    cur_counter++;
    old_line = yylineno  ;
    yylineno = line_pos_1;
  }
  if (TRACEON) { printf("TOKEN = %d \n",value);
                 printf("TOKENCHAR = %c \n", value);
               }
  return (value);
}


 
