
#include <stdio.h>
#include <malloc.h>
#include "macro.h"
#include "tag" 
#include "ext_low.h"
#include "ext_ann.h"
#include "ext_lib.h"
#include "ext_mid.h"

extern PTR_FILE pointer_on_file_proj;

main(argc,argv)
int argc;
char *argv[];
{
 char * proj;
 PTR_BFND temp,temp2;
 char * filename;
 FILE * outfile;
 extern PTR_BFND Fusion_Loops();

 temp=(PTR_BFND)malloc(sizeof(PTR_BFND));
 temp2=(PTR_BFND)malloc(sizeof(PTR_BFND));
 filename=(char* )malloc(sizeof(char)); 
 proj=argv[1];
 Initialize_Project_Toolbox(proj);
 filename=getname(proj); 
 outfile=fopen(filename,"w");
 temp=FILE_GOBAL_BFND(pointer_on_file_proj);
 while (temp)  
 { 
   if (BIF_CODE(temp)==FOR_NODE)
   { 
     temp2=Get_Last_Node_Of_Stmt(temp);
     temp2=BIF_NEXT(temp2);
     if (BIF_CODE(temp2)==FOR_NODE)
       break;
   }
   temp=BIF_NEXT(temp);
 }
 Fusion_Loops(temp,temp2);   
 outfile=pointer_on_file_proj->fid;
 UnparseProgram(outfile);
 Write_Data_Base_For_Debug();
 return;
}

PTR_BFND Fusion_Loops(loop1,loop2)
PTR_BFND loop1,loop2;
{
  PTR_BFND Bif_Copy();
  PTR_BFND Duplicate_Stmts();

  PTR_LLND inf1,inf2,sup1,sup2,temp1,temp2,exp,newinf,newsup;
  PTR_BFND body,bodyend,first,last,where;
  int inf1_val,inf2_val,sup1_val,sup2_val,length1,length2;
  PTR_SYMB index1,index2;
  int len,leng;

  len=(int)sizeof(PTR_LLND);
  leng=(int)sizeof(PTR_BFND);
  inf1=(PTR_LLND)xmalloc(len);
  inf2=(PTR_LLND)xmalloc(len);
  sup1=(PTR_LLND)xmalloc(len);
  sup2=(PTR_LLND)xmalloc(len); 
  body=(PTR_BFND)xmalloc(leng);
  bodyend=(PTR_BFND)xmalloc(leng);
  first=(PTR_BFND)xmalloc(leng);
  last=(PTR_BFND)xmalloc(leng);
  where=(PTR_BFND)xmalloc(leng);
  index1=(PTR_SYMB)xmalloc(sizeof(PTR_SYMB));
  index2=(PTR_SYMB)xmalloc(sizeof(PTR_SYMB));

  inf1=Loop_Get_Borne_Inf(loop1);
  inf2=Loop_Get_Borne_Inf(loop2); 
  sup1=Loop_Get_Borne_Sup(loop1);
  sup2=Loop_Get_Borne_Sup(loop2);
  index1=Loop_Get_Index(loop1);
  index2=Loop_Get_Index(loop2);

  inf1_val=NODE_IV(inf1);
  inf2_val=NODE_IV(inf2);
  sup1_val=NODE_IV(sup1);
  sup2_val=NODE_IV(sup2);
  length1=sup1_val-inf1_val;
  length2=sup2_val-inf2_val;
  if (length1>length2)
  {
    first=BIF_NEXT(loop1);
    last=Get_Node_Before(Get_Last_Node_Of_Stmt(loop1));
    /*body=Bif_Copy(first,last);*/
    body=Duplicate_Stmts(first,last);
    bodyend=Get_Last_Node_Of_Stmt(body);
    newinf=inf1;
    newsup=bif_build(INT_VAL,T_INT,NULL,NULL);
    NODE_IV(newsup)=sup1_val-length2-1;

    if(sup1_val==sup2_val)
      exp=bif_build(VAR_REF,T_INT,index2,NULL); 
    else if(sup1_val>sup2_val)
    {
      temp1=bif_build(VAR_REF,T_INT,index2,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=sup1_val-sup2_val;
      exp=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    else
    {
      temp1=bif_build(VAR_REF,T_INT,index2,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=sup2_val-sup1_val;
      exp=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }

    Replace_Var_In_Section(body,bodyend,index1,exp);
    where=loop2;
    Insert_List_of_BifNode(body,where,loop2);
    
    Loop_Set_Borne_Inf(loop1,newinf);
    Loop_Set_Borne_Sup(loop1,newsup);
  }
  else if (length2>length1)
  {
    first=BIF_NEXT(loop2);
    last=Get_Node_Before(Get_Last_Node_Of_Stmt(loop2));
   /* body=Bif_Copy(first,last);*/
    body=Duplicate_Stmts(first,last);
    bodyend=Get_Last_Node_Of_Stmt(body);
    newsup=sup2;
    newinf=bif_build(INT_VAL,T_INT,NULL,NULL);
    NODE_IV(newinf)=inf2_val+length1;

    if(inf1_val==inf2_val)
      exp=bif_build(VAR_REF,T_INT,index1,NULL);
    else if(inf1_val>inf2_val)
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf1_val-inf2_val;
      exp=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    } 
    else
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf2_val-inf1_val;
      exp=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    Loop_Set_Borne_Inf(loop2,newinf);
    Loop_Set_Borne_Sup(loop2,newsup);
    Replace_Var_In_Section(body,bodyend,index2,exp);
    where=Get_Node_Before(Get_Last_Node_Of_Stmt(loop1));
    Insert_List_of_BifNode(body,where,loop1);
  }
  else
  {
    last=Get_Node_Before(Get_Last_Node_Of_Stmt(loop2));
    where=Get_Node_Before(Get_Last_Node_Of_Stmt(loop1));
    body=Extract_Loop_Body(loop2);
    Extract_Bif_Section(loop2,Get_Last_Node_Of_Stmt(loop2));
    if(inf1_val==inf2_val)
      exp=bif_build(VAR_REF,T_INT,index1,NULL);
    else if(inf1_val>inf2_val)
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf1_val-inf2_val;
      exp=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    else
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf2_val-inf1_val;
      exp=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    Replace_Var_In_Section(body,last,index2,exp); 
    Insert_List_of_BifNode(body,where,NULL);
  }
}


PTR_BFND Bif_Copy(begin,end)
PTR_BFND begin,end;
{
  PTR_BFND beg,temp1,temp2;

  beg=(PTR_BFND)xmalloc(sizeof(PTR_BFND));
  temp2=(PTR_BFND)xmalloc(sizeof(PTR_BFND));

  temp1=(PTR_BFND)bif_make_node(BIFNODE);
  temp1=begin;
  beg=temp1; 
  begin=BIF_NEXT(begin);
  while(begin!=end) 
  {
    temp2=(PTR_BFND)bif_make_node(BIFNODE);
    temp2=begin;
    BIF_NEXT(temp1)=temp2;
    temp1=temp2;
    begin=BIF_NEXT(begin);
  }
  temp2=(PTR_BFND)bif_make_node(BIFNODE);
  temp2=begin;
  BIF_NEXT(temp1)=temp2;
  temp1=temp2;
  return beg;
}


PTR_BFND
  Duplicate_Stmts (body,end)
     PTR_BFND body,end;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;

 if (! body) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = Get_Last_Label_Id();

 lenght = 0;
 for (temp = body; temp!=end ; temp = BIF_NEXT(temp))
   {
     lenght++;
     lastnode = temp;
   }
      lenght++;
     lastnode = temp;
 
 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 bzero(alloue, 2* lenght * sizeof(PTR_BFND));

 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 bzero(label_insection, 2* lenght * sizeof(PTR_LABEL));
 temp = body;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) bif_make_node (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = bif_copy_expr (BIF_LL1 (temp));
      BIF_LL2 (copie) = bif_copy_expr (BIF_LL2 (temp));
      BIF_LL3 (copie) = bif_copy_expr (BIF_LL3 (temp));
      if (last)
        BIF_NEXT(last) = copie;

  
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
        {
          /* create a new label */

          maxlabelname++;
          LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
          LABEL_BODY(label_insection[2*i+1]) == copie;
          LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
          LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
          LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
          BIF_LABEL(copie) = label_insection[2*i+1];
          label_insection[2*i] = BIF_LABEL(temp);
        }

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = body;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1];
     lab = NULL;

     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;

         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {
                 lab = NODE_LABEL(ptl);
                 trouve = 0;
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);
           }
         temp = BIF_NEXT(temp);
         continue;
       }

        
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
         lab = NODE_LABEL(BIF_LL3(temp));
         cas = 2;      
       }
     else
       {
         lab = BIF_LABEL_USE(temp);
         cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
         int trouve = 0;
         for (j = 0; j < lenght; j++)
           {
             if (label_insection[2*j])
               if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                 {
                   trouve = j+1;
                   break;
                 }
           }
         if(trouve)
           {
             if (cas == 1)
               {
                 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
               }

             if (cas == 2)
               {
                 if (BIF_LL3(copie))
                   {
                     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1
];
                   }
               }
           } else
             {
               if (cas == 1)
                 BIF_LABEL_USE(copie) = lab; /* outside */
               /* if ((cas == 2) no change */
             }
       }
     temp = BIF_NEXT(temp);
   }

 /* on met a jour le blob list */
 copie = alloue[1];
 for (temp = body; temp<=end ; temp = BIF_NEXT(temp))
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp;
              blobtemp = BLOB_NEXT(blobtemp))
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp;
              blobtemp = BLOB_NEXT(blobtemp))
           {

             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];
 for (temp = body; temp<=end ; temp = BIF_NEXT(temp))
   {
     if (In_Section(body, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       }
     copie = BIF_NEXT(copie);
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}

