
#include <stdio.h>
#include <malloc.h>
#include "macro.h"
#include "tag" 
#include "ext_low.h"
#include "ext_ann.h"
#include "ext_lib.h"
#include "ext_mid.h"

extern PTR_FILE pointer_on_file_proj;

main(argc,argv)
int argc;
char *argv[];
{
 char * proj;
 PTR_BFND temp,temp2;
 char * filename;
 FILE * outfile;
 extern PTR_BFND interchange_two_loops();
 temp=(PTR_BFND)malloc(sizeof(PTR_BFND));
 temp2=(PTR_BFND)malloc(sizeof(PTR_BFND));
 filename=(char* )malloc(sizeof(char)); 
 proj=argv[1];
 Initialize_Project_Toolbox(proj);
 filename=getname(proj); 
 outfile=fopen(filename,"w");
 temp=FILE_GOBAL_BFND(pointer_on_file_proj);
 while (temp)  
 { 
   if (BIF_CODE(temp)==FOR_NODE)
   { if (BIF_CODE(BIF_NEXT(temp))==FOR_NODE) 
     {
       temp2=BIF_NEXT(temp);
       break;
     }
   }
   temp=BIF_NEXT(temp);
 }
 interchange_two_loops(temp,temp2);   
 outfile=pointer_on_file_proj->fid;
 UnparseProgram(outfile);
 Write_Data_Base_For_Debug();
 return;
} 

/*****************************************************************************
*    INPUT :  the two loops to be interchanged                               *
*    OUTPUT:  the first loop interchanged                                    *
*    NOTE  :  This function only can interchange the perfactly nested loops. *
*             If one of the limits of the second loop is a expression which  *
*             has index variable of the first loop ,it must be linear.       *
******************************************************************************/             
PTR_BFND interchange_two_loops(loop1,loop2)
PTR_BFND loop1,loop2;
{
  PTR_LLND old_sup1,old_sup2,old_inf1,old_inf2;
  PTR_LLND new_sup1,new_sup2,new_inf1,new_inf2;
  PTR_SYMB index1,index2,up,down;
  int tag,length,leng,len;
  PTR_LLND temp1,temp2,temp3;
  PTR_LLND coef,remain,coef1,coef2;
  PTR_DIS corem;
  int *value1,*value2;
  int val1,val2;
  PTR_LLND condition;
  PTR_BFND min,max,bif1,bif2;
  PTR_TYPE type;
  int val11,val21,val12,val22;
  
 
  if(!loop1 || !loop2)
  {
     Message("one or two loops to be exchanged are null",0);
     return;
  }
  if((BIF_NEXT(loop1)!=loop2) || (BIF_CODE(loop1)!=FOR_NODE) || 
      (BIF_CODE(loop2)!=FOR_NODE) || (blob_list_length(BIF_BLOB1(loop1))!=2))
  {
     Message("they are not loops or not perfectly nested",0);
     return;
  } 
  
  length=sizeof(struct llnd);
  leng=sizeof(struct symb);
  len=sizeof(PTR_DIS);
  
  value1=(int *)xmalloc(sizeof(int));
  value2=(int *)xmalloc(sizeof(int)); 
  index1=(PTR_SYMB)xmalloc(leng);
  index2=(PTR_SYMB)xmalloc(leng);
  old_sup1=(PTR_LLND)xmalloc(length);
  old_sup2=(PTR_LLND)xmalloc(length);
  old_inf1=(PTR_LLND)xmalloc(length);
  old_inf2=(PTR_LLND)xmalloc(length);
  new_sup1=(PTR_LLND)xmalloc(length);
  new_sup2=(PTR_LLND)xmalloc(length);
  new_inf1=(PTR_LLND)xmalloc(length);
  new_inf2=(PTR_LLND)xmalloc(length);
  corem=(PTR_DIS)xmalloc(len);
  min=(PTR_BFND)xmalloc(sizeof(PTR_BFND));
  bif1=(PTR_BFND)xmalloc(sizeof(PTR_BFND));
  bif2=(PTR_BFND)xmalloc(sizeof(PTR_BFND));
  up=(PTR_SYMB)xmalloc(sizeof(PTR_SYMB));
  down=(PTR_SYMB)xmalloc(sizeof(PTR_SYMB)); 
  type=(PTR_TYPE)xmalloc(sizeof(PTR_TYPE));

  old_sup1=Loop_Get_Borne_Sup(loop1);
  old_sup2=Loop_Get_Borne_Sup(loop2);
  old_inf1=Loop_Get_Borne_Inf(loop1);
  old_inf2=Loop_Get_Borne_Inf(loop2);
  index1=Loop_Get_Index(loop1);
  index2=Loop_Get_Index(loop2);
 
  if(!Is_Var_In_Expression(BIF_LL1(loop2),index1))
    tag=0;
  else 
    if(Is_Var_In_Expression(NODE_OPERAND0(BIF_LL1(loop2)),index1)
      &&Is_Var_In_Expression(NODE_OPERAND1(BIF_LL1(loop2)),index1))
    { 
      tag=5;   /*there is previous loop's index in up and down limit*/
      corem=spit(NODE_OPERAND0(BIF_LL1(loop2)),index1);
      value1=Evaluate_Expression(corem->factor);
      value2=Evaluate_Expression(corem->remain);
      val12=*(value2+1);
      if(*(value1+1)==NULL)
      {
        Message("the factor can not be computed!",0);
        return;
      }
      else
         val11=*(value1+1);

      coef1=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(coef1)=val11;
      if(*(value2+1)==NULL)
        old_inf2=corem->remain;
      else
      {
        old_inf2=bif_build(INT_VAL,T_INT,NULL,NULL);
        NODE_IV(old_inf2)=val12;
      }

      corem=spit(NODE_OPERAND1(BIF_LL1(loop2)),index1);
      value1=Evaluate_Expression(corem->factor);
      value2=Evaluate_Expression(corem->remain);
      val22=*(value2+1);
      if(*(value1+1)==NULL)
      {
        Message("the factor can not be computed!",0);
        return;
      }
      else
         val21=*(value1+1);

      coef2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(coef2)=val21;
      if(*(value2+1)==NULL)
        old_sup2=corem->remain;
      else
      {
        old_sup2=bif_build(INT_VAL,T_INT,NULL,NULL);
        NODE_IV(old_sup2)=val22;
      }

    } 
    else
    {
      if(Is_Var_In_Expression(NODE_OPERAND0(BIF_LL1(loop2)),index1))
      {
        corem=spit(NODE_OPERAND0(BIF_LL1(loop2)),index1);
        value1=Evaluate_Expression(corem->factor);
        value2=Evaluate_Expression(corem->remain);
        val2=*(value2+1);
        if(*(value1+1)==NULL)
        {
          Message("the factor can not be computed!",0);
          return;
        }
        else
           val1=*(value1+1);
        if(val1>0)
          tag=1;         /*upper right trapezoide*/
        else
          tag=2;         /*lower right trapezoide*/
      }
      else if(Is_Var_In_Expression(NODE_OPERAND1(BIF_LL1(loop2)),index1))
      {
        corem=spit(NODE_OPERAND1(BIF_LL1(loop2)),index1);
        value1=Evaluate_Expression(corem->factor);
        value2=Evaluate_Expression(corem->remain);
        val2=*(value2+1);
        if(*(value1+1)==NULL)
        {
          Message("the factor can not be computed!",0);
          return;
        }
        else
           val1=*(value1+1);
        if(val1>0)
          tag=3;         /*lower left trapezoide*/ 
        else
          tag=4;         /*upper left trapezoide*/
      }
    coef=bif_build(INT_VAL,T_INT,NULL,NULL);
    NODE_IV(coef)=val1;
    if(*(value2+1)==NULL)
    {
       remain=(PTR_LLND)xmalloc(length);
       remain=corem->remain;
    }
    else
    { 
       remain=bif_build(INT_VAL,T_INT,NULL,NULL);
       NODE_IV(remain)=val2;
    }
  }
   
  switch (tag)
  {
    case 0:
      new_inf1=old_inf2; 
      new_sup1=old_sup2;
      new_inf2=old_inf1;
      new_sup2=old_sup1;
    break;
    case 1:
      new_sup1=old_sup2;
      new_inf2=old_inf1;
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_inf1;
      new_inf1=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(new_inf1)=remain;
      NODE_OPERAND1(new_inf1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND0(temp1)=temp2;
      NODE_OPERAND1(temp1)=remain;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;

      type=Return_to_me_type(T_INT);     
      up=Install_Variable(loop1,type);
      new_sup2=(PTR_LLND)bif_build(VAR_REF,type,up,NULL);
      bif1=Make_Assign(new_sup2,temp3);
      bif2=Make_Assign(new_sup2,old_sup2);
      condition=(PTR_LLND)bif_make_node(LT_OP);
      NODE_OPERAND0(condition)=temp3;
      NODE_OPERAND1(condition)=old_sup2; 
      min=Make_If_Then_Else(bif1,bif2,condition);
      Insert_Bifnode_Before(loop2,min,loop1); 
    break;
    case 2:
      new_sup1=old_sup2;
      new_sup2=old_sup1;
      
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_inf1;
      new_inf1=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(new_inf1)=remain;
      NODE_OPERAND1(new_inf1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND0(temp1)=remain;
      NODE_OPERAND1(temp1)=temp2;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;

      type=Return_to_me_type(T_INT);
      down=Install_Variable(loop1,type);
      new_inf2=(PTR_LLND)bif_build(VAR_REF,type,down,NULL);
      bif1=Make_Assign(new_inf2,temp3);
      bif2=Make_Assign(new_inf2,old_inf1);
      condition=(PTR_LLND)bif_make_node(GT_OP);
      NODE_OPERAND0(condition)=temp3;
      NODE_OPERAND1(condition)=old_inf1;
      max=Make_If_Then_Else(bif1,bif2,condition);
      Insert_Bifnode_Before(loop2,max,loop1);
    break;
    case 3:
      new_inf1=old_inf2;   
      new_sup2=old_sup1;
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_sup1;  
      new_sup1=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(new_sup1)=remain;
      NODE_OPERAND1(new_sup1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND0(temp1)=temp2;
      NODE_OPERAND1(temp1)=remain;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;
      
      type=Return_to_me_type(T_INT);
      down=Install_Variable(loop1,type);
      new_inf2=(PTR_LLND)bif_build(VAR_REF,type,down,NULL);
      bif1=Make_Assign(new_inf2,temp3);
      bif2=Make_Assign(new_inf2,old_inf1);
      condition=(PTR_LLND)bif_make_node(GT_OP);
      NODE_OPERAND0(condition)=temp3;
      NODE_OPERAND1(condition)=old_inf1;
      max=Make_If_Then_Else(bif1,bif2,condition);
      Insert_Bifnode_Before(loop2,max,loop1);
    break;
    case 4:
      new_inf1=old_inf2;
      new_inf2=old_inf1;
      
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_inf1;
      new_sup1=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(new_sup1)=remain;
      NODE_OPERAND1(new_sup1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND1(temp1)=temp2;
      NODE_OPERAND0(temp1)=remain;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;

      type=Return_to_me_type(T_INT);
      up=Install_Variable(loop1,type);
      new_sup2=(PTR_LLND)bif_build(VAR_REF,type,up,NULL);
      bif1=Make_Assign(new_sup2,temp3);
      bif2=Make_Assign(new_sup2,old_sup1);
      condition=(PTR_LLND)bif_make_node(LT_OP);
      NODE_OPERAND0(condition)=temp3;
      NODE_OPERAND1(condition)=old_sup1;
      min=Make_If_Then_Else(bif1,bif2,condition);
      Insert_Bifnode_Before(loop2,min,loop1);
    break;    
    case 5:
      if (val11>0)
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef1;
        NODE_OPERAND1(temp1)=old_inf1;
        new_inf1=(PTR_LLND)bif_make_node(ADD_OP);
        NODE_OPERAND0(new_inf1)=old_inf2;
        NODE_OPERAND1(new_inf1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND0(temp1)=temp2;
        NODE_OPERAND1(temp1)=old_inf2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef1;

        type=Return_to_me_type(T_INT);
        up=Install_Variable(loop1,type);
        new_sup2=(PTR_LLND)bif_build(VAR_REF,type,up,NULL);
        bif1=Make_Assign(new_sup2,temp3);
        bif2=Make_Assign(new_sup2,old_sup2);
        condition=(PTR_LLND)bif_make_node(LT_OP);
        NODE_OPERAND0(condition)=temp3;
        NODE_OPERAND1(condition)=old_sup2;
        min=Make_If_Then_Else(bif1,bif2,condition);
        Insert_Bifnode_Before(loop2,min,loop1);
      }
      else
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef1;
        NODE_OPERAND1(temp1)=old_inf1;
        new_inf1=(PTR_LLND)bif_make_node(SUBT_OP);
        NODE_OPERAND0(new_inf1)=old_inf2;
        NODE_OPERAND1(new_inf1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND0(temp1)=old_inf2;
        NODE_OPERAND1(temp1)=temp2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef1;

        type=Return_to_me_type(T_INT);
        down=Install_Variable(loop1,type);
        new_inf2=(PTR_LLND)bif_build(VAR_REF,type,down,NULL);
        bif1=Make_Assign(new_inf2,temp3);
        bif2=Make_Assign(new_inf2,old_inf1);
        condition=(PTR_LLND)bif_make_node(GT_OP);
        NODE_OPERAND0(condition)=temp3;
        NODE_OPERAND1(condition)=old_inf1;
        max=Make_If_Then_Else(bif1,bif2,condition);
        Insert_Bifnode_Before(loop2,max,loop1);
      }  
      if(val21>0)
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef2;
        NODE_OPERAND1(temp1)=old_sup1;
        new_sup1=(PTR_LLND)bif_make_node(ADD_OP);
        NODE_OPERAND0(new_sup1)=old_sup2;
        NODE_OPERAND1(new_sup1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND0(temp1)=temp2;
        NODE_OPERAND1(temp1)=old_sup2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef2;
       
        type=Return_to_me_type(T_INT);
        down=Install_Variable(loop1,type);
        new_inf2=(PTR_LLND)bif_build(VAR_REF,type,down,NULL);
        bif1=Make_Assign(new_inf2,temp3);
        bif2=Make_Assign(new_inf2,old_inf1);
        condition=(PTR_LLND)bif_make_node(GT_OP);
        NODE_OPERAND0(condition)=temp3;
        NODE_OPERAND1(condition)=old_inf1;
        max=Make_If_Then_Else(bif1,bif2,condition);
        Insert_Bifnode_Before(loop2,max,loop1);
      }
      else
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef2;
        NODE_OPERAND1(temp1)=old_inf1;
        new_sup1=(PTR_LLND)bif_make_node(SUBT_OP);
        NODE_OPERAND0(new_sup1)=old_sup2;
        NODE_OPERAND1(new_sup1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND1(temp1)=temp2;
        NODE_OPERAND0(temp1)=old_sup2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef2;

        type=Return_to_me_type(T_INT);
        up=Install_Variable(loop1,type);
        new_sup2=(PTR_LLND)bif_build(VAR_REF,type,up,NULL);
        bif1=Make_Assign(new_sup2,temp3);
        bif2=Make_Assign(new_sup2,old_sup1);
        condition=(PTR_LLND)bif_make_node(LT_OP);
        NODE_OPERAND0(condition)=temp3;
        NODE_OPERAND1(condition)=old_sup1;
        min=Make_If_Then_Else(bif1,bif2,condition);
        Insert_Bifnode_Before(loop2,min,loop1);
      } 
    break;
    default:
      return;   
  }
  Loop_Set_Index(loop1,index2);
  Loop_Set_Index(loop2,index1);
  Loop_Set_Borne_Inf(loop1,new_inf1);
  Loop_Set_Borne_Inf(loop2,new_inf2);
  Loop_Set_Borne_Sup(loop1,new_sup1);
  Loop_Set_Borne_Sup(loop2,new_sup2);
  return loop1;
}
