
/* expand low_level.c of toolbox*/

#include <stdio.h>
#include <malloc.h>
#include "macro.h"
#include "tag" 
#include "ext_low.h"
#include "ext_ann.h"
#include "ext_lib.h"
#include "ext_mid.h"
  
/*************************************************************************
*   FUNCTION: Split the factor of symb in expr.                          * 
*   INPUT   : The expression and the symb                                *
*   OUTPUT  : The factor of the symb and the remain                      *
**************************************************************************/    
PTR_DIS spit(expr,symb)
PTR_LLND expr;
PTR_SYMB symb;
{
  PTR_DIS ll,temp1,temp2;

  if (!expr || !symb)
  {
     Message("the expr or symb is NULL",0);
     return NULL;
  }

  ll=(PTR_DIS)malloc(sizeof(PTR_DIS));
  temp1=(PTR_DIS)malloc(sizeof(PTR_DIS));
  temp2=(PTR_DIS)malloc(sizeof(PTR_DIS));
  switch(NODE_CODE(expr))
  {
    case INT_VAL:
         ll->remain=expr;
         ll->factor=bif_build(INT_VAL,T_INT,NULL,NULL);
         NODE_IV(ll->factor)=0;
         break;
    case VAR_REF:
         if(NODE_SYMB(expr)=symb)
         {
           ll->remain=bif_build(INT_VAL,T_INT,NULL,NULL);
           NODE_IV(ll->remain)=0;
           ll->factor=bif_build(INT_VAL,T_INT,NULL,NULL);
           NODE_IV(ll->factor)=1;
         }
         else
         {
           ll->remain=expr;
           ll->factor=bif_build(INT_VAL,T_INT,NULL,NULL);
           NODE_IV(ll->factor)=0;
         }
           break;
    case ADD_OP:
         ll->remain=(PTR_LLND)bif_make_node(ADD_OP);
         ll->factor=(PTR_LLND)bif_make_node(ADD_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         NODE_OPERAND1(ll->factor)=temp2->factor;
         break;

    case SUBT_OP:
         ll->remain=(PTR_LLND)bif_make_node(SUBT_OP);
         ll->factor=(PTR_LLND)bif_make_node(SUBT_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         NODE_OPERAND1(ll->factor)=temp2->factor;
         break;
    case MINUS_OP:
         ll->remain=(PTR_LLND)bif_make_node(MINUS_OP);
         ll->factor=(PTR_LLND)bif_make_node(MINUS_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         break;
    case MULT_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb)
              &&Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
           return NULL;
         ll->remain=(PTR_LLND)bif_make_node(MULT_OP);
         ll->factor=(PTR_LLND)bif_make_node(MULT_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb))
         {
           NODE_OPERAND0(ll->factor)=temp1->factor;
           NODE_OPERAND1(ll->factor)=temp2->remain;
         }
         if(Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         {
           NODE_OPERAND0(ll->factor)=temp2->factor;
           NODE_OPERAND1(ll->factor)=temp1->remain;
         }
         break;
    case DIV_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         return NULL;
         ll->remain=(PTR_LLND)bif_make_node(DIV_OP);
         ll->factor=(PTR_LLND)bif_make_node(DIV_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         NODE_OPERAND0(ll->factor)=temp1->factor;
         NODE_OPERAND1(ll->factor)=temp2->remain;
         break;
    case EXP_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb)
              ||Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         return NULL;
         ll->remain=(PTR_LLND)bif_make_node(EXP_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         break;
    case MOD_OP:
         if(Is_Var_Ref_To_Symb(NODE_OPERAND0(expr),symb)
              ||Is_Var_Ref_To_Symb(NODE_OPERAND1(expr),symb))
         return NULL;
         ll->remain=(PTR_LLND)bif_make_node(MOD_OP);
         temp1=spit(NODE_OPERAND0(expr),symb);
         temp2=spit(NODE_OPERAND1(expr),symb);
         NODE_OPERAND0(ll->remain)=temp1->remain;
         NODE_OPERAND1(ll->remain)=temp2->remain;
         break; 
    default:
         return NULL;
  }
  return ll;
}

/**************************************************************
* FUNCTION: It can determine whether the loop1 and loop2 are  *
*             perfectly nested.                               *
* INPUT   : the loop1 and loop2;                              *
* OUTPUT  : if they are perfectly nested ,return TRUE.        *
*           otherwise return FALSE.                           *
* NOTE    : loop1 suround loop2.                              * 
***************************************************************/   
int Perfectly(loop1,loop2)
PTR_BFND loop1;
PTR_BFND loop2;
{
  if (loop1 && loop2 && BIF_CODE(loop1)==FOR_NODE && BIF_CODE(loop2)==
FOR_NODE && BIF_NEXT(loop1)==loop2 && blob_list_length(BIF_BLOB1(loop1
))==2)
    return TRUE;
  else
    return FALSE;
}


/*****************************************************************
* FUNCTION :copy the section from begin to end.                  *
* INPUT    :the scope of BFND to be copied ,begin and end;       * 
* OUTPUT   :the list of BFNDs copied;                            *
*****************************************************************/
PTR_BFND Bif_Copy(begin,end)
PTR_BFND begin,end;
{
 PTR_BFND copie, last, temp, cherche, lastnode;
 int lenght,i,j;
 PTR_BFND *alloue;
 PTR_BLOB blobtemp;
 PTR_LABEL *label_insection;
 PTR_LABEL lab;
 int maxlabelname;

 if (! begin || ! end) return NULL;
  /* on calcul d'abord la longueur */

 maxlabelname = Get_Last_Label_Id();

 lenght = 0;
 for (temp = begin; temp!=end ; temp = BIF_NEXT(temp))
   {
     lenght++;
     lastnode = temp;
   }
      lenght++;
     lastnode = temp;
 
 alloue = (PTR_BFND *) xmalloc(2*lenght * sizeof(PTR_BFND));
 bzero(alloue, 2* lenght * sizeof(PTR_BFND));

 /* label part, we record label */
 label_insection = (PTR_LABEL *) xmalloc(2*lenght * sizeof(PTR_LABEL));
 bzero(label_insection, 2* lenght * sizeof(PTR_LABEL));
 temp = begin;
 last = NULL;
 for (i = 0; i < lenght; i++)
   {
      copie = (PTR_BFND) bif_make_node (BIF_CODE (temp));
      BIF_SYMB (copie) = BIF_SYMB (temp);
      BIF_LL1 (copie) = bif_copy_expr (BIF_LL1 (temp));
      BIF_LL2 (copie) = bif_copy_expr (BIF_LL2 (temp));
      BIF_LL3 (copie) = bif_copy_expr (BIF_LL3 (temp));
      if (last)
        BIF_NEXT(last) = copie;

  
      if (BIF_LABEL(temp))/* && (LABEL_BODY(BIF_LABEL(temp)) == temp))*/
        {
          /* create a new label */

          maxlabelname++;
          LABEL_STMTNO(label_insection[2*i+1]) = maxlabelname;
          LABEL_BODY(label_insection[2*i+1]) == copie;
          LABEL_USED(label_insection[2*i+1]) = LABEL_USED(BIF_LABEL(temp));
          LABEL_ILLEGAL(label_insection[2*i+1])=LABEL_ILLEGAL(BIF_LABEL(temp));
          LABEL_DEFINED(label_insection[2*i+1])=LABEL_DEFINED(BIF_LABEL(temp));
          BIF_LABEL(copie) = label_insection[2*i+1];
          label_insection[2*i] = BIF_LABEL(temp);
        }

      /* on fait corresponde temp et copie */
      alloue[2*i] = temp;
      alloue[2*i+1] = copie;
      temp = BIF_NEXT(temp);
      last = copie;
   }

 /* On met a jour les labels */
 temp = begin;
 for (i = 0; i < lenght; i++)
   {
     int cas;
     copie = alloue[2*i+1];
     lab = NULL;

     /* We treat first the COMGOTO_NODE first */
     if (BIF_CODE(temp) == COMGOTO_NODE)
       {
         PTR_LLND listlab, ptl;
         int trouve = 0;

         listlab = BIF_LL1(copie);
         while (listlab)
           {
             ptl = NODE_OPERAND0(listlab);
             /* we look in the list */
             if (ptl)
               {
                 lab = NODE_LABEL(ptl);
                 trouve = 0;
                 for (j = 0; j < lenght; j++)
                   {
                     if (label_insection[2*j])
                       if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                         {
                           trouve = j+1;
                           break;
                         }
                   }
                 if(trouve)
                   {
                     NODE_LABEL(ptl) =  label_insection[2*(trouve-1)+1];
                   }
               }
             listlab = NODE_OPERAND1(listlab);
           }
         temp = BIF_NEXT(temp);
         continue;
       }

        
     if (BIF_LL3(temp) && (NODE_CODE(BIF_LL3(temp)) == LABEL_REF))
       {
         lab = NODE_LABEL(BIF_LL3(temp));
         cas = 2;      
       }
     else
       {
         lab = BIF_LABEL_USE(temp);
         cas = 1;
       }
     if (lab)
       { /* look where the label is the label is defined somewhere */
         int trouve = 0;
         for (j = 0; j < lenght; j++)
           {
             if (label_insection[2*j])
               if (LABEL_STMTNO(label_insection[2*j]) == LABEL_STMTNO(lab))
                 {
                   trouve = j+1;
                   break;
                 }
           }
         if(trouve)
           {
             if (cas == 1)
               {
                 BIF_LABEL_USE(copie) = label_insection[2*(trouve-1)+1];
               }

             if (cas == 2)
               {
                 if (BIF_LL3(copie))
                   {
                     NODE_LABEL(BIF_LL3(copie)) = label_insection[2*(trouve-1)+1
];
                   }
               }
           } else
             {
               if (cas == 1)
                 BIF_LABEL_USE(copie) = lab; /* outside */
               /* if ((cas == 2) no change */
             }
       }
     temp = BIF_NEXT(temp);
   }

 /* on met a jour le blob list */
 copie = alloue[1];
 for (temp = begin; temp<=end ; temp = BIF_NEXT(temp))
   {
     if (BIF_BLOB1(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB1(temp);blobtemp;
              blobtemp = BLOB_NEXT(blobtemp))
           {
             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste1(cherche, copie);
           }
       }
     if (BIF_BLOB2(temp))
       { /* on doit cree la blob liste */
         for (blobtemp = BIF_BLOB2(temp);blobtemp;
              blobtemp = BLOB_NEXT(blobtemp))
           {

             /* on cherche la reference dans le tableaux allouer */
             cherche = NULL;
             for (i = 0; i <lenght ; i++)
               {
                 if (alloue[2*i] == BLOB_VALUE(blobtemp))
                     {
                       cherche = alloue[2*i+1];
                       break;
                     }
               }
             Append_In_Blob_Liste2(cherche, copie);
           }
       }
     copie = BIF_NEXT(copie);
   }

 /* on remet ici a jour les CP */
 copie = alloue[1];
 for (temp = begin; temp<=end ; temp = BIF_NEXT(temp))
   {
     if (In_Section(begin, lastnode, BIF_CP(temp)))
       { /* on cherche le bif_cp pour la copie */
         cherche = NULL;
         for (i = 0; i <lenght ; i++)
           {
             if (alloue[2*i] == BIF_CP(temp))
               {
                 cherche = alloue[2*i+1];
                 break;
               }
           }
         BIF_CP(copie) = cherche;
       }
     copie = BIF_NEXT(copie);
   }
 copie = alloue[1];
 free(alloue);
 free(label_insection);
 return copie;
}


/*ex_high_level.c*/

/**********************************************************
*  FUNCTION: It can reverse the iteration order.          *
*  INPUT   : the loop to be reversed                      *
*  OUTPUT  : the loop after reversed                      * 
***********************************************************/ 

PTR_BFND Reverse(loop)
PTR_BFND loop;
{
  PTR_LLND old_sup,old_inf,new_sup,new_inf;
  PTR_SYMB index;
  PTR_LLND temp1,temp2;
  PTR_BFND beg,fin;

  if (BIF_CODE(loop)!=FOR_NODE)
  {
    Message("Not a for loop to reversed",0);
    return 0;
  } 
  beg=BIF_NEXT(loop);
  fin=Get_Last_Node_Of_Stmt(loop);
  old_sup=Loop_Get_Borne_Sup(loop);
  old_inf=Loop_Get_Borne_Inf(loop);
  index=Loop_Get_Index(loop);
  new_sup=(PTR_LLND)bif_make_node(MINUS_OP);
  new_inf=(PTR_LLND)bif_make_node(MINUS_OP);
  NODE_OPERAND0(new_inf)=old_sup;
  NODE_OPERAND0(new_sup)=old_inf;
  Loop_Set_Borne_Sup(loop,new_sup);
  Loop_Set_Borne_Inf(loop,new_inf);
  temp1=(PTR_LLND)bif_make_node(VAR_REF);
  NODE_SYMB(temp1)=index;
  temp2=(PTR_LLND)bif_make_node(MINUS_OP);
  NODE_OPERAND0(temp2)=temp1;
  Replace_Var_In_Section(beg,fin,index,temp2);
  return loop;
}

/*****************************************************************
*   FUNCTION: It can skew the iteration space .                  *
*   INPUT   : the loop to be skewed                              *
*             skewing factor                                     *
*   OUTPUT  : the loop after skewed                              *
******************************************************************/     

PTR_BFND Skew_Loop(loop,factor)
PTR_BFND loop;
int factor;
{
  PTR_BFND previous,first,last; 
  PTR_LLND sup,inf,new_index;
  PTR_LLND new_sup,new_inf,ll1,ll2,ll3,ll4;
  PTR_SYMB index1,index2;

  if(!loop)
    return NULL;
  if(factor==0)
    return loop; 
  previous=Get_Previous_Nested_Loop(loop);

  if(!previous)
    return NULL;

  sup=Loop_Get_Borne_Sup(loop);
  inf=Loop_Get_Borne_Inf(loop);
  index1=Loop_Get_Index(previous);
  index2=Loop_Get_Index(loop);
  ll1=bif_build(INT_VAL,T_INT,NULL,NULL);
  NODE_IV(ll1)=abs(factor);
  ll2=bif_build(VAR_REF,T_INT,index1,NULL);
  ll3=(PTR_LLND)bif_make_node(MULT_OP);
  NODE_OPERAND0(ll3)=ll1;
  NODE_OPERAND1(ll3)=ll2;
  if (factor>0)
  {
    new_sup=(PTR_LLND)bif_make_node(ADD_OP);
    new_inf=(PTR_LLND)bif_make_node(ADD_OP);
    new_index=(PTR_LLND)bif_make_node(MULT_OP);
  }
  else
  {
    new_sup=(PTR_LLND)bif_make_node(SUBT_OP);
    new_inf=(PTR_LLND)bif_make_node(SUBT_OP);
    new_index=(PTR_LLND)bif_make_node(ADD_OP);
  }
  NODE_OPERAND0(new_sup)=sup;
  NODE_OPERAND1(new_sup)=ll3;
  NODE_OPERAND0(new_inf)=inf;
  NODE_OPERAND1(new_inf)=ll3;
  Loop_Set_Borne_Inf(loop,new_inf);
  Loop_Set_Borne_Sup(loop,new_sup);
  ll4=bif_build(VAR_REF,T_INT,index2,NULL);
  NODE_OPERAND0(new_index)=ll4;
  NODE_OPERAND1(new_index)=ll3;
  first=BIF_NEXT(loop);
  last=Get_Last_Node_Of_Stmt(loop);
  Replace_Var_In_Section(first,last,index2,new_index);
  return loop;
} 

/**************************************************************
*  FUNCTION: It can move the iteration space .                *
*  INPUT   : the loop and the factor of moving.               *
*  OUTPUT  : The loop after moved.                            *
**************************************************************/     

PTR_BFND Bump_Loop(loop,factor)
PTR_BFND loop;
int factor;
{
  PTR_BFND first,last; 
  PTR_LLND sup,inf,new_index;
  PTR_LLND new_sup,new_inf,ll1,ll2;
  PTR_SYMB index;

  if(!loop)
    return NULL;
  if(factor==0)
    return loop; 

  sup=Loop_Get_Borne_Sup(loop);
  inf=Loop_Get_Borne_Inf(loop);
  index=Loop_Get_Index(loop);
  ll1=bif_build(INT_VAL,T_INT,NULL,NULL);
  NODE_IV(ll1)=abs(factor);
  if (factor>0)
  {
    new_sup=(PTR_LLND)bif_make_node(ADD_OP);
    new_inf=(PTR_LLND)bif_make_node(ADD_OP);
    new_index=(PTR_LLND)bif_make_node(SUBT_OP);
  }
  else
  {
    new_sup=(PTR_LLND)bif_make_node(SUBT_OP);
    new_inf=(PTR_LLND)bif_make_node(SUBT_OP);
    new_index=(PTR_LLND)bif_make_node(ADD_OP);
  }
  NODE_OPERAND0(new_sup)=sup;
  NODE_OPERAND1(new_sup)=ll1;
  NODE_OPERAND0(new_inf)=inf;
  NODE_OPERAND1(new_inf)=ll1;
  Loop_Set_Borne_Inf(loop,new_inf);
  Loop_Set_Borne_Sup(loop,new_sup);
  ll2=bif_build(VAR_REF,T_INT,index,NULL);
  NODE_OPERAND0(new_index)=ll2;
  NODE_OPERAND1(new_index)=ll1;
  first=BIF_NEXT(loop);
  last=Get_Last_Node_Of_Stmt(loop);
  Replace_Var_In_Section(first,last,index,new_index);
  return loop;
} 
  

/*****************************************************************************
*    INPUT :  the two loops to be interchanged                               *
*    OUTPUT:  the first loop interchanged                                    *
*    NOTE  :  This function only can interchange the perfactly nested loops. *
*             If one of the limits of the second loop is a expression which  *
*             has index variable of the first loop ,it must be linear.       *
******************************************************************************/             
PTR_BFND interchange_two_loops(loop1,loop2)
PTR_BFND loop1,loop2;
{
  PTR_LLND old_sup1,old_sup2,old_inf1,old_inf2;
  PTR_LLND new_sup1,new_sup2,new_inf1,new_inf2;
  PTR_SYMB index1,index2;
  int tag,length,leng,len;
  PTR_LLND temp1,temp2,temp3;
  PTR_LLND coef,remain,coef1,coef2;
  PTR_DIS corem;
  int *value1,*value2;
  int val1,val2;
  PTR_LLND condition;
  int val11,val21,val12,val22;
  
 
  if(!loop1 || !loop2)
  {
     Message("one or two loops to be exchanged are null",0);
     return;
  }
  if((BIF_NEXT(loop1)!=loop2) || (BIF_CODE(loop1)!=FOR_NODE) || 
      (BIF_CODE(loop2)!=FOR_NODE) || (blob_list_length(BIF_BLOB1(loop1))!=2))
  {
     Message("they are not loops or not perfectly nested",0);
     return;
  } 
  
  length=sizeof(struct llnd);
  leng=sizeof(struct symb);
  len=sizeof(PTR_DIS);
  
  value1=(int *)xmalloc(sizeof(int));
  value2=(int *)xmalloc(sizeof(int)); 
  index1=(PTR_SYMB)xmalloc(leng);
  index2=(PTR_SYMB)xmalloc(leng);
  old_sup1=(PTR_LLND)xmalloc(length);
  old_sup2=(PTR_LLND)xmalloc(length);
  old_inf1=(PTR_LLND)xmalloc(length);
  old_inf2=(PTR_LLND)xmalloc(length);
  new_sup1=(PTR_LLND)xmalloc(length);
  new_sup2=(PTR_LLND)xmalloc(length);
  new_inf1=(PTR_LLND)xmalloc(length);
  new_inf2=(PTR_LLND)xmalloc(length);
  corem=(PTR_DIS)xmalloc(len);

  old_sup1=Loop_Get_Borne_Sup(loop1);
  old_sup2=Loop_Get_Borne_Sup(loop2);
  old_inf1=Loop_Get_Borne_Inf(loop1);
  old_inf2=Loop_Get_Borne_Inf(loop2);
  index1=Loop_Get_Index(loop1);
  index2=Loop_Get_Index(loop2);
 
  if(!Is_Var_In_Expression(BIF_LL1(loop2),index1))
    tag=0;
  else 
    if(Is_Var_In_Expression(NODE_OPERAND0(BIF_LL1(loop2)),index1)
      &&Is_Var_In_Expression(NODE_OPERAND1(BIF_LL1(loop2)),index1))
    { 
      tag=5;   /*there is previous loop's index in up and down limit*/
      corem=spit(NODE_OPERAND0(BIF_LL1(loop2)),index1);
      value1=Evaluate_Expression(corem->factor);
      value2=Evaluate_Expression(corem->remain);
      val12=*(value2+1);
      if(*(value1+1)==NULL)
      {
        Message("the factor can not be computed!",0);
        return;
      }
      else
         val11=*(value1+1);

      coef1=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(coef1)=val11;
      if(*(value2+1)==NULL)
        old_inf2=corem->remain;
      else
      {
        old_inf2=bif_build(INT_VAL,T_INT,NULL,NULL);
        NODE_IV(old_inf2)=val12;
      }

      corem=spit(NODE_OPERAND1(BIF_LL1(loop2)),index1);
      value1=Evaluate_Expression(corem->factor);
      value2=Evaluate_Expression(corem->remain);
      val22=*(value2+1);
      if(*(value1+1)==NULL)
      {
        Message("the factor can not be computed!",0);
        return;
      }
      else
         val21=*(value1+1);

      coef2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(coef2)=val21;
      if(*(value2+1)==NULL)
        old_sup2=corem->remain;
      else
      {
        old_sup2=bif_build(INT_VAL,T_INT,NULL,NULL);
        NODE_IV(old_sup2)=val22;
      }

    } 
    else
    {
      if(Is_Var_In_Expression(NODE_OPERAND0(BIF_LL1(loop2)),index1))
      {
        corem=spit(NODE_OPERAND0(BIF_LL1(loop2)),index1);
        value1=Evaluate_Expression(corem->factor);
        value2=Evaluate_Expression(corem->remain);
        val2=*(value2+1);
        if(*(value1+1)==NULL)
        {
          Message("the factor can not be computed!",0);
          return;
        }
        else
           val1=*(value1+1);
        if(val1>0)
          tag=1;         /*upper right trapezoide*/
        else
          tag=2;         /*lower right trapezoide*/
      }
      else if(Is_Var_In_Expression(NODE_OPERAND1(BIF_LL1(loop2)),index1))
      {
        corem=spit(NODE_OPERAND1(BIF_LL1(loop2)),index1);
        value1=Evaluate_Expression(corem->factor);
        value2=Evaluate_Expression(corem->remain);
        val2=*(value2+1);
        if(*(value1+1)==NULL)
        {
          Message("the factor can not be computed!",0);
          return;
        }
        else
           val1=*(value1+1);
        if(val1>0)
          tag=3;         /*lower left trapezoide*/ 
        else
          tag=4;         /*upper left trapezoide*/
      }
    coef=bif_build(INT_VAL,T_INT,NULL,NULL);
    NODE_IV(coef)=val1;
    if(*(value2+1)==NULL)
    {
       remain=(PTR_LLND)xmalloc(length);
       remain=corem->remain;
    }
    else
    { 
       remain=bif_build(INT_VAL,T_INT,NULL,NULL);
       NODE_IV(remain)=val2;
    }
  }
   
  switch (tag)
  {
    case 0:
      new_inf1=old_inf2; 
      new_sup1=old_sup2;
      new_inf2=old_inf1;
      new_sup2=old_sup1;
    break;
    case 1:
      new_sup1=old_sup2;
      new_inf2=old_inf1;
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_inf1;
      new_inf1=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(new_inf1)=remain;
      NODE_OPERAND1(new_inf1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND0(temp1)=temp2;
      NODE_OPERAND1(temp1)=remain;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;
      new_sup2=bif_build(MIN_OP,NULL,NULL,NULL);
      NODE_OPERAND0(new_sup2)=temp3;
      NODE_OPERAND1(new_sup2)=old_sup2;
    break;
    case 2:
      new_sup1=old_sup2;
      new_sup2=old_sup1;
      
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_inf1;
      new_inf1=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(new_inf1)=remain;
      NODE_OPERAND1(new_inf1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND0(temp1)=remain;
      NODE_OPERAND1(temp1)=temp2;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;
      new_sup2=bif_build(MAX_OP,NULL,NULL,NULL);
      NODE_OPERAND0(new_inf2)=temp3;
      NODE_OPERAND1(new_inf2)=old_inf1;
    break;
    case 3:
      new_inf1=old_inf2;   
      new_sup2=old_sup1;
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_sup1;  
      new_sup1=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(new_sup1)=remain;
      NODE_OPERAND1(new_sup1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND0(temp1)=temp2;
      NODE_OPERAND1(temp1)=remain;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;
      new_sup2=bif_build(MAX_OP,NULL,NULL,NULL);
      NODE_OPERAND0(new_inf2)=temp3;
      NODE_OPERAND1(new_inf2)=old_inf1; 
    break;
    case 4:
      new_inf1=old_inf2;
      new_inf2=old_inf1;
      
      temp1=(PTR_LLND)bif_make_node(MULT_OP);
      NODE_OPERAND0(temp1)=coef;
      NODE_OPERAND1(temp1)=old_inf1;
      new_sup1=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(new_sup1)=remain;
      NODE_OPERAND1(new_sup1)=temp1;
      temp1=(PTR_LLND)bif_make_node(SUBT_OP);
      temp2=bif_build(VAR_REF,T_INT,index2,NULL);
      NODE_OPERAND1(temp1)=temp2;
      NODE_OPERAND0(temp1)=remain;
      temp3=(PTR_LLND)bif_make_node(DIV_OP);
      NODE_OPERAND0(temp3)=temp1;
      NODE_OPERAND1(temp3)=coef;
      new_sup2=bif_build(MIN_OP,NULL,NULL,NULL);
      NODE_OPERAND0(new_sup2)=temp3;
      NODE_OPERAND1(new_sup2)=old_sup1;
    break;    
    case 5:
      if (val11>0)
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef1;
        NODE_OPERAND1(temp1)=old_inf1;
        new_inf1=(PTR_LLND)bif_make_node(ADD_OP);
        NODE_OPERAND0(new_inf1)=old_inf2;
        NODE_OPERAND1(new_inf1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND0(temp1)=temp2;
        NODE_OPERAND1(temp1)=old_inf2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef1;
        new_sup2=bif_build(MIN_OP,NULL,NULL,NULL);
        NODE_OPERAND0(new_sup2)=temp3;
        NODE_OPERAND1(new_sup2)=old_sup2;
      }
      else
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef1;
        NODE_OPERAND1(temp1)=old_inf1;
        new_inf1=(PTR_LLND)bif_make_node(SUBT_OP);
        NODE_OPERAND0(new_inf1)=old_inf2;
        NODE_OPERAND1(new_inf1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND0(temp1)=old_inf2;
        NODE_OPERAND1(temp1)=temp2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef1;
        new_sup2=bif_build(MAX_OP,NULL,NULL,NULL);
        NODE_OPERAND0(new_inf2)=temp3;
        NODE_OPERAND1(new_inf2)=old_inf1;
      }  
      if(val21>0)
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef2;
        NODE_OPERAND1(temp1)=old_sup1;
        new_sup1=(PTR_LLND)bif_make_node(ADD_OP);
        NODE_OPERAND0(new_sup1)=old_sup2;
        NODE_OPERAND1(new_sup1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND0(temp1)=temp2;
        NODE_OPERAND1(temp1)=old_sup2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef2;
        new_sup2=bif_build(MAX_OP,NULL,NULL,NULL);
        NODE_OPERAND0(new_inf2)=temp3;
        NODE_OPERAND1(new_inf2)=old_inf1;
      }
      else
      {
        temp1=(PTR_LLND)bif_make_node(MULT_OP);
        NODE_OPERAND0(temp1)=coef2;
        NODE_OPERAND1(temp1)=old_inf1;
        new_sup1=(PTR_LLND)bif_make_node(SUBT_OP);
        NODE_OPERAND0(new_sup1)=old_sup2;
        NODE_OPERAND1(new_sup1)=temp1;
        temp1=(PTR_LLND)bif_make_node(SUBT_OP);
        temp2=bif_build(VAR_REF,T_INT,index2,NULL);
        NODE_OPERAND1(temp1)=temp2;
        NODE_OPERAND0(temp1)=old_sup2;
        temp3=(PTR_LLND)bif_make_node(DIV_OP);
        NODE_OPERAND0(temp3)=temp1;
        NODE_OPERAND1(temp3)=coef2;
        new_sup2=bif_build(MIN_OP,NULL,NULL,NULL);
        NODE_OPERAND0(new_sup2)=temp3;
        NODE_OPERAND1(new_sup2)=old_sup1;
      } 
    break;
    default:
      return;   
  }
  Loop_Set_Index(loop1,index2);
  Loop_Set_Index(loop2,index1);
  Loop_Set_Borne_Inf(loop1,new_inf1);
  Loop_Set_Borne_Inf(loop2,new_inf2);
  Loop_Set_Borne_Sup(loop1,new_sup1);
  Loop_Set_Borne_Sup(loop2,new_sup2);
  return loop1;
}


/*****************************************************************
*  FUNCTION: It can interchange the loop to the level.           *
*  INPUT   : the loop ;                                          * 
*            the level;                                          * 
*  OUTPUT  : the loop after interchanged;                        *
*  NOTE    : the level of the loop must be greater than the level*
*****************************************************************/

PTR_BFND Interchange(loop,level)
PTR_BFND loop;
int level;
{ 
  PTR_BFND temp1,temp2;
  int i,n,j=1;
  
  temp1=(PTR_BFND)xmalloc(sizeof(PTR_BFND));
  temp2=(PTR_BFND)xmalloc(sizeof(PTR_BFND));
  temp1=temp2=loop;
  while (BIF_CODE(temp2)==FOR_NODE)
  {
    temp2=Get_Previous_Nested_Loop(temp1);
    if (Perfectly(temp2,temp1))
    { 
      temp1=temp2;
      j++;
    }
    else
      break; 
  }
  n=Perfectly_Nested(temp1);
  if (level>n)
  {
    Message("the level does not exist",0);
    return;
  }
  if (j<level)
  {
    Message("the loop is upon the level",0);
    return;
  }
  for (i=1;i<=(j-level);i++)
  { 
    temp2=Get_Previous_Nested_Loop(loop); 
    loop=Interchange_Two_Loops(temp2,loop);
  }
  return loop;
}  
 
/*******************************************************************
* FUNCTION:fuse two loops;                                         * 
* INPUT   :the loop1 and loop2 to be fused;                        *
* OUTPUT  :NULL;                                                   *
* NOTE    :The  restrictions to loop1 and loop2 is their steps must*
*          be one and they must be adjacent.                       *
*******************************************************************/
void Fusion_Loops(loop1,loop2)
PTR_BFND loop1,loop2;
{
  PTR_BFND Bif_Copy();

  PTR_LLND inf1,inf2,sup1,sup2,temp1,temp2,exp,newinf,newsup;
  PTR_BFND body,bodyend,first,last,where;
  int inf1_val,inf2_val,sup1_val,sup2_val,length1,length2;
  PTR_SYMB index1,index2;
  int len,leng;

  len=(int)sizeof(PTR_LLND);
  leng=(int)sizeof(PTR_BFND);
  inf1=(PTR_LLND)xmalloc(len);
  inf2=(PTR_LLND)xmalloc(len);
  sup1=(PTR_LLND)xmalloc(len);
  sup2=(PTR_LLND)xmalloc(len); 
  body=(PTR_BFND)xmalloc(leng);
  bodyend=(PTR_BFND)xmalloc(leng);
  first=(PTR_BFND)xmalloc(leng);
  last=(PTR_BFND)xmalloc(leng);
  where=(PTR_BFND)xmalloc(leng);
  index1=(PTR_SYMB)xmalloc(sizeof(PTR_SYMB));
  index2=(PTR_SYMB)xmalloc(sizeof(PTR_SYMB));

  inf1=Loop_Get_Borne_Inf(loop1);
  inf2=Loop_Get_Borne_Inf(loop2); 
  sup1=Loop_Get_Borne_Sup(loop1);
  sup2=Loop_Get_Borne_Sup(loop2);
  index1=Loop_Get_Index(loop1);
  index2=Loop_Get_Index(loop2);

  inf1_val=NODE_IV(inf1);
  inf2_val=NODE_IV(inf2);
  sup1_val=NODE_IV(sup1);
  sup2_val=NODE_IV(sup2);
  length1=sup1_val-inf1_val;
  length2=sup2_val-inf2_val;
  if (length1>length2)
  {
    first=BIF_NEXT(loop1);
    last=Get_Node_Before(Get_Last_Node_Of_Stmt(loop1));
    body=Bif_Copy(first,last);
    bodyend=Get_Last_Node_Of_Stmt(body);
    newinf=inf1;
    newsup=bif_build(INT_VAL,T_INT,NULL,NULL);
    NODE_IV(newsup)=sup1_val-length2-1;

    if(sup1_val==sup2_val)
      exp=bif_build(VAR_REF,T_INT,index2,NULL); 
    else if(sup1_val>sup2_val)
    {
      temp1=bif_build(VAR_REF,T_INT,index2,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=sup1_val-sup2_val;
      exp=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    else
    {
      temp1=bif_build(VAR_REF,T_INT,index2,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=sup2_val-sup1_val;
      exp=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }

    Replace_Var_In_Section(body,bodyend,index1,exp);
    where=loop2;
    Insert_List_of_BifNode(body,where,loop2);
    
    Loop_Set_Borne_Inf(loop1,newinf);
    Loop_Set_Borne_Sup(loop1,newsup);
  }
  else if (length2>length1)
  {
    first=BIF_NEXT(loop2);
    last=Get_Node_Before(Get_Last_Node_Of_Stmt(loop2));
    body=Bif_Copy(first,last);
    bodyend=Get_Last_Node_Of_Stmt(body);
    newsup=sup2;
    newinf=bif_build(INT_VAL,T_INT,NULL,NULL);
    NODE_IV(newinf)=inf2_val+length1;

    if(inf1_val==inf2_val)
      exp=bif_build(VAR_REF,T_INT,index1,NULL);
    else if(inf1_val>inf2_val)
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf1_val-inf2_val;
      exp=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    } 
    else
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf2_val-inf1_val;
      exp=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    Loop_Set_Borne_Inf(loop2,newinf);
    Loop_Set_Borne_Sup(loop2,newsup);
    Replace_Var_In_Section(body,bodyend,index2,exp);
    where=Get_Node_Before(Get_Last_Node_Of_Stmt(loop1));
    Insert_List_of_BifNode(body,where,loop1);
  }
  else
  {
    last=Get_Node_Before(Get_Last_Node_Of_Stmt(loop2));
    where=Get_Node_Before(Get_Last_Node_Of_Stmt(loop1));
    body=Extract_Loop_Body(loop2);
    Extract_Bif_Section(loop2,Get_Last_Node_Of_Stmt(loop2));
    if(inf1_val==inf2_val)
      exp=bif_build(VAR_REF,T_INT,index1,NULL);
    else if(inf1_val>inf2_val)
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf1_val-inf2_val;
      exp=(PTR_LLND)bif_make_node(SUBT_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    else
    {
      temp1=bif_build(VAR_REF,T_INT,index1,NULL);
      temp2=bif_build(INT_VAL,T_INT,NULL,NULL);
      NODE_IV(temp2)=inf2_val-inf1_val;
      exp=(PTR_LLND)bif_make_node(ADD_OP);
      NODE_OPERAND0(exp)=temp1;
      NODE_OPERAND1(exp)=temp2;
    }
    Replace_Var_In_Section(body,last,index2,exp); 
    Insert_List_of_BifNode(body,where,NULL);
  }
}

/****************************************************************
* FILE      :printdep.c                                         *
* FUNCTION  :It can print the information of a FORTRAN file.    *
* INPUT     :the project file of the source file.               *
* OUTPUT    :                                                   *
****************************************************************/
#include "macro.h"
#include "dependence.h"
#include "ext_lib.h"
#include <stdio.h>
main(argc,argv)
int argc;
char * argv[];
{

  extern PTR_FILE cur_file;

  PTR_DEP first,temp;
  char *vect;
  int i;
  char * proj;

  proj=argv[1];
  Initialize_Project_Toolbox(proj);
  do_glob_analysis_toolbox(); 
  first=FIRST_DEP_IN_PROJ(cur_file);
  printf("ID  TYPE        DIRECT          SYMB FROM   TO  FFWD FBACK TFWD TBACK\n");  
  for(temp=first;temp;temp=DEP_NEXT(temp))
  {
    vect=DEP_DIRECTION(temp);
    printf("%2d ",DEP_ID(temp));
    switch(DEP_TYPE(temp))
    {
      case 0:
             printf(" flow_dep    ");
             break;
      case 1:
             printf(" anti_dep    ");
             break;
      case 2:
             printf(" output_dep  ");  
             break;
      default:
             printf(" unknow      ");
    }
    for(i=1;i<6;i++)
    {
       switch(vect[i])
       {
         case 1:
          printf("=  ");
          break;
         case 2:
          printf("<  ");
          break;
         case 3:
          printf("<= ");
          break;
         case 4:
          printf(">  ");
          break;
         case 5:
          printf(">= ");
          break;
         case 6:
          printf("<> ");
          break;
         case 7:
          printf("*  ");
          break;
         default:
          printf("-1 ");
       }     
    }
    printf("%5d",SYMB_ID(DEP_SYMB(temp)));
    printf("%5d",BIF_ID(DEP_FROM_BIF(temp)));
    printf("%5d",BIF_ID(DEP_TO_BIF(temp)));
    printf("%6d%6d%5d%6d",DEP_ID(DEP_FROM_FWD(temp)),DEP_ID(DEP_FROM_BACK(temp))
            ,DEP_ID(DEP_TO_FWD(temp)),DEP_ID(DEP_TO_BACK(temp)));           
    printf("\n");
    printf("                ");
    for(i=6;i<MAX_DEP;i++)
    {
       switch(vect[i])
       {
         case 1:
          printf("=  ");
          break;
         case 2:
          printf("<  ");
          break;
         case 3:
          printf("<= ");
          break;
         case 4:
          printf(">  ");
          break;
         case 5:
          printf(">= ");
          break;
         case 6:
          printf("<> ");
          break;
         case 7:
          printf("*  ");
          break;
         default:
          printf("-1 ");
       }
    }
    printf("\n");
  }
}

/* an example of restruction.fusion loops  */

#include <stdio.h>
#include <malloc.h>
#include "macro.h"
#include "tag" 
#include "ext_low.h"
#include "ext_ann.h"
#include "ext_lib.h"
#include "ext_mid.h"

extern PTR_FILE pointer_on_file_proj;

main(argc,argv)
int argc;
char *argv[];
{
 char * proj;
 PTR_BFND temp,temp2;
 char * filename;
 FILE * outfile;
 extern PTR_BFND Fusion_Loops();

 temp=(PTR_BFND)malloc(sizeof(PTR_BFND));
 temp2=(PTR_BFND)malloc(sizeof(PTR_BFND));
 filename=(char* )malloc(sizeof(char)); 
 proj=argv[1];
 Initialize_Project_Toolbox(proj);
 filename=getname(proj); 
 outfile=fopen(filename,"w");
 temp=FILE_GOBAL_BFND(pointer_on_file_proj);
 while (temp)  
 { 
   if (BIF_CODE(temp)==FOR_NODE)
   { 
     temp2=Get_Last_Node_Of_Stmt(temp);
     temp2=BIF_NEXT(temp2);
     if (BIF_CODE(temp2)==FOR_NODE)
       break;
   }
   temp=BIF_NEXT(temp);
 }
 Fusion_Loops(temp,temp2);   
 UnparseProgram(outfile);
 Write_Data_Base_For_Debug();
 return;
}

