/*  As fortran language,the first array_mumber is numbered 1.  */

# define  nestdepth 3

extern int ZjdGetAlignOffset();
extern int ZjdGetAlignStride();
extern int ZjdGetBlocksize();



struct LINE_EXPRESSION{
        int id;
	int increase;
        int soffset;
        int eoffset;
        int sstride[nestdepth];
        int estride[nestdepth];
        int addition;
                    /* addition==0 : no additional info . */
                    /* addition==1 : the begin part has additional info,soffset_a */
                    /* addition==2 : the end part has additional info,eoffset_a */
        int soffset_a;
        int eoffset_a;
        struct LINE_EXPRESSION * next;
        };

struct MESSAGE{
	int processor_id;
	struct LINE_EXPRESSION * ptr_line_expression;
	struct MESSAGE * next;
	};


struct PROCESSOR_ITERATION{
        struct LINE_EXPRESSION * iteration;
	struct LINE_EXPRESSION * send;
	struct LINE_EXPRESSION * recv;
	struct MESSAGE         * IN;
	struct MESSAGE         * OUT;
        struct PROCESSOR_ITERATION * next;
        };


struct EXPRESSION{
	int  expr_id;
	struct PROCESSOR_ITERATION * * iteration;
	struct EXPRESSION * next;
	};




typedef   struct LINE_EXPRESSION *  PTR_LINE_EXPRESSION;
typedef   struct PROCESSOR_ITERATION * *  PTR_PTR_PROCESSOR_ITERATION;
typedef   struct PROCESSOR_ITERATION *  PTR_PROCESSOR_ITERATION;




#include <stdio.h>
#include "tag"
#include "defs.h"
#include "ll.h"
#include "SiEList.h"
#include "SiFuns.h"




int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */

struct LINE_EXPRESSION * iteration=NULL;
int processor_num;
struct EXPRESSION *  expression=NULL;
struct EXPRESSION *  expression_nil=NULL;
ELIST procs;


struct LOOP{
	int loopnode_id;
	struct MESSAGE * message;
	struct LOOP * next;
	};

int assign_child_id;
struct LOOP * loop=NULL;
struct LOOP * loop_nil=NULL;



int pro_var_id,ENV_id; /* of addclause */
int call_stat1,call_stat2 ;  /* of addclause */


int executable_stmt();


struct llnd *
ZjdIdGetPtrLlnd();

PTR_PTR_PROCESSOR_ITERATION  
WorkIteration();

PTR_LINE_EXPRESSION
CopyIteration();

struct LINE_EXPRESSION *
SUB();

struct LINE_EXPRESSION *
AND();

struct LINE_EXPRESSION *
LLCopyIteration();

char *
ZjdCreatVarName();




main(argc, argv)
int argc;
char **argv;
{

        ELIST e, enames, subname;
        char * proj_name;
        int i, j;
        char *filename;

        iteration=NULL;

        proj_name = argv[1];
/*        printf("opening project: %s\n",proj_name);*/
        SiOpenProject(proj_name,proj_name);

        SiDoGlobalAnalysis();

        procs = SiGetProcIdList(proj_name);
 /*       printf("\n proc list:\n");*/
        enames =  SiGetProcList(proj_name);
  /*      SiUnparseEList(enames);*/
 /*       printf("start analysis\n");*/
        for(e = procs; e; e = SiECdr(e))
        {
                filename = SiECadar(enames);
 /*               printf("\nIn source file %s  and doing analysis for-\n",filename);*/

                subname = SiECddar(enames);
 /*               printf("subroutine =%s=\n",SiECar(subname));*/
                SiSelectFile(filename);
                instrument((int)SiECar(e));
                enames = SiECdr(enames);
        }

	ZjdGetLoopPartition(procs);

	ZjdAddClause(procs);

	printf("\n");
        printf("\n");
        printf("\n");

	SiUnparseEList(SiUnparseBlock((int)SiECar(procs)));

}


instrument(statement_id)

int statement_id;
{
        ELIST  children,branch;
        int    child_stmt,variant;

/*        SiUnparseEList(SiUnparseStmt(statement_id));   */ 
        variant=SiStmtVariant(statement_id);

        switch(variant)
        {
          case FOR_NODE:     /* basic loop node: "do" in Fortran */
               treatfornode(statement_id);
               break;
          case WHILE_NODE:   /* C while                          */
          case IF_NODE:      /* a if node with a "then"        */
          case ELSEIF_NODE:  /* a matching "else if ... "then" */
          case LOGIF_NODE:  /* an if without a then */
          case PROC_STAT:
          case PROG_HEDR:
          case PROC_HEDR:
          case FUNC_HEDR:

               children=SiControlChildren(statement_id);
               while(children)
               {
                   branch=(ELIST)SiECar(children);
                   while(branch)
                   {
                       child_stmt=(int)SiECar(branch);
                       instrument(child_stmt);
                       branch=SiECdr(branch);
                   }
                   children=SiECdr(children);
               }
               break;
          case ASSIGN_STAT:
               treatassignnode(statement_id);
               break;
          default:
               break;
        }

}


treatfornode(fornode_id)

int  fornode_id;

{
	
	int     i;
        ELIST   forchildren,loopbound,children,e;
	struct LINE_EXPRESSION * iteration_use, * iteration_temp;


/*   below to add this level to  iteration set  */


	iteration_use=(PTR_LINE_EXPRESSION)calloc(1,sizeof(struct LINE_EXPRESSION));
	iteration_use->id=0;
	iteration_use->increase=0;
	iteration_use->soffset=0;
	iteration_use->eoffset=0;
	iteration_use->addition=0;
	iteration_use->soffset_a=0;
	iteration_use->eoffset_a=0;
	for(i=0;i<nestdepth;i++)
	{
		iteration_use->sstride[i]=0;
		iteration_use->estride[i]=0;
	}
	iteration_use->next=NULL;

	iteration_use->id=(int)SiECar(SiInductionVars(fornode_id));
	loopbound=SiLoopBounds(fornode_id);
	ExpressionGetOffset((int)SiECar(loopbound),iteration_use->sstride,&iteration_use->soffset,1);
	ExpressionGetOffset((int)SiECadr(loopbound),iteration_use->estride,&iteration_use->eoffset,1);
        ExpressionGetOffset((int)SiECaddr(loopbound),NULL,&iteration_use->increase,1);
	if(iteration_use->increase==0)
		iteration_use->increase=1;

	
	if(!iteration)
	{
		iteration=iteration_use;
		iteration_temp=iteration;
	}
	else
	{
		iteration_temp=iteration;
		while(iteration_temp->next)
			iteration_temp=iteration_temp->next;
		iteration_temp->next=iteration_use;
	};

/*  below to handle  the childrens of this for_stmt  */


	forchildren=SiControlChildren(fornode_id);
	forchildren=(ELIST)SiECar(forchildren);
	e=forchildren;
	while(e)
	{
		instrument((int)SiECar(e));
		e=SiECdr(e);
	}

/* below to remove this level in the iteration set  */ 

	if(iteration->next==NULL)
	{
                struct LINE_EXPRESSION * iteration_show;
                int i;
                
                iteration_show=iteration;
/* if you want to show the nestloop at this point ,you should delete below line  */
		iteration_show=NULL;  

                while(iteration_show)
                {


                        printf("*******************\n");
			printf("do varible id= %d  ;increase= %d  ;soffset= %d  ;eoffset= %d ;addition= %d ;soffset_a= %d ;eoffset_a= %d ;\n",iteration_show->id,iteration_show->increase,iteration_show->soffset,iteration_show->eoffset,iteration_show->addition,iteration_show->soffset_a,iteration_show->eoffset_a);

                        for(i=0;i<nestdepth;i++)
                                printf("sstride[%d]= %d   ;  estride[%d]= %d   \n",i,iteration_show->sstride[i],i,iteration_show->estride[i]);

                        iteration_show=iteration_show->next;
		}



		ZjdCollectgarbage(iteration);
		iteration=NULL;
	}
	else
	{
		struct LINE_EXPRESSION * iteration_show;
		int i;
	
	
		iteration_show=iteration;
 	/* if you want to show the nestloop at this point ,you should delete below line  */
		iteration_show=NULL;	

		while(iteration_show)
		{


			printf("*******************\n");
			printf("do varible id= %d  ;increase= %d  ;soffset= %d  ;eoffset= %d" ,
					iteration_show->id,iteration_show->increase,iteration_show->soffset,
					iteration_show->eoffset);
			printf("addition= %d ;soffset_a= %d ;eoffset_a= %d ;\n",
					iteration_show->addition,iteration_show->soffset_a,
					iteration_show->eoffset_a);

			for(i=0;i<nestdepth;i++)
				printf("sstride[%d]= %d   ;  estride[%d]= %d   \n",
						i,iteration_show->sstride[i],i,iteration_show->estride[i]);

			iteration_show=iteration_show->next;
		}
	

	
		ZjdCollectgarbage(iteration_temp->next);
		iteration_temp->next=NULL;
	}
}

ZjdCollectgarbage(iteration)
struct LINE_EXPRESSION * iteration;
{
	return 0;
}

ExpressionGetOffset(expr_id,stride_ptr,offset_ptr,indicator)
int expr_id,indicator;
int stride_ptr[nestdepth];
int * offset_ptr;
{
	int expr_variant,l_child,r_child;
	ELIST child_expr;

/*      SiUnparseEList(SiUnparseExpr(expr_id));*/
	expr_variant=SiExprVariant(expr_id);
	l_child=SiGetLeftChild(expr_id);
	r_child=SiGetRightChild(expr_id);

	switch(expr_variant)
	{
		case ADD_OP:
			ExpressionGetOffset(l_child,stride_ptr,offset_ptr,1);
			ExpressionGetOffset(r_child,stride_ptr,offset_ptr,1);
			break;
		case SUBT_OP:
			ExpressionGetOffset(l_child,stride_ptr,offset_ptr,1);
                        ExpressionGetOffset(r_child,stride_ptr,offset_ptr,-1);
			break;
		case MINUS_OP:
			SiGetIntConstExpr(l_child,offset_ptr);
			(*offset_ptr)=indicator*(-1)*(*offset_ptr);
			break;
		case INT_VAL:
			SiGetIntConstExpr(expr_id,offset_ptr);
			break;
		case VAR_REF:
			{
				PTR_LINE_EXPRESSION  iteration_use;
                                int id,value,i;

                                id=SiVarId(expr_id);
				value=1*indicator;
				
				iteration_use=iteration;
                                i=0;
                                while(iteration_use)
                                {
                                        if(id==iteration_use->id)
                                                stride_ptr[i]=value;
                                        i++;
                                        iteration_use=iteration_use->next;
				}
			}


			break;
		case MULT_OP:
			if(SiExprVariant(r_child)==VAR_REF)
			{
				PTR_LINE_EXPRESSION  iteration_use;
				int id,value,i;
				
				id=SiVarId(r_child);
				if(SiExprVariant(l_child)==MINUS_OP)
				{
					SiGetIntConstExpr(SiGetLeftChild(l_child),&value);
					value=value*indicator*(-1);
				}
				else
				{
					SiGetIntConstExpr(l_child,&value);
					value=value*indicator;
				}
				
				iteration_use=iteration;
				i=0;
				while(iteration_use)
				{
					if(id==iteration_use->id)
						stride_ptr[i]=value;
					i++;
					iteration_use=iteration_use->next;
				}
			} /* if r_child is a variant */
			else/* if l_child is a variant */
			{
                                PTR_LINE_EXPRESSION  iteration_use;
                                int id,value,i;
                                
                                id=SiVarId(l_child);
                                if(SiExprVariant(r_child)==MINUS_OP)
                                {       
                                        SiGetIntConstExpr(SiGetLeftChild(r_child),&value);
                                        value=value*indicator*(-1);
                                }
                                else
                                {
                                        SiGetIntConstExpr(r_child,&value);
                                        value=value*indicator;
                                }
                                
                                iteration_use=iteration;
                                i=0;
                                while(iteration_use)
                                {
                                        if(id==iteration_use->id)
                                                stride_ptr[i]=value;
                                        i++;    
                                        iteration_use=iteration_use->next;
                                }
			}
	} /* end of switch  */


}


int  zdiv(a,b)
int a,b;
{
	if((a % b)==0)
		return(a /b);
	else
		return((a /b)+1); 
}

int  zmin(a,b)
int a,b;
{
        if(a < b)
                return a ;
        else
                return b ;
}

int  zmax(a,b)
int a,b;
{
        if(a > b)
                return a ;
        else
                return b ;
}




treatassignnode(assignnode_id)
int  assignnode_id;

{
         ELIST  assignnode_bothside;
	 int left_id,right_id;

         assignnode_bothside=(ELIST)SiGetBothSides(assignnode_id);
	 left_id=(int)SiECar(assignnode_bothside);
	 right_id=(int)SiECadr(assignnode_bothside);
	 
	 if(SiExprVariant(left_id)==VAR_REF && SiExprVariant(right_id)==INT_VAL)
	 {
/*		SiUnparseEList(SiUnparseExpr(left_id));    
		SiUnparseEList(SiUnparseExpr(right_id));     */
		
		if(!strcmp(SiVarIdent(SiVarId(left_id)),"processor_number"))
		{
			SiGetIntConstExpr(right_id,&processor_num);
			processor_num=processor_num-1;
		}
/*		if(!strcmp(SiVarIdent(SiVarId(left_id)),"array_length"))
                        SiGetIntConstExpr(right_id,&array_length);
                if(!strcmp(SiVarIdent(SiVarId(left_id)),"divided_dimension"))
                        SiGetIntConstExpr(right_id,&divided_dimension);
		note: If two strings are equal , then the return of strcmp() will be false(or 0)  */
                
	 }   
	 else
	 {
         	treatleftarray(left_id,assignnode_id);
         	treatrightarray(right_id,left_id,assignnode_id);
	 }
}


treatleftarray(arrayexpr_id,stmt_id)

int arrayexpr_id,stmt_id;
{
        struct  llnd * arrayllnd_ptr;
        int     i;



/*        SiUnparseEList(SiUnparseExpr(arrayexpr_id));*/
	if(!expression)
	{
		expression=(struct EXPRESSION *)calloc(1,sizeof(struct EXPRESSION));
		expression->next=NULL;
		expression->iteration=NULL;
		expression->expr_id=0;
		expression_nil=expression;
		
	}
	else 
	{
		expression_nil->next=(struct EXPRESSION *)calloc(1,sizeof(struct EXPRESSION));
		expression_nil=expression_nil->next;
		expression_nil->next=NULL;
                expression_nil->iteration=NULL;
                expression_nil->expr_id=0;

	}
	
	expression_nil->expr_id=arrayexpr_id;
	expression_nil->iteration=(PTR_PTR_PROCESSOR_ITERATION)WorkIteration(arrayexpr_id,stmt_id);

        /*  now we already get the iteration sets , below we'll show it  */

        {
                struct LINE_EXPRESSION * iteration_show;
		struct PROCESSOR_ITERATION * * ptr_ptr_processor;
                int  i,j;

                printf("\n");
                printf("*******************  for below  *********************\n");
                SiUnparseEList(SiUnparseStmt(stmt_id));
                SiUnparseEList(SiUnparseExpr(arrayexpr_id));

		ptr_ptr_processor=expression_nil->iteration;
                for(j=0;j<=processor_num;j++)
                        if(ptr_ptr_processor[j])
                        {
                                printf("*** ptr_ptr_processor[%d]***\n",j);
                                iteration_show=ptr_ptr_processor[j]->iteration;
                                while(iteration_show)
                                {
					int nostride,nofirst;

					printf("  %s = ",  SiVarIdent(iteration_show->id));
					nofirst=1;
					nostride=1;
					for(i=0;i<nestdepth;i++)
						if(iteration_show->sstride[i]!=0)
						{ 
							struct LINE_EXPRESSION	 * iteration_use;
							int t;
							
							nostride=0;
							iteration_use=iteration;
							for(t=0;t<i;t++)
								iteration_use=iteration_use->next;

							if(!nofirst)
								printf("+");
							printf("%d%s",iteration_show->sstride[i],SiVarIdent(iteration_use->id));

							nofirst=0;
								
						 }	
					if(nostride || iteration_show->soffset !=0)
						if(!nofirst && iteration_show->soffset>0)
							printf("+%d , ",iteration_show->soffset);
						else
							printf("%d , ",iteration_show->soffset);
					nofirst=1;
					nostride=1;
                                        for(i=0;i<nestdepth;i++)
                                                if(iteration_show->estride[i]!=0)
                                                { 
                                                        struct LINE_EXPRESSION  * iteration_use;
                                                        int t;
                                  
							nostride=0;                      
                                                        iteration_use=iteration;
                                                        for(t=0;t<i;t++)
        							iteration_use=iteration_use->next;

							if(!nofirst)
                                                                printf("+");
                                                        printf("%d%s",iteration_show->estride[i],SiVarIdent(iteration_use->id));

                                                        nofirst=0;

                                                                
                                                 }      
					if(nostride|| iteration_show->eoffset !=0)	
                                                if(!nofirst && iteration_show->eoffset>0)
                                        		printf("+%d  ",iteration_show->eoffset);
						else
							printf("%d  ",iteration_show->eoffset);
					if(iteration_show->increase>1)
						printf(", %d",iteration_show->increase);

                                        if(iteration_show->addition != 0)
                                                if(iteration_show->addition == 1)
                                                        printf("  && %s >=%d ",  SiVarIdent(iteration_show->id),iteration_show->soffset_a);
                                                else
                                                        printf("  && %s <=%d ",  SiVarIdent(iteration_show->id),iteration_show->eoffset_a);


					printf("\n");                                                                


      /*                                printf("do varible id= %d  ;increase= %d  ;soffset= %d  ;
							eoffset= %d ;addition= %d ;soffset_a= %d ;
							eoffset_a= %d ;\n",iteration_show->id,
							iteration_show->increase,iteration_show->soffset,
							iteration_show->eoffset,iteration_show->addition,
							iteration_show->soffset_a,iteration_show->eoffset_a);   
     */
                    /*                  for(i=0;i<nestdepth;i++)   */
                    /*                            printf("sstride[%d]= %d   ;  estride[%d]= %d   \n",
								i,iteration_show->sstride[i],i,
								iteration_show->estride[i]);                
		   */
                                        iteration_show=iteration_show->next;
                                }
                        }

        }

}


treatrightarray(expr_id,leftexpr_id,stmt_id)

int expr_id,leftexpr_id,stmt_id;

{       int     i,j,l_child,r_child;
	struct EXPRESSION *    left_expression;
	struct MESSAGE * message_use, * message_oldO, * message_oldI;


 /*       SiUnparseEList(SiUnparseExpr(expr_id));*/

	switch(SiExprVariant(expr_id))		
	{
		case ADD_OP:
		case DIV_OP:
		case MULT_OP:
		case SUBT_OP:
        		l_child=SiGetLeftChild(expr_id);
			r_child=SiGetRightChild(expr_id);
		        treatrightarray(l_child,leftexpr_id,stmt_id);
                        treatrightarray(r_child,leftexpr_id,stmt_id);
                        break;
		case ARRAY_REF:
 		        if(!expression)
      		        {
                		expression=(struct EXPRESSION *)calloc(1,sizeof(struct EXPRESSION));
                		expression->next=NULL;
                		expression->iteration=NULL;
                		expression->expr_id=0;
                		expression_nil=expression;
        		}
        		else
        		{
                		expression_nil->next=(struct EXPRESSION *)calloc(1,sizeof(struct EXPRESSION));
                		expression_nil=expression_nil->next;
                		expression_nil->next=NULL;
                		expression_nil->iteration=NULL;
                		expression_nil->expr_id=0;
        		}

        		expression_nil->expr_id=expr_id;
        		expression_nil->iteration=(PTR_PTR_PROCESSOR_ITERATION)WorkIteration(expr_id,stmt_id);
			
		/*****************  below to compute comunication *****************/		
			
			left_expression=expression;
			while(left_expression->expr_id != leftexpr_id)
				left_expression=left_expression->next;

			for (i=0;i<=processor_num;i++)
			{
				expression_nil->iteration[i]->send=SUB(expression_nil->iteration[i]->iteration,left_expression->iteration[i]->iteration);
				expression_nil->iteration[i]->recv=SUB(left_expression->iteration[i]->iteration,expression_nil->iteration[i]->iteration); 
				expression_nil->iteration[i]->IN=NULL;
				expression_nil->iteration[i]->OUT=NULL;
				
			}	
			for (i=0;i<=processor_num;i++)
				for (j=0;j<=processor_num;j++)
					if(j != i)
					{
						message_use=calloc(1,sizeof(struct MESSAGE));
						message_use->processor_id=j;
						message_use->next=NULL;
						message_use->ptr_line_expression=AND(expression_nil->iteration[i]->send,expression_nil->iteration[j]->recv);
						if(message_use->ptr_line_expression)
							if(! expression_nil->iteration[i]->OUT)
								expression_nil->iteration[i]->OUT=message_use;
							else
							{
								message_oldO=expression_nil->iteration[i]->OUT;
								while(message_oldO->next)
									message_oldO=message_oldO->next;
								message_oldO->next=message_use;
							}
		
						message_use=calloc(1,sizeof(struct MESSAGE));           
						message_use->processor_id=i;
						message_use->next=NULL;         
						message_use->ptr_line_expression=AND(expression_nil->iteration[i]->send,expression_nil->iteration[j]->recv);       
						if(message_use->ptr_line_expression)
							if(! expression_nil->iteration[j]->IN)         
                                                        	expression_nil->iteration[j]->IN=message_use;          
                                                	else            
                                                	{                
                                                        	message_oldI=expression_nil->iteration[j]->IN;
                                                        	while(message_oldI->next)
                                                                	message_oldI=message_oldI->next;
                                                        	message_oldI->next=message_use;
                                                	}               


					}	


			        /*  now we already get the right_iteration sets , below we'll show it  */

       			 	{
            		    		struct LINE_EXPRESSION * iteration_show;
					struct MESSAGE         * message_show;
				        struct PROCESSOR_ITERATION * * ptr_ptr_processor;
                			int  i,j;

                                        printf("\n");
                			printf("*********************  for below  *******************\n");
                			SiUnparseEList(SiUnparseStmt(stmt_id));
                			SiUnparseEList(SiUnparseExpr(expr_id));
					ptr_ptr_processor=expression_nil->iteration;
                			for(j=0;j<=processor_num;j++)
                        			if(ptr_ptr_processor[j])
                        			{
                                			iteration_show=ptr_ptr_processor[j]->iteration;
							if(iteration_show) printf("*** ptr_ptr_processor[%d]***\n",j);
                                			while(iteration_show)
                                			{
								int nostride,nofirst;
                                  
					      			printf("  %s = ",  SiVarIdent(iteration_show->id));
                                        			nofirst=1;
								nostride=1;
                                        			for(i=0;i<nestdepth;i++)
                                                			if(iteration_show->sstride[i]!=0)
                                                			{
                                                        			struct LINE_EXPRESSION   * iteration_use;
                                                        			int t;

										nostride=0;
                                                        			iteration_use=iteration;
                                                        			for(t=0;t<i;t++)
                                                                			iteration_use=iteration_use->next;

										if(!nofirst)
											printf("+");
                                                        			printf("%d%s",iteration_show->sstride[i],
												SiVarIdent(iteration_use->id));
										nofirst=0;

                                                 			}
								if(nostride|| iteration_show->soffset !=0)
									if(!nofirst && iteration_show->soffset>0)
                                        					printf("+%d , ",iteration_show->soffset);
									else
										printf("%d , ",iteration_show->soffset);
								nofirst=1;
								nostride=1;	
                                        			for(i=0;i<nestdepth;i++)
                                                			if(iteration_show->estride[i]!=0)
                                                			{
                                                        			struct LINE_EXPRESSION  * iteration_use;
                                                        			int t;

                                                        			nostride=0;
										iteration_use=iteration;
                                                        			for(t=0;t<i;t++)
                                                                			iteration_use=iteration_use->next;

										if(!nofirst)
											printf("+");
                                                        			printf("%d%s",iteration_show->estride[i],
												SiVarIdent(iteration_use->id));
										nofirst=0;

                                                 			}
								if(nostride|| iteration_show->eoffset !=0)
                                                                        if(!nofirst && iteration_show->eoffset>0)
										printf("+%d  ",iteration_show->eoffset);
									else
                                        					printf("%d  ",iteration_show->eoffset);
                                        			if(iteration_show->increase>1)
                                                			printf(", %d",iteration_show->increase);
                                        			if(iteration_show->addition != 0)
                                                			if(iteration_show->addition == 1)
                                                        			printf("  && %s >=%d ",  SiVarIdent(iteration_show->id),iteration_show->soffset_a);
                                                			else
                                                        			printf("  && %s <=%d ",  SiVarIdent(iteration_show->id),iteration_show->eoffset_a);


                                        			printf("\n");


                                        			iteration_show=iteration_show->next;
                                			}
                        			}
					printf("\n");
                                        printf("\n");
					printf("******** below is comunication sets ********\n");
                                        printf("\n");

                                        for(j=0;j<=processor_num;j++)
                                                if(ptr_ptr_processor[j])
                                                {
							if(ptr_ptr_processor[j]->send || ptr_ptr_processor[j]->recv)
                                                        	printf("*** ptr_ptr_processor[%d]***\n",j);
                                                        iteration_show=ptr_ptr_processor[j]->send;
							if(iteration_show) printf("******  send ******\n");
                                                        while(iteration_show)
                                                        {

                                        			printf("  %s = ",  SiVarIdent(iteration_show->id));
                                        			for(i=0;i<nestdepth;i++)
                                                			if(iteration_show->sstride[i]!=0)
                                                			{
                                                        			struct LINE_EXPRESSION   * iteration_use;
                                                        			int t;

                                                        			iteration_use=iteration;
                                                        			for(t=0;t<i;t++)
                                                                			iteration_use=iteration_use->next;

                                                        			printf("%d%s+",iteration_show->sstride[i],SiVarIdent(iteration_use->id));

                                                 			}
                                        			printf("%d , ",iteration_show->soffset);
                                        			for(i=0;i<nestdepth;i++)
                                                			if(iteration_show->estride[i]!=0)
                                                			{
                                                        			struct LINE_EXPRESSION  * iteration_use;
                                                        			int t;

                                                        			iteration_use=iteration;
                                                        			for(t=0;t<i;t++)
                                                                			iteration_use=iteration_use->next;

                                                        			printf("%d%s+",iteration_show->estride[i],SiVarIdent(iteration_use->id));

                                                 			}		
                                        			printf("%d  ",iteration_show->eoffset);
                                        			if(iteration_show->increase>1)
                                                			printf(", %d\n",iteration_show->increase);
                                        			else    printf("\n");


                                                                iteration_show=iteration_show->next;
                                                        }

                                                        iteration_show=ptr_ptr_processor[j]->recv;
							if(iteration_show) printf("***** recv *****\n");
                                                        while(iteration_show)
                                                        {

                                        			printf("  %s = ",  SiVarIdent(iteration_show->id));
                                        			for(i=0;i<nestdepth;i++)
                                                			if(iteration_show->sstride[i]!=0)
                                                			{
                                                        			struct LINE_EXPRESSION   * iteration_use;
                                                        			int t;

                                                        			iteration_use=iteration;
                                                        			for(t=0;t<i;t++)
                                                                			iteration_use=iteration_use->next;

                                                        			printf("%d%s+",iteration_show->sstride[i],SiVarIdent(iteration_use->id));

                                                 			}
                                        			printf("%d , ",iteration_show->soffset);
                                        			for(i=0;i<nestdepth;i++)
                                                			if(iteration_show->estride[i]!=0)
                                                			{
                                                        			struct LINE_EXPRESSION  * iteration_use;
                                                       	 			int t;

                                                        			iteration_use=iteration;
                                                        			for(t=0;t<i;t++)
                                                                			iteration_use=iteration_use->next;

                                                        			printf("%d%s+",iteration_show->estride[i],SiVarIdent(iteration_use->id));

                                                 			}
                                        			printf("%d  ",iteration_show->eoffset);
                                        			if(iteration_show->increase>1)
                                                			printf(", %d\n",iteration_show->increase);
                                        			else    printf("\n");


                                                                iteration_show=iteration_show->next;
                                                        }

							message_show=ptr_ptr_processor[j]->IN;
							if(message_show) printf("**** IN ****\n");
							while(message_show)
							{
								printf("processor_id= %d\n",message_show->processor_id);
								iteration_show=message_show->ptr_line_expression;
								while(iteration_show)
 	                                                        {

                                        				printf("  %s = ",  SiVarIdent(iteration_show->id));
                                        				for(i=0;i<nestdepth;i++)
                                                				if(iteration_show->sstride[i]!=0)
                                                				{
                                                        				struct LINE_EXPRESSION   * iteration_use;
                                                        				int t;

                                                        				iteration_use=iteration;
                                                        				for(t=0;t<i;t++)
                                                                				iteration_use=iteration_use->next;

                                                        				printf("%d%s+",iteration_show->sstride[i],SiVarIdent(iteration_use->id));

                                                 				}
                                        				printf("%d , ",iteration_show->soffset);
                                        				for(i=0;i<nestdepth;i++)
                                                				if(iteration_show->estride[i]!=0)
                                                				{
                                                        				struct LINE_EXPRESSION  * iteration_use;
                                                        				int t;

                                                        				iteration_use=iteration;
                                                        				for(t=0;t<i;t++)
                                                                				iteration_use=iteration_use->next;

                                                        				printf("%d%s+",iteration_show->estride[i],SiVarIdent(iteration_use->id));

                                                 				}
                                        				printf("%d  ",iteration_show->eoffset);
                                        				if(iteration_show->increase>1)
                                                				printf(", %d\n",iteration_show->increase);
                                        				else    printf("\n");


                                                                	iteration_show=iteration_show->next;
                                                        	}
								message_show=message_show->next;


							}

                                                        message_show=ptr_ptr_processor[j]->OUT;
							if(message_show) printf("***** OUT ****\n");
                                                        while(message_show)
                                                        {
                                                                printf("processor_id= %d\n",message_show->processor_id);
                                                                iteration_show=message_show->ptr_line_expression;
                                                                while(iteration_show)
                                                                {

                                        				printf("  %s = ",  SiVarIdent(iteration_show->id));
                                        				for(i=0;i<nestdepth;i++)
                                                				if(iteration_show->sstride[i]!=0)
                                                				{
                                                        				struct LINE_EXPRESSION   * iteration_use;
                                                        				int t;

                                                        				iteration_use=iteration;
                                                        				for(t=0;t<i;t++)
                                                                				iteration_use=iteration_use->next;

                                                        				printf("%d%s+",iteration_show->sstride[i],SiVarIdent(iteration_use->id));

                                                 				}
                                        				printf("%d , ",iteration_show->soffset);
                                        				for(i=0;i<nestdepth;i++)
                                                				if(iteration_show->estride[i]!=0)
                                                				{
                                                        				struct LINE_EXPRESSION  * iteration_use;
                                                        				int t;

                                                        				iteration_use=iteration;
                                                        				for(t=0;t<i;t++)
                                                                				iteration_use=iteration_use->next;

                                                        				printf("%d%s+",iteration_show->estride[i],SiVarIdent(iteration_use->id));

                                                 				}
                                        				printf("%d  ",iteration_show->eoffset);
                                        				if(iteration_show->increase>1)
                                                				printf(", %d\n",iteration_show->increase);
                                        				else    printf("\n");


                                                                        iteration_show=iteration_show->next;
                                                                }
                                                                message_show=message_show->next;


                                                        }


                                                }



        			}



			break;
		default:
			break;
	}
}


PTR_PTR_PROCESSOR_ITERATION  WorkIteration(expr_id,stmt_id)
int expr_id,stmt_id;
{
	int distributeddimension,align_offset,align_stride;
	struct LINE_EXPRESSION * expr_use;
	ELIST subscript,subscript_origin;
	int i,blocksize;
	struct PROCESSOR_ITERATION * * ptr_ptr_processor;
	

	distributeddimension=ZjdGetDistributedDimension(expr_id);
	align_offset=ZjdGetAlignOffset(expr_id);
	align_stride=ZjdGetAlignStride(expr_id);
	blocksize=ZjdGetBlocksize(expr_id);

	subscript=(ELIST)SiGetSubscript(stmt_id,expr_id);
	subscript_origin=subscript;

	for(i=1;i<distributeddimension;i++)
		subscript=SiECdr(subscript);
	subscript=(ELIST)SiECar(subscript);

	expr_use=(PTR_LINE_EXPRESSION)calloc(1,sizeof(struct LINE_EXPRESSION));
	expr_use->id=distributeddimension;
	expr_use->soffset=(int)SiECadr(subscript);
	expr_use->eoffset=0;
	expr_use->next=NULL;
	expr_use->addition=0;
	expr_use->soffset_a=0;
	expr_use->eoffset_a=0;
	subscript=(ELIST)SiECaddr(subscript);
	for(i=0;i<nestdepth;i++)
	{
		expr_use->estride[i]=0;
		if(subscript)
			expr_use->sstride[i]=(int)SiECar(subscript);
		else
			expr_use->sstride[i]=0;
		
		if(subscript)
			subscript=(ELIST)SiECdr(subscript);					
	}
        /* now we already get the subscript expression of the distributed array */
	/* below we'll show it */ 
	{
                struct LINE_EXPRESSION * iteration_show;
		int  i; 

                iteration_show=expr_use;
 /* if you want to show the nestloop at this point ,you should delete below line  */
		iteration_show=NULL;

                while(iteration_show)
                {


                        printf("*******************\n");
                        printf("do varible id= %d  ;soffset= %d  ;eoffset= %d ;addition= %d ;soffset_a= %d ;eoffset_a= %d ;\n",iteration_show->id,iteration_show->soffset,iteration_show->eoffset,iteration_show->addition,iteration_show->soffset_a,iteration_show->eoffset_a);

                        for(i=0;i<nestdepth;i++)
                                printf("sstride[%d]= %d   ;  estride[%d]= %d   \n",i,iteration_show->sstride[i],i,iteration_show->estride[i]);
                        iteration_show=iteration_show->next;
                }

	}
	

	SiEFree(subscript_origin);
	expr_use->soffset=expr_use->soffset*align_stride+align_offset;
	for(i=0;i<nestdepth;i++)                                                        
		expr_use->sstride[i]=expr_use->sstride[i]*align_stride;
        /* now we already get the adapted subscript expression according to align */
	/* below we'll show it */  



        {
                struct LINE_EXPRESSION * iteration_show;
                int  i; 

                iteration_show=expr_use;
 /* if you want to show the nestloop at this point ,you should delete below line  */
		iteration_show=NULL;

                while(iteration_show)
                {


                        printf("*******************\n");
                        printf("do varible id= %d  ;soffset= %d  ;eoffset= %d ;addition= %d ;soffset_a= %d ;eoffset_a= %d ;\n",iteration_show->id,iteration_show->soffset,iteration_show->eoffset,iteration_show->addition,iteration_show->soffset_a,iteration_show->eoffset_a);
                        for(i=0;i<nestdepth;i++)
                                printf("sstride[%d]= %d   ;  estride[%d]= %d   \n",i,iteration_show->sstride[i],i,iteration_show->estride[i]);
                        iteration_show=iteration_show->next;
                }

        }

        /* below we'll compute the iteration sets according to distributing direction */

 
        ptr_ptr_processor=(PTR_PTR_PROCESSOR_ITERATION)calloc(processor_num+1,sizeof(struct PROCESSOR_ITERATION * ));
        for(i=0;i<=processor_num;i++)
	{
                ptr_ptr_processor[i]=(PTR_PROCESSOR_ITERATION)calloc(1,sizeof(struct PROCESSOR_ITERATION));
		ptr_ptr_processor[i]->iteration=NULL;
		ptr_ptr_processor[i]->next=NULL;
		ptr_ptr_processor[i]->send=NULL;
		ptr_ptr_processor[i]->recv=NULL;
		ptr_ptr_processor[i]->IN=NULL;
		ptr_ptr_processor[i]->OUT=NULL;
	}


	if(expr_use->sstride[0]!=0 && expr_use->sstride[1]==0 && expr_use->sstride[2]==0)
	{
		int a,d,N,M,t1,t2,i,t1b,t2b;


		a=expr_use->sstride[0];
		d=expr_use->soffset;
		M=iteration->soffset;
		N=iteration->eoffset;

		
		if(a>0)
		{
			t1=(a * M +d-1)/blocksize;
			t2=(a * N +d-1)/blocksize;

                        t1b=t1;
                        t2b=t2;
                        /* keep t1b and t2b ,so as to find if the first point(related to t1b) is in the first machine */
                        /* and if the last point is in the last machine . */




                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  


			
			for(i=t1;i<=t2;i++)
			{
				ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

				ptr_ptr_processor[i]->iteration->soffset=zdiv(i*blocksize+1-d,a);
				ptr_ptr_processor[i]->iteration->eoffset=((i+1)*blocksize-d)/a;
				if(i==t1)
					ptr_ptr_processor[i]->iteration->soffset=M;
				if(i==t2 && i!=t1)
					ptr_ptr_processor[i]->iteration->eoffset=N;
			}
		}
		else
		{
			t1=(a * N +d-1)/blocksize;
			t2=(a * M +d-1)/blocksize;

                        t1b=t1;
                        t2b=t2;
                        /* keep t1b and k3b ,so as to find if the first point(related to t1b) is in the first machine */
                        /* and if the last point is in the last machine . */



                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  



			for(i=t1;i<=t2;i++)
                        {
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

				ptr_ptr_processor[i]->iteration->soffset=zdiv(-((i+1)*blocksize-d),-a);
                                ptr_ptr_processor[i]->iteration->eoffset=(-(i*blocksize+1-d)) /(-a);
                                if(i==t2 && i!=t1)
                                        ptr_ptr_processor[i]->iteration->soffset=M;
                                if(i==t1)
                                        ptr_ptr_processor[i]->iteration->eoffset=N;
                        }       
                }
	};/*along I aix */

	if(expr_use->sstride[0]==0 && expr_use->sstride[1]!=0 && expr_use->sstride[2]==0)
	{
		int a1,d1,a,d,N,M,M1,t1,t2,t3,temp,i;


                a=expr_use->sstride[1];
                d=expr_use->soffset;
		M=iteration->soffset;
                N=iteration->eoffset;
		M1=iteration->next->soffset;
		a1=iteration->next->estride[0];
		d1=iteration->next->eoffset;



                if(a>0)
                {
                        t1=(M1*a + d-1) /blocksize;
                        t2=(a*(a1 * N +d1)+d-1)/blocksize;
			t3=(a*(a1*M+d1)+d-1)/blocksize;


                        if(t2>t3)
                        {
                                temp=t2;
                                t2=t3;
                                t3=temp;
                        }






                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                  



                        for(i=t1;i<=t3;i++)
                        {
				
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

                                if(i>=t1 && i<=t2-1)
				{
					if(i!=t1)
						ptr_ptr_processor[i]->iteration->next->soffset=zdiv(i*blocksize+1-d, a);
					ptr_ptr_processor[i]->iteration->next->eoffset=((i+1)*blocksize-d) /a;
                                        ptr_ptr_processor[i]->iteration->next->estride[0]=0;
				}
                                if(i>=t2 && i!=t3)
				{	
					if(i!=t1)
						ptr_ptr_processor[i]->iteration->next->soffset=zdiv(i*blocksize+1-d, a);
					ptr_ptr_processor[i]->iteration->next->addition=2;
					ptr_ptr_processor[i]->iteration->next->eoffset_a=((i+1)*blocksize-d) /a;
				}	
				if(i==t3 && i!=t1)
				{
					ptr_ptr_processor[i]->iteration->next->soffset=zdiv(i*blocksize+1-d, a);
				}
                        }
                }
                else /* a<0 */
                {
                        t1=(a*(a1 * N +d1)+d-1)/blocksize;
                        t2=(a*(a1*M+d1)+d-1)/blocksize;
			t3=(M1 * a +d-1) /blocksize;

                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                    
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                    


                        if(t1>t2)
                        {
                                temp=t1;
                                t1=t2;
                                t2=temp;
                        }

                        for(i=t1;i<=t3;i++)
                        {
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);
                                
                                if(i==t1 && i!=t3)
                                        ptr_ptr_processor[i]->iteration->next->soffset=zdiv(-((i+1)*blocksize-d), -a);
                                if(i>t1 && i<=t2)
                                {
					if(i!=t3)
                                        	ptr_ptr_processor[i]->iteration->next->soffset=zdiv(-((i+1)*blocksize-d), -a);
					ptr_ptr_processor[i]->iteration->next->addition=2;
                                        ptr_ptr_processor[i]->iteration->next->eoffset_a=(-(i*blocksize+1-d)) /(-a);
                                }
                                if(i>t2 && i<=t3)
                                {
					if(i!=t3)
                                        	ptr_ptr_processor[i]->iteration->next->soffset=zdiv(-((i+1)*blocksize-d), -a);
                                        ptr_ptr_processor[i]->iteration->next->eoffset=(-(i*blocksize+1-d)) /(-a) ;
                                        ptr_ptr_processor[i]->iteration->next->estride[0]=0;
                                }
                        }/* end of for*/

                }/* end of else */
        };/*along J aix */



        if(expr_use->sstride[0]==0 && expr_use->sstride[1]==0 && expr_use->sstride[2]!=0)
        {
                int a1,d1,a2,b2,d2,N,M,M1,M2,a3,d3,t1,t2,t3,temp,i,t4,t5,tmin,tmax;

                M=iteration->soffset;
                N=iteration->eoffset;
                a1=iteration->next->estride[0];
                d1=iteration->next->eoffset;
		M1=iteration->next->soffset;
		a2=iteration->next->next->estride[0];
		b2=iteration->next->next->estride[1];
		d2=iteration->next->next->eoffset;
		M2=iteration->next->next->soffset;
		a3=expr_use->sstride[2];
		d3=expr_use->soffset;




                if(a3>0)
                {
			t1=(a3*M2+d3-1) /blocksize;
			t2=((a2*M+b2*(a1*M+d1)+d2)*a3+d3-1) /blocksize;
			t3=((a2*N+b2*(a1*N+d1)+d2)*a3+d3-1) /blocksize;
                        t4=((a2*M+b2*M1+d2)*a3+d3-1) /blocksize;
                        t5=((a2*N+b2*M1+d2)*a3+d3-1) /blocksize;

			tmin=t2;
			if(t3<tmin) tmin=t3;
			if(t4<tmin) tmin=t4;
			if(t5<tmin) tmin=t5;
			tmax=t2;
                        if(t3>tmax) tmax=t3;
                        if(t4>tmax) tmax=t4;
                        if(t5>tmax) tmax=t5;

			t2=tmin;
			t3=tmax;

                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                  


			if(t1==t2 && t2==t3)
			{
				ptr_ptr_processor[t2]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);
				
			}
			if(t1==t2 && t2!=t3 )	
			{
                                for(i=t2;i<=t3;i++)
                                {
                                        ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);
        
                                        if(i<t3)
                                        {
                                                if(i!=t2)
                                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                                ptr_ptr_processor[i]->iteration->next->next->addition=2;
                                                ptr_ptr_processor[i]->iteration->next->next->eoffset_a=((i+1)*blocksize-d3) /a3;
                                        }
					else
                                                ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                }
				
			}
			if(t1!=t2 && t2==t3)
			{
                                for(i=t1;i<=t3;i++)
                                {
                                        ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

                                        if(i<t3)
                                        {
                                                if(i!=t1)
                                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                                ptr_ptr_processor[i]->iteration->next->next->eoffset=((i+1)*blocksize-d3) /a3;
                                                ptr_ptr_processor[i]->iteration->next->next->estride[0]=0;
                                                ptr_ptr_processor[i]->iteration->next->next->estride[1]=0;

                                        }
					else
                                                ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                }

			}
			if(t1!=t2 && t2!=t3)
			{
	                        for(i=t1;i<=t3;i++)
        	                {
                	                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);
	
        	                        if(i>=t1 && i<t2)
                	                {
						if(i!=t1)
                                	        	ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                        	ptr_ptr_processor[i]->iteration->next->next->eoffset=((i+1)*blocksize-d3) /a3;
                                        	ptr_ptr_processor[i]->iteration->next->next->estride[0]=0;
                                        	ptr_ptr_processor[i]->iteration->next->next->estride[1]=0;

 	                               	}

 	                               	if(i>=t2 && i<t3)
        	                        {
						if(i!=t1)
                        	                	ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                	        ptr_ptr_processor[i]->iteration->next->next->addition=2;
                                        	ptr_ptr_processor[i]->iteration->next->next->eoffset_a=((i+1)*blocksize-d3) /a3;
                                	}
                	                if(i==t3 && i!=t1)
        	                                ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                        	}
			}
                }
		else /* a3<0 */
		{
			t1=((a2*M+b2*M1+d2)*a3+d3-1)/blocksize;
			t2=((a2*M+b2*(a1*M+d1)+d2)*a3+d3-1)/blocksize;
			t3=((a2*N+b2*(a1*N+d1)+d2)*a3+d3-1) /blocksize;
			if(t2<t3)
				t2=t3;
			t3=(a3*M2+d3-1)/blocksize;


                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                  


                        for(i=t1;i<=t3;i++)
                        {
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

                                if(i==t1 && i!=t3)
                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                if(i>t1 && i<=t2)
                                {
					if(i!=t3)
                                        	ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                        ptr_ptr_processor[i]->iteration->next->next->addition=2;
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset_a=(-(i*blocksize+1-d3)) /(-a3);
                                }
                                if(i>t2 && i<=t3)
                                {
					if(i!=t3)
                                        	ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset=(-(i*blocksize+1-d3)) /(-a3) ;
                                        ptr_ptr_processor[i]->iteration->next->next->estride[0]=0;
					ptr_ptr_processor[i]->iteration->next->next->estride[1]=0;
                                }
                        }/* end of for*/

                }/* end of else */
        };/*along K aix */


	if(expr_use->sstride[2]==0 && expr_use->sstride[1]!=0 && (expr_use->sstride[0]==(-expr_use->sstride[1]*iteration->next->estride[0])))
	{
	
                int a1,d1,a2,b2,d2,N,M,M1,M2,a3,d3,t1,t2,t3,temp,i;

		M=iteration->soffset;
                N=iteration->eoffset;
                a1=iteration->next->estride[0];
                d1=iteration->next->eoffset;
		M1=iteration->next->soffset;
                a2=iteration->next->next->estride[0];
                b2=iteration->next->next->estride[1];
                d2=iteration->next->next->eoffset;
		M2=iteration->next->next->soffset;
                a3=expr_use->sstride[1];
                d3=expr_use->soffset;



                if(a3>0)
                {
			t1=((M1-a1*M)*a3+d3-1) /blocksize;
			t2=(a3*(a1*M+d1-a2*M)+d3-1) /blocksize;
			t3=(-a3*a1*N+d3-1) /blocksize;
			if(t2>t3)
			{
				temp=t2;
				t2=t3;
				t3=temp;
			}


                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                  


                        for(i=t1;i<=t3;i++)
                        {
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

                                if(i==t1)
                                        ptr_ptr_processor[i]->iteration->next->eoffset=((i+1)*blocksize-d3) /a3;
                                if(i>t1 && i<=t2)
                                {
                                        ptr_ptr_processor[i]->iteration->next->soffset=zdiv(i*blocksize+1-d3, a3);
					ptr_ptr_processor[i]->iteration->next->sstride[0]=a1;
					ptr_ptr_processor[i]->iteration->next->addition=1;
					ptr_ptr_processor[i]->iteration->next->soffset_a=M1;
                                        ptr_ptr_processor[i]->iteration->next->eoffset=((i+1)*blocksize-d3) /a3;

                                }
                                if(i>t2 && i<t3)
                                {
                                        ptr_ptr_processor[i]->iteration->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                        ptr_ptr_processor[i]->iteration->next->sstride[0]=a1;
                                        ptr_ptr_processor[i]->iteration->next->eoffset=((i+1)*blocksize-d3) /a3;
                                }
                                if(i==t3 && i!=t1)
				{
                                        ptr_ptr_processor[i]->iteration->next->soffset=zdiv(i*blocksize+1-d3, a3);
					ptr_ptr_processor[i]->iteration->next->sstride[0]=a1;
				}
                        }
		}
		else /*  a3 < 0  */
		{
			t3=((M1-a1*M)*a3+d3-1)/blocksize;
			t1=(a3*(a1*M+d1-a2*M)+d3-1)/blocksize ;
			t2=(-a3*a1*N+d3-1) /blocksize;
			if(t1>t2)
			{
				temp=t1;
				t1=t2;
				t2=temp;
			}


                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                  


                        for(i=t1;i<=t3;i++)
                        {
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

                                if(i==t1)
				{
                                        ptr_ptr_processor[i]->iteration->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
					ptr_ptr_processor[i]->iteration->next->sstride[0]=a1;
				}
                                if(i>t1 && i<t2)
                                {
                                        ptr_ptr_processor[i]->iteration->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                        ptr_ptr_processor[i]->iteration->next->sstride[0]=a1;
                                        ptr_ptr_processor[i]->iteration->next->eoffset=(-(i*blocksize+1-d3)) /(-a3);
                                }
                                if(i>=t2 && i<t3)
                                {
                                        ptr_ptr_processor[i]->iteration->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
					ptr_ptr_processor[i]->iteration->next->sstride[0]=a1;
					ptr_ptr_processor[i]->iteration->next->addition=1;
					ptr_ptr_processor[i]->iteration->next->soffset_a=M1;
                                        ptr_ptr_processor[i]->iteration->next->eoffset=(-(i*blocksize+1-d3)) /(-a3) ;
                                }
                                if(i==t3 && i!=t1)
                                        ptr_ptr_processor[i]->iteration->next->eoffset=(-(i*blocksize+1-d3)) / (-a3);
                        }/* end of for*/

                }/* end of else */
        };/*along xie J aix */

			
	if(expr_use->sstride[2]!=0 && (expr_use->sstride[0]==-expr_use->sstride[2]*iteration->next->next->estride[0]) && (expr_use->sstride[1]==-expr_use->sstride[2]*iteration->next->next->estride[1]) && (iteration->next->next->estride[1]!=0 ||iteration->next->next->estride[0]!=0))

{
                int a1,d1,a2,b2,d2,N,M,M1,M2,a3,d3,t1,t2,t3,temp,i,t1b,t3b;

		M=iteration->soffset;
                N=iteration->eoffset;
                a1=iteration->next->estride[0];
                d1=iteration->next->eoffset;
		M1=iteration->next->soffset;
                a2=iteration->next->next->estride[0];
                b2=iteration->next->next->estride[1];
                d2=iteration->next->next->eoffset;
		M2=iteration->next->next->soffset;
                a3=expr_use->sstride[2];
                d3=expr_use->soffset;



		if(a3>0)
		{
			t3=(a3*d2+d3-1)/blocksize;
			t1=(a3*(M2-a2*M-b2*M1)+d3-1)/blocksize;
			t2=(a3*(M2-a2*M-b2*(a1*M+d1))+d3-1) /blocksize;
			if(t1>t2)
			{
				temp=t1;
				t1=t2;
				t2=temp;
			}
			temp=(a3*(M2-a2*N-b2*M1)+d3-1) /blocksize;
			if(t1>temp)
				t1=temp;
			if(t2<temp)
				t2=temp;
			temp=(a3*(M2-a2*N-b2*(a1*N+d1))+d3-1) /blocksize;
			if(t1>temp)
                                t1=temp;
                        if(t2<temp)
                                t2=temp;


			t1b=t1;
			t3b=t3;
			/* keep t1b and k3b ,so as to find if the first point(related to t1b) is in the first machine */
			/* and if the last point is in the last machine . */

                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                  


			
                        for(i=t1;i<=t3;i++)
                        {
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

                                if(i==t1)
				{
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset=((i+1)*blocksize-d3) /a3;
					if(i!=t1b)
					{
						ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
						ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        	ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
                                        	ptr_ptr_processor[i]->iteration->next->next->addition=1;
                                        	ptr_ptr_processor[i]->iteration->next->next->soffset_a=M2;
					}

				}
                                if(i>t1 && i<=t2)
                                {
                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
                                        ptr_ptr_processor[i]->iteration->next->next->addition=1;
                                        ptr_ptr_processor[i]->iteration->next->next->soffset_a=M2;
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset=((i+1)*blocksize-d3) /a3;

                                }
                                if(i>t2 && i<t3)
                                {
                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset=((i+1)*blocksize-d3) /a3;
                                }
                                if(i==t3 && i!=t1)
                                {
                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(i*blocksize+1-d3, a3);
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
					if(i!=t3b)
						ptr_ptr_processor[i]->iteration->next->next->eoffset=((i+1)*blocksize-d3) /a3;
                                }
                        }
                }
		else /* a3<0 */
		{

                        t1=(a3*d2+d3-1)/blocksize;
                        t2=(a3*(M2-a2*M-b2*M1)+d3-1) /blocksize;
                        t3=(a3*(M2-a2*M-b2*(a1*M+d1))+d3-1) /blocksize;
                        if(t2>t3)
                        {
                                temp=t2;
                                t2=t3;
                                t3=temp;
                        }
                        temp=(a3*(M2-a2*N-b2*M1)+d3-1) /blocksize;
                        if(t2>temp)
                                t2=temp;
                        if(t3<temp)
                                t3=temp;
                        temp=(a3*(M2-a2*N-b2*(a1*N+d1))+d3-1) /blocksize;
                        if(t2>temp)
                                t2=temp;
                        if(t3<temp)
                                t3=temp;


                        t1b=t1;
                        t3b=t3;
                        /* keep t1b and k3b ,so as to find if the first point(related to t1b) is in the first machine */
                        /* and if the last point is in the last machine . */


                        t1=zmax(t1,0);
                        t1=zmin(t1,processor_num);                    
                        t2=zmax(t2,0);
                        t2=zmin(t2,processor_num);                  
                        t3=zmax(t3,0);
                        t3=zmin(t3,processor_num);                  




                        for(i=t1;i<=t3;i++)
                        {
                                ptr_ptr_processor[i]->iteration=(PTR_LINE_EXPRESSION)CopyIteration(iteration);

                                if(i==t1)
                                {
                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
					if(i!=t1b)
						ptr_ptr_processor[i]->iteration->next->next->eoffset=(-(i*blocksize+1-d3)) /(-a3);
                                }
                                if(i>t1 && i<t2)
                                {
                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset=(-(i*blocksize+1-d3)) /(-a3);
                                }
                                if(i>=t2 && i<t3)
                                {
                                        ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
                                        ptr_ptr_processor[i]->iteration->next->next->addition=1;
                                        ptr_ptr_processor[i]->iteration->next->next->soffset_a=M2;
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset=(-(i*blocksize+1-d3)) /(-a3) ;
                                }
                                if(i==t3 && i!=t1)
				{
                                        ptr_ptr_processor[i]->iteration->next->next->eoffset=(-(i*blocksize+1-d3)) / (-a3);
					if(i!=t3b)
					{
						ptr_ptr_processor[i]->iteration->next->next->soffset=zdiv(-((i+1)*blocksize-d3), -a3);
                                        	ptr_ptr_processor[i]->iteration->next->next->sstride[0]=a2;
                                        	ptr_ptr_processor[i]->iteration->next->next->sstride[1]=b2;
                                        	ptr_ptr_processor[i]->iteration->next->next->addition=1;
                                        	ptr_ptr_processor[i]->iteration->next->next->soffset_a=M2;

					}
				}
                        }/* end of for*/

                }/* end of else */
        };/*along xie K aix */

	/*  now we already get the iteration sets , below we'll show it  */

/*	{*/
 /*               struct LINE_EXPRESSION * iteration_show;*/
  /*              int  i,j;*/
		
	/*	printf("*******************  for below  ************\n");*/
	 /*       SiUnparseEList(SiUnparseStmt(stmt_id));  */
          /*      SiUnparseEList(SiUnparseExpr(expr_id));*/  

	/*	for(j=0;j<=processor_num;j++)*/
		/*	if(ptr_ptr_processor[j])*/
	/*		{*/
		/*		printf("*******************  ptr_ptr_processor[%d]************\n",j);*/
                /*		iteration_show=ptr_ptr_processor[j]->iteration;*/
         	 /*   	        while(iteration_show)*/
                /*		{*/


	/*				printf("id= %d  ;soffset= %d  ;eoffset= %d ;addition= %d ;soffset_a= %d ;eoffset_a= %d ;\n",iteration_show->id,iteration_show->soffset,iteration_show->eoffset,iteration_show->addition,iteration_show->soffset_a,iteration_show->eoffset_a);*/
	/**/
        	/*	                for(i=0;i<nestdepth;i++)*/
                /*		                printf("sstride[%d]= %d   ;  estride[%d]= %d   \n",i,iteration_show->sstride[i],i,iteration_show->estride[i]);*/
                  /*      		iteration_show=iteration_show->next;*/
               	/*	 	}*/
		/*	}*/

/*	}*/


	return ptr_ptr_processor;

}


struct llnd *
ZjdIdGetPtrLlnd(arrayexpr_id)
int arrayexpr_id;
{
	PTR_LLND  ll;
	
	if(ll=FindLLNode(arrayexpr_id))
		return ll;
	else 
		return NULL;

}




PTR_LINE_EXPRESSION
CopyIteration(ptr_a)
PTR_LINE_EXPRESSION ptr_a;
{
	PTR_LINE_EXPRESSION iteration_use, iteration_temp,iteration_origin;
	int i;

	iteration_origin=NULL;
	if(!ptr_a)
		iteration_use=iteration;
	else
		iteration_use=ptr_a;

	while(iteration_use)
	{
		if(!iteration_origin)
		{
			iteration_origin=(PTR_LINE_EXPRESSION)calloc(1,sizeof(struct LINE_EXPRESSION));
			iteration_temp=iteration_origin;
		}
		else
		{
			iteration_temp->next=(PTR_LINE_EXPRESSION)calloc(1,sizeof(struct LINE_EXPRESSION));
			iteration_temp=iteration_temp->next;
		}

		iteration_temp->id=iteration_use->id;
		iteration_temp->increase=iteration_use->increase;
		iteration_temp->soffset=iteration_use->soffset;
		iteration_temp->eoffset=iteration_use->eoffset;
		iteration_temp->addition=iteration_use->addition;
		iteration_temp->soffset_a=iteration_use->soffset_a;
		iteration_temp->eoffset_a=iteration_use->eoffset_a;
		for(i=0;i<nestdepth;i++)
		{
			iteration_temp->sstride[i]=iteration_use->sstride[i];
			iteration_temp->estride[i]=iteration_use->estride[i];
		}
		iteration_temp->next=NULL;

		iteration_use=iteration_use->next;
	}
	return(iteration_origin);
}






struct LINE_EXPRESSION *
SUB(ptr_a,ptr_b)
struct LINE_EXPRESSION * ptr_a , * ptr_b;
{
        struct LINE_EXPRESSION * ptr_line_expression=NULL,* ptr_line_expression_use,* ptr_line_expression_temp;
	int equal_num=0,depth=0,sub_num=0;

        if(ptr_b==NULL) 
	{
		ptr_line_expression=CopyIteration(ptr_a);
		return ptr_line_expression;
	}

        ptr_line_expression=(PTR_LINE_EXPRESSION)CopyIteration(ptr_a);
        ptr_line_expression_use=ptr_line_expression;

        while(ptr_a && ptr_b)
        {
		depth++;

                if(ZjdIntStrEqu(ptr_a->sstride,ptr_b->sstride,nestdepth))
	                if(ZjdIntStrEqu(ptr_a->estride,ptr_b->estride,nestdepth))
			{
				if(ZjdIntStrEqu(ptr_a->sstride,ptr_a->estride,nestdepth))
				{
					if((ptr_a->soffset < ptr_b->soffset) && (ptr_b->eoffset >=ptr_a->eoffset))
						if((ptr_a->addition==0) && (ptr_b->addition==0))
						{
							sub_num++;
							ptr_line_expression_use->eoffset=zmin(ptr_b->soffset-1,ptr_a->eoffset);
						}
					if((ptr_a->soffset>=ptr_b->soffset) && (ptr_b->eoffset<ptr_a->eoffset))
						if((ptr_a->addition==0) && (ptr_b->addition==0))
                                                {
                                                        sub_num++;
                                                        ptr_line_expression_use->soffset=zmax(ptr_b->eoffset+1,ptr_a->soffset);
                                                }

				}	
				/* if the to line_expression is equal ,then add 1 to 'equal_num'   */
				if((ptr_a->soffset==ptr_b->soffset) && (ptr_a->eoffset==ptr_b->eoffset))   
					if((ptr_a->addition==ptr_b->addition) && (ptr_a->soffset_a==ptr_b->soffset_a) && (ptr_a->eoffset_a==ptr_b->eoffset_a))
					{
						equal_num++;
					}
			}

                ptr_a=ptr_a->next;
                ptr_b=ptr_b->next;
                ptr_line_expression_use=ptr_line_expression_use->next;
	}
	
	if(ptr_b) 
		return NULL;
	if(equal_num==depth)
		return NULL; /* this do should be NULL */ 
	if((sub_num==1) && ((equal_num+sub_num)==depth) )
		return ptr_line_expression;
	return NULL;

}


struct LINE_EXPRESSION *
AND(ptr_a,ptr_b)
struct LINE_EXPRESSION * ptr_a , * ptr_b;
{
        struct LINE_EXPRESSION * ptr_line_expression=NULL,* ptr_line_expression_use,* ptr_line_expression_temp;
        int equal_num=0,depth=0,and_num=0;

        if((ptr_b==NULL) || (ptr_a==NULL))
        {
                return NULL;
        }

        ptr_line_expression=(PTR_LINE_EXPRESSION)CopyIteration(ptr_a);
        ptr_line_expression_use=ptr_line_expression;

        while(ptr_a && ptr_b)
        {
                depth++;

                if(ZjdIntStrEqu(ptr_a->sstride,ptr_b->sstride,nestdepth))
                        if(ZjdIntStrEqu(ptr_a->estride,ptr_b->estride,nestdepth))
                        {
                                if(!((ptr_a->soffset==ptr_b->soffset) && (ptr_a->eoffset==ptr_b->eoffset)))
                                	if(ZjdIntStrEqu(ptr_a->sstride,ptr_a->estride,nestdepth))
                                	{
                                        	if(!(ptr_a->soffset > ptr_b->eoffset || ptr_b->soffset > ptr_a->eoffset)) 
                                                	if((ptr_a->addition==0) && (ptr_b->addition==0))
                                                	{
                                                        	and_num++;
                                                        	ptr_line_expression_use->soffset=zmax(ptr_b->soffset,ptr_a->soffset);
                                                        	ptr_line_expression_use->eoffset=zmin(ptr_b->eoffset,ptr_a->eoffset);
                                                	}

                                	}
                                /* if the to line_expression is equal ,then add 1 to 'equal_num'   */
                                if((ptr_a->soffset==ptr_b->soffset) && (ptr_a->eoffset==ptr_b->eoffset))
                                        if((ptr_a->addition==ptr_b->addition) && (ptr_a->soffset_a==ptr_b->soffset_a) && (ptr_a->eoffset_a==ptr_b->eoffset_a))
                                        {
                                                equal_num++;
                                        }
                        }

                ptr_a=ptr_a->next;
                ptr_b=ptr_b->next;
                ptr_line_expression_use=ptr_line_expression_use->next;

        }

        if(ptr_b)
		return NULL;
        if((equal_num+and_num)==depth) 
                return ptr_line_expression;

	return NULL;
}




/*struct LINE_EXPRESSION **/
/*AND(ptr_a,ptr_b)*/
/*struct LINE_EXPRESSION * ptr_a , * ptr_b;*/
/*{*/
/*	struct LINE_EXPRESSION * ptr_line_expression=NULL,* ptr_line_expression_use,* ptr_line_expression_temp;*/
	
/*	if((ptr_a==NULL) || (ptr_b==NULL))*/
	/*	return NULL;*/
	
/*	ptr_line_expression=(PTR_LINE_EXPRESSION)CopyIteration(ptr_a);*/
	/*ptr_line_expression_use=ptr_line_expression;*/
	

	/*while(ptr_a && ptr_b)*/
	/*{*/
		/*if(ZjdIntStrEqu(ptr_a->sstride,ptr_b->sstride,nestdepth))*/	
		/*	ptr_line_expression_use->soffset=zmax(ptr_a->soffset,ptr_b->soffset);*/
	/*	else return NULL;*/
		/*if(ZjdIntStrEqu(ptr_a->estride,ptr_b->estride,nestdepth))*/
               /*         ptr_line_expression_use->eoffset=zmin(ptr_a->eoffset,ptr_b->eoffset);*/
               /* else return NULL;*/
	/*	if(ptr_a->addition==ptr_b->addition)*/
	/*	{*/
		/*	if(ptr_a->addition==1)*/
		/*	{*/
		/*		ptr_line_expression_use->soffset_a=zmax(ptr_a->soffset_a,ptr_b->soffset_a);*/
		/*	}*/
		/*	else*/
	/*		{*/
		/*		if(ptr_a->addition==2)*/
			/*		ptr_line_expression_use->eoffset=zmin(ptr_a->eoffset_a,ptr_b->eoffset_a);*/
		/*	}*/
	/*	}*/
	/*	else*/
	/*	{*/
	/*		if(ptr_a->addition==0)*/
	/*		{*/
	/*			ptr_line_expression_use->addition=ptr_b->addition;*/
	/*			ptr_line_expression_use->soffset_a=ptr_b->soffset_a;*/
	/*			ptr_line_expression_use->eoffset_a=ptr_b->eoffset_a;*/

	/*		}*/
	/*		else*/
	/*		{*/
	/*			if(ptr_b->addition==0)*/
		/*		{*/
			/*		ptr_line_expression_use->addition=ptr_a->addition;*/
			/*		ptr_line_expression_use->soffset_a=ptr_a->soffset_a;*/
			/*		ptr_line_expression_use->eoffset_a=ptr_a->eoffset_a;*/
			/*	}*/

/*				else  return NULL;*//* we can add a addition ,and this condition can no longer be NULL */
	/*		}*/
	/*	}*/
		
	/*	ptr_a=ptr_a->next;*/
	/*	ptr_b=ptr_b->next;*/
	/*	ptr_line_expression_temp=ptr_line_expression_use;*/
	/*	ptr_line_expression_use=ptr_line_expression_use->next;*/
		
/*	}*/
/*	ptr_line_expression_temp->next=NULL;*/
	
/*	return NULL;*/
/*}*/


ZjdIntStrEqu(a,b,length)
int * a,* b,length;
{
	int i;
		
	for(i=0;i<length;i++) 
		if(a[i]!=b[i]) return 0;
	return 1;
}


ZjdGetLoopPartition(procs)
ELIST procs;

{
        ELIST e;
        char *filename;

        for(e = procs; e; e = SiECdr(e))
        {
                Linstrument((int)SiECar(e));
        }
	


}

Linstrument(statement_id)

int statement_id;
{
        ELIST  children,branch;
        int    child_stmt,variant;

/*        SiUnparseEList(SiUnparseStmt(statement_id));  */  
        variant=SiStmtVariant(statement_id);

        switch(variant)
        {
          case FOR_NODE:     /* basic loop node: "do" in Fortran */
               Ltreatfornode(statement_id);
               break;
          case WHILE_NODE:   /* C while                          */
          case IF_NODE:      /* a if node with a "then"        */
          case ELSEIF_NODE:  /* a matching "else if ... "then" */
          case  LOGIF_NODE:  /* an if without a then */
          case PROC_STAT:
          case PROG_HEDR:
          case PROC_HEDR:
          case FUNC_HEDR:

               children=SiControlChildren(statement_id);
               while(children)
               {
                   branch=(ELIST)SiECar(children);
                   while(branch)
                   {
                       child_stmt=(int)SiECar(branch);
                       Linstrument(child_stmt);
                       branch=SiECdr(branch);
                   }
                   children=SiECdr(children);
               }
               break;
          case ASSIGN_STAT:
          default:
               break;
        }

}


Ltreatfornode(fornode_id)

int  fornode_id;

{
        
        int     variant,i,equal,assign_child_num,left_expression_id,iteration_var_id;
        ELIST   forchildren,loopbound,children,e,assignnode_bothside;
        struct MESSAGE * message_use, * message_temp;
	struct EXPRESSION *  expression_use;
        struct LINE_EXPRESSION * iteration_use, * iteration_temp;


/*	SiUnparseEList(SiUnparseStmt(fornode_id));   */

/*   below to add this level to  iteration set  */


        iteration_use=(PTR_LINE_EXPRESSION)calloc(1,sizeof(struct LINE_EXPRESSION));
        iteration_use->id=0;
        iteration_use->increase=0;
        iteration_use->soffset=0;
        iteration_use->eoffset=0;
        iteration_use->addition=0;
        iteration_use->soffset_a=0;
        iteration_use->eoffset_a=0;
        for(i=0;i<nestdepth;i++)
        {
                iteration_use->sstride[i]=0;
                iteration_use->estride[i]=0;
        }
        iteration_use->next=NULL;

        iteration_use->id=(int)SiECar(SiInductionVars(fornode_id));
        loopbound=SiLoopBounds(fornode_id);
        ExpressionGetOffset((int)SiECar(loopbound),iteration_use->sstride,&iteration_use->soffset,1);
        ExpressionGetOffset((int)SiECadr(loopbound),iteration_use->estride,&iteration_use->eoffset,1);
        ExpressionGetOffset((int)SiECaddr(loopbound),NULL,&iteration_use->increase,1);
        if(iteration_use->increase==0)
                iteration_use->increase=1;


        if(!iteration)
        {
                iteration=iteration_use;
                iteration_temp=iteration;
        }
        else
        {
                iteration_temp=iteration;
                while(iteration_temp->next)
                        iteration_temp=iteration_temp->next;
                iteration_temp->next=iteration_use;
        };



/*   below to annex the partition infor within a for_stmt  */ 

	assign_child_num=0;

        forchildren=SiControlChildren(fornode_id);
        forchildren=(ELIST)SiECar(forchildren);
        e=forchildren;
	while(e)
	{
        	variant=SiStmtVariant((int)SiECar(e));
		switch(variant)
        	{
          	case FOR_NODE:     /* basic loop node: "do" in Fortran */
               		assign_child_num+=Ltreatfornode((int)SiECar(e));
               		break;
          	case ASSIGN_STAT:
			assign_child_num++;	
			assign_child_id=(int)SiECar(e);
               		break;
		case CONTROL_END:
			break;
          	default:
			assign_child_num=2; /* it can be any number larger than 1  */
        	}
		
		e=SiECdr(e);

	}

	if(assign_child_num==1)
	{
		assignnode_bothside=(ELIST)SiGetBothSides(assign_child_id);
		left_expression_id=(int)SiECar(assignnode_bothside);
		expression_use=expression;
		while(expression_use->expr_id!=left_expression_id)
			expression_use=expression_use->next;
		iteration_var_id=(int)SiECar(SiInductionVars(fornode_id));

		equal=TRUE;
		for(i=1;i<=processor_num;i++)
			if(!ZjdEqual_line_expression(expression_use->iteration[0]->iteration,
					expression_use->iteration[i]->iteration,iteration_var_id))
				equal=FALSE;

		if(equal)
		{
			message_use=(struct MESSAGE *)calloc(1,sizeof(struct MESSAGE));
			message_use->processor_id=processor_num+1;
				/* give processor_num+1 to processor_id ,in order to indicate that 
				this loop_level hasn't been partitioned ,i.e. all processor have the same iteration set */
			if(expression_use->iteration[0]->iteration)
				message_use->ptr_line_expression=(PTR_LINE_EXPRESSION)
						LLCopyIteration(expression_use->iteration[0]->iteration,iteration_var_id);
			else
			{
				message_use->ptr_line_expression=(PTR_LINE_EXPRESSION)
						LLCopyIteration(iteration,iteration_var_id);
			}
			message_use->next=NULL;
		}
		else
		{
			message_use=(struct MESSAGE *)calloc(1,sizeof(struct MESSAGE));
                        message_use->processor_id=0;
                        message_use->ptr_line_expression=NULL;
                        message_use->next=NULL;
			message_temp=message_use;

			for(i=0;i<=processor_num;i++)
			{
				message_temp->processor_id=i;
				message_temp->ptr_line_expression=(PTR_LINE_EXPRESSION)
						LLCopyIteration(expression_use->iteration[i]->iteration,iteration_var_id);
				if(i!=processor_num)
					message_temp->next=(struct MESSAGE *)calloc(1,sizeof(struct MESSAGE));
				else
					message_temp->next=NULL;
				message_temp=message_temp->next;			
			}

		
		}
	}
	else  /* perhaps the solves for this branch  is not perfectly right,it needs some corrects in the future  */
	{
                assignnode_bothside=(ELIST)SiGetBothSides(assign_child_id);
                left_expression_id=(int)SiECar(assignnode_bothside);
                expression_use=expression;
                while(expression_use->expr_id!=left_expression_id)
                        expression_use=expression_use->next;
                iteration_var_id=(int)SiECar(SiInductionVars(fornode_id));

                message_use=(struct MESSAGE *)calloc(1,sizeof(struct MESSAGE));
                message_use->processor_id=processor_num+1;
                        /* give processor_num+1 to processor_id ,in order to indicate that this loop_level hasn't been partitioned ,i.e. all processor have the same iteration set */
                message_use->ptr_line_expression=(PTR_LINE_EXPRESSION)LLCopyIteration(expression_use->iteration[0]->iteration,iteration_var_id);
                message_use->next=NULL;

	}

        if(!loop)
        {
                loop=(struct LOOP *)calloc(1,sizeof(struct LOOP));
                loop->next=NULL;
                loop->message=NULL;
                loop->loopnode_id=0;
                loop_nil=loop;
         }
         else
         {
                loop_nil->next=(struct LOOP *)calloc(1,sizeof(struct LOOP));
                loop_nil=loop_nil->next;
                loop_nil->next=NULL;
                loop_nil->message=NULL;
                loop_nil->loopnode_id=0;
          }

          loop_nil->loopnode_id=fornode_id;
          loop_nil->message=message_use;

        /*  now we already get the iteration sets , below we'll show it  */

       	{
             	struct LINE_EXPRESSION * iteration_show;
                struct PROCESSOR_ITERATION * * ptr_ptr_processor;
		struct MESSAGE * message_use;
                int  i,j;

 	        printf("\n");
		printf("*******************  for below  *********************\n");
                printf("*******************  for below  *********************\n");
               	SiUnparseEList(SiUnparseStmt(loop_nil->loopnode_id));

		message_use=loop_nil->message;
		while(message_use)
		{
			if(message_use->processor_id != processor_num+1)
				printf("*** ptr_ptr_processor[%d]***\n",message_use->processor_id);
			iteration_show=message_use->ptr_line_expression;	
			
               	        while(iteration_show)
                       	{

 	                        printf("  %s = ",  SiVarIdent(iteration_show->id));
                                for(i=0;i<nestdepth;i++)
                                       	if(iteration_show->sstride[i]!=0)
                                       	{
                                               	struct LINE_EXPRESSION * iteration_use;
                                               	int t;

	                                        iteration_use=iteration;
                                                for(t=0;t<i;t++)
               	                                        iteration_use=iteration_use->next;

 	                                         printf("%d%s+",iteration_show->sstride[i],SiVarIdent(iteration_use->id));

  	                                 }
                                printf("%d , ",iteration_show->soffset);
               	                for(i=0;i<nestdepth;i++)
                       	                if(iteration_show->estride[i]!=0)
                               	        {
                                       	        struct LINE_EXPRESSION * iteration_use;
                                               	int t;

                                                iteration_use=iteration;
                                                for(t=0;t<i;t++)
               	                                      iteration_use=iteration_use->next;

 	                                         printf("%d%s+",iteration_show->estride[i],SiVarIdent(iteration_use->id));

 	                                } 
                                printf("%d  ",iteration_show->eoffset);
               	                if(iteration_show->increase>1)
                       	                printf(", %d",iteration_show->increase);

                                if(iteration_show->addition != 0)
                                        if(iteration_show->addition == 1)
                                                printf("  && %s >=%d ",  SiVarIdent(iteration_show->id),iteration_show->soffset_a);
                                        else
                                                printf("  && %s <=%d ",  SiVarIdent(iteration_show->id),iteration_show->eoffset_a);


                               	printf("\n");



 	                        iteration_show=iteration_show->next;
                        } /* of while(iteration_show)  */
			
			message_use=message_use->next;
		}/* of while(message_use)  */

	}

/* below to remove this level in the iteration set  */

        if(iteration->next==NULL)
        {
                ZjdCollectgarbage(iteration);
                iteration=NULL;
        }
        else
        {
                ZjdCollectgarbage(iteration_temp->next);
                iteration_temp->next=NULL;
        }







	return  assign_child_num;
	

}

struct LINE_EXPRESSION *
LLCopyIteration(ptr_line_expression,iteration_var_id)

PTR_LINE_EXPRESSION ptr_line_expression;
int iteration_var_id;

{
        PTR_LINE_EXPRESSION iteration_use, iteration_temp,iteration_origin;
        int i;

        iteration_origin=NULL;
        iteration_use=ptr_line_expression;

	if(!iteration_use) return NULL;

	while(iteration_use->id != iteration_var_id)
		iteration_use=iteration_use->next;

        iteration_origin=(PTR_LINE_EXPRESSION)calloc(1,sizeof(struct LINE_EXPRESSION));
	iteration_origin->next=NULL;

        iteration_origin->id=iteration_use->id;
        iteration_origin->increase=iteration_use->increase;
        iteration_origin->soffset=iteration_use->soffset;
        iteration_origin->eoffset=iteration_use->eoffset;
        iteration_origin->addition=iteration_use->addition;
        iteration_origin->soffset_a=iteration_use->soffset_a;
        iteration_origin->eoffset_a=iteration_use->eoffset_a;
        for(i=0;i<nestdepth;i++)
        {
                iteration_origin->sstride[i]=iteration_use->sstride[i];
                iteration_origin->estride[i]=iteration_use->estride[i];
        }
        return(iteration_origin);
	
}


ZjdEqual_line_expression(ptr_line_expression_a,ptr_line_expression_b,iteration_var_id)

PTR_LINE_EXPRESSION ptr_line_expression_a,ptr_line_expression_b;
int iteration_var_id;
{
	PTR_LINE_EXPRESSION iteration_use_a,iteration_use_b;
	int equal,i;

	iteration_use_a=ptr_line_expression_a;
	iteration_use_b=ptr_line_expression_b;
	
	if((!iteration_use_a) &&(!iteration_use_b)) return TRUE;
	if((!iteration_use_a) &&(iteration_use_b)) return FALSE;
	if((iteration_use_a) &&(!iteration_use_b)) return FALSE;


	while(iteration_use_a->id != iteration_var_id)
		iteration_use_a=iteration_use_a->next;
	while(iteration_use_b->id != iteration_var_id)    
                iteration_use_b=iteration_use_b->next;  
        
	equal=TRUE;

	if(iteration_use_a->increase!=iteration_use_b->increase) equal=FALSE;
        if(iteration_use_a->soffset!=iteration_use_b->soffset) equal=FALSE;
        if(iteration_use_a->eoffset!=iteration_use_b->eoffset) equal=FALSE;
        if(iteration_use_a->addition!=iteration_use_b->addition) equal=FALSE;
        if(iteration_use_a->soffset_a!=iteration_use_b->soffset_a) equal=FALSE;
        if(iteration_use_a->eoffset_a!=iteration_use_b->eoffset_a) equal=FALSE;
        for(i=0;i<nestdepth;i++)
        {
                if(iteration_use_a->sstride[i]!=iteration_use_b->sstride[i]) equal=FALSE;
                if(iteration_use_a->estride[i]!=iteration_use_b->estride[i]) equal=FALSE;
        }
        
	return equal;
	
}



ZjdAddClause(procs)
ELIST procs;
{
        ELIST e;
	int cont_id,str_id,type_id ,symb; 

        cont_id=SiNewConstant(SiEAppend(SiENumber(1),SiENumber(4)));
        type_id=SiMakeArrayType(TYPE_INT,1,cont_id);
	ENV_id = SiNewVarInt(type_id, (int)SiECar(procs), "ENV");

        symb = SiMakeSubroutineName("KXINIT");
	call_stat1 = SiNewStmtInt(PROC_STAT,symb,-1,-1,-1);
/*	SiUnparseEList(SiUnparseStmt(call_stat1));    */

        str_id=SiNewSymbolRef(VAR_REF,ENV_id,-1);
        str_id=SiNewExpr(EXPR_LIST,str_id);

        symb = SiMakeSubroutineName("KXPARA");
        call_stat2 = SiNewStmtInt(PROC_STAT,symb,str_id,-1,-1);
/*	SiUnparseEList(SiUnparseStmt(call_stat2));    */

/*	pro_var_id=SiNewVarInt(TYPE_INT,(int)SiECar(procs) ,"ENV[1]");    */

        for(e = procs; e; e = SiECdr(e))
        {
                Ninstrument((int)SiECar(e),procs);
        }



}


Ninstrument(statement_id,procs)

int statement_id;
ELIST procs;
{
        ELIST  children,branch;
        int    child_stmt,variant;
	static int first_executable_found=0 ;


        SiUnparseEList(SiUnparseStmt(statement_id));    
        variant=SiStmtVariant(statement_id);

        if(first_executable_found == 0 && executable_stmt(statement_id))
	{
        	first_executable_found = 1;
		SiReplaceStmt(SiEAppend(SiENumber(statement_id), SiENumber(call_stat1)));
        	SiInsertStmt(SiEAppend(SiENumber(call_stat1),
                        SiEAppend( SiENumber(1), SiENumber(statement_id))));

		SiReplaceStmt(SiEAppend(SiENumber(statement_id), SiENumber(call_stat2)));
                SiInsertStmt(SiEAppend(SiENumber(call_stat2),
                        SiEAppend( SiENumber(1), SiENumber(statement_id))));

        }


        switch(variant)
        {
          case FOR_NODE:     /* basic loop node: "do" in Fortran */
               Ntreatfornode(statement_id,procs);
		break;
          case WHILE_NODE:   /* C while                          */
          case IF_NODE:      /* a if node with a "then"        */
          case ELSEIF_NODE:  /* a matching "else if ... "then" */
          case LOGIF_NODE:  /* an if without a then */
          case PROC_STAT:
          case PROG_HEDR:
          case PROC_HEDR:
          case FUNC_HEDR:

               children=SiControlChildren(statement_id);
               while(children)
               {
                   branch=(ELIST)SiECar(children);
                   while(branch)
                   {
                       child_stmt=(int)SiECar(branch);
                       Ninstrument(child_stmt,procs);
                       branch=SiECdr(branch);
                   }
                   children=SiECdr(children);
               }
               break;
          case ASSIGN_STAT:
          default:
               break;
        }

}


Ntreatfornode(fornode_id,procs)

int  fornode_id;
ELIST procs;
{
	struct LOOP * loop_use;
	struct MESSAGE * message_use;
	char * start, * end;
	int pronum_cons_id,pro_var_ref_id,if_stmt_id;
	ELIST elist_use,ifchildren;
	int start_var_id,end_var_id,start_var_ref_id,end_var_ref_id,cons_id,start_stmt_id,end_stmt_id;
	int id,expr_id;

        ELIST   forchildren,loopbound,children,e;
        struct LINE_EXPRESSION * iteration_use, * iteration_temp;
	int i;


/*   below to add this level to  iteration set  */


        iteration_use=(PTR_LINE_EXPRESSION)calloc(1,sizeof(struct LINE_EXPRESSION));
        iteration_use->id=0;
        iteration_use->increase=0;
        iteration_use->soffset=0;
        iteration_use->eoffset=0;
        iteration_use->addition=0;
        iteration_use->soffset_a=0;
        iteration_use->eoffset_a=0;
        for(i=0;i<nestdepth;i++)
        {
                iteration_use->sstride[i]=0;
                iteration_use->estride[i]=0;
        }
        iteration_use->next=NULL;

        iteration_use->id=(int)SiECar(SiInductionVars(fornode_id));
        loopbound=SiLoopBounds(fornode_id);
        ExpressionGetOffset((int)SiECar(loopbound),iteration_use->sstride,&iteration_use->soffset,1);
        ExpressionGetOffset((int)SiECadr(loopbound),iteration_use->estride,&iteration_use->eoffset,1);
        ExpressionGetOffset((int)SiECaddr(loopbound),NULL,&iteration_use->increase,1);

        if(iteration_use->increase==0)
                iteration_use->increase=1;


        if(!iteration)
        {
                iteration=iteration_use;
                iteration_temp=iteration;
        }
        else
        {
                iteration_temp=iteration;
                while(iteration_temp->next)
                        iteration_temp=iteration_temp->next;
                iteration_temp->next=iteration_use;
        };

/*  below to add clauses according to the partition  infor */

	loop_use=loop;
	while(loop_use->loopnode_id != fornode_id)
		loop_use=loop_use->next;
	if(loop_use->message->processor_id != processor_num+1)
	{
		message_use=loop_use->message;
		start=ZjdCreatVarName();
		end=ZjdCreatVarName();
		start_var_id=SiNewVarInt(TYPE_INT,(int)SiECar(procs) ,start);
		end_var_id=SiNewVarInt(TYPE_INT,(int)SiECar(procs) ,end);


		while(message_use)
		{
			if(!message_use->ptr_line_expression)
			{
			/* for this condition,it means that the corresponding processor has no iteration set ,
			so below we let start to be 1 and end to be 0 ,and thus there is no iteration in effect */
	
				start_var_ref_id=SiNewSymbolRef(VAR_REF,start_var_id,-1);
				cons_id=SiNewConstant(SiEAppend(SiENumber(1),SiENumber(1)));
				start_stmt_id=SiNewStmtInt(ASSIGN_STAT ,-1,start_var_ref_id,cons_id,-1);
				end_var_ref_id=SiNewSymbolRef(VAR_REF,end_var_id,-1);
                                cons_id=SiNewConstant(SiEAppend(SiENumber(1),SiENumber(0)));
                                end_stmt_id=SiNewStmtInt(ASSIGN_STAT ,-1,end_var_ref_id,cons_id,-1);


			}
			else
			{
                          	start_var_ref_id=SiNewSymbolRef(VAR_REF,start_var_id,-1);

				cons_id=-1;
				{
					struct LINE_EXPRESSION * iteration_show;
					int i;

					iteration_show=message_use->ptr_line_expression;
					for(i=0;i<nestdepth;i++)
						if(iteration_show->sstride[i]!=0)
						{
							struct LINE_EXPRESSION   * iteration_use;
							int t,sym_ref_id,cons_ref_id;
						
							iteration_use=iteration;
							for(t=0;t<i;t++)
								iteration_use=iteration_use->next;
							sym_ref_id=SiNewSymbolRef(VAR_REF,iteration_use->id,-1);
							cons_ref_id=SiNewConstant(SiEAppend(SiENumber(1),SiENumber(iteration_show->sstride[i])));
							if(cons_id==-1)
								cons_id=SiNewExpr(MULT_OP,cons_ref_id,sym_ref_id);
							else
								cons_id=SiNewExpr(ADD_OP,cons_id,SiNewExpr(MULT_OP,cons_ref_id,sym_ref_id));
						
						}
					if(cons_id==-1)
						cons_id=SiNewConstant(SiEAppend(SiENumber(1),SiENumber(iteration_show->soffset)));
					else
						if(iteration_show->soffset!=0)
							cons_id=SiNewExpr(ADD_OP,cons_id,SiNewConstant(SiEAppend(SiENumber(1),SiENumber(iteration_show->soffset))));

					
				}	
                        	start_stmt_id=SiNewStmtInt(ASSIGN_STAT ,-1,start_var_ref_id,cons_id,-1);

                        	end_var_ref_id=SiNewSymbolRef(VAR_REF,end_var_id,-1);
           /*             	elist_use=SiENumber(1);
                        	elist_use=SiEAppend(elist_use,SiENumber(message_use->ptr_line_expression->eoffset));
                        	cons_id=SiNewConstant(elist_use);       */

                        	cons_id=-1;
                        	{
                                	struct LINE_EXPRESSION * iteration_show;
                                	int i;

                                	iteration_show=message_use->ptr_line_expression;
                                	for(i=0;i<nestdepth;i++)
                                        	if(iteration_show->estride[i]!=0)
                                        	{
                                                	struct LINE_EXPRESSION   * iteration_use;
                                                	int t,sym_ref_id,cons_ref_id;

                                                	iteration_use=iteration;
                                                	for(t=0;t<i;t++)
                                                        	iteration_use=iteration_use->next;
                                                	sym_ref_id=SiNewSymbolRef(VAR_REF,iteration_use->id,-1);
                                                	cons_ref_id=SiNewConstant(SiEAppend(SiENumber(1),SiENumber(iteration_show->estride[i])));
                                                	if(cons_id==-1)
                                                        	cons_id=SiNewExpr(MULT_OP,cons_ref_id,sym_ref_id);
                                                	else
                                                        	cons_id=SiNewExpr(ADD_OP,cons_id,SiNewExpr(MULT_OP,cons_ref_id,sym_ref_id));

                                        	}
                                	if(cons_id==-1)
                                        	cons_id=SiNewConstant(SiEAppend(SiENumber(1),SiENumber(iteration_show->eoffset)));
                                	else
                                        	if(iteration_show->eoffset!=0)
                                                	cons_id=SiNewExpr(ADD_OP,cons_id,SiNewConstant(SiEAppend(SiENumber(1),SiENumber(iteration_show->eoffset))));


                        	}
                        	end_stmt_id=SiNewStmtInt(ASSIGN_STAT ,-1,end_var_ref_id,cons_id,-1);


			} /* end of else */
			elist_use=SiENumber(1);
			elist_use=SiEAppend(elist_use,SiENumber(message_use->processor_id));
			pronum_cons_id=SiNewConstant(elist_use);

			pro_var_ref_id=SiNewSymbolRef(ARRAY_REF,ENV_id,SiNewConstant
					(SiEAppend(SiENumber(1),SiENumber(1))));
/*			pro_var_ref_id=SiNewSymbolRef(VAR_REF,pro_var_id,-1);   */
			expr_id=(int)SiNewExpr(EQ_OP ,pro_var_ref_id,pronum_cons_id);
/*			SiUnparseEList(SiUnparseExpr(expr_id));     */

			elist_use=SiENumber(IF_NODE);
			elist_use=SiEAppend(elist_use,SiENumber(expr_id));
			elist_use=SiEAppend(elist_use,SiENumber(start_stmt_id));
			elist_use=SiEAppend(elist_use,SiENumber(end_stmt_id));


			if_stmt_id=SiNewIf(elist_use);
/*			SiUnparseEList(SiUnparseStmt(if_stmt_id));     */

			SiReplaceStmt(SiEAppend(SiENumber(fornode_id), SiENumber(if_stmt_id)));
			SiInsertStmt(SiEAppend(SiENumber(if_stmt_id),SiEAppend
					( SiENumber(1), SiENumber(fornode_id))));  

			start_var_ref_id=SiNewSymbolRef(VAR_REF,start_var_id,-1);
			end_var_ref_id=SiNewSymbolRef(VAR_REF,end_var_id,-1);
			SiReplaceLeftSide(fornode_id,SiNewExpr(DDOT,start_var_ref_id,end_var_ref_id));

/*			SiInsertStmt(SiEAppend(SiENumber(if_stmt_id),SiEAppend
					( SiENumber(1), SiENumber(SiNewStmtInt(CONTROL_END ,-1,-1,-1,-1)))));  
*/


			message_use=message_use->next;
		}	
	}
/*  below to handle  the childrens of this for_stmt  */


        forchildren=SiControlChildren(fornode_id);
        forchildren=(ELIST)SiECar(forchildren);
        e=forchildren;
        while(e)
        {
                Ninstrument((int)SiECar(e),procs);
                e=SiECdr(e);
        }

/* below to remove this level in the iteration set  */

        if(iteration->next==NULL)
        {
                ZjdCollectgarbage(iteration);
                iteration=NULL;
        }
        else
        {
                ZjdCollectgarbage(iteration_temp->next);
                iteration_temp->next=NULL;
        }



}


char *
ZjdCreatVarName()
{
	static int t=0;
	char * c;
	int length=1,temp,j;
	
	temp=t;
	while(temp /10>0)
	{
		temp=(int)temp/10;
		length++;  
	}
	
	c=calloc(length+1+3,sizeof(char));
	c[0]='u';
	c[1]='s';
	c[2]='e';

	temp=t;
	for(j=0;j<length;j++)
	{
		switch(temp % 10)
		{
		case 0:
			c[length+3-1-j]='0';
			break;
                case 1:
                        c[length+3-1-j]='1';
                        break;

                case 2:
                        c[length+3-1-j]='2';
                        break;
                case 3:
                        c[length+3-1-j]='3';
                        break;
                case 4:
                        c[length+3-1-j]='4';
                        break;
                case 5:
                        c[length+3-1-j]='5';
                        break;
                case 6:
                        c[length+3-1-j]='6';
                        break;
                case 7:
                        c[length+3-1-j]='7';
                        break;
                case 8:
                        c[length+3-1-j]='8';
                        break;
                case 9:
                        c[length+3-1-j]='9';
                        break;
		}

		temp=(int)temp/10;
	}
/*	c[length+3]=0;  */

	t++;
	return c;
}


int executable_stmt(stmt_id)
int stmt_id;
{

  if( SiStmtVariant(stmt_id) <= 168 && SiStmtVariant(stmt_id) >=152 )
   return 0;
  if(SiStmtVariant(stmt_id) ==101 )
   return 0;

  return 1;
}


