/*  As fortran language,the first array_mumber is numbered 1.  */

extern int processor_num;


#include <stdio.h>
#include "tag"
#include "defs.h"
#include "ll.h"
#include "SiEList.h"
#include "SiFuns.h"


extern ELIST procs;

int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */


/********************************************************/
/*						    	*/
/* this can only handle the simplized align patern  	*/
/* like a*I+b						*/  
/*						    	*/
/* INPUT = an array reference id                    	*/
/* OUTPUT= the align stride of corresponding array  	*/
/*						    	*/
/*						    	*/
/********************************************************/

int 
ZjdGetAlignStride(expr_id)
int expr_id;

{
	int array_sym_id;   	/* id of the corresponding array symble  		*/
	int align_stmt_id;  	/* id of the corresponding align statement  		*/
	int distr_stmt_id;  	/* id of the corresponding distribute statement  	*/
	int list_id;		/* id of a expression with the type EXPR_LIST 		*/
	int array_ref_id;	/* id of a expression with the type ARRAY_REF		*/
	int dim_par_id;		/* id of a dimension reference to indicate the partition patern	*/
	int dim_num;		/* dimension number beginning from 1 			*/
	int model_ref_id;   	/* id of the model reference  				*/
	int use_id,temp_id;
	int stride;
	int i;

	array_sym_id=SiVarId(expr_id);

	/* below to get the corresponding array reference id in the distribute statement	*/ 
	distr_stmt_id=ZJDgetdistribute(expr_id);
	list_id=SiGetLeftChild(distr_stmt_id);
	while(list_id!=-1)
	{
		array_ref_id=SiGetLeftChild(list_id);
		if(SiVarId(array_ref_id)==array_sym_id)
			list_id=-1;
		else
			list_id=SiGetRightChild(list_id);
	}

	/* below to ascertain the dimension which is block_partitioned in the array reference	*/
	list_id=SiGetLeftChild(array_ref_id);
	dim_num=0;
	while(list_id!=-1)
	{
		dim_num++;
		dim_par_id=SiGetLeftChild(list_id);
		if(SiExprVariant(dim_par_id)==BLOCK_OP)
			list_id=-1;
		else
			list_id=SiGetRightChild(list_id);
	}

	/* below to compute the align stride  	*/
	align_stmt_id=ZJDgetalign(expr_id);
	model_ref_id=SiECadr(SiGetBothSides(align_stmt_id));
	list_id=SiGetLeftChild(SiGetLeftChild(model_ref_id));
	for(i=1;i<dim_num;i++)
		list_id=SiGetRightChild(list_id);
	/* use_id to hold the dimension reference  	*/
	use_id=SiGetLeftChild(list_id);
	switch(SiExprVariant(use_id))
	{
		int minus=1;

		case VAR_REF:
			return 1;
			break;
		case MULT_OP:
			if(SiExprVariant(SiGetLeftChild(use_id))==INT_VAL)
				temp_id=SiGetLeftChild(use_id);
			else
				temp_id=SiGetRightChild(use_id);

			SiGetIntConstExpr(temp_id,&stride);
			return stride*minus;
			break;
		case ADD_OP:
			if(SiExprVariant(SiGetLeftChild(use_id))==INT_VAL)
				temp_id=SiGetRightChild(use_id);
			else
				temp_id=SiGetLeftChild(use_id);

			switch(SiExprVariant(temp_id))
			{
				case MULT_OP:
					if(SiExprVariant(SiGetLeftChild(temp_id))==INT_VAL)
						temp_id=SiGetLeftChild(temp_id);
					else
						temp_id=SiGetRightChild(temp_id);

					SiGetIntConstExpr(temp_id,&stride);
					return stride*minus;
					break;
				case VAR_REF:
					return 1;
					break;

			}

			break;
		case SUBT_OP:		/* that is "l_child - r_child" */
			if(SiExprVariant(SiGetLeftChild(use_id))==INT_VAL)
			{
				minus=-1;
				temp_id=SiGetRightChild(use_id); 
			}
			else
				temp_id=SiGetLeftChild(use_id);
                        switch(SiExprVariant(temp_id))
                        {
                                case MULT_OP:
                                        if(SiExprVariant(SiGetLeftChild(temp_id))==INT_VAL)
                                                temp_id=SiGetLeftChild(temp_id);
                                        else    
                                                temp_id=SiGetRightChild(temp_id);

                                        SiGetIntConstExpr(temp_id,&stride);
                                        return stride*minus;
                                        break;
                                case VAR_REF:
                                        return 1*minus;
                                        break;

                        }
	}
	

}

/********************************************************/
/*                                                      */
/* this can only handle the simplized align patern      */
/* like a*I+b                                           */
/*                                                      */
/* INPUT = an array reference id                        */
/* OUTPUT= the align offset of corresponding array      */
/*                                                      */
/*                                                      */
/********************************************************/



int 
ZjdGetAlignOffset(expr_id)
int expr_id;

{
        int array_sym_id;       /* id of the corresponding array symble                 */
        int align_stmt_id;      /* id of the corresponding align statement              */
        int distr_stmt_id;      /* id of the corresponding distribute statement         */
        int list_id;            /* id of a expression with the type EXPR_LIST           */
        int array_ref_id;       /* id of a expression with the type ARRAY_REF           */
        int dim_par_id;         /* id of a dimension reference to indicate the partition patern */
        int dim_num;            /* dimension number beginning from 1                    */
        int model_ref_id;       /* id of the model reference                            */
        int use_id,temp_id;
        int offset;
        int i;

        array_sym_id=SiVarId(expr_id);

        /* below to get the corresponding array reference id in the distribute statement        */
        distr_stmt_id=ZJDgetdistribute(expr_id);
        list_id=SiGetLeftChild(distr_stmt_id);
        while(list_id!=-1)
        {
                array_ref_id=SiGetLeftChild(list_id);
                if(SiVarId(array_ref_id)==array_sym_id)
                        list_id=-1;
                else
                        list_id=SiGetRightChild(list_id);
        }

        /* below to ascertain the dimension which is block_partitioned in the array reference   */
        list_id=SiGetLeftChild(array_ref_id);
        dim_num=0;
        while(list_id!=-1)
        {
                dim_num++;
                dim_par_id=SiGetLeftChild(list_id);
                if(SiExprVariant(dim_par_id)==BLOCK_OP)
                        list_id=-1;
                else
                        list_id=SiGetRightChild(list_id);
        }

        /* below to compute the align stride    */
        align_stmt_id=ZJDgetalign(expr_id);
        model_ref_id=SiECadr(SiGetBothSides(align_stmt_id));
        list_id=SiGetLeftChild(SiGetLeftChild(model_ref_id));
        for(i=1;i<dim_num;i++)
                list_id=SiGetRightChild(list_id);
        /* use_id to hold the dimension reference       */
        use_id=SiGetLeftChild(list_id);
        switch(SiExprVariant(use_id))
        {
                int minus=1;

		case MULT_OP:
                case VAR_REF:
                        return 0;
                        break;
                case ADD_OP:
                        if(SiExprVariant(SiGetLeftChild(use_id))==INT_VAL)
                                temp_id=SiGetLeftChild(use_id);
                        else
                                temp_id=SiGetRightChild(use_id);
			
			SiGetIntConstExpr(temp_id,&offset);
			return offset;
                        break;
                case SUBT_OP:           /* that is "l_child - r_child" */
                        if(SiExprVariant(SiGetLeftChild(use_id))==INT_VAL)
                        {
				temp_id=SiGetLeftChild(use_id);
				SiGetIntConstExpr(temp_id,&offset);
				return offset;
                        }
                        else
			{
                                temp_id=SiGetRightChild(use_id);
				minus=-1;
				SiGetIntConstExpr(temp_id,&offset);
				return offset*minus;
			}

			
        }


}

/****************************************************************/
/*                                                      	*/
/*                                                      	*/
/* INPUT = an array reference id                        	*/
/* OUTPUT= the partitioned dimension  of corresponding array    */
/* the dimension is numbered from 1				*/
/*                                                      	*/
/*                                                      	*/
/****************************************************************/



int
ZjdGetDistributedDimension(expr_id)
int expr_id;

{
        int array_sym_id;       /* id of the corresponding array symble                 */
        int align_stmt_id;      /* id of the corresponding align statement              */
        int distr_stmt_id;      /* id of the corresponding distribute statement         */
        int list_id;            /* id of a expression with the type EXPR_LIST           */
        int array_ref_id;       /* id of a expression with the type ARRAY_REF           */
        int dim_par_id;         /* id of a dimension reference to indicate the partition patern */
        int dim_num;            /* dimension number beginning from 1                    */
        int model_ref_id;       /* id of the model reference                            */
        int use_id,temp_id;
        int i;

        array_sym_id=SiVarId(expr_id);

        /* below to get the corresponding array reference id in the distribute statement        */
        distr_stmt_id=ZJDgetdistribute(expr_id);
        list_id=SiGetLeftChild(distr_stmt_id);
        while(list_id!=-1)
        {
                array_ref_id=SiGetLeftChild(list_id);
                if(SiVarId(array_ref_id)==array_sym_id)
                        list_id=-1;
                else
                        list_id=SiGetRightChild(list_id);
        }

        /* below to ascertain the dimension which is block_partitioned in the array reference   */
        list_id=SiGetLeftChild(array_ref_id);
        dim_num=0;
        while(list_id!=-1)
        {
                dim_num++;
                dim_par_id=SiGetLeftChild(list_id);
                if(SiExprVariant(dim_par_id)==BLOCK_OP)
                        list_id=-1;
                else
                        list_id=SiGetRightChild(list_id);
        }
	
	return dim_num;
}





int 
ZjdGetBlocksize(expr_id)
int expr_id;

{
        int array_sym_id;       /* id of the corresponding array symble                 */
        int align_stmt_id;      /* id of the corresponding align statement              */
        int distr_stmt_id;      /* id of the corresponding distribute statement         */
	int decom_stmt_id;	/* id of the corresponding decomposition statement	*/
        int list_id;            /* id of a expression with the type EXPR_LIST           */
        int array_ref_id;       /* id of a expression with the type ARRAY_REF           */
        int dim_par_id;         /* id of a dimension reference to indicate 
					the partition patern 				*/
        int dim_num;            /* dimension number beginning from 1                    */
        int model_ref_id;       /* id of the model reference                            */
        int use_id,temp_id;
        int dim_length; 	/* length of a certain dimension  			*/
        int i;

        array_sym_id=SiVarId(expr_id);

        /* below to get the corresponding array reference id in the distribute statement        */
        distr_stmt_id=ZJDgetdistribute(expr_id);
        list_id=SiGetLeftChild(distr_stmt_id);
        while(list_id!=-1)
        {
                array_ref_id=SiGetLeftChild(list_id);
                if(SiVarId(array_ref_id)==array_sym_id)
                        list_id=-1;
                else
                        list_id=SiGetRightChild(list_id);
        }

        /* below to ascertain the dimension which is block_partitioned in the array reference   */
        list_id=SiGetLeftChild(array_ref_id);
        dim_num=0;
        while(list_id!=-1)
        {
                dim_num++;
                dim_par_id=SiGetLeftChild(list_id);
                if(SiExprVariant(dim_par_id)==BLOCK_OP)
                        list_id=-1;
                else
                        list_id=SiGetRightChild(list_id);
        }

	/* below to compute block size 	*/
	decom_stmt_id=ZJDgetdecomposition(expr_id);
	list_id=SiGetLeftChild(decom_stmt_id);
	while(list_id!=-1)
        {
                array_ref_id=SiGetLeftChild(list_id);
                if(SiVarId(array_ref_id)==array_sym_id)
                        list_id=-1;
                else
                        list_id=SiGetRightChild(list_id);
        }

        for(i=1;i<dim_num;i++)
                list_id=SiGetRightChild(list_id);

        use_id=SiGetLeftChild(list_id);
	SiGetIntConstExpr(use_id,&dim_length);

	return dim_length/processor_num;

}


int 
ZjdIfDistributed(expr_id)
int expr_id;

{
	if(ZJDgetalign(expr_id))
		return 1;
	else 
		return 0;

}



int 
ZJDgetalign(expr_id)
int expr_id;

{
	ELIST 	e,children,branch;
	int 	array_sym_id;	/* the id of the corresponding real array */
	int 	child_stmt,variant;

	array_sym_id=SiVarId(expr_id);

        for(e = procs; e; e = SiECdr(e))
	{
               children=SiControlChildren((int)SiECar(e));
               while(children)
               {
                   branch=(ELIST)SiECar(children);
                   while(branch)
                   {
                       	child_stmt=(int)SiECar(branch);
		        variant=SiStmtVariant(child_stmt);
			switch(variant)
			{
			  case ALIGN_STMT:
				if(array_sym_id==SiVarId(SiGetLeftChild(SiGetLeftChild(child_stmt))))
					return child_stmt;
			  	break;
			  default:
				break;
			}
                       	branch=SiECdr(branch);
                   }
                   children=SiECdr(children);
               }
	}

	return 0;

}


int
ZJDgetdistribute(expr_id)
int expr_id;

{
 	int 	align_stmt_id,child_stmt,variant;
	int 	array_sym_id;   	/* here to hord id of the decomposition array	*/
       	ELIST 	e,children,branch;

	align_stmt_id=ZJDgetalign(expr_id);

        array_sym_id=SiVarId(SiGetLeftChild(SiGetRightChild(child_stmt)));

        for(e = procs; e; e = SiECdr(e))
        {
               children=SiControlChildren((int)SiECar(e));
               while(children)
               {
                   branch=(ELIST)SiECar(children);
                   while(branch)
                   {
                        child_stmt=(int)SiECar(branch);
                        variant=SiStmtVariant(child_stmt);
                        switch(variant)
                        {
                          case DISTRIBUTE_STMT:
                                if(array_sym_id==SiVarId(SiGetLeftChild(SiGetLeftChild(child_stmt))))
                                        return child_stmt;
                                break;
                          default:
                                break;
                        }
                        branch=SiECdr(branch);
                   }
                   children=SiECdr(children);
               }
        }

        return 0;

}



int
ZJDgetdecomposition(expr_id)
int expr_id;

{
        int     align_stmt_id,child_stmt,variant;
        int     array_sym_id;           /* here to hord id of the decomposition array   */
        ELIST   e,children,branch;

        align_stmt_id=ZJDgetalign(expr_id);

        array_sym_id=SiVarId(SiGetLeftChild(SiGetRightChild(child_stmt)));

        for(e = procs; e; e = SiECdr(e))
        {
               children=SiControlChildren((int)SiECar(e));
               while(children)
               {
                   branch=(ELIST)SiECar(children);
                   while(branch)
                   {
                        child_stmt=(int)SiECar(branch);
                        variant=SiStmtVariant(child_stmt);
                        switch(variant)
                        {
                          case DECOMPOSITION_STMT:
                                if(array_sym_id==SiVarId(SiGetLeftChild(SiGetLeftChild(child_stmt))))
                                        return child_stmt;
                                break;
                          default:
                                break;
                        }
                        branch=SiECdr(branch);
                   }
                   children=SiECdr(children);
               }
        }

        return 0;

}





