#include <stdlib.h>
#include "db.h"
/*#include "defs.h"
/*include "SiDefines.h"
/*include "bif.h"
/*include "ll.h"
/*include "symb.h"
*/

extern int atoi();
extern void exit();
extern PTR_PROJ OpenProj();

PCF UnparseBlock[];

int debug;
enum SCOPE {in_proc,in_func} ;
enum SCOPE scope;


void
main(argc, argv)
    int   argc;
    char *argv[];
{
    PTR_PROJ pr;
    PTR_FILE fi;
    char *s;
    struct bfnd *bp;
    PTR_SYMB sp;

    bp = (PTR_BFND) malloc (sizeof(struct bfnd) );
    if (argc < 2) 
    {
        fprintf(stderr,"Usage: unparse [-d nnn] filename\n");
	exit(1);
    }
    else
    {
	argv++; argc--;
	if(**argv == '-')
	    if ((*argv)[1] == 'd') {
		argv++;
		debug = atoi(*argv++);
	    } else {
		fprintf(stderr,"Usage: unparse [-d nnn] filename\n");
		exit(1);
	    }

	if ((pr = OpenProj("test", argc, argv)) != NULL) {
	    fi = (PTR_FILE) pr->file_chain->ref;
	bp = fi->head_bfnd;
	sp = fi->head_symb;
	scope = in_func;/*pointers are used if in procedure */
/*          trans_symb(sp);*/
	    trans_blck(bp);	
	    if(fi->lang == ForSrc)
	   	fi->lang = CSrc;
	    printf("\n /*** Converting file %s ***/ \n",fi->filename);
	    printf("\n#include \"mylib.h\"\n");
	    s = (*UnparseBlock[fi->lang])(fi->head_bfnd);
	    printf("%s\n", s);
	}
    }
}

/*trans_symb(PTR_SYMB sp)
/*{
/*PTR_SYMB sym;

for(sym  = sp; sym; sym = sym->thread)
   {
    if(sym->variant == PROCEDURE_NAME || sym->variant == FUNCTION_NAME)
     {
       if(strcmp(sym->ident,"MAX") == 0)
	  sym->entry.func_decl.tag = _MAX_;
       else
          if(strcmp(sym->ident,"MIN") == 0)
             sym->entry.func_decl.tag = _MIN_;
          else
	     if(strcmp(sym->ident,"MOD") == 0)
                sym->entry.func_decl.tag = _MOD_;
             else
                if(strcmp(sym->ident,"SEND") == 0)  
                   sym->entry.func_decl.tag =_SEND_;
                else      
                   if(strcmp(sym->ident,"RECEIVE") == 0)
                      sym->entry.func_decl.tag =_RECEIVE_;
                   else
                         sym->entry.func_decl.tag =_SELF_DEF_;
     }		
   }
}*/


trans_blck(struct bfnd *bp)
{
 PTR_BLOB blp1,blp2;

 if (bp != NULL)
    {
     blp1 = (struct blob *) malloc ( sizeof(struct blob) );
     blp2 = (struct blob *) malloc ( sizeof(struct blob) );

     trans_bfnd( bp);

     if(bp->variant == PROC_HEDR)
     {
      scope = in_proc;

      for(blp1 = bp->entry.template.bl_ptr1; blp1; blp1 = blp1->next)
      trans_blck(blp1->ref);

      for(blp2 = bp->entry.template.bl_ptr2; blp2; blp2 = blp2->next)
      trans_blck(blp2->ref);
      scope = in_func;
     }
     else
     {
      for(blp1 = bp->entry.template.bl_ptr1; blp1; blp1 = blp1->next)
      trans_blck(blp1->ref);

      for(blp2 = bp->entry.template.bl_ptr2; blp2; blp2 = blp2->next)
      trans_blck(blp2->ref);
     }
    }

}

 trans_bfnd( struct bfnd *bp)
 {
  switch ( bp->variant ) {
	case    GLOBAL:
		break;
        case    PROG_HEDR:
                progtofunc( bp );
                break;
        case    PROC_HEDR:
                proctofunc( bp );
                break;
        case    ASSIGN_STAT:
                /*if( scope == in_func &&
		/*assgntoretnd( bp );
		/*else
		*/
		assgntoexpr( bp);
                break;
        case    RETURN_STAT:
                retstatoretnd( bp );
                break;
        case    PROC_STAT:
                prcstatoexpr( bp );
                break;
        case    ELSEIF_NODE:
        case    IF_NODE:
                iftoif( bp);
                break;
        case 	VAR_DECL:
		vartovar( bp );
		break;
        case    FOR_NODE:
		fortofor(bp );
		break;
        /*case :
        /*case :
*/
        default:;
 }
}

 progtofunc( struct bfnd *bp )
 {
  struct symb   *sp1;
  struct llnd   *lp1, *lp2;
  struct data_type	*tp1;

  sp1 = (struct symb *) malloc ( sizeof (struct symb) );
  lp1 = (struct llnd *) malloc ( sizeof (struct llnd) );
  lp2 = (struct llnd *) malloc ( sizeof (struct llnd) );
  tp1 = (struct data_type *) malloc ( sizeof (struct data_type) );

  tp1->variant = DEFAULT;
  bp->variant = FUNC_HEDR;
  sp1->variant = FUNCTION_NAME;
  sp1->type = tp1;
  sp1->ident = "main";
  bp->entry.program.prog_symb = sp1;
  /* modify the symbol nodes */

  lp1->variant = EXPR_LIST;
  lp1->type = DEFAULT;
  bp->entry.program.null_1 = lp1;

  lp2->variant = FUNCTION_REF;
  lp2->entry.list.null_1 = sp1;
  lp1->entry.list.item = lp2;

  /* modify the low level nodes */
 }

 proctofunc( struct bfnd *bp )/* transfer a procedure_head to  a function_head */
 /* the difference between functions and procedures is that the former pass the adresses while the later pass the values */
 {

 }

 assgntoretnd( struct bfnd *bp )
 {
  PTR_LLND lp1,lp2;

  lp1 = (struct llnd *) malloc ( sizeof (struct llnd) );
  lp2 = (struct llnd *) malloc ( sizeof (struct llnd) );

  bp->variant = RETURN_NODE;
  lp2->variant = EXPR_LIST;
  lp2->entry.template.ll_ptr1 = bp->entry.assign.r_value;
  lp2->type = bp->entry.assign.l_value->type;

  lp1->variant = EXPR_LIST;
  lp1->entry.template.ll_ptr1 = lp2;
  lp1->type = lp2->type;

  bp->entry.template.ll_ptr1 = lp1;
 }

 prcstatoexpr( struct bfnd *bp )
 {;
  /*int 		number;/* To indicate the number of the used */
  /*PTR_LLND	lp;
  
  /*number = 0;
  /*for(lp = bp->entry.template.ll_ptr1;lp;lp = lp->entry.template.ll_ptr1)
	/*number++;
  /*transprocstat(bp,number); 
  */
 }
 
/*transprocstat(struct bfnd *bp,int number)
/*{
/* PTR_TYPE	tp[number];
/* PTR_LLND       addr_op[number];
 /*PTR_LLND       expr,func,lp;
 /*int 		i;

 /*for (i = 0; i < number; i++)
 /*    {
 /*     addr_op[i] = (PTR_LLND)malloc( sizeof (struct llnd) );
 /*     tp[i] = (PTR_TYPE)malloc( sizeof (struct data_type) );
 /*    }	
 /*expr = (PTR_LLND)malloc( sizeof (struct llnd) );
 /*func = (PTR_LLND)malloc( sizeof (struct llnd) );
/*
 /*func->variant = FUNC_CALL;
 /*func->entry.template.ll_ptr1 = bp->entry.template.ll_ptr1;
 /*func->entry.template.symbol = bp->entry.template.symbol;
 /* func->type = */

 /*expr->variant = EXPR_LIST;
 /*expr->entry.template.ll_ptr1 = func;
 /* expr->type = func->type;*/
 
 /*bp->variant = EXPR_STMT_NODE;
 /*bp->entry.template.ll_ptr1 = expr;
 /*func->entry.template.ll_ptr1->type->variant = T_POINTER;
 /*for(i = 0,lp = func->entry.template.ll_ptr1;lp;i++,lp = lp->entry.template.ll_ptr2)
 /*   {
 /*    addr_op[i]->entry.template.ll_ptr1 = lp->entry.template.ll_ptr1;
 /*    lp->entry.template.ll_ptr1 = addr_op[i];
 /*    addr_op[i]->type->variant = T_POINTER; 
 /*   }	
/*}*/
 vartovar ( struct bfnd *bp )
 {
  bp->entry.template.ll_ptr1->type = bp->entry.template.ll_ptr2->type;
  bp->entry.template.ll_ptr2 = NULL;
 }

 assgntoexpr ( struct bfnd *bp)
 {
  struct llnd   *lp1, *lp2;
  PTR_TYPE      type1;

  lp1 = (struct llnd *) malloc ( sizeof (struct llnd) );
  lp2 = (struct llnd *) malloc ( sizeof (struct llnd) );
  type1 = (PTR_TYPE) malloc ( sizeof (struct data_type) ); 
  lp2->variant = ASSGN_OP;
  lp2->type = bp->entry.assign.l_value->type;
  lp2->entry.template.ll_ptr1 = bp->entry.assign.l_value;
  lp2->entry.template.ll_ptr2 = bp->entry.assign.r_value;
  lp1->variant = EXPR_LIST;
  lp1->type = bp->entry.assign.l_value->type;
  lp1->entry.list.item = lp2;

  bp->variant = EXPR_STMT_NODE;
  bp->entry.assign.l_value = lp1;
  bp->entry.assign.r_value = NULL;
 }

 iftoif( struct bfnd *bp)
 {
  struct llnd   *lp1;
  PTR_BFND 	bp1,bp2;
  PTR_BLOB	tail,blp1,blp2;

  bp1 = ( PTR_BFND ) malloc ( sizeof (struct bfnd) );
  bp2 = ( PTR_BFND ) malloc ( sizeof (struct bfnd) );
  blp1 = ( PTR_BLOB ) malloc ( sizeof (struct blob) );
  blp2 = ( PTR_BLOB ) malloc ( sizeof (struct blob) );
  lp1 = ( PTR_LLND ) malloc ( sizeof (struct llnd) );

  if(bp->variant == ELSEIF_NODE)
     bp->variant = IF_NODE; 

  if(bp->entry.if_node.control_false->ref->variant == ELSEIF_NODE)
    {
     tail = bp->entry.if_node.control_true;
     while(tail->next)
	tail = tail->next; 

     bp1->variant = CONTROL_END;
     bp1->control_parent = bp;
     blp1->ref = bp1;
     blp1->next = tail->next;
     tail->next = blp1;
        
     tail = bp->entry.if_node.control_false;
     while(tail->next) 
        tail = tail->next;

     bp2->variant = CONTROL_END;
     bp2->control_parent = bp;
     blp2->ref = bp2;
     blp2->next = tail->next;
     tail->next = blp2;
    }
  lp1->variant = EXPR_LIST;
  lp1->entry.list.item = bp->entry.if_node.condition;
  bp->entry.if_node.condition = lp1;
  /* Modify the condition expression */

 }

retstatoretnd( PTR_BFND bp )
{
 bp->variant = RETURN_NODE;
}

fortofor( PTR_BFND bp )
{
 PTR_LLND lp[11];
 PTR_LLND incre;
 int i;
 PTR_LLND extra;

 if( bp->entry.for_node.increment == NULL)
   { 
    incre = (PTR_LLND) malloc (sizeof(struct llnd));
    incre->variant = INT_VAL;
    incre->entry.ival = 1;
    bp->entry.for_node.increment = incre;
   } /* to convert to the standard F-tree */
  
 for(i = 0;i < 11;i++)
    {
     lp[i] = (PTR_LLND) malloc (sizeof(struct llnd));
     (lp[i])->type = bp->entry.for_node.control_var->type;
    }
 for(i = 0;i <= 3; i++)
   { 
    lp[i]->variant = VAR_REF; 
    (lp[i])->entry.template.symbol = bp->entry.for_node.control_var;   
   }
 lp[4]->variant = ASSGN_OP;
 lp[4]->entry.template.ll_ptr1 = lp[0];
 lp[4]->entry.template.ll_ptr2 = bp->entry.for_node.range->entry.template.ll_ptr1;  

 if(bp->entry.for_node.range->entry.binary_op.l_operand->entry.ival <= bp->entry.for_node.range->entry.binary_op.r_operand->entry.ival)
      {
	lp[5]->variant = LE_OP;
 	lp[6]->variant = ADD_OP;
      }
 else {
	lp[5]->variant = GE_OP;
        if(bp->entry.for_node.increment->variant == MINUS_OP)
           {
            lp[6]->variant = SUBT_OP;
	    extra = bp->entry.for_node.increment;
  	    bp->entry.for_node.increment = bp->entry.for_node.increment->entry.template.ll_ptr1;
	    free(extra);
           }
      }
 lp[5]->entry.template.ll_ptr1 = lp[1];
 lp[5]->entry.template.ll_ptr2 = bp->entry.for_node.range->entry.template.ll_ptr2;
 lp[6]->entry.template.ll_ptr1 = lp[2];
 lp[6]->entry.template.ll_ptr2 = bp->entry.for_node.increment;

 lp[7]->variant = ASSGN_OP;
 lp[7]->entry.template.ll_ptr1 = lp[3];
 lp[7]->entry.template.ll_ptr2 = lp[6];

 for(i = 8;i < 11;i++)
     lp[i]->variant = EXPR_LIST;
 lp[8]->entry.template.ll_ptr1 = lp[4];
 lp[9]->entry.template.ll_ptr1 = lp[5];
 lp[10]->entry.template.ll_ptr1 = lp[7];

 bp->entry.template.ll_ptr1 = lp[8];
 bp->entry.template.ll_ptr2 = lp[9];
 bp->entry.template.ll_ptr3 = lp[10];
 bp->entry.template.symbol = NULL;
}

