C 
C Nb proc = 1 , fichier entre : lns3937.mat ; time (milli)  :  373
C Nb proc = 2 , fichier entre : lns3937.mat ; time (milli)  :  264
C Nb proc = 4 , fichier entre : lns3937.mat ; time (milli)  :  198
C Nb proc = 8 , fichier entre : lns3937.mat ; time (milli)  :  185
C Nb proc = 16 , fichier entre : lns3937.mat ; time (milli) :  209
C Nb proc = 32 , fichier entre : lns3937.mat ; time (milli) :  287
C 


      program matmul
C$ann[Define("SVM", 1)]
c-------------------------------------------------
c produit matrice creuse par vecteur
c matrice symetrique ou non symetrique
c stockage par lignes
c
c version simple precision
c ------------------------
c
c programmeur: J.Erhel - INRIA - Avril 89
c-------------------------------------------------
c
c dimensions maximales: a modifier au besoin
      parameter (nsmx=4000,ndmx=nsmx,namx=80000)
c-----------------------------------------------------------------
c nombre d'operations: a modifier pour obtenir un temps mesurable
      parameter (nbop=1)
c-----------------------------------------------------------------
c
      logical sym
c
      integer iold(4000),jcol(80000)
      real  bmat(80000)
      real  ylig(4000)
      real  coorx(4000), tcoorx(4000)
      integer logfr(4000)
      real  amat(80000)
      integer ia(4000+1),ja(80000)
      integer t1(1), tia(4000+1)
      integer st,et
C$ann[Shared(t1)]
C$ann[Shared(tia)]
C$ann[Shared(ja)]
C$ann[Shared(iold)]
C$ann[Shared(jcol)]
C$ann[Shared(bmat)]
C$ann[Shared(amat)]
C$ann[Shared(tcoorx)]
C$ann[Shared(ylig)]
c
c-------------------------------------------------
c
      sym=.false.
c
c lecture de la matrice au format Harwell
c ---------------------------------------

C$ann[BeginSeq()]
      call lirharw(nsmx,namx,sym,ns,na,iold,jcol,bmat)
      print *,' nombre de lignes : ',ns
      print *,' nombre de coefficients non nuls : ',na
c
      if (sym.and.2*na.gt.namx) then
      print *,' matrice trop grande'
C     for the ipsc
C     gsync() 
      stop
      endif

C update local variable 
      
C end update 
c
c stockage par lignes
c -------------------
      
      call hw2lig(sym,ns,na,iold,jcol,bmat,logfr,amat,tia,ja)
c
c produit par lignes
c ------------------
      call inivec(ns,tcoorx,ylig)
      t1(1) = ns
C$ann[EndSeq()]

C     update local variables
       ns = t1(1)
       do i = 1, nsmx+1
          ia(i) = tia(i)
       enddo
        do i = 1, nsmx
          coorx(i) = tcoorx(i)
       enddo

C$ann[BeginSeq()]
      print *,'start compute...'
C$ann[EndSeq()]
      st = mclock()
      call axlig(ns,ia,ja,amat,coorx,ylig)
      et = mclock()
C$ann[BeginSeq()]
      print *,'end compute...'
      do i=1,ns/10
         print *,'elem vector',i, ylig(i)
      enddo
      print *,' Timing results : ',et-st
C$ann[EndSeq()]
c
      stop
      end
c
      subroutine inivec(ns,x,y)
c
      dimension x(ns),y(ns)
c
      do 1 is=1,ns
      x(is)=1
      y(is)=0
1     continue
c
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C$ann[NoSideEffect()]
      subroutine inimat(na,amat)
c     ==========================
c
      dimension amat(na)
c
      do 2 isg=1,na
      amat(isg)=1
2     continue
c
      return
      end

C$ann[NoSideEffect()]
      subroutine lirharw(nmax,nzmax,
     1                   sym,ncol,nnzero,pointr,rowind,values)
c
c
c en-tete du fichier Harwell
      character*72 title
      character*8  key 
      character*3  mxtype 
      character*1 rhstyp
      character*16 ptrfmt, indfmt 
      character*20 valfmt, rhsfmt
c
      integer totcrd, ptrcrd, indcrd, valcrd, rhscrd, nrow, ncol,
     1 nnzero, neltvl,nrhs,nrhsix
c
c matrice au format Harwell 
      logical sym
      integer pointr(nmax),rowind(nzmax)
      real values(nzmax)
c
c fichier entree
c
      integer nfich1
      character*80 filename
c
c--------------
c
      nfich1=11
      print *,' fichier entree ? '
      read(5,100) filename
C       filename= 'lns3937.mat'
      
      open(nfich1,file=filename)
c
c read matrix in Harwell format
c -----------------------------
c
c read in header block
c --------------------
      read(nfich1,1000,end=99) title,key,
     1 totcrd,ptrcrd,indcrd,valcrd,rhscrd,
     2 mxtype,nrow,ncol,nnzero,neltvl,
     3 ptrfmt,indfmt,valfmt,rhsfmt      
c
      if (rhscrd.gt.0) then
        read(nfich1,1001) rhstyp,nrhs,nrhsix
      endif
c
c control the dimensions
c ----------------------
      if (nrow.gt.nmax.or.ncol.ge.nmax.or.nnzero.gt.nzmax) then
        print *,' matrice trop grande'
        stop
      endif
c
      if (mxtype.eq.'rsa') mxtype='RSA'
      if (mxtype.eq.'rua') mxtype='RUA'
      if (mxtype.eq.'psa') mxtype='PSA'
      if (mxtype.eq.'pua') mxtype='PUA'
c
      if (mxtype.ne.'RSA'.and.mxtype.ne.'RUA'.and.
     1    mxtype.ne.'PSA'.and.mxtype.ne.'PUA') then
         print *,' type de matrice non valide : ',mxtype
         stop
      endif
      sym = mxtype(2:2).eq.'S'
      if (sym) print *,' matrice symetrique'
c
      if (nrow.ne.ncol) then
        print *,' matrice non carree'
        stop
      endif
c
c read matrix structure
c ---------------------
        read(nfich1,ptrfmt) (pointr(i),i=1,ncol+1)
        read(nfich1,indfmt) (rowind(i),i=1,nnzero)
        
          print *,'fin lecture structure...'
c
c read matrix values
c ------------------
      if (mxtype(1:1).eq.'R') then
        read(nfich1,valfmt) (values(i),i=1,nnzero)
      else
        call inimat(nnzero,values)
      endif
c
      print *,'fin lecture value...'

c end of normal execution
c -----------------------
      return
c
c end of file
c -----------
99    continue
      print *,' fin de fichier'
      stop
c
c formats
c -------
1000  format(a72,a8/5i14/a3,11x,4i14/2a16,2a20)
1001  format(a1,13x,2i14)
100   format(a80)
c
      end

C$ann[NoSideEffect()]
      subroutine hw2lig(sym,n,na,pointr,rowind,values,ideg,a,ia,ja)
c
c conversion from Harwell format to (a-ia-ja) format
c ==================================================
c
c sym = vrai si matrice symetrique
c n = nombre de lignes ou colonnes
c na = nombre de coefficienst non nuls
c      in => dans values, out => dans a
c pointr,rowind,values = format Harwell
c ideg = degre de chaque ligne
c a,ia,ja = format Modulef
c
      logical sym
      integer n,na,i,j,k
      integer pointr(*),rowind(*),ia(*),ja(*),ideg(*)
      real values(*),a(*)
c
c -----------------
c
c degre de chaque ligne
c ---------------------
      do 10 i=1,n
        ideg(i)=0
10    continue
c
      do 1 j=1,n
        do 2 k=pointr(j),pointr(j+1)-1
           i=rowind(k)
           ideg(i)=ideg(i)+1
2       continue
1     continue
c                              -- cas symetrique
      if (sym) then
        do 3 j=1,n
          ideg(j)=ideg(j)+pointr(j+1)-pointr(j)-1
3       continue
      endif
c
c pointeur-ligne ia
c -----------------
      ia(1)=1
      do 4 i=1,n
        ia(i+1)=ia(i)+ideg(i)
        ideg(i)=0
4     continue
c                              -- cas symetrique
      if (sym) then
        if (ia(n+1).ne.2*na-n+1) then
           print *,' erreur hw2mf symetrique',na,ia(n+1)
           stop
        else
           na=ia(n+1)-1
        endif
c                              -- cas non symetrique
      else
        if (ia(n+1).ne.na+1) then
           print *,' erreur hw2mf non symetrique',na,ia(n+1)
           stop
        endif
      endif
c
c
c pointeur-colonne ja
c -------------------
      do 5 j=1,n
        do 6 k=pointr(j),pointr(j+1)-1
          i=rowind(k)
          ja(ia(i)+ideg(i))=j
          a (ia(i)+ideg(i))=values(k)
          ideg(i)=ideg(i)+1
6       continue
5     continue
c
c                              -- cas symetrique
      if (sym) then
        do 7 j=1,n
          do 8 k=pointr(j),pointr(j+1)-1
            i=rowind(k)
            if (i.ne.j) then
              ja(ia(j)+ideg(j))=i
              a (ia(j)+ideg(j))=values(k)
              ideg(j)=ideg(j)+1
            endif
8         continue
7       continue
      endif
c
      return
      end
c
      subroutine axlig(n,ia,ja,a,x,y)
c     ===================================
c
      integer ia(*),ja(*)
      real a(*),x(*),y(*)
      real temp
c
c boucle parallele
C$ann[DoShared("BLOCK")]
C$ann[WeakCoherency(y)]
      do 1 i=1,n
         temp = 0.
         do 2 k=ia(i),ia(i+1)-1
            temp = temp + a(k)*x(ja(k))
 2       continue
         y(i) = temp
1     continue
c
      return
      end

